# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/AccelerationCartesian.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class AccelerationCartesian(genpy.Message):
  _md5sum = "5bced7c3af99e5b732792122a60cd390"
  _type = "etsi_its_cpm_ts_msgs/AccelerationCartesian"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationCartesian::= SEQUENCE{
#     xAcceleration      AccelerationComponent,
#     yAcceleration      AccelerationComponent,
#     zAcceleration      AccelerationComponent OPTIONAL
# }            
# ------------------------------------------------------------------------------
# *
# * This DF represents a acceleration vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
# * 
# * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationComponent x_acceleration

AccelerationComponent y_acceleration

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an acceleration component along with a confidence value.
# *
# * It shall include the following components: 
# *
# * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the provided value.
# *
# * @category: Kinematic Information
# * @revision: Created in V2.1.1
# 

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of an acceleration component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-160` for acceleration values equal to or less than -16 m/s^2,
# * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
# * - `102` if the confidence value is unavailable.
# *
# * The value 0 shall not be used.
# *
# * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the acceleration value may be valid and used by the application.
# * 
# * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102
"""
  __slots__ = ['x_acceleration','y_acceleration','z_acceleration','z_acceleration_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/AccelerationComponent','etsi_its_cpm_ts_msgs/AccelerationComponent','etsi_its_cpm_ts_msgs/AccelerationComponent','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       x_acceleration,y_acceleration,z_acceleration,z_acceleration_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AccelerationCartesian, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.x_acceleration is None:
        self.x_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.y_acceleration is None:
        self.y_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.z_acceleration is None:
        self.z_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.z_acceleration_is_present is None:
        self.z_acceleration_is_present = False
    else:
      self.x_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      self.y_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      self.z_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      self.z_acceleration_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hBhBh2B().pack(_x.x_acceleration.value.value, _x.x_acceleration.confidence.value, _x.y_acceleration.value.value, _x.y_acceleration.confidence.value, _x.z_acceleration.value.value, _x.z_acceleration.confidence.value, _x.z_acceleration_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.x_acceleration is None:
        self.x_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.y_acceleration is None:
        self.y_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.z_acceleration is None:
        self.z_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      end = 0
      _x = self
      start = end
      end += 10
      (_x.x_acceleration.value.value, _x.x_acceleration.confidence.value, _x.y_acceleration.value.value, _x.y_acceleration.confidence.value, _x.z_acceleration.value.value, _x.z_acceleration.confidence.value, _x.z_acceleration_is_present,) = _get_struct_hBhBh2B().unpack(str[start:end])
      self.z_acceleration_is_present = bool(self.z_acceleration_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hBhBh2B().pack(_x.x_acceleration.value.value, _x.x_acceleration.confidence.value, _x.y_acceleration.value.value, _x.y_acceleration.confidence.value, _x.z_acceleration.value.value, _x.z_acceleration.confidence.value, _x.z_acceleration_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.x_acceleration is None:
        self.x_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.y_acceleration is None:
        self.y_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      if self.z_acceleration is None:
        self.z_acceleration = etsi_its_cpm_ts_msgs.msg.AccelerationComponent()
      end = 0
      _x = self
      start = end
      end += 10
      (_x.x_acceleration.value.value, _x.x_acceleration.confidence.value, _x.y_acceleration.value.value, _x.y_acceleration.confidence.value, _x.z_acceleration.value.value, _x.z_acceleration.confidence.value, _x.z_acceleration_is_present,) = _get_struct_hBhBh2B().unpack(str[start:end])
      self.z_acceleration_is_present = bool(self.z_acceleration_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hBhBh2B = None
def _get_struct_hBhBh2B():
    global _struct_hBhBh2B
    if _struct_hBhBh2B is None:
        _struct_hBhBh2B = struct.Struct("<hBhBh2B")
    return _struct_hBhBh2B
