# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/AccelerationMagnitude.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class AccelerationMagnitude(genpy.Message):
  _md5sum = "f9a6b57d9a8685b9ff2a500433ce0785"
  _type = "etsi_its_cpm_ts_msgs/AccelerationMagnitude"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitude::= SEQUENCE {
#     accelerationMagnitudeValue   AccelerationMagnitudeValue,
#     accelerationConfidence       AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the magnitude of the acceleration vector and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
# * 
# * @field accelerationConfidence: the confidence value of the magnitude value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitudeValue acceleration_magnitude_value

AccelerationConfidence acceleration_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitudeValue ::= INTEGER {
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (0.. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
# *
# * The value shall be set to:
# * - `0` to indicate no acceleration,
# * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 161
uint8 POSITIVE_OUT_OF_RANGE = 160
uint8 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
# * - `102` if the confidence value is unavailable.
# *
# * The value 0 shall not be used.
# *
# * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the acceleration value may be valid and used by the application.
# * 
# * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102
"""
  __slots__ = ['acceleration_magnitude_value','acceleration_confidence']
  _slot_types = ['etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue','etsi_its_cpm_ts_msgs/AccelerationConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       acceleration_magnitude_value,acceleration_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AccelerationMagnitude, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.acceleration_magnitude_value is None:
        self.acceleration_magnitude_value = etsi_its_cpm_ts_msgs.msg.AccelerationMagnitudeValue()
      if self.acceleration_confidence is None:
        self.acceleration_confidence = etsi_its_cpm_ts_msgs.msg.AccelerationConfidence()
    else:
      self.acceleration_magnitude_value = etsi_its_cpm_ts_msgs.msg.AccelerationMagnitudeValue()
      self.acceleration_confidence = etsi_its_cpm_ts_msgs.msg.AccelerationConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.acceleration_magnitude_value.value, _x.acceleration_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.acceleration_magnitude_value is None:
        self.acceleration_magnitude_value = etsi_its_cpm_ts_msgs.msg.AccelerationMagnitudeValue()
      if self.acceleration_confidence is None:
        self.acceleration_confidence = etsi_its_cpm_ts_msgs.msg.AccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.acceleration_magnitude_value.value, _x.acceleration_confidence.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.acceleration_magnitude_value.value, _x.acceleration_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.acceleration_magnitude_value is None:
        self.acceleration_magnitude_value = etsi_its_cpm_ts_msgs.msg.AccelerationMagnitudeValue()
      if self.acceleration_confidence is None:
        self.acceleration_confidence = etsi_its_cpm_ts_msgs.msg.AccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.acceleration_magnitude_value.value, _x.acceleration_confidence.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
