# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/CartesianAngularAccelerationComponent.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class CartesianAngularAccelerationComponent(genpy.Message):
  _md5sum = "d1812351dc0d365cd3966f9ef9701239"
  _type = "etsi_its_cpm_ts_msgs/CartesianAngularAccelerationComponent"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularAccelerationComponent ::= SEQUENCE {
#     value         CartesianAngularAccelerationComponentValue,
#     confidence    AngularAccelerationConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angular acceleration component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angular acceleration component value.
# *
# * @field confidence: The confidence value associated to the provided value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1 
# 

CartesianAngularAccelerationComponentValue value

AngularAccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularAccelerationComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularAccelerationComponentValue ::= INTEGER {
#     negativeOutOfRange (-255),
#     positiveOutOfRange (255),
#     unavailable        (256)
# } (-255..256)
# ------------------------------------------------------------------------------
# *
# * This DE represents an angular acceleration value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
#  * The value shall be set to: 
# * - `-255` if the acceleration is equal to or less than -255 degrees/s^2,
# * - `n` (`n > -255` and `n < 255`) if the acceleration is equal to or less than n x 1 degree/s^2,
#      and greater than `(n-1)` x 0,01 degree/s^2,
# * - `255` if the acceleration is greater than 254 degrees/s^2,
# * - `256` if the information is unavailable.
# *
# * @unit:  degree/s^2 (degrees per second squared)
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -255
int16 MAX = 256
int16 NEGATIVE_OUT_OF_RANGE = -255
int16 POSITIVE_OUT_OF_RANGE = 255
int16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngularAccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngularAccelerationConfidence ::= ENUMERATED {
#     degSecSquared-01 (0), 
#     degSecSquared-02 (1), 
#     degSecSquared-05 (2),  
#     degSecSquared-10 (3), 
#     degSecSquared-20 (4),  
#     degSecSquared-50 (5),  
#     outOfRange       (6),     
#     unavailable      (7)   
# }
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angular acceleration confidence value which represents the estimated accuracy of an angular acceleration value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * For correlation computation, maximum interval levels shall be assumed.
# *
# * The value shall be set to:
# * - 0 - `degSecSquared-01` - if the accuracy is equal to or less than 1 degree/second^2,
# * - 1 - `degSecSquared-02` - if the accuracy is equal to or less than 2 degrees/second^2 and greater than 1 degree/second^2,
# * - 2 - `degSecSquared-05` - if the accuracy is equal to or less than 5 degrees/second^2 and greater than 1 degree/second^2,
# * - 3 - `degSecSquared-10` - if the accuracy is equal to or less than 10 degrees/second^2 and greater than 5 degrees/second^2,
# * - 4 - `degSecSquared-20` - if the accuracy is equal to or less than 20 degrees/second^2 and greater than 10 degrees/second^2,
# * - 5 - `degSecSquared-50` - if the accuracy is equal to or less than 50 degrees/second^2 and greater than 20 degrees/second^2,
# * - 6 - `outOfRange`       - if the accuracy is out of range, i.e. greater than 50 degrees/second^2,
# * - 7 - `unavailable`      - if the accuracy information is unavailable.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 DEG_SEC_SQUARED_01 = 0
uint8 DEG_SEC_SQUARED_02 = 1
uint8 DEG_SEC_SQUARED_05 = 2
uint8 DEG_SEC_SQUARED_10 = 3
uint8 DEG_SEC_SQUARED_20 = 4
uint8 DEG_SEC_SQUARED_50 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7

"""
  __slots__ = ['value','confidence']
  _slot_types = ['etsi_its_cpm_ts_msgs/CartesianAngularAccelerationComponentValue','etsi_its_cpm_ts_msgs/AngularAccelerationConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value,confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CartesianAngularAccelerationComponent, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.CartesianAngularAccelerationComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.AngularAccelerationConfidence()
    else:
      self.value = etsi_its_cpm_ts_msgs.msg.CartesianAngularAccelerationComponentValue()
      self.confidence = etsi_its_cpm_ts_msgs.msg.AngularAccelerationConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.value.value, _x.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.CartesianAngularAccelerationComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.AngularAccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.value.value, _x.confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.value.value, _x.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.CartesianAngularAccelerationComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.AngularAccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.value.value, _x.confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
