# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class CartesianPosition3dWithConfidence(genpy.Message):
  _md5sum = "ce4eb509b62b6a3c8f0025a6add36baf"
  _type = "etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3dWithConfidence::= SEQUENCE{    
#     xCoordinate    CartesianCoordinateWithConfidence, 
#     yCoordinate    CartesianCoordinateWithConfidence, 
#     zCoordinate    CartesianCoordinateWithConfidence OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system with an associated confidence level for each coordinate.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value with the associated confidence level.
# *
# * @field yCoordinate: the Y coordinate value with the associated confidence level.
# *
# * @field zCoordinate: the optional Z coordinate value with the associated confidence level.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateWithConfidence x_coordinate

CartesianCoordinateWithConfidence y_coordinate

CartesianCoordinateWithConfidence z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateWithConfidence ::= SEQUENCE {
#     value         CartesianCoordinateLarge,
#     confidence    CoordinateConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a coordinate along with a confidence value in a cartesian reference system.
# *
# * It shall include the following components: 
# * 
# * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
# * 
# * @field confidence: the coordinate confidence value associated to the provided value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateLarge value

CoordinateConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateLarge::= INTEGER{ 
#     negativeOutOfRange (-131072),
#     positiveOutOfRange (131071)
# } (-131072..131071)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
# *
# * The value shall be set to:
# * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
# * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
# *  
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int32 value
int32 MIN = -131072
int32 MAX = 131071
int32 NEGATIVE_OUT_OF_RANGE = -131072
int32 POSITIVE_OUT_OF_RANGE = 131071

================================================================================
MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CoordinateConfidence ::= INTEGER {
#     outOfRange            (4095),
#     unavailable           (4096) 
# } (1..4096)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
# * - `4095` if the confidence value is greater than 40,94 metres,
# * - `4096` if the confidence value is not available.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 1
uint16 MAX = 4096
uint16 OUT_OF_RANGE = 4095
uint16 UNAVAILABLE = 4096
"""
  __slots__ = ['x_coordinate','y_coordinate','z_coordinate','z_coordinate_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence','etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence','etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       x_coordinate,y_coordinate,z_coordinate,z_coordinate_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CartesianPosition3dWithConfidence, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.z_coordinate_is_present is None:
        self.z_coordinate_is_present = False
    else:
      self.x_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      self.y_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      self.z_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      self.z_coordinate_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_iHiHiHB().pack(_x.x_coordinate.value.value, _x.x_coordinate.confidence.value, _x.y_coordinate.value.value, _x.y_coordinate.confidence.value, _x.z_coordinate.value.value, _x.z_coordinate.confidence.value, _x.z_coordinate_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      end = 0
      _x = self
      start = end
      end += 19
      (_x.x_coordinate.value.value, _x.x_coordinate.confidence.value, _x.y_coordinate.value.value, _x.y_coordinate.confidence.value, _x.z_coordinate.value.value, _x.z_coordinate.confidence.value, _x.z_coordinate_is_present,) = _get_struct_iHiHiHB().unpack(str[start:end])
      self.z_coordinate_is_present = bool(self.z_coordinate_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_iHiHiHB().pack(_x.x_coordinate.value.value, _x.x_coordinate.confidence.value, _x.y_coordinate.value.value, _x.y_coordinate.confidence.value, _x.z_coordinate.value.value, _x.z_coordinate.confidence.value, _x.z_coordinate_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_cpm_ts_msgs.msg.CartesianCoordinateWithConfidence()
      end = 0
      _x = self
      start = end
      end += 19
      (_x.x_coordinate.value.value, _x.x_coordinate.confidence.value, _x.y_coordinate.value.value, _x.y_coordinate.confidence.value, _x.z_coordinate.value.value, _x.z_coordinate.confidence.value, _x.z_coordinate_is_present,) = _get_struct_iHiHiHB().unpack(str[start:end])
      self.z_coordinate_is_present = bool(self.z_coordinate_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_iHiHiHB = None
def _get_struct_iHiHiHB():
    global _struct_iHiHiHB
    if _struct_iHiHiHB is None:
        _struct_iHiHiHB = struct.Struct("<iHiHiHB")
    return _struct_iHiHiHB
