# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/CauseCode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class CauseCode(genpy.Message):
  _md5sum = "797af580ea5e1c995443b7c6f52a6b30"
  _type = "etsi_its_cpm_ts_msgs/CauseCode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CauseCode ::= SEQUENCE {
#     causeCode       CauseCodeType,
#     subCauseCode    SubCauseCodeType,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF is a representation of the cause code value of a traffic event. 
# *
# * It shall include the following components: 
# *
# * @field causeCode: the main cause of a detected event. 
# *
# * @field subCauseCode: the subordinate cause of a detected event. 
# *
# * The semantics of the entire DF are completely defined by the component causeCode. The interpretation of the subCauseCode may 
# * provide additional information that is not strictly necessary to understand the causeCode itself, and is therefore optional.
# *
# * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref CauseCodeV2 instead. 
# *
# * @category: Traffic information
# * @revision: Editorial update in V2.1.1
# 

CauseCodeType cause_code

SubCauseCodeType sub_cause_code


================================================================================
MSG: etsi_its_cpm_ts_msgs/CauseCodeType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CauseCodeType ::= INTEGER {
#     trafficCondition                                (1),
#     accident                                        (2),
#     roadworks                                       (3),
#     impassability                                   (5),
#     adverseWeatherCondition-Adhesion                (6),
#     aquaplaning                                     (7),
#     hazardousLocation-SurfaceCondition              (9),
#     hazardousLocation-ObstacleOnTheRoad             (10),
#     hazardousLocation-AnimalOnTheRoad               (11),
#     humanPresenceOnTheRoad                          (12),
#     wrongWayDriving                                 (14),
#     rescueAndRecoveryWorkInProgress                 (15),
#     adverseWeatherCondition-ExtremeWeatherCondition (17),
#     adverseWeatherCondition-Visibility              (18),
#     adverseWeatherCondition-Precipitation           (19),
#     violence                                        (20),
#     slowVehicle                                     (26),
#     dangerousEndOfQueue                             (27),
#     vehicleBreakdown                                (91),
#     postCrash                                       (92),
#     humanProblem                                    (93),
#     stationaryVehicle                               (94),
#     emergencyVehicleApproaching                     (95),
#     hazardousLocation-DangerousCurve                (96),
#     collisionRisk                                   (97),
#     signalViolation                                 (98),
#     dangerousSituation                              (99),
#     railwayLevelCrossing                            (100) 
# } (0..255)
# ------------------------------------------------------------------------------
# *
# *The DE represents the value of the cause code of an event. 
# * 
# * The value shall be set to:
# * - 0                                                     - reserved for future use,
# * - 1  - `trafficCondition`                               - in case the type of event is an abnormal traffic condition,
# * - 2  - `accident`                                       - in case the type of event is a road accident,
# * - 3  - `roadworks`                                      - in case the type of event is roadwork,
# * - 4                                                     - reserved for future usage,
# * - 5  - `impassability`                                  - in case the  type of event is unmanaged road blocking, referring to any
# *                                                           blocking of a road, partial or total, which has not been adequately
# *                                                           secured and signposted,
# * - 6  - `adverseWeatherCondition-Adhesion`               - in case the  type of event is low adhesion,
# * - 7  - `aquaplaning`                                    - danger of aquaplaning on the road,
# * - 8                                                     - reserved for future usage,
# * - 9  - `hazardousLocation-SurfaceCondition`             - in case the type of event is abnormal road surface condition,
# * - 10 - `hazardousLocation-ObstacleOnTheRoad`            - in case the type of event is obstacle on the road,
# * - 11 - `hazardousLocation-AnimalOnTheRoad`              - in case the type of event is animal on the road,
# * - 12 - `humanPresenceOnTheRoad`                         - in case the type of event is human presence on the road,
# * - 13                                                    - reserved for future usage,
# * - 14 - `wrongWayDriving`                                - in case the type of the event is vehicle driving in wrong way,
# * - 15 - `rescueAndRecoveryWorkInProgress`                - in case the type of event is rescue and recovery work for accident or for a road hazard in progress,
# * - 16                                                    - reserved for future usage,
# * - 17 - `adverseWeatherCondition-ExtremeWeatherCondition`- in case the type of event is extreme weather condition,
# * - 18 - `adverseWeatherCondition-Visibility`             - in case the type of event is low visibility,
# * - 19 - `adverseWeatherCondition-Precipitation`          - in case the type of event is precipitation,
# * - 20 - `violence`                                       - in case the the type of event is human violence on or near the road,
# * - 21-25                                                 - reserved for future usage,
# * - 26 - `slowVehicle`                                    - in case the type of event is slow vehicle driving on the road,
# * - 27 - `dangerousEndOfQueue`                            - in case the type of event is dangerous end of vehicle queue,
# * - 28-90                                                 - are reserved for future usage,
# * - 91 - `vehicleBreakdown`                               - in case the type of event is break down vehicle on the road,
# * - 92 - `postCrash`                                      - in case the type of event is a detected crash,
# * - 93 - `humanProblem`                                   - in case the type of event is human health problem in vehicles involved in traffic,
# * - 94 - `stationaryVehicle`                              - in case the type of event is stationary vehicle,
# * - 95 - `emergencyVehicleApproaching`                    - in case the type of event is approaching vehicle operating emergency mission,
# * - 96 - `hazardousLocation-DangerousCurve`               - in case the type of event is dangerous curve,
# * - 97 - `collisionRisk`                                  - in case the type of event is a collision risk,
# * - 98 - `signalViolation`                                - in case the type of event is signal violation,
# * - 99 - `dangerousSituation`                             - in case the type of event is dangerous situation in which autonomous safety system in vehicle 
# *                                                             is activated,
# * - 100 - `railwayLevelCrossing`                          - in case the type of event is a railway level crossing. 
# * - 101-255                                               - are reserved for future usage.
# *
# * @category: Traffic information
# * @revision: V1.3.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 TRAFFIC_CONDITION = 1
uint8 ACCIDENT = 2
uint8 ROADWORKS = 3
uint8 IMPASSABILITY = 5
uint8 ADVERSE_WEATHER_CONDITION_ADHESION = 6
uint8 AQUAPLANING = 7
uint8 HAZARDOUS_LOCATION_SURFACE_CONDITION = 9
uint8 HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD = 10
uint8 HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD = 11
uint8 HUMAN_PRESENCE_ON_THE_ROAD = 12
uint8 WRONG_WAY_DRIVING = 14
uint8 RESCUE_AND_RECOVERY_WORK_IN_PROGRESS = 15
uint8 ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION = 17
uint8 ADVERSE_WEATHER_CONDITION_VISIBILITY = 18
uint8 ADVERSE_WEATHER_CONDITION_PRECIPITATION = 19
uint8 VIOLENCE = 20
uint8 SLOW_VEHICLE = 26
uint8 DANGEROUS_END_OF_QUEUE = 27
uint8 VEHICLE_BREAKDOWN = 91
uint8 POST_CRASH = 92
uint8 HUMAN_PROBLEM = 93
uint8 STATIONARY_VEHICLE = 94
uint8 EMERGENCY_VEHICLE_APPROACHING = 95
uint8 HAZARDOUS_LOCATION_DANGEROUS_CURVE = 96
uint8 COLLISION_RISK = 97
uint8 SIGNAL_VIOLATION = 98
uint8 DANGEROUS_SITUATION = 99
uint8 RAILWAY_LEVEL_CROSSING = 100

================================================================================
MSG: etsi_its_cpm_ts_msgs/SubCauseCodeType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SubCauseCodeType ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the generic sub cause of a detected event.
# * 
# * @note: The sub cause code value assignment varies based on value of @ref CauseCode.
# *
# * @category: Traffic information
# * @revision: Description revised in V2.1.1 (this is  the generic sub cause type)
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255

"""
  __slots__ = ['cause_code','sub_cause_code']
  _slot_types = ['etsi_its_cpm_ts_msgs/CauseCodeType','etsi_its_cpm_ts_msgs/SubCauseCodeType']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cause_code,sub_cause_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CauseCode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cause_code is None:
        self.cause_code = etsi_its_cpm_ts_msgs.msg.CauseCodeType()
      if self.sub_cause_code is None:
        self.sub_cause_code = etsi_its_cpm_ts_msgs.msg.SubCauseCodeType()
    else:
      self.cause_code = etsi_its_cpm_ts_msgs.msg.CauseCodeType()
      self.sub_cause_code = etsi_its_cpm_ts_msgs.msg.SubCauseCodeType()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.cause_code.value, _x.sub_cause_code.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cause_code is None:
        self.cause_code = etsi_its_cpm_ts_msgs.msg.CauseCodeType()
      if self.sub_cause_code is None:
        self.sub_cause_code = etsi_its_cpm_ts_msgs.msg.SubCauseCodeType()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.cause_code.value, _x.sub_cause_code.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.cause_code.value, _x.sub_cause_code.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cause_code is None:
        self.cause_code = etsi_its_cpm_ts_msgs.msg.CauseCodeType()
      if self.sub_cause_code is None:
        self.sub_cause_code = etsi_its_cpm_ts_msgs.msg.SubCauseCodeType()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.cause_code.value, _x.sub_cause_code.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
