# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class EulerAnglesWithConfidence(genpy.Message):
  _md5sum = "98c10fa4ae29e04457595050eb60bcd4"
  _type = "etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EulerAnglesWithConfidence ::= SEQUENCE {
#     zAngle CartesianAngle,
#     yAngle CartesianAngle OPTIONAL,
#     xAngle CartesianAngle OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
# *
# * It shall include the following components: 
# *
# * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
# *
# * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
# *
# * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

CartesianAngle z_angle

CartesianAngle y_angle
bool y_angle_is_present

CartesianAngle x_angle
bool x_angle_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  __slots__ = ['z_angle','y_angle','y_angle_is_present','x_angle','x_angle_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/CartesianAngle','etsi_its_cpm_ts_msgs/CartesianAngle','bool','etsi_its_cpm_ts_msgs/CartesianAngle','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       z_angle,y_angle,y_angle_is_present,x_angle,x_angle_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EulerAnglesWithConfidence, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.z_angle is None:
        self.z_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.y_angle is None:
        self.y_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.y_angle_is_present is None:
        self.y_angle_is_present = False
      if self.x_angle is None:
        self.x_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.x_angle_is_present is None:
        self.x_angle_is_present = False
    else:
      self.z_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      self.y_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      self.y_angle_is_present = False
      self.x_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      self.x_angle_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_HBH2BH2B().pack(_x.z_angle.value.value, _x.z_angle.confidence.value, _x.y_angle.value.value, _x.y_angle.confidence.value, _x.y_angle_is_present, _x.x_angle.value.value, _x.x_angle.confidence.value, _x.x_angle_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.z_angle is None:
        self.z_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.y_angle is None:
        self.y_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.x_angle is None:
        self.x_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.z_angle.value.value, _x.z_angle.confidence.value, _x.y_angle.value.value, _x.y_angle.confidence.value, _x.y_angle_is_present, _x.x_angle.value.value, _x.x_angle.confidence.value, _x.x_angle_is_present,) = _get_struct_HBH2BH2B().unpack(str[start:end])
      self.y_angle_is_present = bool(self.y_angle_is_present)
      self.x_angle_is_present = bool(self.x_angle_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_HBH2BH2B().pack(_x.z_angle.value.value, _x.z_angle.confidence.value, _x.y_angle.value.value, _x.y_angle.confidence.value, _x.y_angle_is_present, _x.x_angle.value.value, _x.x_angle.confidence.value, _x.x_angle_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.z_angle is None:
        self.z_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.y_angle is None:
        self.y_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      if self.x_angle is None:
        self.x_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.z_angle.value.value, _x.z_angle.confidence.value, _x.y_angle.value.value, _x.y_angle.confidence.value, _x.y_angle_is_present, _x.x_angle.value.value, _x.x_angle.confidence.value, _x.x_angle_is_present,) = _get_struct_HBH2BH2B().unpack(str[start:end])
      self.y_angle_is_present = bool(self.y_angle_is_present)
      self.x_angle_is_present = bool(self.x_angle_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_HBH2BH2B = None
def _get_struct_HBH2BH2B():
    global _struct_HBH2BH2B
    if _struct_HBH2BH2B is None:
        _struct_HBH2BH2B = struct.Struct("<HBH2BH2B")
    return _struct_HBH2BH2B
