# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/EventPoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class EventPoint(genpy.Message):
  _md5sum = "9ad60ce6e05ee12bd0eec7374ddef515"
  _type = "etsi_its_cpm_ts_msgs/EventPoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EventPoint ::= SEQUENCE {
#     eventPosition         DeltaReferencePosition,
#     eventDeltaTime        PathDeltaTime OPTIONAL,
#     informationQuality    InformationQuality
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides information related to an event at a defined position.
# *
# * It shall include the following components: 
# * 
# * @field eventPosition: offset position of a detected event point to a defined position. 
# * 
# * @field eventDeltaTime: optional time travelled by the detecting ITS-S since the previous detected event point.
# * 
# * @field informationQuality: Information quality of the detection for this event point.
# * 
# * @category: GeoReference information, Traffic information
# * @revision: generalized the semantics in V2.1.1
# 

DeltaReferencePosition event_position

PathDeltaTime event_delta_time
bool event_delta_time_is_present

InformationQuality information_quality


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------
# *
# * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
# *
# * It shall include the following components: 
# *
# * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
# *
# * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
# *
# * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
# *
# * @category: GeoReference information
# * @revision:  V1.3.1
# 

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset latitude with regards to a defined latitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
# * - `0` for no latitudinal offset,
# * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
# * - `131 072` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072

================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset longitude with regards to a defined longitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
# * - `0` for no longitudinal offset,
# * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
# * - `131 072` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072

================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset altitude with regards to a defined altitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `-12 700` for values equal to or lower than -127 metres,
# * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
# * - `0` for no altitudinal offset,
# * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
# * - `12 799` for values equal to or greater than 127,99 metres,
# * - `12 800` when the information is unavailable.
# *
# * @unit: 0,01 metre
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800

================================================================================
MSG: etsi_its_cpm_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------
# *
# * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
# *
# * @unit 0,01 second
# * @category: GeoReference information
# * @revision: V1.3.1
# 

int64 value
int64 MIN = 1
int64 MAX = 65535


================================================================================
MSG: etsi_its_cpm_ts_msgs/InformationQuality
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InformationQuality ::= INTEGER (0..7)
# ------------------------------------------------------------------------------
# *
# * This DE represents the quality level of provided information.
# * 
# * The value shall be set to:
# * - `0` if the information is unavailable,
# * - `1` if the quality level is lowest,
# * - `n` (`n > 1` and `n < 7`) if the quality level is n, 
# * - `7` if the quality level is highest.
# *
# * @note: Definition of quality level is out of scope of the present document.
# * @category: Basic information
# * @revision: Editorial update in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 7

"""
  __slots__ = ['event_position','event_delta_time','event_delta_time_is_present','information_quality']
  _slot_types = ['etsi_its_cpm_ts_msgs/DeltaReferencePosition','etsi_its_cpm_ts_msgs/PathDeltaTime','bool','etsi_its_cpm_ts_msgs/InformationQuality']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       event_position,event_delta_time,event_delta_time_is_present,information_quality

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EventPoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.event_position is None:
        self.event_position = etsi_its_cpm_ts_msgs.msg.DeltaReferencePosition()
      if self.event_delta_time is None:
        self.event_delta_time = etsi_its_cpm_ts_msgs.msg.PathDeltaTime()
      if self.event_delta_time_is_present is None:
        self.event_delta_time_is_present = False
      if self.information_quality is None:
        self.information_quality = etsi_its_cpm_ts_msgs.msg.InformationQuality()
    else:
      self.event_position = etsi_its_cpm_ts_msgs.msg.DeltaReferencePosition()
      self.event_delta_time = etsi_its_cpm_ts_msgs.msg.PathDeltaTime()
      self.event_delta_time_is_present = False
      self.information_quality = etsi_its_cpm_ts_msgs.msg.InformationQuality()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2ihq2B().pack(_x.event_position.delta_latitude.value, _x.event_position.delta_longitude.value, _x.event_position.delta_altitude.value, _x.event_delta_time.value, _x.event_delta_time_is_present, _x.information_quality.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.event_position is None:
        self.event_position = etsi_its_cpm_ts_msgs.msg.DeltaReferencePosition()
      if self.event_delta_time is None:
        self.event_delta_time = etsi_its_cpm_ts_msgs.msg.PathDeltaTime()
      if self.information_quality is None:
        self.information_quality = etsi_its_cpm_ts_msgs.msg.InformationQuality()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.event_position.delta_latitude.value, _x.event_position.delta_longitude.value, _x.event_position.delta_altitude.value, _x.event_delta_time.value, _x.event_delta_time_is_present, _x.information_quality.value,) = _get_struct_2ihq2B().unpack(str[start:end])
      self.event_delta_time_is_present = bool(self.event_delta_time_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2ihq2B().pack(_x.event_position.delta_latitude.value, _x.event_position.delta_longitude.value, _x.event_position.delta_altitude.value, _x.event_delta_time.value, _x.event_delta_time_is_present, _x.information_quality.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.event_position is None:
        self.event_position = etsi_its_cpm_ts_msgs.msg.DeltaReferencePosition()
      if self.event_delta_time is None:
        self.event_delta_time = etsi_its_cpm_ts_msgs.msg.PathDeltaTime()
      if self.information_quality is None:
        self.information_quality = etsi_its_cpm_ts_msgs.msg.InformationQuality()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.event_position.delta_latitude.value, _x.event_position.delta_longitude.value, _x.event_position.delta_altitude.value, _x.event_delta_time.value, _x.event_delta_time_is_present, _x.information_quality.value,) = _get_struct_2ihq2B().unpack(str[start:end])
      self.event_delta_time_is_present = bool(self.event_delta_time_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2ihq2B = None
def _get_struct_2ihq2B():
    global _struct_2ihq2B
    if _struct_2ihq2B is None:
        _struct_2ihq2B = struct.Struct("<2ihq2B")
    return _struct_2ihq2B
