# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/Heading.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class Heading(genpy.Message):
  _md5sum = "ba6c4c57d47253384552cbf3ba9a74d0"
  _type = "etsi_its_cpm_ts_msgs/Heading"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Heading ::= SEQUENCE {
#     headingValue         HeadingValue,
#     headingConfidence    HeadingConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the Heading in a WGS84 co-ordinates system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * It shall include the following components: 
# * 
# * @field headingValue: the heading value.
# * 
# * @field headingConfidence: the confidence value of the heading value with a predefined confidence level.
# * 
# * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84Angle instead. 
# * @category: Kinematic Information
# * @revision: Description revised in V2.1.1
# 

HeadingValue heading_value

HeadingConfidence heading_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# *
# * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
# *
# * Unit: 0,1 degree
# * Categories: GeoReference information
# * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/HeadingConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# HeadingConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the heading confidence value which represents the estimated absolute accuracy of a heading value with a confidence level of 95 %.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degree and more than (n-1) x 0,1 degree,
# * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the confidence value information is not available.
# * 
# * @note:	The fact that a value is received with confidence value set to `unavailable(127)` can be caused by several reasons,
# * such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the heading value may be valid and used by the application.
# *
# * @note: If a heading value is received and its confidence value is set to `outOfRange(126)`, it means that the 
# * heading value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleConfidence instead. 
# * 
# * @unit: 0,1 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  __slots__ = ['heading_value','heading_confidence']
  _slot_types = ['etsi_its_cpm_ts_msgs/HeadingValue','etsi_its_cpm_ts_msgs/HeadingConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       heading_value,heading_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Heading, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.heading_value is None:
        self.heading_value = etsi_its_cpm_ts_msgs.msg.HeadingValue()
      if self.heading_confidence is None:
        self.heading_confidence = etsi_its_cpm_ts_msgs.msg.HeadingConfidence()
    else:
      self.heading_value = etsi_its_cpm_ts_msgs.msg.HeadingValue()
      self.heading_confidence = etsi_its_cpm_ts_msgs.msg.HeadingConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_HB().pack(_x.heading_value.value, _x.heading_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.heading_value is None:
        self.heading_value = etsi_its_cpm_ts_msgs.msg.HeadingValue()
      if self.heading_confidence is None:
        self.heading_confidence = etsi_its_cpm_ts_msgs.msg.HeadingConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.heading_value.value, _x.heading_confidence.value,) = _get_struct_HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_HB().pack(_x.heading_value.value, _x.heading_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.heading_value is None:
        self.heading_value = etsi_its_cpm_ts_msgs.msg.HeadingValue()
      if self.heading_confidence is None:
        self.heading_confidence = etsi_its_cpm_ts_msgs.msg.HeadingConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.heading_value.value, _x.heading_confidence.value,) = _get_struct_HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_HB = None
def _get_struct_HB():
    global _struct_HB
    if _struct_HB is None:
        _struct_HB = struct.Struct("<HB")
    return _struct_HB
