# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/InterferenceManagementChannel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class InterferenceManagementChannel(genpy.Message):
  _md5sum = "1579f5b38c93a0a540adfdb6f296cc73"
  _type = "etsi_its_cpm_ts_msgs/InterferenceManagementChannel"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementChannel ::= SEQUENCE {
#     centreFrequency    INTEGER (1 .. 99999),
#     channelWidth       INTEGER (0 .. 9999),
#     exponent           INTEGER (0 .. 15) 
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a frequency channel 
# *
# * It shall include the following components: 
# *
# * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)
# * 
# * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)
# *
# * @field exponent: exponent of the power of 10 used in the calculation of the components above.
# *
# * @category: Communication information
# * @revision: created in V2.1.1
#

uint32 centre_frequency
uint32 CENTRE_FREQUENCY_MIN = 1
uint32 CENTRE_FREQUENCY_MAX = 99999

uint16 channel_width
uint16 CHANNEL_WIDTH_MIN = 0
uint16 CHANNEL_WIDTH_MAX = 9999

uint8 exponent
uint8 EXPONENT_MIN = 0
uint8 EXPONENT_MAX = 15

"""
  # Pseudo-constants
  CENTRE_FREQUENCY_MIN = 1
  CENTRE_FREQUENCY_MAX = 99999
  CHANNEL_WIDTH_MIN = 0
  CHANNEL_WIDTH_MAX = 9999
  EXPONENT_MIN = 0
  EXPONENT_MAX = 15

  __slots__ = ['centre_frequency','channel_width','exponent']
  _slot_types = ['uint32','uint16','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       centre_frequency,channel_width,exponent

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(InterferenceManagementChannel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.centre_frequency is None:
        self.centre_frequency = 0
      if self.channel_width is None:
        self.channel_width = 0
      if self.exponent is None:
        self.exponent = 0
    else:
      self.centre_frequency = 0
      self.channel_width = 0
      self.exponent = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_IHB = None
def _get_struct_IHB():
    global _struct_IHB
    if _struct_IHB is None:
        _struct_IHB = struct.Struct("<IHB")
    return _struct_IHB
