# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/InterferenceManagementInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class InterferenceManagementInfo(genpy.Message):
  _md5sum = "704e5f6be098251fad9d420af3499d8d"
  _type = "etsi_its_cpm_ts_msgs/InterferenceManagementInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementInfo::= SEQUENCE (SIZE(1..16,...)) OF InterferenceManagementInfoPerChannel
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of up to 16 definitions containing interference management information, per affected frequency channels.
# *  
# * @category: Communication information.
# * @revision: created in V2.1.1
# 

InterferenceManagementInfoPerChannel[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementInfoPerChannel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementInfoPerChannel ::= SEQUENCE {
#     interferenceManagementChannel           InterferenceManagementChannel,
#     interferenceManagementZoneType          InterferenceManagementZoneType,
#     interferenceManagementMitigationType    MitigationForTechnologies OPTIONAL,
#     expiryTime                              TimestampIts OPTIONAL, 
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF contains interference management information for one affected frequency channel.
# *
# * It shall include the following components: 
# *
# * @field interferenceManagementChannel: frequency channel for which the zone should be applied interference management 
# *
# * @field interferenceManagementZoneType: type of the interference management zone. 
# *
# * @field interferenceManagementMitigationType: optional type of the mitigation to be used in the interference management zone. 
# * In the case where no mitigation should be applied by the ITS-S, this is indicated by the field interferenceManagementMitigationType being absent.
# *
# * @field expiryTime: optional time at which the validity of the interference management communication zone will expire. 
# * This component is present when the interference management is temporarily valid
# *
# * @category: Communication information
# * @revision: created in V2.1.1
# 

InterferenceManagementChannel interference_management_channel

InterferenceManagementZoneType interference_management_zone_type

MitigationForTechnologies interference_management_mitigation_type
bool interference_management_mitigation_type_is_present

TimestampIts expiry_time
bool expiry_time_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementChannel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementChannel ::= SEQUENCE {
#     centreFrequency    INTEGER (1 .. 99999),
#     channelWidth       INTEGER (0 .. 9999),
#     exponent           INTEGER (0 .. 15) 
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a frequency channel 
# *
# * It shall include the following components: 
# *
# * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)
# * 
# * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)
# *
# * @field exponent: exponent of the power of 10 used in the calculation of the components above.
# *
# * @category: Communication information
# * @revision: created in V2.1.1
#

uint32 centre_frequency
uint32 CENTRE_FREQUENCY_MIN = 1
uint32 CENTRE_FREQUENCY_MAX = 99999

uint16 channel_width
uint16 CHANNEL_WIDTH_MIN = 0
uint16 CHANNEL_WIDTH_MAX = 9999

uint8 exponent
uint8 EXPONENT_MIN = 0
uint8 EXPONENT_MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementZoneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZoneType ::= ENUMERATED {
#     permanentCenDsrcTolling (0),
#     temporaryCenDsrcTolling (1),
#     unavailable             (2), 
#     urbanRail               (3),      
#     satelliteStation        (4),
#     fixedLinks              (5), 
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DE defines the type of an interference management zone, so that an ITS-S can 
# * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
# * It is an extension of the type @ref ProtectedZoneType.
# *
# * The value shall be set to:
# * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,
# * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,
# * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,
# * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 PERMANENT_CEN_DSRC_TOLLING = 0
uint8 TEMPORARY_CEN_DSRC_TOLLING = 1
uint8 UNAVAILABLE = 2
uint8 URBAN_RAIL = 3
uint8 SATELLITE_STATION = 4
uint8 FIXED_LINKS = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/MitigationForTechnologies
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationForTechnologies ::= SEQUENCE (SIZE(1..8)) OF MitigationPerTechnologyClass 
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of @ref MitigationPerTechnologyClass.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
#

MitigationPerTechnologyClass[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationPerTechnologyClass ::= SEQUENCE {
#    accessTechnologyClass    AccessTechnologyClass, 
#    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL, 
#    powerReduction           INTEGER (0 .. 30) OPTIONAL,
#    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,   
#    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,   
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
# *
# * It shall include the following components: 
# *
# * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
# *
# * @field lowDutyCycle: duty cycle limit.
# * @unit: 0,01 % steps
# *
# * @field powerReduction: the delta value of power to be reduced.
# * @unit: dB
# *
# * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
# * @unit: ms
# *
# * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
# * @unit: ms
# *
# * @note: All parameters are optional, as they may not apply to some of the technologies or
# * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7. 
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

AccessTechnologyClass access_technology_class

uint16 low_duty_cycle
bool low_duty_cycle_is_present
uint16 LOW_DUTY_CYCLE_MIN = 0
uint16 LOW_DUTY_CYCLE_MAX = 10000

uint8 power_reduction
bool power_reduction_is_present
uint8 POWER_REDUCTION_MIN = 0
uint8 POWER_REDUCTION_MAX = 30

uint16 dmc_toff_limit
bool dmc_toff_limit_is_present
uint16 DMC_TOFF_LIMIT_MIN = 0
uint16 DMC_TOFF_LIMIT_MAX = 1200

uint8 dmc_ton_limit
bool dmc_ton_limit_is_present
uint8 DMC_TON_LIMIT_MIN = 0
uint8 DMC_TON_LIMIT_MAX = 20


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccessTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccessTechnologyClass ::= ENUMERATED {
#    any         (0), 
#    itsg5Class  (1), 
#    ltev2xClass (2), 
#    nrv2xClass  (3),
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates an access technology.
# *
# * The value shall be set to:
# * - `0`: in case of any access technology class,
# * - `1`: in case of ITS-G5 access technology class,
# * - `2`: in case of LTE-V2X access technology class,
# * - `3`: in case of NR-V2X access technology class.
# * 
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 ANY = 0
uint8 ITSG5_CLASS = 1
uint8 LTEV2X_CLASS = 2
uint8 NRV2X_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TimestampIts
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TimestampIts ::= INTEGER (0..4398046511103)
# ------------------------------------------------------------------------------
# *
# * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
# * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
# * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
# *  i.e. it is not altered by leap seconds, which occur in UTC.
# * 
# * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
# * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
# * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
# * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
# * further 5 leap seconds have been inserted in UTC.
# * 
# * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
# * which includes one leap second insertion since the ITS epoch.
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Description revised in in V2.1.1
# 

uint64 value
uint64 MIN = 0
uint64 MAX = 4398046511103

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 16

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/InterferenceManagementInfoPerChannel[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(InterferenceManagementInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.interference_management_channel
        _x = _v1
        buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
        _v2 = val1.interference_management_zone_type
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.interference_management_mitigation_type
        length = len(_v3.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v3.array:
          _v4 = val3.access_technology_class
          _x = _v4.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3
          buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
        _x = val1.interference_management_mitigation_type_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.expiry_time
        _x = _v5.value
        buff.write(_get_struct_Q().pack(_x))
        _x = val1.expiry_time_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementInfoPerChannel()
        _v6 = val1.interference_management_channel
        _x = _v6
        start = end
        end += 7
        (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
        _v7 = val1.interference_management_zone_type
        start = end
        end += 1
        (_v7.value,) = _get_struct_B().unpack(str[start:end])
        _v8 = val1.interference_management_mitigation_type
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
          _v9 = val3.access_technology_class
          start = end
          end += 1
          (_v9.value,) = _get_struct_B().unpack(str[start:end])
          _x = val3
          start = end
          end += 10
          (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
          val3.low_duty_cycle_is_present = bool(val3.low_duty_cycle_is_present)
          val3.power_reduction_is_present = bool(val3.power_reduction_is_present)
          val3.dmc_toff_limit_is_present = bool(val3.dmc_toff_limit_is_present)
          val3.dmc_ton_limit_is_present = bool(val3.dmc_ton_limit_is_present)
          _v8.array.append(val3)
        start = end
        end += 1
        (val1.interference_management_mitigation_type_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.interference_management_mitigation_type_is_present = bool(val1.interference_management_mitigation_type_is_present)
        _v10 = val1.expiry_time
        start = end
        end += 8
        (_v10.value,) = _get_struct_Q().unpack(str[start:end])
        start = end
        end += 1
        (val1.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.expiry_time_is_present = bool(val1.expiry_time_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v11 = val1.interference_management_channel
        _x = _v11
        buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
        _v12 = val1.interference_management_zone_type
        _x = _v12.value
        buff.write(_get_struct_B().pack(_x))
        _v13 = val1.interference_management_mitigation_type
        length = len(_v13.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v13.array:
          _v14 = val3.access_technology_class
          _x = _v14.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3
          buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
        _x = val1.interference_management_mitigation_type_is_present
        buff.write(_get_struct_B().pack(_x))
        _v15 = val1.expiry_time
        _x = _v15.value
        buff.write(_get_struct_Q().pack(_x))
        _x = val1.expiry_time_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementInfoPerChannel()
        _v16 = val1.interference_management_channel
        _x = _v16
        start = end
        end += 7
        (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
        _v17 = val1.interference_management_zone_type
        start = end
        end += 1
        (_v17.value,) = _get_struct_B().unpack(str[start:end])
        _v18 = val1.interference_management_mitigation_type
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v18.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
          _v19 = val3.access_technology_class
          start = end
          end += 1
          (_v19.value,) = _get_struct_B().unpack(str[start:end])
          _x = val3
          start = end
          end += 10
          (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
          val3.low_duty_cycle_is_present = bool(val3.low_duty_cycle_is_present)
          val3.power_reduction_is_present = bool(val3.power_reduction_is_present)
          val3.dmc_toff_limit_is_present = bool(val3.dmc_toff_limit_is_present)
          val3.dmc_ton_limit_is_present = bool(val3.dmc_ton_limit_is_present)
          _v18.array.append(val3)
        start = end
        end += 1
        (val1.interference_management_mitigation_type_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.interference_management_mitigation_type_is_present = bool(val1.interference_management_mitigation_type_is_present)
        _v20 = val1.expiry_time
        start = end
        end += 8
        (_v20.value,) = _get_struct_Q().unpack(str[start:end])
        start = end
        end += 1
        (val1.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.expiry_time_is_present = bool(val1.expiry_time_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H3BH3B = None
def _get_struct_H3BH3B():
    global _struct_H3BH3B
    if _struct_H3BH3B is None:
        _struct_H3BH3B = struct.Struct("<H3BH3B")
    return _struct_H3BH3B
_struct_IHB = None
def _get_struct_IHB():
    global _struct_IHB
    if _struct_IHB is None:
        _struct_IHB = struct.Struct("<IHB")
    return _struct_IHB
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
