# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/InterferenceManagementZoneDefinition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class InterferenceManagementZoneDefinition(genpy.Message):
  _md5sum = "aed43e2e7692fa62e56e42a669c661ef"
  _type = "etsi_its_cpm_ts_msgs/InterferenceManagementZoneDefinition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZoneDefinition::= SEQUENCE{     
#     interferenceManagementZoneLatitude     Latitude, 
#     interferenceManagementZoneLongitude    Longitude, 
#     interferenceManagementZoneId           ProtectedZoneId OPTIONAL,
#     interferenceManagementZoneShape        Shape (WITH COMPONENTS{..., radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# *
# * This DF represents the geographical definition of the zone where band sharing occurs. 
# *
# * It shall include the following components: 
# *
# * @field interferenceManagementZoneLatitude: Latitude of the centre point of the interference management zone.
# *
# * @field interferenceManagementZoneLongitude: Longitude of the centre point of the interference management zone.
# *
# * @field interferenceManagementZoneId: optional identification of the interference management zone. 
# *
# * @field interferenceManagementZoneShape: shape of the interference management zone placed at the centre point. 
# *
# * @category: Communication information
# * @revision: created in V2.1.1
# 

Latitude interference_management_zone_latitude

Longitude interference_management_zone_longitude

ProtectedZoneId interference_management_zone_id
bool interference_management_zone_id_is_present

Shape interference_management_zone_shape
bool interference_management_zone_shape_is_present
int64 INTERFERENCE_MANAGEMENT_ZONE_SHAPE_MIN = 0


================================================================================
MSG: etsi_its_cpm_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/ProtectedZoneId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedZoneId ::= INTEGER (0.. 134217727)
# ------------------------------------------------------------------------------
# *
# * This DE represents the indentifier of a protected communication zone.
# * 
# * 
# * @category: Infrastructure information, Communication information
# * @revision: Revision in V2.1.1 (changed name from ProtectedZoneID to ProtectedZoneId)
# 

uint32 value
uint32 MIN = 0
uint32 MAX = 134217727


================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present

"""
  # Pseudo-constants
  INTERFERENCE_MANAGEMENT_ZONE_SHAPE_MIN = 0

  __slots__ = ['interference_management_zone_latitude','interference_management_zone_longitude','interference_management_zone_id','interference_management_zone_id_is_present','interference_management_zone_shape','interference_management_zone_shape_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/Latitude','etsi_its_cpm_ts_msgs/Longitude','etsi_its_cpm_ts_msgs/ProtectedZoneId','bool','etsi_its_cpm_ts_msgs/Shape','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       interference_management_zone_latitude,interference_management_zone_longitude,interference_management_zone_id,interference_management_zone_id_is_present,interference_management_zone_shape,interference_management_zone_shape_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(InterferenceManagementZoneDefinition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.interference_management_zone_latitude is None:
        self.interference_management_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.interference_management_zone_longitude is None:
        self.interference_management_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.interference_management_zone_id is None:
        self.interference_management_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      if self.interference_management_zone_id_is_present is None:
        self.interference_management_zone_id_is_present = False
      if self.interference_management_zone_shape is None:
        self.interference_management_zone_shape = etsi_its_cpm_ts_msgs.msg.Shape()
      if self.interference_management_zone_shape_is_present is None:
        self.interference_management_zone_shape_is_present = False
    else:
      self.interference_management_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      self.interference_management_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      self.interference_management_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      self.interference_management_zone_id_is_present = False
      self.interference_management_zone_shape = etsi_its_cpm_ts_msgs.msg.Shape()
      self.interference_management_zone_shape_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2iI2B3h2B3HBHB3h2B2HB3h2B().pack(_x.interference_management_zone_latitude.value, _x.interference_management_zone_longitude.value, _x.interference_management_zone_id.value, _x.interference_management_zone_id_is_present, _x.interference_management_zone_shape.choice, _x.interference_management_zone_shape.rectangular.center_point.x_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.y_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present, _x.interference_management_zone_shape.rectangular.center_point_is_present, _x.interference_management_zone_shape.rectangular.semi_length.value, _x.interference_management_zone_shape.rectangular.semi_breadth.value, _x.interference_management_zone_shape.rectangular.orientation.value, _x.interference_management_zone_shape.rectangular.orientation_is_present, _x.interference_management_zone_shape.rectangular.height.value, _x.interference_management_zone_shape.rectangular.height_is_present, _x.interference_management_zone_shape.circular.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.circular.shape_reference_point_is_present, _x.interference_management_zone_shape.circular.radius.value, _x.interference_management_zone_shape.circular.height.value, _x.interference_management_zone_shape.circular.height_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point_is_present))
      length = len(self.interference_management_zone_shape.polygonal.polygon.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.interference_management_zone_shape.polygonal.polygon.array:
        _v1 = val1.x_coordinate
        _x = _v1.value
        buff.write(_get_struct_h().pack(_x))
        _v2 = val1.y_coordinate
        _x = _v2.value
        buff.write(_get_struct_h().pack(_x))
        _v3 = val1.z_coordinate
        _x = _v3.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_HB3h2B3HBHB3h2B4HBH2B3hB().pack(_x.interference_management_zone_shape.polygonal.height.value, _x.interference_management_zone_shape.polygonal.height_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point_is_present, _x.interference_management_zone_shape.elliptical.semi_major_axis_length.value, _x.interference_management_zone_shape.elliptical.semi_minor_axis_length.value, _x.interference_management_zone_shape.elliptical.orientation.value, _x.interference_management_zone_shape.elliptical.orientation_is_present, _x.interference_management_zone_shape.elliptical.height.value, _x.interference_management_zone_shape.elliptical.height_is_present, _x.interference_management_zone_shape.radial.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.radial.shape_reference_point_is_present, _x.interference_management_zone_shape.radial.range.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_start.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present, _x.interference_management_zone_shape.radial.vertical_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present, _x.interference_management_zone_shape.radial_shapes.ref_point_id.value, _x.interference_management_zone_shape.radial_shapes.x_coordinate.value, _x.interference_management_zone_shape.radial_shapes.y_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate_is_present))
      length = len(self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array:
        _v4 = val1.range
        _x = _v4.value
        buff.write(_get_struct_H().pack(_x))
        _v5 = val1.horizontal_opening_angle_start
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _v6 = val1.horizontal_opening_angle_end
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
        _v7 = val1.vertical_opening_angle_start
        _x = _v7.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v8 = val1.vertical_opening_angle_end
        _x = _v8.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.interference_management_zone_shape_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.interference_management_zone_latitude is None:
        self.interference_management_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.interference_management_zone_longitude is None:
        self.interference_management_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.interference_management_zone_id is None:
        self.interference_management_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      if self.interference_management_zone_shape is None:
        self.interference_management_zone_shape = etsi_its_cpm_ts_msgs.msg.Shape()
      end = 0
      _x = self
      start = end
      end += 53
      (_x.interference_management_zone_latitude.value, _x.interference_management_zone_longitude.value, _x.interference_management_zone_id.value, _x.interference_management_zone_id_is_present, _x.interference_management_zone_shape.choice, _x.interference_management_zone_shape.rectangular.center_point.x_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.y_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present, _x.interference_management_zone_shape.rectangular.center_point_is_present, _x.interference_management_zone_shape.rectangular.semi_length.value, _x.interference_management_zone_shape.rectangular.semi_breadth.value, _x.interference_management_zone_shape.rectangular.orientation.value, _x.interference_management_zone_shape.rectangular.orientation_is_present, _x.interference_management_zone_shape.rectangular.height.value, _x.interference_management_zone_shape.rectangular.height_is_present, _x.interference_management_zone_shape.circular.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.circular.shape_reference_point_is_present, _x.interference_management_zone_shape.circular.radius.value, _x.interference_management_zone_shape.circular.height.value, _x.interference_management_zone_shape.circular.height_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point_is_present,) = _get_struct_2iI2B3h2B3HBHB3h2B2HB3h2B().unpack(str[start:end])
      self.interference_management_zone_id_is_present = bool(self.interference_management_zone_id_is_present)
      self.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present)
      self.interference_management_zone_shape.rectangular.center_point_is_present = bool(self.interference_management_zone_shape.rectangular.center_point_is_present)
      self.interference_management_zone_shape.rectangular.orientation_is_present = bool(self.interference_management_zone_shape.rectangular.orientation_is_present)
      self.interference_management_zone_shape.rectangular.height_is_present = bool(self.interference_management_zone_shape.rectangular.height_is_present)
      self.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.circular.shape_reference_point_is_present = bool(self.interference_management_zone_shape.circular.shape_reference_point_is_present)
      self.interference_management_zone_shape.circular.height_is_present = bool(self.interference_management_zone_shape.circular.height_is_present)
      self.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.polygonal.shape_reference_point_is_present = bool(self.interference_management_zone_shape.polygonal.shape_reference_point_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interference_management_zone_shape.polygonal.polygon.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
        _v9 = val1.x_coordinate
        start = end
        end += 2
        (_v9.value,) = _get_struct_h().unpack(str[start:end])
        _v10 = val1.y_coordinate
        start = end
        end += 2
        (_v10.value,) = _get_struct_h().unpack(str[start:end])
        _v11 = val1.z_coordinate
        start = end
        end += 2
        (_v11.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_coordinate_is_present = bool(val1.z_coordinate_is_present)
        self.interference_management_zone_shape.polygonal.polygon.array.append(val1)
      _x = self
      start = end
      end += 49
      (_x.interference_management_zone_shape.polygonal.height.value, _x.interference_management_zone_shape.polygonal.height_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point_is_present, _x.interference_management_zone_shape.elliptical.semi_major_axis_length.value, _x.interference_management_zone_shape.elliptical.semi_minor_axis_length.value, _x.interference_management_zone_shape.elliptical.orientation.value, _x.interference_management_zone_shape.elliptical.orientation_is_present, _x.interference_management_zone_shape.elliptical.height.value, _x.interference_management_zone_shape.elliptical.height_is_present, _x.interference_management_zone_shape.radial.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.radial.shape_reference_point_is_present, _x.interference_management_zone_shape.radial.range.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_start.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present, _x.interference_management_zone_shape.radial.vertical_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present, _x.interference_management_zone_shape.radial_shapes.ref_point_id.value, _x.interference_management_zone_shape.radial_shapes.x_coordinate.value, _x.interference_management_zone_shape.radial_shapes.y_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate_is_present,) = _get_struct_HB3h2B3HBHB3h2B4HBH2B3hB().unpack(str[start:end])
      self.interference_management_zone_shape.polygonal.height_is_present = bool(self.interference_management_zone_shape.polygonal.height_is_present)
      self.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.elliptical.shape_reference_point_is_present = bool(self.interference_management_zone_shape.elliptical.shape_reference_point_is_present)
      self.interference_management_zone_shape.elliptical.orientation_is_present = bool(self.interference_management_zone_shape.elliptical.orientation_is_present)
      self.interference_management_zone_shape.elliptical.height_is_present = bool(self.interference_management_zone_shape.elliptical.height_is_present)
      self.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.radial.shape_reference_point_is_present = bool(self.interference_management_zone_shape.radial.shape_reference_point_is_present)
      self.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present = bool(self.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present)
      self.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present = bool(self.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present)
      self.interference_management_zone_shape.radial_shapes.z_coordinate_is_present = bool(self.interference_management_zone_shape.radial_shapes.z_coordinate_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
        _v12 = val1.range
        start = end
        end += 2
        (_v12.value,) = _get_struct_H().unpack(str[start:end])
        _v13 = val1.horizontal_opening_angle_start
        start = end
        end += 2
        (_v13.value,) = _get_struct_H().unpack(str[start:end])
        _v14 = val1.horizontal_opening_angle_end
        start = end
        end += 2
        (_v14.value,) = _get_struct_H().unpack(str[start:end])
        _v15 = val1.vertical_opening_angle_start
        start = end
        end += 2
        (_v15.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_start_is_present = bool(val1.vertical_opening_angle_start_is_present)
        _v16 = val1.vertical_opening_angle_end
        start = end
        end += 2
        (_v16.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_end_is_present = bool(val1.vertical_opening_angle_end_is_present)
        self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array.append(val1)
      start = end
      end += 1
      (self.interference_management_zone_shape_is_present,) = _get_struct_B().unpack(str[start:end])
      self.interference_management_zone_shape_is_present = bool(self.interference_management_zone_shape_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2iI2B3h2B3HBHB3h2B2HB3h2B().pack(_x.interference_management_zone_latitude.value, _x.interference_management_zone_longitude.value, _x.interference_management_zone_id.value, _x.interference_management_zone_id_is_present, _x.interference_management_zone_shape.choice, _x.interference_management_zone_shape.rectangular.center_point.x_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.y_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present, _x.interference_management_zone_shape.rectangular.center_point_is_present, _x.interference_management_zone_shape.rectangular.semi_length.value, _x.interference_management_zone_shape.rectangular.semi_breadth.value, _x.interference_management_zone_shape.rectangular.orientation.value, _x.interference_management_zone_shape.rectangular.orientation_is_present, _x.interference_management_zone_shape.rectangular.height.value, _x.interference_management_zone_shape.rectangular.height_is_present, _x.interference_management_zone_shape.circular.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.circular.shape_reference_point_is_present, _x.interference_management_zone_shape.circular.radius.value, _x.interference_management_zone_shape.circular.height.value, _x.interference_management_zone_shape.circular.height_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point_is_present))
      length = len(self.interference_management_zone_shape.polygonal.polygon.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.interference_management_zone_shape.polygonal.polygon.array:
        _v17 = val1.x_coordinate
        _x = _v17.value
        buff.write(_get_struct_h().pack(_x))
        _v18 = val1.y_coordinate
        _x = _v18.value
        buff.write(_get_struct_h().pack(_x))
        _v19 = val1.z_coordinate
        _x = _v19.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_HB3h2B3HBHB3h2B4HBH2B3hB().pack(_x.interference_management_zone_shape.polygonal.height.value, _x.interference_management_zone_shape.polygonal.height_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point_is_present, _x.interference_management_zone_shape.elliptical.semi_major_axis_length.value, _x.interference_management_zone_shape.elliptical.semi_minor_axis_length.value, _x.interference_management_zone_shape.elliptical.orientation.value, _x.interference_management_zone_shape.elliptical.orientation_is_present, _x.interference_management_zone_shape.elliptical.height.value, _x.interference_management_zone_shape.elliptical.height_is_present, _x.interference_management_zone_shape.radial.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.radial.shape_reference_point_is_present, _x.interference_management_zone_shape.radial.range.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_start.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present, _x.interference_management_zone_shape.radial.vertical_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present, _x.interference_management_zone_shape.radial_shapes.ref_point_id.value, _x.interference_management_zone_shape.radial_shapes.x_coordinate.value, _x.interference_management_zone_shape.radial_shapes.y_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate_is_present))
      length = len(self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array:
        _v20 = val1.range
        _x = _v20.value
        buff.write(_get_struct_H().pack(_x))
        _v21 = val1.horizontal_opening_angle_start
        _x = _v21.value
        buff.write(_get_struct_H().pack(_x))
        _v22 = val1.horizontal_opening_angle_end
        _x = _v22.value
        buff.write(_get_struct_H().pack(_x))
        _v23 = val1.vertical_opening_angle_start
        _x = _v23.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v24 = val1.vertical_opening_angle_end
        _x = _v24.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.interference_management_zone_shape_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.interference_management_zone_latitude is None:
        self.interference_management_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.interference_management_zone_longitude is None:
        self.interference_management_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.interference_management_zone_id is None:
        self.interference_management_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      if self.interference_management_zone_shape is None:
        self.interference_management_zone_shape = etsi_its_cpm_ts_msgs.msg.Shape()
      end = 0
      _x = self
      start = end
      end += 53
      (_x.interference_management_zone_latitude.value, _x.interference_management_zone_longitude.value, _x.interference_management_zone_id.value, _x.interference_management_zone_id_is_present, _x.interference_management_zone_shape.choice, _x.interference_management_zone_shape.rectangular.center_point.x_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.y_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate.value, _x.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present, _x.interference_management_zone_shape.rectangular.center_point_is_present, _x.interference_management_zone_shape.rectangular.semi_length.value, _x.interference_management_zone_shape.rectangular.semi_breadth.value, _x.interference_management_zone_shape.rectangular.orientation.value, _x.interference_management_zone_shape.rectangular.orientation_is_present, _x.interference_management_zone_shape.rectangular.height.value, _x.interference_management_zone_shape.rectangular.height_is_present, _x.interference_management_zone_shape.circular.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.circular.shape_reference_point_is_present, _x.interference_management_zone_shape.circular.radius.value, _x.interference_management_zone_shape.circular.height.value, _x.interference_management_zone_shape.circular.height_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.polygonal.shape_reference_point_is_present,) = _get_struct_2iI2B3h2B3HBHB3h2B2HB3h2B().unpack(str[start:end])
      self.interference_management_zone_id_is_present = bool(self.interference_management_zone_id_is_present)
      self.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.rectangular.center_point.z_coordinate_is_present)
      self.interference_management_zone_shape.rectangular.center_point_is_present = bool(self.interference_management_zone_shape.rectangular.center_point_is_present)
      self.interference_management_zone_shape.rectangular.orientation_is_present = bool(self.interference_management_zone_shape.rectangular.orientation_is_present)
      self.interference_management_zone_shape.rectangular.height_is_present = bool(self.interference_management_zone_shape.rectangular.height_is_present)
      self.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.circular.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.circular.shape_reference_point_is_present = bool(self.interference_management_zone_shape.circular.shape_reference_point_is_present)
      self.interference_management_zone_shape.circular.height_is_present = bool(self.interference_management_zone_shape.circular.height_is_present)
      self.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.polygonal.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.polygonal.shape_reference_point_is_present = bool(self.interference_management_zone_shape.polygonal.shape_reference_point_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interference_management_zone_shape.polygonal.polygon.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
        _v25 = val1.x_coordinate
        start = end
        end += 2
        (_v25.value,) = _get_struct_h().unpack(str[start:end])
        _v26 = val1.y_coordinate
        start = end
        end += 2
        (_v26.value,) = _get_struct_h().unpack(str[start:end])
        _v27 = val1.z_coordinate
        start = end
        end += 2
        (_v27.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_coordinate_is_present = bool(val1.z_coordinate_is_present)
        self.interference_management_zone_shape.polygonal.polygon.array.append(val1)
      _x = self
      start = end
      end += 49
      (_x.interference_management_zone_shape.polygonal.height.value, _x.interference_management_zone_shape.polygonal.height_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.elliptical.shape_reference_point_is_present, _x.interference_management_zone_shape.elliptical.semi_major_axis_length.value, _x.interference_management_zone_shape.elliptical.semi_minor_axis_length.value, _x.interference_management_zone_shape.elliptical.orientation.value, _x.interference_management_zone_shape.elliptical.orientation_is_present, _x.interference_management_zone_shape.elliptical.height.value, _x.interference_management_zone_shape.elliptical.height_is_present, _x.interference_management_zone_shape.radial.shape_reference_point.x_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.y_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate.value, _x.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present, _x.interference_management_zone_shape.radial.shape_reference_point_is_present, _x.interference_management_zone_shape.radial.range.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_start.value, _x.interference_management_zone_shape.radial.stationary_horizontal_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present, _x.interference_management_zone_shape.radial.vertical_opening_angle_end.value, _x.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present, _x.interference_management_zone_shape.radial_shapes.ref_point_id.value, _x.interference_management_zone_shape.radial_shapes.x_coordinate.value, _x.interference_management_zone_shape.radial_shapes.y_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate.value, _x.interference_management_zone_shape.radial_shapes.z_coordinate_is_present,) = _get_struct_HB3h2B3HBHB3h2B4HBH2B3hB().unpack(str[start:end])
      self.interference_management_zone_shape.polygonal.height_is_present = bool(self.interference_management_zone_shape.polygonal.height_is_present)
      self.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.elliptical.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.elliptical.shape_reference_point_is_present = bool(self.interference_management_zone_shape.elliptical.shape_reference_point_is_present)
      self.interference_management_zone_shape.elliptical.orientation_is_present = bool(self.interference_management_zone_shape.elliptical.orientation_is_present)
      self.interference_management_zone_shape.elliptical.height_is_present = bool(self.interference_management_zone_shape.elliptical.height_is_present)
      self.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present = bool(self.interference_management_zone_shape.radial.shape_reference_point.z_coordinate_is_present)
      self.interference_management_zone_shape.radial.shape_reference_point_is_present = bool(self.interference_management_zone_shape.radial.shape_reference_point_is_present)
      self.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present = bool(self.interference_management_zone_shape.radial.vertical_opening_angle_start_is_present)
      self.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present = bool(self.interference_management_zone_shape.radial.vertical_opening_angle_end_is_present)
      self.interference_management_zone_shape.radial_shapes.z_coordinate_is_present = bool(self.interference_management_zone_shape.radial_shapes.z_coordinate_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
        _v28 = val1.range
        start = end
        end += 2
        (_v28.value,) = _get_struct_H().unpack(str[start:end])
        _v29 = val1.horizontal_opening_angle_start
        start = end
        end += 2
        (_v29.value,) = _get_struct_H().unpack(str[start:end])
        _v30 = val1.horizontal_opening_angle_end
        start = end
        end += 2
        (_v30.value,) = _get_struct_H().unpack(str[start:end])
        _v31 = val1.vertical_opening_angle_start
        start = end
        end += 2
        (_v31.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_start_is_present = bool(val1.vertical_opening_angle_start_is_present)
        _v32 = val1.vertical_opening_angle_end
        start = end
        end += 2
        (_v32.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_end_is_present = bool(val1.vertical_opening_angle_end_is_present)
        self.interference_management_zone_shape.radial_shapes.radial_shapes_list.array.append(val1)
      start = end
      end += 1
      (self.interference_management_zone_shape_is_present,) = _get_struct_B().unpack(str[start:end])
      self.interference_management_zone_shape_is_present = bool(self.interference_management_zone_shape_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2iI2B3h2B3HBHB3h2B2HB3h2B = None
def _get_struct_2iI2B3h2B3HBHB3h2B2HB3h2B():
    global _struct_2iI2B3h2B3HBHB3h2B2HB3h2B
    if _struct_2iI2B3h2B3HBHB3h2B2HB3h2B is None:
        _struct_2iI2B3h2B3HBHB3h2B2HB3h2B = struct.Struct("<2iI2B3h2B3HBHB3h2B2HB3h2B")
    return _struct_2iI2B3h2B3HBHB3h2B2HB3h2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_HB3h2B3HBHB3h2B4HBH2B3hB = None
def _get_struct_HB3h2B3HBHB3h2B4HBH2B3hB():
    global _struct_HB3h2B3HBHB3h2B4HBH2B3hB
    if _struct_HB3h2B3HBHB3h2B4HBH2B3hB is None:
        _struct_HB3h2B3HBHB3h2B4HBH2B3hB = struct.Struct("<HB3h2B3HBHB3h2B4HBH2B3hB")
    return _struct_HB3h2B3HBHB3h2B4HBH2B3hB
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
