# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/InterferenceManagementZoneType.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class InterferenceManagementZoneType(genpy.Message):
  _md5sum = "171ce0aae659243138528d63f10745b3"
  _type = "etsi_its_cpm_ts_msgs/InterferenceManagementZoneType"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZoneType ::= ENUMERATED {
#     permanentCenDsrcTolling (0),
#     temporaryCenDsrcTolling (1),
#     unavailable             (2), 
#     urbanRail               (3),      
#     satelliteStation        (4),
#     fixedLinks              (5), 
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DE defines the type of an interference management zone, so that an ITS-S can 
# * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
# * It is an extension of the type @ref ProtectedZoneType.
# *
# * The value shall be set to:
# * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,
# * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,
# * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,
# * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 PERMANENT_CEN_DSRC_TOLLING = 0
uint8 TEMPORARY_CEN_DSRC_TOLLING = 1
uint8 UNAVAILABLE = 2
uint8 URBAN_RAIL = 3
uint8 SATELLITE_STATION = 4
uint8 FIXED_LINKS = 5

"""
  # Pseudo-constants
  PERMANENT_CEN_DSRC_TOLLING = 0
  TEMPORARY_CEN_DSRC_TOLLING = 1
  UNAVAILABLE = 2
  URBAN_RAIL = 3
  SATELLITE_STATION = 4
  FIXED_LINKS = 5

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(InterferenceManagementZoneType, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
