# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/InterferenceManagementZones.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class InterferenceManagementZones(genpy.Message):
  _md5sum = "943aef04796a9bca35dfecb1f78f4ef6"
  _type = "etsi_its_cpm_ts_msgs/InterferenceManagementZones"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZones ::= SEQUENCE (SIZE(1..16), ...) OF InterferenceManagementZone
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of up to 16 interference  management zones.  
# *
# * **EXAMPLE**: An interference management communication zone may be defined around a CEN DSRC road side equipment or an urban rail operational area.
# * 
# * @category: Communication information
# * @revision: created in V2.1.1
# 

InterferenceManagementZone[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementZone
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZone ::= SEQUENCE {
# 	zoneDefinition    InterferenceManagementZoneDefinition,
# 	managementInfo    InterferenceManagementInfo
# }
# ------------------------------------------------------------------------------
# *
# * 
# * This DF represents a zone  inside which the ITS communication should be restricted in order to manage interference.
# *
# * It shall include the following components: 
# *
# * @field zoneDefinition: contains the geographical definition of the zone.
# *
# * @field managementInfo: contains interference management information applicable in the zone defined in the component zoneDefinition.
# *
# * @category: Communication information
# * @revision: created in V2.1.1
# 

InterferenceManagementZoneDefinition zone_definition

InterferenceManagementInfo management_info


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementZoneDefinition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZoneDefinition::= SEQUENCE{     
#     interferenceManagementZoneLatitude     Latitude, 
#     interferenceManagementZoneLongitude    Longitude, 
#     interferenceManagementZoneId           ProtectedZoneId OPTIONAL,
#     interferenceManagementZoneShape        Shape (WITH COMPONENTS{..., radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# *
# * This DF represents the geographical definition of the zone where band sharing occurs. 
# *
# * It shall include the following components: 
# *
# * @field interferenceManagementZoneLatitude: Latitude of the centre point of the interference management zone.
# *
# * @field interferenceManagementZoneLongitude: Longitude of the centre point of the interference management zone.
# *
# * @field interferenceManagementZoneId: optional identification of the interference management zone. 
# *
# * @field interferenceManagementZoneShape: shape of the interference management zone placed at the centre point. 
# *
# * @category: Communication information
# * @revision: created in V2.1.1
# 

Latitude interference_management_zone_latitude

Longitude interference_management_zone_longitude

ProtectedZoneId interference_management_zone_id
bool interference_management_zone_id_is_present

Shape interference_management_zone_shape
bool interference_management_zone_shape_is_present
int64 INTERFERENCE_MANAGEMENT_ZONE_SHAPE_MIN = 0


================================================================================
MSG: etsi_its_cpm_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/ProtectedZoneId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedZoneId ::= INTEGER (0.. 134217727)
# ------------------------------------------------------------------------------
# *
# * This DE represents the indentifier of a protected communication zone.
# * 
# * 
# * @category: Infrastructure information, Communication information
# * @revision: Revision in V2.1.1 (changed name from ProtectedZoneID to ProtectedZoneId)
# 

uint32 value
uint32 MIN = 0
uint32 MAX = 134217727


================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementInfo
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementInfo::= SEQUENCE (SIZE(1..16,...)) OF InterferenceManagementInfoPerChannel
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of up to 16 definitions containing interference management information, per affected frequency channels.
# *  
# * @category: Communication information.
# * @revision: created in V2.1.1
# 

InterferenceManagementInfoPerChannel[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementInfoPerChannel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementInfoPerChannel ::= SEQUENCE {
#     interferenceManagementChannel           InterferenceManagementChannel,
#     interferenceManagementZoneType          InterferenceManagementZoneType,
#     interferenceManagementMitigationType    MitigationForTechnologies OPTIONAL,
#     expiryTime                              TimestampIts OPTIONAL, 
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF contains interference management information for one affected frequency channel.
# *
# * It shall include the following components: 
# *
# * @field interferenceManagementChannel: frequency channel for which the zone should be applied interference management 
# *
# * @field interferenceManagementZoneType: type of the interference management zone. 
# *
# * @field interferenceManagementMitigationType: optional type of the mitigation to be used in the interference management zone. 
# * In the case where no mitigation should be applied by the ITS-S, this is indicated by the field interferenceManagementMitigationType being absent.
# *
# * @field expiryTime: optional time at which the validity of the interference management communication zone will expire. 
# * This component is present when the interference management is temporarily valid
# *
# * @category: Communication information
# * @revision: created in V2.1.1
# 

InterferenceManagementChannel interference_management_channel

InterferenceManagementZoneType interference_management_zone_type

MitigationForTechnologies interference_management_mitigation_type
bool interference_management_mitigation_type_is_present

TimestampIts expiry_time
bool expiry_time_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementChannel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementChannel ::= SEQUENCE {
#     centreFrequency    INTEGER (1 .. 99999),
#     channelWidth       INTEGER (0 .. 9999),
#     exponent           INTEGER (0 .. 15) 
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a frequency channel 
# *
# * It shall include the following components: 
# *
# * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)
# * 
# * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)
# *
# * @field exponent: exponent of the power of 10 used in the calculation of the components above.
# *
# * @category: Communication information
# * @revision: created in V2.1.1
#

uint32 centre_frequency
uint32 CENTRE_FREQUENCY_MIN = 1
uint32 CENTRE_FREQUENCY_MAX = 99999

uint16 channel_width
uint16 CHANNEL_WIDTH_MIN = 0
uint16 CHANNEL_WIDTH_MAX = 9999

uint8 exponent
uint8 EXPONENT_MIN = 0
uint8 EXPONENT_MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/InterferenceManagementZoneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# InterferenceManagementZoneType ::= ENUMERATED {
#     permanentCenDsrcTolling (0),
#     temporaryCenDsrcTolling (1),
#     unavailable             (2), 
#     urbanRail               (3),      
#     satelliteStation        (4),
#     fixedLinks              (5), 
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DE defines the type of an interference management zone, so that an ITS-S can 
# * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
# * It is an extension of the type @ref ProtectedZoneType.
# *
# * The value shall be set to:
# * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
# * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,
# * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,
# * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,
# * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 PERMANENT_CEN_DSRC_TOLLING = 0
uint8 TEMPORARY_CEN_DSRC_TOLLING = 1
uint8 UNAVAILABLE = 2
uint8 URBAN_RAIL = 3
uint8 SATELLITE_STATION = 4
uint8 FIXED_LINKS = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/MitigationForTechnologies
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationForTechnologies ::= SEQUENCE (SIZE(1..8)) OF MitigationPerTechnologyClass 
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of @ref MitigationPerTechnologyClass.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
#

MitigationPerTechnologyClass[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationPerTechnologyClass ::= SEQUENCE {
#    accessTechnologyClass    AccessTechnologyClass, 
#    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL, 
#    powerReduction           INTEGER (0 .. 30) OPTIONAL,
#    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,   
#    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,   
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
# *
# * It shall include the following components: 
# *
# * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
# *
# * @field lowDutyCycle: duty cycle limit.
# * @unit: 0,01 % steps
# *
# * @field powerReduction: the delta value of power to be reduced.
# * @unit: dB
# *
# * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
# * @unit: ms
# *
# * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
# * @unit: ms
# *
# * @note: All parameters are optional, as they may not apply to some of the technologies or
# * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7. 
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

AccessTechnologyClass access_technology_class

uint16 low_duty_cycle
bool low_duty_cycle_is_present
uint16 LOW_DUTY_CYCLE_MIN = 0
uint16 LOW_DUTY_CYCLE_MAX = 10000

uint8 power_reduction
bool power_reduction_is_present
uint8 POWER_REDUCTION_MIN = 0
uint8 POWER_REDUCTION_MAX = 30

uint16 dmc_toff_limit
bool dmc_toff_limit_is_present
uint16 DMC_TOFF_LIMIT_MIN = 0
uint16 DMC_TOFF_LIMIT_MAX = 1200

uint8 dmc_ton_limit
bool dmc_ton_limit_is_present
uint8 DMC_TON_LIMIT_MIN = 0
uint8 DMC_TON_LIMIT_MAX = 20


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccessTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccessTechnologyClass ::= ENUMERATED {
#    any         (0), 
#    itsg5Class  (1), 
#    ltev2xClass (2), 
#    nrv2xClass  (3),
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates an access technology.
# *
# * The value shall be set to:
# * - `0`: in case of any access technology class,
# * - `1`: in case of ITS-G5 access technology class,
# * - `2`: in case of LTE-V2X access technology class,
# * - `3`: in case of NR-V2X access technology class.
# * 
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 ANY = 0
uint8 ITSG5_CLASS = 1
uint8 LTEV2X_CLASS = 2
uint8 NRV2X_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TimestampIts
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TimestampIts ::= INTEGER (0..4398046511103)
# ------------------------------------------------------------------------------
# *
# * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
# * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
# * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
# *  i.e. it is not altered by leap seconds, which occur in UTC.
# * 
# * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
# * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
# * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
# * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
# * further 5 leap seconds have been inserted in UTC.
# * 
# * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
# * which includes one leap second insertion since the ITS epoch.
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Description revised in in V2.1.1
# 

uint64 value
uint64 MIN = 0
uint64 MAX = 4398046511103

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 16

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/InterferenceManagementZone[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(InterferenceManagementZones, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.zone_definition
        _v2 = _v1.interference_management_zone_latitude
        _x = _v2.value
        buff.write(_get_struct_i().pack(_x))
        _v3 = _v1.interference_management_zone_longitude
        _x = _v3.value
        buff.write(_get_struct_i().pack(_x))
        _v4 = _v1.interference_management_zone_id
        _x = _v4.value
        buff.write(_get_struct_I().pack(_x))
        _x = _v1.interference_management_zone_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = _v1.interference_management_zone_shape
        _x = _v5.choice
        buff.write(_get_struct_B().pack(_x))
        _v6 = _v5.rectangular
        _v7 = _v6.center_point
        _v8 = _v7.x_coordinate
        _x = _v8.value
        buff.write(_get_struct_h().pack(_x))
        _v9 = _v7.y_coordinate
        _x = _v9.value
        buff.write(_get_struct_h().pack(_x))
        _v10 = _v7.z_coordinate
        _x = _v10.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v7.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v6.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v11 = _v6.semi_length
        _x = _v11.value
        buff.write(_get_struct_H().pack(_x))
        _v12 = _v6.semi_breadth
        _x = _v12.value
        buff.write(_get_struct_H().pack(_x))
        _v13 = _v6.orientation
        _x = _v13.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v6.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v14 = _v6.height
        _x = _v14.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v6.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v15 = _v5.circular
        _v16 = _v15.shape_reference_point
        _v17 = _v16.x_coordinate
        _x = _v17.value
        buff.write(_get_struct_h().pack(_x))
        _v18 = _v16.y_coordinate
        _x = _v18.value
        buff.write(_get_struct_h().pack(_x))
        _v19 = _v16.z_coordinate
        _x = _v19.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v16.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v15.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = _v15.radius
        _x = _v20.value
        buff.write(_get_struct_H().pack(_x))
        _v21 = _v15.height
        _x = _v21.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v15.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v22 = _v5.polygonal
        _v23 = _v22.shape_reference_point
        _v24 = _v23.x_coordinate
        _x = _v24.value
        buff.write(_get_struct_h().pack(_x))
        _v25 = _v23.y_coordinate
        _x = _v25.value
        buff.write(_get_struct_h().pack(_x))
        _v26 = _v23.z_coordinate
        _x = _v26.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v23.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v22.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v27 = _v22.polygon
        length = len(_v27.array)
        buff.write(_struct_I.pack(length))
        for val6 in _v27.array:
          _v28 = val6.x_coordinate
          _x = _v28.value
          buff.write(_get_struct_h().pack(_x))
          _v29 = val6.y_coordinate
          _x = _v29.value
          buff.write(_get_struct_h().pack(_x))
          _v30 = val6.z_coordinate
          _x = _v30.value
          buff.write(_get_struct_h().pack(_x))
          _x = val6.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v31 = _v22.height
        _x = _v31.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v22.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v32 = _v5.elliptical
        _v33 = _v32.shape_reference_point
        _v34 = _v33.x_coordinate
        _x = _v34.value
        buff.write(_get_struct_h().pack(_x))
        _v35 = _v33.y_coordinate
        _x = _v35.value
        buff.write(_get_struct_h().pack(_x))
        _v36 = _v33.z_coordinate
        _x = _v36.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v33.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v32.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v37 = _v32.semi_major_axis_length
        _x = _v37.value
        buff.write(_get_struct_H().pack(_x))
        _v38 = _v32.semi_minor_axis_length
        _x = _v38.value
        buff.write(_get_struct_H().pack(_x))
        _v39 = _v32.orientation
        _x = _v39.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v32.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v40 = _v32.height
        _x = _v40.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v32.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v41 = _v5.radial
        _v42 = _v41.shape_reference_point
        _v43 = _v42.x_coordinate
        _x = _v43.value
        buff.write(_get_struct_h().pack(_x))
        _v44 = _v42.y_coordinate
        _x = _v44.value
        buff.write(_get_struct_h().pack(_x))
        _v45 = _v42.z_coordinate
        _x = _v45.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v42.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v41.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v46 = _v41.range
        _x = _v46.value
        buff.write(_get_struct_H().pack(_x))
        _v47 = _v41.stationary_horizontal_opening_angle_start
        _x = _v47.value
        buff.write(_get_struct_H().pack(_x))
        _v48 = _v41.stationary_horizontal_opening_angle_end
        _x = _v48.value
        buff.write(_get_struct_H().pack(_x))
        _v49 = _v41.vertical_opening_angle_start
        _x = _v49.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v41.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v50 = _v41.vertical_opening_angle_end
        _x = _v50.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v41.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v51 = _v5.radial_shapes
        _v52 = _v51.ref_point_id
        _x = _v52.value
        buff.write(_get_struct_B().pack(_x))
        _v53 = _v51.x_coordinate
        _x = _v53.value
        buff.write(_get_struct_h().pack(_x))
        _v54 = _v51.y_coordinate
        _x = _v54.value
        buff.write(_get_struct_h().pack(_x))
        _v55 = _v51.z_coordinate
        _x = _v55.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v51.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v56 = _v51.radial_shapes_list
        length = len(_v56.array)
        buff.write(_struct_I.pack(length))
        for val6 in _v56.array:
          _v57 = val6.range
          _x = _v57.value
          buff.write(_get_struct_H().pack(_x))
          _v58 = val6.horizontal_opening_angle_start
          _x = _v58.value
          buff.write(_get_struct_H().pack(_x))
          _v59 = val6.horizontal_opening_angle_end
          _x = _v59.value
          buff.write(_get_struct_H().pack(_x))
          _v60 = val6.vertical_opening_angle_start
          _x = _v60.value
          buff.write(_get_struct_H().pack(_x))
          _x = val6.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v61 = val6.vertical_opening_angle_end
          _x = _v61.value
          buff.write(_get_struct_H().pack(_x))
          _x = val6.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = _v1.interference_management_zone_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v62 = val1.management_info
        length = len(_v62.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v62.array:
          _v63 = val3.interference_management_channel
          _x = _v63
          buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
          _v64 = val3.interference_management_zone_type
          _x = _v64.value
          buff.write(_get_struct_B().pack(_x))
          _v65 = val3.interference_management_mitigation_type
          length = len(_v65.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v65.array:
            _v66 = val5.access_technology_class
            _x = _v66.value
            buff.write(_get_struct_B().pack(_x))
            _x = val5
            buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
          _x = val3.interference_management_mitigation_type_is_present
          buff.write(_get_struct_B().pack(_x))
          _v67 = val3.expiry_time
          _x = _v67.value
          buff.write(_get_struct_Q().pack(_x))
          _x = val3.expiry_time_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementZone()
        _v68 = val1.zone_definition
        _v69 = _v68.interference_management_zone_latitude
        start = end
        end += 4
        (_v69.value,) = _get_struct_i().unpack(str[start:end])
        _v70 = _v68.interference_management_zone_longitude
        start = end
        end += 4
        (_v70.value,) = _get_struct_i().unpack(str[start:end])
        _v71 = _v68.interference_management_zone_id
        start = end
        end += 4
        (_v71.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (_v68.interference_management_zone_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v68.interference_management_zone_id_is_present = bool(_v68.interference_management_zone_id_is_present)
        _v72 = _v68.interference_management_zone_shape
        start = end
        end += 1
        (_v72.choice,) = _get_struct_B().unpack(str[start:end])
        _v73 = _v72.rectangular
        _v74 = _v73.center_point
        _v75 = _v74.x_coordinate
        start = end
        end += 2
        (_v75.value,) = _get_struct_h().unpack(str[start:end])
        _v76 = _v74.y_coordinate
        start = end
        end += 2
        (_v76.value,) = _get_struct_h().unpack(str[start:end])
        _v77 = _v74.z_coordinate
        start = end
        end += 2
        (_v77.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v74.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v74.z_coordinate_is_present = bool(_v74.z_coordinate_is_present)
        start = end
        end += 1
        (_v73.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v73.center_point_is_present = bool(_v73.center_point_is_present)
        _v78 = _v73.semi_length
        start = end
        end += 2
        (_v78.value,) = _get_struct_H().unpack(str[start:end])
        _v79 = _v73.semi_breadth
        start = end
        end += 2
        (_v79.value,) = _get_struct_H().unpack(str[start:end])
        _v80 = _v73.orientation
        start = end
        end += 2
        (_v80.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v73.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v73.orientation_is_present = bool(_v73.orientation_is_present)
        _v81 = _v73.height
        start = end
        end += 2
        (_v81.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v73.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v73.height_is_present = bool(_v73.height_is_present)
        _v82 = _v72.circular
        _v83 = _v82.shape_reference_point
        _v84 = _v83.x_coordinate
        start = end
        end += 2
        (_v84.value,) = _get_struct_h().unpack(str[start:end])
        _v85 = _v83.y_coordinate
        start = end
        end += 2
        (_v85.value,) = _get_struct_h().unpack(str[start:end])
        _v86 = _v83.z_coordinate
        start = end
        end += 2
        (_v86.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v83.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v83.z_coordinate_is_present = bool(_v83.z_coordinate_is_present)
        start = end
        end += 1
        (_v82.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v82.shape_reference_point_is_present = bool(_v82.shape_reference_point_is_present)
        _v87 = _v82.radius
        start = end
        end += 2
        (_v87.value,) = _get_struct_H().unpack(str[start:end])
        _v88 = _v82.height
        start = end
        end += 2
        (_v88.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v82.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v82.height_is_present = bool(_v82.height_is_present)
        _v89 = _v72.polygonal
        _v90 = _v89.shape_reference_point
        _v91 = _v90.x_coordinate
        start = end
        end += 2
        (_v91.value,) = _get_struct_h().unpack(str[start:end])
        _v92 = _v90.y_coordinate
        start = end
        end += 2
        (_v92.value,) = _get_struct_h().unpack(str[start:end])
        _v93 = _v90.z_coordinate
        start = end
        end += 2
        (_v93.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v90.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.z_coordinate_is_present = bool(_v90.z_coordinate_is_present)
        start = end
        end += 1
        (_v89.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v89.shape_reference_point_is_present = bool(_v89.shape_reference_point_is_present)
        _v94 = _v89.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v94.array = []
        for i in range(0, length):
          val6 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v95 = val6.x_coordinate
          start = end
          end += 2
          (_v95.value,) = _get_struct_h().unpack(str[start:end])
          _v96 = val6.y_coordinate
          start = end
          end += 2
          (_v96.value,) = _get_struct_h().unpack(str[start:end])
          _v97 = val6.z_coordinate
          start = end
          end += 2
          (_v97.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val6.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.z_coordinate_is_present = bool(val6.z_coordinate_is_present)
          _v94.array.append(val6)
        _v98 = _v89.height
        start = end
        end += 2
        (_v98.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v89.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v89.height_is_present = bool(_v89.height_is_present)
        _v99 = _v72.elliptical
        _v100 = _v99.shape_reference_point
        _v101 = _v100.x_coordinate
        start = end
        end += 2
        (_v101.value,) = _get_struct_h().unpack(str[start:end])
        _v102 = _v100.y_coordinate
        start = end
        end += 2
        (_v102.value,) = _get_struct_h().unpack(str[start:end])
        _v103 = _v100.z_coordinate
        start = end
        end += 2
        (_v103.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v100.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v100.z_coordinate_is_present = bool(_v100.z_coordinate_is_present)
        start = end
        end += 1
        (_v99.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.shape_reference_point_is_present = bool(_v99.shape_reference_point_is_present)
        _v104 = _v99.semi_major_axis_length
        start = end
        end += 2
        (_v104.value,) = _get_struct_H().unpack(str[start:end])
        _v105 = _v99.semi_minor_axis_length
        start = end
        end += 2
        (_v105.value,) = _get_struct_H().unpack(str[start:end])
        _v106 = _v99.orientation
        start = end
        end += 2
        (_v106.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v99.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.orientation_is_present = bool(_v99.orientation_is_present)
        _v107 = _v99.height
        start = end
        end += 2
        (_v107.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v99.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.height_is_present = bool(_v99.height_is_present)
        _v108 = _v72.radial
        _v109 = _v108.shape_reference_point
        _v110 = _v109.x_coordinate
        start = end
        end += 2
        (_v110.value,) = _get_struct_h().unpack(str[start:end])
        _v111 = _v109.y_coordinate
        start = end
        end += 2
        (_v111.value,) = _get_struct_h().unpack(str[start:end])
        _v112 = _v109.z_coordinate
        start = end
        end += 2
        (_v112.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v109.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v109.z_coordinate_is_present = bool(_v109.z_coordinate_is_present)
        start = end
        end += 1
        (_v108.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v108.shape_reference_point_is_present = bool(_v108.shape_reference_point_is_present)
        _v113 = _v108.range
        start = end
        end += 2
        (_v113.value,) = _get_struct_H().unpack(str[start:end])
        _v114 = _v108.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v114.value,) = _get_struct_H().unpack(str[start:end])
        _v115 = _v108.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v115.value,) = _get_struct_H().unpack(str[start:end])
        _v116 = _v108.vertical_opening_angle_start
        start = end
        end += 2
        (_v116.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v108.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v108.vertical_opening_angle_start_is_present = bool(_v108.vertical_opening_angle_start_is_present)
        _v117 = _v108.vertical_opening_angle_end
        start = end
        end += 2
        (_v117.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v108.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v108.vertical_opening_angle_end_is_present = bool(_v108.vertical_opening_angle_end_is_present)
        _v118 = _v72.radial_shapes
        _v119 = _v118.ref_point_id
        start = end
        end += 1
        (_v119.value,) = _get_struct_B().unpack(str[start:end])
        _v120 = _v118.x_coordinate
        start = end
        end += 2
        (_v120.value,) = _get_struct_h().unpack(str[start:end])
        _v121 = _v118.y_coordinate
        start = end
        end += 2
        (_v121.value,) = _get_struct_h().unpack(str[start:end])
        _v122 = _v118.z_coordinate
        start = end
        end += 2
        (_v122.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v118.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v118.z_coordinate_is_present = bool(_v118.z_coordinate_is_present)
        _v123 = _v118.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v123.array = []
        for i in range(0, length):
          val6 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v124 = val6.range
          start = end
          end += 2
          (_v124.value,) = _get_struct_H().unpack(str[start:end])
          _v125 = val6.horizontal_opening_angle_start
          start = end
          end += 2
          (_v125.value,) = _get_struct_H().unpack(str[start:end])
          _v126 = val6.horizontal_opening_angle_end
          start = end
          end += 2
          (_v126.value,) = _get_struct_H().unpack(str[start:end])
          _v127 = val6.vertical_opening_angle_start
          start = end
          end += 2
          (_v127.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val6.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.vertical_opening_angle_start_is_present = bool(val6.vertical_opening_angle_start_is_present)
          _v128 = val6.vertical_opening_angle_end
          start = end
          end += 2
          (_v128.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val6.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.vertical_opening_angle_end_is_present = bool(val6.vertical_opening_angle_end_is_present)
          _v123.array.append(val6)
        start = end
        end += 1
        (_v68.interference_management_zone_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        _v68.interference_management_zone_shape_is_present = bool(_v68.interference_management_zone_shape_is_present)
        _v129 = val1.management_info
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v129.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementInfoPerChannel()
          _v130 = val3.interference_management_channel
          _x = _v130
          start = end
          end += 7
          (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
          _v131 = val3.interference_management_zone_type
          start = end
          end += 1
          (_v131.value,) = _get_struct_B().unpack(str[start:end])
          _v132 = val3.interference_management_mitigation_type
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v132.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
            _v133 = val5.access_technology_class
            start = end
            end += 1
            (_v133.value,) = _get_struct_B().unpack(str[start:end])
            _x = val5
            start = end
            end += 10
            (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
            val5.low_duty_cycle_is_present = bool(val5.low_duty_cycle_is_present)
            val5.power_reduction_is_present = bool(val5.power_reduction_is_present)
            val5.dmc_toff_limit_is_present = bool(val5.dmc_toff_limit_is_present)
            val5.dmc_ton_limit_is_present = bool(val5.dmc_ton_limit_is_present)
            _v132.array.append(val5)
          start = end
          end += 1
          (val3.interference_management_mitigation_type_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.interference_management_mitigation_type_is_present = bool(val3.interference_management_mitigation_type_is_present)
          _v134 = val3.expiry_time
          start = end
          end += 8
          (_v134.value,) = _get_struct_Q().unpack(str[start:end])
          start = end
          end += 1
          (val3.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.expiry_time_is_present = bool(val3.expiry_time_is_present)
          _v129.array.append(val3)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v135 = val1.zone_definition
        _v136 = _v135.interference_management_zone_latitude
        _x = _v136.value
        buff.write(_get_struct_i().pack(_x))
        _v137 = _v135.interference_management_zone_longitude
        _x = _v137.value
        buff.write(_get_struct_i().pack(_x))
        _v138 = _v135.interference_management_zone_id
        _x = _v138.value
        buff.write(_get_struct_I().pack(_x))
        _x = _v135.interference_management_zone_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v139 = _v135.interference_management_zone_shape
        _x = _v139.choice
        buff.write(_get_struct_B().pack(_x))
        _v140 = _v139.rectangular
        _v141 = _v140.center_point
        _v142 = _v141.x_coordinate
        _x = _v142.value
        buff.write(_get_struct_h().pack(_x))
        _v143 = _v141.y_coordinate
        _x = _v143.value
        buff.write(_get_struct_h().pack(_x))
        _v144 = _v141.z_coordinate
        _x = _v144.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v141.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v140.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v145 = _v140.semi_length
        _x = _v145.value
        buff.write(_get_struct_H().pack(_x))
        _v146 = _v140.semi_breadth
        _x = _v146.value
        buff.write(_get_struct_H().pack(_x))
        _v147 = _v140.orientation
        _x = _v147.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v140.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v148 = _v140.height
        _x = _v148.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v140.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v149 = _v139.circular
        _v150 = _v149.shape_reference_point
        _v151 = _v150.x_coordinate
        _x = _v151.value
        buff.write(_get_struct_h().pack(_x))
        _v152 = _v150.y_coordinate
        _x = _v152.value
        buff.write(_get_struct_h().pack(_x))
        _v153 = _v150.z_coordinate
        _x = _v153.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v150.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v149.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v154 = _v149.radius
        _x = _v154.value
        buff.write(_get_struct_H().pack(_x))
        _v155 = _v149.height
        _x = _v155.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v149.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v156 = _v139.polygonal
        _v157 = _v156.shape_reference_point
        _v158 = _v157.x_coordinate
        _x = _v158.value
        buff.write(_get_struct_h().pack(_x))
        _v159 = _v157.y_coordinate
        _x = _v159.value
        buff.write(_get_struct_h().pack(_x))
        _v160 = _v157.z_coordinate
        _x = _v160.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v157.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v156.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v161 = _v156.polygon
        length = len(_v161.array)
        buff.write(_struct_I.pack(length))
        for val6 in _v161.array:
          _v162 = val6.x_coordinate
          _x = _v162.value
          buff.write(_get_struct_h().pack(_x))
          _v163 = val6.y_coordinate
          _x = _v163.value
          buff.write(_get_struct_h().pack(_x))
          _v164 = val6.z_coordinate
          _x = _v164.value
          buff.write(_get_struct_h().pack(_x))
          _x = val6.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v165 = _v156.height
        _x = _v165.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v156.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v166 = _v139.elliptical
        _v167 = _v166.shape_reference_point
        _v168 = _v167.x_coordinate
        _x = _v168.value
        buff.write(_get_struct_h().pack(_x))
        _v169 = _v167.y_coordinate
        _x = _v169.value
        buff.write(_get_struct_h().pack(_x))
        _v170 = _v167.z_coordinate
        _x = _v170.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v167.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v166.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v171 = _v166.semi_major_axis_length
        _x = _v171.value
        buff.write(_get_struct_H().pack(_x))
        _v172 = _v166.semi_minor_axis_length
        _x = _v172.value
        buff.write(_get_struct_H().pack(_x))
        _v173 = _v166.orientation
        _x = _v173.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v166.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v174 = _v166.height
        _x = _v174.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v166.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v175 = _v139.radial
        _v176 = _v175.shape_reference_point
        _v177 = _v176.x_coordinate
        _x = _v177.value
        buff.write(_get_struct_h().pack(_x))
        _v178 = _v176.y_coordinate
        _x = _v178.value
        buff.write(_get_struct_h().pack(_x))
        _v179 = _v176.z_coordinate
        _x = _v179.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v176.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v175.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v180 = _v175.range
        _x = _v180.value
        buff.write(_get_struct_H().pack(_x))
        _v181 = _v175.stationary_horizontal_opening_angle_start
        _x = _v181.value
        buff.write(_get_struct_H().pack(_x))
        _v182 = _v175.stationary_horizontal_opening_angle_end
        _x = _v182.value
        buff.write(_get_struct_H().pack(_x))
        _v183 = _v175.vertical_opening_angle_start
        _x = _v183.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v175.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v184 = _v175.vertical_opening_angle_end
        _x = _v184.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v175.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v185 = _v139.radial_shapes
        _v186 = _v185.ref_point_id
        _x = _v186.value
        buff.write(_get_struct_B().pack(_x))
        _v187 = _v185.x_coordinate
        _x = _v187.value
        buff.write(_get_struct_h().pack(_x))
        _v188 = _v185.y_coordinate
        _x = _v188.value
        buff.write(_get_struct_h().pack(_x))
        _v189 = _v185.z_coordinate
        _x = _v189.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v185.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v190 = _v185.radial_shapes_list
        length = len(_v190.array)
        buff.write(_struct_I.pack(length))
        for val6 in _v190.array:
          _v191 = val6.range
          _x = _v191.value
          buff.write(_get_struct_H().pack(_x))
          _v192 = val6.horizontal_opening_angle_start
          _x = _v192.value
          buff.write(_get_struct_H().pack(_x))
          _v193 = val6.horizontal_opening_angle_end
          _x = _v193.value
          buff.write(_get_struct_H().pack(_x))
          _v194 = val6.vertical_opening_angle_start
          _x = _v194.value
          buff.write(_get_struct_H().pack(_x))
          _x = val6.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v195 = val6.vertical_opening_angle_end
          _x = _v195.value
          buff.write(_get_struct_H().pack(_x))
          _x = val6.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = _v135.interference_management_zone_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v196 = val1.management_info
        length = len(_v196.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v196.array:
          _v197 = val3.interference_management_channel
          _x = _v197
          buff.write(_get_struct_IHB().pack(_x.centre_frequency, _x.channel_width, _x.exponent))
          _v198 = val3.interference_management_zone_type
          _x = _v198.value
          buff.write(_get_struct_B().pack(_x))
          _v199 = val3.interference_management_mitigation_type
          length = len(_v199.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v199.array:
            _v200 = val5.access_technology_class
            _x = _v200.value
            buff.write(_get_struct_B().pack(_x))
            _x = val5
            buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
          _x = val3.interference_management_mitigation_type_is_present
          buff.write(_get_struct_B().pack(_x))
          _v201 = val3.expiry_time
          _x = _v201.value
          buff.write(_get_struct_Q().pack(_x))
          _x = val3.expiry_time_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementZone()
        _v202 = val1.zone_definition
        _v203 = _v202.interference_management_zone_latitude
        start = end
        end += 4
        (_v203.value,) = _get_struct_i().unpack(str[start:end])
        _v204 = _v202.interference_management_zone_longitude
        start = end
        end += 4
        (_v204.value,) = _get_struct_i().unpack(str[start:end])
        _v205 = _v202.interference_management_zone_id
        start = end
        end += 4
        (_v205.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (_v202.interference_management_zone_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v202.interference_management_zone_id_is_present = bool(_v202.interference_management_zone_id_is_present)
        _v206 = _v202.interference_management_zone_shape
        start = end
        end += 1
        (_v206.choice,) = _get_struct_B().unpack(str[start:end])
        _v207 = _v206.rectangular
        _v208 = _v207.center_point
        _v209 = _v208.x_coordinate
        start = end
        end += 2
        (_v209.value,) = _get_struct_h().unpack(str[start:end])
        _v210 = _v208.y_coordinate
        start = end
        end += 2
        (_v210.value,) = _get_struct_h().unpack(str[start:end])
        _v211 = _v208.z_coordinate
        start = end
        end += 2
        (_v211.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v208.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v208.z_coordinate_is_present = bool(_v208.z_coordinate_is_present)
        start = end
        end += 1
        (_v207.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v207.center_point_is_present = bool(_v207.center_point_is_present)
        _v212 = _v207.semi_length
        start = end
        end += 2
        (_v212.value,) = _get_struct_H().unpack(str[start:end])
        _v213 = _v207.semi_breadth
        start = end
        end += 2
        (_v213.value,) = _get_struct_H().unpack(str[start:end])
        _v214 = _v207.orientation
        start = end
        end += 2
        (_v214.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v207.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v207.orientation_is_present = bool(_v207.orientation_is_present)
        _v215 = _v207.height
        start = end
        end += 2
        (_v215.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v207.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v207.height_is_present = bool(_v207.height_is_present)
        _v216 = _v206.circular
        _v217 = _v216.shape_reference_point
        _v218 = _v217.x_coordinate
        start = end
        end += 2
        (_v218.value,) = _get_struct_h().unpack(str[start:end])
        _v219 = _v217.y_coordinate
        start = end
        end += 2
        (_v219.value,) = _get_struct_h().unpack(str[start:end])
        _v220 = _v217.z_coordinate
        start = end
        end += 2
        (_v220.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v217.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v217.z_coordinate_is_present = bool(_v217.z_coordinate_is_present)
        start = end
        end += 1
        (_v216.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v216.shape_reference_point_is_present = bool(_v216.shape_reference_point_is_present)
        _v221 = _v216.radius
        start = end
        end += 2
        (_v221.value,) = _get_struct_H().unpack(str[start:end])
        _v222 = _v216.height
        start = end
        end += 2
        (_v222.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v216.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v216.height_is_present = bool(_v216.height_is_present)
        _v223 = _v206.polygonal
        _v224 = _v223.shape_reference_point
        _v225 = _v224.x_coordinate
        start = end
        end += 2
        (_v225.value,) = _get_struct_h().unpack(str[start:end])
        _v226 = _v224.y_coordinate
        start = end
        end += 2
        (_v226.value,) = _get_struct_h().unpack(str[start:end])
        _v227 = _v224.z_coordinate
        start = end
        end += 2
        (_v227.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v224.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v224.z_coordinate_is_present = bool(_v224.z_coordinate_is_present)
        start = end
        end += 1
        (_v223.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v223.shape_reference_point_is_present = bool(_v223.shape_reference_point_is_present)
        _v228 = _v223.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v228.array = []
        for i in range(0, length):
          val6 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v229 = val6.x_coordinate
          start = end
          end += 2
          (_v229.value,) = _get_struct_h().unpack(str[start:end])
          _v230 = val6.y_coordinate
          start = end
          end += 2
          (_v230.value,) = _get_struct_h().unpack(str[start:end])
          _v231 = val6.z_coordinate
          start = end
          end += 2
          (_v231.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val6.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.z_coordinate_is_present = bool(val6.z_coordinate_is_present)
          _v228.array.append(val6)
        _v232 = _v223.height
        start = end
        end += 2
        (_v232.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v223.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v223.height_is_present = bool(_v223.height_is_present)
        _v233 = _v206.elliptical
        _v234 = _v233.shape_reference_point
        _v235 = _v234.x_coordinate
        start = end
        end += 2
        (_v235.value,) = _get_struct_h().unpack(str[start:end])
        _v236 = _v234.y_coordinate
        start = end
        end += 2
        (_v236.value,) = _get_struct_h().unpack(str[start:end])
        _v237 = _v234.z_coordinate
        start = end
        end += 2
        (_v237.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v234.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v234.z_coordinate_is_present = bool(_v234.z_coordinate_is_present)
        start = end
        end += 1
        (_v233.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v233.shape_reference_point_is_present = bool(_v233.shape_reference_point_is_present)
        _v238 = _v233.semi_major_axis_length
        start = end
        end += 2
        (_v238.value,) = _get_struct_H().unpack(str[start:end])
        _v239 = _v233.semi_minor_axis_length
        start = end
        end += 2
        (_v239.value,) = _get_struct_H().unpack(str[start:end])
        _v240 = _v233.orientation
        start = end
        end += 2
        (_v240.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v233.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v233.orientation_is_present = bool(_v233.orientation_is_present)
        _v241 = _v233.height
        start = end
        end += 2
        (_v241.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v233.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v233.height_is_present = bool(_v233.height_is_present)
        _v242 = _v206.radial
        _v243 = _v242.shape_reference_point
        _v244 = _v243.x_coordinate
        start = end
        end += 2
        (_v244.value,) = _get_struct_h().unpack(str[start:end])
        _v245 = _v243.y_coordinate
        start = end
        end += 2
        (_v245.value,) = _get_struct_h().unpack(str[start:end])
        _v246 = _v243.z_coordinate
        start = end
        end += 2
        (_v246.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v243.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v243.z_coordinate_is_present = bool(_v243.z_coordinate_is_present)
        start = end
        end += 1
        (_v242.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v242.shape_reference_point_is_present = bool(_v242.shape_reference_point_is_present)
        _v247 = _v242.range
        start = end
        end += 2
        (_v247.value,) = _get_struct_H().unpack(str[start:end])
        _v248 = _v242.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v248.value,) = _get_struct_H().unpack(str[start:end])
        _v249 = _v242.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v249.value,) = _get_struct_H().unpack(str[start:end])
        _v250 = _v242.vertical_opening_angle_start
        start = end
        end += 2
        (_v250.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v242.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v242.vertical_opening_angle_start_is_present = bool(_v242.vertical_opening_angle_start_is_present)
        _v251 = _v242.vertical_opening_angle_end
        start = end
        end += 2
        (_v251.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v242.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v242.vertical_opening_angle_end_is_present = bool(_v242.vertical_opening_angle_end_is_present)
        _v252 = _v206.radial_shapes
        _v253 = _v252.ref_point_id
        start = end
        end += 1
        (_v253.value,) = _get_struct_B().unpack(str[start:end])
        _v254 = _v252.x_coordinate
        start = end
        end += 2
        (_v254.value,) = _get_struct_h().unpack(str[start:end])
        _v255 = _v252.y_coordinate
        start = end
        end += 2
        (_v255.value,) = _get_struct_h().unpack(str[start:end])
        _v256 = _v252.z_coordinate
        start = end
        end += 2
        (_v256.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v252.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v252.z_coordinate_is_present = bool(_v252.z_coordinate_is_present)
        _v257 = _v252.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v257.array = []
        for i in range(0, length):
          val6 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v258 = val6.range
          start = end
          end += 2
          (_v258.value,) = _get_struct_H().unpack(str[start:end])
          _v259 = val6.horizontal_opening_angle_start
          start = end
          end += 2
          (_v259.value,) = _get_struct_H().unpack(str[start:end])
          _v260 = val6.horizontal_opening_angle_end
          start = end
          end += 2
          (_v260.value,) = _get_struct_H().unpack(str[start:end])
          _v261 = val6.vertical_opening_angle_start
          start = end
          end += 2
          (_v261.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val6.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.vertical_opening_angle_start_is_present = bool(val6.vertical_opening_angle_start_is_present)
          _v262 = val6.vertical_opening_angle_end
          start = end
          end += 2
          (_v262.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val6.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val6.vertical_opening_angle_end_is_present = bool(val6.vertical_opening_angle_end_is_present)
          _v257.array.append(val6)
        start = end
        end += 1
        (_v202.interference_management_zone_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        _v202.interference_management_zone_shape_is_present = bool(_v202.interference_management_zone_shape_is_present)
        _v263 = val1.management_info
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v263.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.InterferenceManagementInfoPerChannel()
          _v264 = val3.interference_management_channel
          _x = _v264
          start = end
          end += 7
          (_x.centre_frequency, _x.channel_width, _x.exponent,) = _get_struct_IHB().unpack(str[start:end])
          _v265 = val3.interference_management_zone_type
          start = end
          end += 1
          (_v265.value,) = _get_struct_B().unpack(str[start:end])
          _v266 = val3.interference_management_mitigation_type
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v266.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
            _v267 = val5.access_technology_class
            start = end
            end += 1
            (_v267.value,) = _get_struct_B().unpack(str[start:end])
            _x = val5
            start = end
            end += 10
            (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
            val5.low_duty_cycle_is_present = bool(val5.low_duty_cycle_is_present)
            val5.power_reduction_is_present = bool(val5.power_reduction_is_present)
            val5.dmc_toff_limit_is_present = bool(val5.dmc_toff_limit_is_present)
            val5.dmc_ton_limit_is_present = bool(val5.dmc_ton_limit_is_present)
            _v266.array.append(val5)
          start = end
          end += 1
          (val3.interference_management_mitigation_type_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.interference_management_mitigation_type_is_present = bool(val3.interference_management_mitigation_type_is_present)
          _v268 = val3.expiry_time
          start = end
          end += 8
          (_v268.value,) = _get_struct_Q().unpack(str[start:end])
          start = end
          end += 1
          (val3.expiry_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.expiry_time_is_present = bool(val3.expiry_time_is_present)
          _v263.array.append(val3)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_H3BH3B = None
def _get_struct_H3BH3B():
    global _struct_H3BH3B
    if _struct_H3BH3B is None:
        _struct_H3BH3B = struct.Struct("<H3BH3B")
    return _struct_H3BH3B
_struct_IHB = None
def _get_struct_IHB():
    global _struct_IHB
    if _struct_IHB is None:
        _struct_IHB = struct.Struct("<IHB")
    return _struct_IHB
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
