# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/Iso3833VehicleType.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Iso3833VehicleType(genpy.Message):
  _md5sum = "34796d1e0b9cb649f9253ba3919a3c90"
  _type = "etsi_its_cpm_ts_msgs/Iso3833VehicleType"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Iso3833VehicleType ::= INTEGER {
#     passengerCar                 (0),
#     saloon                       (1),	
#     convertibleSaloon            (2),	
#     pullmanSaloon                (3),	
#     stationWagon                 (4),	
#     truckStationWagon            (5),	
#     coupe                        (6),
#     convertible                  (7),	
#     multipurposePassengerCar     (8),	
#     forwardControlPassengerCar   (9),	
#     specialPassengerCar	         (10),
#     bus	                         (11),
#     minibus                      (12),	
#     urbanBus                     (13),	
#     interurbanCoach              (14),	
#     longDistanceCoach            (15),	
#     articulatedBus               (16),	
#     trolleyBus                   (17),
#     specialBus                   (18),	
#     commercialVehicle            (19),	
#     specialCommercialVehicle     (20),
#     specialVehicle               (21),	
#     trailingTowingVehicle        (22),	
#     semiTrailerTowingVehicle     (23),	
#     trailer                      (24),	
#     busTrailer                   (25),
#     generalPurposeTrailer        (26),
#     caravan                      (27),	
#     specialTrailer               (28),	
#     semiTrailer	                 (29),	
#     busSemiTrailer               (30),	
#     generalPurposeSemiTrailer    (31),
#     specialSemiTrailer           (32),	
#     roadTrain                    (33),	
#     passengerRoadTrain           (34),	
#     articulatedRoadTrain         (35),	
#     doubleRoadTrain	             (36),
#     compositeRoadTrain           (37),	
#     specialRoadTrain             (38),	
#     moped                        (39),	
#     motorCycle                   (40)	
# 	} (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the vehicle type according to ISO 3833 [22].
# * A "term No" refers to the number of the corresponding term and its definition in ISO 3833.
# *
# * The value shall be set to:
# * - 0	- `passengerCar`              - term No 3.1.1
# * - 1	- `saloon`                    - term No 3.1.1.1 (sedan)
# * - 2	- `convertibleSaloon`         - term No 3.1.1.2
# * - 3	- `pullmanSaloon`             - term No 3.1.1.3
# * - 4	- `stationWagon`              - term No 3.1.1.4
# * - 5	- `truckStationWagon`         - term No 3.1.1.4.1
# * - 6	- `coupe`                     - term No 3.1.1.5 (coupe)
# * - 7	- `convertible`               - term No 3.1.1.6 (open tourer, roadstar, spider)
# * - 8	- `multipurposePassengerCar`  - term No 3.1.1.7
# * - 9	- `forwardControlPassengerCar`- term No 3.1.1.8
# * - 10	- `specialPassengerCar`       - term No 3.1.1.9
# * - 11	- `bus`                       - term No 3.1.2
# * - 12	- `minibus`                   - term No 3.1.2.1
# * - 13	- `urbanBus`                  - term No 3.1.2.2
# * - 14	- `interurbanCoach`           - term No 3.1.2.3
# * - 15	- `longDistanceCoach`         - term No 3.1.2.4
# * - 16	- `articulatedBus`            - term No 3.1.2.5
# * - 17	- `trolleyBus	`             - term No 3.1.2.6
# * - 18	- `specialBus`                - term No 3.1.2.7
# * - 19	- `commercialVehicle`         - term No 3.1.3
# * - 20	- `specialCommercialVehicle`  - term No 3.1.3.1
# * - 21	- `specialVehicle`            - term No 3.1.4
# * - 22	- `trailingTowingVehicle`     - term No 3.1.5 (draw-bar tractor)
# * - 23	- `semiTrailerTowingVehicle`  - term No 3.1.6 (fifth wheel tractor)
# * - 24	- `trailer`                   - term No 3.2.1
# * - 25	- `busTrailer`                - term No 3.2.1.1
# * - 26	- `generalPurposeTrailer`     - term No 3.2.1.2
# * - 27	- `caravan`                   - term No 3.2.1.3
# * - 28	- `specialTrailer`            - term No 3.2.1.4
# * - 29	- `semiTrailer`               - term No 3.2.2
# * - 30	- `busSemiTrailer`            - term No 3.2.2.1
# * - 31	- `generalPurposeSemiTrailer` - term No 3.2.2.2
# * - 32	- `specialSemiTrailer`        - term No 3.2.2.3
# * - 33	- `roadTrain`                 - term No 3.3.1
# * - 34	- `passengerRoadTrain`        - term No 3.3.2
# * - 35	- `articulatedRoadTrain`      - term No 3.3.3
# * - 36	- `doubleRoadTrain`           - term No 3.3.4
# * - 37	- `compositeRoadTrain`        - term No 3.3.5
# * - 38	- `specialRoadTrain`          - term No 3.3.6
# * - 39	- `moped`                     - term No 3.4
# * - 40	- `motorCycle`                - term No 3.5
# * - 41-255                           - reserved for future use
# * 
# * @category: Vehicle information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 PASSENGER_CAR = 0
uint8 SALOON = 1
uint8 CONVERTIBLE_SALOON = 2
uint8 PULLMAN_SALOON = 3
uint8 STATION_WAGON = 4
uint8 TRUCK_STATION_WAGON = 5
uint8 COUPE = 6
uint8 CONVERTIBLE = 7
uint8 MULTIPURPOSE_PASSENGER_CAR = 8
uint8 FORWARD_CONTROL_PASSENGER_CAR = 9
uint8 SPECIAL_PASSENGER_CAR = 10
uint8 BUS = 11
uint8 MINIBUS = 12
uint8 URBAN_BUS = 13
uint8 INTERURBAN_COACH = 14
uint8 LONG_DISTANCE_COACH = 15
uint8 ARTICULATED_BUS = 16
uint8 TROLLEY_BUS = 17
uint8 SPECIAL_BUS = 18
uint8 COMMERCIAL_VEHICLE = 19
uint8 SPECIAL_COMMERCIAL_VEHICLE = 20
uint8 SPECIAL_VEHICLE = 21
uint8 TRAILING_TOWING_VEHICLE = 22
uint8 SEMI_TRAILER_TOWING_VEHICLE = 23
uint8 TRAILER = 24
uint8 BUS_TRAILER = 25
uint8 GENERAL_PURPOSE_TRAILER = 26
uint8 CARAVAN = 27
uint8 SPECIAL_TRAILER = 28
uint8 SEMI_TRAILER = 29
uint8 BUS_SEMI_TRAILER = 30
uint8 GENERAL_PURPOSE_SEMI_TRAILER = 31
uint8 SPECIAL_SEMI_TRAILER = 32
uint8 ROAD_TRAIN = 33
uint8 PASSENGER_ROAD_TRAIN = 34
uint8 ARTICULATED_ROAD_TRAIN = 35
uint8 DOUBLE_ROAD_TRAIN = 36
uint8 COMPOSITE_ROAD_TRAIN = 37
uint8 SPECIAL_ROAD_TRAIN = 38
uint8 MOPED = 39
uint8 MOTOR_CYCLE = 40
"""
  # Pseudo-constants
  MIN = 0
  MAX = 255
  PASSENGER_CAR = 0
  SALOON = 1
  CONVERTIBLE_SALOON = 2
  PULLMAN_SALOON = 3
  STATION_WAGON = 4
  TRUCK_STATION_WAGON = 5
  COUPE = 6
  CONVERTIBLE = 7
  MULTIPURPOSE_PASSENGER_CAR = 8
  FORWARD_CONTROL_PASSENGER_CAR = 9
  SPECIAL_PASSENGER_CAR = 10
  BUS = 11
  MINIBUS = 12
  URBAN_BUS = 13
  INTERURBAN_COACH = 14
  LONG_DISTANCE_COACH = 15
  ARTICULATED_BUS = 16
  TROLLEY_BUS = 17
  SPECIAL_BUS = 18
  COMMERCIAL_VEHICLE = 19
  SPECIAL_COMMERCIAL_VEHICLE = 20
  SPECIAL_VEHICLE = 21
  TRAILING_TOWING_VEHICLE = 22
  SEMI_TRAILER_TOWING_VEHICLE = 23
  TRAILER = 24
  BUS_TRAILER = 25
  GENERAL_PURPOSE_TRAILER = 26
  CARAVAN = 27
  SPECIAL_TRAILER = 28
  SEMI_TRAILER = 29
  BUS_SEMI_TRAILER = 30
  GENERAL_PURPOSE_SEMI_TRAILER = 31
  SPECIAL_SEMI_TRAILER = 32
  ROAD_TRAIN = 33
  PASSENGER_ROAD_TRAIN = 34
  ARTICULATED_ROAD_TRAIN = 35
  DOUBLE_ROAD_TRAIN = 36
  COMPOSITE_ROAD_TRAIN = 37
  SPECIAL_ROAD_TRAIN = 38
  MOPED = 39
  MOTOR_CYCLE = 40

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Iso3833VehicleType, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
