# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class LowerTriangularPositiveSemidefiniteMatrices(genpy.Message):
  _md5sum = "d9a0d2c8a7b7767469bd5bc066224453"
  _type = "etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrices::= SEQUENCE SIZE (1..4) OF LowerTriangularPositiveSemidefiniteMatrix
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of a lower triangular positive semi-definite matrices.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

LowerTriangularPositiveSemidefiniteMatrix[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
#     componentsIncludedIntheMatrix   MatrixIncludedComponents,
#     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a lower triangular positive semi-definite matrix. 
# *
# * It shall include the following components: 
# *
# * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix. 
# * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
# *
# * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows. 
# *
# * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
# * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
# * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

MatrixIncludedComponents components_included_inthe_matrix

LowerTriangularPositiveSemidefiniteMatrixColumns matrix


================================================================================
MSG: etsi_its_cpm_ts_msgs/MatrixIncludedComponents
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MatrixIncludedComponents::= BIT STRING{
#     xPosition                    (0),
#     yPosition                    (1),
#     zPosition                    (2),
#     xVelocityOrVelocityMagnitude (3),
#     yVelocityOrVelocityDirection (4),
#     zSpeed                       (5),
#     xAccelOrAccelMagnitude       (6),
#     yAccelOrAccelDirection       (7),
#     zAcceleration                (8),
#     zAngle                       (9),  
#     yAngle                      (10), 
#     xAngle                      (11), 
#     zAngularVelocity              (12)
# } (SIZE(13,...))
# ------------------------------------------------------------------------------
# *
# * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
# *
# * The corresponding bit shall be set to 1 if the component is included:
# * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
# * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,   
# * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included, 
# * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,   
# * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,   
# * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
# * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,  
# * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,   
# * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
# * - 9 - `zAngle`                        - when the component zAngle is included,
# * - 10 - `yAngle`                       - when the component yAngle is included,   
# * - 11 - `xAngle`                       - when the component xAngle is included,   
# * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.   
# *
# * Otherwise, it shall be set to 0.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 13
int64 MAX_SIZE_BITS = 13
uint8 BIT_INDEX_X_POSITION = 0
uint8 BIT_INDEX_Y_POSITION = 1
uint8 BIT_INDEX_Z_POSITION = 2
uint8 BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
uint8 BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
uint8 BIT_INDEX_Z_SPEED = 5
uint8 BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
uint8 BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
uint8 BIT_INDEX_Z_ACCELERATION = 8
uint8 BIT_INDEX_Z_ANGLE = 9
uint8 BIT_INDEX_Y_ANGLE = 10
uint8 BIT_INDEX_X_ANGLE = 11
uint8 BIT_INDEX_Z_ANGULAR_VELOCITY = 12

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrixColumns
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrixColumns ::= SEQUENCE SIZE (1..13) OF CorrelationColumn
# ------------------------------------------------------------------------------
# * 
# * This DF represents the columns of a lower triangular positive semi-definite matrix, each column not including the main diagonal cell of the matrix.
# * Given a matrix "A" of size n x n, the number of @ref CorrelationColumn to be included in the lower triangular matrix is k=n-1.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

CorrelationColumn[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationColumn
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
# ------------------------------------------------------------------------------
# *
# * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
# * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
# * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
# * starting at 1 from the left.
# *
# * @category: Sensing Information
# * @revision: Created in V2.1.1
#

CorrelationCellValue[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationCellValue ::= INTEGER {
#     full-negative-correlation    (-100),     
#     no-correlation               (0),       
#     full-positive-correlation    (100),
#     unavailable (101)  
# } (-100..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
# *
# * The value shall be set to: 
# * - `-100` in case of full negative correlation,
# * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
# * - `0` in case of no correlation,
# * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
# * - `100` in case of full positive correlation,
# * - `101` in case the correlation information is unavailable. 
# *
# * @unit: the value is scaled by 100
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int8 value
int8 MIN = -100
int8 MAX = 101
int8 FULL_NEGATIVE_CORRELATION = -100
int8 NO_CORRELATION = 0
int8 FULL_POSITIVE_CORRELATION = 100
int8 UNAVAILABLE = 101
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 4

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LowerTriangularPositiveSemidefiniteMatrices, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.components_included_inthe_matrix
        _x = _v1.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v1.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.matrix
        length = len(_v2.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.array:
          length = len(val3.array)
          buff.write(_struct_I.pack(length))
          for val4 in val3.array:
            _x = val4.value
            buff.write(_get_struct_b().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
        _v3 = val1.components_included_inthe_matrix
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v3.value = str[start:end]
        start = end
        end += 1
        (_v3.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v4 = val1.matrix
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.array = []
          for i in range(0, length):
            val4 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
            start = end
            end += 1
            (val4.value,) = _get_struct_b().unpack(str[start:end])
            val3.array.append(val4)
          _v4.array.append(val3)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v5 = val1.components_included_inthe_matrix
        _x = _v5.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v5.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v6 = val1.matrix
        length = len(_v6.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.array:
          length = len(val3.array)
          buff.write(_struct_I.pack(length))
          for val4 in val3.array:
            _x = val4.value
            buff.write(_get_struct_b().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
        _v7 = val1.components_included_inthe_matrix
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v7.value = str[start:end]
        start = end
        end += 1
        (_v7.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v8 = val1.matrix
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val3.array = []
          for i in range(0, length):
            val4 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
            start = end
            end += 1
            (val4.value,) = _get_struct_b().unpack(str[start:end])
            val3.array.append(val4)
          _v8.array.append(val3)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
