# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/MessageRateRange.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class MessageRateRange(genpy.Message):
  _md5sum = "190daf6b0471509a5596aa793857b706"
  _type = "etsi_its_cpm_ts_msgs/MessageRateRange"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MessageRateRange::= SEQUENCE{
#    messageRateMin   MessageRateHz,
#    messageRateMax   MessageRateHz
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the planned or expected range of the message generation rate.
# *
# * It shall include the following components: 
# *
# * @field messageRateMin: the minimum planned or expected message rate.
# *
# * @field messageRateMax: the maximum planned or expected message rate.
# *
#

MessageRateHz message_rate_min

MessageRateHz message_rate_max


================================================================================
MSG: etsi_its_cpm_ts_msgs/MessageRateHz
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MessageRateHz::= SEQUENCE {
#     mantissa    INTEGER (1..100),
#     exponent    INTEGER (-5..2)
#     }
# ------------------------------------------------------------------------------
# *
# * This DE indicates a message rate.
# *
# * @field mantissa: indicates the mantissa.
# *
# * @field exponent: indicates the exponent.
# *
# * The specified message rate is: mantissa*(10^exponent) 
# *
# * @unit: Hz
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 mantissa
uint8 MANTISSA_MIN = 1
uint8 MANTISSA_MAX = 100

int8 exponent
uint8 EXPONENT_MIN = 0
uint8 EXPONENT_MAX = 2

"""
  __slots__ = ['message_rate_min','message_rate_max']
  _slot_types = ['etsi_its_cpm_ts_msgs/MessageRateHz','etsi_its_cpm_ts_msgs/MessageRateHz']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       message_rate_min,message_rate_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MessageRateRange, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.message_rate_min is None:
        self.message_rate_min = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      if self.message_rate_max is None:
        self.message_rate_max = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
    else:
      self.message_rate_min = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      self.message_rate_max = etsi_its_cpm_ts_msgs.msg.MessageRateHz()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BbBb().pack(_x.message_rate_min.mantissa, _x.message_rate_min.exponent, _x.message_rate_max.mantissa, _x.message_rate_max.exponent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.message_rate_min is None:
        self.message_rate_min = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      if self.message_rate_max is None:
        self.message_rate_max = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.message_rate_min.mantissa, _x.message_rate_min.exponent, _x.message_rate_max.mantissa, _x.message_rate_max.exponent,) = _get_struct_BbBb().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BbBb().pack(_x.message_rate_min.mantissa, _x.message_rate_min.exponent, _x.message_rate_max.mantissa, _x.message_rate_max.exponent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.message_rate_min is None:
        self.message_rate_min = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      if self.message_rate_max is None:
        self.message_rate_max = etsi_its_cpm_ts_msgs.msg.MessageRateHz()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.message_rate_min.mantissa, _x.message_rate_min.exponent, _x.message_rate_max.mantissa, _x.message_rate_max.exponent,) = _get_struct_BbBb().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BbBb = None
def _get_struct_BbBb():
    global _struct_BbBb
    if _struct_BbBb is None:
        _struct_BbBb = struct.Struct("<BbBb")
    return _struct_BbBb
