# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/MessageSegmentationInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class MessageSegmentationInfo(genpy.Message):
  _md5sum = "f760192cda7d5c97241759c1672fafe8"
  _type = "etsi_its_cpm_ts_msgs/MessageSegmentationInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MessageSegmentationInfo ::= SEQUENCE {
#     totalMsgNo  CardinalNumber3b,
#     thisMsgNo   OrdinalNumber3b
#     }
# ------------------------------------------------------------------------------
# *
# * This DF provides information about a message with respect to the segmentation process at the sender.
# *
# * It shall include the following components: 
# * 
# * @field totalMsgNo: indicates the total number of messages that has been used on the transmitter side to encode the information.
# *
# * @field thisMsgNo: indicates the position of the message within of the total set of messages.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

CardinalNumber3b total_msg_no

OrdinalNumber3b this_msg_no


================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber3b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CardinalNumber3b ::= INTEGER(1..8)
# ------------------------------------------------------------------------------
# *
# * The DE represents a cardinal number that counts the size of a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 8


================================================================================
MSG: etsi_its_cpm_ts_msgs/OrdinalNumber3b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OrdinalNumber3b ::= INTEGER(1..8) 
# ------------------------------------------------------------------------------
# *
# * The DE represents an ordinal number that indicates the position of an element in a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 8

"""
  __slots__ = ['total_msg_no','this_msg_no']
  _slot_types = ['etsi_its_cpm_ts_msgs/CardinalNumber3b','etsi_its_cpm_ts_msgs/OrdinalNumber3b']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       total_msg_no,this_msg_no

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MessageSegmentationInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.total_msg_no is None:
        self.total_msg_no = etsi_its_cpm_ts_msgs.msg.CardinalNumber3b()
      if self.this_msg_no is None:
        self.this_msg_no = etsi_its_cpm_ts_msgs.msg.OrdinalNumber3b()
    else:
      self.total_msg_no = etsi_its_cpm_ts_msgs.msg.CardinalNumber3b()
      self.this_msg_no = etsi_its_cpm_ts_msgs.msg.OrdinalNumber3b()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.total_msg_no.value, _x.this_msg_no.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.total_msg_no is None:
        self.total_msg_no = etsi_its_cpm_ts_msgs.msg.CardinalNumber3b()
      if self.this_msg_no is None:
        self.this_msg_no = etsi_its_cpm_ts_msgs.msg.OrdinalNumber3b()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.total_msg_no.value, _x.this_msg_no.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.total_msg_no.value, _x.this_msg_no.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.total_msg_no is None:
        self.total_msg_no = etsi_its_cpm_ts_msgs.msg.CardinalNumber3b()
      if self.this_msg_no is None:
        self.this_msg_no = etsi_its_cpm_ts_msgs.msg.OrdinalNumber3b()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.total_msg_no.value, _x.this_msg_no.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
