# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/MitigationForTechnologies.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class MitigationForTechnologies(genpy.Message):
  _md5sum = "da881b148069399058cf4fa91c5bfd20"
  _type = "etsi_its_cpm_ts_msgs/MitigationForTechnologies"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationForTechnologies ::= SEQUENCE (SIZE(1..8)) OF MitigationPerTechnologyClass 
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of @ref MitigationPerTechnologyClass.
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
#

MitigationPerTechnologyClass[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationPerTechnologyClass ::= SEQUENCE {
#    accessTechnologyClass    AccessTechnologyClass, 
#    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL, 
#    powerReduction           INTEGER (0 .. 30) OPTIONAL,
#    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,   
#    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,   
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
# *
# * It shall include the following components: 
# *
# * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
# *
# * @field lowDutyCycle: duty cycle limit.
# * @unit: 0,01 % steps
# *
# * @field powerReduction: the delta value of power to be reduced.
# * @unit: dB
# *
# * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
# * @unit: ms
# *
# * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
# * @unit: ms
# *
# * @note: All parameters are optional, as they may not apply to some of the technologies or
# * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7. 
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

AccessTechnologyClass access_technology_class

uint16 low_duty_cycle
bool low_duty_cycle_is_present
uint16 LOW_DUTY_CYCLE_MIN = 0
uint16 LOW_DUTY_CYCLE_MAX = 10000

uint8 power_reduction
bool power_reduction_is_present
uint8 POWER_REDUCTION_MIN = 0
uint8 POWER_REDUCTION_MAX = 30

uint16 dmc_toff_limit
bool dmc_toff_limit_is_present
uint16 DMC_TOFF_LIMIT_MIN = 0
uint16 DMC_TOFF_LIMIT_MAX = 1200

uint8 dmc_ton_limit
bool dmc_ton_limit_is_present
uint8 DMC_TON_LIMIT_MIN = 0
uint8 DMC_TON_LIMIT_MAX = 20


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccessTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccessTechnologyClass ::= ENUMERATED {
#    any         (0), 
#    itsg5Class  (1), 
#    ltev2xClass (2), 
#    nrv2xClass  (3),
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates an access technology.
# *
# * The value shall be set to:
# * - `0`: in case of any access technology class,
# * - `1`: in case of ITS-G5 access technology class,
# * - `2`: in case of LTE-V2X access technology class,
# * - `3`: in case of NR-V2X access technology class.
# * 
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 ANY = 0
uint8 ITSG5_CLASS = 1
uint8 LTEV2X_CLASS = 2
uint8 NRV2X_CLASS = 3

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MitigationForTechnologies, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.access_technology_class
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
        _v2 = val1.access_technology_class
        start = end
        end += 1
        (_v2.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
        val1.low_duty_cycle_is_present = bool(val1.low_duty_cycle_is_present)
        val1.power_reduction_is_present = bool(val1.power_reduction_is_present)
        val1.dmc_toff_limit_is_present = bool(val1.dmc_toff_limit_is_present)
        val1.dmc_ton_limit_is_present = bool(val1.dmc_ton_limit_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v3 = val1.access_technology_class
        _x = _v3.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_H3BH3B().pack(_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.MitigationPerTechnologyClass()
        _v4 = val1.access_technology_class
        start = end
        end += 1
        (_v4.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_H3BH3B().unpack(str[start:end])
        val1.low_duty_cycle_is_present = bool(val1.low_duty_cycle_is_present)
        val1.power_reduction_is_present = bool(val1.power_reduction_is_present)
        val1.dmc_toff_limit_is_present = bool(val1.dmc_toff_limit_is_present)
        val1.dmc_ton_limit_is_present = bool(val1.dmc_ton_limit_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H3BH3B = None
def _get_struct_H3BH3B():
    global _struct_H3BH3B
    if _struct_H3BH3B is None:
        _struct_H3BH3B = struct.Struct("<H3BH3B")
    return _struct_H3BH3B
