# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class MitigationPerTechnologyClass(genpy.Message):
  _md5sum = "82bf9203de0088f6b2f79d8064d73c5b"
  _type = "etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MitigationPerTechnologyClass ::= SEQUENCE {
#    accessTechnologyClass    AccessTechnologyClass, 
#    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL, 
#    powerReduction           INTEGER (0 .. 30) OPTIONAL,
#    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,   
#    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,   
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
# *
# * It shall include the following components: 
# *
# * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
# *
# * @field lowDutyCycle: duty cycle limit.
# * @unit: 0,01 % steps
# *
# * @field powerReduction: the delta value of power to be reduced.
# * @unit: dB
# *
# * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
# * @unit: ms
# *
# * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
# * @unit: ms
# *
# * @note: All parameters are optional, as they may not apply to some of the technologies or
# * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7. 
# *
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

AccessTechnologyClass access_technology_class

uint16 low_duty_cycle
bool low_duty_cycle_is_present
uint16 LOW_DUTY_CYCLE_MIN = 0
uint16 LOW_DUTY_CYCLE_MAX = 10000

uint8 power_reduction
bool power_reduction_is_present
uint8 POWER_REDUCTION_MIN = 0
uint8 POWER_REDUCTION_MAX = 30

uint16 dmc_toff_limit
bool dmc_toff_limit_is_present
uint16 DMC_TOFF_LIMIT_MIN = 0
uint16 DMC_TOFF_LIMIT_MAX = 1200

uint8 dmc_ton_limit
bool dmc_ton_limit_is_present
uint8 DMC_TON_LIMIT_MIN = 0
uint8 DMC_TON_LIMIT_MAX = 20


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccessTechnologyClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccessTechnologyClass ::= ENUMERATED {
#    any         (0), 
#    itsg5Class  (1), 
#    ltev2xClass (2), 
#    nrv2xClass  (3),
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates an access technology.
# *
# * The value shall be set to:
# * - `0`: in case of any access technology class,
# * - `1`: in case of ITS-G5 access technology class,
# * - `2`: in case of LTE-V2X access technology class,
# * - `3`: in case of NR-V2X access technology class.
# * 
# * @category: Communication information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 ANY = 0
uint8 ITSG5_CLASS = 1
uint8 LTEV2X_CLASS = 2
uint8 NRV2X_CLASS = 3

"""
  # Pseudo-constants
  LOW_DUTY_CYCLE_MIN = 0
  LOW_DUTY_CYCLE_MAX = 10000
  POWER_REDUCTION_MIN = 0
  POWER_REDUCTION_MAX = 30
  DMC_TOFF_LIMIT_MIN = 0
  DMC_TOFF_LIMIT_MAX = 1200
  DMC_TON_LIMIT_MIN = 0
  DMC_TON_LIMIT_MAX = 20

  __slots__ = ['access_technology_class','low_duty_cycle','low_duty_cycle_is_present','power_reduction','power_reduction_is_present','dmc_toff_limit','dmc_toff_limit_is_present','dmc_ton_limit','dmc_ton_limit_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/AccessTechnologyClass','uint16','bool','uint8','bool','uint16','bool','uint8','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       access_technology_class,low_duty_cycle,low_duty_cycle_is_present,power_reduction,power_reduction_is_present,dmc_toff_limit,dmc_toff_limit_is_present,dmc_ton_limit,dmc_ton_limit_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MitigationPerTechnologyClass, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.access_technology_class is None:
        self.access_technology_class = etsi_its_cpm_ts_msgs.msg.AccessTechnologyClass()
      if self.low_duty_cycle is None:
        self.low_duty_cycle = 0
      if self.low_duty_cycle_is_present is None:
        self.low_duty_cycle_is_present = False
      if self.power_reduction is None:
        self.power_reduction = 0
      if self.power_reduction_is_present is None:
        self.power_reduction_is_present = False
      if self.dmc_toff_limit is None:
        self.dmc_toff_limit = 0
      if self.dmc_toff_limit_is_present is None:
        self.dmc_toff_limit_is_present = False
      if self.dmc_ton_limit is None:
        self.dmc_ton_limit = 0
      if self.dmc_ton_limit_is_present is None:
        self.dmc_ton_limit_is_present = False
    else:
      self.access_technology_class = etsi_its_cpm_ts_msgs.msg.AccessTechnologyClass()
      self.low_duty_cycle = 0
      self.low_duty_cycle_is_present = False
      self.power_reduction = 0
      self.power_reduction_is_present = False
      self.dmc_toff_limit = 0
      self.dmc_toff_limit_is_present = False
      self.dmc_ton_limit = 0
      self.dmc_ton_limit_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BH3BH3B().pack(_x.access_technology_class.value, _x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.access_technology_class is None:
        self.access_technology_class = etsi_its_cpm_ts_msgs.msg.AccessTechnologyClass()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.access_technology_class.value, _x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_BH3BH3B().unpack(str[start:end])
      self.low_duty_cycle_is_present = bool(self.low_duty_cycle_is_present)
      self.power_reduction_is_present = bool(self.power_reduction_is_present)
      self.dmc_toff_limit_is_present = bool(self.dmc_toff_limit_is_present)
      self.dmc_ton_limit_is_present = bool(self.dmc_ton_limit_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BH3BH3B().pack(_x.access_technology_class.value, _x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.access_technology_class is None:
        self.access_technology_class = etsi_its_cpm_ts_msgs.msg.AccessTechnologyClass()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.access_technology_class.value, _x.low_duty_cycle, _x.low_duty_cycle_is_present, _x.power_reduction, _x.power_reduction_is_present, _x.dmc_toff_limit, _x.dmc_toff_limit_is_present, _x.dmc_ton_limit, _x.dmc_ton_limit_is_present,) = _get_struct_BH3BH3B().unpack(str[start:end])
      self.low_duty_cycle_is_present = bool(self.low_duty_cycle_is_present)
      self.power_reduction_is_present = bool(self.power_reduction_is_present)
      self.dmc_toff_limit_is_present = bool(self.dmc_toff_limit_is_present)
      self.dmc_ton_limit_is_present = bool(self.dmc_ton_limit_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BH3BH3B = None
def _get_struct_BH3BH3B():
    global _struct_BH3BH3B
    if _struct_BH3BH3B is None:
        _struct_BH3BH3B = struct.Struct("<BH3BH3B")
    return _struct_BH3BH3B
