# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/ObjectClassDescription.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class ObjectClassDescription(genpy.Message):
  _md5sum = "3e86d2f80a397b7a94b2c98e1a86a326"
  _type = "etsi_its_cpm_ts_msgs/ObjectClassDescription"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassDescription ::= SEQUENCE (SIZE(1..8)) OF ObjectClassWithConfidence
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of object classes.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClassWithConfidence[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassWithConfidence ::= SEQUENCE {
#     objectClass    ObjectClass,
#     confidence     ConfidenceLevel
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the classification of a detected object together with a confidence level.
# *
# * It shall include the following components: 
# *
# * @field objectClass: the class of the object.
# *
# * @field Confidence: the associated confidence level.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClass object_class

ConfidenceLevel confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClass ::= CHOICE {
#     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
#     vruSubClass          VruProfileAndSubprofile,
#     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
# ------------------------------------------------------------------------------
# * 
# * This DF indicates both the class and associated subclass that best describes an object.
# *
# * The following options are available:
# *
# * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
# *
# * @field vruSubClass: the object is a VRU and the specific subclass is specified.
# *
# * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
# *
# * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 choice

TrafficParticipantType vehicle_sub_class
uint8 CHOICE_VEHICLE_SUB_CLASS = 0

VruProfileAndSubprofile vru_sub_class
uint8 CHOICE_VRU_SUB_CLASS = 1

VruClusterInformation group_sub_class
uint8 CHOICE_GROUP_SUB_CLASS = 2

OtherSubClass other_sub_class
uint8 CHOICE_OTHER_SUB_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a traffic participant.
# * 
# * The value shall be set to:
# * - 0 `unknown`          - information about traffic participant is not provided,
# * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
# * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
# * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
# * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
# * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
# * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
# * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
# * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
# * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
# * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
# * - 11 `tram`            - vehicle which runs on tracks along public streets,
# * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
# * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
# * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
# * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                            on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
# * - 16-255               - are reserved for future usage.
# * 
# * @category: Communication information.
# * @revision: Created in V2.1.1 based on StationType
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/VruProfileAndSubprofile
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates the profile of a VRU including sub-profile information
# * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
# *
# * @field pedestrian: VRU Profile 1 - Pedestrian.
# *
# * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
# *
# * @field motorcyclist: VRU Profile 3  - Motorcyclist.
# *
# * @field animal: VRU Profile  4 -  Animal.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a pedestrian.
# * 
# * The value shall be set to:
# * - 0 `unavailable`             - to indicate that the information on is unavailable,
# * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
# * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
# * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
# * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
# *
# * The value shall be set to:
# * - 0 `unavailable`           - to indicate that the information  is unavailable,
# * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
# * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
# * - 3 `horse-and-rider`       - to indicate a horse and rider,
# * - 4 `rollerskater`          - to indicate a rolleskater and skater,
# * - 5 `e-scooter`             - to indicate an e-scooter and rider,
# * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
# * - 7 `pedelec`               - to indicate a pedelec and rider,
# * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
# * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a motorcyclist and corresponding vehicle.
# * 
# * The value shall be set to:
# * - 0 `unavailable `                  - to indicate that the information  is unavailable,
# * - 1 `moped`                         - to indicate a moped and rider,
# * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
# * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
# * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
# * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of an animal
# * 
# * The value shall be set to:
# * - 0 `unavailable`     - to indicate that the information  is unavailable,
# * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
# * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
# * - 3 `service-animal`  - to indicate an animal that supports a human being.
# * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterInformation ::= SEQUENCE { 
#    clusterId                  Identifier1B OPTIONAL,
#    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about a VRU cluster.
# *
# * It shall include the following components: 
# *
# * @field clusterId: optional identifier of a VRU cluster .
# *
# * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
# *
# * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
# *
# * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
# * if this component is absent it means that the information is unavailable. 
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

Identifier1B cluster_id
bool cluster_id_is_present

Shape cluster_bounding_box_shape
bool cluster_bounding_box_shape_is_present
int64 CLUSTER_BOUNDING_BOX_SHAPE_MIN = 0

CardinalNumber1B cluster_cardinality_size

VruClusterProfiles cluster_profiles
bool cluster_profiles_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CardinalNumber1B ::= INTEGER(0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents a cardinal number that counts the size of a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterProfiles
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterProfiles ::= BIT STRING {
#     pedestrian   (0),
#     bicyclist    (1),
#     motorcyclist (2),
#     animal       (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------
# * 
# * This DE Identifies all the VRU profile types within a cluster.
# * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
# * 
# * The corresponding bit shall be set to 1 under the following conditions:
# * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
# * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
# * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
# * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
# * 
# * Otherwise, the corresponding bit shall be set to 0.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_PEDESTRIAN = 0
uint8 BIT_INDEX_BICYCLIST = 1
uint8 BIT_INDEX_MOTORCYCLIST = 2
uint8 BIT_INDEX_ANIMAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/OtherSubClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OtherSubClass ::= INTEGER {
#     unknown         (0),
#     singleObject    (1),
#     multipleObjects (2),
#     bulkMaterial    (3)
# } (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the subclass of a detected object for @ref ObjectClass "otherSubclass".
# *
# * The value shall be set to:
# * - `0` - unknown          - if the subclass is unknown.
# * - `1` - singleObject     - if the object is a single object.
# * - `2` - multipleObjects  - if the object is a group of multiple objects.
# * - `3` - bulkMaterial     - if the object is a bulk material.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 SINGLE_OBJECT = 1
uint8 MULTIPLE_OBJECTS = 2
uint8 BULK_MATERIAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/ObjectClassWithConfidence[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ObjectClassDescription, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.object_class
        _x = _v1.choice
        buff.write(_get_struct_B().pack(_x))
        _v2 = _v1.vehicle_sub_class
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = _v1.vru_sub_class
        _x = _v3.choice
        buff.write(_get_struct_B().pack(_x))
        _v4 = _v3.pedestrian
        _x = _v4.value
        buff.write(_get_struct_B().pack(_x))
        _v5 = _v3.bicyclist_and_light_vru_vehicle
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _v6 = _v3.motorcyclist
        _x = _v6.value
        buff.write(_get_struct_B().pack(_x))
        _v7 = _v3.animal
        _x = _v7.value
        buff.write(_get_struct_B().pack(_x))
        _v8 = _v1.group_sub_class
        _v9 = _v8.cluster_id
        _x = _v9.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v8.cluster_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v10 = _v8.cluster_bounding_box_shape
        _x = _v10.choice
        buff.write(_get_struct_B().pack(_x))
        _v11 = _v10.rectangular
        _v12 = _v11.center_point
        _v13 = _v12.x_coordinate
        _x = _v13.value
        buff.write(_get_struct_h().pack(_x))
        _v14 = _v12.y_coordinate
        _x = _v14.value
        buff.write(_get_struct_h().pack(_x))
        _v15 = _v12.z_coordinate
        _x = _v15.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v12.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v11.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v16 = _v11.semi_length
        _x = _v16.value
        buff.write(_get_struct_H().pack(_x))
        _v17 = _v11.semi_breadth
        _x = _v17.value
        buff.write(_get_struct_H().pack(_x))
        _v18 = _v11.orientation
        _x = _v18.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v11.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v19 = _v11.height
        _x = _v19.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v11.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = _v10.circular
        _v21 = _v20.shape_reference_point
        _v22 = _v21.x_coordinate
        _x = _v22.value
        buff.write(_get_struct_h().pack(_x))
        _v23 = _v21.y_coordinate
        _x = _v23.value
        buff.write(_get_struct_h().pack(_x))
        _v24 = _v21.z_coordinate
        _x = _v24.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v21.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v20.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v20.radius
        _x = _v25.value
        buff.write(_get_struct_H().pack(_x))
        _v26 = _v20.height
        _x = _v26.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v20.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v27 = _v10.polygonal
        _v28 = _v27.shape_reference_point
        _v29 = _v28.x_coordinate
        _x = _v29.value
        buff.write(_get_struct_h().pack(_x))
        _v30 = _v28.y_coordinate
        _x = _v30.value
        buff.write(_get_struct_h().pack(_x))
        _v31 = _v28.z_coordinate
        _x = _v31.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v28.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v27.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v32 = _v27.polygon
        length = len(_v32.array)
        buff.write(_struct_I.pack(length))
        for val7 in _v32.array:
          _v33 = val7.x_coordinate
          _x = _v33.value
          buff.write(_get_struct_h().pack(_x))
          _v34 = val7.y_coordinate
          _x = _v34.value
          buff.write(_get_struct_h().pack(_x))
          _v35 = val7.z_coordinate
          _x = _v35.value
          buff.write(_get_struct_h().pack(_x))
          _x = val7.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v36 = _v27.height
        _x = _v36.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v27.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v37 = _v10.elliptical
        _v38 = _v37.shape_reference_point
        _v39 = _v38.x_coordinate
        _x = _v39.value
        buff.write(_get_struct_h().pack(_x))
        _v40 = _v38.y_coordinate
        _x = _v40.value
        buff.write(_get_struct_h().pack(_x))
        _v41 = _v38.z_coordinate
        _x = _v41.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v38.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v37.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v42 = _v37.semi_major_axis_length
        _x = _v42.value
        buff.write(_get_struct_H().pack(_x))
        _v43 = _v37.semi_minor_axis_length
        _x = _v43.value
        buff.write(_get_struct_H().pack(_x))
        _v44 = _v37.orientation
        _x = _v44.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v37.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v45 = _v37.height
        _x = _v45.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v37.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v46 = _v10.radial
        _v47 = _v46.shape_reference_point
        _v48 = _v47.x_coordinate
        _x = _v48.value
        buff.write(_get_struct_h().pack(_x))
        _v49 = _v47.y_coordinate
        _x = _v49.value
        buff.write(_get_struct_h().pack(_x))
        _v50 = _v47.z_coordinate
        _x = _v50.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v47.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v46.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v51 = _v46.range
        _x = _v51.value
        buff.write(_get_struct_H().pack(_x))
        _v52 = _v46.stationary_horizontal_opening_angle_start
        _x = _v52.value
        buff.write(_get_struct_H().pack(_x))
        _v53 = _v46.stationary_horizontal_opening_angle_end
        _x = _v53.value
        buff.write(_get_struct_H().pack(_x))
        _v54 = _v46.vertical_opening_angle_start
        _x = _v54.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v46.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v55 = _v46.vertical_opening_angle_end
        _x = _v55.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v46.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v56 = _v10.radial_shapes
        _v57 = _v56.ref_point_id
        _x = _v57.value
        buff.write(_get_struct_B().pack(_x))
        _v58 = _v56.x_coordinate
        _x = _v58.value
        buff.write(_get_struct_h().pack(_x))
        _v59 = _v56.y_coordinate
        _x = _v59.value
        buff.write(_get_struct_h().pack(_x))
        _v60 = _v56.z_coordinate
        _x = _v60.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v56.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v61 = _v56.radial_shapes_list
        length = len(_v61.array)
        buff.write(_struct_I.pack(length))
        for val7 in _v61.array:
          _v62 = val7.range
          _x = _v62.value
          buff.write(_get_struct_H().pack(_x))
          _v63 = val7.horizontal_opening_angle_start
          _x = _v63.value
          buff.write(_get_struct_H().pack(_x))
          _v64 = val7.horizontal_opening_angle_end
          _x = _v64.value
          buff.write(_get_struct_H().pack(_x))
          _v65 = val7.vertical_opening_angle_start
          _x = _v65.value
          buff.write(_get_struct_H().pack(_x))
          _x = val7.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v66 = val7.vertical_opening_angle_end
          _x = _v66.value
          buff.write(_get_struct_H().pack(_x))
          _x = val7.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = _v8.cluster_bounding_box_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v67 = _v8.cluster_cardinality_size
        _x = _v67.value
        buff.write(_get_struct_B().pack(_x))
        _v68 = _v8.cluster_profiles
        _x = _v68.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v68.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _x = _v8.cluster_profiles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v69 = _v1.other_sub_class
        _x = _v69.value
        buff.write(_get_struct_B().pack(_x))
        _v70 = val1.confidence
        _x = _v70.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
        _v71 = val1.object_class
        start = end
        end += 1
        (_v71.choice,) = _get_struct_B().unpack(str[start:end])
        _v72 = _v71.vehicle_sub_class
        start = end
        end += 1
        (_v72.value,) = _get_struct_B().unpack(str[start:end])
        _v73 = _v71.vru_sub_class
        start = end
        end += 1
        (_v73.choice,) = _get_struct_B().unpack(str[start:end])
        _v74 = _v73.pedestrian
        start = end
        end += 1
        (_v74.value,) = _get_struct_B().unpack(str[start:end])
        _v75 = _v73.bicyclist_and_light_vru_vehicle
        start = end
        end += 1
        (_v75.value,) = _get_struct_B().unpack(str[start:end])
        _v76 = _v73.motorcyclist
        start = end
        end += 1
        (_v76.value,) = _get_struct_B().unpack(str[start:end])
        _v77 = _v73.animal
        start = end
        end += 1
        (_v77.value,) = _get_struct_B().unpack(str[start:end])
        _v78 = _v71.group_sub_class
        _v79 = _v78.cluster_id
        start = end
        end += 1
        (_v79.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v78.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v78.cluster_id_is_present = bool(_v78.cluster_id_is_present)
        _v80 = _v78.cluster_bounding_box_shape
        start = end
        end += 1
        (_v80.choice,) = _get_struct_B().unpack(str[start:end])
        _v81 = _v80.rectangular
        _v82 = _v81.center_point
        _v83 = _v82.x_coordinate
        start = end
        end += 2
        (_v83.value,) = _get_struct_h().unpack(str[start:end])
        _v84 = _v82.y_coordinate
        start = end
        end += 2
        (_v84.value,) = _get_struct_h().unpack(str[start:end])
        _v85 = _v82.z_coordinate
        start = end
        end += 2
        (_v85.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v82.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v82.z_coordinate_is_present = bool(_v82.z_coordinate_is_present)
        start = end
        end += 1
        (_v81.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v81.center_point_is_present = bool(_v81.center_point_is_present)
        _v86 = _v81.semi_length
        start = end
        end += 2
        (_v86.value,) = _get_struct_H().unpack(str[start:end])
        _v87 = _v81.semi_breadth
        start = end
        end += 2
        (_v87.value,) = _get_struct_H().unpack(str[start:end])
        _v88 = _v81.orientation
        start = end
        end += 2
        (_v88.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v81.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v81.orientation_is_present = bool(_v81.orientation_is_present)
        _v89 = _v81.height
        start = end
        end += 2
        (_v89.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v81.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v81.height_is_present = bool(_v81.height_is_present)
        _v90 = _v80.circular
        _v91 = _v90.shape_reference_point
        _v92 = _v91.x_coordinate
        start = end
        end += 2
        (_v92.value,) = _get_struct_h().unpack(str[start:end])
        _v93 = _v91.y_coordinate
        start = end
        end += 2
        (_v93.value,) = _get_struct_h().unpack(str[start:end])
        _v94 = _v91.z_coordinate
        start = end
        end += 2
        (_v94.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v91.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v91.z_coordinate_is_present = bool(_v91.z_coordinate_is_present)
        start = end
        end += 1
        (_v90.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.shape_reference_point_is_present = bool(_v90.shape_reference_point_is_present)
        _v95 = _v90.radius
        start = end
        end += 2
        (_v95.value,) = _get_struct_H().unpack(str[start:end])
        _v96 = _v90.height
        start = end
        end += 2
        (_v96.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v90.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.height_is_present = bool(_v90.height_is_present)
        _v97 = _v80.polygonal
        _v98 = _v97.shape_reference_point
        _v99 = _v98.x_coordinate
        start = end
        end += 2
        (_v99.value,) = _get_struct_h().unpack(str[start:end])
        _v100 = _v98.y_coordinate
        start = end
        end += 2
        (_v100.value,) = _get_struct_h().unpack(str[start:end])
        _v101 = _v98.z_coordinate
        start = end
        end += 2
        (_v101.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v98.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v98.z_coordinate_is_present = bool(_v98.z_coordinate_is_present)
        start = end
        end += 1
        (_v97.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v97.shape_reference_point_is_present = bool(_v97.shape_reference_point_is_present)
        _v102 = _v97.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v102.array = []
        for i in range(0, length):
          val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v103 = val7.x_coordinate
          start = end
          end += 2
          (_v103.value,) = _get_struct_h().unpack(str[start:end])
          _v104 = val7.y_coordinate
          start = end
          end += 2
          (_v104.value,) = _get_struct_h().unpack(str[start:end])
          _v105 = val7.z_coordinate
          start = end
          end += 2
          (_v105.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
          _v102.array.append(val7)
        _v106 = _v97.height
        start = end
        end += 2
        (_v106.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v97.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v97.height_is_present = bool(_v97.height_is_present)
        _v107 = _v80.elliptical
        _v108 = _v107.shape_reference_point
        _v109 = _v108.x_coordinate
        start = end
        end += 2
        (_v109.value,) = _get_struct_h().unpack(str[start:end])
        _v110 = _v108.y_coordinate
        start = end
        end += 2
        (_v110.value,) = _get_struct_h().unpack(str[start:end])
        _v111 = _v108.z_coordinate
        start = end
        end += 2
        (_v111.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v108.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v108.z_coordinate_is_present = bool(_v108.z_coordinate_is_present)
        start = end
        end += 1
        (_v107.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v107.shape_reference_point_is_present = bool(_v107.shape_reference_point_is_present)
        _v112 = _v107.semi_major_axis_length
        start = end
        end += 2
        (_v112.value,) = _get_struct_H().unpack(str[start:end])
        _v113 = _v107.semi_minor_axis_length
        start = end
        end += 2
        (_v113.value,) = _get_struct_H().unpack(str[start:end])
        _v114 = _v107.orientation
        start = end
        end += 2
        (_v114.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v107.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v107.orientation_is_present = bool(_v107.orientation_is_present)
        _v115 = _v107.height
        start = end
        end += 2
        (_v115.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v107.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v107.height_is_present = bool(_v107.height_is_present)
        _v116 = _v80.radial
        _v117 = _v116.shape_reference_point
        _v118 = _v117.x_coordinate
        start = end
        end += 2
        (_v118.value,) = _get_struct_h().unpack(str[start:end])
        _v119 = _v117.y_coordinate
        start = end
        end += 2
        (_v119.value,) = _get_struct_h().unpack(str[start:end])
        _v120 = _v117.z_coordinate
        start = end
        end += 2
        (_v120.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v117.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v117.z_coordinate_is_present = bool(_v117.z_coordinate_is_present)
        start = end
        end += 1
        (_v116.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v116.shape_reference_point_is_present = bool(_v116.shape_reference_point_is_present)
        _v121 = _v116.range
        start = end
        end += 2
        (_v121.value,) = _get_struct_H().unpack(str[start:end])
        _v122 = _v116.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v122.value,) = _get_struct_H().unpack(str[start:end])
        _v123 = _v116.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v123.value,) = _get_struct_H().unpack(str[start:end])
        _v124 = _v116.vertical_opening_angle_start
        start = end
        end += 2
        (_v124.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v116.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v116.vertical_opening_angle_start_is_present = bool(_v116.vertical_opening_angle_start_is_present)
        _v125 = _v116.vertical_opening_angle_end
        start = end
        end += 2
        (_v125.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v116.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v116.vertical_opening_angle_end_is_present = bool(_v116.vertical_opening_angle_end_is_present)
        _v126 = _v80.radial_shapes
        _v127 = _v126.ref_point_id
        start = end
        end += 1
        (_v127.value,) = _get_struct_B().unpack(str[start:end])
        _v128 = _v126.x_coordinate
        start = end
        end += 2
        (_v128.value,) = _get_struct_h().unpack(str[start:end])
        _v129 = _v126.y_coordinate
        start = end
        end += 2
        (_v129.value,) = _get_struct_h().unpack(str[start:end])
        _v130 = _v126.z_coordinate
        start = end
        end += 2
        (_v130.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v126.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v126.z_coordinate_is_present = bool(_v126.z_coordinate_is_present)
        _v131 = _v126.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v131.array = []
        for i in range(0, length):
          val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v132 = val7.range
          start = end
          end += 2
          (_v132.value,) = _get_struct_H().unpack(str[start:end])
          _v133 = val7.horizontal_opening_angle_start
          start = end
          end += 2
          (_v133.value,) = _get_struct_H().unpack(str[start:end])
          _v134 = val7.horizontal_opening_angle_end
          start = end
          end += 2
          (_v134.value,) = _get_struct_H().unpack(str[start:end])
          _v135 = val7.vertical_opening_angle_start
          start = end
          end += 2
          (_v135.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
          _v136 = val7.vertical_opening_angle_end
          start = end
          end += 2
          (_v136.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
          _v131.array.append(val7)
        start = end
        end += 1
        (_v78.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        _v78.cluster_bounding_box_shape_is_present = bool(_v78.cluster_bounding_box_shape_is_present)
        _v137 = _v78.cluster_cardinality_size
        start = end
        end += 1
        (_v137.value,) = _get_struct_B().unpack(str[start:end])
        _v138 = _v78.cluster_profiles
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v138.value = str[start:end]
        start = end
        end += 1
        (_v138.bits_unused,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v78.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
        _v78.cluster_profiles_is_present = bool(_v78.cluster_profiles_is_present)
        _v139 = _v71.other_sub_class
        start = end
        end += 1
        (_v139.value,) = _get_struct_B().unpack(str[start:end])
        _v140 = val1.confidence
        start = end
        end += 1
        (_v140.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v141 = val1.object_class
        _x = _v141.choice
        buff.write(_get_struct_B().pack(_x))
        _v142 = _v141.vehicle_sub_class
        _x = _v142.value
        buff.write(_get_struct_B().pack(_x))
        _v143 = _v141.vru_sub_class
        _x = _v143.choice
        buff.write(_get_struct_B().pack(_x))
        _v144 = _v143.pedestrian
        _x = _v144.value
        buff.write(_get_struct_B().pack(_x))
        _v145 = _v143.bicyclist_and_light_vru_vehicle
        _x = _v145.value
        buff.write(_get_struct_B().pack(_x))
        _v146 = _v143.motorcyclist
        _x = _v146.value
        buff.write(_get_struct_B().pack(_x))
        _v147 = _v143.animal
        _x = _v147.value
        buff.write(_get_struct_B().pack(_x))
        _v148 = _v141.group_sub_class
        _v149 = _v148.cluster_id
        _x = _v149.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v148.cluster_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v150 = _v148.cluster_bounding_box_shape
        _x = _v150.choice
        buff.write(_get_struct_B().pack(_x))
        _v151 = _v150.rectangular
        _v152 = _v151.center_point
        _v153 = _v152.x_coordinate
        _x = _v153.value
        buff.write(_get_struct_h().pack(_x))
        _v154 = _v152.y_coordinate
        _x = _v154.value
        buff.write(_get_struct_h().pack(_x))
        _v155 = _v152.z_coordinate
        _x = _v155.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v152.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v151.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v156 = _v151.semi_length
        _x = _v156.value
        buff.write(_get_struct_H().pack(_x))
        _v157 = _v151.semi_breadth
        _x = _v157.value
        buff.write(_get_struct_H().pack(_x))
        _v158 = _v151.orientation
        _x = _v158.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v151.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v159 = _v151.height
        _x = _v159.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v151.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v160 = _v150.circular
        _v161 = _v160.shape_reference_point
        _v162 = _v161.x_coordinate
        _x = _v162.value
        buff.write(_get_struct_h().pack(_x))
        _v163 = _v161.y_coordinate
        _x = _v163.value
        buff.write(_get_struct_h().pack(_x))
        _v164 = _v161.z_coordinate
        _x = _v164.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v161.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v160.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v165 = _v160.radius
        _x = _v165.value
        buff.write(_get_struct_H().pack(_x))
        _v166 = _v160.height
        _x = _v166.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v160.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v167 = _v150.polygonal
        _v168 = _v167.shape_reference_point
        _v169 = _v168.x_coordinate
        _x = _v169.value
        buff.write(_get_struct_h().pack(_x))
        _v170 = _v168.y_coordinate
        _x = _v170.value
        buff.write(_get_struct_h().pack(_x))
        _v171 = _v168.z_coordinate
        _x = _v171.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v168.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v167.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v172 = _v167.polygon
        length = len(_v172.array)
        buff.write(_struct_I.pack(length))
        for val7 in _v172.array:
          _v173 = val7.x_coordinate
          _x = _v173.value
          buff.write(_get_struct_h().pack(_x))
          _v174 = val7.y_coordinate
          _x = _v174.value
          buff.write(_get_struct_h().pack(_x))
          _v175 = val7.z_coordinate
          _x = _v175.value
          buff.write(_get_struct_h().pack(_x))
          _x = val7.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v176 = _v167.height
        _x = _v176.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v167.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v177 = _v150.elliptical
        _v178 = _v177.shape_reference_point
        _v179 = _v178.x_coordinate
        _x = _v179.value
        buff.write(_get_struct_h().pack(_x))
        _v180 = _v178.y_coordinate
        _x = _v180.value
        buff.write(_get_struct_h().pack(_x))
        _v181 = _v178.z_coordinate
        _x = _v181.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v178.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v177.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v182 = _v177.semi_major_axis_length
        _x = _v182.value
        buff.write(_get_struct_H().pack(_x))
        _v183 = _v177.semi_minor_axis_length
        _x = _v183.value
        buff.write(_get_struct_H().pack(_x))
        _v184 = _v177.orientation
        _x = _v184.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v177.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v185 = _v177.height
        _x = _v185.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v177.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v186 = _v150.radial
        _v187 = _v186.shape_reference_point
        _v188 = _v187.x_coordinate
        _x = _v188.value
        buff.write(_get_struct_h().pack(_x))
        _v189 = _v187.y_coordinate
        _x = _v189.value
        buff.write(_get_struct_h().pack(_x))
        _v190 = _v187.z_coordinate
        _x = _v190.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v187.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v186.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v191 = _v186.range
        _x = _v191.value
        buff.write(_get_struct_H().pack(_x))
        _v192 = _v186.stationary_horizontal_opening_angle_start
        _x = _v192.value
        buff.write(_get_struct_H().pack(_x))
        _v193 = _v186.stationary_horizontal_opening_angle_end
        _x = _v193.value
        buff.write(_get_struct_H().pack(_x))
        _v194 = _v186.vertical_opening_angle_start
        _x = _v194.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v186.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v195 = _v186.vertical_opening_angle_end
        _x = _v195.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v186.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v196 = _v150.radial_shapes
        _v197 = _v196.ref_point_id
        _x = _v197.value
        buff.write(_get_struct_B().pack(_x))
        _v198 = _v196.x_coordinate
        _x = _v198.value
        buff.write(_get_struct_h().pack(_x))
        _v199 = _v196.y_coordinate
        _x = _v199.value
        buff.write(_get_struct_h().pack(_x))
        _v200 = _v196.z_coordinate
        _x = _v200.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v196.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v201 = _v196.radial_shapes_list
        length = len(_v201.array)
        buff.write(_struct_I.pack(length))
        for val7 in _v201.array:
          _v202 = val7.range
          _x = _v202.value
          buff.write(_get_struct_H().pack(_x))
          _v203 = val7.horizontal_opening_angle_start
          _x = _v203.value
          buff.write(_get_struct_H().pack(_x))
          _v204 = val7.horizontal_opening_angle_end
          _x = _v204.value
          buff.write(_get_struct_H().pack(_x))
          _v205 = val7.vertical_opening_angle_start
          _x = _v205.value
          buff.write(_get_struct_H().pack(_x))
          _x = val7.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v206 = val7.vertical_opening_angle_end
          _x = _v206.value
          buff.write(_get_struct_H().pack(_x))
          _x = val7.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = _v148.cluster_bounding_box_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v207 = _v148.cluster_cardinality_size
        _x = _v207.value
        buff.write(_get_struct_B().pack(_x))
        _v208 = _v148.cluster_profiles
        _x = _v208.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v208.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _x = _v148.cluster_profiles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v209 = _v141.other_sub_class
        _x = _v209.value
        buff.write(_get_struct_B().pack(_x))
        _v210 = val1.confidence
        _x = _v210.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
        _v211 = val1.object_class
        start = end
        end += 1
        (_v211.choice,) = _get_struct_B().unpack(str[start:end])
        _v212 = _v211.vehicle_sub_class
        start = end
        end += 1
        (_v212.value,) = _get_struct_B().unpack(str[start:end])
        _v213 = _v211.vru_sub_class
        start = end
        end += 1
        (_v213.choice,) = _get_struct_B().unpack(str[start:end])
        _v214 = _v213.pedestrian
        start = end
        end += 1
        (_v214.value,) = _get_struct_B().unpack(str[start:end])
        _v215 = _v213.bicyclist_and_light_vru_vehicle
        start = end
        end += 1
        (_v215.value,) = _get_struct_B().unpack(str[start:end])
        _v216 = _v213.motorcyclist
        start = end
        end += 1
        (_v216.value,) = _get_struct_B().unpack(str[start:end])
        _v217 = _v213.animal
        start = end
        end += 1
        (_v217.value,) = _get_struct_B().unpack(str[start:end])
        _v218 = _v211.group_sub_class
        _v219 = _v218.cluster_id
        start = end
        end += 1
        (_v219.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v218.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v218.cluster_id_is_present = bool(_v218.cluster_id_is_present)
        _v220 = _v218.cluster_bounding_box_shape
        start = end
        end += 1
        (_v220.choice,) = _get_struct_B().unpack(str[start:end])
        _v221 = _v220.rectangular
        _v222 = _v221.center_point
        _v223 = _v222.x_coordinate
        start = end
        end += 2
        (_v223.value,) = _get_struct_h().unpack(str[start:end])
        _v224 = _v222.y_coordinate
        start = end
        end += 2
        (_v224.value,) = _get_struct_h().unpack(str[start:end])
        _v225 = _v222.z_coordinate
        start = end
        end += 2
        (_v225.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v222.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v222.z_coordinate_is_present = bool(_v222.z_coordinate_is_present)
        start = end
        end += 1
        (_v221.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v221.center_point_is_present = bool(_v221.center_point_is_present)
        _v226 = _v221.semi_length
        start = end
        end += 2
        (_v226.value,) = _get_struct_H().unpack(str[start:end])
        _v227 = _v221.semi_breadth
        start = end
        end += 2
        (_v227.value,) = _get_struct_H().unpack(str[start:end])
        _v228 = _v221.orientation
        start = end
        end += 2
        (_v228.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v221.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v221.orientation_is_present = bool(_v221.orientation_is_present)
        _v229 = _v221.height
        start = end
        end += 2
        (_v229.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v221.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v221.height_is_present = bool(_v221.height_is_present)
        _v230 = _v220.circular
        _v231 = _v230.shape_reference_point
        _v232 = _v231.x_coordinate
        start = end
        end += 2
        (_v232.value,) = _get_struct_h().unpack(str[start:end])
        _v233 = _v231.y_coordinate
        start = end
        end += 2
        (_v233.value,) = _get_struct_h().unpack(str[start:end])
        _v234 = _v231.z_coordinate
        start = end
        end += 2
        (_v234.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v231.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v231.z_coordinate_is_present = bool(_v231.z_coordinate_is_present)
        start = end
        end += 1
        (_v230.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v230.shape_reference_point_is_present = bool(_v230.shape_reference_point_is_present)
        _v235 = _v230.radius
        start = end
        end += 2
        (_v235.value,) = _get_struct_H().unpack(str[start:end])
        _v236 = _v230.height
        start = end
        end += 2
        (_v236.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v230.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v230.height_is_present = bool(_v230.height_is_present)
        _v237 = _v220.polygonal
        _v238 = _v237.shape_reference_point
        _v239 = _v238.x_coordinate
        start = end
        end += 2
        (_v239.value,) = _get_struct_h().unpack(str[start:end])
        _v240 = _v238.y_coordinate
        start = end
        end += 2
        (_v240.value,) = _get_struct_h().unpack(str[start:end])
        _v241 = _v238.z_coordinate
        start = end
        end += 2
        (_v241.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v238.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v238.z_coordinate_is_present = bool(_v238.z_coordinate_is_present)
        start = end
        end += 1
        (_v237.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v237.shape_reference_point_is_present = bool(_v237.shape_reference_point_is_present)
        _v242 = _v237.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v242.array = []
        for i in range(0, length):
          val7 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v243 = val7.x_coordinate
          start = end
          end += 2
          (_v243.value,) = _get_struct_h().unpack(str[start:end])
          _v244 = val7.y_coordinate
          start = end
          end += 2
          (_v244.value,) = _get_struct_h().unpack(str[start:end])
          _v245 = val7.z_coordinate
          start = end
          end += 2
          (_v245.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val7.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.z_coordinate_is_present = bool(val7.z_coordinate_is_present)
          _v242.array.append(val7)
        _v246 = _v237.height
        start = end
        end += 2
        (_v246.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v237.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v237.height_is_present = bool(_v237.height_is_present)
        _v247 = _v220.elliptical
        _v248 = _v247.shape_reference_point
        _v249 = _v248.x_coordinate
        start = end
        end += 2
        (_v249.value,) = _get_struct_h().unpack(str[start:end])
        _v250 = _v248.y_coordinate
        start = end
        end += 2
        (_v250.value,) = _get_struct_h().unpack(str[start:end])
        _v251 = _v248.z_coordinate
        start = end
        end += 2
        (_v251.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v248.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v248.z_coordinate_is_present = bool(_v248.z_coordinate_is_present)
        start = end
        end += 1
        (_v247.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v247.shape_reference_point_is_present = bool(_v247.shape_reference_point_is_present)
        _v252 = _v247.semi_major_axis_length
        start = end
        end += 2
        (_v252.value,) = _get_struct_H().unpack(str[start:end])
        _v253 = _v247.semi_minor_axis_length
        start = end
        end += 2
        (_v253.value,) = _get_struct_H().unpack(str[start:end])
        _v254 = _v247.orientation
        start = end
        end += 2
        (_v254.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v247.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v247.orientation_is_present = bool(_v247.orientation_is_present)
        _v255 = _v247.height
        start = end
        end += 2
        (_v255.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v247.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v247.height_is_present = bool(_v247.height_is_present)
        _v256 = _v220.radial
        _v257 = _v256.shape_reference_point
        _v258 = _v257.x_coordinate
        start = end
        end += 2
        (_v258.value,) = _get_struct_h().unpack(str[start:end])
        _v259 = _v257.y_coordinate
        start = end
        end += 2
        (_v259.value,) = _get_struct_h().unpack(str[start:end])
        _v260 = _v257.z_coordinate
        start = end
        end += 2
        (_v260.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v257.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v257.z_coordinate_is_present = bool(_v257.z_coordinate_is_present)
        start = end
        end += 1
        (_v256.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v256.shape_reference_point_is_present = bool(_v256.shape_reference_point_is_present)
        _v261 = _v256.range
        start = end
        end += 2
        (_v261.value,) = _get_struct_H().unpack(str[start:end])
        _v262 = _v256.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v262.value,) = _get_struct_H().unpack(str[start:end])
        _v263 = _v256.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v263.value,) = _get_struct_H().unpack(str[start:end])
        _v264 = _v256.vertical_opening_angle_start
        start = end
        end += 2
        (_v264.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v256.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v256.vertical_opening_angle_start_is_present = bool(_v256.vertical_opening_angle_start_is_present)
        _v265 = _v256.vertical_opening_angle_end
        start = end
        end += 2
        (_v265.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v256.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v256.vertical_opening_angle_end_is_present = bool(_v256.vertical_opening_angle_end_is_present)
        _v266 = _v220.radial_shapes
        _v267 = _v266.ref_point_id
        start = end
        end += 1
        (_v267.value,) = _get_struct_B().unpack(str[start:end])
        _v268 = _v266.x_coordinate
        start = end
        end += 2
        (_v268.value,) = _get_struct_h().unpack(str[start:end])
        _v269 = _v266.y_coordinate
        start = end
        end += 2
        (_v269.value,) = _get_struct_h().unpack(str[start:end])
        _v270 = _v266.z_coordinate
        start = end
        end += 2
        (_v270.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v266.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v266.z_coordinate_is_present = bool(_v266.z_coordinate_is_present)
        _v271 = _v266.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v271.array = []
        for i in range(0, length):
          val7 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v272 = val7.range
          start = end
          end += 2
          (_v272.value,) = _get_struct_H().unpack(str[start:end])
          _v273 = val7.horizontal_opening_angle_start
          start = end
          end += 2
          (_v273.value,) = _get_struct_H().unpack(str[start:end])
          _v274 = val7.horizontal_opening_angle_end
          start = end
          end += 2
          (_v274.value,) = _get_struct_H().unpack(str[start:end])
          _v275 = val7.vertical_opening_angle_start
          start = end
          end += 2
          (_v275.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val7.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.vertical_opening_angle_start_is_present = bool(val7.vertical_opening_angle_start_is_present)
          _v276 = val7.vertical_opening_angle_end
          start = end
          end += 2
          (_v276.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val7.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val7.vertical_opening_angle_end_is_present = bool(val7.vertical_opening_angle_end_is_present)
          _v271.array.append(val7)
        start = end
        end += 1
        (_v218.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        _v218.cluster_bounding_box_shape_is_present = bool(_v218.cluster_bounding_box_shape_is_present)
        _v277 = _v218.cluster_cardinality_size
        start = end
        end += 1
        (_v277.value,) = _get_struct_B().unpack(str[start:end])
        _v278 = _v218.cluster_profiles
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v278.value = str[start:end]
        start = end
        end += 1
        (_v278.bits_unused,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v218.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
        _v218.cluster_profiles_is_present = bool(_v218.cluster_profiles_is_present)
        _v279 = _v211.other_sub_class
        start = end
        end += 1
        (_v279.value,) = _get_struct_B().unpack(str[start:end])
        _v280 = val1.confidence
        start = end
        end += 1
        (_v280.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
