# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/ProtectedCommunicationZone.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class ProtectedCommunicationZone(genpy.Message):
  _md5sum = "2069d09a9d6c397f224c9236b86c6da2"
  _type = "etsi_its_cpm_ts_msgs/ProtectedCommunicationZone"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedCommunicationZone ::= SEQUENCE {
#     protectedZoneType         ProtectedZoneType,
#     expiryTime                TimestampIts OPTIONAL,
#     protectedZoneLatitude     Latitude,
#     protectedZoneLongitude    Longitude,
#     protectedZoneRadius       ProtectedZoneRadius OPTIONAL,
#     protectedZoneId           ProtectedZoneId OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a zone of protection inside which the ITS communication should be restricted.
# *
# * It shall include the following components: 
# * 
# * @field protectedZoneType: type of the protected zone. 
# * 
# * @field expiryTime: optional time at which the validity of the protected communication zone will expire.
# * 
# * @field protectedZoneLatitude: latitude of the centre point of the protected communication zone.
# * 
# * @field protectedZoneLongitude: longitude of the centre point of the protected communication zone.
# * 
# * @field protectedZoneRadius: optional radius of the protected communication zone in metres.
# * 
# * @field protectedZoneId: the optional ID of the protected communication zone.
# * 
# * @note: A protected communication zone may be defined around a CEN DSRC road side equipment.
# * 
# * @category: Infrastructure information, Communication information
# * @revision: revised in V2.1.1 (changed protectedZoneID to protectedZoneId)
# 

ProtectedZoneType protected_zone_type

TimestampIts expiry_time
bool expiry_time_is_present

Latitude protected_zone_latitude

Longitude protected_zone_longitude

ProtectedZoneRadius protected_zone_radius
bool protected_zone_radius_is_present

ProtectedZoneId protected_zone_id
bool protected_zone_id_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/ProtectedZoneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedZoneType::= ENUMERATED {
#     permanentCenDsrcTolling (0), 
#     ..., 
#     temporaryCenDsrcTolling (1) 
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the type of a protected communication zone, so that an ITS-S is aware of the actions to do
# * while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
# * 
# * The protected zone type is defined in ETSI TS 102 792 [14].
# * 
# * 
# * @category: Communication information
# * @revision: V1.3.1
# 

uint8 value
uint8 PERMANENT_CEN_DSRC_TOLLING = 0
# .extended
uint8 TEMPORARY_CEN_DSRC_TOLLING = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/TimestampIts
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TimestampIts ::= INTEGER (0..4398046511103)
# ------------------------------------------------------------------------------
# *
# * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
# * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
# * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
# *  i.e. it is not altered by leap seconds, which occur in UTC.
# * 
# * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
# * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
# * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
# * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
# * further 5 leap seconds have been inserted in UTC.
# * 
# * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
# * which includes one leap second insertion since the ITS epoch.
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Description revised in in V2.1.1
# 

uint64 value
uint64 MIN = 0
uint64 MAX = 4398046511103


================================================================================
MSG: etsi_its_cpm_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cpm_ts_msgs/ProtectedZoneRadius
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedZoneRadius ::= INTEGER (1..255,...)
# ------------------------------------------------------------------------------
# *
# * This DE represents the radius of a protected communication zone. 
# * 
# * 
# * @unit: metre
# * @category: Infrastructure information, Communication information
# * @revision: V1.3.1
# 

int64 value
int64 MIN = 1
int64 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/ProtectedZoneId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ProtectedZoneId ::= INTEGER (0.. 134217727)
# ------------------------------------------------------------------------------
# *
# * This DE represents the indentifier of a protected communication zone.
# * 
# * 
# * @category: Infrastructure information, Communication information
# * @revision: Revision in V2.1.1 (changed name from ProtectedZoneID to ProtectedZoneId)
# 

uint32 value
uint32 MIN = 0
uint32 MAX = 134217727

"""
  __slots__ = ['protected_zone_type','expiry_time','expiry_time_is_present','protected_zone_latitude','protected_zone_longitude','protected_zone_radius','protected_zone_radius_is_present','protected_zone_id','protected_zone_id_is_present']
  _slot_types = ['etsi_its_cpm_ts_msgs/ProtectedZoneType','etsi_its_cpm_ts_msgs/TimestampIts','bool','etsi_its_cpm_ts_msgs/Latitude','etsi_its_cpm_ts_msgs/Longitude','etsi_its_cpm_ts_msgs/ProtectedZoneRadius','bool','etsi_its_cpm_ts_msgs/ProtectedZoneId','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       protected_zone_type,expiry_time,expiry_time_is_present,protected_zone_latitude,protected_zone_longitude,protected_zone_radius,protected_zone_radius_is_present,protected_zone_id,protected_zone_id_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ProtectedCommunicationZone, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.protected_zone_type is None:
        self.protected_zone_type = etsi_its_cpm_ts_msgs.msg.ProtectedZoneType()
      if self.expiry_time is None:
        self.expiry_time = etsi_its_cpm_ts_msgs.msg.TimestampIts()
      if self.expiry_time_is_present is None:
        self.expiry_time_is_present = False
      if self.protected_zone_latitude is None:
        self.protected_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.protected_zone_longitude is None:
        self.protected_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.protected_zone_radius is None:
        self.protected_zone_radius = etsi_its_cpm_ts_msgs.msg.ProtectedZoneRadius()
      if self.protected_zone_radius_is_present is None:
        self.protected_zone_radius_is_present = False
      if self.protected_zone_id is None:
        self.protected_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      if self.protected_zone_id_is_present is None:
        self.protected_zone_id_is_present = False
    else:
      self.protected_zone_type = etsi_its_cpm_ts_msgs.msg.ProtectedZoneType()
      self.expiry_time = etsi_its_cpm_ts_msgs.msg.TimestampIts()
      self.expiry_time_is_present = False
      self.protected_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      self.protected_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      self.protected_zone_radius = etsi_its_cpm_ts_msgs.msg.ProtectedZoneRadius()
      self.protected_zone_radius_is_present = False
      self.protected_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      self.protected_zone_id_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BQB2iqBIB().pack(_x.protected_zone_type.value, _x.expiry_time.value, _x.expiry_time_is_present, _x.protected_zone_latitude.value, _x.protected_zone_longitude.value, _x.protected_zone_radius.value, _x.protected_zone_radius_is_present, _x.protected_zone_id.value, _x.protected_zone_id_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.protected_zone_type is None:
        self.protected_zone_type = etsi_its_cpm_ts_msgs.msg.ProtectedZoneType()
      if self.expiry_time is None:
        self.expiry_time = etsi_its_cpm_ts_msgs.msg.TimestampIts()
      if self.protected_zone_latitude is None:
        self.protected_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.protected_zone_longitude is None:
        self.protected_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.protected_zone_radius is None:
        self.protected_zone_radius = etsi_its_cpm_ts_msgs.msg.ProtectedZoneRadius()
      if self.protected_zone_id is None:
        self.protected_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.protected_zone_type.value, _x.expiry_time.value, _x.expiry_time_is_present, _x.protected_zone_latitude.value, _x.protected_zone_longitude.value, _x.protected_zone_radius.value, _x.protected_zone_radius_is_present, _x.protected_zone_id.value, _x.protected_zone_id_is_present,) = _get_struct_BQB2iqBIB().unpack(str[start:end])
      self.expiry_time_is_present = bool(self.expiry_time_is_present)
      self.protected_zone_radius_is_present = bool(self.protected_zone_radius_is_present)
      self.protected_zone_id_is_present = bool(self.protected_zone_id_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BQB2iqBIB().pack(_x.protected_zone_type.value, _x.expiry_time.value, _x.expiry_time_is_present, _x.protected_zone_latitude.value, _x.protected_zone_longitude.value, _x.protected_zone_radius.value, _x.protected_zone_radius_is_present, _x.protected_zone_id.value, _x.protected_zone_id_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.protected_zone_type is None:
        self.protected_zone_type = etsi_its_cpm_ts_msgs.msg.ProtectedZoneType()
      if self.expiry_time is None:
        self.expiry_time = etsi_its_cpm_ts_msgs.msg.TimestampIts()
      if self.protected_zone_latitude is None:
        self.protected_zone_latitude = etsi_its_cpm_ts_msgs.msg.Latitude()
      if self.protected_zone_longitude is None:
        self.protected_zone_longitude = etsi_its_cpm_ts_msgs.msg.Longitude()
      if self.protected_zone_radius is None:
        self.protected_zone_radius = etsi_its_cpm_ts_msgs.msg.ProtectedZoneRadius()
      if self.protected_zone_id is None:
        self.protected_zone_id = etsi_its_cpm_ts_msgs.msg.ProtectedZoneId()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.protected_zone_type.value, _x.expiry_time.value, _x.expiry_time_is_present, _x.protected_zone_latitude.value, _x.protected_zone_longitude.value, _x.protected_zone_radius.value, _x.protected_zone_radius_is_present, _x.protected_zone_id.value, _x.protected_zone_id_is_present,) = _get_struct_BQB2iqBIB().unpack(str[start:end])
      self.expiry_time_is_present = bool(self.expiry_time_is_present)
      self.protected_zone_radius_is_present = bool(self.protected_zone_radius_is_present)
      self.protected_zone_id_is_present = bool(self.protected_zone_id_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BQB2iqBIB = None
def _get_struct_BQB2iqBIB():
    global _struct_BQB2iqBIB
    if _struct_BQB2iqBIB is None:
        _struct_BQB2iqBIB = struct.Struct("<BQB2iqBIB")
    return _struct_BQB2iqBIB
