# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/SensorInformationContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class SensorInformationContainer(genpy.Message):
  _md5sum = "1bee189c2b43eb0772cd7de127649ad9"
  _type = "etsi_its_cpm_ts_msgs/SensorInformationContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformationContainer ::= SEQUENCE SIZE(1..128, ...) OF SensorInformation
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Sensor Information Container as a list of information objects about the sensors or data fusion systems from which the station provides information about detected objects.
#

SensorInformation[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformation ::= SEQUENCE {
#     sensorId          		    Identifier1B,
#     sensorType        		    SensorType,
#     perceptionRegionShape		Shape OPTIONAL,
#     perceptionRegionConfidence  ConfidenceLevel OPTIONAL,
#     shadowingApplies            BOOLEAN,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the characteristics of a single sensor or data fusion system.
# *
# * It shall include the following components: 
# *
# * @field sensorId: identifier of the sensor or data fusion system used to relate the perceived object in the Perceived Object Container to the sensor that detected it.
# * this identifier shall uniquely identify the sensor inside the CPM, but may be changed from one CPM to the next.
# *
# * @field sensorType: the type of the sensor.
# *
# * @field perceptionRegionShape: the perception region of the sensor.
# *
# * @field perceptionRegionConfidence: the homogeneous perception region confidence that can be assumed for the entire perception region shape of this sensor. 
# *
# * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
# *
#

Identifier1B sensor_id

SensorType sensor_type

Shape perception_region_shape
bool perception_region_shape_is_present

ConfidenceLevel perception_region_confidence
bool perception_region_confidence_is_present

bool shadowing_applies


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorType ::= INTEGER {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (0..31)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor.
# * 
# * The value shall be set to:
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-31                  - are reserved for future usage.
# *
# * @category: Sensing Information
# * @revision: created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 UNDEFINED = 0
uint8 RADAR = 1
uint8 LIDAR = 2
uint8 MONOVIDEO = 3
uint8 STEREOVISION = 4
uint8 NIGHTVISION = 5
uint8 ULTRASONIC = 6
uint8 PMD = 7
uint8 INDUCTION_LOOP = 8
uint8 SPHERICAL_CAMERA = 9
uint8 UWB = 10
uint8 ACOUSTIC = 11
uint8 LOCAL_AGGREGATION = 12
uint8 ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 128

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/SensorInformation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorInformationContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.sensor_id
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.sensor_type
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.perception_region_shape
        _x = _v3.choice
        buff.write(_get_struct_B().pack(_x))
        _v4 = _v3.rectangular
        _v5 = _v4.center_point
        _v6 = _v5.x_coordinate
        _x = _v6.value
        buff.write(_get_struct_h().pack(_x))
        _v7 = _v5.y_coordinate
        _x = _v7.value
        buff.write(_get_struct_h().pack(_x))
        _v8 = _v5.z_coordinate
        _x = _v8.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v5.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v4.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v9 = _v4.semi_length
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v4.semi_breadth
        _x = _v10.value
        buff.write(_get_struct_H().pack(_x))
        _v11 = _v4.orientation
        _x = _v11.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v4.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v12 = _v4.height
        _x = _v12.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v4.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v13 = _v3.circular
        _v14 = _v13.shape_reference_point
        _v15 = _v14.x_coordinate
        _x = _v15.value
        buff.write(_get_struct_h().pack(_x))
        _v16 = _v14.y_coordinate
        _x = _v16.value
        buff.write(_get_struct_h().pack(_x))
        _v17 = _v14.z_coordinate
        _x = _v17.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v14.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v13.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v18 = _v13.radius
        _x = _v18.value
        buff.write(_get_struct_H().pack(_x))
        _v19 = _v13.height
        _x = _v19.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v13.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = _v3.polygonal
        _v21 = _v20.shape_reference_point
        _v22 = _v21.x_coordinate
        _x = _v22.value
        buff.write(_get_struct_h().pack(_x))
        _v23 = _v21.y_coordinate
        _x = _v23.value
        buff.write(_get_struct_h().pack(_x))
        _v24 = _v21.z_coordinate
        _x = _v24.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v21.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v20.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v20.polygon
        length = len(_v25.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v25.array:
          _v26 = val5.x_coordinate
          _x = _v26.value
          buff.write(_get_struct_h().pack(_x))
          _v27 = val5.y_coordinate
          _x = _v27.value
          buff.write(_get_struct_h().pack(_x))
          _v28 = val5.z_coordinate
          _x = _v28.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v29 = _v20.height
        _x = _v29.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v20.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v30 = _v3.elliptical
        _v31 = _v30.shape_reference_point
        _v32 = _v31.x_coordinate
        _x = _v32.value
        buff.write(_get_struct_h().pack(_x))
        _v33 = _v31.y_coordinate
        _x = _v33.value
        buff.write(_get_struct_h().pack(_x))
        _v34 = _v31.z_coordinate
        _x = _v34.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v31.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v30.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v35 = _v30.semi_major_axis_length
        _x = _v35.value
        buff.write(_get_struct_H().pack(_x))
        _v36 = _v30.semi_minor_axis_length
        _x = _v36.value
        buff.write(_get_struct_H().pack(_x))
        _v37 = _v30.orientation
        _x = _v37.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v30.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v38 = _v30.height
        _x = _v38.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v30.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v39 = _v3.radial
        _v40 = _v39.shape_reference_point
        _v41 = _v40.x_coordinate
        _x = _v41.value
        buff.write(_get_struct_h().pack(_x))
        _v42 = _v40.y_coordinate
        _x = _v42.value
        buff.write(_get_struct_h().pack(_x))
        _v43 = _v40.z_coordinate
        _x = _v43.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v40.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v39.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v44 = _v39.range
        _x = _v44.value
        buff.write(_get_struct_H().pack(_x))
        _v45 = _v39.stationary_horizontal_opening_angle_start
        _x = _v45.value
        buff.write(_get_struct_H().pack(_x))
        _v46 = _v39.stationary_horizontal_opening_angle_end
        _x = _v46.value
        buff.write(_get_struct_H().pack(_x))
        _v47 = _v39.vertical_opening_angle_start
        _x = _v47.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v39.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v48 = _v39.vertical_opening_angle_end
        _x = _v48.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v39.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v49 = _v3.radial_shapes
        _v50 = _v49.ref_point_id
        _x = _v50.value
        buff.write(_get_struct_B().pack(_x))
        _v51 = _v49.x_coordinate
        _x = _v51.value
        buff.write(_get_struct_h().pack(_x))
        _v52 = _v49.y_coordinate
        _x = _v52.value
        buff.write(_get_struct_h().pack(_x))
        _v53 = _v49.z_coordinate
        _x = _v53.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v49.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v54 = _v49.radial_shapes_list
        length = len(_v54.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v54.array:
          _v55 = val5.range
          _x = _v55.value
          buff.write(_get_struct_H().pack(_x))
          _v56 = val5.horizontal_opening_angle_start
          _x = _v56.value
          buff.write(_get_struct_H().pack(_x))
          _v57 = val5.horizontal_opening_angle_end
          _x = _v57.value
          buff.write(_get_struct_H().pack(_x))
          _v58 = val5.vertical_opening_angle_start
          _x = _v58.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v59 = val5.vertical_opening_angle_end
          _x = _v59.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.perception_region_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v60 = val1.perception_region_confidence
        _x = _v60.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
        _v61 = val1.sensor_id
        start = end
        end += 1
        (_v61.value,) = _get_struct_B().unpack(str[start:end])
        _v62 = val1.sensor_type
        start = end
        end += 1
        (_v62.value,) = _get_struct_B().unpack(str[start:end])
        _v63 = val1.perception_region_shape
        start = end
        end += 1
        (_v63.choice,) = _get_struct_B().unpack(str[start:end])
        _v64 = _v63.rectangular
        _v65 = _v64.center_point
        _v66 = _v65.x_coordinate
        start = end
        end += 2
        (_v66.value,) = _get_struct_h().unpack(str[start:end])
        _v67 = _v65.y_coordinate
        start = end
        end += 2
        (_v67.value,) = _get_struct_h().unpack(str[start:end])
        _v68 = _v65.z_coordinate
        start = end
        end += 2
        (_v68.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v65.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v65.z_coordinate_is_present = bool(_v65.z_coordinate_is_present)
        start = end
        end += 1
        (_v64.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v64.center_point_is_present = bool(_v64.center_point_is_present)
        _v69 = _v64.semi_length
        start = end
        end += 2
        (_v69.value,) = _get_struct_H().unpack(str[start:end])
        _v70 = _v64.semi_breadth
        start = end
        end += 2
        (_v70.value,) = _get_struct_H().unpack(str[start:end])
        _v71 = _v64.orientation
        start = end
        end += 2
        (_v71.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v64.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v64.orientation_is_present = bool(_v64.orientation_is_present)
        _v72 = _v64.height
        start = end
        end += 2
        (_v72.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v64.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v64.height_is_present = bool(_v64.height_is_present)
        _v73 = _v63.circular
        _v74 = _v73.shape_reference_point
        _v75 = _v74.x_coordinate
        start = end
        end += 2
        (_v75.value,) = _get_struct_h().unpack(str[start:end])
        _v76 = _v74.y_coordinate
        start = end
        end += 2
        (_v76.value,) = _get_struct_h().unpack(str[start:end])
        _v77 = _v74.z_coordinate
        start = end
        end += 2
        (_v77.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v74.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v74.z_coordinate_is_present = bool(_v74.z_coordinate_is_present)
        start = end
        end += 1
        (_v73.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v73.shape_reference_point_is_present = bool(_v73.shape_reference_point_is_present)
        _v78 = _v73.radius
        start = end
        end += 2
        (_v78.value,) = _get_struct_H().unpack(str[start:end])
        _v79 = _v73.height
        start = end
        end += 2
        (_v79.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v73.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v73.height_is_present = bool(_v73.height_is_present)
        _v80 = _v63.polygonal
        _v81 = _v80.shape_reference_point
        _v82 = _v81.x_coordinate
        start = end
        end += 2
        (_v82.value,) = _get_struct_h().unpack(str[start:end])
        _v83 = _v81.y_coordinate
        start = end
        end += 2
        (_v83.value,) = _get_struct_h().unpack(str[start:end])
        _v84 = _v81.z_coordinate
        start = end
        end += 2
        (_v84.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v81.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v81.z_coordinate_is_present = bool(_v81.z_coordinate_is_present)
        start = end
        end += 1
        (_v80.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v80.shape_reference_point_is_present = bool(_v80.shape_reference_point_is_present)
        _v85 = _v80.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v85.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v86 = val5.x_coordinate
          start = end
          end += 2
          (_v86.value,) = _get_struct_h().unpack(str[start:end])
          _v87 = val5.y_coordinate
          start = end
          end += 2
          (_v87.value,) = _get_struct_h().unpack(str[start:end])
          _v88 = val5.z_coordinate
          start = end
          end += 2
          (_v88.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v85.array.append(val5)
        _v89 = _v80.height
        start = end
        end += 2
        (_v89.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v80.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v80.height_is_present = bool(_v80.height_is_present)
        _v90 = _v63.elliptical
        _v91 = _v90.shape_reference_point
        _v92 = _v91.x_coordinate
        start = end
        end += 2
        (_v92.value,) = _get_struct_h().unpack(str[start:end])
        _v93 = _v91.y_coordinate
        start = end
        end += 2
        (_v93.value,) = _get_struct_h().unpack(str[start:end])
        _v94 = _v91.z_coordinate
        start = end
        end += 2
        (_v94.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v91.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v91.z_coordinate_is_present = bool(_v91.z_coordinate_is_present)
        start = end
        end += 1
        (_v90.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.shape_reference_point_is_present = bool(_v90.shape_reference_point_is_present)
        _v95 = _v90.semi_major_axis_length
        start = end
        end += 2
        (_v95.value,) = _get_struct_H().unpack(str[start:end])
        _v96 = _v90.semi_minor_axis_length
        start = end
        end += 2
        (_v96.value,) = _get_struct_H().unpack(str[start:end])
        _v97 = _v90.orientation
        start = end
        end += 2
        (_v97.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v90.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.orientation_is_present = bool(_v90.orientation_is_present)
        _v98 = _v90.height
        start = end
        end += 2
        (_v98.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v90.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v90.height_is_present = bool(_v90.height_is_present)
        _v99 = _v63.radial
        _v100 = _v99.shape_reference_point
        _v101 = _v100.x_coordinate
        start = end
        end += 2
        (_v101.value,) = _get_struct_h().unpack(str[start:end])
        _v102 = _v100.y_coordinate
        start = end
        end += 2
        (_v102.value,) = _get_struct_h().unpack(str[start:end])
        _v103 = _v100.z_coordinate
        start = end
        end += 2
        (_v103.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v100.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v100.z_coordinate_is_present = bool(_v100.z_coordinate_is_present)
        start = end
        end += 1
        (_v99.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.shape_reference_point_is_present = bool(_v99.shape_reference_point_is_present)
        _v104 = _v99.range
        start = end
        end += 2
        (_v104.value,) = _get_struct_H().unpack(str[start:end])
        _v105 = _v99.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v105.value,) = _get_struct_H().unpack(str[start:end])
        _v106 = _v99.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v106.value,) = _get_struct_H().unpack(str[start:end])
        _v107 = _v99.vertical_opening_angle_start
        start = end
        end += 2
        (_v107.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v99.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.vertical_opening_angle_start_is_present = bool(_v99.vertical_opening_angle_start_is_present)
        _v108 = _v99.vertical_opening_angle_end
        start = end
        end += 2
        (_v108.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v99.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v99.vertical_opening_angle_end_is_present = bool(_v99.vertical_opening_angle_end_is_present)
        _v109 = _v63.radial_shapes
        _v110 = _v109.ref_point_id
        start = end
        end += 1
        (_v110.value,) = _get_struct_B().unpack(str[start:end])
        _v111 = _v109.x_coordinate
        start = end
        end += 2
        (_v111.value,) = _get_struct_h().unpack(str[start:end])
        _v112 = _v109.y_coordinate
        start = end
        end += 2
        (_v112.value,) = _get_struct_h().unpack(str[start:end])
        _v113 = _v109.z_coordinate
        start = end
        end += 2
        (_v113.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v109.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v109.z_coordinate_is_present = bool(_v109.z_coordinate_is_present)
        _v114 = _v109.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v114.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v115 = val5.range
          start = end
          end += 2
          (_v115.value,) = _get_struct_H().unpack(str[start:end])
          _v116 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v116.value,) = _get_struct_H().unpack(str[start:end])
          _v117 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v117.value,) = _get_struct_H().unpack(str[start:end])
          _v118 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v118.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v119 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v119.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v114.array.append(val5)
        start = end
        end += 1
        (val1.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perception_region_shape_is_present = bool(val1.perception_region_shape_is_present)
        _v120 = val1.perception_region_confidence
        start = end
        end += 1
        (_v120.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
        val1.perception_region_confidence_is_present = bool(val1.perception_region_confidence_is_present)
        val1.shadowing_applies = bool(val1.shadowing_applies)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v121 = val1.sensor_id
        _x = _v121.value
        buff.write(_get_struct_B().pack(_x))
        _v122 = val1.sensor_type
        _x = _v122.value
        buff.write(_get_struct_B().pack(_x))
        _v123 = val1.perception_region_shape
        _x = _v123.choice
        buff.write(_get_struct_B().pack(_x))
        _v124 = _v123.rectangular
        _v125 = _v124.center_point
        _v126 = _v125.x_coordinate
        _x = _v126.value
        buff.write(_get_struct_h().pack(_x))
        _v127 = _v125.y_coordinate
        _x = _v127.value
        buff.write(_get_struct_h().pack(_x))
        _v128 = _v125.z_coordinate
        _x = _v128.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v125.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v124.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v129 = _v124.semi_length
        _x = _v129.value
        buff.write(_get_struct_H().pack(_x))
        _v130 = _v124.semi_breadth
        _x = _v130.value
        buff.write(_get_struct_H().pack(_x))
        _v131 = _v124.orientation
        _x = _v131.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v124.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v132 = _v124.height
        _x = _v132.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v124.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v133 = _v123.circular
        _v134 = _v133.shape_reference_point
        _v135 = _v134.x_coordinate
        _x = _v135.value
        buff.write(_get_struct_h().pack(_x))
        _v136 = _v134.y_coordinate
        _x = _v136.value
        buff.write(_get_struct_h().pack(_x))
        _v137 = _v134.z_coordinate
        _x = _v137.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v134.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v133.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v138 = _v133.radius
        _x = _v138.value
        buff.write(_get_struct_H().pack(_x))
        _v139 = _v133.height
        _x = _v139.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v133.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v140 = _v123.polygonal
        _v141 = _v140.shape_reference_point
        _v142 = _v141.x_coordinate
        _x = _v142.value
        buff.write(_get_struct_h().pack(_x))
        _v143 = _v141.y_coordinate
        _x = _v143.value
        buff.write(_get_struct_h().pack(_x))
        _v144 = _v141.z_coordinate
        _x = _v144.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v141.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v140.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v145 = _v140.polygon
        length = len(_v145.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v145.array:
          _v146 = val5.x_coordinate
          _x = _v146.value
          buff.write(_get_struct_h().pack(_x))
          _v147 = val5.y_coordinate
          _x = _v147.value
          buff.write(_get_struct_h().pack(_x))
          _v148 = val5.z_coordinate
          _x = _v148.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v149 = _v140.height
        _x = _v149.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v140.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v150 = _v123.elliptical
        _v151 = _v150.shape_reference_point
        _v152 = _v151.x_coordinate
        _x = _v152.value
        buff.write(_get_struct_h().pack(_x))
        _v153 = _v151.y_coordinate
        _x = _v153.value
        buff.write(_get_struct_h().pack(_x))
        _v154 = _v151.z_coordinate
        _x = _v154.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v151.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v150.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v155 = _v150.semi_major_axis_length
        _x = _v155.value
        buff.write(_get_struct_H().pack(_x))
        _v156 = _v150.semi_minor_axis_length
        _x = _v156.value
        buff.write(_get_struct_H().pack(_x))
        _v157 = _v150.orientation
        _x = _v157.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v150.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v158 = _v150.height
        _x = _v158.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v150.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v159 = _v123.radial
        _v160 = _v159.shape_reference_point
        _v161 = _v160.x_coordinate
        _x = _v161.value
        buff.write(_get_struct_h().pack(_x))
        _v162 = _v160.y_coordinate
        _x = _v162.value
        buff.write(_get_struct_h().pack(_x))
        _v163 = _v160.z_coordinate
        _x = _v163.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v160.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v159.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v164 = _v159.range
        _x = _v164.value
        buff.write(_get_struct_H().pack(_x))
        _v165 = _v159.stationary_horizontal_opening_angle_start
        _x = _v165.value
        buff.write(_get_struct_H().pack(_x))
        _v166 = _v159.stationary_horizontal_opening_angle_end
        _x = _v166.value
        buff.write(_get_struct_H().pack(_x))
        _v167 = _v159.vertical_opening_angle_start
        _x = _v167.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v159.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v168 = _v159.vertical_opening_angle_end
        _x = _v168.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v159.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v169 = _v123.radial_shapes
        _v170 = _v169.ref_point_id
        _x = _v170.value
        buff.write(_get_struct_B().pack(_x))
        _v171 = _v169.x_coordinate
        _x = _v171.value
        buff.write(_get_struct_h().pack(_x))
        _v172 = _v169.y_coordinate
        _x = _v172.value
        buff.write(_get_struct_h().pack(_x))
        _v173 = _v169.z_coordinate
        _x = _v173.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v169.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v174 = _v169.radial_shapes_list
        length = len(_v174.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v174.array:
          _v175 = val5.range
          _x = _v175.value
          buff.write(_get_struct_H().pack(_x))
          _v176 = val5.horizontal_opening_angle_start
          _x = _v176.value
          buff.write(_get_struct_H().pack(_x))
          _v177 = val5.horizontal_opening_angle_end
          _x = _v177.value
          buff.write(_get_struct_H().pack(_x))
          _v178 = val5.vertical_opening_angle_start
          _x = _v178.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v179 = val5.vertical_opening_angle_end
          _x = _v179.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.perception_region_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v180 = val1.perception_region_confidence
        _x = _v180.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
        _v181 = val1.sensor_id
        start = end
        end += 1
        (_v181.value,) = _get_struct_B().unpack(str[start:end])
        _v182 = val1.sensor_type
        start = end
        end += 1
        (_v182.value,) = _get_struct_B().unpack(str[start:end])
        _v183 = val1.perception_region_shape
        start = end
        end += 1
        (_v183.choice,) = _get_struct_B().unpack(str[start:end])
        _v184 = _v183.rectangular
        _v185 = _v184.center_point
        _v186 = _v185.x_coordinate
        start = end
        end += 2
        (_v186.value,) = _get_struct_h().unpack(str[start:end])
        _v187 = _v185.y_coordinate
        start = end
        end += 2
        (_v187.value,) = _get_struct_h().unpack(str[start:end])
        _v188 = _v185.z_coordinate
        start = end
        end += 2
        (_v188.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v185.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v185.z_coordinate_is_present = bool(_v185.z_coordinate_is_present)
        start = end
        end += 1
        (_v184.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v184.center_point_is_present = bool(_v184.center_point_is_present)
        _v189 = _v184.semi_length
        start = end
        end += 2
        (_v189.value,) = _get_struct_H().unpack(str[start:end])
        _v190 = _v184.semi_breadth
        start = end
        end += 2
        (_v190.value,) = _get_struct_H().unpack(str[start:end])
        _v191 = _v184.orientation
        start = end
        end += 2
        (_v191.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v184.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v184.orientation_is_present = bool(_v184.orientation_is_present)
        _v192 = _v184.height
        start = end
        end += 2
        (_v192.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v184.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v184.height_is_present = bool(_v184.height_is_present)
        _v193 = _v183.circular
        _v194 = _v193.shape_reference_point
        _v195 = _v194.x_coordinate
        start = end
        end += 2
        (_v195.value,) = _get_struct_h().unpack(str[start:end])
        _v196 = _v194.y_coordinate
        start = end
        end += 2
        (_v196.value,) = _get_struct_h().unpack(str[start:end])
        _v197 = _v194.z_coordinate
        start = end
        end += 2
        (_v197.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v194.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v194.z_coordinate_is_present = bool(_v194.z_coordinate_is_present)
        start = end
        end += 1
        (_v193.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v193.shape_reference_point_is_present = bool(_v193.shape_reference_point_is_present)
        _v198 = _v193.radius
        start = end
        end += 2
        (_v198.value,) = _get_struct_H().unpack(str[start:end])
        _v199 = _v193.height
        start = end
        end += 2
        (_v199.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v193.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v193.height_is_present = bool(_v193.height_is_present)
        _v200 = _v183.polygonal
        _v201 = _v200.shape_reference_point
        _v202 = _v201.x_coordinate
        start = end
        end += 2
        (_v202.value,) = _get_struct_h().unpack(str[start:end])
        _v203 = _v201.y_coordinate
        start = end
        end += 2
        (_v203.value,) = _get_struct_h().unpack(str[start:end])
        _v204 = _v201.z_coordinate
        start = end
        end += 2
        (_v204.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v201.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v201.z_coordinate_is_present = bool(_v201.z_coordinate_is_present)
        start = end
        end += 1
        (_v200.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v200.shape_reference_point_is_present = bool(_v200.shape_reference_point_is_present)
        _v205 = _v200.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v205.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v206 = val5.x_coordinate
          start = end
          end += 2
          (_v206.value,) = _get_struct_h().unpack(str[start:end])
          _v207 = val5.y_coordinate
          start = end
          end += 2
          (_v207.value,) = _get_struct_h().unpack(str[start:end])
          _v208 = val5.z_coordinate
          start = end
          end += 2
          (_v208.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v205.array.append(val5)
        _v209 = _v200.height
        start = end
        end += 2
        (_v209.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v200.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v200.height_is_present = bool(_v200.height_is_present)
        _v210 = _v183.elliptical
        _v211 = _v210.shape_reference_point
        _v212 = _v211.x_coordinate
        start = end
        end += 2
        (_v212.value,) = _get_struct_h().unpack(str[start:end])
        _v213 = _v211.y_coordinate
        start = end
        end += 2
        (_v213.value,) = _get_struct_h().unpack(str[start:end])
        _v214 = _v211.z_coordinate
        start = end
        end += 2
        (_v214.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v211.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v211.z_coordinate_is_present = bool(_v211.z_coordinate_is_present)
        start = end
        end += 1
        (_v210.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v210.shape_reference_point_is_present = bool(_v210.shape_reference_point_is_present)
        _v215 = _v210.semi_major_axis_length
        start = end
        end += 2
        (_v215.value,) = _get_struct_H().unpack(str[start:end])
        _v216 = _v210.semi_minor_axis_length
        start = end
        end += 2
        (_v216.value,) = _get_struct_H().unpack(str[start:end])
        _v217 = _v210.orientation
        start = end
        end += 2
        (_v217.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v210.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v210.orientation_is_present = bool(_v210.orientation_is_present)
        _v218 = _v210.height
        start = end
        end += 2
        (_v218.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v210.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v210.height_is_present = bool(_v210.height_is_present)
        _v219 = _v183.radial
        _v220 = _v219.shape_reference_point
        _v221 = _v220.x_coordinate
        start = end
        end += 2
        (_v221.value,) = _get_struct_h().unpack(str[start:end])
        _v222 = _v220.y_coordinate
        start = end
        end += 2
        (_v222.value,) = _get_struct_h().unpack(str[start:end])
        _v223 = _v220.z_coordinate
        start = end
        end += 2
        (_v223.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v220.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v220.z_coordinate_is_present = bool(_v220.z_coordinate_is_present)
        start = end
        end += 1
        (_v219.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v219.shape_reference_point_is_present = bool(_v219.shape_reference_point_is_present)
        _v224 = _v219.range
        start = end
        end += 2
        (_v224.value,) = _get_struct_H().unpack(str[start:end])
        _v225 = _v219.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v225.value,) = _get_struct_H().unpack(str[start:end])
        _v226 = _v219.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v226.value,) = _get_struct_H().unpack(str[start:end])
        _v227 = _v219.vertical_opening_angle_start
        start = end
        end += 2
        (_v227.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v219.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v219.vertical_opening_angle_start_is_present = bool(_v219.vertical_opening_angle_start_is_present)
        _v228 = _v219.vertical_opening_angle_end
        start = end
        end += 2
        (_v228.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v219.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v219.vertical_opening_angle_end_is_present = bool(_v219.vertical_opening_angle_end_is_present)
        _v229 = _v183.radial_shapes
        _v230 = _v229.ref_point_id
        start = end
        end += 1
        (_v230.value,) = _get_struct_B().unpack(str[start:end])
        _v231 = _v229.x_coordinate
        start = end
        end += 2
        (_v231.value,) = _get_struct_h().unpack(str[start:end])
        _v232 = _v229.y_coordinate
        start = end
        end += 2
        (_v232.value,) = _get_struct_h().unpack(str[start:end])
        _v233 = _v229.z_coordinate
        start = end
        end += 2
        (_v233.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v229.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v229.z_coordinate_is_present = bool(_v229.z_coordinate_is_present)
        _v234 = _v229.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v234.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v235 = val5.range
          start = end
          end += 2
          (_v235.value,) = _get_struct_H().unpack(str[start:end])
          _v236 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v236.value,) = _get_struct_H().unpack(str[start:end])
          _v237 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v237.value,) = _get_struct_H().unpack(str[start:end])
          _v238 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v238.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v239 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v239.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v234.array.append(val5)
        start = end
        end += 1
        (val1.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perception_region_shape_is_present = bool(val1.perception_region_shape_is_present)
        _v240 = val1.perception_region_confidence
        start = end
        end += 1
        (_v240.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
        val1.perception_region_confidence_is_present = bool(val1.perception_region_confidence_is_present)
        val1.shadowing_applies = bool(val1.shadowing_applies)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
