# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/SteeringWheelAngle.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class SteeringWheelAngle(genpy.Message):
  _md5sum = "fd82b3d62cd45f5329e953a0c3993c4d"
  _type = "etsi_its_cpm_ts_msgs/SteeringWheelAngle"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SteeringWheelAngle ::= SEQUENCE {
#     steeringWheelAngleValue         SteeringWheelAngleValue,
#     steeringWheelAngleConfidence    SteeringWheelAngleConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the steering wheel angle of the vehicle at certain point in time.
# *
# * It shall include the following components: 
# * 
# * @field steeringWheelAngleValue: steering wheel angle value.
# * 
# * @field steeringWheelAngleConfidence: confidence value of the steering wheel angle value.
# * 
# * @category: Vehicle information
# * @revision: Created in V2.1.1
# 

SteeringWheelAngleValue steering_wheel_angle_value

SteeringWheelAngleConfidence steering_wheel_angle_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/SteeringWheelAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SteeringWheelAngleValue ::= INTEGER { 
#     negativeOutOfRange (-511),
#     positiveOutOfRange (511),
#     unavailable        (512)
# } (-511..512)
# ------------------------------------------------------------------------------
# *
# * This DE represents the steering wheel angle of the vehicle at certain point in time.
# * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
# * 
# * The value shall be set to:
# * - `-511` if the steering wheel angle is equal to or greater than 511 x 1,5 degrees = 766,5 degrees to the right,
# * - `n` (`n > -511` and `n <= 0`) if  the steering wheel angle is equal to or less than n x 1,5 degrees, and greater than (n-1) x 1,5 degrees, 
#      turning clockwise (i.e. to the right),
# * - `n` (`n >= 1` and `n < 511`) if the steering wheel angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees, 
#      turning counter-clockwise (i.e. to the left),
# * - `511` if the steering wheel angle is greater than 510 x 1,5 degrees = 765 degrees to the left,
# * - `512` if information is not available.
# *
# * @unit: 1,5 degree
# * @revision: Description revised in V2.1.1 (meaning of value 511 has changed slightly).
# 

int16 value
int16 MIN = -511
int16 MAX = 512
int16 NEGATIVE_OUT_OF_RANGE = -511
int16 POSITIVE_OUT_OF_RANGE = 511
int16 UNAVAILABLE = 512

================================================================================
MSG: etsi_its_cpm_ts_msgs/SteeringWheelAngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SteeringWheelAngleConfidence ::= INTEGER {
#     outOfRange                      (126), 
#     unavailable                     (127)
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the steering wheel angle confidence value which represents the estimated absolute accuracy for a  steering wheel angle value with a confidence level of 95 %.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 1,5 degrees,
# * - `126` if the confidence value is out of range, i.e. greater than 187,5 degrees,
# * - `127` if the confidence value is not available.
# * 
# * @note: The fact that a steering wheel angle value is received with confidence value set to `unavailable(127)`
# * can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the steering wheel angle value may be valid and used by the application.
# * 
# * If a steering wheel angle value is received and its confidence value is set to `outOfRange(126)`,
# * it means that the steering wheel angle value is not valid and therefore cannot be trusted.
# * Such value is not useful for the application.
# * 
# * @unit: 1,5 degree
# * @category: Vehicle Information
# * @revision: Description revised in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  __slots__ = ['steering_wheel_angle_value','steering_wheel_angle_confidence']
  _slot_types = ['etsi_its_cpm_ts_msgs/SteeringWheelAngleValue','etsi_its_cpm_ts_msgs/SteeringWheelAngleConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       steering_wheel_angle_value,steering_wheel_angle_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SteeringWheelAngle, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.steering_wheel_angle_value is None:
        self.steering_wheel_angle_value = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleValue()
      if self.steering_wheel_angle_confidence is None:
        self.steering_wheel_angle_confidence = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleConfidence()
    else:
      self.steering_wheel_angle_value = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleValue()
      self.steering_wheel_angle_confidence = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.steering_wheel_angle_value.value, _x.steering_wheel_angle_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.steering_wheel_angle_value is None:
        self.steering_wheel_angle_value = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleValue()
      if self.steering_wheel_angle_confidence is None:
        self.steering_wheel_angle_confidence = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.steering_wheel_angle_value.value, _x.steering_wheel_angle_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.steering_wheel_angle_value.value, _x.steering_wheel_angle_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.steering_wheel_angle_value is None:
        self.steering_wheel_angle_value = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleValue()
      if self.steering_wheel_angle_confidence is None:
        self.steering_wheel_angle_confidence = etsi_its_cpm_ts_msgs.msg.SteeringWheelAngleConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.steering_wheel_angle_value.value, _x.steering_wheel_angle_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
