# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/Traces.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class Traces(genpy.Message):
  _md5sum = "e4d3acfa2b0a673e349a005c6ebe32ea"
  _type = "etsi_its_cpm_ts_msgs/Traces"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Traces ::= SEQUENCE SIZE(1..7) OF Path
# ------------------------------------------------------------------------------
# *
# * This DF represents one or more paths using @ref PathHistory.
# * 
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1. Is is now based on Path and not on PathHistory
# 

Path[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 7

================================================================================
MSG: etsi_its_cpm_ts_msgs/Path
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
# ------------------------------------------------------------------------------
# *
# * This DF represents a path with a set of path points.
# * It shall contain up to `40` @ref PathPoint. 
# * 
# * The first PathPoint presents an offset delta position with regards to an external reference position.
# * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
# *
# * @category: GeoReference information, Vehicle information
# * @revision: created in V2.1.1 based on PathHistory
# 

PathPoint[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 40

================================================================================
MSG: etsi_its_cpm_ts_msgs/PathPoint
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathPoint ::= SEQUENCE {
#     pathPosition     DeltaReferencePosition,
#     pathDeltaTime    PathDeltaTime OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF defines an offset waypoint position within a path.
# *
# * It shall include the following components: 
# *
# * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
# *
# * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
# *
# * @category GeoReference information
# * @revision: semantics updated in V2.1.1
# 

DeltaReferencePosition path_position

PathDeltaTime path_delta_time
bool path_delta_time_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------
# *
# * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
# *
# * It shall include the following components: 
# *
# * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
# *
# * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
# *
# * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
# *
# * @category: GeoReference information
# * @revision:  V1.3.1
# 

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset latitude with regards to a defined latitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
# * - `0` for no latitudinal offset,
# * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
# * - `131 072` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072

================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset longitude with regards to a defined longitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
# * - `0` for no longitudinal offset,
# * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
# * - `131 072` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072

================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------
# *
# * This DE represents an offset altitude with regards to a defined altitude value.
# * It may be used to describe a geographical point with regards to a specific reference geographical position.
# *
# * The value shall be set to:
# * - `-12 700` for values equal to or lower than -127 metres,
# * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
# * - `0` for no altitudinal offset,
# * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
# * - `12 799` for values equal to or greater than 127,99 metres,
# * - `12 800` when the information is unavailable.
# *
# * @unit: 0,01 metre
# * @category: GeoReference information
# * @revision: editorial update in V2.1.1
# 

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800

================================================================================
MSG: etsi_its_cpm_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------
# *
# * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
# *
# * @unit 0,01 second
# * @category: GeoReference information
# * @revision: V1.3.1
# 

int64 value
int64 MIN = 1
int64 MAX = 65535

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 7

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/Path[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Traces, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        length = len(val1.array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.array:
          _v1 = val2.path_position
          _v2 = _v1.delta_latitude
          _x = _v2.value
          buff.write(_get_struct_i().pack(_x))
          _v3 = _v1.delta_longitude
          _x = _v3.value
          buff.write(_get_struct_i().pack(_x))
          _v4 = _v1.delta_altitude
          _x = _v4.value
          buff.write(_get_struct_h().pack(_x))
          _v5 = val2.path_delta_time
          _x = _v5.value
          buff.write(_get_struct_q().pack(_x))
          _x = val2.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.Path()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.array = []
        for i in range(0, length):
          val2 = etsi_its_cpm_ts_msgs.msg.PathPoint()
          _v6 = val2.path_position
          _v7 = _v6.delta_latitude
          start = end
          end += 4
          (_v7.value,) = _get_struct_i().unpack(str[start:end])
          _v8 = _v6.delta_longitude
          start = end
          end += 4
          (_v8.value,) = _get_struct_i().unpack(str[start:end])
          _v9 = _v6.delta_altitude
          start = end
          end += 2
          (_v9.value,) = _get_struct_h().unpack(str[start:end])
          _v10 = val2.path_delta_time
          start = end
          end += 8
          (_v10.value,) = _get_struct_q().unpack(str[start:end])
          start = end
          end += 1
          (val2.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val2.path_delta_time_is_present = bool(val2.path_delta_time_is_present)
          val1.array.append(val2)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        length = len(val1.array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.array:
          _v11 = val2.path_position
          _v12 = _v11.delta_latitude
          _x = _v12.value
          buff.write(_get_struct_i().pack(_x))
          _v13 = _v11.delta_longitude
          _x = _v13.value
          buff.write(_get_struct_i().pack(_x))
          _v14 = _v11.delta_altitude
          _x = _v14.value
          buff.write(_get_struct_h().pack(_x))
          _v15 = val2.path_delta_time
          _x = _v15.value
          buff.write(_get_struct_q().pack(_x))
          _x = val2.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.Path()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.array = []
        for i in range(0, length):
          val2 = etsi_its_cpm_ts_msgs.msg.PathPoint()
          _v16 = val2.path_position
          _v17 = _v16.delta_latitude
          start = end
          end += 4
          (_v17.value,) = _get_struct_i().unpack(str[start:end])
          _v18 = _v16.delta_longitude
          start = end
          end += 4
          (_v18.value,) = _get_struct_i().unpack(str[start:end])
          _v19 = _v16.delta_altitude
          start = end
          end += 2
          (_v19.value,) = _get_struct_h().unpack(str[start:end])
          _v20 = val2.path_delta_time
          start = end
          end += 8
          (_v20.value,) = _get_struct_q().unpack(str[start:end])
          start = end
          end += 1
          (val2.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val2.path_delta_time_is_present = bool(val2.path_delta_time_is_present)
          val1.array.append(val2)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
_struct_q = None
def _get_struct_q():
    global _struct_q
    if _struct_q is None:
        _struct_q = struct.Struct("<q")
    return _struct_q
