# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/TrailerData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class TrailerData(genpy.Message):
  _md5sum = "8ebde3803528403afb68e13ab2e6ee15"
  _type = "etsi_its_cpm_ts_msgs/TrailerData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerData ::= SEQUENCE { 
#     refPointId          Identifier1B,
#     hitchPointOffset    StandardLength1B, 
#     frontOverhang       StandardLength1B OPTIONAL, 
#     rearOverhang        StandardLength1B OPTIONAL, 
#     trailerWidth        VehicleWidth OPTIONAL,
#     hitchAngle          CartesianAngle,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides detailed information about an attached trailer.
# *
# * It shall include the following components: 
# *
# * @field refPointId: identifier of the reference point of the trailer.
# *
# * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
# * vehicle Reference Point.
# *
# * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
# * is not overhanging to the front with respect to the trailer reference point.
# *
# * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID.
# *
# * @field trailerWidth: optional width of the trailer.
# *
# * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
# * direction of the ISO 8855 [21] coordinate system centered on the trailer) and the direction of
# * the segment having as end points the reference point of the trailer and the reference point of
# * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
# * xy, described in the local Cartesian coordinate system of the trailer. The
# * angle is measured with negative values considering the trailer orientation turning clockwise
# * starting from the segment direction. The angle value accuracy is provided with the
# * confidence level of 95 %.
# *
# * @category: Vehicle information
# * @revision: Created in V2.1.1
#

Identifier1B ref_point_id

StandardLength1B hitch_point_offset

StandardLength1B front_overhang
bool front_overhang_is_present

StandardLength1B rear_overhang
bool rear_overhang_is_present

VehicleWidth trailer_width
bool trailer_width_is_present

CartesianAngle hitch_angle


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength1B::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
#
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
# * - `61` indicates that the vehicle width is greater than 6,0 metres,
# * - `62` indicates that the information in unavailable.
# * 
# * @unit: 0,1 metre
# * @category: Vehicle information 
# * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62

================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  __slots__ = ['ref_point_id','hitch_point_offset','front_overhang','front_overhang_is_present','rear_overhang','rear_overhang_is_present','trailer_width','trailer_width_is_present','hitch_angle']
  _slot_types = ['etsi_its_cpm_ts_msgs/Identifier1B','etsi_its_cpm_ts_msgs/StandardLength1B','etsi_its_cpm_ts_msgs/StandardLength1B','bool','etsi_its_cpm_ts_msgs/StandardLength1B','bool','etsi_its_cpm_ts_msgs/VehicleWidth','bool','etsi_its_cpm_ts_msgs/CartesianAngle']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ref_point_id,hitch_point_offset,front_overhang,front_overhang_is_present,rear_overhang,rear_overhang_is_present,trailer_width,trailer_width_is_present,hitch_angle

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TrailerData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_cpm_ts_msgs.msg.Identifier1B()
      if self.hitch_point_offset is None:
        self.hitch_point_offset = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.front_overhang is None:
        self.front_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.front_overhang_is_present is None:
        self.front_overhang_is_present = False
      if self.rear_overhang is None:
        self.rear_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.rear_overhang_is_present is None:
        self.rear_overhang_is_present = False
      if self.trailer_width is None:
        self.trailer_width = etsi_its_cpm_ts_msgs.msg.VehicleWidth()
      if self.trailer_width_is_present is None:
        self.trailer_width_is_present = False
      if self.hitch_angle is None:
        self.hitch_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
    else:
      self.ref_point_id = etsi_its_cpm_ts_msgs.msg.Identifier1B()
      self.hitch_point_offset = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      self.front_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      self.front_overhang_is_present = False
      self.rear_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      self.rear_overhang_is_present = False
      self.trailer_width = etsi_its_cpm_ts_msgs.msg.VehicleWidth()
      self.trailer_width_is_present = False
      self.hitch_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_8BHB().pack(_x.ref_point_id.value, _x.hitch_point_offset.value, _x.front_overhang.value, _x.front_overhang_is_present, _x.rear_overhang.value, _x.rear_overhang_is_present, _x.trailer_width.value, _x.trailer_width_is_present, _x.hitch_angle.value.value, _x.hitch_angle.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_cpm_ts_msgs.msg.Identifier1B()
      if self.hitch_point_offset is None:
        self.hitch_point_offset = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.front_overhang is None:
        self.front_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.rear_overhang is None:
        self.rear_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.trailer_width is None:
        self.trailer_width = etsi_its_cpm_ts_msgs.msg.VehicleWidth()
      if self.hitch_angle is None:
        self.hitch_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.ref_point_id.value, _x.hitch_point_offset.value, _x.front_overhang.value, _x.front_overhang_is_present, _x.rear_overhang.value, _x.rear_overhang_is_present, _x.trailer_width.value, _x.trailer_width_is_present, _x.hitch_angle.value.value, _x.hitch_angle.confidence.value,) = _get_struct_8BHB().unpack(str[start:end])
      self.front_overhang_is_present = bool(self.front_overhang_is_present)
      self.rear_overhang_is_present = bool(self.rear_overhang_is_present)
      self.trailer_width_is_present = bool(self.trailer_width_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_8BHB().pack(_x.ref_point_id.value, _x.hitch_point_offset.value, _x.front_overhang.value, _x.front_overhang_is_present, _x.rear_overhang.value, _x.rear_overhang_is_present, _x.trailer_width.value, _x.trailer_width_is_present, _x.hitch_angle.value.value, _x.hitch_angle.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_cpm_ts_msgs.msg.Identifier1B()
      if self.hitch_point_offset is None:
        self.hitch_point_offset = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.front_overhang is None:
        self.front_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.rear_overhang is None:
        self.rear_overhang = etsi_its_cpm_ts_msgs.msg.StandardLength1B()
      if self.trailer_width is None:
        self.trailer_width = etsi_its_cpm_ts_msgs.msg.VehicleWidth()
      if self.hitch_angle is None:
        self.hitch_angle = etsi_its_cpm_ts_msgs.msg.CartesianAngle()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.ref_point_id.value, _x.hitch_point_offset.value, _x.front_overhang.value, _x.front_overhang_is_present, _x.rear_overhang.value, _x.rear_overhang_is_present, _x.trailer_width.value, _x.trailer_width_is_present, _x.hitch_angle.value.value, _x.hitch_angle.confidence.value,) = _get_struct_8BHB().unpack(str[start:end])
      self.front_overhang_is_present = bool(self.front_overhang_is_present)
      self.rear_overhang_is_present = bool(self.rear_overhang_is_present)
      self.trailer_width_is_present = bool(self.trailer_width_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_8BHB = None
def _get_struct_8BHB():
    global _struct_8BHB
    if _struct_8BHB is None:
        _struct_8BHB = struct.Struct("<8BHB")
    return _struct_8BHB
