# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/TrailerDataSet.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class TrailerDataSet(genpy.Message):
  _md5sum = "08a90d57e2516d08b88aa2e415457577"
  _type = "etsi_its_cpm_ts_msgs/TrailerDataSet"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerDataSet::= SEQUENCE SIZE(1..8,...) OF TrailerData (WITH COMPONENTS {... ,frontOverhang ABSENT, rearOverhang ABSENT, trailerWidth ABSENT}) 
# ------------------------------------------------------------------------------
# *
# * This DF  represents a list of trailer data.
# * 
#

TrailerData[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerData ::= SEQUENCE { 
#     refPointId          Identifier1B,
#     hitchPointOffset    StandardLength1B, 
#     frontOverhang       StandardLength1B OPTIONAL, 
#     rearOverhang        StandardLength1B OPTIONAL, 
#     trailerWidth        VehicleWidth OPTIONAL,
#     hitchAngle          CartesianAngle,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides detailed information about an attached trailer.
# *
# * It shall include the following components: 
# *
# * @field refPointId: identifier of the reference point of the trailer.
# *
# * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
# * vehicle Reference Point.
# *
# * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
# * is not overhanging to the front with respect to the trailer reference point.
# *
# * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID.
# *
# * @field trailerWidth: optional width of the trailer.
# *
# * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
# * direction of the ISO 8855 [21] coordinate system centered on the trailer) and the direction of
# * the segment having as end points the reference point of the trailer and the reference point of
# * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
# * xy, described in the local Cartesian coordinate system of the trailer. The
# * angle is measured with negative values considering the trailer orientation turning clockwise
# * starting from the segment direction. The angle value accuracy is provided with the
# * confidence level of 95 %.
# *
# * @category: Vehicle information
# * @revision: Created in V2.1.1
#

Identifier1B ref_point_id

StandardLength1B hitch_point_offset

StandardLength1B front_overhang
bool front_overhang_is_present

StandardLength1B rear_overhang
bool rear_overhang_is_present

VehicleWidth trailer_width
bool trailer_width_is_present

CartesianAngle hitch_angle


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength1B::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
#
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
# * - `61` indicates that the vehicle width is greater than 6,0 metres,
# * - `62` indicates that the information in unavailable.
# * 
# * @unit: 0,1 metre
# * @category: Vehicle information 
# * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62

================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/TrailerData[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TrailerDataSet, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.ref_point_id
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.hitch_point_offset
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.front_overhang
        _x = _v3.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.front_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v4 = val1.rear_overhang
        _x = _v4.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.rear_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.trailer_width
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trailer_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v6 = val1.hitch_angle
        _v7 = _v6.value
        _x = _v7.value
        buff.write(_get_struct_H().pack(_x))
        _v8 = _v6.confidence
        _x = _v8.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.TrailerData()
        _v9 = val1.ref_point_id
        start = end
        end += 1
        (_v9.value,) = _get_struct_B().unpack(str[start:end])
        _v10 = val1.hitch_point_offset
        start = end
        end += 1
        (_v10.value,) = _get_struct_B().unpack(str[start:end])
        _v11 = val1.front_overhang
        start = end
        end += 1
        (_v11.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.front_overhang_is_present = bool(val1.front_overhang_is_present)
        _v12 = val1.rear_overhang
        start = end
        end += 1
        (_v12.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.rear_overhang_is_present = bool(val1.rear_overhang_is_present)
        _v13 = val1.trailer_width
        start = end
        end += 1
        (_v13.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trailer_width_is_present = bool(val1.trailer_width_is_present)
        _v14 = val1.hitch_angle
        _v15 = _v14.value
        start = end
        end += 2
        (_v15.value,) = _get_struct_H().unpack(str[start:end])
        _v16 = _v14.confidence
        start = end
        end += 1
        (_v16.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v17 = val1.ref_point_id
        _x = _v17.value
        buff.write(_get_struct_B().pack(_x))
        _v18 = val1.hitch_point_offset
        _x = _v18.value
        buff.write(_get_struct_B().pack(_x))
        _v19 = val1.front_overhang
        _x = _v19.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.front_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = val1.rear_overhang
        _x = _v20.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.rear_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v21 = val1.trailer_width
        _x = _v21.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trailer_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v22 = val1.hitch_angle
        _v23 = _v22.value
        _x = _v23.value
        buff.write(_get_struct_H().pack(_x))
        _v24 = _v22.confidence
        _x = _v24.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.TrailerData()
        _v25 = val1.ref_point_id
        start = end
        end += 1
        (_v25.value,) = _get_struct_B().unpack(str[start:end])
        _v26 = val1.hitch_point_offset
        start = end
        end += 1
        (_v26.value,) = _get_struct_B().unpack(str[start:end])
        _v27 = val1.front_overhang
        start = end
        end += 1
        (_v27.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.front_overhang_is_present = bool(val1.front_overhang_is_present)
        _v28 = val1.rear_overhang
        start = end
        end += 1
        (_v28.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.rear_overhang_is_present = bool(val1.rear_overhang_is_present)
        _v29 = val1.trailer_width
        start = end
        end += 1
        (_v29.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trailer_width_is_present = bool(val1.trailer_width_is_present)
        _v30 = val1.hitch_angle
        _v31 = _v30.value
        start = end
        end += 2
        (_v31.value,) = _get_struct_H().unpack(str[start:end])
        _v32 = _v30.confidence
        start = end
        end += 1
        (_v32.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
