# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/VehicleBreakdownSubCauseCode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleBreakdownSubCauseCode(genpy.Message):
  _md5sum = "38c9b0db912e9fdf91a415063aa52ad3"
  _type = "etsi_its_cpm_ts_msgs/VehicleBreakdownSubCauseCode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleBreakdownSubCauseCode ::= INTEGER {
#     unavailable          (0), 
#     lackOfFuel           (1), 
#     lackOfBatteryPower   (2), 
#     engineProblem        (3), 
#     transmissionProblem  (4), 
#     engineCoolingProblem (5), 
#     brakingSystemProblem (6), 
#     steeringProblem      (7), 
#     tyrePuncture         (8), 
#     tyrePressureProblem  (9), 
#     vehicleOnFire        (10)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the value of the sub cause codes of the @ref CauseCode `vehicleBreakdown`. 
# * 
# * The value shall be set to:
# * - 0 `unavailable`         - in case further detailed information on cause of vehicle break down is unavailable,
# * - 1 `lackOfFuel`          - in case vehicle break down is due to lack of fuel,
# * - 2 `lackOfBatteryPower`  - in case vehicle break down is caused by lack of battery power,
# * - 3 `engineProblem`       - in case vehicle break down is caused by an engine problem,
# * - 4 `transmissionProblem` - in case vehicle break down is caused by transmission problem,
# * - 5 `engineCoolingProblem`- in case vehicle break down is caused by an engine cooling problem,
# * - 6 `brakingSystemProblem`- in case vehicle break down is caused by a braking system problem,
# * - 7 `steeringProblem`     - in case vehicle break down is caused by a steering problem,
# * - 8 `tyrePuncture`        - in case vehicle break down is caused by tyre puncture,
# * - 9 `tyrePressureProblem` - in case low tyre pressure in detected,
# * - 10 `vehicleOnFire`      - in case the vehicle is on fire.
# * - 11-255                  - are reserved for future usage.
# *
# * @category: Traffic information
#
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 LACK_OF_FUEL = 1
uint8 LACK_OF_BATTERY_POWER = 2
uint8 ENGINE_PROBLEM = 3
uint8 TRANSMISSION_PROBLEM = 4
uint8 ENGINE_COOLING_PROBLEM = 5
uint8 BRAKING_SYSTEM_PROBLEM = 6
uint8 STEERING_PROBLEM = 7
uint8 TYRE_PUNCTURE = 8
uint8 TYRE_PRESSURE_PROBLEM = 9
uint8 VEHICLE_ON_FIRE = 10
"""
  # Pseudo-constants
  MIN = 0
  MAX = 255
  UNAVAILABLE = 0
  LACK_OF_FUEL = 1
  LACK_OF_BATTERY_POWER = 2
  ENGINE_PROBLEM = 3
  TRANSMISSION_PROBLEM = 4
  ENGINE_COOLING_PROBLEM = 5
  BRAKING_SYSTEM_PROBLEM = 6
  STEERING_PROBLEM = 7
  TYRE_PUNCTURE = 8
  TYRE_PRESSURE_PROBLEM = 9
  VEHICLE_ON_FIRE = 10

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleBreakdownSubCauseCode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
