# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/VehicleLengthV2.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class VehicleLengthV2(genpy.Message):
  _md5sum = "7867b68e6ff274d58ac5b8f7202e6855"
  _type = "etsi_its_cpm_ts_msgs/VehicleLengthV2"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleLengthV2 ::= SEQUENCE {
#     vehicleLengthValue            VehicleLengthValue,
#     trailerPresenceInformation    TrailerPresenceInformation
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the length of vehicle and accuracy indication information.
# *
# * It shall include the following components: 
# * 
# * @field vehicleLengthValue: length of vehicle. 
# * 
# * @field trailerPresenceInformation: information about the trailer presence.
# * 
# * @category: Vehicle information
# * @revision: created in V2.1.1 based on @ref VehicleLength but using @ref TrailerPresenceInformation.
# 

VehicleLengthValue vehicle_length_value

TrailerPresenceInformation trailer_presence_information


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleLengthValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleLengthValue ::= INTEGER {
#     outOfRange(1022), 
#     unavailable(1023)
# }  (1..1023)
# ------------------------------------------------------------------------------
# *
# * This DE represents the length of a vehicle.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1022`) to indicate the applicable value n is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
# * - `1 022` to indicate that the vehicle length is greater than 102.1 metres,
# * - `1 023` to indicate that the information in unavailable.
# * 
# * 
# * @unit: 0,1 metre
# * @category: Vehicle information
# * @revision: Description updated in V2.1.1 (the meaning of 1 022 has changed slightly).
# 

uint16 value
uint16 MIN = 1
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerPresenceInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerPresenceInformation ::= ENUMERATED {
#     noTrailerPresent                (0), 
#     trailerPresentWithKnownLength   (1), 
#     trailerPresentWithUnknownLength (2), 
#     trailerPresenceIsUnknown        (3), 
#     unavailable                     (4)
# }
# ------------------------------------------------------------------------------
# *
# * This DE provides information about the presence of a trailer. 
# *
# * The value shall be set to:
# * - 0 `noTrailerPresent`                - to indicate that no trailer is present, i.e. either the vehicle is physically not enabled to tow a trailer or it has been detected that no trailer is present.
# * - 1 `trailerPresentWithKnownLength`   - to indicate that a trailer has been detected as present and the length is included in the vehicle length value.
# * - 2 `trailerPresentWithUnknownLength` - to indicate that a trailer has been detected as present and the length is not included in the vehicle length value.
# * - 3 `trailerPresenceIsUnknown`        - to indicate that information about the trailer presence is unknown, i.e. the vehicle is physically enabled to tow a trailer but the detection of trailer presence/absence is not possible.
# * - 4 `unavailable`                     - to indicate that the information about the presence of a trailer is not available, i.e. it is neither known whether the vehicle is able to tow a trailer 
# *                                         nor the detection of trailer presence/absence is possible.
# * 
# * @category: Vehicle information
# * @revision: Created in V2.1.1 based on VehicleLengthConfidenceIndication
#

uint8 value
uint8 NO_TRAILER_PRESENT = 0
uint8 TRAILER_PRESENT_WITH_KNOWN_LENGTH = 1
uint8 TRAILER_PRESENT_WITH_UNKNOWN_LENGTH = 2
uint8 TRAILER_PRESENCE_IS_UNKNOWN = 3
uint8 UNAVAILABLE = 4

"""
  __slots__ = ['vehicle_length_value','trailer_presence_information']
  _slot_types = ['etsi_its_cpm_ts_msgs/VehicleLengthValue','etsi_its_cpm_ts_msgs/TrailerPresenceInformation']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       vehicle_length_value,trailer_presence_information

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleLengthV2, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.vehicle_length_value is None:
        self.vehicle_length_value = etsi_its_cpm_ts_msgs.msg.VehicleLengthValue()
      if self.trailer_presence_information is None:
        self.trailer_presence_information = etsi_its_cpm_ts_msgs.msg.TrailerPresenceInformation()
    else:
      self.vehicle_length_value = etsi_its_cpm_ts_msgs.msg.VehicleLengthValue()
      self.trailer_presence_information = etsi_its_cpm_ts_msgs.msg.TrailerPresenceInformation()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_HB().pack(_x.vehicle_length_value.value, _x.trailer_presence_information.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicle_length_value is None:
        self.vehicle_length_value = etsi_its_cpm_ts_msgs.msg.VehicleLengthValue()
      if self.trailer_presence_information is None:
        self.trailer_presence_information = etsi_its_cpm_ts_msgs.msg.TrailerPresenceInformation()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.vehicle_length_value.value, _x.trailer_presence_information.value,) = _get_struct_HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_HB().pack(_x.vehicle_length_value.value, _x.trailer_presence_information.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicle_length_value is None:
        self.vehicle_length_value = etsi_its_cpm_ts_msgs.msg.VehicleLengthValue()
      if self.trailer_presence_information is None:
        self.trailer_presence_information = etsi_its_cpm_ts_msgs.msg.TrailerPresenceInformation()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.vehicle_length_value.value, _x.trailer_presence_information.value,) = _get_struct_HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_HB = None
def _get_struct_HB():
    global _struct_HB
    if _struct_HB is None:
        _struct_HB = struct.Struct("<HB")
    return _struct_HB
