# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/VehicleRole.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleRole(genpy.Message):
  _md5sum = "202c9449bc19f6aac1f8286f02abf2a5"
  _type = "etsi_its_cpm_ts_msgs/VehicleRole"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleRole ::= ENUMERATED {
#     default         (0), 
#     publicTransport (1), 
#     specialTransport(2), 
#     dangerousGoods  (3), 
#     roadWork        (4), 
#     rescue          (5), 
#     emergency       (6), 
#     safetyCar       (7), 
#     agriculture     (8), 
#     commercial      (9), 
#     military        (10), 
#     roadOperator    (11), 
#     taxi            (12), 
#     reserved1       (13), 
#     reserved2       (14), 
#     reserved3       (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the role played by a vehicle at a point in time.
# *
# * The value shall be set to:
# * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,
# * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,
# * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,
# * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,
# * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,
# * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,
# * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,
# * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,
# * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor, 
# * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,
# * - 10 `military`        - to indicate that the vehicle is used for military purpose, 
# * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,
# * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service.
# * - 13 `reserved`        - is reserved for future usage.
# * - 14 `reserved`        - is reserved for future usage.
# * - 15 `reserved`        - is reserved for future usage.
# * 
# * @category: Vehicle Information
# * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3)
# 

uint8 value
uint8 DEFAULT = 0
uint8 PUBLIC_TRANSPORT = 1
uint8 SPECIAL_TRANSPORT = 2
uint8 DANGEROUS_GOODS = 3
uint8 ROAD_WORK = 4
uint8 RESCUE = 5
uint8 EMERGENCY = 6
uint8 SAFETY_CAR = 7
uint8 AGRICULTURE = 8
uint8 COMMERCIAL = 9
uint8 MILITARY = 10
uint8 ROAD_OPERATOR = 11
uint8 TAXI = 12
uint8 RESERVED1 = 13
uint8 RESERVED2 = 14
uint8 RESERVED3 = 15

"""
  # Pseudo-constants
  DEFAULT = 0
  PUBLIC_TRANSPORT = 1
  SPECIAL_TRANSPORT = 2
  DANGEROUS_GOODS = 3
  ROAD_WORK = 4
  RESCUE = 5
  EMERGENCY = 6
  SAFETY_CAR = 7
  AGRICULTURE = 8
  COMMERCIAL = 9
  MILITARY = 10
  ROAD_OPERATOR = 11
  TAXI = 12
  RESERVED1 = 13
  RESERVED2 = 14
  RESERVED3 = 15

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleRole, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
