# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/VelocityComponent.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class VelocityComponent(genpy.Message):
  _md5sum = "f93e6a7825fcaaa750b2fda47935d04c"
  _type = "etsi_its_cpm_ts_msgs/VelocityComponent"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponent ::= SEQUENCE {
#     value         VelocityComponentValue,
#     confidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a component of the velocity vector and the associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the value of the component.
# * 
# * @field confidence: the confidence value of the value.
# *
# * @category: Kinematic information
# * @revision: V2.1.1
# 

VelocityComponentValue value

SpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponentValue ::= INTEGER {
#     negativeOutOfRange (-16383),
#     positiveOutOfRange  (16382),
#     unavailable        (16383)
# } (-16383..16383)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of a velocity component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
# * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for velocity values equal to or greater than 163,81 m/s,
# * - `16 383` if the velocity information is not available.
# * 
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -16383
int16 MAX = 16383
int16 NEGATIVE_OUT_OF_RANGE = -16383
int16 POSITIVE_OUT_OF_RANGE = 16382
int16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
# * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
# * - `127` if the confidence value information is not available.
# *  
# * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the speed value may be valid and used by the application.
# * 
# * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
# * and therefore cannot be trusted. Such is not useful for the application.
# *
# * @unit: 0,01 m/s
# * @category: Vehicle information
# * @revision: Description revised in V2.1.1 
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127
"""
  __slots__ = ['value','confidence']
  _slot_types = ['etsi_its_cpm_ts_msgs/VelocityComponentValue','etsi_its_cpm_ts_msgs/SpeedConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value,confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VelocityComponent, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.VelocityComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.SpeedConfidence()
    else:
      self.value = etsi_its_cpm_ts_msgs.msg.VelocityComponentValue()
      self.confidence = etsi_its_cpm_ts_msgs.msg.SpeedConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.value.value, _x.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.VelocityComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.SpeedConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.value.value, _x.confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.value.value, _x.confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.value is None:
        self.value = etsi_its_cpm_ts_msgs.msg.VelocityComponentValue()
      if self.confidence is None:
        self.confidence = etsi_its_cpm_ts_msgs.msg.SpeedConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.value.value, _x.confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
