// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let AccelerationPolarWithZ = require('./AccelerationPolarWithZ.js');
let AccelerationCartesian = require('./AccelerationCartesian.js');

//-----------------------------------------------------------

class Acceleration3dWithConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.choice = null;
      this.polar_acceleration = null;
      this.cartesian_acceleration = null;
    }
    else {
      if (initObj.hasOwnProperty('choice')) {
        this.choice = initObj.choice
      }
      else {
        this.choice = 0;
      }
      if (initObj.hasOwnProperty('polar_acceleration')) {
        this.polar_acceleration = initObj.polar_acceleration
      }
      else {
        this.polar_acceleration = new AccelerationPolarWithZ();
      }
      if (initObj.hasOwnProperty('cartesian_acceleration')) {
        this.cartesian_acceleration = initObj.cartesian_acceleration
      }
      else {
        this.cartesian_acceleration = new AccelerationCartesian();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Acceleration3dWithConfidence
    // Serialize message field [choice]
    bufferOffset = _serializer.uint8(obj.choice, buffer, bufferOffset);
    // Serialize message field [polar_acceleration]
    bufferOffset = AccelerationPolarWithZ.serialize(obj.polar_acceleration, buffer, bufferOffset);
    // Serialize message field [cartesian_acceleration]
    bufferOffset = AccelerationCartesian.serialize(obj.cartesian_acceleration, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Acceleration3dWithConfidence
    let len;
    let data = new Acceleration3dWithConfidence(null);
    // Deserialize message field [choice]
    data.choice = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [polar_acceleration]
    data.polar_acceleration = AccelerationPolarWithZ.deserialize(buffer, bufferOffset);
    // Deserialize message field [cartesian_acceleration]
    data.cartesian_acceleration = AccelerationCartesian.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/Acceleration3dWithConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'cb9f4334372d2a2ce2eea9c557082cf0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Acceleration3dWithConfidence::= CHOICE {
    #     polarAcceleration                    AccelerationPolarWithZ,
    #     cartesianAcceleration                AccelerationCartesian 
    # }
    # ------------------------------------------------------------------------------
    # 
    #
    #
    #
    #
    #
    #
    #
    #
    #
    # Specification of CDD Data Frames:
    #
    #
    #
    #
    #
    #
    #
    #
    #
    #
    #*
    # * This DF represents an acceleration vector with associated confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field polarAcceleration: the representation of the acceleration vector in a polar or cylindrical coordinate system. 
    # * 
    # * @field cartesianAcceleration: the representation of the acceleration vector in a cartesian coordinate system.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 choice
    
    AccelerationPolarWithZ polar_acceleration
    uint8 CHOICE_POLAR_ACCELERATION = 0
    
    AccelerationCartesian cartesian_acceleration
    uint8 CHOICE_CARTESIAN_ACCELERATION = 1
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationPolarWithZ
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationPolarWithZ::= SEQUENCE{
    #     accelerationMagnitude                             AccelerationMagnitude,
    #     accelerationDirection                             CartesianAngle,
    #     zAcceleration                                     AccelerationComponent OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents an acceleration vector in a polar or cylindrical coordinate system.
    # 
    # * It shall include the following components: 
    # * 
    # * @field accelerationMagnitude: magnitude of the acceleration vector projected onto the reference plane, with the associated confidence value.
    # * 
    # * @field accelerationDirection: polar angle of the acceleration vector projected onto the reference plane, with the associated confidence value.
    # *
    # * @field zAcceleration: the optional z component of the acceleration vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    AccelerationMagnitude acceleration_magnitude
    
    CartesianAngle acceleration_direction
    
    AccelerationComponent z_acceleration
    bool z_acceleration_is_present
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationMagnitude::= SEQUENCE {
    #     accelerationMagnitudeValue   AccelerationMagnitudeValue,
    #     accelerationConfidence       AccelerationConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the magnitude of the acceleration vector and associated confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
    # * 
    # * @field accelerationConfidence: the confidence value of the magnitude value.
    # *
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    AccelerationMagnitudeValue acceleration_magnitude_value
    
    AccelerationConfidence acceleration_confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationMagnitudeValue ::= INTEGER {
    #     positiveOutOfRange (160),
    #     unavailable        (161)  
    # } (0.. 161)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
    # *
    # * The value shall be set to:
    # * - `0` to indicate no acceleration,
    # * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    # * - `160` for acceleration values greater than 15,9 m/s^2,
    # * - `161` when the data is unavailable.
    # *
    # * @unit 0,1 m/s^2
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 161
    uint8 POSITIVE_OUT_OF_RANGE = 160
    uint8 UNAVAILABLE = 161
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationConfidence ::= INTEGER {
    #     outOfRange                 (101), 
    #     unavailable                (102)
    # } (0..102)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    # * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
    # * - `102` if the confidence value is unavailable.
    # *
    # * The value 0 shall not be used.
    # *
    # * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the acceleration value may be valid and used by the application.
    # * 
    # * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
    # *
    # * @unit 0,1 m/s^2
    # * @category: Kinematic information
    # * @revision: Description revised in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 102
    uint8 OUT_OF_RANGE = 101
    uint8 UNAVAILABLE = 102
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngle
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngle ::= SEQUENCE {
    #     value         CartesianAngleValue,
    #     confidence    AngleConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
    # *
    # * It shall include the following components: 
    # *
    # * @field value: The angle value which can be estimated as the mean of the current distribution.
    # *
    # * @field confidence: The confidence value associated to the provided value.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    CartesianAngleValue value
    
    AngleConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngleValue ::= INTEGER {
    #     valueNotUsed (3600),
    #     unavailable  (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
    # * a right-hand local coordinate system from the abscissa.
    # *
    # * The value shall be set to: 
    # * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
    # * - `36001` if the accuracy information is not available.
    # *
    # * The value 3600 shall not be used. 
    # * 
    # * @unit 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 VALUE_NOT_USED = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AngleConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AngleConfidence ::= INTEGER {
    #     outOfRange  (126),
    #     unavailable (127)   
    # } (1..127)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
    # * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
    # * - `127` if the accuracy information is not available.
    # *
    # * @unit: 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationComponent ::= SEQUENCE {
    #     value         AccelerationValue,
    #     confidence    AccelerationConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents an acceleration component along with a confidence value.
    # *
    # * It shall include the following components: 
    # *
    # * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
    # *
    # * @field confidence: the confidence value associated to the provided value.
    # *
    # * @category: Kinematic Information
    # * @revision: Created in V2.1.1
    # 
    
    AccelerationValue value
    
    AccelerationConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationValue ::= INTEGER {
    #     negativeOutOfRange (-160),
    #     positiveOutOfRange (160),
    #     unavailable        (161)  
    # } (-160 .. 161)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the value of an acceleration component in a defined coordinate system.
    # *
    # * The value shall be set to:
    # * - `-160` for acceleration values equal to or less than -16 m/s^2,
    # * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    # * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    # * - `160` for acceleration values greater than 15,9 m/s^2,
    # * - `161` when the data is unavailable.
    # *
    # * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
    # * @unit 0,1 m/s^2
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -160
    int16 MAX = 161
    int16 NEGATIVE_OUT_OF_RANGE = -160
    int16 POSITIVE_OUT_OF_RANGE = 160
    int16 UNAVAILABLE = 161
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccelerationCartesian
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccelerationCartesian::= SEQUENCE{
    #     xAcceleration      AccelerationComponent,
    #     yAcceleration      AccelerationComponent,
    #     zAcceleration      AccelerationComponent OPTIONAL
    # }            
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a acceleration vector in a cartesian coordinate system.
    # 
    # * It shall include the following components: 
    # * 
    # * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
    # * 
    # * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
    # *
    # * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    AccelerationComponent x_acceleration
    
    AccelerationComponent y_acceleration
    
    AccelerationComponent z_acceleration
    bool z_acceleration_is_present
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Acceleration3dWithConfidence(null);
    if (msg.choice !== undefined) {
      resolved.choice = msg.choice;
    }
    else {
      resolved.choice = 0
    }

    if (msg.polar_acceleration !== undefined) {
      resolved.polar_acceleration = AccelerationPolarWithZ.Resolve(msg.polar_acceleration)
    }
    else {
      resolved.polar_acceleration = new AccelerationPolarWithZ()
    }

    if (msg.cartesian_acceleration !== undefined) {
      resolved.cartesian_acceleration = AccelerationCartesian.Resolve(msg.cartesian_acceleration)
    }
    else {
      resolved.cartesian_acceleration = new AccelerationCartesian()
    }

    return resolved;
    }
};

// Constants for message
Acceleration3dWithConfidence.Constants = {
  CHOICE_POLAR_ACCELERATION: 0,
  CHOICE_CARTESIAN_ACCELERATION: 1,
}

module.exports = Acceleration3dWithConfidence;
