// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class AngularSpeedConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AngularSpeedConfidence
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AngularSpeedConfidence
    let len;
    let data = new AngularSpeedConfidence(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/AngularSpeedConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '51586ee60daad17b930cceac239d314c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AngularSpeedConfidence ::= ENUMERATED {
    #     degSec-01   (0), 
    #     degSec-02   (1),  
    #     degSec-05   (2), 
    #     degSec-10   (3), 
    #     degSec-20   (4),  
    #     degSec-50   (5), 
    #     outOfRange  (6),   
    #     unavailable (7)   
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # * For correlation computation, maximum interval levels can be assumed.
    # *
    # * The value shall be set to:
    # * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
    # * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
    # * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
    # * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
    # * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
    # * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
    # * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
    # * - 7 - `unavailable` - if the accuracy information is unavailable.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 DEG_SEC_01 = 0
    uint8 DEG_SEC_02 = 1
    uint8 DEG_SEC_05 = 2
    uint8 DEG_SEC_10 = 3
    uint8 DEG_SEC_20 = 4
    uint8 DEG_SEC_50 = 5
    uint8 OUT_OF_RANGE = 6
    uint8 UNAVAILABLE = 7
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AngularSpeedConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
AngularSpeedConfidence.Constants = {
  DEG_SEC_01: 0,
  DEG_SEC_02: 1,
  DEG_SEC_05: 2,
  DEG_SEC_10: 3,
  DEG_SEC_20: 4,
  DEG_SEC_50: 5,
  OUT_OF_RANGE: 6,
  UNAVAILABLE: 7,
}

module.exports = AngularSpeedConfidence;
