// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CartesianAngularVelocityComponentValue = require('./CartesianAngularVelocityComponentValue.js');
let AngularSpeedConfidence = require('./AngularSpeedConfidence.js');

//-----------------------------------------------------------

class CartesianAngularVelocityComponent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = new CartesianAngularVelocityComponentValue();
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = new AngularSpeedConfidence();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CartesianAngularVelocityComponent
    // Serialize message field [value]
    bufferOffset = CartesianAngularVelocityComponentValue.serialize(obj.value, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = AngularSpeedConfidence.serialize(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CartesianAngularVelocityComponent
    let len;
    let data = new CartesianAngularVelocityComponent(null);
    // Deserialize message field [value]
    data.value = CartesianAngularVelocityComponentValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = AngularSpeedConfidence.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ea3e4bf7a8ae565bfa74ad40f25e5511';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngularVelocityComponent ::= SEQUENCE {
    #     value         CartesianAngularVelocityComponentValue,
    #     confidence    AngularSpeedConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents an angular velocity component along with a confidence value in a cartesian coordinate system.
    # *
    # * It shall include the following components: 
    # *
    # * @field value: The angular velocity component.
    # *
    # * @field confidence: The confidence value associated to the provided value.
    # *
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    CartesianAngularVelocityComponentValue value
    
    AngularSpeedConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponentValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngularVelocityComponentValue ::= INTEGER {
    #     negativeOutofRange (-255),
    #     positiveOutOfRange (255),
    #     unavailable	       (256)
    # } (-255..256)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an angular velocity component described in a local Cartesian coordinate system, per default counted positive in
    # * a right-hand local coordinate system from the abscissa.
    # *
    # * The value shall be set to: 
    # * - `-255` if the velocity is equal to or less than -255 degrees/s,
    # * - `n` (`n > -255` and `n < 255`) if the velocity is equal to or less than n x 1 degree/s, and greater than (n-1) x 1 degree/s,
    # * - `255` if the velocity is greater than 254 degrees/s,
    # * - `256` if the information is unavailable.
    # *
    # * @unit: degree/s
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -255
    int16 MAX = 256
    int16 NEGATIVE_OUTOF_RANGE = -255
    int16 POSITIVE_OUT_OF_RANGE = 255
    int16 UNAVAILABLE = 256
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AngularSpeedConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AngularSpeedConfidence ::= ENUMERATED {
    #     degSec-01   (0), 
    #     degSec-02   (1),  
    #     degSec-05   (2), 
    #     degSec-10   (3), 
    #     degSec-20   (4),  
    #     degSec-50   (5), 
    #     outOfRange  (6),   
    #     unavailable (7)   
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # * For correlation computation, maximum interval levels can be assumed.
    # *
    # * The value shall be set to:
    # * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
    # * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
    # * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
    # * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
    # * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
    # * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
    # * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
    # * - 7 - `unavailable` - if the accuracy information is unavailable.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 DEG_SEC_01 = 0
    uint8 DEG_SEC_02 = 1
    uint8 DEG_SEC_05 = 2
    uint8 DEG_SEC_10 = 3
    uint8 DEG_SEC_20 = 4
    uint8 DEG_SEC_50 = 5
    uint8 OUT_OF_RANGE = 6
    uint8 UNAVAILABLE = 7
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CartesianAngularVelocityComponent(null);
    if (msg.value !== undefined) {
      resolved.value = CartesianAngularVelocityComponentValue.Resolve(msg.value)
    }
    else {
      resolved.value = new CartesianAngularVelocityComponentValue()
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = AngularSpeedConfidence.Resolve(msg.confidence)
    }
    else {
      resolved.confidence = new AngularSpeedConfidence()
    }

    return resolved;
    }
};

module.exports = CartesianAngularVelocityComponent;
