// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CartesianCoordinateLarge = require('./CartesianCoordinateLarge.js');
let CoordinateConfidence = require('./CoordinateConfidence.js');

//-----------------------------------------------------------

class CartesianCoordinateWithConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = new CartesianCoordinateLarge();
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = new CoordinateConfidence();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CartesianCoordinateWithConfidence
    // Serialize message field [value]
    bufferOffset = CartesianCoordinateLarge.serialize(obj.value, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = CoordinateConfidence.serialize(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CartesianCoordinateWithConfidence
    let len;
    let data = new CartesianCoordinateWithConfidence(null);
    // Deserialize message field [value]
    data.value = CartesianCoordinateLarge.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = CoordinateConfidence.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 6;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e1ab67da5f7c301221eb41b91064aeb9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianCoordinateWithConfidence ::= SEQUENCE {
    #     value         CartesianCoordinateLarge,
    #     confidence    CoordinateConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a coordinate along with a confidence value in a cartesian reference system.
    # *
    # * It shall include the following components: 
    # * 
    # * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
    # * 
    # * @field confidence: the coordinate confidence value associated to the provided value.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    #
    
    CartesianCoordinateLarge value
    
    CoordinateConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianCoordinateLarge::= INTEGER{ 
    #     negativeOutOfRange (-131072),
    #     positiveOutOfRange (131071)
    # } (-131072..131071)
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
    # *
    # * The value shall be set to:
    # * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
    # * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
    # * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
    # *  
    # * @unit 0,01 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    int32 value
    int32 MIN = -131072
    int32 MAX = 131071
    int32 NEGATIVE_OUT_OF_RANGE = -131072
    int32 POSITIVE_OUT_OF_RANGE = 131071
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CoordinateConfidence ::= INTEGER {
    #     outOfRange            (4095),
    #     unavailable           (4096) 
    # } (1..4096)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
    # * - `4095` if the confidence value is greater than 40,94 metres,
    # * - `4096` if the confidence value is not available.
    # *
    # * @unit 0,01 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 1
    uint16 MAX = 4096
    uint16 OUT_OF_RANGE = 4095
    uint16 UNAVAILABLE = 4096
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CartesianCoordinateWithConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = CartesianCoordinateLarge.Resolve(msg.value)
    }
    else {
      resolved.value = new CartesianCoordinateLarge()
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = CoordinateConfidence.Resolve(msg.confidence)
    }
    else {
      resolved.confidence = new CoordinateConfidence()
    }

    return resolved;
    }
};

module.exports = CartesianCoordinateWithConfidence;
