// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CauseCodeType {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CauseCodeType
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CauseCodeType
    let len;
    let data = new CauseCodeType(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CauseCodeType';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '19d23b4602bae41ba86cae85e6028aeb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CauseCodeType ::= INTEGER {
    #     trafficCondition                                (1),
    #     accident                                        (2),
    #     roadworks                                       (3),
    #     impassability                                   (5),
    #     adverseWeatherCondition-Adhesion                (6),
    #     aquaplaning                                     (7),
    #     hazardousLocation-SurfaceCondition              (9),
    #     hazardousLocation-ObstacleOnTheRoad             (10),
    #     hazardousLocation-AnimalOnTheRoad               (11),
    #     humanPresenceOnTheRoad                          (12),
    #     wrongWayDriving                                 (14),
    #     rescueAndRecoveryWorkInProgress                 (15),
    #     adverseWeatherCondition-ExtremeWeatherCondition (17),
    #     adverseWeatherCondition-Visibility              (18),
    #     adverseWeatherCondition-Precipitation           (19),
    #     violence                                        (20),
    #     slowVehicle                                     (26),
    #     dangerousEndOfQueue                             (27),
    #     vehicleBreakdown                                (91),
    #     postCrash                                       (92),
    #     humanProblem                                    (93),
    #     stationaryVehicle                               (94),
    #     emergencyVehicleApproaching                     (95),
    #     hazardousLocation-DangerousCurve                (96),
    #     collisionRisk                                   (97),
    #     signalViolation                                 (98),
    #     dangerousSituation                              (99),
    #     railwayLevelCrossing                            (100) 
    # } (0..255)
    # ------------------------------------------------------------------------------
    # *
    # *The DE represents the value of the cause code of an event. 
    # * 
    # * The value shall be set to:
    # * - 0                                                     - reserved for future use,
    # * - 1  - `trafficCondition`                               - in case the type of event is an abnormal traffic condition,
    # * - 2  - `accident`                                       - in case the type of event is a road accident,
    # * - 3  - `roadworks`                                      - in case the type of event is roadwork,
    # * - 4                                                     - reserved for future usage,
    # * - 5  - `impassability`                                  - in case the  type of event is unmanaged road blocking, referring to any
    # *                                                           blocking of a road, partial or total, which has not been adequately
    # *                                                           secured and signposted,
    # * - 6  - `adverseWeatherCondition-Adhesion`               - in case the  type of event is low adhesion,
    # * - 7  - `aquaplaning`                                    - danger of aquaplaning on the road,
    # * - 8                                                     - reserved for future usage,
    # * - 9  - `hazardousLocation-SurfaceCondition`             - in case the type of event is abnormal road surface condition,
    # * - 10 - `hazardousLocation-ObstacleOnTheRoad`            - in case the type of event is obstacle on the road,
    # * - 11 - `hazardousLocation-AnimalOnTheRoad`              - in case the type of event is animal on the road,
    # * - 12 - `humanPresenceOnTheRoad`                         - in case the type of event is human presence on the road,
    # * - 13                                                    - reserved for future usage,
    # * - 14 - `wrongWayDriving`                                - in case the type of the event is vehicle driving in wrong way,
    # * - 15 - `rescueAndRecoveryWorkInProgress`                - in case the type of event is rescue and recovery work for accident or for a road hazard in progress,
    # * - 16                                                    - reserved for future usage,
    # * - 17 - `adverseWeatherCondition-ExtremeWeatherCondition`- in case the type of event is extreme weather condition,
    # * - 18 - `adverseWeatherCondition-Visibility`             - in case the type of event is low visibility,
    # * - 19 - `adverseWeatherCondition-Precipitation`          - in case the type of event is precipitation,
    # * - 20 - `violence`                                       - in case the the type of event is human violence on or near the road,
    # * - 21-25                                                 - reserved for future usage,
    # * - 26 - `slowVehicle`                                    - in case the type of event is slow vehicle driving on the road,
    # * - 27 - `dangerousEndOfQueue`                            - in case the type of event is dangerous end of vehicle queue,
    # * - 28-90                                                 - are reserved for future usage,
    # * - 91 - `vehicleBreakdown`                               - in case the type of event is break down vehicle on the road,
    # * - 92 - `postCrash`                                      - in case the type of event is a detected crash,
    # * - 93 - `humanProblem`                                   - in case the type of event is human health problem in vehicles involved in traffic,
    # * - 94 - `stationaryVehicle`                              - in case the type of event is stationary vehicle,
    # * - 95 - `emergencyVehicleApproaching`                    - in case the type of event is approaching vehicle operating emergency mission,
    # * - 96 - `hazardousLocation-DangerousCurve`               - in case the type of event is dangerous curve,
    # * - 97 - `collisionRisk`                                  - in case the type of event is a collision risk,
    # * - 98 - `signalViolation`                                - in case the type of event is signal violation,
    # * - 99 - `dangerousSituation`                             - in case the type of event is dangerous situation in which autonomous safety system in vehicle 
    # *                                                             is activated,
    # * - 100 - `railwayLevelCrossing`                          - in case the type of event is a railway level crossing. 
    # * - 101-255                                               - are reserved for future usage.
    # *
    # * @category: Traffic information
    # * @revision: V1.3.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    uint8 TRAFFIC_CONDITION = 1
    uint8 ACCIDENT = 2
    uint8 ROADWORKS = 3
    uint8 IMPASSABILITY = 5
    uint8 ADVERSE_WEATHER_CONDITION_ADHESION = 6
    uint8 AQUAPLANING = 7
    uint8 HAZARDOUS_LOCATION_SURFACE_CONDITION = 9
    uint8 HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD = 10
    uint8 HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD = 11
    uint8 HUMAN_PRESENCE_ON_THE_ROAD = 12
    uint8 WRONG_WAY_DRIVING = 14
    uint8 RESCUE_AND_RECOVERY_WORK_IN_PROGRESS = 15
    uint8 ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION = 17
    uint8 ADVERSE_WEATHER_CONDITION_VISIBILITY = 18
    uint8 ADVERSE_WEATHER_CONDITION_PRECIPITATION = 19
    uint8 VIOLENCE = 20
    uint8 SLOW_VEHICLE = 26
    uint8 DANGEROUS_END_OF_QUEUE = 27
    uint8 VEHICLE_BREAKDOWN = 91
    uint8 POST_CRASH = 92
    uint8 HUMAN_PROBLEM = 93
    uint8 STATIONARY_VEHICLE = 94
    uint8 EMERGENCY_VEHICLE_APPROACHING = 95
    uint8 HAZARDOUS_LOCATION_DANGEROUS_CURVE = 96
    uint8 COLLISION_RISK = 97
    uint8 SIGNAL_VIOLATION = 98
    uint8 DANGEROUS_SITUATION = 99
    uint8 RAILWAY_LEVEL_CROSSING = 100
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CauseCodeType(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
CauseCodeType.Constants = {
  MIN: 0,
  MAX: 255,
  TRAFFIC_CONDITION: 1,
  ACCIDENT: 2,
  ROADWORKS: 3,
  IMPASSABILITY: 5,
  ADVERSE_WEATHER_CONDITION_ADHESION: 6,
  AQUAPLANING: 7,
  HAZARDOUS_LOCATION_SURFACE_CONDITION: 9,
  HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD: 10,
  HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD: 11,
  HUMAN_PRESENCE_ON_THE_ROAD: 12,
  WRONG_WAY_DRIVING: 14,
  RESCUE_AND_RECOVERY_WORK_IN_PROGRESS: 15,
  ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION: 17,
  ADVERSE_WEATHER_CONDITION_VISIBILITY: 18,
  ADVERSE_WEATHER_CONDITION_PRECIPITATION: 19,
  VIOLENCE: 20,
  SLOW_VEHICLE: 26,
  DANGEROUS_END_OF_QUEUE: 27,
  VEHICLE_BREAKDOWN: 91,
  POST_CRASH: 92,
  HUMAN_PROBLEM: 93,
  STATIONARY_VEHICLE: 94,
  EMERGENCY_VEHICLE_APPROACHING: 95,
  HAZARDOUS_LOCATION_DANGEROUS_CURVE: 96,
  COLLISION_RISK: 97,
  SIGNAL_VIOLATION: 98,
  DANGEROUS_SITUATION: 99,
  RAILWAY_LEVEL_CROSSING: 100,
}

module.exports = CauseCodeType;
