// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CoordinateConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CoordinateConfidence
    // Serialize message field [value]
    bufferOffset = _serializer.uint16(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CoordinateConfidence
    let len;
    let data = new CoordinateConfidence(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint16(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CoordinateConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a7d99ccb90580a13c169670d3c86e549';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CoordinateConfidence ::= INTEGER {
    #     outOfRange            (4095),
    #     unavailable           (4096) 
    # } (1..4096)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
    # * - `4095` if the confidence value is greater than 40,94 metres,
    # * - `4096` if the confidence value is not available.
    # *
    # * @unit 0,01 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 1
    uint16 MAX = 4096
    uint16 OUT_OF_RANGE = 4095
    uint16 UNAVAILABLE = 4096
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CoordinateConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
CoordinateConfidence.Constants = {
  MIN: 1,
  MAX: 4096,
  OUT_OF_RANGE: 4095,
  UNAVAILABLE: 4096,
}

module.exports = CoordinateConfidence;
