// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CorrelationCellValue {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CorrelationCellValue
    // Serialize message field [value]
    bufferOffset = _serializer.int8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CorrelationCellValue
    let len;
    let data = new CorrelationCellValue(null);
    // Deserialize message field [value]
    data.value = _deserializer.int8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CorrelationCellValue';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5a268f69f2597ec2f6f9d7ba6c52c76a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CorrelationCellValue ::= INTEGER {
    #     full-negative-correlation    (-100),     
    #     no-correlation               (0),       
    #     full-positive-correlation    (100),
    #     unavailable (101)  
    # } (-100..101)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
    # *
    # * The value shall be set to: 
    # * - `-100` in case of full negative correlation,
    # * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
    # * - `0` in case of no correlation,
    # * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
    # * - `100` in case of full positive correlation,
    # * - `101` in case the correlation information is unavailable. 
    # *
    # * @unit: the value is scaled by 100
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    int8 value
    int8 MIN = -100
    int8 MAX = 101
    int8 FULL_NEGATIVE_CORRELATION = -100
    int8 NO_CORRELATION = 0
    int8 FULL_POSITIVE_CORRELATION = 100
    int8 UNAVAILABLE = 101
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CorrelationCellValue(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
CorrelationCellValue.Constants = {
  MIN: -100,
  MAX: 101,
  FULL_NEGATIVE_CORRELATION: -100,
  NO_CORRELATION: 0,
  FULL_POSITIVE_CORRELATION: 100,
  UNAVAILABLE: 101,
}

module.exports = CorrelationCellValue;
