// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CorrelationCellValue = require('./CorrelationCellValue.js');

//-----------------------------------------------------------

class CorrelationColumn {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.array = null;
    }
    else {
      if (initObj.hasOwnProperty('array')) {
        this.array = initObj.array
      }
      else {
        this.array = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CorrelationColumn
    // Serialize message field [array]
    // Serialize the length for message field [array]
    bufferOffset = _serializer.uint32(obj.array.length, buffer, bufferOffset);
    obj.array.forEach((val) => {
      bufferOffset = CorrelationCellValue.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CorrelationColumn
    let len;
    let data = new CorrelationColumn(null);
    // Deserialize message field [array]
    // Deserialize array length for message field [array]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.array = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.array[i] = CorrelationCellValue.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.array.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/CorrelationColumn';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9f8d0c5e9907baef83a8dcffcd52c5f9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
    # * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
    # * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
    # * starting at 1 from the left.
    # *
    # * @category: Sensing Information
    # * @revision: Created in V2.1.1
    #
    
    CorrelationCellValue[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 13
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CorrelationCellValue ::= INTEGER {
    #     full-negative-correlation    (-100),     
    #     no-correlation               (0),       
    #     full-positive-correlation    (100),
    #     unavailable (101)  
    # } (-100..101)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
    # *
    # * The value shall be set to: 
    # * - `-100` in case of full negative correlation,
    # * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
    # * - `0` in case of no correlation,
    # * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
    # * - `100` in case of full positive correlation,
    # * - `101` in case the correlation information is unavailable. 
    # *
    # * @unit: the value is scaled by 100
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    int8 value
    int8 MIN = -100
    int8 MAX = 101
    int8 FULL_NEGATIVE_CORRELATION = -100
    int8 NO_CORRELATION = 0
    int8 FULL_POSITIVE_CORRELATION = 100
    int8 UNAVAILABLE = 101
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CorrelationColumn(null);
    if (msg.array !== undefined) {
      resolved.array = new Array(msg.array.length);
      for (let i = 0; i < resolved.array.length; ++i) {
        resolved.array[i] = CorrelationCellValue.Resolve(msg.array[i]);
      }
    }
    else {
      resolved.array = []
    }

    return resolved;
    }
};

// Constants for message
CorrelationColumn.Constants = {
  MIN_SIZE: 1,
  MAX_SIZE: 13,
}

module.exports = CorrelationColumn;
