// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CartesianAngle = require('./CartesianAngle.js');

//-----------------------------------------------------------

class EulerAnglesWithConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.z_angle = null;
      this.y_angle = null;
      this.y_angle_is_present = null;
      this.x_angle = null;
      this.x_angle_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('z_angle')) {
        this.z_angle = initObj.z_angle
      }
      else {
        this.z_angle = new CartesianAngle();
      }
      if (initObj.hasOwnProperty('y_angle')) {
        this.y_angle = initObj.y_angle
      }
      else {
        this.y_angle = new CartesianAngle();
      }
      if (initObj.hasOwnProperty('y_angle_is_present')) {
        this.y_angle_is_present = initObj.y_angle_is_present
      }
      else {
        this.y_angle_is_present = false;
      }
      if (initObj.hasOwnProperty('x_angle')) {
        this.x_angle = initObj.x_angle
      }
      else {
        this.x_angle = new CartesianAngle();
      }
      if (initObj.hasOwnProperty('x_angle_is_present')) {
        this.x_angle_is_present = initObj.x_angle_is_present
      }
      else {
        this.x_angle_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type EulerAnglesWithConfidence
    // Serialize message field [z_angle]
    bufferOffset = CartesianAngle.serialize(obj.z_angle, buffer, bufferOffset);
    // Serialize message field [y_angle]
    bufferOffset = CartesianAngle.serialize(obj.y_angle, buffer, bufferOffset);
    // Serialize message field [y_angle_is_present]
    bufferOffset = _serializer.bool(obj.y_angle_is_present, buffer, bufferOffset);
    // Serialize message field [x_angle]
    bufferOffset = CartesianAngle.serialize(obj.x_angle, buffer, bufferOffset);
    // Serialize message field [x_angle_is_present]
    bufferOffset = _serializer.bool(obj.x_angle_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type EulerAnglesWithConfidence
    let len;
    let data = new EulerAnglesWithConfidence(null);
    // Deserialize message field [z_angle]
    data.z_angle = CartesianAngle.deserialize(buffer, bufferOffset);
    // Deserialize message field [y_angle]
    data.y_angle = CartesianAngle.deserialize(buffer, bufferOffset);
    // Deserialize message field [y_angle_is_present]
    data.y_angle_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [x_angle]
    data.x_angle = CartesianAngle.deserialize(buffer, bufferOffset);
    // Deserialize message field [x_angle_is_present]
    data.x_angle_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 11;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '98c10fa4ae29e04457595050eb60bcd4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # EulerAnglesWithConfidence ::= SEQUENCE {
    #     zAngle CartesianAngle,
    #     yAngle CartesianAngle OPTIONAL,
    #     xAngle CartesianAngle OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
    # *
    # * It shall include the following components: 
    # *
    # * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
    # * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
    # * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
    # *
    # * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
    # * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
    # * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
    # *
    # * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
    # * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
    # * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    CartesianAngle z_angle
    
    CartesianAngle y_angle
    bool y_angle_is_present
    
    CartesianAngle x_angle
    bool x_angle_is_present
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngle
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngle ::= SEQUENCE {
    #     value         CartesianAngleValue,
    #     confidence    AngleConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
    # *
    # * It shall include the following components: 
    # *
    # * @field value: The angle value which can be estimated as the mean of the current distribution.
    # *
    # * @field confidence: The confidence value associated to the provided value.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    CartesianAngleValue value
    
    AngleConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngleValue ::= INTEGER {
    #     valueNotUsed (3600),
    #     unavailable  (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
    # * a right-hand local coordinate system from the abscissa.
    # *
    # * The value shall be set to: 
    # * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
    # * - `36001` if the accuracy information is not available.
    # *
    # * The value 3600 shall not be used. 
    # * 
    # * @unit 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 VALUE_NOT_USED = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AngleConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AngleConfidence ::= INTEGER {
    #     outOfRange  (126),
    #     unavailable (127)   
    # } (1..127)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
    # * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
    # * - `127` if the accuracy information is not available.
    # *
    # * @unit: 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new EulerAnglesWithConfidence(null);
    if (msg.z_angle !== undefined) {
      resolved.z_angle = CartesianAngle.Resolve(msg.z_angle)
    }
    else {
      resolved.z_angle = new CartesianAngle()
    }

    if (msg.y_angle !== undefined) {
      resolved.y_angle = CartesianAngle.Resolve(msg.y_angle)
    }
    else {
      resolved.y_angle = new CartesianAngle()
    }

    if (msg.y_angle_is_present !== undefined) {
      resolved.y_angle_is_present = msg.y_angle_is_present;
    }
    else {
      resolved.y_angle_is_present = false
    }

    if (msg.x_angle !== undefined) {
      resolved.x_angle = CartesianAngle.Resolve(msg.x_angle)
    }
    else {
      resolved.x_angle = new CartesianAngle()
    }

    if (msg.x_angle_is_present !== undefined) {
      resolved.x_angle_is_present = msg.x_angle_is_present;
    }
    else {
      resolved.x_angle_is_present = false
    }

    return resolved;
    }
};

module.exports = EulerAnglesWithConfidence;
