// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DeltaReferencePosition = require('./DeltaReferencePosition.js');
let PathDeltaTime = require('./PathDeltaTime.js');
let InformationQuality = require('./InformationQuality.js');

//-----------------------------------------------------------

class EventPoint {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.event_position = null;
      this.event_delta_time = null;
      this.event_delta_time_is_present = null;
      this.information_quality = null;
    }
    else {
      if (initObj.hasOwnProperty('event_position')) {
        this.event_position = initObj.event_position
      }
      else {
        this.event_position = new DeltaReferencePosition();
      }
      if (initObj.hasOwnProperty('event_delta_time')) {
        this.event_delta_time = initObj.event_delta_time
      }
      else {
        this.event_delta_time = new PathDeltaTime();
      }
      if (initObj.hasOwnProperty('event_delta_time_is_present')) {
        this.event_delta_time_is_present = initObj.event_delta_time_is_present
      }
      else {
        this.event_delta_time_is_present = false;
      }
      if (initObj.hasOwnProperty('information_quality')) {
        this.information_quality = initObj.information_quality
      }
      else {
        this.information_quality = new InformationQuality();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type EventPoint
    // Serialize message field [event_position]
    bufferOffset = DeltaReferencePosition.serialize(obj.event_position, buffer, bufferOffset);
    // Serialize message field [event_delta_time]
    bufferOffset = PathDeltaTime.serialize(obj.event_delta_time, buffer, bufferOffset);
    // Serialize message field [event_delta_time_is_present]
    bufferOffset = _serializer.bool(obj.event_delta_time_is_present, buffer, bufferOffset);
    // Serialize message field [information_quality]
    bufferOffset = InformationQuality.serialize(obj.information_quality, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type EventPoint
    let len;
    let data = new EventPoint(null);
    // Deserialize message field [event_position]
    data.event_position = DeltaReferencePosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [event_delta_time]
    data.event_delta_time = PathDeltaTime.deserialize(buffer, bufferOffset);
    // Deserialize message field [event_delta_time_is_present]
    data.event_delta_time_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [information_quality]
    data.information_quality = InformationQuality.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/EventPoint';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9ad60ce6e05ee12bd0eec7374ddef515';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # EventPoint ::= SEQUENCE {
    #     eventPosition         DeltaReferencePosition,
    #     eventDeltaTime        PathDeltaTime OPTIONAL,
    #     informationQuality    InformationQuality
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides information related to an event at a defined position.
    # *
    # * It shall include the following components: 
    # * 
    # * @field eventPosition: offset position of a detected event point to a defined position. 
    # * 
    # * @field eventDeltaTime: optional time travelled by the detecting ITS-S since the previous detected event point.
    # * 
    # * @field informationQuality: Information quality of the detection for this event point.
    # * 
    # * @category: GeoReference information, Traffic information
    # * @revision: generalized the semantics in V2.1.1
    # 
    
    DeltaReferencePosition event_position
    
    PathDeltaTime event_delta_time
    bool event_delta_time_is_present
    
    InformationQuality information_quality
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/DeltaReferencePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaReferencePosition ::= SEQUENCE {
    #     deltaLatitude     DeltaLatitude,
    #     deltaLongitude    DeltaLongitude,
    #     deltaAltitude     DeltaAltitude
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
    # *
    # * It shall include the following components: 
    # *
    # * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
    # *
    # * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
    # *
    # * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
    # *
    # * @category: GeoReference information
    # * @revision:  V1.3.1
    # 
    
    DeltaLatitude delta_latitude
    
    DeltaLongitude delta_longitude
    
    DeltaAltitude delta_altitude
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/DeltaLatitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLatitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset latitude with regards to a defined latitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
    # * - `0` for no latitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/DeltaLongitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLongitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset longitude with regards to a defined longitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
    # * - `0` for no longitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/DeltaAltitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaAltitude ::= INTEGER {
    #     negativeOutOfRange (-12700),
    #     positiveOutOfRange (12799),
    #     unavailable        (12800)
    # } (-12700..12800)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset altitude with regards to a defined altitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `-12 700` for values equal to or lower than -127 metres,
    # * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
    # * - `0` for no altitudinal offset,
    # * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
    # * - `12 799` for values equal to or greater than 127,99 metres,
    # * - `12 800` when the information is unavailable.
    # *
    # * @unit: 0,01 metre
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int16 value
    int16 MIN = -12700
    int16 MAX = 12800
    int16 NEGATIVE_OUT_OF_RANGE = -12700
    int16 POSITIVE_OUT_OF_RANGE = 12799
    int16 UNAVAILABLE = 12800
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/PathDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathDeltaTime ::= INTEGER (1..65535, ...) 
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
    # *
    # * @unit 0,01 second
    # * @category: GeoReference information
    # * @revision: V1.3.1
    # 
    
    int64 value
    int64 MIN = 1
    int64 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/InformationQuality
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # InformationQuality ::= INTEGER (0..7)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the quality level of provided information.
    # * 
    # * The value shall be set to:
    # * - `0` if the information is unavailable,
    # * - `1` if the quality level is lowest,
    # * - `n` (`n > 1` and `n < 7`) if the quality level is n, 
    # * - `7` if the quality level is highest.
    # *
    # * @note: Definition of quality level is out of scope of the present document.
    # * @category: Basic information
    # * @revision: Editorial update in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 7
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new EventPoint(null);
    if (msg.event_position !== undefined) {
      resolved.event_position = DeltaReferencePosition.Resolve(msg.event_position)
    }
    else {
      resolved.event_position = new DeltaReferencePosition()
    }

    if (msg.event_delta_time !== undefined) {
      resolved.event_delta_time = PathDeltaTime.Resolve(msg.event_delta_time)
    }
    else {
      resolved.event_delta_time = new PathDeltaTime()
    }

    if (msg.event_delta_time_is_present !== undefined) {
      resolved.event_delta_time_is_present = msg.event_delta_time_is_present;
    }
    else {
      resolved.event_delta_time_is_present = false
    }

    if (msg.information_quality !== undefined) {
      resolved.information_quality = InformationQuality.Resolve(msg.information_quality)
    }
    else {
      resolved.information_quality = new InformationQuality()
    }

    return resolved;
    }
};

module.exports = EventPoint;
