// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let HeadingValue = require('./HeadingValue.js');
let HeadingConfidence = require('./HeadingConfidence.js');

//-----------------------------------------------------------

class Heading {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.heading_value = null;
      this.heading_confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('heading_value')) {
        this.heading_value = initObj.heading_value
      }
      else {
        this.heading_value = new HeadingValue();
      }
      if (initObj.hasOwnProperty('heading_confidence')) {
        this.heading_confidence = initObj.heading_confidence
      }
      else {
        this.heading_confidence = new HeadingConfidence();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Heading
    // Serialize message field [heading_value]
    bufferOffset = HeadingValue.serialize(obj.heading_value, buffer, bufferOffset);
    // Serialize message field [heading_confidence]
    bufferOffset = HeadingConfidence.serialize(obj.heading_confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Heading
    let len;
    let data = new Heading(null);
    // Deserialize message field [heading_value]
    data.heading_value = HeadingValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [heading_confidence]
    data.heading_confidence = HeadingConfidence.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/Heading';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ba6c4c57d47253384552cbf3ba9a74d0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Heading ::= SEQUENCE {
    #     headingValue         HeadingValue,
    #     headingConfidence    HeadingConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the Heading in a WGS84 co-ordinates system.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * It shall include the following components: 
    # * 
    # * @field headingValue: the heading value.
    # * 
    # * @field headingConfidence: the confidence value of the heading value with a predefined confidence level.
    # * 
    # * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84Angle instead. 
    # * @category: Kinematic Information
    # * @revision: Description revised in V2.1.1
    # 
    
    HeadingValue heading_value
    
    HeadingConfidence heading_confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/HeadingValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # HeadingValue ::= INTEGER { 
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
    # * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    # *
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
    # *
    # * Unit: 0,1 degree
    # * Categories: GeoReference information
    # * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/HeadingConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # HeadingConfidence ::= INTEGER {
    #     outOfRange  (126), 
    #     unavailable (127)  
    # } (1..127)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the heading confidence value which represents the estimated absolute accuracy of a heading value with a confidence level of 95 %.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degree and more than (n-1) x 0,1 degree,
    # * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
    # * - `127` if the confidence value information is not available.
    # * 
    # * @note:	The fact that a value is received with confidence value set to `unavailable(127)` can be caused by several reasons,
    # * such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the heading value may be valid and used by the application.
    # *
    # * @note: If a heading value is received and its confidence value is set to `outOfRange(126)`, it means that the 
    # * heading value is not valid and therefore cannot be trusted. Such value is not useful for the application.
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleConfidence instead. 
    # * 
    # * @unit: 0,1 degree
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Heading(null);
    if (msg.heading_value !== undefined) {
      resolved.heading_value = HeadingValue.Resolve(msg.heading_value)
    }
    else {
      resolved.heading_value = new HeadingValue()
    }

    if (msg.heading_confidence !== undefined) {
      resolved.heading_confidence = HeadingConfidence.Resolve(msg.heading_confidence)
    }
    else {
      resolved.heading_confidence = new HeadingConfidence()
    }

    return resolved;
    }
};

module.exports = Heading;
