// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class InterferenceManagementChannel {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.centre_frequency = null;
      this.channel_width = null;
      this.exponent = null;
    }
    else {
      if (initObj.hasOwnProperty('centre_frequency')) {
        this.centre_frequency = initObj.centre_frequency
      }
      else {
        this.centre_frequency = 0;
      }
      if (initObj.hasOwnProperty('channel_width')) {
        this.channel_width = initObj.channel_width
      }
      else {
        this.channel_width = 0;
      }
      if (initObj.hasOwnProperty('exponent')) {
        this.exponent = initObj.exponent
      }
      else {
        this.exponent = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type InterferenceManagementChannel
    // Serialize message field [centre_frequency]
    bufferOffset = _serializer.uint32(obj.centre_frequency, buffer, bufferOffset);
    // Serialize message field [channel_width]
    bufferOffset = _serializer.uint16(obj.channel_width, buffer, bufferOffset);
    // Serialize message field [exponent]
    bufferOffset = _serializer.uint8(obj.exponent, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type InterferenceManagementChannel
    let len;
    let data = new InterferenceManagementChannel(null);
    // Deserialize message field [centre_frequency]
    data.centre_frequency = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [channel_width]
    data.channel_width = _deserializer.uint16(buffer, bufferOffset);
    // Deserialize message field [exponent]
    data.exponent = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 7;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/InterferenceManagementChannel';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1579f5b38c93a0a540adfdb6f296cc73';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # InterferenceManagementChannel ::= SEQUENCE {
    #     centreFrequency    INTEGER (1 .. 99999),
    #     channelWidth       INTEGER (0 .. 9999),
    #     exponent           INTEGER (0 .. 15) 
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a frequency channel 
    # *
    # * It shall include the following components: 
    # *
    # * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)
    # * 
    # * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)
    # *
    # * @field exponent: exponent of the power of 10 used in the calculation of the components above.
    # *
    # * @category: Communication information
    # * @revision: created in V2.1.1
    #
    
    uint32 centre_frequency
    uint32 CENTRE_FREQUENCY_MIN = 1
    uint32 CENTRE_FREQUENCY_MAX = 99999
    
    uint16 channel_width
    uint16 CHANNEL_WIDTH_MIN = 0
    uint16 CHANNEL_WIDTH_MAX = 9999
    
    uint8 exponent
    uint8 EXPONENT_MIN = 0
    uint8 EXPONENT_MAX = 15
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new InterferenceManagementChannel(null);
    if (msg.centre_frequency !== undefined) {
      resolved.centre_frequency = msg.centre_frequency;
    }
    else {
      resolved.centre_frequency = 0
    }

    if (msg.channel_width !== undefined) {
      resolved.channel_width = msg.channel_width;
    }
    else {
      resolved.channel_width = 0
    }

    if (msg.exponent !== undefined) {
      resolved.exponent = msg.exponent;
    }
    else {
      resolved.exponent = 0
    }

    return resolved;
    }
};

// Constants for message
InterferenceManagementChannel.Constants = {
  CENTRE_FREQUENCY_MIN: 1,
  CENTRE_FREQUENCY_MAX: 99999,
  CHANNEL_WIDTH_MIN: 0,
  CHANNEL_WIDTH_MAX: 9999,
  EXPONENT_MIN: 0,
  EXPONENT_MAX: 15,
}

module.exports = InterferenceManagementChannel;
