// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class InterferenceManagementZoneType {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type InterferenceManagementZoneType
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type InterferenceManagementZoneType
    let len;
    let data = new InterferenceManagementZoneType(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/InterferenceManagementZoneType';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '171ce0aae659243138528d63f10745b3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # InterferenceManagementZoneType ::= ENUMERATED {
    #     permanentCenDsrcTolling (0),
    #     temporaryCenDsrcTolling (1),
    #     unavailable             (2), 
    #     urbanRail               (3),      
    #     satelliteStation        (4),
    #     fixedLinks              (5), 
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DE defines the type of an interference management zone, so that an ITS-S can 
    # * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).
    # * It is an extension of the type @ref ProtectedZoneType.
    # *
    # * The value shall be set to:
    # * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
    # * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],
    # * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,
    # * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,
    # * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,
    # * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.
    # *
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 value
    uint8 PERMANENT_CEN_DSRC_TOLLING = 0
    uint8 TEMPORARY_CEN_DSRC_TOLLING = 1
    uint8 UNAVAILABLE = 2
    uint8 URBAN_RAIL = 3
    uint8 SATELLITE_STATION = 4
    uint8 FIXED_LINKS = 5
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new InterferenceManagementZoneType(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
InterferenceManagementZoneType.Constants = {
  PERMANENT_CEN_DSRC_TOLLING: 0,
  TEMPORARY_CEN_DSRC_TOLLING: 1,
  UNAVAILABLE: 2,
  URBAN_RAIL: 3,
  SATELLITE_STATION: 4,
  FIXED_LINKS: 5,
}

module.exports = InterferenceManagementZoneType;
