// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let TimestampIts = require('./TimestampIts.js');
let ReferencePosition = require('./ReferencePosition.js');
let MessageSegmentationInfo = require('./MessageSegmentationInfo.js');
let MessageRateRange = require('./MessageRateRange.js');

//-----------------------------------------------------------

class ManagementContainer {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.reference_time = null;
      this.reference_position = null;
      this.segmentation_info = null;
      this.segmentation_info_is_present = null;
      this.message_rate_range = null;
      this.message_rate_range_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('reference_time')) {
        this.reference_time = initObj.reference_time
      }
      else {
        this.reference_time = new TimestampIts();
      }
      if (initObj.hasOwnProperty('reference_position')) {
        this.reference_position = initObj.reference_position
      }
      else {
        this.reference_position = new ReferencePosition();
      }
      if (initObj.hasOwnProperty('segmentation_info')) {
        this.segmentation_info = initObj.segmentation_info
      }
      else {
        this.segmentation_info = new MessageSegmentationInfo();
      }
      if (initObj.hasOwnProperty('segmentation_info_is_present')) {
        this.segmentation_info_is_present = initObj.segmentation_info_is_present
      }
      else {
        this.segmentation_info_is_present = false;
      }
      if (initObj.hasOwnProperty('message_rate_range')) {
        this.message_rate_range = initObj.message_rate_range
      }
      else {
        this.message_rate_range = new MessageRateRange();
      }
      if (initObj.hasOwnProperty('message_rate_range_is_present')) {
        this.message_rate_range_is_present = initObj.message_rate_range_is_present
      }
      else {
        this.message_rate_range_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ManagementContainer
    // Serialize message field [reference_time]
    bufferOffset = TimestampIts.serialize(obj.reference_time, buffer, bufferOffset);
    // Serialize message field [reference_position]
    bufferOffset = ReferencePosition.serialize(obj.reference_position, buffer, bufferOffset);
    // Serialize message field [segmentation_info]
    bufferOffset = MessageSegmentationInfo.serialize(obj.segmentation_info, buffer, bufferOffset);
    // Serialize message field [segmentation_info_is_present]
    bufferOffset = _serializer.bool(obj.segmentation_info_is_present, buffer, bufferOffset);
    // Serialize message field [message_rate_range]
    bufferOffset = MessageRateRange.serialize(obj.message_rate_range, buffer, bufferOffset);
    // Serialize message field [message_rate_range_is_present]
    bufferOffset = _serializer.bool(obj.message_rate_range_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ManagementContainer
    let len;
    let data = new ManagementContainer(null);
    // Deserialize message field [reference_time]
    data.reference_time = TimestampIts.deserialize(buffer, bufferOffset);
    // Deserialize message field [reference_position]
    data.reference_position = ReferencePosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [segmentation_info]
    data.segmentation_info = MessageSegmentationInfo.deserialize(buffer, bufferOffset);
    // Deserialize message field [segmentation_info_is_present]
    data.segmentation_info_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [message_rate_range]
    data.message_rate_range = MessageRateRange.deserialize(buffer, bufferOffset);
    // Deserialize message field [message_rate_range_is_present]
    data.message_rate_range_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 35;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/ManagementContainer';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f5c7bb2508a9dae37b2d201f636fadef';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ManagementContainer ::= SEQUENCE {
    #     referenceTime      TimestampIts,
    #     referencePosition  ReferencePosition,
    #     segmentationInfo   MessageSegmentationInfo OPTIONAL,
    #     messageRateRange   MessageRateRange OPTIONAL,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF  represents the management container of the CPM. 
    # * The management container provides basic information about the originating ITS-S, which are not specific to a specific type of station.
    # *
    # * It shall include the following components: 
    # *
    # * @field referenceTime: the reference time for all time related information in the CPM.
    # *
    # * @field messageRateRange: the planned or expected range of the CPM generation rate.
    # *
    # * @field segmentationInfo: information regarding the message segmentation on facility layer.
    # *
    # * @field referencePosition: the reference position for all position related information in the CPM.
    # *
    #
    
    TimestampIts reference_time
    
    ReferencePosition reference_position
    
    MessageSegmentationInfo segmentation_info
    bool segmentation_info_is_present
    
    MessageRateRange message_rate_range
    bool message_rate_range_is_present
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/TimestampIts
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TimestampIts ::= INTEGER (0..4398046511103)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. 
    # * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.
    # * "Elapsed" means that the true number of milliseconds is continuously counted without interruption,
    # *  i.e. it is not altered by leap seconds, which occur in UTC.
    # * 
    # * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, 
    # * operated in accordance with the definition of the second, the unit of time of the International System of Units. 
    # * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. 
    # * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, 
    # * further 5 leap seconds have been inserted in UTC.
    # * 
    # * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,
    # * which includes one leap second insertion since the ITS epoch.
    # * @unit: 0,001 s
    # * @category: Basic information
    # * @revision: Description revised in in V2.1.1
    # 
    
    uint64 value
    uint64 MIN = 0
    uint64 MAX = 4398046511103
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/ReferencePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ReferencePosition ::= SEQUENCE {
    #     latitude                     Latitude,
    #     longitude                    Longitude,
    #     positionConfidenceEllipse    PosConfidenceEllipse,
    #     altitude                     Altitude
    # }
    # ------------------------------------------------------------------------------
    # *
    # * A position within a geographic coordinate system together with a confidence ellipse. 
    # *
    # * It shall include the following components: 
    # *
    # * @field latitude: the latitude of the geographical point.
    # *
    # * @field longitude: the longitude of the geographical point.
    # *
    # * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
    # *
    # * @field altitude: the altitude and an altitude accuracy of the geographical point.
    # *
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref ReferencePositionWithConfidence instead. 
    # * @category: GeoReference information
    # * @revision: description updated in V2.1.1
    # 
    
    Latitude latitude
    
    Longitude longitude
    
    PosConfidenceEllipse position_confidence_ellipse
    
    Altitude altitude
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/Latitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Latitude ::= INTEGER {
    #     unavailable(900000001)
    # } (-900000000..900000001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
    # * in south hemisphere.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
    # * - `0` is used for the latitude of the equator,
    # * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
    # * - `900 000 001` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: Editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -900000000
    int32 MAX = 900000001
    int32 UNAVAILABLE = 900000001
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/Longitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Longitude ::= INTEGER {
    #     valueNotUsed (-1800000000),
    #     unavailable  (1800000001)
    # } (-1800000000..1800000001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
    # * to the east or to the west of the prime meridian.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
    # * - `0` to indicate the prime meridian,
    # * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
    # * - `1 800 000 001` when the information is unavailable.
    # *
    # * The value -1 800 000 000 shall not be used. 
    # * 
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    int32 value
    int32 MIN = -1800000000
    int32 MAX = 1800000001
    int32 VALUE_NOT_USED = -1800000000
    int32 UNAVAILABLE = 1800000001
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/PosConfidenceEllipse
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PosConfidenceEllipse ::= SEQUENCE {
    #     semiMajorConfidence     SemiAxisLength,
    #     semiMinorConfidence     SemiAxisLength,
    #     semiMajorOrientation    HeadingValue
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
    # * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
    # * position point for which the position accuracy is evaluated.
    # *
    # * It shall include the following components: 
    # *
    # * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
    # * and major axis point of the position accuracy ellipse. 
    # *
    # * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
    # * and minor axis point of the position accuracy ellipse. 
    # *
    # * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
    # * ellipse with regards to the WGS84 north. 
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # *
    # * @category GeoReference information
    # * @revision: V1.3.1
    # 
    
    SemiAxisLength semi_major_confidence
    
    SemiAxisLength semi_minor_confidence
    
    HeadingValue semi_major_orientation
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/SemiAxisLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SemiAxisLength ::= INTEGER{
    #     doNotUse    (0),
    #     outOfRange  (4094), 
    #     unavailable (4095)
    # } (0..4095)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 4095
    uint16 DO_NOT_USE = 0
    uint16 OUT_OF_RANGE = 4094
    uint16 UNAVAILABLE = 4095
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/HeadingValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # HeadingValue ::= INTEGER { 
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
    # * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    # *
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
    # *
    # * Unit: 0,1 degree
    # * Categories: GeoReference information
    # * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/Altitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Altitude ::= SEQUENCE {
    #     altitudeValue         AltitudeValue,
    #     altitudeConfidence    AltitudeConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides the altitude and confidence level of an altitude information in a WGS84 coordinate system.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * It shall include the following components: 
    # *
    # * @field altitudeValue: altitude of a geographical point.
    # *
    # * @field altitudeConfidence: confidence level of the altitudeValue.
    # *
    # * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref AltitudeWithConfidence instead. 
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    AltitudeValue altitude_value
    
    AltitudeConfidence altitude_confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AltitudeValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AltitudeValue ::= INTEGER {
    #     negativeOutOfRange (-100000),
    #     postiveOutOfRange  (800000),
    #     unavailable        (800001)
    # } (-100000..800001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the altitude value in a WGS84 coordinate system.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `-100 000` if the altitude is equal to or less than -1 000 m,
    # * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
    # * - `800 000` if the altitude  greater than 7 999,99 m,
    # * - `800 001` if the information is not available.
    # *
    # * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
    # * @unit: 0,01 metre
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
    # 
    
    int32 value
    int32 MIN = -100000
    int32 MAX = 800001
    int32 NEGATIVE_OUT_OF_RANGE = -100000
    int32 POSTIVE_OUT_OF_RANGE = 800000
    int32 UNAVAILABLE = 800001
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AltitudeConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AltitudeConfidence ::= ENUMERATED {
    #     alt-000-01  (0),
    #     alt-000-02  (1),
    #     alt-000-05  (2),
    #     alt-000-10  (3),
    #     alt-000-20  (4),
    #     alt-000-50  (5),
    #     alt-001-00  (6),
    #     alt-002-00  (7),
    #     alt-005-00  (8),
    #     alt-010-00  (9),
    #     alt-020-00  (10),
    #     alt-050-00  (11),
    #     alt-100-00  (12),
    #     alt-200-00  (13),
    #     outOfRange  (14),
    #     unavailable (15)
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
    # *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
    # *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
    # *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
    # *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
    # *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
    # *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
    # *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
    # *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
    # *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
    # *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
    # *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
    # *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
    # *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
    # *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
    # *   - 15 - `unavailable`  - if the confidence value is unavailable.       
    # *
    # * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
    # * by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the altitude value may be valid and used by the application.
    # * 
    # * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
    # * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
    # *
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    uint8 value
    uint8 ALT_000_01 = 0
    uint8 ALT_000_02 = 1
    uint8 ALT_000_05 = 2
    uint8 ALT_000_10 = 3
    uint8 ALT_000_20 = 4
    uint8 ALT_000_50 = 5
    uint8 ALT_001_00 = 6
    uint8 ALT_002_00 = 7
    uint8 ALT_005_00 = 8
    uint8 ALT_010_00 = 9
    uint8 ALT_020_00 = 10
    uint8 ALT_050_00 = 11
    uint8 ALT_100_00 = 12
    uint8 ALT_200_00 = 13
    uint8 OUT_OF_RANGE = 14
    uint8 UNAVAILABLE = 15
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/MessageSegmentationInfo
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MessageSegmentationInfo ::= SEQUENCE {
    #     totalMsgNo  CardinalNumber3b,
    #     thisMsgNo   OrdinalNumber3b
    #     }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides information about a message with respect to the segmentation process at the sender.
    # *
    # * It shall include the following components: 
    # * 
    # * @field totalMsgNo: indicates the total number of messages that has been used on the transmitter side to encode the information.
    # *
    # * @field thisMsgNo: indicates the position of the message within of the total set of messages.
    # *
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    # 
    
    CardinalNumber3b total_msg_no
    
    OrdinalNumber3b this_msg_no
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CardinalNumber3b
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CardinalNumber3b ::= INTEGER(1..8)
    # ------------------------------------------------------------------------------
    # *
    # * The DE represents a cardinal number that counts the size of a set. 
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 8
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/OrdinalNumber3b
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # OrdinalNumber3b ::= INTEGER(1..8) 
    # ------------------------------------------------------------------------------
    # *
    # * The DE represents an ordinal number that indicates the position of an element in a set. 
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 8
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/MessageRateRange
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MessageRateRange::= SEQUENCE{
    #    messageRateMin   MessageRateHz,
    #    messageRateMax   MessageRateHz
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF  represents the planned or expected range of the message generation rate.
    # *
    # * It shall include the following components: 
    # *
    # * @field messageRateMin: the minimum planned or expected message rate.
    # *
    # * @field messageRateMax: the maximum planned or expected message rate.
    # *
    #
    
    MessageRateHz message_rate_min
    
    MessageRateHz message_rate_max
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/MessageRateHz
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MessageRateHz::= SEQUENCE {
    #     mantissa    INTEGER (1..100),
    #     exponent    INTEGER (-5..2)
    #     }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a message rate.
    # *
    # * @field mantissa: indicates the mantissa.
    # *
    # * @field exponent: indicates the exponent.
    # *
    # * The specified message rate is: mantissa*(10^exponent) 
    # *
    # * @unit: Hz
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 mantissa
    uint8 MANTISSA_MIN = 1
    uint8 MANTISSA_MAX = 100
    
    int8 exponent
    uint8 EXPONENT_MIN = 0
    uint8 EXPONENT_MAX = 2
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ManagementContainer(null);
    if (msg.reference_time !== undefined) {
      resolved.reference_time = TimestampIts.Resolve(msg.reference_time)
    }
    else {
      resolved.reference_time = new TimestampIts()
    }

    if (msg.reference_position !== undefined) {
      resolved.reference_position = ReferencePosition.Resolve(msg.reference_position)
    }
    else {
      resolved.reference_position = new ReferencePosition()
    }

    if (msg.segmentation_info !== undefined) {
      resolved.segmentation_info = MessageSegmentationInfo.Resolve(msg.segmentation_info)
    }
    else {
      resolved.segmentation_info = new MessageSegmentationInfo()
    }

    if (msg.segmentation_info_is_present !== undefined) {
      resolved.segmentation_info_is_present = msg.segmentation_info_is_present;
    }
    else {
      resolved.segmentation_info_is_present = false
    }

    if (msg.message_rate_range !== undefined) {
      resolved.message_rate_range = MessageRateRange.Resolve(msg.message_rate_range)
    }
    else {
      resolved.message_rate_range = new MessageRateRange()
    }

    if (msg.message_rate_range_is_present !== undefined) {
      resolved.message_rate_range_is_present = msg.message_rate_range_is_present;
    }
    else {
      resolved.message_rate_range_is_present = false
    }

    return resolved;
    }
};

module.exports = ManagementContainer;
