// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MitigationPerTechnologyClass = require('./MitigationPerTechnologyClass.js');

//-----------------------------------------------------------

class MitigationForTechnologies {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.array = null;
    }
    else {
      if (initObj.hasOwnProperty('array')) {
        this.array = initObj.array
      }
      else {
        this.array = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MitigationForTechnologies
    // Serialize message field [array]
    // Serialize the length for message field [array]
    bufferOffset = _serializer.uint32(obj.array.length, buffer, bufferOffset);
    obj.array.forEach((val) => {
      bufferOffset = MitigationPerTechnologyClass.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MitigationForTechnologies
    let len;
    let data = new MitigationForTechnologies(null);
    // Deserialize message field [array]
    // Deserialize array length for message field [array]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.array = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.array[i] = MitigationPerTechnologyClass.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 11 * object.array.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/MitigationForTechnologies';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'da881b148069399058cf4fa91c5bfd20';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MitigationForTechnologies ::= SEQUENCE (SIZE(1..8)) OF MitigationPerTechnologyClass 
    # ------------------------------------------------------------------------------
    # *
    # * This DF shall contain a list of @ref MitigationPerTechnologyClass.
    # *
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    #
    
    MitigationPerTechnologyClass[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 8
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/MitigationPerTechnologyClass
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MitigationPerTechnologyClass ::= SEQUENCE {
    #    accessTechnologyClass    AccessTechnologyClass, 
    #    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL, 
    #    powerReduction           INTEGER (0 .. 30) OPTIONAL,
    #    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,   
    #    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,   
    #    ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
    # *
    # * It shall include the following components: 
    # *
    # * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
    # *
    # * @field lowDutyCycle: duty cycle limit.
    # * @unit: 0,01 % steps
    # *
    # * @field powerReduction: the delta value of power to be reduced.
    # * @unit: dB
    # *
    # * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
    # * @unit: ms
    # *
    # * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
    # * @unit: ms
    # *
    # * @note: All parameters are optional, as they may not apply to some of the technologies or
    # * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7. 
    # *
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    # 
    
    AccessTechnologyClass access_technology_class
    
    uint16 low_duty_cycle
    bool low_duty_cycle_is_present
    uint16 LOW_DUTY_CYCLE_MIN = 0
    uint16 LOW_DUTY_CYCLE_MAX = 10000
    
    uint8 power_reduction
    bool power_reduction_is_present
    uint8 POWER_REDUCTION_MIN = 0
    uint8 POWER_REDUCTION_MAX = 30
    
    uint16 dmc_toff_limit
    bool dmc_toff_limit_is_present
    uint16 DMC_TOFF_LIMIT_MIN = 0
    uint16 DMC_TOFF_LIMIT_MAX = 1200
    
    uint8 dmc_ton_limit
    bool dmc_ton_limit_is_present
    uint8 DMC_TON_LIMIT_MIN = 0
    uint8 DMC_TON_LIMIT_MAX = 20
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AccessTechnologyClass
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AccessTechnologyClass ::= ENUMERATED {
    #    any         (0), 
    #    itsg5Class  (1), 
    #    ltev2xClass (2), 
    #    nrv2xClass  (3),
    #    ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates an access technology.
    # *
    # * The value shall be set to:
    # * - `0`: in case of any access technology class,
    # * - `1`: in case of ITS-G5 access technology class,
    # * - `2`: in case of LTE-V2X access technology class,
    # * - `3`: in case of NR-V2X access technology class.
    # * 
    # * @category: Communication information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 value
    uint8 ANY = 0
    uint8 ITSG5_CLASS = 1
    uint8 LTEV2X_CLASS = 2
    uint8 NRV2X_CLASS = 3
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MitigationForTechnologies(null);
    if (msg.array !== undefined) {
      resolved.array = new Array(msg.array.length);
      for (let i = 0; i < resolved.array.length; ++i) {
        resolved.array[i] = MitigationPerTechnologyClass.Resolve(msg.array[i]);
      }
    }
    else {
      resolved.array = []
    }

    return resolved;
    }
};

// Constants for message
MitigationForTechnologies.Constants = {
  MIN_SIZE: 1,
  MAX_SIZE: 8,
}

module.exports = MitigationForTechnologies;
