// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ObjectDimensionValue = require('./ObjectDimensionValue.js');
let ObjectDimensionConfidence = require('./ObjectDimensionConfidence.js');

//-----------------------------------------------------------

class ObjectDimension {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = new ObjectDimensionValue();
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = new ObjectDimensionConfidence();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ObjectDimension
    // Serialize message field [value]
    bufferOffset = ObjectDimensionValue.serialize(obj.value, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = ObjectDimensionConfidence.serialize(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ObjectDimension
    let len;
    let data = new ObjectDimension(null);
    // Deserialize message field [value]
    data.value = ObjectDimensionValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = ObjectDimensionConfidence.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/ObjectDimension';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '52095991c6daa8715d91ce7fa17a1f43';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ObjectDimension ::= SEQUENCE {
    #     value         ObjectDimensionValue,
    #     confidence    ObjectDimensionConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a dimension of an object together with a confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field value: the object dimension value which can be estimated as the mean of the current distribution.
    # *
    # * @field confidence: the associated confidence value.
    # *
    # * @category: Sensing information
    # * @revision: Created in V2.1.1
    #
    
    ObjectDimensionValue value
    
    ObjectDimensionConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/ObjectDimensionValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ObjectDimensionValue ::= INTEGER { 
    #     outOfRange              (255),
    #     unavailable             (256)
    # }(1..256)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents a single dimension of an object.
    # *
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
    # * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
    # * - `256` if the data is unavailable.
    # *
    # * @unit 0,1 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1 
    #
    
    uint16 value
    uint16 MIN = 1
    uint16 MAX = 256
    uint16 OUT_OF_RANGE = 255
    uint16 UNAVAILABLE = 256
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/ObjectDimensionConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ObjectDimensionConfidence ::= INTEGER { 
    #     outOfRange              (31),
    #     unavailable             (32)
    # } (1..32)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
    # * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
    # * - `32` if the confidence value is unavailable.
    # *
    # * @unit 0,1 m
    # * @category: Sensing information
    # * @revision: Created in V2.1.1 
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 32
    uint8 OUT_OF_RANGE = 31
    uint8 UNAVAILABLE = 32
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ObjectDimension(null);
    if (msg.value !== undefined) {
      resolved.value = ObjectDimensionValue.Resolve(msg.value)
    }
    else {
      resolved.value = new ObjectDimensionValue()
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = ObjectDimensionConfidence.Resolve(msg.confidence)
    }
    else {
      resolved.confidence = new ObjectDimensionConfidence()
    }

    return resolved;
    }
};

module.exports = ObjectDimension;
