// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class RelevanceDistance {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RelevanceDistance
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RelevanceDistance
    let len;
    let data = new RelevanceDistance(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/RelevanceDistance';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7a483d411f6ba2af29a6b49568cdb396';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RelevanceDistance ::= ENUMERATED {
    #     lessThan50m(0), 
    #     lessThan100m(1), 
    #     lessThan200m(2), 
    #     lessThan500m(3), 
    #     lessThan1000m(4), 
    #     lessThan5km(5), 
    #     lessThan10km(6), 
    #     over10km(7)
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE describes a distance of relevance for information indicated in a message.
    # *
    # * The value shall be set to:
    # * - 0 `lessThan50m`   - for distances below 50 m,
    # * - 1 `lessThan100m`  - for distances below 100 m, 
    # * - 2 `lessThan200m`  - for distances below 200 m, 
    # * - 3 `lessThan500m`  - for distances below 300 m, 
    # * - 4 `lessThan1000m` - for distances below 1 000 m, 
    # * - 5 `lessThan5km`   - for distances below 5 000 m, 
    # * - 6 `lessThan10km`  - for distances below 10 000 m, 
    # * - 7 `over10km`      - for distances over 10 000 m. 
    # * 
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref StandardLength3b instead. 
    # *
    # * @category: GeoReference information
    # * @revision: Editorial update in V2.1.1
    # 
    
    uint8 value
    uint8 LESS_THAN50M = 0
    uint8 LESS_THAN100M = 1
    uint8 LESS_THAN200M = 2
    uint8 LESS_THAN500M = 3
    uint8 LESS_THAN1000M = 4
    uint8 LESS_THAN5KM = 5
    uint8 LESS_THAN10KM = 6
    uint8 OVER10KM = 7
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RelevanceDistance(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
RelevanceDistance.Constants = {
  LESS_THAN50M: 0,
  LESS_THAN100M: 1,
  LESS_THAN200M: 2,
  LESS_THAN500M: 3,
  LESS_THAN1000M: 4,
  LESS_THAN5KM: 5,
  LESS_THAN10KM: 6,
  OVER10KM: 7,
}

module.exports = RelevanceDistance;
