// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class SensorType {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SensorType
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SensorType
    let len;
    let data = new SensorType(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/SensorType';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9e8a57d0708389acff397800f74e37eb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SensorType ::= INTEGER {
    #     undefined         (0),
    #     radar             (1),
    #     lidar             (2),
    #     monovideo         (3),
    #     stereovision      (4),
    #     nightvision       (5),
    #     ultrasonic        (6),
    #     pmd               (7),
    #     inductionLoop     (8),
    #     sphericalCamera   (9),
    #     uwb               (10),
    #     acoustic          (11),
    #     localAggregation  (12),
    #     itsAggregation    (13)
    # } (0..31)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the type of sensor.
    # * 
    # * The value shall be set to:
    # * - 0  `undefined`         - in case the sensor type is undefined. 
    # * - 1  `radar`             - in case the sensor is a radar,
    # * - 2  `lidar`             - in case the sensor is a lidar,
    # * - 3  `monovideo`         - in case the sensor is mono video,
    # * - 4  `stereovision`      - in case the sensor is stereo vision,
    # * - 5  `nightvision`       - in case the sensor is night vision,
    # * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
    # * - 7  `pmd`               - in case the sensor is photonic mixing device,
    # * - 8  `inductionLoop`     - in case the sensor is an induction loop,
    # * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
    # * - 10 `uwb`               - in case the sensor is ultra wide band,
    # * - 11 `acoustic`          - in case the sensor is acoustic,
    # * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
    # * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
    # * - 14-31                  - are reserved for future usage.
    # *
    # * @category: Sensing Information
    # * @revision: created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 31
    uint8 UNDEFINED = 0
    uint8 RADAR = 1
    uint8 LIDAR = 2
    uint8 MONOVIDEO = 3
    uint8 STEREOVISION = 4
    uint8 NIGHTVISION = 5
    uint8 ULTRASONIC = 6
    uint8 PMD = 7
    uint8 INDUCTION_LOOP = 8
    uint8 SPHERICAL_CAMERA = 9
    uint8 UWB = 10
    uint8 ACOUSTIC = 11
    uint8 LOCAL_AGGREGATION = 12
    uint8 ITS_AGGREGATION = 13
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SensorType(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
SensorType.Constants = {
  MIN: 0,
  MAX: 31,
  UNDEFINED: 0,
  RADAR: 1,
  LIDAR: 2,
  MONOVIDEO: 3,
  STEREOVISION: 4,
  NIGHTVISION: 5,
  ULTRASONIC: 6,
  PMD: 7,
  INDUCTION_LOOP: 8,
  SPHERICAL_CAMERA: 9,
  UWB: 10,
  ACOUSTIC: 11,
  LOCAL_AGGREGATION: 12,
  ITS_AGGREGATION: 13,
}

module.exports = SensorType;
