// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class SteeringWheelAngleConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SteeringWheelAngleConfidence
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SteeringWheelAngleConfidence
    let len;
    let data = new SteeringWheelAngleConfidence(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/SteeringWheelAngleConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8989383d88683bc79ce922e426e2c6b3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SteeringWheelAngleConfidence ::= INTEGER {
    #     outOfRange                      (126), 
    #     unavailable                     (127)
    # } (1..127)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the steering wheel angle confidence value which represents the estimated absolute accuracy for a  steering wheel angle value with a confidence level of 95 %.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n x 1,5 degrees,
    # * - `126` if the confidence value is out of range, i.e. greater than 187,5 degrees,
    # * - `127` if the confidence value is not available.
    # * 
    # * @note: The fact that a steering wheel angle value is received with confidence value set to `unavailable(127)`
    # * can be caused by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the steering wheel angle value may be valid and used by the application.
    # * 
    # * If a steering wheel angle value is received and its confidence value is set to `outOfRange(126)`,
    # * it means that the steering wheel angle value is not valid and therefore cannot be trusted.
    # * Such value is not useful for the application.
    # * 
    # * @unit: 1,5 degree
    # * @category: Vehicle Information
    # * @revision: Description revised in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SteeringWheelAngleConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
SteeringWheelAngleConfidence.Constants = {
  MIN: 1,
  MAX: 127,
  OUT_OF_RANGE: 126,
  UNAVAILABLE: 127,
}

module.exports = SteeringWheelAngleConfidence;
