// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let VelocityPolarWithZ = require('./VelocityPolarWithZ.js');
let VelocityCartesian = require('./VelocityCartesian.js');

//-----------------------------------------------------------

class Velocity3dWithConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.choice = null;
      this.polar_velocity = null;
      this.cartesian_velocity = null;
    }
    else {
      if (initObj.hasOwnProperty('choice')) {
        this.choice = initObj.choice
      }
      else {
        this.choice = 0;
      }
      if (initObj.hasOwnProperty('polar_velocity')) {
        this.polar_velocity = initObj.polar_velocity
      }
      else {
        this.polar_velocity = new VelocityPolarWithZ();
      }
      if (initObj.hasOwnProperty('cartesian_velocity')) {
        this.cartesian_velocity = initObj.cartesian_velocity
      }
      else {
        this.cartesian_velocity = new VelocityCartesian();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Velocity3dWithConfidence
    // Serialize message field [choice]
    bufferOffset = _serializer.uint8(obj.choice, buffer, bufferOffset);
    // Serialize message field [polar_velocity]
    bufferOffset = VelocityPolarWithZ.serialize(obj.polar_velocity, buffer, bufferOffset);
    // Serialize message field [cartesian_velocity]
    bufferOffset = VelocityCartesian.serialize(obj.cartesian_velocity, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Velocity3dWithConfidence
    let len;
    let data = new Velocity3dWithConfidence(null);
    // Deserialize message field [choice]
    data.choice = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [polar_velocity]
    data.polar_velocity = VelocityPolarWithZ.deserialize(buffer, bufferOffset);
    // Deserialize message field [cartesian_velocity]
    data.cartesian_velocity = VelocityCartesian.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 21;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/Velocity3dWithConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd7e5678ea89c6350004e7c09a7fa06e4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Velocity3dWithConfidence::= CHOICE{
    #     polarVelocity          VelocityPolarWithZ, 
    #     cartesianVelocity      VelocityCartesian
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a velocity vector with associated confidence value.
    # *
    # * The following options are available:
    # * 
    # * @field polarVelocity: the representation of the velocity vector in a polar or cylindrical coordinate system. 
    # * 
    # * @field cartesianVelocity: the representation of the velocity vector in a cartesian coordinate system.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 choice
    
    VelocityPolarWithZ polar_velocity
    uint8 CHOICE_POLAR_VELOCITY = 0
    
    VelocityCartesian cartesian_velocity
    uint8 CHOICE_CARTESIAN_VELOCITY = 1
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/VelocityPolarWithZ
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityPolarWithZ::= SEQUENCE {
    #     velocityMagnitude    Speed, 
    #     velocityDirection    CartesianAngle,
    #     zVelocity            VelocityComponent OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a velocity vector in a polar or cylindrical coordinate system.
    # *
    # * It shall include the following components: 
    # * 
    # * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
    # * 
    # * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
    # *
    # * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    Speed velocity_magnitude
    
    CartesianAngle velocity_direction
    
    VelocityComponent z_velocity
    bool z_velocity_is_present
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/Speed
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Speed ::= SEQUENCE {
    #     speedValue         SpeedValue,
    #     speedConfidence    SpeedConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the speed and associated confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field speedValue: the speed value.
    # * 
    # * @field speedConfidence: the confidence value of the speed value.
    # *
    # * @category: Kinematic information
    # * @revision: V1.3.1
    # 
    
    SpeedValue speed_value
    
    SpeedConfidence speed_confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/SpeedValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SpeedValue ::= INTEGER {
    #     standstill  (0), 
    #     outOfRange  (16382), 
    #     unavailable (16383)
    # } (0..16383)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
    # *
    # * The value shall be set to:
    # * - `0` in a standstill situation.
    # * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
    # * - `16 382` for speed values greater than 163,81 m/s,
    # * - `16 383` if the speed accuracy information is not available.
    # * 
    # * @note: the definition of standstill is out of scope of the present document.
    # *
    # * @unit: 0,01 m/s
    # * @category: Kinematic information
    # * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 16383
    uint16 STANDSTILL = 0
    uint16 OUT_OF_RANGE = 16382
    uint16 UNAVAILABLE = 16383
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SpeedConfidence ::= INTEGER {
    #     outOfRange  (126), 
    #     unavailable (127)
    # } (1..127)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
    # * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
    # * - `127` if the confidence value information is not available.
    # *  
    # * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the speed value may be valid and used by the application.
    # * 
    # * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
    # * and therefore cannot be trusted. Such is not useful for the application.
    # *
    # * @unit: 0,01 m/s
    # * @category: Vehicle information
    # * @revision: Description revised in V2.1.1 
    # 
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngle
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngle ::= SEQUENCE {
    #     value         CartesianAngleValue,
    #     confidence    AngleConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
    # *
    # * It shall include the following components: 
    # *
    # * @field value: The angle value which can be estimated as the mean of the current distribution.
    # *
    # * @field confidence: The confidence value associated to the provided value.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    CartesianAngleValue value
    
    AngleConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngleValue ::= INTEGER {
    #     valueNotUsed (3600),
    #     unavailable  (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
    # * a right-hand local coordinate system from the abscissa.
    # *
    # * The value shall be set to: 
    # * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
    # * - `36001` if the accuracy information is not available.
    # *
    # * The value 3600 shall not be used. 
    # * 
    # * @unit 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 VALUE_NOT_USED = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/AngleConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AngleConfidence ::= INTEGER {
    #     outOfRange  (126),
    #     unavailable (127)   
    # } (1..127)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
    # * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
    # * - `127` if the accuracy information is not available.
    # *
    # * @unit: 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/VelocityComponent
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityComponent ::= SEQUENCE {
    #     value         VelocityComponentValue,
    #     confidence    SpeedConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a component of the velocity vector and the associated confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field value: the value of the component.
    # * 
    # * @field confidence: the confidence value of the value.
    # *
    # * @category: Kinematic information
    # * @revision: V2.1.1
    # 
    
    VelocityComponentValue value
    
    SpeedConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityComponentValue ::= INTEGER {
    #     negativeOutOfRange (-16383),
    #     positiveOutOfRange  (16382),
    #     unavailable        (16383)
    # } (-16383..16383)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the value of a velocity component in a defined coordinate system.
    # *
    # * The value shall be set to:
    # * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
    # * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
    # * - `16 382` for velocity values equal to or greater than 163,81 m/s,
    # * - `16 383` if the velocity information is not available.
    # * 
    # * @unit: 0,01 m/s
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -16383
    int16 MAX = 16383
    int16 NEGATIVE_OUT_OF_RANGE = -16383
    int16 POSITIVE_OUT_OF_RANGE = 16382
    int16 UNAVAILABLE = 16383
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/VelocityCartesian
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityCartesian::= SEQUENCE {
    #     xVelocity   VelocityComponent,
    #     yVelocity   VelocityComponent,
    #     zVelocity   VelocityComponent OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a velocity vector in a cartesian coordinate system.
    # 
    # * It shall include the following components: 
    # * 
    # * @field xVelocity: the x component of the velocity vector with the associated confidence value.
    # * 
    # * @field yVelocity: the y component of the velocity vector with the associated confidence value.
    # *
    # * @field zVelocity: the optional z component of the velocity vector with the associated confidence value.
    # * 
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    # 
    
    VelocityComponent x_velocity
    
    VelocityComponent y_velocity
    
    VelocityComponent z_velocity
    bool z_velocity_is_present
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Velocity3dWithConfidence(null);
    if (msg.choice !== undefined) {
      resolved.choice = msg.choice;
    }
    else {
      resolved.choice = 0
    }

    if (msg.polar_velocity !== undefined) {
      resolved.polar_velocity = VelocityPolarWithZ.Resolve(msg.polar_velocity)
    }
    else {
      resolved.polar_velocity = new VelocityPolarWithZ()
    }

    if (msg.cartesian_velocity !== undefined) {
      resolved.cartesian_velocity = VelocityCartesian.Resolve(msg.cartesian_velocity)
    }
    else {
      resolved.cartesian_velocity = new VelocityCartesian()
    }

    return resolved;
    }
};

// Constants for message
Velocity3dWithConfidence.Constants = {
  CHOICE_POLAR_VELOCITY: 0,
  CHOICE_CARTESIAN_VELOCITY: 1,
}

module.exports = Velocity3dWithConfidence;
