// Auto-generated. Do not edit!

// (in-package etsi_its_cpm_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let VelocityComponentValue = require('./VelocityComponentValue.js');
let SpeedConfidence = require('./SpeedConfidence.js');

//-----------------------------------------------------------

class VelocityComponent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = new VelocityComponentValue();
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = new SpeedConfidence();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VelocityComponent
    // Serialize message field [value]
    bufferOffset = VelocityComponentValue.serialize(obj.value, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = SpeedConfidence.serialize(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VelocityComponent
    let len;
    let data = new VelocityComponent(null);
    // Deserialize message field [value]
    data.value = VelocityComponentValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = SpeedConfidence.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cpm_ts_msgs/VelocityComponent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f93e6a7825fcaaa750b2fda47935d04c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityComponent ::= SEQUENCE {
    #     value         VelocityComponentValue,
    #     confidence    SpeedConfidence
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a component of the velocity vector and the associated confidence value.
    # *
    # * It shall include the following components: 
    # * 
    # * @field value: the value of the component.
    # * 
    # * @field confidence: the confidence value of the value.
    # *
    # * @category: Kinematic information
    # * @revision: V2.1.1
    # 
    
    VelocityComponentValue value
    
    SpeedConfidence confidence
    
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VelocityComponentValue ::= INTEGER {
    #     negativeOutOfRange (-16383),
    #     positiveOutOfRange  (16382),
    #     unavailable        (16383)
    # } (-16383..16383)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the value of a velocity component in a defined coordinate system.
    # *
    # * The value shall be set to:
    # * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
    # * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
    # * - `16 382` for velocity values equal to or greater than 163,81 m/s,
    # * - `16 383` if the velocity information is not available.
    # * 
    # * @unit: 0,01 m/s
    # * @category: Kinematic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -16383
    int16 MAX = 16383
    int16 NEGATIVE_OUT_OF_RANGE = -16383
    int16 POSITIVE_OUT_OF_RANGE = 16382
    int16 UNAVAILABLE = 16383
    
    ================================================================================
    MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SpeedConfidence ::= INTEGER {
    #     outOfRange  (126), 
    #     unavailable (127)
    # } (1..127)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
    # * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
    # * - `127` if the confidence value information is not available.
    # *  
    # * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the speed value may be valid and used by the application.
    # * 
    # * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
    # * and therefore cannot be trusted. Such is not useful for the application.
    # *
    # * @unit: 0,01 m/s
    # * @category: Vehicle information
    # * @revision: Description revised in V2.1.1 
    # 
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 127
    uint8 OUT_OF_RANGE = 126
    uint8 UNAVAILABLE = 127
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VelocityComponent(null);
    if (msg.value !== undefined) {
      resolved.value = VelocityComponentValue.Resolve(msg.value)
    }
    else {
      resolved.value = new VelocityComponentValue()
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = SpeedConfidence.Resolve(msg.confidence)
    }
    else {
      resolved.confidence = new SpeedConfidence()
    }

    return resolved;
    }
};

module.exports = VelocityComponent;
