
"use strict";

let AngularAccelerationConfidence = require('./AngularAccelerationConfidence.js');
let HumanPresenceOnTheRoadSubCauseCode = require('./HumanPresenceOnTheRoadSubCauseCode.js');
let PathHistory = require('./PathHistory.js');
let MessageRateHz = require('./MessageRateHz.js');
let VehicleHeight = require('./VehicleHeight.js');
let PerceivedObjectIds = require('./PerceivedObjectIds.js');
let PerceivedObject = require('./PerceivedObject.js');
let Temperature = require('./Temperature.js');
let PosPillar = require('./PosPillar.js');
let VarLengthNumber = require('./VarLengthNumber.js');
let LateralAcceleration = require('./LateralAcceleration.js');
let ExteriorLights = require('./ExteriorLights.js');
let Curvature = require('./Curvature.js');
let OtherSubClass = require('./OtherSubClass.js');
let DeltaTimeTenthOfSecond = require('./DeltaTimeTenthOfSecond.js');
let SafeDistanceIndication = require('./SafeDistanceIndication.js');
let LowerTriangularPositiveSemidefiniteMatrix = require('./LowerTriangularPositiveSemidefiniteMatrix.js');
let EmergencyVehicleApproachingSubCauseCode = require('./EmergencyVehicleApproachingSubCauseCode.js');
let LateralAccelerationValue = require('./LateralAccelerationValue.js');
let AngleConfidence = require('./AngleConfidence.js');
let TrafficIslandPosition = require('./TrafficIslandPosition.js');
let RequestResponseIndication = require('./RequestResponseIndication.js');
let YawRate = require('./YawRate.js');
let EuVehicleCategoryM = require('./EuVehicleCategoryM.js');
let TurningDirection = require('./TurningDirection.js');
let GeneralizedLanePosition = require('./GeneralizedLanePosition.js');
let LongitudinalLanePositionValue = require('./LongitudinalLanePositionValue.js');
let PerformanceClass = require('./PerformanceClass.js');
let DeltaLongitude = require('./DeltaLongitude.js');
let WrappedCpmContainers = require('./WrappedCpmContainers.js');
let ClosedLanes = require('./ClosedLanes.js');
let SpeedValue = require('./SpeedValue.js');
let StandardLength12b = require('./StandardLength12b.js');
let InterferenceManagementZones = require('./InterferenceManagementZones.js');
let SafeDistanceIndicator = require('./SafeDistanceIndicator.js');
let Acceleration3dWithConfidence = require('./Acceleration3dWithConfidence.js');
let TrafficParticipantType = require('./TrafficParticipantType.js');
let CoordinateConfidence = require('./CoordinateConfidence.js');
let EmbarkationStatus = require('./EmbarkationStatus.js');
let ObjectFace = require('./ObjectFace.js');
let SteeringWheelAngleValue = require('./SteeringWheelAngleValue.js');
let WheelBaseVehicle = require('./WheelBaseVehicle.js');
let Traces = require('./Traces.js');
let VelocityComponentValue = require('./VelocityComponentValue.js');
let PathDeltaTime = require('./PathDeltaTime.js');
let RoadworksSubCauseCode = require('./RoadworksSubCauseCode.js');
let EulerAnglesWithConfidence = require('./EulerAnglesWithConfidence.js');
let VruSizeClass = require('./VruSizeClass.js');
let VehicleIdentification = require('./VehicleIdentification.js');
let CartesianAngularVelocityComponentValue = require('./CartesianAngularVelocityComponentValue.js');
let ItsPduHeader = require('./ItsPduHeader.js');
let ClusterBreakupInfo = require('./ClusterBreakupInfo.js');
let ReferencePosition = require('./ReferencePosition.js');
let EmergencyPriority = require('./EmergencyPriority.js');
let MitigationForTechnologies = require('./MitigationForTechnologies.js');
let TrailerPresenceInformation = require('./TrailerPresenceInformation.js');
let AccelerationMagnitude = require('./AccelerationMagnitude.js');
let TrafficDirection = require('./TrafficDirection.js');
let ProtectedZoneId = require('./ProtectedZoneId.js');
let CartesianAngularAccelerationComponentValue = require('./CartesianAngularAccelerationComponentValue.js');
let Altitude = require('./Altitude.js');
let PosLonCarr = require('./PosLonCarr.js');
let EllipticalShape = require('./EllipticalShape.js');
let RescueAndRecoveryWorkInProgressSubCauseCode = require('./RescueAndRecoveryWorkInProgressSubCauseCode.js');
let VruClusterProfiles = require('./VruClusterProfiles.js');
let RadialShapesList = require('./RadialShapesList.js');
let Heading = require('./Heading.js');
let PhoneNumber = require('./PhoneNumber.js');
let LaneType = require('./LaneType.js');
let SemiAxisLength = require('./SemiAxisLength.js');
let TrailerDataSet = require('./TrailerDataSet.js');
let Ext3 = require('./Ext3.js');
let BasicContainer = require('./BasicContainer.js');
let AirHumidity = require('./AirHumidity.js');
let CartesianAngularVelocityComponent = require('./CartesianAngularVelocityComponent.js');
let DangerousGoodsExtended = require('./DangerousGoodsExtended.js');
let TrajectoryInterceptionProbability = require('./TrajectoryInterceptionProbability.js');
let PositionConfidenceEllipse = require('./PositionConfidenceEllipse.js');
let AccelerationMagnitudeValue = require('./AccelerationMagnitudeValue.js');
let DigitalMap = require('./DigitalMap.js');
let PrecipitationIntensity = require('./PrecipitationIntensity.js');
let PerceivedObjectContainer = require('./PerceivedObjectContainer.js');
let AccidentSubCauseCode = require('./AccidentSubCauseCode.js');
let InterferenceManagementZone = require('./InterferenceManagementZone.js');
let LongitudinalLanePositionConfidence = require('./LongitudinalLanePositionConfidence.js');
let SlowVehicleSubCauseCode = require('./SlowVehicleSubCauseCode.js');
let StabilityChangeIndication = require('./StabilityChangeIndication.js');
let PositionOfPillars = require('./PositionOfPillars.js');
let EuVehicleCategoryO = require('./EuVehicleCategoryO.js');
let TrajectoryInterceptionIndication = require('./TrajectoryInterceptionIndication.js');
let HazardousLocationObstacleOnTheRoadSubCauseCode = require('./HazardousLocationObstacleOnTheRoadSubCauseCode.js');
let PathPoint = require('./PathPoint.js');
let AccelerationControl = require('./AccelerationControl.js');
let RectangularShape = require('./RectangularShape.js');
let ConstraintWrappedCpmContainers = require('./ConstraintWrappedCpmContainers.js');
let TurningRadius = require('./TurningRadius.js');
let DeltaAltitude = require('./DeltaAltitude.js');
let TrafficConditionSubCauseCode = require('./TrafficConditionSubCauseCode.js');
let PosFrontAx = require('./PosFrontAx.js');
let NumberOfOccupants = require('./NumberOfOccupants.js');
let ObjectDimension = require('./ObjectDimension.js');
let WrappedCpmContainer = require('./WrappedCpmContainer.js');
let CauseCodeChoice = require('./CauseCodeChoice.js');
let CartesianCoordinate = require('./CartesianCoordinate.js');
let LowerTriangularPositiveSemidefiniteMatrixColumns = require('./LowerTriangularPositiveSemidefiniteMatrixColumns.js');
let MapPosition = require('./MapPosition.js');
let AccelerationCartesian = require('./AccelerationCartesian.js');
let HumanProblemSubCauseCode = require('./HumanProblemSubCauseCode.js');
let SensorInformation = require('./SensorInformation.js');
let AdverseWeatherConditionPrecipitationSubCauseCode = require('./AdverseWeatherConditionPrecipitationSubCauseCode.js');
let ObjectDimensionValue = require('./ObjectDimensionValue.js');
let DangerousSituationSubCauseCode = require('./DangerousSituationSubCauseCode.js');
let CartesianCoordinateSmall = require('./CartesianCoordinateSmall.js');
let StationId = require('./StationId.js');
let CorrelationCellValue = require('./CorrelationCellValue.js');
let PerceivedObjects = require('./PerceivedObjects.js');
let VruEnvironment = require('./VruEnvironment.js');
let VruSubProfileBicyclist = require('./VruSubProfileBicyclist.js');
let ClusterBreakupReason = require('./ClusterBreakupReason.js');
let CurvatureConfidence = require('./CurvatureConfidence.js');
let VehicleBreakdownSubCauseCode = require('./VehicleBreakdownSubCauseCode.js');
let AltitudeConfidence = require('./AltitudeConfidence.js');
let PolygonalShape = require('./PolygonalShape.js');
let CardinalNumber1B = require('./CardinalNumber1B.js');
let ReferencePositionWithConfidence = require('./ReferencePositionWithConfidence.js');
let StandardLength1B = require('./StandardLength1B.js');
let ActionIdList = require('./ActionIdList.js');
let VehicleLengthValue = require('./VehicleLengthValue.js');
let RadialShapeDetails = require('./RadialShapeDetails.js');
let PtActivation = require('./PtActivation.js');
let EuVehicleCategoryN = require('./EuVehicleCategoryN.js');
let InterferenceManagementInfoPerChannel = require('./InterferenceManagementInfoPerChannel.js');
let StationType = require('./StationType.js');
let Identifier2B = require('./Identifier2B.js');
let ObjectDimensionConfidence = require('./ObjectDimensionConfidence.js');
let VruSubProfileAnimal = require('./VruSubProfileAnimal.js');
let ObjectPerceptionQuality = require('./ObjectPerceptionQuality.js');
let CurvatureCalculationMode = require('./CurvatureCalculationMode.js');
let VerticalAccelerationValue = require('./VerticalAccelerationValue.js');
let AccelerationComponent = require('./AccelerationComponent.js');
let InterferenceManagementChannel = require('./InterferenceManagementChannel.js');
let PositioningSolutionType = require('./PositioningSolutionType.js');
let CartesianCoordinateLarge = require('./CartesianCoordinateLarge.js');
let CartesianPosition3d = require('./CartesianPosition3d.js');
let PtActivationData = require('./PtActivationData.js');
let TimestampIts = require('./TimestampIts.js');
let HazardousLocationDangerousCurveSubCauseCode = require('./HazardousLocationDangerousCurveSubCauseCode.js');
let ManagementContainer = require('./ManagementContainer.js');
let DeltaTimeQuarterSecond = require('./DeltaTimeQuarterSecond.js');
let ItineraryPath = require('./ItineraryPath.js');
let Shape = require('./Shape.js');
let Ext1 = require('./Ext1.js');
let PerceptionRegionContainer = require('./PerceptionRegionContainer.js');
let MitigationPerTechnologyClass = require('./MitigationPerTechnologyClass.js');
let TransmissionInterval = require('./TransmissionInterval.js');
let OriginatingRsuContainer = require('./OriginatingRsuContainer.js');
let ActionId = require('./ActionId.js');
let VelocityCartesian = require('./VelocityCartesian.js');
let VehicleMass = require('./VehicleMass.js');
let HeadingChangeIndication = require('./HeadingChangeIndication.js');
let VruSubProfileMotorcyclist = require('./VruSubProfileMotorcyclist.js');
let ObjectClassWithConfidence = require('./ObjectClassWithConfidence.js');
let AdverseWeatherConditionExtremeWeatherConditionSubCauseCode = require('./AdverseWeatherConditionExtremeWeatherConditionSubCauseCode.js');
let Path = require('./Path.js');
let Wgs84AngleConfidence = require('./Wgs84AngleConfidence.js');
let VehicleLengthV2 = require('./VehicleLengthV2.js');
let AltitudeValue = require('./AltitudeValue.js');
let SequenceOfCartesianPosition3d = require('./SequenceOfCartesianPosition3d.js');
let LanePosition = require('./LanePosition.js');
let StabilityLossProbability = require('./StabilityLossProbability.js');
let LongitudinalLanePosition = require('./LongitudinalLanePosition.js');
let HazardousLocationSurfaceConditionSubCauseCode = require('./HazardousLocationSurfaceConditionSubCauseCode.js');
let ObjectClass = require('./ObjectClass.js');
let SensorInformationContainer = require('./SensorInformationContainer.js');
let AccelerationChange = require('./AccelerationChange.js');
let CollisionRiskSubCauseCode = require('./CollisionRiskSubCauseCode.js');
let PtActivationType = require('./PtActivationType.js');
let MessageSegmentationInfo = require('./MessageSegmentationInfo.js');
let CardinalNumber3b = require('./CardinalNumber3b.js');
let Ext2 = require('./Ext2.js');
let ConfidenceLevel = require('./ConfidenceLevel.js');
let CurvatureValue = require('./CurvatureValue.js');
let HeadingConfidence = require('./HeadingConfidence.js');
let LaneWidth = require('./LaneWidth.js');
let CartesianPosition3dWithConfidence = require('./CartesianPosition3dWithConfidence.js');
let RelevanceDistance = require('./RelevanceDistance.js');
let MapReference = require('./MapReference.js');
let PostCrashSubCauseCode = require('./PostCrashSubCauseCode.js');
let StandardLength3b = require('./StandardLength3b.js');
let TrailerData = require('./TrailerData.js');
let LightBarSirenInUse = require('./LightBarSirenInUse.js');
let CauseCodeV2 = require('./CauseCodeV2.js');
let WMInumber = require('./WMInumber.js');
let PathPredicted = require('./PathPredicted.js');
let YawRateValue = require('./YawRateValue.js');
let VerticalAcceleration = require('./VerticalAcceleration.js');
let VruClusterInformation = require('./VruClusterInformation.js');
let AccelerationConfidence = require('./AccelerationConfidence.js');
let VehicleLength = require('./VehicleLength.js');
let AccelerationChangeIndication = require('./AccelerationChangeIndication.js');
let VruDeviceUsage = require('./VruDeviceUsage.js');
let PerceptionRegion = require('./PerceptionRegion.js');
let ClusterLeaveReason = require('./ClusterLeaveReason.js');
let ProtectedZoneRadius = require('./ProtectedZoneRadius.js');
let AxlesCount = require('./AxlesCount.js');
let EuVehicleCategoryL = require('./EuVehicleCategoryL.js');
let HazardousLocationAnimalOnTheRoadSubCauseCode = require('./HazardousLocationAnimalOnTheRoadSubCauseCode.js');
let DangerousGoodsBasic = require('./DangerousGoodsBasic.js');
let StationaryVehicleSubCauseCode = require('./StationaryVehicleSubCauseCode.js');
let CartesianAngle = require('./CartesianAngle.js');
let VehicleRole = require('./VehicleRole.js');
let EuVehicleCategoryCode = require('./EuVehicleCategoryCode.js');
let CorrelationColumn = require('./CorrelationColumn.js');
let VelocityPolarWithZ = require('./VelocityPolarWithZ.js');
let DeltaTimeMilliSecondPositive = require('./DeltaTimeMilliSecondPositive.js');
let MessageId = require('./MessageId.js');
let HeadingValue = require('./HeadingValue.js');
let AccelerationValue = require('./AccelerationValue.js');
let CenDsrcTollingZoneID = require('./CenDsrcTollingZoneID.js');
let OrdinalNumber3b = require('./OrdinalNumber3b.js');
let CircularShape = require('./CircularShape.js');
let VruSubProfilePedestrian = require('./VruSubProfilePedestrian.js');
let VruSpecificExteriorLights = require('./VruSpecificExteriorLights.js');
let ClusterLeaveInfo = require('./ClusterLeaveInfo.js');
let Direction = require('./Direction.js');
let EventPoint = require('./EventPoint.js');
let DrivingLaneStatus = require('./DrivingLaneStatus.js');
let SignalViolationSubCauseCode = require('./SignalViolationSubCauseCode.js');
let CauseCode = require('./CauseCode.js');
let CauseCodeType = require('./CauseCodeType.js');
let Velocity3dWithConfidence = require('./Velocity3dWithConfidence.js');
let MatrixIncludedComponents = require('./MatrixIncludedComponents.js');
let MessageRateRange = require('./MessageRateRange.js');
let InterferenceManagementZoneDefinition = require('./InterferenceManagementZoneDefinition.js');
let ProtectedZoneType = require('./ProtectedZoneType.js');
let VruProfileAndSubprofile = require('./VruProfileAndSubprofile.js');
let RestrictedTypes = require('./RestrictedTypes.js');
let InterferenceManagementZoneType = require('./InterferenceManagementZoneType.js');
let SequenceOfSafeDistanceIndication = require('./SequenceOfSafeDistanceIndication.js');
let TrajectoryInterceptionConfidence = require('./TrajectoryInterceptionConfidence.js');
let TrafficRule = require('./TrafficRule.js');
let Wgs84AngleValue = require('./Wgs84AngleValue.js');
let RelevanceTrafficDirection = require('./RelevanceTrafficDirection.js');
let AccelerationPolarWithZ = require('./AccelerationPolarWithZ.js');
let StationarySince = require('./StationarySince.js');
let SpeedConfidence = require('./SpeedConfidence.js');
let VehicleLengthConfidenceIndication = require('./VehicleLengthConfidenceIndication.js');
let VehicleWidth = require('./VehicleWidth.js');
let ProtectedCommunicationZonesRSU = require('./ProtectedCommunicationZonesRSU.js');
let AccessTechnologyClass = require('./AccessTechnologyClass.js');
let GenerationDeltaTime = require('./GenerationDeltaTime.js');
let SubCauseCodeType = require('./SubCauseCodeType.js');
let VelocityComponent = require('./VelocityComponent.js');
let BarometricPressure = require('./BarometricPressure.js');
let AdverseWeatherConditionAdhesionSubCauseCode = require('./AdverseWeatherConditionAdhesionSubCauseCode.js');
let CartesianAngleValue = require('./CartesianAngleValue.js');
let AdverseWeatherConditionVisibilitySubCauseCode = require('./AdverseWeatherConditionVisibilitySubCauseCode.js');
let CpmPayload = require('./CpmPayload.js');
let Iso3833VehicleType = require('./Iso3833VehicleType.js');
let RadialShape = require('./RadialShape.js');
let SequenceOfTrajectoryInterceptionIndication = require('./SequenceOfTrajectoryInterceptionIndication.js');
let PathPointPredicted = require('./PathPointPredicted.js');
let WrongWayDrivingSubCauseCode = require('./WrongWayDrivingSubCauseCode.js');
let PosCentMass = require('./PosCentMass.js');
let HeightLonCarr = require('./HeightLonCarr.js');
let VDS = require('./VDS.js');
let OpeningDaysHours = require('./OpeningDaysHours.js');
let CpmContainers = require('./CpmContainers.js');
let VruExteriorLights = require('./VruExteriorLights.js');
let DeltaTimeMilliSecondSigned = require('./DeltaTimeMilliSecondSigned.js');
let Wgs84Angle = require('./Wgs84Angle.js');
let SteeringWheelAngle = require('./SteeringWheelAngle.js');
let DeltaTimeSecond = require('./DeltaTimeSecond.js');
let RoadSegmentReferenceId = require('./RoadSegmentReferenceId.js');
let AngularSpeedConfidence = require('./AngularSpeedConfidence.js');
let EventHistory = require('./EventHistory.js');
let CenDsrcTollingZone = require('./CenDsrcTollingZone.js');
let EventZone = require('./EventZone.js');
let ObjectClassDescription = require('./ObjectClassDescription.js');
let DriveDirection = require('./DriveDirection.js');
let ProtectedCommunicationZone = require('./ProtectedCommunicationZone.js');
let SpecialTransportType = require('./SpecialTransportType.js');
let Latitude = require('./Latitude.js');
let SpeedLimit = require('./SpeedLimit.js');
let DeltaReferencePosition = require('./DeltaReferencePosition.js');
let CartesianAngularAccelerationComponent = require('./CartesianAngularAccelerationComponent.js');
let RadialShapes = require('./RadialShapes.js');
let BogiesCount = require('./BogiesCount.js');
let Longitude = require('./Longitude.js');
let ClusterJoinInfo = require('./ClusterJoinInfo.js');
let InterferenceManagementInfo = require('./InterferenceManagementInfo.js');
let VruMovementControl = require('./VruMovementControl.js');
let LongitudinalAcceleration = require('./LongitudinalAcceleration.js');
let SensorType = require('./SensorType.js');
let OrdinalNumber1B = require('./OrdinalNumber1B.js');
let SequenceOfIdentifier1B = require('./SequenceOfIdentifier1B.js');
let IntersectionReferenceId = require('./IntersectionReferenceId.js');
let LongitudinalAccelerationValue = require('./LongitudinalAccelerationValue.js');
let DeltaLatitude = require('./DeltaLatitude.js');
let RoadType = require('./RoadType.js');
let CartesianCoordinateWithConfidence = require('./CartesianCoordinateWithConfidence.js');
let PosConfidenceEllipse = require('./PosConfidenceEllipse.js');
let OriginatingVehicleContainer = require('./OriginatingVehicleContainer.js');
let LowerTriangularPositiveSemidefiniteMatrices = require('./LowerTriangularPositiveSemidefiniteMatrices.js');
let HardShoulderStatus = require('./HardShoulderStatus.js');
let EnergyStorageType = require('./EnergyStorageType.js');
let CollectivePerceptionMessage = require('./CollectivePerceptionMessage.js');
let Identifier1B = require('./Identifier1B.js');
let Speed = require('./Speed.js');
let PositionOfOccupants = require('./PositionOfOccupants.js');
let DangerousEndOfQueueSubCauseCode = require('./DangerousEndOfQueueSubCauseCode.js');
let ValidityDuration = require('./ValidityDuration.js');
let SteeringWheelAngleConfidence = require('./SteeringWheelAngleConfidence.js');
let RailwayLevelCrossingSubCauseCode = require('./RailwayLevelCrossingSubCauseCode.js');
let StandardLength9b = require('./StandardLength9b.js');
let YawRateConfidence = require('./YawRateConfidence.js');
let LanePositionAndType = require('./LanePositionAndType.js');
let CpmContainerId = require('./CpmContainerId.js');
let StandardLength2B = require('./StandardLength2B.js');
let SequenceNumber = require('./SequenceNumber.js');
let InformationQuality = require('./InformationQuality.js');

module.exports = {
  AngularAccelerationConfidence: AngularAccelerationConfidence,
  HumanPresenceOnTheRoadSubCauseCode: HumanPresenceOnTheRoadSubCauseCode,
  PathHistory: PathHistory,
  MessageRateHz: MessageRateHz,
  VehicleHeight: VehicleHeight,
  PerceivedObjectIds: PerceivedObjectIds,
  PerceivedObject: PerceivedObject,
  Temperature: Temperature,
  PosPillar: PosPillar,
  VarLengthNumber: VarLengthNumber,
  LateralAcceleration: LateralAcceleration,
  ExteriorLights: ExteriorLights,
  Curvature: Curvature,
  OtherSubClass: OtherSubClass,
  DeltaTimeTenthOfSecond: DeltaTimeTenthOfSecond,
  SafeDistanceIndication: SafeDistanceIndication,
  LowerTriangularPositiveSemidefiniteMatrix: LowerTriangularPositiveSemidefiniteMatrix,
  EmergencyVehicleApproachingSubCauseCode: EmergencyVehicleApproachingSubCauseCode,
  LateralAccelerationValue: LateralAccelerationValue,
  AngleConfidence: AngleConfidence,
  TrafficIslandPosition: TrafficIslandPosition,
  RequestResponseIndication: RequestResponseIndication,
  YawRate: YawRate,
  EuVehicleCategoryM: EuVehicleCategoryM,
  TurningDirection: TurningDirection,
  GeneralizedLanePosition: GeneralizedLanePosition,
  LongitudinalLanePositionValue: LongitudinalLanePositionValue,
  PerformanceClass: PerformanceClass,
  DeltaLongitude: DeltaLongitude,
  WrappedCpmContainers: WrappedCpmContainers,
  ClosedLanes: ClosedLanes,
  SpeedValue: SpeedValue,
  StandardLength12b: StandardLength12b,
  InterferenceManagementZones: InterferenceManagementZones,
  SafeDistanceIndicator: SafeDistanceIndicator,
  Acceleration3dWithConfidence: Acceleration3dWithConfidence,
  TrafficParticipantType: TrafficParticipantType,
  CoordinateConfidence: CoordinateConfidence,
  EmbarkationStatus: EmbarkationStatus,
  ObjectFace: ObjectFace,
  SteeringWheelAngleValue: SteeringWheelAngleValue,
  WheelBaseVehicle: WheelBaseVehicle,
  Traces: Traces,
  VelocityComponentValue: VelocityComponentValue,
  PathDeltaTime: PathDeltaTime,
  RoadworksSubCauseCode: RoadworksSubCauseCode,
  EulerAnglesWithConfidence: EulerAnglesWithConfidence,
  VruSizeClass: VruSizeClass,
  VehicleIdentification: VehicleIdentification,
  CartesianAngularVelocityComponentValue: CartesianAngularVelocityComponentValue,
  ItsPduHeader: ItsPduHeader,
  ClusterBreakupInfo: ClusterBreakupInfo,
  ReferencePosition: ReferencePosition,
  EmergencyPriority: EmergencyPriority,
  MitigationForTechnologies: MitigationForTechnologies,
  TrailerPresenceInformation: TrailerPresenceInformation,
  AccelerationMagnitude: AccelerationMagnitude,
  TrafficDirection: TrafficDirection,
  ProtectedZoneId: ProtectedZoneId,
  CartesianAngularAccelerationComponentValue: CartesianAngularAccelerationComponentValue,
  Altitude: Altitude,
  PosLonCarr: PosLonCarr,
  EllipticalShape: EllipticalShape,
  RescueAndRecoveryWorkInProgressSubCauseCode: RescueAndRecoveryWorkInProgressSubCauseCode,
  VruClusterProfiles: VruClusterProfiles,
  RadialShapesList: RadialShapesList,
  Heading: Heading,
  PhoneNumber: PhoneNumber,
  LaneType: LaneType,
  SemiAxisLength: SemiAxisLength,
  TrailerDataSet: TrailerDataSet,
  Ext3: Ext3,
  BasicContainer: BasicContainer,
  AirHumidity: AirHumidity,
  CartesianAngularVelocityComponent: CartesianAngularVelocityComponent,
  DangerousGoodsExtended: DangerousGoodsExtended,
  TrajectoryInterceptionProbability: TrajectoryInterceptionProbability,
  PositionConfidenceEllipse: PositionConfidenceEllipse,
  AccelerationMagnitudeValue: AccelerationMagnitudeValue,
  DigitalMap: DigitalMap,
  PrecipitationIntensity: PrecipitationIntensity,
  PerceivedObjectContainer: PerceivedObjectContainer,
  AccidentSubCauseCode: AccidentSubCauseCode,
  InterferenceManagementZone: InterferenceManagementZone,
  LongitudinalLanePositionConfidence: LongitudinalLanePositionConfidence,
  SlowVehicleSubCauseCode: SlowVehicleSubCauseCode,
  StabilityChangeIndication: StabilityChangeIndication,
  PositionOfPillars: PositionOfPillars,
  EuVehicleCategoryO: EuVehicleCategoryO,
  TrajectoryInterceptionIndication: TrajectoryInterceptionIndication,
  HazardousLocationObstacleOnTheRoadSubCauseCode: HazardousLocationObstacleOnTheRoadSubCauseCode,
  PathPoint: PathPoint,
  AccelerationControl: AccelerationControl,
  RectangularShape: RectangularShape,
  ConstraintWrappedCpmContainers: ConstraintWrappedCpmContainers,
  TurningRadius: TurningRadius,
  DeltaAltitude: DeltaAltitude,
  TrafficConditionSubCauseCode: TrafficConditionSubCauseCode,
  PosFrontAx: PosFrontAx,
  NumberOfOccupants: NumberOfOccupants,
  ObjectDimension: ObjectDimension,
  WrappedCpmContainer: WrappedCpmContainer,
  CauseCodeChoice: CauseCodeChoice,
  CartesianCoordinate: CartesianCoordinate,
  LowerTriangularPositiveSemidefiniteMatrixColumns: LowerTriangularPositiveSemidefiniteMatrixColumns,
  MapPosition: MapPosition,
  AccelerationCartesian: AccelerationCartesian,
  HumanProblemSubCauseCode: HumanProblemSubCauseCode,
  SensorInformation: SensorInformation,
  AdverseWeatherConditionPrecipitationSubCauseCode: AdverseWeatherConditionPrecipitationSubCauseCode,
  ObjectDimensionValue: ObjectDimensionValue,
  DangerousSituationSubCauseCode: DangerousSituationSubCauseCode,
  CartesianCoordinateSmall: CartesianCoordinateSmall,
  StationId: StationId,
  CorrelationCellValue: CorrelationCellValue,
  PerceivedObjects: PerceivedObjects,
  VruEnvironment: VruEnvironment,
  VruSubProfileBicyclist: VruSubProfileBicyclist,
  ClusterBreakupReason: ClusterBreakupReason,
  CurvatureConfidence: CurvatureConfidence,
  VehicleBreakdownSubCauseCode: VehicleBreakdownSubCauseCode,
  AltitudeConfidence: AltitudeConfidence,
  PolygonalShape: PolygonalShape,
  CardinalNumber1B: CardinalNumber1B,
  ReferencePositionWithConfidence: ReferencePositionWithConfidence,
  StandardLength1B: StandardLength1B,
  ActionIdList: ActionIdList,
  VehicleLengthValue: VehicleLengthValue,
  RadialShapeDetails: RadialShapeDetails,
  PtActivation: PtActivation,
  EuVehicleCategoryN: EuVehicleCategoryN,
  InterferenceManagementInfoPerChannel: InterferenceManagementInfoPerChannel,
  StationType: StationType,
  Identifier2B: Identifier2B,
  ObjectDimensionConfidence: ObjectDimensionConfidence,
  VruSubProfileAnimal: VruSubProfileAnimal,
  ObjectPerceptionQuality: ObjectPerceptionQuality,
  CurvatureCalculationMode: CurvatureCalculationMode,
  VerticalAccelerationValue: VerticalAccelerationValue,
  AccelerationComponent: AccelerationComponent,
  InterferenceManagementChannel: InterferenceManagementChannel,
  PositioningSolutionType: PositioningSolutionType,
  CartesianCoordinateLarge: CartesianCoordinateLarge,
  CartesianPosition3d: CartesianPosition3d,
  PtActivationData: PtActivationData,
  TimestampIts: TimestampIts,
  HazardousLocationDangerousCurveSubCauseCode: HazardousLocationDangerousCurveSubCauseCode,
  ManagementContainer: ManagementContainer,
  DeltaTimeQuarterSecond: DeltaTimeQuarterSecond,
  ItineraryPath: ItineraryPath,
  Shape: Shape,
  Ext1: Ext1,
  PerceptionRegionContainer: PerceptionRegionContainer,
  MitigationPerTechnologyClass: MitigationPerTechnologyClass,
  TransmissionInterval: TransmissionInterval,
  OriginatingRsuContainer: OriginatingRsuContainer,
  ActionId: ActionId,
  VelocityCartesian: VelocityCartesian,
  VehicleMass: VehicleMass,
  HeadingChangeIndication: HeadingChangeIndication,
  VruSubProfileMotorcyclist: VruSubProfileMotorcyclist,
  ObjectClassWithConfidence: ObjectClassWithConfidence,
  AdverseWeatherConditionExtremeWeatherConditionSubCauseCode: AdverseWeatherConditionExtremeWeatherConditionSubCauseCode,
  Path: Path,
  Wgs84AngleConfidence: Wgs84AngleConfidence,
  VehicleLengthV2: VehicleLengthV2,
  AltitudeValue: AltitudeValue,
  SequenceOfCartesianPosition3d: SequenceOfCartesianPosition3d,
  LanePosition: LanePosition,
  StabilityLossProbability: StabilityLossProbability,
  LongitudinalLanePosition: LongitudinalLanePosition,
  HazardousLocationSurfaceConditionSubCauseCode: HazardousLocationSurfaceConditionSubCauseCode,
  ObjectClass: ObjectClass,
  SensorInformationContainer: SensorInformationContainer,
  AccelerationChange: AccelerationChange,
  CollisionRiskSubCauseCode: CollisionRiskSubCauseCode,
  PtActivationType: PtActivationType,
  MessageSegmentationInfo: MessageSegmentationInfo,
  CardinalNumber3b: CardinalNumber3b,
  Ext2: Ext2,
  ConfidenceLevel: ConfidenceLevel,
  CurvatureValue: CurvatureValue,
  HeadingConfidence: HeadingConfidence,
  LaneWidth: LaneWidth,
  CartesianPosition3dWithConfidence: CartesianPosition3dWithConfidence,
  RelevanceDistance: RelevanceDistance,
  MapReference: MapReference,
  PostCrashSubCauseCode: PostCrashSubCauseCode,
  StandardLength3b: StandardLength3b,
  TrailerData: TrailerData,
  LightBarSirenInUse: LightBarSirenInUse,
  CauseCodeV2: CauseCodeV2,
  WMInumber: WMInumber,
  PathPredicted: PathPredicted,
  YawRateValue: YawRateValue,
  VerticalAcceleration: VerticalAcceleration,
  VruClusterInformation: VruClusterInformation,
  AccelerationConfidence: AccelerationConfidence,
  VehicleLength: VehicleLength,
  AccelerationChangeIndication: AccelerationChangeIndication,
  VruDeviceUsage: VruDeviceUsage,
  PerceptionRegion: PerceptionRegion,
  ClusterLeaveReason: ClusterLeaveReason,
  ProtectedZoneRadius: ProtectedZoneRadius,
  AxlesCount: AxlesCount,
  EuVehicleCategoryL: EuVehicleCategoryL,
  HazardousLocationAnimalOnTheRoadSubCauseCode: HazardousLocationAnimalOnTheRoadSubCauseCode,
  DangerousGoodsBasic: DangerousGoodsBasic,
  StationaryVehicleSubCauseCode: StationaryVehicleSubCauseCode,
  CartesianAngle: CartesianAngle,
  VehicleRole: VehicleRole,
  EuVehicleCategoryCode: EuVehicleCategoryCode,
  CorrelationColumn: CorrelationColumn,
  VelocityPolarWithZ: VelocityPolarWithZ,
  DeltaTimeMilliSecondPositive: DeltaTimeMilliSecondPositive,
  MessageId: MessageId,
  HeadingValue: HeadingValue,
  AccelerationValue: AccelerationValue,
  CenDsrcTollingZoneID: CenDsrcTollingZoneID,
  OrdinalNumber3b: OrdinalNumber3b,
  CircularShape: CircularShape,
  VruSubProfilePedestrian: VruSubProfilePedestrian,
  VruSpecificExteriorLights: VruSpecificExteriorLights,
  ClusterLeaveInfo: ClusterLeaveInfo,
  Direction: Direction,
  EventPoint: EventPoint,
  DrivingLaneStatus: DrivingLaneStatus,
  SignalViolationSubCauseCode: SignalViolationSubCauseCode,
  CauseCode: CauseCode,
  CauseCodeType: CauseCodeType,
  Velocity3dWithConfidence: Velocity3dWithConfidence,
  MatrixIncludedComponents: MatrixIncludedComponents,
  MessageRateRange: MessageRateRange,
  InterferenceManagementZoneDefinition: InterferenceManagementZoneDefinition,
  ProtectedZoneType: ProtectedZoneType,
  VruProfileAndSubprofile: VruProfileAndSubprofile,
  RestrictedTypes: RestrictedTypes,
  InterferenceManagementZoneType: InterferenceManagementZoneType,
  SequenceOfSafeDistanceIndication: SequenceOfSafeDistanceIndication,
  TrajectoryInterceptionConfidence: TrajectoryInterceptionConfidence,
  TrafficRule: TrafficRule,
  Wgs84AngleValue: Wgs84AngleValue,
  RelevanceTrafficDirection: RelevanceTrafficDirection,
  AccelerationPolarWithZ: AccelerationPolarWithZ,
  StationarySince: StationarySince,
  SpeedConfidence: SpeedConfidence,
  VehicleLengthConfidenceIndication: VehicleLengthConfidenceIndication,
  VehicleWidth: VehicleWidth,
  ProtectedCommunicationZonesRSU: ProtectedCommunicationZonesRSU,
  AccessTechnologyClass: AccessTechnologyClass,
  GenerationDeltaTime: GenerationDeltaTime,
  SubCauseCodeType: SubCauseCodeType,
  VelocityComponent: VelocityComponent,
  BarometricPressure: BarometricPressure,
  AdverseWeatherConditionAdhesionSubCauseCode: AdverseWeatherConditionAdhesionSubCauseCode,
  CartesianAngleValue: CartesianAngleValue,
  AdverseWeatherConditionVisibilitySubCauseCode: AdverseWeatherConditionVisibilitySubCauseCode,
  CpmPayload: CpmPayload,
  Iso3833VehicleType: Iso3833VehicleType,
  RadialShape: RadialShape,
  SequenceOfTrajectoryInterceptionIndication: SequenceOfTrajectoryInterceptionIndication,
  PathPointPredicted: PathPointPredicted,
  WrongWayDrivingSubCauseCode: WrongWayDrivingSubCauseCode,
  PosCentMass: PosCentMass,
  HeightLonCarr: HeightLonCarr,
  VDS: VDS,
  OpeningDaysHours: OpeningDaysHours,
  CpmContainers: CpmContainers,
  VruExteriorLights: VruExteriorLights,
  DeltaTimeMilliSecondSigned: DeltaTimeMilliSecondSigned,
  Wgs84Angle: Wgs84Angle,
  SteeringWheelAngle: SteeringWheelAngle,
  DeltaTimeSecond: DeltaTimeSecond,
  RoadSegmentReferenceId: RoadSegmentReferenceId,
  AngularSpeedConfidence: AngularSpeedConfidence,
  EventHistory: EventHistory,
  CenDsrcTollingZone: CenDsrcTollingZone,
  EventZone: EventZone,
  ObjectClassDescription: ObjectClassDescription,
  DriveDirection: DriveDirection,
  ProtectedCommunicationZone: ProtectedCommunicationZone,
  SpecialTransportType: SpecialTransportType,
  Latitude: Latitude,
  SpeedLimit: SpeedLimit,
  DeltaReferencePosition: DeltaReferencePosition,
  CartesianAngularAccelerationComponent: CartesianAngularAccelerationComponent,
  RadialShapes: RadialShapes,
  BogiesCount: BogiesCount,
  Longitude: Longitude,
  ClusterJoinInfo: ClusterJoinInfo,
  InterferenceManagementInfo: InterferenceManagementInfo,
  VruMovementControl: VruMovementControl,
  LongitudinalAcceleration: LongitudinalAcceleration,
  SensorType: SensorType,
  OrdinalNumber1B: OrdinalNumber1B,
  SequenceOfIdentifier1B: SequenceOfIdentifier1B,
  IntersectionReferenceId: IntersectionReferenceId,
  LongitudinalAccelerationValue: LongitudinalAccelerationValue,
  DeltaLatitude: DeltaLatitude,
  RoadType: RoadType,
  CartesianCoordinateWithConfidence: CartesianCoordinateWithConfidence,
  PosConfidenceEllipse: PosConfidenceEllipse,
  OriginatingVehicleContainer: OriginatingVehicleContainer,
  LowerTriangularPositiveSemidefiniteMatrices: LowerTriangularPositiveSemidefiniteMatrices,
  HardShoulderStatus: HardShoulderStatus,
  EnergyStorageType: EnergyStorageType,
  CollectivePerceptionMessage: CollectivePerceptionMessage,
  Identifier1B: Identifier1B,
  Speed: Speed,
  PositionOfOccupants: PositionOfOccupants,
  DangerousEndOfQueueSubCauseCode: DangerousEndOfQueueSubCauseCode,
  ValidityDuration: ValidityDuration,
  SteeringWheelAngleConfidence: SteeringWheelAngleConfidence,
  RailwayLevelCrossingSubCauseCode: RailwayLevelCrossingSubCauseCode,
  StandardLength9b: StandardLength9b,
  YawRateConfidence: YawRateConfidence,
  LanePositionAndType: LanePositionAndType,
  CpmContainerId: CpmContainerId,
  StandardLength2B: StandardLength2B,
  SequenceNumber: SequenceNumber,
  InformationQuality: InformationQuality,
};
