# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/PerceivedObjects.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class PerceivedObjects(genpy.Message):
  _md5sum = "81d2cc40314c954eef0aa5adef682529"
  _type = "etsi_its_cpm_ts_msgs/PerceivedObjects"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjects::= SEQUENCE SIZE(0..255, ...) OF PerceivedObject (WITH COMPONENTS {... ,objectId PRESENT})
# ------------------------------------------------------------------------------
# * @brief Perceived Objects
# * This DF provides a list of perceived objects represented in the coordinate system in which the y-axis corresponds to the North direction, the x-axis to the East direction, and the z- axis to the vertical direction.
#

PerceivedObject[] array
int64 MIN_SIZE = 0
int64 MAX_SIZE = 255

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObject
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObject ::= SEQUENCE {
#     objectId                                          Identifier2B OPTIONAL,
#     measurementDeltaTime                              DeltaTimeMilliSecondSigned,
#     position                                          CartesianPosition3dWithConfidence, 
#     velocity                                          Velocity3dWithConfidence OPTIONAL,
#     acceleration                                      Acceleration3dWithConfidence OPTIONAL,
#     angles                                            EulerAnglesWithConfidence OPTIONAL,
#     zAngularVelocity                                  CartesianAngularVelocityComponent OPTIONAL,
#     lowerTriangularCorrelationMatrices                LowerTriangularPositiveSemidefiniteMatrices OPTIONAL,
#     objectDimensionZ                                  ObjectDimension OPTIONAL,
#     objectDimensionY                                  ObjectDimension OPTIONAL,
#     objectDimensionX                                  ObjectDimension OPTIONAL,
#     objectAge                                         DeltaTimeMilliSecondSigned (0..2047) OPTIONAL,
#     objectPerceptionQuality                           ObjectPerceptionQuality OPTIONAL,
#     sensorIdList                                      SequenceOfIdentifier1B OPTIONAL,
#     classification                                    ObjectClassDescription OPTIONAL,
#     mapPosition                                       MapPosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF contains information about a perceived object including its kinematic state and attitude vector in a pre-defined coordinate system and with respect to a reference time.
# * 
# * It shall include the following components: 
# *
# * @field objectId: optional identifier assigned to a detected object.
# *
# * @field measurementDeltaTime: the time difference from a reference time to the time of the  measurement of the object. 
# * Negative values indicate that the provided object state refers to a point in time before the reference time.
# *
# * @field position: the position of the geometric centre of the object's bounding box within the pre-defined coordinate system.
# *
# * @field velocity: the velocity vector of the object within the pre-defined coordinate system.
# *
# * @field acceleration: the acceleration vector of the object within the pre-defined coordinate system.
# *
# * @field angles: optional Euler angles of the object bounding box at the time of measurement. 
# * 
# * @field zAngularVelocity: optional angular velocity of the object around the z-axis at the time of measurement.
# * The angular velocity is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule.
# *
# * @field lowerTriangularCorrelationMatrices: optional set of lower triangular correlation matrices for selected components of the provided kinematic state and attitude vector.
# *
# * @field objectDimensionZ: optional z-dimension of object bounding box. 
# * This dimension shall be measured along the direction of the z-axis after all the rotations have been applied. 
# *
# * @field objectDimensionY: optional y-dimension of the object bounding box. 
# * This dimension shall be measured along the direction of the y-axis after all the rotations have been applied. 
# *
# * @field objectDimensionX: optional x-dimension of object bounding box.
# * This dimension shall be measured along the direction of the x-axis after all the rotations have been applied.
# * 
# * @field objectAge: optional age of the detected and described object, i.e. the difference in time between the moment 
# * it has been first detected and the reference time of the message. Value `1500` indicates that the object has been observed for more than 1.5s.
# *
# * @field objectPerceptionQuality: optional confidence associated to the object. 
# *
# * @field sensorIdList: optional list of sensor-IDs which provided the measurement data. 
# *
# * @field classification: optional classification of the described object
# *
# * @field matchedPosition: optional map-matched position of an object.
# *
# * @category Sensing information
# * @revision: created in V2.1.1
# 

Identifier2B object_id
bool object_id_is_present

DeltaTimeMilliSecondSigned measurement_delta_time

CartesianPosition3dWithConfidence position

Velocity3dWithConfidence velocity
bool velocity_is_present

Acceleration3dWithConfidence acceleration
bool acceleration_is_present

EulerAnglesWithConfidence angles
bool angles_is_present

CartesianAngularVelocityComponent z_angular_velocity
bool z_angular_velocity_is_present

LowerTriangularPositiveSemidefiniteMatrices lower_triangular_correlation_matrices
bool lower_triangular_correlation_matrices_is_present

ObjectDimension object_dimension_z
bool object_dimension_z_is_present

ObjectDimension object_dimension_y
bool object_dimension_y_is_present

ObjectDimension object_dimension_x
bool object_dimension_x_is_present

DeltaTimeMilliSecondSigned object_age
bool object_age_is_present
uint16 OBJECT_AGE_MIN = 0
uint16 OBJECT_AGE_MAX = 2047

ObjectPerceptionQuality object_perception_quality
bool object_perception_quality_is_present

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

ObjectClassDescription classification
bool classification_is_present

MapPosition map_position
bool map_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaTimeMilliSecondSigned
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaTimeMilliSecondSigned ::= INTEGER (-2048..2047)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a signed difference in time with respect to a reference time.
# *
# * The value shall be set to:
# * - `-2048` for time values equal to or less than -2,048 s,
# * - `n` (`n > -2048` and `n < 2047`) to indicate a time value equal to or less than n x 0,001 s, and greater than (n-1) x 0,001 s,
# * - `2047` for time values greater than 2,046 s
# *
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -2048
int16 MAX = 2047


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3dWithConfidence::= SEQUENCE{    
#     xCoordinate    CartesianCoordinateWithConfidence, 
#     yCoordinate    CartesianCoordinateWithConfidence, 
#     zCoordinate    CartesianCoordinateWithConfidence OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system with an associated confidence level for each coordinate.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value with the associated confidence level.
# *
# * @field yCoordinate: the Y coordinate value with the associated confidence level.
# *
# * @field zCoordinate: the optional Z coordinate value with the associated confidence level.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateWithConfidence x_coordinate

CartesianCoordinateWithConfidence y_coordinate

CartesianCoordinateWithConfidence z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateWithConfidence ::= SEQUENCE {
#     value         CartesianCoordinateLarge,
#     confidence    CoordinateConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a coordinate along with a confidence value in a cartesian reference system.
# *
# * It shall include the following components: 
# * 
# * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
# * 
# * @field confidence: the coordinate confidence value associated to the provided value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateLarge value

CoordinateConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateLarge::= INTEGER{ 
#     negativeOutOfRange (-131072),
#     positiveOutOfRange (131071)
# } (-131072..131071)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
# *
# * The value shall be set to:
# * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
# * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
# *  
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int32 value
int32 MIN = -131072
int32 MAX = 131071
int32 NEGATIVE_OUT_OF_RANGE = -131072
int32 POSITIVE_OUT_OF_RANGE = 131071

================================================================================
MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CoordinateConfidence ::= INTEGER {
#     outOfRange            (4095),
#     unavailable           (4096) 
# } (1..4096)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
# * - `4095` if the confidence value is greater than 40,94 metres,
# * - `4096` if the confidence value is not available.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 1
uint16 MAX = 4096
uint16 OUT_OF_RANGE = 4095
uint16 UNAVAILABLE = 4096

================================================================================
MSG: etsi_its_cpm_ts_msgs/Velocity3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Velocity3dWithConfidence::= CHOICE{
#     polarVelocity          VelocityPolarWithZ, 
#     cartesianVelocity      VelocityCartesian
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector with associated confidence value.
# *
# * The following options are available:
# * 
# * @field polarVelocity: the representation of the velocity vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianVelocity: the representation of the velocity vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

VelocityPolarWithZ polar_velocity
uint8 CHOICE_POLAR_VELOCITY = 0

VelocityCartesian cartesian_velocity
uint8 CHOICE_CARTESIAN_VELOCITY = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityPolarWithZ::= SEQUENCE {
#     velocityMagnitude    Speed, 
#     velocityDirection    CartesianAngle,
#     zVelocity            VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a polar or cylindrical coordinate system.
# *
# * It shall include the following components: 
# * 
# * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
# * 
# * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

Speed velocity_magnitude

CartesianAngle velocity_direction

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the speed and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field speedValue: the speed value.
# * 
# * @field speedConfidence: the confidence value of the speed value.
# *
# * @category: Kinematic information
# * @revision: V1.3.1
# 

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------
# *
# * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
# *
# * The value shall be set to:
# * - `0` in a standstill situation.
# * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for speed values greater than 163,81 m/s,
# * - `16 383` if the speed accuracy information is not available.
# * 
# * @note: the definition of standstill is out of scope of the present document.
# *
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
#

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
# * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
# * - `127` if the confidence value information is not available.
# *  
# * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the speed value may be valid and used by the application.
# * 
# * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
# * and therefore cannot be trusted. Such is not useful for the application.
# *
# * @unit: 0,01 m/s
# * @category: Vehicle information
# * @revision: Description revised in V2.1.1 
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponent ::= SEQUENCE {
#     value         VelocityComponentValue,
#     confidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a component of the velocity vector and the associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the value of the component.
# * 
# * @field confidence: the confidence value of the value.
# *
# * @category: Kinematic information
# * @revision: V2.1.1
# 

VelocityComponentValue value

SpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponentValue ::= INTEGER {
#     negativeOutOfRange (-16383),
#     positiveOutOfRange  (16382),
#     unavailable        (16383)
# } (-16383..16383)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of a velocity component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
# * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for velocity values equal to or greater than 163,81 m/s,
# * - `16 383` if the velocity information is not available.
# * 
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -16383
int16 MAX = 16383
int16 NEGATIVE_OUT_OF_RANGE = -16383
int16 POSITIVE_OUT_OF_RANGE = 16382
int16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityCartesian::= SEQUENCE {
#     xVelocity   VelocityComponent,
#     yVelocity   VelocityComponent,
#     zVelocity   VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xVelocity: the x component of the velocity vector with the associated confidence value.
# * 
# * @field yVelocity: the y component of the velocity vector with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

VelocityComponent x_velocity

VelocityComponent y_velocity

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Acceleration3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Acceleration3dWithConfidence::= CHOICE {
#     polarAcceleration                    AccelerationPolarWithZ,
#     cartesianAcceleration                AccelerationCartesian 
# }
# ------------------------------------------------------------------------------
# 
#
#
#
#
#
#
#
#
#
# Specification of CDD Data Frames:
#
#
#
#
#
#
#
#
#
#
#*
# * This DF represents an acceleration vector with associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field polarAcceleration: the representation of the acceleration vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianAcceleration: the representation of the acceleration vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

AccelerationPolarWithZ polar_acceleration
uint8 CHOICE_POLAR_ACCELERATION = 0

AccelerationCartesian cartesian_acceleration
uint8 CHOICE_CARTESIAN_ACCELERATION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationPolarWithZ::= SEQUENCE{
#     accelerationMagnitude                             AccelerationMagnitude,
#     accelerationDirection                             CartesianAngle,
#     zAcceleration                                     AccelerationComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents an acceleration vector in a polar or cylindrical coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field accelerationMagnitude: magnitude of the acceleration vector projected onto the reference plane, with the associated confidence value.
# * 
# * @field accelerationDirection: polar angle of the acceleration vector projected onto the reference plane, with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitude acceleration_magnitude

CartesianAngle acceleration_direction

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitude::= SEQUENCE {
#     accelerationMagnitudeValue   AccelerationMagnitudeValue,
#     accelerationConfidence       AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the magnitude of the acceleration vector and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
# * 
# * @field accelerationConfidence: the confidence value of the magnitude value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitudeValue acceleration_magnitude_value

AccelerationConfidence acceleration_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitudeValue ::= INTEGER {
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (0.. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
# *
# * The value shall be set to:
# * - `0` to indicate no acceleration,
# * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 161
uint8 POSITIVE_OUT_OF_RANGE = 160
uint8 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
# * - `102` if the confidence value is unavailable.
# *
# * The value 0 shall not be used.
# *
# * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the acceleration value may be valid and used by the application.
# * 
# * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an acceleration component along with a confidence value.
# *
# * It shall include the following components: 
# *
# * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the provided value.
# *
# * @category: Kinematic Information
# * @revision: Created in V2.1.1
# 

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of an acceleration component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-160` for acceleration values equal to or less than -16 m/s^2,
# * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationCartesian::= SEQUENCE{
#     xAcceleration      AccelerationComponent,
#     yAcceleration      AccelerationComponent,
#     zAcceleration      AccelerationComponent OPTIONAL
# }            
# ------------------------------------------------------------------------------
# *
# * This DF represents a acceleration vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
# * 
# * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationComponent x_acceleration

AccelerationComponent y_acceleration

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EulerAnglesWithConfidence ::= SEQUENCE {
#     zAngle CartesianAngle,
#     yAngle CartesianAngle OPTIONAL,
#     xAngle CartesianAngle OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
# *
# * It shall include the following components: 
# *
# * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
# *
# * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
# *
# * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

CartesianAngle z_angle

CartesianAngle y_angle
bool y_angle_is_present

CartesianAngle x_angle
bool x_angle_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponent ::= SEQUENCE {
#     value         CartesianAngularVelocityComponentValue,
#     confidence    AngularSpeedConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an angular velocity component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angular velocity component.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

CartesianAngularVelocityComponentValue value

AngularSpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponentValue ::= INTEGER {
#     negativeOutofRange (-255),
#     positiveOutOfRange (255),
#     unavailable	       (256)
# } (-255..256)
# ------------------------------------------------------------------------------
# *
# * This DE represents an angular velocity component described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `-255` if the velocity is equal to or less than -255 degrees/s,
# * - `n` (`n > -255` and `n < 255`) if the velocity is equal to or less than n x 1 degree/s, and greater than (n-1) x 1 degree/s,
# * - `255` if the velocity is greater than 254 degrees/s,
# * - `256` if the information is unavailable.
# *
# * @unit: degree/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -255
int16 MAX = 256
int16 NEGATIVE_OUTOF_RANGE = -255
int16 POSITIVE_OUT_OF_RANGE = 255
int16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngularSpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngularSpeedConfidence ::= ENUMERATED {
#     degSec-01   (0), 
#     degSec-02   (1),  
#     degSec-05   (2), 
#     degSec-10   (3), 
#     degSec-20   (4),  
#     degSec-50   (5), 
#     outOfRange  (6),   
#     unavailable (7)   
# }
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * For correlation computation, maximum interval levels can be assumed.
# *
# * The value shall be set to:
# * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
# * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
# * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
# * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
# * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
# * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
# * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
# * - 7 - `unavailable` - if the accuracy information is unavailable.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 DEG_SEC_01 = 0
uint8 DEG_SEC_02 = 1
uint8 DEG_SEC_05 = 2
uint8 DEG_SEC_10 = 3
uint8 DEG_SEC_20 = 4
uint8 DEG_SEC_50 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrices::= SEQUENCE SIZE (1..4) OF LowerTriangularPositiveSemidefiniteMatrix
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of a lower triangular positive semi-definite matrices.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

LowerTriangularPositiveSemidefiniteMatrix[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
#     componentsIncludedIntheMatrix   MatrixIncludedComponents,
#     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a lower triangular positive semi-definite matrix. 
# *
# * It shall include the following components: 
# *
# * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix. 
# * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
# *
# * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows. 
# *
# * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
# * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
# * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

MatrixIncludedComponents components_included_inthe_matrix

LowerTriangularPositiveSemidefiniteMatrixColumns matrix


================================================================================
MSG: etsi_its_cpm_ts_msgs/MatrixIncludedComponents
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MatrixIncludedComponents::= BIT STRING{
#     xPosition                    (0),
#     yPosition                    (1),
#     zPosition                    (2),
#     xVelocityOrVelocityMagnitude (3),
#     yVelocityOrVelocityDirection (4),
#     zSpeed                       (5),
#     xAccelOrAccelMagnitude       (6),
#     yAccelOrAccelDirection       (7),
#     zAcceleration                (8),
#     zAngle                       (9),  
#     yAngle                      (10), 
#     xAngle                      (11), 
#     zAngularVelocity              (12)
# } (SIZE(13,...))
# ------------------------------------------------------------------------------
# *
# * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
# *
# * The corresponding bit shall be set to 1 if the component is included:
# * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
# * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,   
# * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included, 
# * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,   
# * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,   
# * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
# * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,  
# * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,   
# * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
# * - 9 - `zAngle`                        - when the component zAngle is included,
# * - 10 - `yAngle`                       - when the component yAngle is included,   
# * - 11 - `xAngle`                       - when the component xAngle is included,   
# * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.   
# *
# * Otherwise, it shall be set to 0.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 13
int64 MAX_SIZE_BITS = 13
uint8 BIT_INDEX_X_POSITION = 0
uint8 BIT_INDEX_Y_POSITION = 1
uint8 BIT_INDEX_Z_POSITION = 2
uint8 BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
uint8 BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
uint8 BIT_INDEX_Z_SPEED = 5
uint8 BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
uint8 BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
uint8 BIT_INDEX_Z_ACCELERATION = 8
uint8 BIT_INDEX_Z_ANGLE = 9
uint8 BIT_INDEX_Y_ANGLE = 10
uint8 BIT_INDEX_X_ANGLE = 11
uint8 BIT_INDEX_Z_ANGULAR_VELOCITY = 12

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrixColumns
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrixColumns ::= SEQUENCE SIZE (1..13) OF CorrelationColumn
# ------------------------------------------------------------------------------
# * 
# * This DF represents the columns of a lower triangular positive semi-definite matrix, each column not including the main diagonal cell of the matrix.
# * Given a matrix "A" of size n x n, the number of @ref CorrelationColumn to be included in the lower triangular matrix is k=n-1.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

CorrelationColumn[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationColumn
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
# ------------------------------------------------------------------------------
# *
# * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
# * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
# * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
# * starting at 1 from the left.
# *
# * @category: Sensing Information
# * @revision: Created in V2.1.1
#

CorrelationCellValue[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationCellValue ::= INTEGER {
#     full-negative-correlation    (-100),     
#     no-correlation               (0),       
#     full-positive-correlation    (100),
#     unavailable (101)  
# } (-100..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
# *
# * The value shall be set to: 
# * - `-100` in case of full negative correlation,
# * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
# * - `0` in case of no correlation,
# * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
# * - `100` in case of full positive correlation,
# * - `101` in case the correlation information is unavailable. 
# *
# * @unit: the value is scaled by 100
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int8 value
int8 MIN = -100
int8 MAX = 101
int8 FULL_NEGATIVE_CORRELATION = -100
int8 NO_CORRELATION = 0
int8 FULL_POSITIVE_CORRELATION = 100
int8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimension
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimension ::= SEQUENCE {
#     value         ObjectDimensionValue,
#     confidence    ObjectDimensionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a dimension of an object together with a confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the object dimension value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the associated confidence value.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectDimensionValue value

ObjectDimensionConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionValue ::= INTEGER { 
#     outOfRange              (255),
#     unavailable             (256)
# }(1..256)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single dimension of an object.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
# * - `256` if the data is unavailable.
# *
# * @unit 0,1 m
# * @category: Basic information
# * @revision: Created in V2.1.1 
#

uint16 value
uint16 MIN = 1
uint16 MAX = 256
uint16 OUT_OF_RANGE = 255
uint16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionConfidence ::= INTEGER { 
#     outOfRange              (31),
#     unavailable             (32)
# } (1..32)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
# * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
# * - `32` if the confidence value is unavailable.
# *
# * @unit 0,1 m
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 32
uint8 OUT_OF_RANGE = 31
uint8 UNAVAILABLE = 32

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectPerceptionQuality
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectPerceptionQuality ::= INTEGER {
#     noConfidence        (0), 
#     fullConfidence      (15) 
# } (0..15)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single-value indication about the overall information quality of a perceived object.
# * 
# * The value shall be set to:  
# * - `0`                        : if there is no confidence in detected object, e.g. for "ghost"-objects or if confidence could not be computed,
# * - `n` (`n > 0` and `n < 15`) : for the applicable confidence value,
# * - `15`                       : if there is full confidence in the detected Object.
# * 
# * @unit n/a
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 0
uint8 MAX = 15
uint8 NO_CONFIDENCE = 0
uint8 FULL_CONFIDENCE = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfIdentifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfIdentifier1B ::= SEQUENCE SIZE(1..128, ...) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of DE @ref Identifier1B.
# *
# * @category: Basic information
# * @revision: created in V2.1.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassDescription
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassDescription ::= SEQUENCE (SIZE(1..8)) OF ObjectClassWithConfidence
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of object classes.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClassWithConfidence[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassWithConfidence ::= SEQUENCE {
#     objectClass    ObjectClass,
#     confidence     ConfidenceLevel
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the classification of a detected object together with a confidence level.
# *
# * It shall include the following components: 
# *
# * @field objectClass: the class of the object.
# *
# * @field Confidence: the associated confidence level.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClass object_class

ConfidenceLevel confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClass ::= CHOICE {
#     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
#     vruSubClass          VruProfileAndSubprofile,
#     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
# ------------------------------------------------------------------------------
# * 
# * This DF indicates both the class and associated subclass that best describes an object.
# *
# * The following options are available:
# *
# * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
# *
# * @field vruSubClass: the object is a VRU and the specific subclass is specified.
# *
# * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
# *
# * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 choice

TrafficParticipantType vehicle_sub_class
uint8 CHOICE_VEHICLE_SUB_CLASS = 0

VruProfileAndSubprofile vru_sub_class
uint8 CHOICE_VRU_SUB_CLASS = 1

VruClusterInformation group_sub_class
uint8 CHOICE_GROUP_SUB_CLASS = 2

OtherSubClass other_sub_class
uint8 CHOICE_OTHER_SUB_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a traffic participant.
# * 
# * The value shall be set to:
# * - 0 `unknown`          - information about traffic participant is not provided,
# * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
# * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
# * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
# * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
# * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
# * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
# * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
# * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
# * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
# * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
# * - 11 `tram`            - vehicle which runs on tracks along public streets,
# * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
# * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
# * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
# * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                            on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
# * - 16-255               - are reserved for future usage.
# * 
# * @category: Communication information.
# * @revision: Created in V2.1.1 based on StationType
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/VruProfileAndSubprofile
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates the profile of a VRU including sub-profile information
# * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
# *
# * @field pedestrian: VRU Profile 1 - Pedestrian.
# *
# * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
# *
# * @field motorcyclist: VRU Profile 3  - Motorcyclist.
# *
# * @field animal: VRU Profile  4 -  Animal.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a pedestrian.
# * 
# * The value shall be set to:
# * - 0 `unavailable`             - to indicate that the information on is unavailable,
# * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
# * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
# * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
# * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
# *
# * The value shall be set to:
# * - 0 `unavailable`           - to indicate that the information  is unavailable,
# * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
# * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
# * - 3 `horse-and-rider`       - to indicate a horse and rider,
# * - 4 `rollerskater`          - to indicate a rolleskater and skater,
# * - 5 `e-scooter`             - to indicate an e-scooter and rider,
# * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
# * - 7 `pedelec`               - to indicate a pedelec and rider,
# * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
# * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a motorcyclist and corresponding vehicle.
# * 
# * The value shall be set to:
# * - 0 `unavailable `                  - to indicate that the information  is unavailable,
# * - 1 `moped`                         - to indicate a moped and rider,
# * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
# * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
# * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
# * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of an animal
# * 
# * The value shall be set to:
# * - 0 `unavailable`     - to indicate that the information  is unavailable,
# * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
# * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
# * - 3 `service-animal`  - to indicate an animal that supports a human being.
# * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterInformation ::= SEQUENCE { 
#    clusterId                  Identifier1B OPTIONAL,
#    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about a VRU cluster.
# *
# * It shall include the following components: 
# *
# * @field clusterId: optional identifier of a VRU cluster .
# *
# * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
# *
# * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
# *
# * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
# * if this component is absent it means that the information is unavailable. 
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

Identifier1B cluster_id
bool cluster_id_is_present

Shape cluster_bounding_box_shape
bool cluster_bounding_box_shape_is_present
int64 CLUSTER_BOUNDING_BOX_SHAPE_MIN = 0

CardinalNumber1B cluster_cardinality_size

VruClusterProfiles cluster_profiles
bool cluster_profiles_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CardinalNumber1B ::= INTEGER(0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents a cardinal number that counts the size of a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterProfiles
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterProfiles ::= BIT STRING {
#     pedestrian   (0),
#     bicyclist    (1),
#     motorcyclist (2),
#     animal       (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------
# * 
# * This DE Identifies all the VRU profile types within a cluster.
# * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
# * 
# * The corresponding bit shall be set to 1 under the following conditions:
# * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
# * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
# * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
# * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
# * 
# * Otherwise, the corresponding bit shall be set to 0.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_PEDESTRIAN = 0
uint8 BIT_INDEX_BICYCLIST = 1
uint8 BIT_INDEX_MOTORCYCLIST = 2
uint8 BIT_INDEX_ANIMAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/OtherSubClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OtherSubClass ::= INTEGER {
#     unknown         (0),
#     singleObject    (1),
#     multipleObjects (2),
#     bulkMaterial    (3)
# } (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the subclass of a detected object for @ref ObjectClass "otherSubclass".
# *
# * The value shall be set to:
# * - `0` - unknown          - if the subclass is unknown.
# * - `1` - singleObject     - if the object is a single object.
# * - `2` - multipleObjects  - if the object is a group of multiple objects.
# * - `3` - bulkMaterial     - if the object is a bulk material.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 SINGLE_OBJECT = 1
uint8 MULTIPLE_OBJECTS = 2
uint8 BULK_MATERIAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# * 
# * @field mapReference: optionally identifies the MAPEM containing the topology information.
# * It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
# *
# * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
# * conflict area of an intersection which connects e.g an ingress with an egress lane.
# *
# * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
# * 
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the estimated position along the longitudinal length of a particular lane. 
# *
# * It shall include the following components: 
# *
# * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
# *
# * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
# *
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
# * 
# * The value shall be set to:
# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
# * - `32 767` if the longitudinal offset information is not available. 
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
# * - `1 023` if the confidence value is unavailable.
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023
"""
  # Pseudo-constants
  MIN_SIZE = 0
  MAX_SIZE = 255

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/PerceivedObject[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PerceivedObjects, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.object_id
        _x = _v1.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.object_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.measurement_delta_time
        _x = _v2.value
        buff.write(_get_struct_h().pack(_x))
        _v3 = val1.position
        _v4 = _v3.x_coordinate
        _v5 = _v4.value
        _x = _v5.value
        buff.write(_get_struct_i().pack(_x))
        _v6 = _v4.confidence
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
        _v7 = _v3.y_coordinate
        _v8 = _v7.value
        _x = _v8.value
        buff.write(_get_struct_i().pack(_x))
        _v9 = _v7.confidence
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v3.z_coordinate
        _v11 = _v10.value
        _x = _v11.value
        buff.write(_get_struct_i().pack(_x))
        _v12 = _v10.confidence
        _x = _v12.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v3.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v13 = val1.velocity
        _x = _v13.choice
        buff.write(_get_struct_B().pack(_x))
        _v14 = _v13.polar_velocity
        _v15 = _v14.velocity_magnitude
        _v16 = _v15.speed_value
        _x = _v16.value
        buff.write(_get_struct_H().pack(_x))
        _v17 = _v15.speed_confidence
        _x = _v17.value
        buff.write(_get_struct_B().pack(_x))
        _v18 = _v14.velocity_direction
        _v19 = _v18.value
        _x = _v19.value
        buff.write(_get_struct_H().pack(_x))
        _v20 = _v18.confidence
        _x = _v20.value
        buff.write(_get_struct_B().pack(_x))
        _v21 = _v14.z_velocity
        _v22 = _v21.value
        _x = _v22.value
        buff.write(_get_struct_h().pack(_x))
        _v23 = _v21.confidence
        _x = _v23.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v14.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v24 = _v13.cartesian_velocity
        _v25 = _v24.x_velocity
        _v26 = _v25.value
        _x = _v26.value
        buff.write(_get_struct_h().pack(_x))
        _v27 = _v25.confidence
        _x = _v27.value
        buff.write(_get_struct_B().pack(_x))
        _v28 = _v24.y_velocity
        _v29 = _v28.value
        _x = _v29.value
        buff.write(_get_struct_h().pack(_x))
        _v30 = _v28.confidence
        _x = _v30.value
        buff.write(_get_struct_B().pack(_x))
        _v31 = _v24.z_velocity
        _v32 = _v31.value
        _x = _v32.value
        buff.write(_get_struct_h().pack(_x))
        _v33 = _v31.confidence
        _x = _v33.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v24.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v34 = val1.acceleration
        _x = _v34.choice
        buff.write(_get_struct_B().pack(_x))
        _v35 = _v34.polar_acceleration
        _v36 = _v35.acceleration_magnitude
        _v37 = _v36.acceleration_magnitude_value
        _x = _v37.value
        buff.write(_get_struct_B().pack(_x))
        _v38 = _v36.acceleration_confidence
        _x = _v38.value
        buff.write(_get_struct_B().pack(_x))
        _v39 = _v35.acceleration_direction
        _v40 = _v39.value
        _x = _v40.value
        buff.write(_get_struct_H().pack(_x))
        _v41 = _v39.confidence
        _x = _v41.value
        buff.write(_get_struct_B().pack(_x))
        _v42 = _v35.z_acceleration
        _v43 = _v42.value
        _x = _v43.value
        buff.write(_get_struct_h().pack(_x))
        _v44 = _v42.confidence
        _x = _v44.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v35.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v45 = _v34.cartesian_acceleration
        _v46 = _v45.x_acceleration
        _v47 = _v46.value
        _x = _v47.value
        buff.write(_get_struct_h().pack(_x))
        _v48 = _v46.confidence
        _x = _v48.value
        buff.write(_get_struct_B().pack(_x))
        _v49 = _v45.y_acceleration
        _v50 = _v49.value
        _x = _v50.value
        buff.write(_get_struct_h().pack(_x))
        _v51 = _v49.confidence
        _x = _v51.value
        buff.write(_get_struct_B().pack(_x))
        _v52 = _v45.z_acceleration
        _v53 = _v52.value
        _x = _v53.value
        buff.write(_get_struct_h().pack(_x))
        _v54 = _v52.confidence
        _x = _v54.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v45.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v55 = val1.angles
        _v56 = _v55.z_angle
        _v57 = _v56.value
        _x = _v57.value
        buff.write(_get_struct_H().pack(_x))
        _v58 = _v56.confidence
        _x = _v58.value
        buff.write(_get_struct_B().pack(_x))
        _v59 = _v55.y_angle
        _v60 = _v59.value
        _x = _v60.value
        buff.write(_get_struct_H().pack(_x))
        _v61 = _v59.confidence
        _x = _v61.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v55.y_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v62 = _v55.x_angle
        _v63 = _v62.value
        _x = _v63.value
        buff.write(_get_struct_H().pack(_x))
        _v64 = _v62.confidence
        _x = _v64.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v55.x_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.angles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v65 = val1.z_angular_velocity
        _v66 = _v65.value
        _x = _v66.value
        buff.write(_get_struct_h().pack(_x))
        _v67 = _v65.confidence
        _x = _v67.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.z_angular_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v68 = val1.lower_triangular_correlation_matrices
        length = len(_v68.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v68.array:
          _v69 = val3.components_included_inthe_matrix
          _x = _v69.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v69.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _v70 = val3.matrix
          length = len(_v70.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v70.array:
            length = len(val5.array)
            buff.write(_struct_I.pack(length))
            for val6 in val5.array:
              _x = val6.value
              buff.write(_get_struct_b().pack(_x))
        _x = val1.lower_triangular_correlation_matrices_is_present
        buff.write(_get_struct_B().pack(_x))
        _v71 = val1.object_dimension_z
        _v72 = _v71.value
        _x = _v72.value
        buff.write(_get_struct_H().pack(_x))
        _v73 = _v71.confidence
        _x = _v73.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_z_is_present
        buff.write(_get_struct_B().pack(_x))
        _v74 = val1.object_dimension_y
        _v75 = _v74.value
        _x = _v75.value
        buff.write(_get_struct_H().pack(_x))
        _v76 = _v74.confidence
        _x = _v76.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_y_is_present
        buff.write(_get_struct_B().pack(_x))
        _v77 = val1.object_dimension_x
        _v78 = _v77.value
        _x = _v78.value
        buff.write(_get_struct_H().pack(_x))
        _v79 = _v77.confidence
        _x = _v79.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_x_is_present
        buff.write(_get_struct_B().pack(_x))
        _v80 = val1.object_age
        _x = _v80.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.object_age_is_present
        buff.write(_get_struct_B().pack(_x))
        _v81 = val1.object_perception_quality
        _x = _v81.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_perception_quality_is_present
        buff.write(_get_struct_B().pack(_x))
        _v82 = val1.sensor_id_list
        length = len(_v82.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v82.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v83 = val1.classification
        length = len(_v83.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v83.array:
          _v84 = val3.object_class
          _x = _v84.choice
          buff.write(_get_struct_B().pack(_x))
          _v85 = _v84.vehicle_sub_class
          _x = _v85.value
          buff.write(_get_struct_B().pack(_x))
          _v86 = _v84.vru_sub_class
          _x = _v86.choice
          buff.write(_get_struct_B().pack(_x))
          _v87 = _v86.pedestrian
          _x = _v87.value
          buff.write(_get_struct_B().pack(_x))
          _v88 = _v86.bicyclist_and_light_vru_vehicle
          _x = _v88.value
          buff.write(_get_struct_B().pack(_x))
          _v89 = _v86.motorcyclist
          _x = _v89.value
          buff.write(_get_struct_B().pack(_x))
          _v90 = _v86.animal
          _x = _v90.value
          buff.write(_get_struct_B().pack(_x))
          _v91 = _v84.group_sub_class
          _v92 = _v91.cluster_id
          _x = _v92.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v91.cluster_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v93 = _v91.cluster_bounding_box_shape
          _x = _v93.choice
          buff.write(_get_struct_B().pack(_x))
          _v94 = _v93.rectangular
          _v95 = _v94.center_point
          _v96 = _v95.x_coordinate
          _x = _v96.value
          buff.write(_get_struct_h().pack(_x))
          _v97 = _v95.y_coordinate
          _x = _v97.value
          buff.write(_get_struct_h().pack(_x))
          _v98 = _v95.z_coordinate
          _x = _v98.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v95.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v94.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v99 = _v94.semi_length
          _x = _v99.value
          buff.write(_get_struct_H().pack(_x))
          _v100 = _v94.semi_breadth
          _x = _v100.value
          buff.write(_get_struct_H().pack(_x))
          _v101 = _v94.orientation
          _x = _v101.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v94.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v102 = _v94.height
          _x = _v102.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v94.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v103 = _v93.circular
          _v104 = _v103.shape_reference_point
          _v105 = _v104.x_coordinate
          _x = _v105.value
          buff.write(_get_struct_h().pack(_x))
          _v106 = _v104.y_coordinate
          _x = _v106.value
          buff.write(_get_struct_h().pack(_x))
          _v107 = _v104.z_coordinate
          _x = _v107.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v104.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v103.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v108 = _v103.radius
          _x = _v108.value
          buff.write(_get_struct_H().pack(_x))
          _v109 = _v103.height
          _x = _v109.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v103.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v110 = _v93.polygonal
          _v111 = _v110.shape_reference_point
          _v112 = _v111.x_coordinate
          _x = _v112.value
          buff.write(_get_struct_h().pack(_x))
          _v113 = _v111.y_coordinate
          _x = _v113.value
          buff.write(_get_struct_h().pack(_x))
          _v114 = _v111.z_coordinate
          _x = _v114.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v111.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v110.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v115 = _v110.polygon
          length = len(_v115.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v115.array:
            _v116 = val9.x_coordinate
            _x = _v116.value
            buff.write(_get_struct_h().pack(_x))
            _v117 = val9.y_coordinate
            _x = _v117.value
            buff.write(_get_struct_h().pack(_x))
            _v118 = val9.z_coordinate
            _x = _v118.value
            buff.write(_get_struct_h().pack(_x))
            _x = val9.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v119 = _v110.height
          _x = _v119.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v110.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v120 = _v93.elliptical
          _v121 = _v120.shape_reference_point
          _v122 = _v121.x_coordinate
          _x = _v122.value
          buff.write(_get_struct_h().pack(_x))
          _v123 = _v121.y_coordinate
          _x = _v123.value
          buff.write(_get_struct_h().pack(_x))
          _v124 = _v121.z_coordinate
          _x = _v124.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v121.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v120.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v125 = _v120.semi_major_axis_length
          _x = _v125.value
          buff.write(_get_struct_H().pack(_x))
          _v126 = _v120.semi_minor_axis_length
          _x = _v126.value
          buff.write(_get_struct_H().pack(_x))
          _v127 = _v120.orientation
          _x = _v127.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v120.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v128 = _v120.height
          _x = _v128.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v120.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v129 = _v93.radial
          _v130 = _v129.shape_reference_point
          _v131 = _v130.x_coordinate
          _x = _v131.value
          buff.write(_get_struct_h().pack(_x))
          _v132 = _v130.y_coordinate
          _x = _v132.value
          buff.write(_get_struct_h().pack(_x))
          _v133 = _v130.z_coordinate
          _x = _v133.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v130.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v129.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v134 = _v129.range
          _x = _v134.value
          buff.write(_get_struct_H().pack(_x))
          _v135 = _v129.stationary_horizontal_opening_angle_start
          _x = _v135.value
          buff.write(_get_struct_H().pack(_x))
          _v136 = _v129.stationary_horizontal_opening_angle_end
          _x = _v136.value
          buff.write(_get_struct_H().pack(_x))
          _v137 = _v129.vertical_opening_angle_start
          _x = _v137.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v129.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v138 = _v129.vertical_opening_angle_end
          _x = _v138.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v129.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v139 = _v93.radial_shapes
          _v140 = _v139.ref_point_id
          _x = _v140.value
          buff.write(_get_struct_B().pack(_x))
          _v141 = _v139.x_coordinate
          _x = _v141.value
          buff.write(_get_struct_h().pack(_x))
          _v142 = _v139.y_coordinate
          _x = _v142.value
          buff.write(_get_struct_h().pack(_x))
          _v143 = _v139.z_coordinate
          _x = _v143.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v139.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v144 = _v139.radial_shapes_list
          length = len(_v144.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v144.array:
            _v145 = val9.range
            _x = _v145.value
            buff.write(_get_struct_H().pack(_x))
            _v146 = val9.horizontal_opening_angle_start
            _x = _v146.value
            buff.write(_get_struct_H().pack(_x))
            _v147 = val9.horizontal_opening_angle_end
            _x = _v147.value
            buff.write(_get_struct_H().pack(_x))
            _v148 = val9.vertical_opening_angle_start
            _x = _v148.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v149 = val9.vertical_opening_angle_end
            _x = _v149.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = _v91.cluster_bounding_box_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v150 = _v91.cluster_cardinality_size
          _x = _v150.value
          buff.write(_get_struct_B().pack(_x))
          _v151 = _v91.cluster_profiles
          _x = _v151.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v151.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _x = _v91.cluster_profiles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v152 = _v84.other_sub_class
          _x = _v152.value
          buff.write(_get_struct_B().pack(_x))
          _v153 = val3.confidence
          _x = _v153.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.classification_is_present
        buff.write(_get_struct_B().pack(_x))
        _v154 = val1.map_position
        _v155 = _v154.map_reference
        _x = _v155.choice
        buff.write(_get_struct_B().pack(_x))
        _v156 = _v155.roadsegment
        _v157 = _v156.region
        _x = _v157.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v156.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v158 = _v156.id
        _x = _v158.value
        buff.write(_get_struct_H().pack(_x))
        _v159 = _v155.intersection
        _v160 = _v159.region
        _x = _v160.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v159.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v161 = _v159.id
        _x = _v161.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v154.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v162 = _v154.lane_id
        _x = _v162.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v154.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v163 = _v154.connection_id
        _x = _v163.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v154.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v164 = _v154.longitudinal_lane_position
        _v165 = _v164.longitudinal_lane_position_value
        _x = _v165.value
        buff.write(_get_struct_H().pack(_x))
        _v166 = _v164.longitudinal_lane_position_confidence
        _x = _v166.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v154.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_position_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
        _v167 = val1.object_id
        start = end
        end += 2
        (_v167.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_id_is_present = bool(val1.object_id_is_present)
        _v168 = val1.measurement_delta_time
        start = end
        end += 2
        (_v168.value,) = _get_struct_h().unpack(str[start:end])
        _v169 = val1.position
        _v170 = _v169.x_coordinate
        _v171 = _v170.value
        start = end
        end += 4
        (_v171.value,) = _get_struct_i().unpack(str[start:end])
        _v172 = _v170.confidence
        start = end
        end += 2
        (_v172.value,) = _get_struct_H().unpack(str[start:end])
        _v173 = _v169.y_coordinate
        _v174 = _v173.value
        start = end
        end += 4
        (_v174.value,) = _get_struct_i().unpack(str[start:end])
        _v175 = _v173.confidence
        start = end
        end += 2
        (_v175.value,) = _get_struct_H().unpack(str[start:end])
        _v176 = _v169.z_coordinate
        _v177 = _v176.value
        start = end
        end += 4
        (_v177.value,) = _get_struct_i().unpack(str[start:end])
        _v178 = _v176.confidence
        start = end
        end += 2
        (_v178.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v169.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v169.z_coordinate_is_present = bool(_v169.z_coordinate_is_present)
        _v179 = val1.velocity
        start = end
        end += 1
        (_v179.choice,) = _get_struct_B().unpack(str[start:end])
        _v180 = _v179.polar_velocity
        _v181 = _v180.velocity_magnitude
        _v182 = _v181.speed_value
        start = end
        end += 2
        (_v182.value,) = _get_struct_H().unpack(str[start:end])
        _v183 = _v181.speed_confidence
        start = end
        end += 1
        (_v183.value,) = _get_struct_B().unpack(str[start:end])
        _v184 = _v180.velocity_direction
        _v185 = _v184.value
        start = end
        end += 2
        (_v185.value,) = _get_struct_H().unpack(str[start:end])
        _v186 = _v184.confidence
        start = end
        end += 1
        (_v186.value,) = _get_struct_B().unpack(str[start:end])
        _v187 = _v180.z_velocity
        _v188 = _v187.value
        start = end
        end += 2
        (_v188.value,) = _get_struct_h().unpack(str[start:end])
        _v189 = _v187.confidence
        start = end
        end += 1
        (_v189.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v180.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v180.z_velocity_is_present = bool(_v180.z_velocity_is_present)
        _v190 = _v179.cartesian_velocity
        _v191 = _v190.x_velocity
        _v192 = _v191.value
        start = end
        end += 2
        (_v192.value,) = _get_struct_h().unpack(str[start:end])
        _v193 = _v191.confidence
        start = end
        end += 1
        (_v193.value,) = _get_struct_B().unpack(str[start:end])
        _v194 = _v190.y_velocity
        _v195 = _v194.value
        start = end
        end += 2
        (_v195.value,) = _get_struct_h().unpack(str[start:end])
        _v196 = _v194.confidence
        start = end
        end += 1
        (_v196.value,) = _get_struct_B().unpack(str[start:end])
        _v197 = _v190.z_velocity
        _v198 = _v197.value
        start = end
        end += 2
        (_v198.value,) = _get_struct_h().unpack(str[start:end])
        _v199 = _v197.confidence
        start = end
        end += 1
        (_v199.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v190.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v190.z_velocity_is_present = bool(_v190.z_velocity_is_present)
        start = end
        end += 1
        (val1.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.velocity_is_present = bool(val1.velocity_is_present)
        _v200 = val1.acceleration
        start = end
        end += 1
        (_v200.choice,) = _get_struct_B().unpack(str[start:end])
        _v201 = _v200.polar_acceleration
        _v202 = _v201.acceleration_magnitude
        _v203 = _v202.acceleration_magnitude_value
        start = end
        end += 1
        (_v203.value,) = _get_struct_B().unpack(str[start:end])
        _v204 = _v202.acceleration_confidence
        start = end
        end += 1
        (_v204.value,) = _get_struct_B().unpack(str[start:end])
        _v205 = _v201.acceleration_direction
        _v206 = _v205.value
        start = end
        end += 2
        (_v206.value,) = _get_struct_H().unpack(str[start:end])
        _v207 = _v205.confidence
        start = end
        end += 1
        (_v207.value,) = _get_struct_B().unpack(str[start:end])
        _v208 = _v201.z_acceleration
        _v209 = _v208.value
        start = end
        end += 2
        (_v209.value,) = _get_struct_h().unpack(str[start:end])
        _v210 = _v208.confidence
        start = end
        end += 1
        (_v210.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v201.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v201.z_acceleration_is_present = bool(_v201.z_acceleration_is_present)
        _v211 = _v200.cartesian_acceleration
        _v212 = _v211.x_acceleration
        _v213 = _v212.value
        start = end
        end += 2
        (_v213.value,) = _get_struct_h().unpack(str[start:end])
        _v214 = _v212.confidence
        start = end
        end += 1
        (_v214.value,) = _get_struct_B().unpack(str[start:end])
        _v215 = _v211.y_acceleration
        _v216 = _v215.value
        start = end
        end += 2
        (_v216.value,) = _get_struct_h().unpack(str[start:end])
        _v217 = _v215.confidence
        start = end
        end += 1
        (_v217.value,) = _get_struct_B().unpack(str[start:end])
        _v218 = _v211.z_acceleration
        _v219 = _v218.value
        start = end
        end += 2
        (_v219.value,) = _get_struct_h().unpack(str[start:end])
        _v220 = _v218.confidence
        start = end
        end += 1
        (_v220.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v211.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v211.z_acceleration_is_present = bool(_v211.z_acceleration_is_present)
        start = end
        end += 1
        (val1.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.acceleration_is_present = bool(val1.acceleration_is_present)
        _v221 = val1.angles
        _v222 = _v221.z_angle
        _v223 = _v222.value
        start = end
        end += 2
        (_v223.value,) = _get_struct_H().unpack(str[start:end])
        _v224 = _v222.confidence
        start = end
        end += 1
        (_v224.value,) = _get_struct_B().unpack(str[start:end])
        _v225 = _v221.y_angle
        _v226 = _v225.value
        start = end
        end += 2
        (_v226.value,) = _get_struct_H().unpack(str[start:end])
        _v227 = _v225.confidence
        start = end
        end += 1
        (_v227.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v221.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v221.y_angle_is_present = bool(_v221.y_angle_is_present)
        _v228 = _v221.x_angle
        _v229 = _v228.value
        start = end
        end += 2
        (_v229.value,) = _get_struct_H().unpack(str[start:end])
        _v230 = _v228.confidence
        start = end
        end += 1
        (_v230.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v221.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v221.x_angle_is_present = bool(_v221.x_angle_is_present)
        start = end
        end += 1
        (val1.angles_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.angles_is_present = bool(val1.angles_is_present)
        _v231 = val1.z_angular_velocity
        _v232 = _v231.value
        start = end
        end += 2
        (_v232.value,) = _get_struct_h().unpack(str[start:end])
        _v233 = _v231.confidence
        start = end
        end += 1
        (_v233.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_angular_velocity_is_present = bool(val1.z_angular_velocity_is_present)
        _v234 = val1.lower_triangular_correlation_matrices
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v234.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
          _v235 = val3.components_included_inthe_matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v235.value = str[start:end]
          start = end
          end += 1
          (_v235.bits_unused,) = _get_struct_B().unpack(str[start:end])
          _v236 = val3.matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v236.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val5.array = []
            for i in range(0, length):
              val6 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
              start = end
              end += 1
              (val6.value,) = _get_struct_b().unpack(str[start:end])
              val5.array.append(val6)
            _v236.array.append(val5)
          _v234.array.append(val3)
        start = end
        end += 1
        (val1.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lower_triangular_correlation_matrices_is_present = bool(val1.lower_triangular_correlation_matrices_is_present)
        _v237 = val1.object_dimension_z
        _v238 = _v237.value
        start = end
        end += 2
        (_v238.value,) = _get_struct_H().unpack(str[start:end])
        _v239 = _v237.confidence
        start = end
        end += 1
        (_v239.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_z_is_present = bool(val1.object_dimension_z_is_present)
        _v240 = val1.object_dimension_y
        _v241 = _v240.value
        start = end
        end += 2
        (_v241.value,) = _get_struct_H().unpack(str[start:end])
        _v242 = _v240.confidence
        start = end
        end += 1
        (_v242.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_y_is_present = bool(val1.object_dimension_y_is_present)
        _v243 = val1.object_dimension_x
        _v244 = _v243.value
        start = end
        end += 2
        (_v244.value,) = _get_struct_H().unpack(str[start:end])
        _v245 = _v243.confidence
        start = end
        end += 1
        (_v245.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_x_is_present = bool(val1.object_dimension_x_is_present)
        _v246 = val1.object_age
        start = end
        end += 2
        (_v246.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_age_is_present = bool(val1.object_age_is_present)
        _v247 = val1.object_perception_quality
        start = end
        end += 1
        (_v247.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_perception_quality_is_present = bool(val1.object_perception_quality_is_present)
        _v248 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v248.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v248.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v249 = val1.classification
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v249.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
          _v250 = val3.object_class
          start = end
          end += 1
          (_v250.choice,) = _get_struct_B().unpack(str[start:end])
          _v251 = _v250.vehicle_sub_class
          start = end
          end += 1
          (_v251.value,) = _get_struct_B().unpack(str[start:end])
          _v252 = _v250.vru_sub_class
          start = end
          end += 1
          (_v252.choice,) = _get_struct_B().unpack(str[start:end])
          _v253 = _v252.pedestrian
          start = end
          end += 1
          (_v253.value,) = _get_struct_B().unpack(str[start:end])
          _v254 = _v252.bicyclist_and_light_vru_vehicle
          start = end
          end += 1
          (_v254.value,) = _get_struct_B().unpack(str[start:end])
          _v255 = _v252.motorcyclist
          start = end
          end += 1
          (_v255.value,) = _get_struct_B().unpack(str[start:end])
          _v256 = _v252.animal
          start = end
          end += 1
          (_v256.value,) = _get_struct_B().unpack(str[start:end])
          _v257 = _v250.group_sub_class
          _v258 = _v257.cluster_id
          start = end
          end += 1
          (_v258.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v257.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v257.cluster_id_is_present = bool(_v257.cluster_id_is_present)
          _v259 = _v257.cluster_bounding_box_shape
          start = end
          end += 1
          (_v259.choice,) = _get_struct_B().unpack(str[start:end])
          _v260 = _v259.rectangular
          _v261 = _v260.center_point
          _v262 = _v261.x_coordinate
          start = end
          end += 2
          (_v262.value,) = _get_struct_h().unpack(str[start:end])
          _v263 = _v261.y_coordinate
          start = end
          end += 2
          (_v263.value,) = _get_struct_h().unpack(str[start:end])
          _v264 = _v261.z_coordinate
          start = end
          end += 2
          (_v264.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v261.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v261.z_coordinate_is_present = bool(_v261.z_coordinate_is_present)
          start = end
          end += 1
          (_v260.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v260.center_point_is_present = bool(_v260.center_point_is_present)
          _v265 = _v260.semi_length
          start = end
          end += 2
          (_v265.value,) = _get_struct_H().unpack(str[start:end])
          _v266 = _v260.semi_breadth
          start = end
          end += 2
          (_v266.value,) = _get_struct_H().unpack(str[start:end])
          _v267 = _v260.orientation
          start = end
          end += 2
          (_v267.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v260.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v260.orientation_is_present = bool(_v260.orientation_is_present)
          _v268 = _v260.height
          start = end
          end += 2
          (_v268.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v260.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v260.height_is_present = bool(_v260.height_is_present)
          _v269 = _v259.circular
          _v270 = _v269.shape_reference_point
          _v271 = _v270.x_coordinate
          start = end
          end += 2
          (_v271.value,) = _get_struct_h().unpack(str[start:end])
          _v272 = _v270.y_coordinate
          start = end
          end += 2
          (_v272.value,) = _get_struct_h().unpack(str[start:end])
          _v273 = _v270.z_coordinate
          start = end
          end += 2
          (_v273.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v270.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v270.z_coordinate_is_present = bool(_v270.z_coordinate_is_present)
          start = end
          end += 1
          (_v269.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v269.shape_reference_point_is_present = bool(_v269.shape_reference_point_is_present)
          _v274 = _v269.radius
          start = end
          end += 2
          (_v274.value,) = _get_struct_H().unpack(str[start:end])
          _v275 = _v269.height
          start = end
          end += 2
          (_v275.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v269.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v269.height_is_present = bool(_v269.height_is_present)
          _v276 = _v259.polygonal
          _v277 = _v276.shape_reference_point
          _v278 = _v277.x_coordinate
          start = end
          end += 2
          (_v278.value,) = _get_struct_h().unpack(str[start:end])
          _v279 = _v277.y_coordinate
          start = end
          end += 2
          (_v279.value,) = _get_struct_h().unpack(str[start:end])
          _v280 = _v277.z_coordinate
          start = end
          end += 2
          (_v280.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v277.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v277.z_coordinate_is_present = bool(_v277.z_coordinate_is_present)
          start = end
          end += 1
          (_v276.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v276.shape_reference_point_is_present = bool(_v276.shape_reference_point_is_present)
          _v281 = _v276.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v281.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v282 = val9.x_coordinate
            start = end
            end += 2
            (_v282.value,) = _get_struct_h().unpack(str[start:end])
            _v283 = val9.y_coordinate
            start = end
            end += 2
            (_v283.value,) = _get_struct_h().unpack(str[start:end])
            _v284 = val9.z_coordinate
            start = end
            end += 2
            (_v284.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val9.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.z_coordinate_is_present = bool(val9.z_coordinate_is_present)
            _v281.array.append(val9)
          _v285 = _v276.height
          start = end
          end += 2
          (_v285.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v276.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v276.height_is_present = bool(_v276.height_is_present)
          _v286 = _v259.elliptical
          _v287 = _v286.shape_reference_point
          _v288 = _v287.x_coordinate
          start = end
          end += 2
          (_v288.value,) = _get_struct_h().unpack(str[start:end])
          _v289 = _v287.y_coordinate
          start = end
          end += 2
          (_v289.value,) = _get_struct_h().unpack(str[start:end])
          _v290 = _v287.z_coordinate
          start = end
          end += 2
          (_v290.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v287.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v287.z_coordinate_is_present = bool(_v287.z_coordinate_is_present)
          start = end
          end += 1
          (_v286.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v286.shape_reference_point_is_present = bool(_v286.shape_reference_point_is_present)
          _v291 = _v286.semi_major_axis_length
          start = end
          end += 2
          (_v291.value,) = _get_struct_H().unpack(str[start:end])
          _v292 = _v286.semi_minor_axis_length
          start = end
          end += 2
          (_v292.value,) = _get_struct_H().unpack(str[start:end])
          _v293 = _v286.orientation
          start = end
          end += 2
          (_v293.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v286.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v286.orientation_is_present = bool(_v286.orientation_is_present)
          _v294 = _v286.height
          start = end
          end += 2
          (_v294.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v286.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v286.height_is_present = bool(_v286.height_is_present)
          _v295 = _v259.radial
          _v296 = _v295.shape_reference_point
          _v297 = _v296.x_coordinate
          start = end
          end += 2
          (_v297.value,) = _get_struct_h().unpack(str[start:end])
          _v298 = _v296.y_coordinate
          start = end
          end += 2
          (_v298.value,) = _get_struct_h().unpack(str[start:end])
          _v299 = _v296.z_coordinate
          start = end
          end += 2
          (_v299.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v296.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v296.z_coordinate_is_present = bool(_v296.z_coordinate_is_present)
          start = end
          end += 1
          (_v295.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v295.shape_reference_point_is_present = bool(_v295.shape_reference_point_is_present)
          _v300 = _v295.range
          start = end
          end += 2
          (_v300.value,) = _get_struct_H().unpack(str[start:end])
          _v301 = _v295.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v301.value,) = _get_struct_H().unpack(str[start:end])
          _v302 = _v295.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v302.value,) = _get_struct_H().unpack(str[start:end])
          _v303 = _v295.vertical_opening_angle_start
          start = end
          end += 2
          (_v303.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v295.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v295.vertical_opening_angle_start_is_present = bool(_v295.vertical_opening_angle_start_is_present)
          _v304 = _v295.vertical_opening_angle_end
          start = end
          end += 2
          (_v304.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v295.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v295.vertical_opening_angle_end_is_present = bool(_v295.vertical_opening_angle_end_is_present)
          _v305 = _v259.radial_shapes
          _v306 = _v305.ref_point_id
          start = end
          end += 1
          (_v306.value,) = _get_struct_B().unpack(str[start:end])
          _v307 = _v305.x_coordinate
          start = end
          end += 2
          (_v307.value,) = _get_struct_h().unpack(str[start:end])
          _v308 = _v305.y_coordinate
          start = end
          end += 2
          (_v308.value,) = _get_struct_h().unpack(str[start:end])
          _v309 = _v305.z_coordinate
          start = end
          end += 2
          (_v309.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v305.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v305.z_coordinate_is_present = bool(_v305.z_coordinate_is_present)
          _v310 = _v305.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v310.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v311 = val9.range
            start = end
            end += 2
            (_v311.value,) = _get_struct_H().unpack(str[start:end])
            _v312 = val9.horizontal_opening_angle_start
            start = end
            end += 2
            (_v312.value,) = _get_struct_H().unpack(str[start:end])
            _v313 = val9.horizontal_opening_angle_end
            start = end
            end += 2
            (_v313.value,) = _get_struct_H().unpack(str[start:end])
            _v314 = val9.vertical_opening_angle_start
            start = end
            end += 2
            (_v314.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_start_is_present = bool(val9.vertical_opening_angle_start_is_present)
            _v315 = val9.vertical_opening_angle_end
            start = end
            end += 2
            (_v315.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_end_is_present = bool(val9.vertical_opening_angle_end_is_present)
            _v310.array.append(val9)
          start = end
          end += 1
          (_v257.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          _v257.cluster_bounding_box_shape_is_present = bool(_v257.cluster_bounding_box_shape_is_present)
          _v316 = _v257.cluster_cardinality_size
          start = end
          end += 1
          (_v316.value,) = _get_struct_B().unpack(str[start:end])
          _v317 = _v257.cluster_profiles
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v317.value = str[start:end]
          start = end
          end += 1
          (_v317.bits_unused,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v257.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
          _v257.cluster_profiles_is_present = bool(_v257.cluster_profiles_is_present)
          _v318 = _v250.other_sub_class
          start = end
          end += 1
          (_v318.value,) = _get_struct_B().unpack(str[start:end])
          _v319 = val3.confidence
          start = end
          end += 1
          (_v319.value,) = _get_struct_B().unpack(str[start:end])
          _v249.array.append(val3)
        start = end
        end += 1
        (val1.classification_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.classification_is_present = bool(val1.classification_is_present)
        _v320 = val1.map_position
        _v321 = _v320.map_reference
        start = end
        end += 1
        (_v321.choice,) = _get_struct_B().unpack(str[start:end])
        _v322 = _v321.roadsegment
        _v323 = _v322.region
        start = end
        end += 2
        (_v323.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v322.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v322.region_is_present = bool(_v322.region_is_present)
        _v324 = _v322.id
        start = end
        end += 2
        (_v324.value,) = _get_struct_H().unpack(str[start:end])
        _v325 = _v321.intersection
        _v326 = _v325.region
        start = end
        end += 2
        (_v326.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v325.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v325.region_is_present = bool(_v325.region_is_present)
        _v327 = _v325.id
        start = end
        end += 2
        (_v327.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v320.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v320.map_reference_is_present = bool(_v320.map_reference_is_present)
        _v328 = _v320.lane_id
        start = end
        end += 1
        (_v328.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v320.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v320.lane_id_is_present = bool(_v320.lane_id_is_present)
        _v329 = _v320.connection_id
        start = end
        end += 1
        (_v329.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v320.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v320.connection_id_is_present = bool(_v320.connection_id_is_present)
        _v330 = _v320.longitudinal_lane_position
        _v331 = _v330.longitudinal_lane_position_value
        start = end
        end += 2
        (_v331.value,) = _get_struct_H().unpack(str[start:end])
        _v332 = _v330.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v332.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v320.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v320.longitudinal_lane_position_is_present = bool(_v320.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_position_is_present = bool(val1.map_position_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v333 = val1.object_id
        _x = _v333.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.object_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v334 = val1.measurement_delta_time
        _x = _v334.value
        buff.write(_get_struct_h().pack(_x))
        _v335 = val1.position
        _v336 = _v335.x_coordinate
        _v337 = _v336.value
        _x = _v337.value
        buff.write(_get_struct_i().pack(_x))
        _v338 = _v336.confidence
        _x = _v338.value
        buff.write(_get_struct_H().pack(_x))
        _v339 = _v335.y_coordinate
        _v340 = _v339.value
        _x = _v340.value
        buff.write(_get_struct_i().pack(_x))
        _v341 = _v339.confidence
        _x = _v341.value
        buff.write(_get_struct_H().pack(_x))
        _v342 = _v335.z_coordinate
        _v343 = _v342.value
        _x = _v343.value
        buff.write(_get_struct_i().pack(_x))
        _v344 = _v342.confidence
        _x = _v344.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v335.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v345 = val1.velocity
        _x = _v345.choice
        buff.write(_get_struct_B().pack(_x))
        _v346 = _v345.polar_velocity
        _v347 = _v346.velocity_magnitude
        _v348 = _v347.speed_value
        _x = _v348.value
        buff.write(_get_struct_H().pack(_x))
        _v349 = _v347.speed_confidence
        _x = _v349.value
        buff.write(_get_struct_B().pack(_x))
        _v350 = _v346.velocity_direction
        _v351 = _v350.value
        _x = _v351.value
        buff.write(_get_struct_H().pack(_x))
        _v352 = _v350.confidence
        _x = _v352.value
        buff.write(_get_struct_B().pack(_x))
        _v353 = _v346.z_velocity
        _v354 = _v353.value
        _x = _v354.value
        buff.write(_get_struct_h().pack(_x))
        _v355 = _v353.confidence
        _x = _v355.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v346.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v356 = _v345.cartesian_velocity
        _v357 = _v356.x_velocity
        _v358 = _v357.value
        _x = _v358.value
        buff.write(_get_struct_h().pack(_x))
        _v359 = _v357.confidence
        _x = _v359.value
        buff.write(_get_struct_B().pack(_x))
        _v360 = _v356.y_velocity
        _v361 = _v360.value
        _x = _v361.value
        buff.write(_get_struct_h().pack(_x))
        _v362 = _v360.confidence
        _x = _v362.value
        buff.write(_get_struct_B().pack(_x))
        _v363 = _v356.z_velocity
        _v364 = _v363.value
        _x = _v364.value
        buff.write(_get_struct_h().pack(_x))
        _v365 = _v363.confidence
        _x = _v365.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v356.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v366 = val1.acceleration
        _x = _v366.choice
        buff.write(_get_struct_B().pack(_x))
        _v367 = _v366.polar_acceleration
        _v368 = _v367.acceleration_magnitude
        _v369 = _v368.acceleration_magnitude_value
        _x = _v369.value
        buff.write(_get_struct_B().pack(_x))
        _v370 = _v368.acceleration_confidence
        _x = _v370.value
        buff.write(_get_struct_B().pack(_x))
        _v371 = _v367.acceleration_direction
        _v372 = _v371.value
        _x = _v372.value
        buff.write(_get_struct_H().pack(_x))
        _v373 = _v371.confidence
        _x = _v373.value
        buff.write(_get_struct_B().pack(_x))
        _v374 = _v367.z_acceleration
        _v375 = _v374.value
        _x = _v375.value
        buff.write(_get_struct_h().pack(_x))
        _v376 = _v374.confidence
        _x = _v376.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v367.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v377 = _v366.cartesian_acceleration
        _v378 = _v377.x_acceleration
        _v379 = _v378.value
        _x = _v379.value
        buff.write(_get_struct_h().pack(_x))
        _v380 = _v378.confidence
        _x = _v380.value
        buff.write(_get_struct_B().pack(_x))
        _v381 = _v377.y_acceleration
        _v382 = _v381.value
        _x = _v382.value
        buff.write(_get_struct_h().pack(_x))
        _v383 = _v381.confidence
        _x = _v383.value
        buff.write(_get_struct_B().pack(_x))
        _v384 = _v377.z_acceleration
        _v385 = _v384.value
        _x = _v385.value
        buff.write(_get_struct_h().pack(_x))
        _v386 = _v384.confidence
        _x = _v386.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v377.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v387 = val1.angles
        _v388 = _v387.z_angle
        _v389 = _v388.value
        _x = _v389.value
        buff.write(_get_struct_H().pack(_x))
        _v390 = _v388.confidence
        _x = _v390.value
        buff.write(_get_struct_B().pack(_x))
        _v391 = _v387.y_angle
        _v392 = _v391.value
        _x = _v392.value
        buff.write(_get_struct_H().pack(_x))
        _v393 = _v391.confidence
        _x = _v393.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v387.y_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v394 = _v387.x_angle
        _v395 = _v394.value
        _x = _v395.value
        buff.write(_get_struct_H().pack(_x))
        _v396 = _v394.confidence
        _x = _v396.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v387.x_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.angles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v397 = val1.z_angular_velocity
        _v398 = _v397.value
        _x = _v398.value
        buff.write(_get_struct_h().pack(_x))
        _v399 = _v397.confidence
        _x = _v399.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.z_angular_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v400 = val1.lower_triangular_correlation_matrices
        length = len(_v400.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v400.array:
          _v401 = val3.components_included_inthe_matrix
          _x = _v401.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v401.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _v402 = val3.matrix
          length = len(_v402.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v402.array:
            length = len(val5.array)
            buff.write(_struct_I.pack(length))
            for val6 in val5.array:
              _x = val6.value
              buff.write(_get_struct_b().pack(_x))
        _x = val1.lower_triangular_correlation_matrices_is_present
        buff.write(_get_struct_B().pack(_x))
        _v403 = val1.object_dimension_z
        _v404 = _v403.value
        _x = _v404.value
        buff.write(_get_struct_H().pack(_x))
        _v405 = _v403.confidence
        _x = _v405.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_z_is_present
        buff.write(_get_struct_B().pack(_x))
        _v406 = val1.object_dimension_y
        _v407 = _v406.value
        _x = _v407.value
        buff.write(_get_struct_H().pack(_x))
        _v408 = _v406.confidence
        _x = _v408.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_y_is_present
        buff.write(_get_struct_B().pack(_x))
        _v409 = val1.object_dimension_x
        _v410 = _v409.value
        _x = _v410.value
        buff.write(_get_struct_H().pack(_x))
        _v411 = _v409.confidence
        _x = _v411.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_x_is_present
        buff.write(_get_struct_B().pack(_x))
        _v412 = val1.object_age
        _x = _v412.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.object_age_is_present
        buff.write(_get_struct_B().pack(_x))
        _v413 = val1.object_perception_quality
        _x = _v413.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_perception_quality_is_present
        buff.write(_get_struct_B().pack(_x))
        _v414 = val1.sensor_id_list
        length = len(_v414.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v414.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v415 = val1.classification
        length = len(_v415.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v415.array:
          _v416 = val3.object_class
          _x = _v416.choice
          buff.write(_get_struct_B().pack(_x))
          _v417 = _v416.vehicle_sub_class
          _x = _v417.value
          buff.write(_get_struct_B().pack(_x))
          _v418 = _v416.vru_sub_class
          _x = _v418.choice
          buff.write(_get_struct_B().pack(_x))
          _v419 = _v418.pedestrian
          _x = _v419.value
          buff.write(_get_struct_B().pack(_x))
          _v420 = _v418.bicyclist_and_light_vru_vehicle
          _x = _v420.value
          buff.write(_get_struct_B().pack(_x))
          _v421 = _v418.motorcyclist
          _x = _v421.value
          buff.write(_get_struct_B().pack(_x))
          _v422 = _v418.animal
          _x = _v422.value
          buff.write(_get_struct_B().pack(_x))
          _v423 = _v416.group_sub_class
          _v424 = _v423.cluster_id
          _x = _v424.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v423.cluster_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v425 = _v423.cluster_bounding_box_shape
          _x = _v425.choice
          buff.write(_get_struct_B().pack(_x))
          _v426 = _v425.rectangular
          _v427 = _v426.center_point
          _v428 = _v427.x_coordinate
          _x = _v428.value
          buff.write(_get_struct_h().pack(_x))
          _v429 = _v427.y_coordinate
          _x = _v429.value
          buff.write(_get_struct_h().pack(_x))
          _v430 = _v427.z_coordinate
          _x = _v430.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v427.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v426.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v431 = _v426.semi_length
          _x = _v431.value
          buff.write(_get_struct_H().pack(_x))
          _v432 = _v426.semi_breadth
          _x = _v432.value
          buff.write(_get_struct_H().pack(_x))
          _v433 = _v426.orientation
          _x = _v433.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v426.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v434 = _v426.height
          _x = _v434.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v426.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v435 = _v425.circular
          _v436 = _v435.shape_reference_point
          _v437 = _v436.x_coordinate
          _x = _v437.value
          buff.write(_get_struct_h().pack(_x))
          _v438 = _v436.y_coordinate
          _x = _v438.value
          buff.write(_get_struct_h().pack(_x))
          _v439 = _v436.z_coordinate
          _x = _v439.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v436.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v435.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v440 = _v435.radius
          _x = _v440.value
          buff.write(_get_struct_H().pack(_x))
          _v441 = _v435.height
          _x = _v441.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v435.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v442 = _v425.polygonal
          _v443 = _v442.shape_reference_point
          _v444 = _v443.x_coordinate
          _x = _v444.value
          buff.write(_get_struct_h().pack(_x))
          _v445 = _v443.y_coordinate
          _x = _v445.value
          buff.write(_get_struct_h().pack(_x))
          _v446 = _v443.z_coordinate
          _x = _v446.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v443.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v442.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v447 = _v442.polygon
          length = len(_v447.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v447.array:
            _v448 = val9.x_coordinate
            _x = _v448.value
            buff.write(_get_struct_h().pack(_x))
            _v449 = val9.y_coordinate
            _x = _v449.value
            buff.write(_get_struct_h().pack(_x))
            _v450 = val9.z_coordinate
            _x = _v450.value
            buff.write(_get_struct_h().pack(_x))
            _x = val9.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v451 = _v442.height
          _x = _v451.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v442.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v452 = _v425.elliptical
          _v453 = _v452.shape_reference_point
          _v454 = _v453.x_coordinate
          _x = _v454.value
          buff.write(_get_struct_h().pack(_x))
          _v455 = _v453.y_coordinate
          _x = _v455.value
          buff.write(_get_struct_h().pack(_x))
          _v456 = _v453.z_coordinate
          _x = _v456.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v453.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v452.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v457 = _v452.semi_major_axis_length
          _x = _v457.value
          buff.write(_get_struct_H().pack(_x))
          _v458 = _v452.semi_minor_axis_length
          _x = _v458.value
          buff.write(_get_struct_H().pack(_x))
          _v459 = _v452.orientation
          _x = _v459.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v452.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v460 = _v452.height
          _x = _v460.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v452.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v461 = _v425.radial
          _v462 = _v461.shape_reference_point
          _v463 = _v462.x_coordinate
          _x = _v463.value
          buff.write(_get_struct_h().pack(_x))
          _v464 = _v462.y_coordinate
          _x = _v464.value
          buff.write(_get_struct_h().pack(_x))
          _v465 = _v462.z_coordinate
          _x = _v465.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v462.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v461.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v466 = _v461.range
          _x = _v466.value
          buff.write(_get_struct_H().pack(_x))
          _v467 = _v461.stationary_horizontal_opening_angle_start
          _x = _v467.value
          buff.write(_get_struct_H().pack(_x))
          _v468 = _v461.stationary_horizontal_opening_angle_end
          _x = _v468.value
          buff.write(_get_struct_H().pack(_x))
          _v469 = _v461.vertical_opening_angle_start
          _x = _v469.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v461.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v470 = _v461.vertical_opening_angle_end
          _x = _v470.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v461.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v471 = _v425.radial_shapes
          _v472 = _v471.ref_point_id
          _x = _v472.value
          buff.write(_get_struct_B().pack(_x))
          _v473 = _v471.x_coordinate
          _x = _v473.value
          buff.write(_get_struct_h().pack(_x))
          _v474 = _v471.y_coordinate
          _x = _v474.value
          buff.write(_get_struct_h().pack(_x))
          _v475 = _v471.z_coordinate
          _x = _v475.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v471.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v476 = _v471.radial_shapes_list
          length = len(_v476.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v476.array:
            _v477 = val9.range
            _x = _v477.value
            buff.write(_get_struct_H().pack(_x))
            _v478 = val9.horizontal_opening_angle_start
            _x = _v478.value
            buff.write(_get_struct_H().pack(_x))
            _v479 = val9.horizontal_opening_angle_end
            _x = _v479.value
            buff.write(_get_struct_H().pack(_x))
            _v480 = val9.vertical_opening_angle_start
            _x = _v480.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v481 = val9.vertical_opening_angle_end
            _x = _v481.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = _v423.cluster_bounding_box_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v482 = _v423.cluster_cardinality_size
          _x = _v482.value
          buff.write(_get_struct_B().pack(_x))
          _v483 = _v423.cluster_profiles
          _x = _v483.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v483.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _x = _v423.cluster_profiles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v484 = _v416.other_sub_class
          _x = _v484.value
          buff.write(_get_struct_B().pack(_x))
          _v485 = val3.confidence
          _x = _v485.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.classification_is_present
        buff.write(_get_struct_B().pack(_x))
        _v486 = val1.map_position
        _v487 = _v486.map_reference
        _x = _v487.choice
        buff.write(_get_struct_B().pack(_x))
        _v488 = _v487.roadsegment
        _v489 = _v488.region
        _x = _v489.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v488.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v490 = _v488.id
        _x = _v490.value
        buff.write(_get_struct_H().pack(_x))
        _v491 = _v487.intersection
        _v492 = _v491.region
        _x = _v492.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v491.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v493 = _v491.id
        _x = _v493.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v486.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v494 = _v486.lane_id
        _x = _v494.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v486.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v495 = _v486.connection_id
        _x = _v495.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v486.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v496 = _v486.longitudinal_lane_position
        _v497 = _v496.longitudinal_lane_position_value
        _x = _v497.value
        buff.write(_get_struct_H().pack(_x))
        _v498 = _v496.longitudinal_lane_position_confidence
        _x = _v498.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v486.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_position_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
        _v499 = val1.object_id
        start = end
        end += 2
        (_v499.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_id_is_present = bool(val1.object_id_is_present)
        _v500 = val1.measurement_delta_time
        start = end
        end += 2
        (_v500.value,) = _get_struct_h().unpack(str[start:end])
        _v501 = val1.position
        _v502 = _v501.x_coordinate
        _v503 = _v502.value
        start = end
        end += 4
        (_v503.value,) = _get_struct_i().unpack(str[start:end])
        _v504 = _v502.confidence
        start = end
        end += 2
        (_v504.value,) = _get_struct_H().unpack(str[start:end])
        _v505 = _v501.y_coordinate
        _v506 = _v505.value
        start = end
        end += 4
        (_v506.value,) = _get_struct_i().unpack(str[start:end])
        _v507 = _v505.confidence
        start = end
        end += 2
        (_v507.value,) = _get_struct_H().unpack(str[start:end])
        _v508 = _v501.z_coordinate
        _v509 = _v508.value
        start = end
        end += 4
        (_v509.value,) = _get_struct_i().unpack(str[start:end])
        _v510 = _v508.confidence
        start = end
        end += 2
        (_v510.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v501.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v501.z_coordinate_is_present = bool(_v501.z_coordinate_is_present)
        _v511 = val1.velocity
        start = end
        end += 1
        (_v511.choice,) = _get_struct_B().unpack(str[start:end])
        _v512 = _v511.polar_velocity
        _v513 = _v512.velocity_magnitude
        _v514 = _v513.speed_value
        start = end
        end += 2
        (_v514.value,) = _get_struct_H().unpack(str[start:end])
        _v515 = _v513.speed_confidence
        start = end
        end += 1
        (_v515.value,) = _get_struct_B().unpack(str[start:end])
        _v516 = _v512.velocity_direction
        _v517 = _v516.value
        start = end
        end += 2
        (_v517.value,) = _get_struct_H().unpack(str[start:end])
        _v518 = _v516.confidence
        start = end
        end += 1
        (_v518.value,) = _get_struct_B().unpack(str[start:end])
        _v519 = _v512.z_velocity
        _v520 = _v519.value
        start = end
        end += 2
        (_v520.value,) = _get_struct_h().unpack(str[start:end])
        _v521 = _v519.confidence
        start = end
        end += 1
        (_v521.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v512.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v512.z_velocity_is_present = bool(_v512.z_velocity_is_present)
        _v522 = _v511.cartesian_velocity
        _v523 = _v522.x_velocity
        _v524 = _v523.value
        start = end
        end += 2
        (_v524.value,) = _get_struct_h().unpack(str[start:end])
        _v525 = _v523.confidence
        start = end
        end += 1
        (_v525.value,) = _get_struct_B().unpack(str[start:end])
        _v526 = _v522.y_velocity
        _v527 = _v526.value
        start = end
        end += 2
        (_v527.value,) = _get_struct_h().unpack(str[start:end])
        _v528 = _v526.confidence
        start = end
        end += 1
        (_v528.value,) = _get_struct_B().unpack(str[start:end])
        _v529 = _v522.z_velocity
        _v530 = _v529.value
        start = end
        end += 2
        (_v530.value,) = _get_struct_h().unpack(str[start:end])
        _v531 = _v529.confidence
        start = end
        end += 1
        (_v531.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v522.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v522.z_velocity_is_present = bool(_v522.z_velocity_is_present)
        start = end
        end += 1
        (val1.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.velocity_is_present = bool(val1.velocity_is_present)
        _v532 = val1.acceleration
        start = end
        end += 1
        (_v532.choice,) = _get_struct_B().unpack(str[start:end])
        _v533 = _v532.polar_acceleration
        _v534 = _v533.acceleration_magnitude
        _v535 = _v534.acceleration_magnitude_value
        start = end
        end += 1
        (_v535.value,) = _get_struct_B().unpack(str[start:end])
        _v536 = _v534.acceleration_confidence
        start = end
        end += 1
        (_v536.value,) = _get_struct_B().unpack(str[start:end])
        _v537 = _v533.acceleration_direction
        _v538 = _v537.value
        start = end
        end += 2
        (_v538.value,) = _get_struct_H().unpack(str[start:end])
        _v539 = _v537.confidence
        start = end
        end += 1
        (_v539.value,) = _get_struct_B().unpack(str[start:end])
        _v540 = _v533.z_acceleration
        _v541 = _v540.value
        start = end
        end += 2
        (_v541.value,) = _get_struct_h().unpack(str[start:end])
        _v542 = _v540.confidence
        start = end
        end += 1
        (_v542.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v533.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v533.z_acceleration_is_present = bool(_v533.z_acceleration_is_present)
        _v543 = _v532.cartesian_acceleration
        _v544 = _v543.x_acceleration
        _v545 = _v544.value
        start = end
        end += 2
        (_v545.value,) = _get_struct_h().unpack(str[start:end])
        _v546 = _v544.confidence
        start = end
        end += 1
        (_v546.value,) = _get_struct_B().unpack(str[start:end])
        _v547 = _v543.y_acceleration
        _v548 = _v547.value
        start = end
        end += 2
        (_v548.value,) = _get_struct_h().unpack(str[start:end])
        _v549 = _v547.confidence
        start = end
        end += 1
        (_v549.value,) = _get_struct_B().unpack(str[start:end])
        _v550 = _v543.z_acceleration
        _v551 = _v550.value
        start = end
        end += 2
        (_v551.value,) = _get_struct_h().unpack(str[start:end])
        _v552 = _v550.confidence
        start = end
        end += 1
        (_v552.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v543.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v543.z_acceleration_is_present = bool(_v543.z_acceleration_is_present)
        start = end
        end += 1
        (val1.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.acceleration_is_present = bool(val1.acceleration_is_present)
        _v553 = val1.angles
        _v554 = _v553.z_angle
        _v555 = _v554.value
        start = end
        end += 2
        (_v555.value,) = _get_struct_H().unpack(str[start:end])
        _v556 = _v554.confidence
        start = end
        end += 1
        (_v556.value,) = _get_struct_B().unpack(str[start:end])
        _v557 = _v553.y_angle
        _v558 = _v557.value
        start = end
        end += 2
        (_v558.value,) = _get_struct_H().unpack(str[start:end])
        _v559 = _v557.confidence
        start = end
        end += 1
        (_v559.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v553.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v553.y_angle_is_present = bool(_v553.y_angle_is_present)
        _v560 = _v553.x_angle
        _v561 = _v560.value
        start = end
        end += 2
        (_v561.value,) = _get_struct_H().unpack(str[start:end])
        _v562 = _v560.confidence
        start = end
        end += 1
        (_v562.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v553.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v553.x_angle_is_present = bool(_v553.x_angle_is_present)
        start = end
        end += 1
        (val1.angles_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.angles_is_present = bool(val1.angles_is_present)
        _v563 = val1.z_angular_velocity
        _v564 = _v563.value
        start = end
        end += 2
        (_v564.value,) = _get_struct_h().unpack(str[start:end])
        _v565 = _v563.confidence
        start = end
        end += 1
        (_v565.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_angular_velocity_is_present = bool(val1.z_angular_velocity_is_present)
        _v566 = val1.lower_triangular_correlation_matrices
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v566.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
          _v567 = val3.components_included_inthe_matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v567.value = str[start:end]
          start = end
          end += 1
          (_v567.bits_unused,) = _get_struct_B().unpack(str[start:end])
          _v568 = val3.matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v568.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val5.array = []
            for i in range(0, length):
              val6 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
              start = end
              end += 1
              (val6.value,) = _get_struct_b().unpack(str[start:end])
              val5.array.append(val6)
            _v568.array.append(val5)
          _v566.array.append(val3)
        start = end
        end += 1
        (val1.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lower_triangular_correlation_matrices_is_present = bool(val1.lower_triangular_correlation_matrices_is_present)
        _v569 = val1.object_dimension_z
        _v570 = _v569.value
        start = end
        end += 2
        (_v570.value,) = _get_struct_H().unpack(str[start:end])
        _v571 = _v569.confidence
        start = end
        end += 1
        (_v571.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_z_is_present = bool(val1.object_dimension_z_is_present)
        _v572 = val1.object_dimension_y
        _v573 = _v572.value
        start = end
        end += 2
        (_v573.value,) = _get_struct_H().unpack(str[start:end])
        _v574 = _v572.confidence
        start = end
        end += 1
        (_v574.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_y_is_present = bool(val1.object_dimension_y_is_present)
        _v575 = val1.object_dimension_x
        _v576 = _v575.value
        start = end
        end += 2
        (_v576.value,) = _get_struct_H().unpack(str[start:end])
        _v577 = _v575.confidence
        start = end
        end += 1
        (_v577.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_x_is_present = bool(val1.object_dimension_x_is_present)
        _v578 = val1.object_age
        start = end
        end += 2
        (_v578.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_age_is_present = bool(val1.object_age_is_present)
        _v579 = val1.object_perception_quality
        start = end
        end += 1
        (_v579.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_perception_quality_is_present = bool(val1.object_perception_quality_is_present)
        _v580 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v580.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v580.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v581 = val1.classification
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v581.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
          _v582 = val3.object_class
          start = end
          end += 1
          (_v582.choice,) = _get_struct_B().unpack(str[start:end])
          _v583 = _v582.vehicle_sub_class
          start = end
          end += 1
          (_v583.value,) = _get_struct_B().unpack(str[start:end])
          _v584 = _v582.vru_sub_class
          start = end
          end += 1
          (_v584.choice,) = _get_struct_B().unpack(str[start:end])
          _v585 = _v584.pedestrian
          start = end
          end += 1
          (_v585.value,) = _get_struct_B().unpack(str[start:end])
          _v586 = _v584.bicyclist_and_light_vru_vehicle
          start = end
          end += 1
          (_v586.value,) = _get_struct_B().unpack(str[start:end])
          _v587 = _v584.motorcyclist
          start = end
          end += 1
          (_v587.value,) = _get_struct_B().unpack(str[start:end])
          _v588 = _v584.animal
          start = end
          end += 1
          (_v588.value,) = _get_struct_B().unpack(str[start:end])
          _v589 = _v582.group_sub_class
          _v590 = _v589.cluster_id
          start = end
          end += 1
          (_v590.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v589.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v589.cluster_id_is_present = bool(_v589.cluster_id_is_present)
          _v591 = _v589.cluster_bounding_box_shape
          start = end
          end += 1
          (_v591.choice,) = _get_struct_B().unpack(str[start:end])
          _v592 = _v591.rectangular
          _v593 = _v592.center_point
          _v594 = _v593.x_coordinate
          start = end
          end += 2
          (_v594.value,) = _get_struct_h().unpack(str[start:end])
          _v595 = _v593.y_coordinate
          start = end
          end += 2
          (_v595.value,) = _get_struct_h().unpack(str[start:end])
          _v596 = _v593.z_coordinate
          start = end
          end += 2
          (_v596.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v593.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v593.z_coordinate_is_present = bool(_v593.z_coordinate_is_present)
          start = end
          end += 1
          (_v592.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v592.center_point_is_present = bool(_v592.center_point_is_present)
          _v597 = _v592.semi_length
          start = end
          end += 2
          (_v597.value,) = _get_struct_H().unpack(str[start:end])
          _v598 = _v592.semi_breadth
          start = end
          end += 2
          (_v598.value,) = _get_struct_H().unpack(str[start:end])
          _v599 = _v592.orientation
          start = end
          end += 2
          (_v599.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v592.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v592.orientation_is_present = bool(_v592.orientation_is_present)
          _v600 = _v592.height
          start = end
          end += 2
          (_v600.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v592.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v592.height_is_present = bool(_v592.height_is_present)
          _v601 = _v591.circular
          _v602 = _v601.shape_reference_point
          _v603 = _v602.x_coordinate
          start = end
          end += 2
          (_v603.value,) = _get_struct_h().unpack(str[start:end])
          _v604 = _v602.y_coordinate
          start = end
          end += 2
          (_v604.value,) = _get_struct_h().unpack(str[start:end])
          _v605 = _v602.z_coordinate
          start = end
          end += 2
          (_v605.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v602.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v602.z_coordinate_is_present = bool(_v602.z_coordinate_is_present)
          start = end
          end += 1
          (_v601.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v601.shape_reference_point_is_present = bool(_v601.shape_reference_point_is_present)
          _v606 = _v601.radius
          start = end
          end += 2
          (_v606.value,) = _get_struct_H().unpack(str[start:end])
          _v607 = _v601.height
          start = end
          end += 2
          (_v607.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v601.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v601.height_is_present = bool(_v601.height_is_present)
          _v608 = _v591.polygonal
          _v609 = _v608.shape_reference_point
          _v610 = _v609.x_coordinate
          start = end
          end += 2
          (_v610.value,) = _get_struct_h().unpack(str[start:end])
          _v611 = _v609.y_coordinate
          start = end
          end += 2
          (_v611.value,) = _get_struct_h().unpack(str[start:end])
          _v612 = _v609.z_coordinate
          start = end
          end += 2
          (_v612.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v609.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v609.z_coordinate_is_present = bool(_v609.z_coordinate_is_present)
          start = end
          end += 1
          (_v608.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v608.shape_reference_point_is_present = bool(_v608.shape_reference_point_is_present)
          _v613 = _v608.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v613.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v614 = val9.x_coordinate
            start = end
            end += 2
            (_v614.value,) = _get_struct_h().unpack(str[start:end])
            _v615 = val9.y_coordinate
            start = end
            end += 2
            (_v615.value,) = _get_struct_h().unpack(str[start:end])
            _v616 = val9.z_coordinate
            start = end
            end += 2
            (_v616.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val9.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.z_coordinate_is_present = bool(val9.z_coordinate_is_present)
            _v613.array.append(val9)
          _v617 = _v608.height
          start = end
          end += 2
          (_v617.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v608.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v608.height_is_present = bool(_v608.height_is_present)
          _v618 = _v591.elliptical
          _v619 = _v618.shape_reference_point
          _v620 = _v619.x_coordinate
          start = end
          end += 2
          (_v620.value,) = _get_struct_h().unpack(str[start:end])
          _v621 = _v619.y_coordinate
          start = end
          end += 2
          (_v621.value,) = _get_struct_h().unpack(str[start:end])
          _v622 = _v619.z_coordinate
          start = end
          end += 2
          (_v622.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v619.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v619.z_coordinate_is_present = bool(_v619.z_coordinate_is_present)
          start = end
          end += 1
          (_v618.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v618.shape_reference_point_is_present = bool(_v618.shape_reference_point_is_present)
          _v623 = _v618.semi_major_axis_length
          start = end
          end += 2
          (_v623.value,) = _get_struct_H().unpack(str[start:end])
          _v624 = _v618.semi_minor_axis_length
          start = end
          end += 2
          (_v624.value,) = _get_struct_H().unpack(str[start:end])
          _v625 = _v618.orientation
          start = end
          end += 2
          (_v625.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v618.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v618.orientation_is_present = bool(_v618.orientation_is_present)
          _v626 = _v618.height
          start = end
          end += 2
          (_v626.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v618.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v618.height_is_present = bool(_v618.height_is_present)
          _v627 = _v591.radial
          _v628 = _v627.shape_reference_point
          _v629 = _v628.x_coordinate
          start = end
          end += 2
          (_v629.value,) = _get_struct_h().unpack(str[start:end])
          _v630 = _v628.y_coordinate
          start = end
          end += 2
          (_v630.value,) = _get_struct_h().unpack(str[start:end])
          _v631 = _v628.z_coordinate
          start = end
          end += 2
          (_v631.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v628.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v628.z_coordinate_is_present = bool(_v628.z_coordinate_is_present)
          start = end
          end += 1
          (_v627.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v627.shape_reference_point_is_present = bool(_v627.shape_reference_point_is_present)
          _v632 = _v627.range
          start = end
          end += 2
          (_v632.value,) = _get_struct_H().unpack(str[start:end])
          _v633 = _v627.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v633.value,) = _get_struct_H().unpack(str[start:end])
          _v634 = _v627.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v634.value,) = _get_struct_H().unpack(str[start:end])
          _v635 = _v627.vertical_opening_angle_start
          start = end
          end += 2
          (_v635.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v627.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v627.vertical_opening_angle_start_is_present = bool(_v627.vertical_opening_angle_start_is_present)
          _v636 = _v627.vertical_opening_angle_end
          start = end
          end += 2
          (_v636.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v627.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v627.vertical_opening_angle_end_is_present = bool(_v627.vertical_opening_angle_end_is_present)
          _v637 = _v591.radial_shapes
          _v638 = _v637.ref_point_id
          start = end
          end += 1
          (_v638.value,) = _get_struct_B().unpack(str[start:end])
          _v639 = _v637.x_coordinate
          start = end
          end += 2
          (_v639.value,) = _get_struct_h().unpack(str[start:end])
          _v640 = _v637.y_coordinate
          start = end
          end += 2
          (_v640.value,) = _get_struct_h().unpack(str[start:end])
          _v641 = _v637.z_coordinate
          start = end
          end += 2
          (_v641.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v637.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v637.z_coordinate_is_present = bool(_v637.z_coordinate_is_present)
          _v642 = _v637.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v642.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v643 = val9.range
            start = end
            end += 2
            (_v643.value,) = _get_struct_H().unpack(str[start:end])
            _v644 = val9.horizontal_opening_angle_start
            start = end
            end += 2
            (_v644.value,) = _get_struct_H().unpack(str[start:end])
            _v645 = val9.horizontal_opening_angle_end
            start = end
            end += 2
            (_v645.value,) = _get_struct_H().unpack(str[start:end])
            _v646 = val9.vertical_opening_angle_start
            start = end
            end += 2
            (_v646.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_start_is_present = bool(val9.vertical_opening_angle_start_is_present)
            _v647 = val9.vertical_opening_angle_end
            start = end
            end += 2
            (_v647.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_end_is_present = bool(val9.vertical_opening_angle_end_is_present)
            _v642.array.append(val9)
          start = end
          end += 1
          (_v589.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          _v589.cluster_bounding_box_shape_is_present = bool(_v589.cluster_bounding_box_shape_is_present)
          _v648 = _v589.cluster_cardinality_size
          start = end
          end += 1
          (_v648.value,) = _get_struct_B().unpack(str[start:end])
          _v649 = _v589.cluster_profiles
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v649.value = str[start:end]
          start = end
          end += 1
          (_v649.bits_unused,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v589.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
          _v589.cluster_profiles_is_present = bool(_v589.cluster_profiles_is_present)
          _v650 = _v582.other_sub_class
          start = end
          end += 1
          (_v650.value,) = _get_struct_B().unpack(str[start:end])
          _v651 = val3.confidence
          start = end
          end += 1
          (_v651.value,) = _get_struct_B().unpack(str[start:end])
          _v581.array.append(val3)
        start = end
        end += 1
        (val1.classification_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.classification_is_present = bool(val1.classification_is_present)
        _v652 = val1.map_position
        _v653 = _v652.map_reference
        start = end
        end += 1
        (_v653.choice,) = _get_struct_B().unpack(str[start:end])
        _v654 = _v653.roadsegment
        _v655 = _v654.region
        start = end
        end += 2
        (_v655.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v654.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v654.region_is_present = bool(_v654.region_is_present)
        _v656 = _v654.id
        start = end
        end += 2
        (_v656.value,) = _get_struct_H().unpack(str[start:end])
        _v657 = _v653.intersection
        _v658 = _v657.region
        start = end
        end += 2
        (_v658.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v657.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v657.region_is_present = bool(_v657.region_is_present)
        _v659 = _v657.id
        start = end
        end += 2
        (_v659.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v652.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v652.map_reference_is_present = bool(_v652.map_reference_is_present)
        _v660 = _v652.lane_id
        start = end
        end += 1
        (_v660.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v652.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v652.lane_id_is_present = bool(_v652.lane_id_is_present)
        _v661 = _v652.connection_id
        start = end
        end += 1
        (_v661.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v652.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v652.connection_id_is_present = bool(_v652.connection_id_is_present)
        _v662 = _v652.longitudinal_lane_position
        _v663 = _v662.longitudinal_lane_position_value
        start = end
        end += 2
        (_v663.value,) = _get_struct_H().unpack(str[start:end])
        _v664 = _v662.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v664.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v652.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v652.longitudinal_lane_position_is_present = bool(_v652.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_position_is_present = bool(val1.map_position_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
