# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/WrappedCpmContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class WrappedCpmContainer(genpy.Message):
  _md5sum = "974ccaa8ba8fb22bae1c04d99dfb3b21"
  _type = "etsi_its_cpm_ts_msgs/WrappedCpmContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# WrappedCpmContainer ::= SEQUENCE {
#    containerId     CPM-CONTAINER-ID-AND-TYPE.&id( {CpmContainers} ),
# ------------------------------------------------------------------------------
# *
# * This DF represents a CPM container preceded by its type identifier and a lenght indicator.
# *
# * It shall include the following components: 
# *
# * @field containerId: the identifier of the container type.
# *
# * @field containerData: the container content consistent with the container type.
# *
#

CpmContainerId container_id

CpmContainers container_data


================================================================================
MSG: etsi_its_cpm_ts_msgs/CpmContainerId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CpmContainerId ::= INTEGER (1..16)
# ------------------------------------------------------------------------------
# *
# * This DE represents the identifier of the container type. 
# *
#

uint8 value
uint8 MIN = 1
uint8 MAX = 16
uint8 ORIGINATING_RSU_CONTAINER = 2
uint8 ORIGINATING_VEHICLE_CONTAINER = 1
uint8 PERCEIVED_OBJECT_CONTAINER = 5
uint8 PERCEPTION_REGION_CONTAINER = 4
uint8 SENSOR_INFORMATION_CONTAINER = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/CpmContainers
# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CpmContainers CPM-CONTAINER-ID-AND-TYPE ::= {
#     {OriginatingVehicleContainer IDENTIFIED BY originatingVehicleContainer} |
# ------------------------------------------------------------------------------
CpmContainerId choice
OriginatingVehicleContainer originating_vehicle_container
OriginatingRsuContainer originating_rsu_container
SensorInformationContainer sensor_information_container
PerceptionRegionContainer perception_region_container
PerceivedObjectContainer perceived_object_container

================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingVehicleContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OriginatingVehicleContainer ::= SEQUENCE {
#     orientationAngle   Wgs84Angle,
#     pitchAngle         CartesianAngle OPTIONAL,
#     rollAngle          CartesianAngle OPTIONAL,
#     trailerDataSet     TrailerDataSet OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Originating Vehicle Container
# *
# * It shall include the following components: 
# *
# * @field orientationAngle: the angle and angle accuracy of the absolute orientation of the disseminating vehicle in the WGS84 coordinate system with respect to true North.
# *
# * @field pitchAngle: the optional angle and angle accuracy between the ground plane and the current orientation of the vehicle's x-axis with respect to the ground plane about the y-axis according to the ISO 8855.
# *
# * @field rollAngle: the optional angle and angle accuracy between the ground plane and the current orientation of a vehicle's y-axis with respect to the ground plane about the x-axis according to the ISO 8855
# *
# * @field trailerData: information about the trailer dimensions and orientation in case a trailer is present.
# * 
#

Wgs84Angle orientation_angle

CartesianAngle pitch_angle
bool pitch_angle_is_present

CartesianAngle roll_angle
bool roll_angle_is_present

TrailerDataSet trailer_data_set
bool trailer_data_set_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84Angle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84Angle ::= SEQUENCE {
#     value         Wgs84AngleValue,
#     confidence    Wgs84AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an angular component along with a confidence value in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * It shall include the following components: 
# *
# * @field value: the angle value, which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the angle value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

Wgs84AngleValue value

Wgs84AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,
# * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the confidence value is not available.
# *
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerDataSet
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerDataSet::= SEQUENCE SIZE(1..8,...) OF TrailerData (WITH COMPONENTS {... ,frontOverhang ABSENT, rearOverhang ABSENT, trailerWidth ABSENT}) 
# ------------------------------------------------------------------------------
# *
# * This DF  represents a list of trailer data.
# * 
#

TrailerData[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerData ::= SEQUENCE { 
#     refPointId          Identifier1B,
#     hitchPointOffset    StandardLength1B, 
#     frontOverhang       StandardLength1B OPTIONAL, 
#     rearOverhang        StandardLength1B OPTIONAL, 
#     trailerWidth        VehicleWidth OPTIONAL,
#     hitchAngle          CartesianAngle,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides detailed information about an attached trailer.
# *
# * It shall include the following components: 
# *
# * @field refPointId: identifier of the reference point of the trailer.
# *
# * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
# * vehicle Reference Point.
# *
# * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
# * is not overhanging to the front with respect to the trailer reference point.
# *
# * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID.
# *
# * @field trailerWidth: optional width of the trailer.
# *
# * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
# * direction of the ISO 8855 [21] coordinate system centered on the trailer) and the direction of
# * the segment having as end points the reference point of the trailer and the reference point of
# * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
# * xy, described in the local Cartesian coordinate system of the trailer. The
# * angle is measured with negative values considering the trailer orientation turning clockwise
# * starting from the segment direction. The angle value accuracy is provided with the
# * confidence level of 95 %.
# *
# * @category: Vehicle information
# * @revision: Created in V2.1.1
#

Identifier1B ref_point_id

StandardLength1B hitch_point_offset

StandardLength1B front_overhang
bool front_overhang_is_present

StandardLength1B rear_overhang
bool rear_overhang_is_present

VehicleWidth trailer_width
bool trailer_width_is_present

CartesianAngle hitch_angle


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength1B::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
#
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
# * - `61` indicates that the vehicle width is greater than 6,0 metres,
# * - `62` indicates that the information in unavailable.
# * 
# * @unit: 0,1 metre
# * @category: Vehicle information 
# * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62

================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingRsuContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OriginatingRsuContainer ::= SEQUENCE{
#     mapReference    MapReference OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Originating RSU Container.
# *
# * It shall include the following components: 
# *
# * @field mapReference: identifies the MAPEM containing the topology information reference in the Perceived Object Container
# * 
#

MapReference map_reference
bool map_reference_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cpm_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformationContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformationContainer ::= SEQUENCE SIZE(1..128, ...) OF SensorInformation
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Sensor Information Container as a list of information objects about the sensors or data fusion systems from which the station provides information about detected objects.
#

SensorInformation[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformation ::= SEQUENCE {
#     sensorId          		    Identifier1B,
#     sensorType        		    SensorType,
#     perceptionRegionShape		Shape OPTIONAL,
#     perceptionRegionConfidence  ConfidenceLevel OPTIONAL,
#     shadowingApplies            BOOLEAN,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the characteristics of a single sensor or data fusion system.
# *
# * It shall include the following components: 
# *
# * @field sensorId: identifier of the sensor or data fusion system used to relate the perceived object in the Perceived Object Container to the sensor that detected it.
# * this identifier shall uniquely identify the sensor inside the CPM, but may be changed from one CPM to the next.
# *
# * @field sensorType: the type of the sensor.
# *
# * @field perceptionRegionShape: the perception region of the sensor.
# *
# * @field perceptionRegionConfidence: the homogeneous perception region confidence that can be assumed for the entire perception region shape of this sensor. 
# *
# * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
# *
#

Identifier1B sensor_id

SensorType sensor_type

Shape perception_region_shape
bool perception_region_shape_is_present

ConfidenceLevel perception_region_confidence
bool perception_region_confidence_is_present

bool shadowing_applies


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorType ::= INTEGER {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (0..31)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor.
# * 
# * The value shall be set to:
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-31                  - are reserved for future usage.
# *
# * @category: Sensing Information
# * @revision: created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 UNDEFINED = 0
uint8 RADAR = 1
uint8 LIDAR = 2
uint8 MONOVIDEO = 3
uint8 STEREOVISION = 4
uint8 NIGHTVISION = 5
uint8 ULTRASONIC = 6
uint8 PMD = 7
uint8 INDUCTION_LOOP = 8
uint8 SPHERICAL_CAMERA = 9
uint8 UWB = 10
uint8 ACOUSTIC = 11
uint8 LOCAL_AGGREGATION = 12
uint8 ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegionContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceptionRegionContainer ::= SEQUENCE SIZE(1..256, ...) OF PerceptionRegion
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Perception Region Container as a list of perception region information objects. 
#

PerceptionRegion[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegion
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceptionRegion ::= SEQUENCE {
#     measurementDeltaTime         DeltaTimeMilliSecondSigned,     
#     perceptionRegionConfidence   ConfidenceLevel,
#     perceptionRegionShape        Shape, 
#     shadowingApplies             BOOLEAN,
#     sensorIdList                 SequenceOfIdentifier1B OPTIONAL,
#     numberOfPerceivedObjects     CardinalNumber1B OPTIONAL,
#     perceivedObjectIds           PerceivedObjectIds OPTIONAL,
# 	...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the actual perception capabilities available to the transmitting ITS-S, offering additional (often dynamic) details to the information provided in the sensor information container.
# *
# * It shall include the following components: 
#
# * @field measurementDeltaTime: difference between the time of estimation of the perception region and the reference time. Positive values indicates that the provided information refers to a point in time after the reference time.
# *
# * @field perceptionRegionConfidence: the perception confidence.
# *
# * @field perceptionRegionShape: specification of the shape of the perception region.
# *
# * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
# *
# * @field sensorIdList: the optional list of identifiers of the sensors which are involved in perceiving the region.
# *
# * @field numberOfPerceivedObjects: the optional number of perceived objects contained in the perception region specified in the component perceptionRegionShape. 
# *
# * @field perceivedObjectIds: the optional list of identifiers of the objects specified in the Perceived Object Container that are contained in the perception region specified in the component perceptionRegionShape.
# *
#

DeltaTimeMilliSecondSigned measurement_delta_time

ConfidenceLevel perception_region_confidence

Shape perception_region_shape

bool shadowing_applies

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

CardinalNumber1B number_of_perceived_objects
bool number_of_perceived_objects_is_present

PerceivedObjectIds perceived_object_ids
bool perceived_object_ids_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaTimeMilliSecondSigned
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaTimeMilliSecondSigned ::= INTEGER (-2048..2047)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a signed difference in time with respect to a reference time.
# *
# * The value shall be set to:
# * - `-2048` for time values equal to or less than -2,048 s,
# * - `n` (`n > -2048` and `n < 2047`) to indicate a time value equal to or less than n x 0,001 s, and greater than (n-1) x 0,001 s,
# * - `2047` for time values greater than 2,046 s
# *
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -2048
int16 MAX = 2047


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfIdentifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfIdentifier1B ::= SEQUENCE SIZE(1..128, ...) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of DE @ref Identifier1B.
# *
# * @category: Basic information
# * @revision: created in V2.1.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CardinalNumber1B ::= INTEGER(0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents a cardinal number that counts the size of a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectIds
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjectIds::= SEQUENCE SIZE(0..255, ...) OF Identifier2B
# ------------------------------------------------------------------------------
# *
# * This DF  represents a list of identifiers of perceived objects. 
#

Identifier2B[] array
int64 MIN_SIZE = 0
int64 MAX_SIZE = 255

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjectContainer ::= SEQUENCE {
#     numberOfPerceivedObjects    CardinalNumber1B,
#     perceivedObjects            PerceivedObjects,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Perceived Object Container 
# *
# * It shall include the following components: 
# *
# * @field numberOfPerceivedObjects: the total number of perceived objects at the time of generating the message. 
# *
# * @field perceivedObjects: the list of perceived objects.
# *
#

CardinalNumber1B number_of_perceived_objects

PerceivedObjects perceived_objects


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjects
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjects::= SEQUENCE SIZE(0..255, ...) OF PerceivedObject (WITH COMPONENTS {... ,objectId PRESENT})
# ------------------------------------------------------------------------------
# * @brief Perceived Objects
# * This DF provides a list of perceived objects represented in the coordinate system in which the y-axis corresponds to the North direction, the x-axis to the East direction, and the z- axis to the vertical direction.
#

PerceivedObject[] array
int64 MIN_SIZE = 0
int64 MAX_SIZE = 255

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObject
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObject ::= SEQUENCE {
#     objectId                                          Identifier2B OPTIONAL,
#     measurementDeltaTime                              DeltaTimeMilliSecondSigned,
#     position                                          CartesianPosition3dWithConfidence, 
#     velocity                                          Velocity3dWithConfidence OPTIONAL,
#     acceleration                                      Acceleration3dWithConfidence OPTIONAL,
#     angles                                            EulerAnglesWithConfidence OPTIONAL,
#     zAngularVelocity                                  CartesianAngularVelocityComponent OPTIONAL,
#     lowerTriangularCorrelationMatrices                LowerTriangularPositiveSemidefiniteMatrices OPTIONAL,
#     objectDimensionZ                                  ObjectDimension OPTIONAL,
#     objectDimensionY                                  ObjectDimension OPTIONAL,
#     objectDimensionX                                  ObjectDimension OPTIONAL,
#     objectAge                                         DeltaTimeMilliSecondSigned (0..2047) OPTIONAL,
#     objectPerceptionQuality                           ObjectPerceptionQuality OPTIONAL,
#     sensorIdList                                      SequenceOfIdentifier1B OPTIONAL,
#     classification                                    ObjectClassDescription OPTIONAL,
#     mapPosition                                       MapPosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF contains information about a perceived object including its kinematic state and attitude vector in a pre-defined coordinate system and with respect to a reference time.
# * 
# * It shall include the following components: 
# *
# * @field objectId: optional identifier assigned to a detected object.
# *
# * @field measurementDeltaTime: the time difference from a reference time to the time of the  measurement of the object. 
# * Negative values indicate that the provided object state refers to a point in time before the reference time.
# *
# * @field position: the position of the geometric centre of the object's bounding box within the pre-defined coordinate system.
# *
# * @field velocity: the velocity vector of the object within the pre-defined coordinate system.
# *
# * @field acceleration: the acceleration vector of the object within the pre-defined coordinate system.
# *
# * @field angles: optional Euler angles of the object bounding box at the time of measurement. 
# * 
# * @field zAngularVelocity: optional angular velocity of the object around the z-axis at the time of measurement.
# * The angular velocity is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule.
# *
# * @field lowerTriangularCorrelationMatrices: optional set of lower triangular correlation matrices for selected components of the provided kinematic state and attitude vector.
# *
# * @field objectDimensionZ: optional z-dimension of object bounding box. 
# * This dimension shall be measured along the direction of the z-axis after all the rotations have been applied. 
# *
# * @field objectDimensionY: optional y-dimension of the object bounding box. 
# * This dimension shall be measured along the direction of the y-axis after all the rotations have been applied. 
# *
# * @field objectDimensionX: optional x-dimension of object bounding box.
# * This dimension shall be measured along the direction of the x-axis after all the rotations have been applied.
# * 
# * @field objectAge: optional age of the detected and described object, i.e. the difference in time between the moment 
# * it has been first detected and the reference time of the message. Value `1500` indicates that the object has been observed for more than 1.5s.
# *
# * @field objectPerceptionQuality: optional confidence associated to the object. 
# *
# * @field sensorIdList: optional list of sensor-IDs which provided the measurement data. 
# *
# * @field classification: optional classification of the described object
# *
# * @field matchedPosition: optional map-matched position of an object.
# *
# * @category Sensing information
# * @revision: created in V2.1.1
# 

Identifier2B object_id
bool object_id_is_present

DeltaTimeMilliSecondSigned measurement_delta_time

CartesianPosition3dWithConfidence position

Velocity3dWithConfidence velocity
bool velocity_is_present

Acceleration3dWithConfidence acceleration
bool acceleration_is_present

EulerAnglesWithConfidence angles
bool angles_is_present

CartesianAngularVelocityComponent z_angular_velocity
bool z_angular_velocity_is_present

LowerTriangularPositiveSemidefiniteMatrices lower_triangular_correlation_matrices
bool lower_triangular_correlation_matrices_is_present

ObjectDimension object_dimension_z
bool object_dimension_z_is_present

ObjectDimension object_dimension_y
bool object_dimension_y_is_present

ObjectDimension object_dimension_x
bool object_dimension_x_is_present

DeltaTimeMilliSecondSigned object_age
bool object_age_is_present
uint16 OBJECT_AGE_MIN = 0
uint16 OBJECT_AGE_MAX = 2047

ObjectPerceptionQuality object_perception_quality
bool object_perception_quality_is_present

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

ObjectClassDescription classification
bool classification_is_present

MapPosition map_position
bool map_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3dWithConfidence::= SEQUENCE{    
#     xCoordinate    CartesianCoordinateWithConfidence, 
#     yCoordinate    CartesianCoordinateWithConfidence, 
#     zCoordinate    CartesianCoordinateWithConfidence OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system with an associated confidence level for each coordinate.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value with the associated confidence level.
# *
# * @field yCoordinate: the Y coordinate value with the associated confidence level.
# *
# * @field zCoordinate: the optional Z coordinate value with the associated confidence level.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateWithConfidence x_coordinate

CartesianCoordinateWithConfidence y_coordinate

CartesianCoordinateWithConfidence z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateWithConfidence ::= SEQUENCE {
#     value         CartesianCoordinateLarge,
#     confidence    CoordinateConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a coordinate along with a confidence value in a cartesian reference system.
# *
# * It shall include the following components: 
# * 
# * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
# * 
# * @field confidence: the coordinate confidence value associated to the provided value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateLarge value

CoordinateConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateLarge::= INTEGER{ 
#     negativeOutOfRange (-131072),
#     positiveOutOfRange (131071)
# } (-131072..131071)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
# *
# * The value shall be set to:
# * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
# * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
# *  
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int32 value
int32 MIN = -131072
int32 MAX = 131071
int32 NEGATIVE_OUT_OF_RANGE = -131072
int32 POSITIVE_OUT_OF_RANGE = 131071

================================================================================
MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CoordinateConfidence ::= INTEGER {
#     outOfRange            (4095),
#     unavailable           (4096) 
# } (1..4096)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
# * - `4095` if the confidence value is greater than 40,94 metres,
# * - `4096` if the confidence value is not available.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 1
uint16 MAX = 4096
uint16 OUT_OF_RANGE = 4095
uint16 UNAVAILABLE = 4096

================================================================================
MSG: etsi_its_cpm_ts_msgs/Velocity3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Velocity3dWithConfidence::= CHOICE{
#     polarVelocity          VelocityPolarWithZ, 
#     cartesianVelocity      VelocityCartesian
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector with associated confidence value.
# *
# * The following options are available:
# * 
# * @field polarVelocity: the representation of the velocity vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianVelocity: the representation of the velocity vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

VelocityPolarWithZ polar_velocity
uint8 CHOICE_POLAR_VELOCITY = 0

VelocityCartesian cartesian_velocity
uint8 CHOICE_CARTESIAN_VELOCITY = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityPolarWithZ::= SEQUENCE {
#     velocityMagnitude    Speed, 
#     velocityDirection    CartesianAngle,
#     zVelocity            VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a polar or cylindrical coordinate system.
# *
# * It shall include the following components: 
# * 
# * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
# * 
# * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

Speed velocity_magnitude

CartesianAngle velocity_direction

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the speed and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field speedValue: the speed value.
# * 
# * @field speedConfidence: the confidence value of the speed value.
# *
# * @category: Kinematic information
# * @revision: V1.3.1
# 

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------
# *
# * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
# *
# * The value shall be set to:
# * - `0` in a standstill situation.
# * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for speed values greater than 163,81 m/s,
# * - `16 383` if the speed accuracy information is not available.
# * 
# * @note: the definition of standstill is out of scope of the present document.
# *
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
#

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
# * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
# * - `127` if the confidence value information is not available.
# *  
# * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the speed value may be valid and used by the application.
# * 
# * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
# * and therefore cannot be trusted. Such is not useful for the application.
# *
# * @unit: 0,01 m/s
# * @category: Vehicle information
# * @revision: Description revised in V2.1.1 
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponent ::= SEQUENCE {
#     value         VelocityComponentValue,
#     confidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a component of the velocity vector and the associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the value of the component.
# * 
# * @field confidence: the confidence value of the value.
# *
# * @category: Kinematic information
# * @revision: V2.1.1
# 

VelocityComponentValue value

SpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponentValue ::= INTEGER {
#     negativeOutOfRange (-16383),
#     positiveOutOfRange  (16382),
#     unavailable        (16383)
# } (-16383..16383)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of a velocity component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
# * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for velocity values equal to or greater than 163,81 m/s,
# * - `16 383` if the velocity information is not available.
# * 
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -16383
int16 MAX = 16383
int16 NEGATIVE_OUT_OF_RANGE = -16383
int16 POSITIVE_OUT_OF_RANGE = 16382
int16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityCartesian::= SEQUENCE {
#     xVelocity   VelocityComponent,
#     yVelocity   VelocityComponent,
#     zVelocity   VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xVelocity: the x component of the velocity vector with the associated confidence value.
# * 
# * @field yVelocity: the y component of the velocity vector with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

VelocityComponent x_velocity

VelocityComponent y_velocity

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Acceleration3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Acceleration3dWithConfidence::= CHOICE {
#     polarAcceleration                    AccelerationPolarWithZ,
#     cartesianAcceleration                AccelerationCartesian 
# }
# ------------------------------------------------------------------------------
# 
#
#
#
#
#
#
#
#
#
# Specification of CDD Data Frames:
#
#
#
#
#
#
#
#
#
#
#*
# * This DF represents an acceleration vector with associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field polarAcceleration: the representation of the acceleration vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianAcceleration: the representation of the acceleration vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

AccelerationPolarWithZ polar_acceleration
uint8 CHOICE_POLAR_ACCELERATION = 0

AccelerationCartesian cartesian_acceleration
uint8 CHOICE_CARTESIAN_ACCELERATION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationPolarWithZ::= SEQUENCE{
#     accelerationMagnitude                             AccelerationMagnitude,
#     accelerationDirection                             CartesianAngle,
#     zAcceleration                                     AccelerationComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents an acceleration vector in a polar or cylindrical coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field accelerationMagnitude: magnitude of the acceleration vector projected onto the reference plane, with the associated confidence value.
# * 
# * @field accelerationDirection: polar angle of the acceleration vector projected onto the reference plane, with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitude acceleration_magnitude

CartesianAngle acceleration_direction

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitude::= SEQUENCE {
#     accelerationMagnitudeValue   AccelerationMagnitudeValue,
#     accelerationConfidence       AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the magnitude of the acceleration vector and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
# * 
# * @field accelerationConfidence: the confidence value of the magnitude value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitudeValue acceleration_magnitude_value

AccelerationConfidence acceleration_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitudeValue ::= INTEGER {
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (0.. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
# *
# * The value shall be set to:
# * - `0` to indicate no acceleration,
# * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 161
uint8 POSITIVE_OUT_OF_RANGE = 160
uint8 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
# * - `102` if the confidence value is unavailable.
# *
# * The value 0 shall not be used.
# *
# * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the acceleration value may be valid and used by the application.
# * 
# * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an acceleration component along with a confidence value.
# *
# * It shall include the following components: 
# *
# * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the provided value.
# *
# * @category: Kinematic Information
# * @revision: Created in V2.1.1
# 

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of an acceleration component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-160` for acceleration values equal to or less than -16 m/s^2,
# * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationCartesian::= SEQUENCE{
#     xAcceleration      AccelerationComponent,
#     yAcceleration      AccelerationComponent,
#     zAcceleration      AccelerationComponent OPTIONAL
# }            
# ------------------------------------------------------------------------------
# *
# * This DF represents a acceleration vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
# * 
# * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationComponent x_acceleration

AccelerationComponent y_acceleration

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EulerAnglesWithConfidence ::= SEQUENCE {
#     zAngle CartesianAngle,
#     yAngle CartesianAngle OPTIONAL,
#     xAngle CartesianAngle OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
# *
# * It shall include the following components: 
# *
# * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
# *
# * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
# *
# * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

CartesianAngle z_angle

CartesianAngle y_angle
bool y_angle_is_present

CartesianAngle x_angle
bool x_angle_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponent ::= SEQUENCE {
#     value         CartesianAngularVelocityComponentValue,
#     confidence    AngularSpeedConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an angular velocity component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angular velocity component.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

CartesianAngularVelocityComponentValue value

AngularSpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponentValue ::= INTEGER {
#     negativeOutofRange (-255),
#     positiveOutOfRange (255),
#     unavailable	       (256)
# } (-255..256)
# ------------------------------------------------------------------------------
# *
# * This DE represents an angular velocity component described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `-255` if the velocity is equal to or less than -255 degrees/s,
# * - `n` (`n > -255` and `n < 255`) if the velocity is equal to or less than n x 1 degree/s, and greater than (n-1) x 1 degree/s,
# * - `255` if the velocity is greater than 254 degrees/s,
# * - `256` if the information is unavailable.
# *
# * @unit: degree/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -255
int16 MAX = 256
int16 NEGATIVE_OUTOF_RANGE = -255
int16 POSITIVE_OUT_OF_RANGE = 255
int16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngularSpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngularSpeedConfidence ::= ENUMERATED {
#     degSec-01   (0), 
#     degSec-02   (1),  
#     degSec-05   (2), 
#     degSec-10   (3), 
#     degSec-20   (4),  
#     degSec-50   (5), 
#     outOfRange  (6),   
#     unavailable (7)   
# }
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * For correlation computation, maximum interval levels can be assumed.
# *
# * The value shall be set to:
# * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
# * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
# * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
# * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
# * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
# * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
# * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
# * - 7 - `unavailable` - if the accuracy information is unavailable.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 DEG_SEC_01 = 0
uint8 DEG_SEC_02 = 1
uint8 DEG_SEC_05 = 2
uint8 DEG_SEC_10 = 3
uint8 DEG_SEC_20 = 4
uint8 DEG_SEC_50 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrices::= SEQUENCE SIZE (1..4) OF LowerTriangularPositiveSemidefiniteMatrix
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of a lower triangular positive semi-definite matrices.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

LowerTriangularPositiveSemidefiniteMatrix[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
#     componentsIncludedIntheMatrix   MatrixIncludedComponents,
#     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a lower triangular positive semi-definite matrix. 
# *
# * It shall include the following components: 
# *
# * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix. 
# * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
# *
# * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows. 
# *
# * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
# * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
# * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

MatrixIncludedComponents components_included_inthe_matrix

LowerTriangularPositiveSemidefiniteMatrixColumns matrix


================================================================================
MSG: etsi_its_cpm_ts_msgs/MatrixIncludedComponents
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MatrixIncludedComponents::= BIT STRING{
#     xPosition                    (0),
#     yPosition                    (1),
#     zPosition                    (2),
#     xVelocityOrVelocityMagnitude (3),
#     yVelocityOrVelocityDirection (4),
#     zSpeed                       (5),
#     xAccelOrAccelMagnitude       (6),
#     yAccelOrAccelDirection       (7),
#     zAcceleration                (8),
#     zAngle                       (9),  
#     yAngle                      (10), 
#     xAngle                      (11), 
#     zAngularVelocity              (12)
# } (SIZE(13,...))
# ------------------------------------------------------------------------------
# *
# * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
# *
# * The corresponding bit shall be set to 1 if the component is included:
# * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
# * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,   
# * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included, 
# * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,   
# * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,   
# * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
# * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,  
# * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,   
# * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
# * - 9 - `zAngle`                        - when the component zAngle is included,
# * - 10 - `yAngle`                       - when the component yAngle is included,   
# * - 11 - `xAngle`                       - when the component xAngle is included,   
# * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.   
# *
# * Otherwise, it shall be set to 0.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 13
int64 MAX_SIZE_BITS = 13
uint8 BIT_INDEX_X_POSITION = 0
uint8 BIT_INDEX_Y_POSITION = 1
uint8 BIT_INDEX_Z_POSITION = 2
uint8 BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
uint8 BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
uint8 BIT_INDEX_Z_SPEED = 5
uint8 BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
uint8 BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
uint8 BIT_INDEX_Z_ACCELERATION = 8
uint8 BIT_INDEX_Z_ANGLE = 9
uint8 BIT_INDEX_Y_ANGLE = 10
uint8 BIT_INDEX_X_ANGLE = 11
uint8 BIT_INDEX_Z_ANGULAR_VELOCITY = 12

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrixColumns
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrixColumns ::= SEQUENCE SIZE (1..13) OF CorrelationColumn
# ------------------------------------------------------------------------------
# * 
# * This DF represents the columns of a lower triangular positive semi-definite matrix, each column not including the main diagonal cell of the matrix.
# * Given a matrix "A" of size n x n, the number of @ref CorrelationColumn to be included in the lower triangular matrix is k=n-1.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

CorrelationColumn[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationColumn
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
# ------------------------------------------------------------------------------
# *
# * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
# * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
# * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
# * starting at 1 from the left.
# *
# * @category: Sensing Information
# * @revision: Created in V2.1.1
#

CorrelationCellValue[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationCellValue ::= INTEGER {
#     full-negative-correlation    (-100),     
#     no-correlation               (0),       
#     full-positive-correlation    (100),
#     unavailable (101)  
# } (-100..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
# *
# * The value shall be set to: 
# * - `-100` in case of full negative correlation,
# * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
# * - `0` in case of no correlation,
# * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
# * - `100` in case of full positive correlation,
# * - `101` in case the correlation information is unavailable. 
# *
# * @unit: the value is scaled by 100
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int8 value
int8 MIN = -100
int8 MAX = 101
int8 FULL_NEGATIVE_CORRELATION = -100
int8 NO_CORRELATION = 0
int8 FULL_POSITIVE_CORRELATION = 100
int8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimension
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimension ::= SEQUENCE {
#     value         ObjectDimensionValue,
#     confidence    ObjectDimensionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a dimension of an object together with a confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the object dimension value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the associated confidence value.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectDimensionValue value

ObjectDimensionConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionValue ::= INTEGER { 
#     outOfRange              (255),
#     unavailable             (256)
# }(1..256)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single dimension of an object.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
# * - `256` if the data is unavailable.
# *
# * @unit 0,1 m
# * @category: Basic information
# * @revision: Created in V2.1.1 
#

uint16 value
uint16 MIN = 1
uint16 MAX = 256
uint16 OUT_OF_RANGE = 255
uint16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionConfidence ::= INTEGER { 
#     outOfRange              (31),
#     unavailable             (32)
# } (1..32)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
# * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
# * - `32` if the confidence value is unavailable.
# *
# * @unit 0,1 m
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 32
uint8 OUT_OF_RANGE = 31
uint8 UNAVAILABLE = 32

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectPerceptionQuality
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectPerceptionQuality ::= INTEGER {
#     noConfidence        (0), 
#     fullConfidence      (15) 
# } (0..15)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single-value indication about the overall information quality of a perceived object.
# * 
# * The value shall be set to:  
# * - `0`                        : if there is no confidence in detected object, e.g. for "ghost"-objects or if confidence could not be computed,
# * - `n` (`n > 0` and `n < 15`) : for the applicable confidence value,
# * - `15`                       : if there is full confidence in the detected Object.
# * 
# * @unit n/a
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 0
uint8 MAX = 15
uint8 NO_CONFIDENCE = 0
uint8 FULL_CONFIDENCE = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassDescription
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassDescription ::= SEQUENCE (SIZE(1..8)) OF ObjectClassWithConfidence
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of object classes.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClassWithConfidence[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassWithConfidence ::= SEQUENCE {
#     objectClass    ObjectClass,
#     confidence     ConfidenceLevel
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the classification of a detected object together with a confidence level.
# *
# * It shall include the following components: 
# *
# * @field objectClass: the class of the object.
# *
# * @field Confidence: the associated confidence level.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClass object_class

ConfidenceLevel confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClass ::= CHOICE {
#     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
#     vruSubClass          VruProfileAndSubprofile,
#     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
# ------------------------------------------------------------------------------
# * 
# * This DF indicates both the class and associated subclass that best describes an object.
# *
# * The following options are available:
# *
# * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
# *
# * @field vruSubClass: the object is a VRU and the specific subclass is specified.
# *
# * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
# *
# * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 choice

TrafficParticipantType vehicle_sub_class
uint8 CHOICE_VEHICLE_SUB_CLASS = 0

VruProfileAndSubprofile vru_sub_class
uint8 CHOICE_VRU_SUB_CLASS = 1

VruClusterInformation group_sub_class
uint8 CHOICE_GROUP_SUB_CLASS = 2

OtherSubClass other_sub_class
uint8 CHOICE_OTHER_SUB_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a traffic participant.
# * 
# * The value shall be set to:
# * - 0 `unknown`          - information about traffic participant is not provided,
# * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
# * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
# * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
# * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
# * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
# * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
# * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
# * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
# * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
# * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
# * - 11 `tram`            - vehicle which runs on tracks along public streets,
# * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
# * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
# * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
# * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                            on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
# * - 16-255               - are reserved for future usage.
# * 
# * @category: Communication information.
# * @revision: Created in V2.1.1 based on StationType
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/VruProfileAndSubprofile
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates the profile of a VRU including sub-profile information
# * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
# *
# * @field pedestrian: VRU Profile 1 - Pedestrian.
# *
# * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
# *
# * @field motorcyclist: VRU Profile 3  - Motorcyclist.
# *
# * @field animal: VRU Profile  4 -  Animal.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a pedestrian.
# * 
# * The value shall be set to:
# * - 0 `unavailable`             - to indicate that the information on is unavailable,
# * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
# * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
# * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
# * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
# *
# * The value shall be set to:
# * - 0 `unavailable`           - to indicate that the information  is unavailable,
# * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
# * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
# * - 3 `horse-and-rider`       - to indicate a horse and rider,
# * - 4 `rollerskater`          - to indicate a rolleskater and skater,
# * - 5 `e-scooter`             - to indicate an e-scooter and rider,
# * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
# * - 7 `pedelec`               - to indicate a pedelec and rider,
# * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
# * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a motorcyclist and corresponding vehicle.
# * 
# * The value shall be set to:
# * - 0 `unavailable `                  - to indicate that the information  is unavailable,
# * - 1 `moped`                         - to indicate a moped and rider,
# * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
# * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
# * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
# * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of an animal
# * 
# * The value shall be set to:
# * - 0 `unavailable`     - to indicate that the information  is unavailable,
# * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
# * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
# * - 3 `service-animal`  - to indicate an animal that supports a human being.
# * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterInformation ::= SEQUENCE { 
#    clusterId                  Identifier1B OPTIONAL,
#    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about a VRU cluster.
# *
# * It shall include the following components: 
# *
# * @field clusterId: optional identifier of a VRU cluster .
# *
# * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
# *
# * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
# *
# * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
# * if this component is absent it means that the information is unavailable. 
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

Identifier1B cluster_id
bool cluster_id_is_present

Shape cluster_bounding_box_shape
bool cluster_bounding_box_shape_is_present
int64 CLUSTER_BOUNDING_BOX_SHAPE_MIN = 0

CardinalNumber1B cluster_cardinality_size

VruClusterProfiles cluster_profiles
bool cluster_profiles_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterProfiles
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterProfiles ::= BIT STRING {
#     pedestrian   (0),
#     bicyclist    (1),
#     motorcyclist (2),
#     animal       (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------
# * 
# * This DE Identifies all the VRU profile types within a cluster.
# * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
# * 
# * The corresponding bit shall be set to 1 under the following conditions:
# * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
# * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
# * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
# * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
# * 
# * Otherwise, the corresponding bit shall be set to 0.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_PEDESTRIAN = 0
uint8 BIT_INDEX_BICYCLIST = 1
uint8 BIT_INDEX_MOTORCYCLIST = 2
uint8 BIT_INDEX_ANIMAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/OtherSubClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OtherSubClass ::= INTEGER {
#     unknown         (0),
#     singleObject    (1),
#     multipleObjects (2),
#     bulkMaterial    (3)
# } (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the subclass of a detected object for @ref ObjectClass "otherSubclass".
# *
# * The value shall be set to:
# * - `0` - unknown          - if the subclass is unknown.
# * - `1` - singleObject     - if the object is a single object.
# * - `2` - multipleObjects  - if the object is a group of multiple objects.
# * - `3` - bulkMaterial     - if the object is a bulk material.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 SINGLE_OBJECT = 1
uint8 MULTIPLE_OBJECTS = 2
uint8 BULK_MATERIAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# * 
# * @field mapReference: optionally identifies the MAPEM containing the topology information.
# * It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
# *
# * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
# * conflict area of an intersection which connects e.g an ingress with an egress lane.
# *
# * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
# * 
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the estimated position along the longitudinal length of a particular lane. 
# *
# * It shall include the following components: 
# *
# * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
# *
# * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
# *
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
# * 
# * The value shall be set to:
# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
# * - `32 767` if the longitudinal offset information is not available. 
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
# * - `1 023` if the confidence value is unavailable.
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023
"""
  __slots__ = ['container_id','container_data']
  _slot_types = ['etsi_its_cpm_ts_msgs/CpmContainerId','etsi_its_cpm_ts_msgs/CpmContainers']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       container_id,container_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WrappedCpmContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.container_id is None:
        self.container_id = etsi_its_cpm_ts_msgs.msg.CpmContainerId()
      if self.container_data is None:
        self.container_data = etsi_its_cpm_ts_msgs.msg.CpmContainers()
    else:
      self.container_id = etsi_its_cpm_ts_msgs.msg.CpmContainerId()
      self.container_data = etsi_its_cpm_ts_msgs.msg.CpmContainers()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2BHBH2BH2B().pack(_x.container_id.value, _x.container_data.choice.value, _x.container_data.originating_vehicle_container.orientation_angle.value.value, _x.container_data.originating_vehicle_container.orientation_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle.value.value, _x.container_data.originating_vehicle_container.pitch_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle_is_present, _x.container_data.originating_vehicle_container.roll_angle.value.value, _x.container_data.originating_vehicle_container.roll_angle.confidence.value, _x.container_data.originating_vehicle_container.roll_angle_is_present))
      length = len(self.container_data.originating_vehicle_container.trailer_data_set.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.originating_vehicle_container.trailer_data_set.array:
        _v1 = val1.ref_point_id
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.hitch_point_offset
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.front_overhang
        _x = _v3.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.front_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v4 = val1.rear_overhang
        _x = _v4.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.rear_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.trailer_width
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trailer_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v6 = val1.hitch_angle
        _v7 = _v6.value
        _x = _v7.value
        buff.write(_get_struct_H().pack(_x))
        _v8 = _v6.confidence
        _x = _v8.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2BHB2HBHB().pack(_x.container_data.originating_vehicle_container.trailer_data_set_is_present, _x.container_data.originating_rsu_container.map_reference.choice, _x.container_data.originating_rsu_container.map_reference.roadsegment.region.value, _x.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present, _x.container_data.originating_rsu_container.map_reference.roadsegment.id.value, _x.container_data.originating_rsu_container.map_reference.intersection.region.value, _x.container_data.originating_rsu_container.map_reference.intersection.region_is_present, _x.container_data.originating_rsu_container.map_reference.intersection.id.value, _x.container_data.originating_rsu_container.map_reference_is_present))
      length = len(self.container_data.sensor_information_container.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.sensor_information_container.array:
        _v9 = val1.sensor_id
        _x = _v9.value
        buff.write(_get_struct_B().pack(_x))
        _v10 = val1.sensor_type
        _x = _v10.value
        buff.write(_get_struct_B().pack(_x))
        _v11 = val1.perception_region_shape
        _x = _v11.choice
        buff.write(_get_struct_B().pack(_x))
        _v12 = _v11.rectangular
        _v13 = _v12.center_point
        _v14 = _v13.x_coordinate
        _x = _v14.value
        buff.write(_get_struct_h().pack(_x))
        _v15 = _v13.y_coordinate
        _x = _v15.value
        buff.write(_get_struct_h().pack(_x))
        _v16 = _v13.z_coordinate
        _x = _v16.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v13.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v12.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v17 = _v12.semi_length
        _x = _v17.value
        buff.write(_get_struct_H().pack(_x))
        _v18 = _v12.semi_breadth
        _x = _v18.value
        buff.write(_get_struct_H().pack(_x))
        _v19 = _v12.orientation
        _x = _v19.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v12.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = _v12.height
        _x = _v20.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v12.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v21 = _v11.circular
        _v22 = _v21.shape_reference_point
        _v23 = _v22.x_coordinate
        _x = _v23.value
        buff.write(_get_struct_h().pack(_x))
        _v24 = _v22.y_coordinate
        _x = _v24.value
        buff.write(_get_struct_h().pack(_x))
        _v25 = _v22.z_coordinate
        _x = _v25.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v22.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v21.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v26 = _v21.radius
        _x = _v26.value
        buff.write(_get_struct_H().pack(_x))
        _v27 = _v21.height
        _x = _v27.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v21.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v28 = _v11.polygonal
        _v29 = _v28.shape_reference_point
        _v30 = _v29.x_coordinate
        _x = _v30.value
        buff.write(_get_struct_h().pack(_x))
        _v31 = _v29.y_coordinate
        _x = _v31.value
        buff.write(_get_struct_h().pack(_x))
        _v32 = _v29.z_coordinate
        _x = _v32.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v29.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v28.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v33 = _v28.polygon
        length = len(_v33.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v33.array:
          _v34 = val5.x_coordinate
          _x = _v34.value
          buff.write(_get_struct_h().pack(_x))
          _v35 = val5.y_coordinate
          _x = _v35.value
          buff.write(_get_struct_h().pack(_x))
          _v36 = val5.z_coordinate
          _x = _v36.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v37 = _v28.height
        _x = _v37.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v28.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v38 = _v11.elliptical
        _v39 = _v38.shape_reference_point
        _v40 = _v39.x_coordinate
        _x = _v40.value
        buff.write(_get_struct_h().pack(_x))
        _v41 = _v39.y_coordinate
        _x = _v41.value
        buff.write(_get_struct_h().pack(_x))
        _v42 = _v39.z_coordinate
        _x = _v42.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v39.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v38.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v43 = _v38.semi_major_axis_length
        _x = _v43.value
        buff.write(_get_struct_H().pack(_x))
        _v44 = _v38.semi_minor_axis_length
        _x = _v44.value
        buff.write(_get_struct_H().pack(_x))
        _v45 = _v38.orientation
        _x = _v45.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v38.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v46 = _v38.height
        _x = _v46.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v38.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v47 = _v11.radial
        _v48 = _v47.shape_reference_point
        _v49 = _v48.x_coordinate
        _x = _v49.value
        buff.write(_get_struct_h().pack(_x))
        _v50 = _v48.y_coordinate
        _x = _v50.value
        buff.write(_get_struct_h().pack(_x))
        _v51 = _v48.z_coordinate
        _x = _v51.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v48.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v47.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v52 = _v47.range
        _x = _v52.value
        buff.write(_get_struct_H().pack(_x))
        _v53 = _v47.stationary_horizontal_opening_angle_start
        _x = _v53.value
        buff.write(_get_struct_H().pack(_x))
        _v54 = _v47.stationary_horizontal_opening_angle_end
        _x = _v54.value
        buff.write(_get_struct_H().pack(_x))
        _v55 = _v47.vertical_opening_angle_start
        _x = _v55.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v47.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v56 = _v47.vertical_opening_angle_end
        _x = _v56.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v47.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v57 = _v11.radial_shapes
        _v58 = _v57.ref_point_id
        _x = _v58.value
        buff.write(_get_struct_B().pack(_x))
        _v59 = _v57.x_coordinate
        _x = _v59.value
        buff.write(_get_struct_h().pack(_x))
        _v60 = _v57.y_coordinate
        _x = _v60.value
        buff.write(_get_struct_h().pack(_x))
        _v61 = _v57.z_coordinate
        _x = _v61.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v57.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v62 = _v57.radial_shapes_list
        length = len(_v62.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v62.array:
          _v63 = val5.range
          _x = _v63.value
          buff.write(_get_struct_H().pack(_x))
          _v64 = val5.horizontal_opening_angle_start
          _x = _v64.value
          buff.write(_get_struct_H().pack(_x))
          _v65 = val5.horizontal_opening_angle_end
          _x = _v65.value
          buff.write(_get_struct_H().pack(_x))
          _v66 = val5.vertical_opening_angle_start
          _x = _v66.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v67 = val5.vertical_opening_angle_end
          _x = _v67.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.perception_region_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v68 = val1.perception_region_confidence
        _x = _v68.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
      length = len(self.container_data.perception_region_container.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.perception_region_container.array:
        _v69 = val1.measurement_delta_time
        _x = _v69.value
        buff.write(_get_struct_h().pack(_x))
        _v70 = val1.perception_region_confidence
        _x = _v70.value
        buff.write(_get_struct_B().pack(_x))
        _v71 = val1.perception_region_shape
        _x = _v71.choice
        buff.write(_get_struct_B().pack(_x))
        _v72 = _v71.rectangular
        _v73 = _v72.center_point
        _v74 = _v73.x_coordinate
        _x = _v74.value
        buff.write(_get_struct_h().pack(_x))
        _v75 = _v73.y_coordinate
        _x = _v75.value
        buff.write(_get_struct_h().pack(_x))
        _v76 = _v73.z_coordinate
        _x = _v76.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v73.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v72.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v77 = _v72.semi_length
        _x = _v77.value
        buff.write(_get_struct_H().pack(_x))
        _v78 = _v72.semi_breadth
        _x = _v78.value
        buff.write(_get_struct_H().pack(_x))
        _v79 = _v72.orientation
        _x = _v79.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v72.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v80 = _v72.height
        _x = _v80.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v72.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v81 = _v71.circular
        _v82 = _v81.shape_reference_point
        _v83 = _v82.x_coordinate
        _x = _v83.value
        buff.write(_get_struct_h().pack(_x))
        _v84 = _v82.y_coordinate
        _x = _v84.value
        buff.write(_get_struct_h().pack(_x))
        _v85 = _v82.z_coordinate
        _x = _v85.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v82.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v81.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v86 = _v81.radius
        _x = _v86.value
        buff.write(_get_struct_H().pack(_x))
        _v87 = _v81.height
        _x = _v87.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v81.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v88 = _v71.polygonal
        _v89 = _v88.shape_reference_point
        _v90 = _v89.x_coordinate
        _x = _v90.value
        buff.write(_get_struct_h().pack(_x))
        _v91 = _v89.y_coordinate
        _x = _v91.value
        buff.write(_get_struct_h().pack(_x))
        _v92 = _v89.z_coordinate
        _x = _v92.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v89.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v88.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v93 = _v88.polygon
        length = len(_v93.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v93.array:
          _v94 = val5.x_coordinate
          _x = _v94.value
          buff.write(_get_struct_h().pack(_x))
          _v95 = val5.y_coordinate
          _x = _v95.value
          buff.write(_get_struct_h().pack(_x))
          _v96 = val5.z_coordinate
          _x = _v96.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v97 = _v88.height
        _x = _v97.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v88.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v98 = _v71.elliptical
        _v99 = _v98.shape_reference_point
        _v100 = _v99.x_coordinate
        _x = _v100.value
        buff.write(_get_struct_h().pack(_x))
        _v101 = _v99.y_coordinate
        _x = _v101.value
        buff.write(_get_struct_h().pack(_x))
        _v102 = _v99.z_coordinate
        _x = _v102.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v99.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v98.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v103 = _v98.semi_major_axis_length
        _x = _v103.value
        buff.write(_get_struct_H().pack(_x))
        _v104 = _v98.semi_minor_axis_length
        _x = _v104.value
        buff.write(_get_struct_H().pack(_x))
        _v105 = _v98.orientation
        _x = _v105.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v98.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v106 = _v98.height
        _x = _v106.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v98.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v107 = _v71.radial
        _v108 = _v107.shape_reference_point
        _v109 = _v108.x_coordinate
        _x = _v109.value
        buff.write(_get_struct_h().pack(_x))
        _v110 = _v108.y_coordinate
        _x = _v110.value
        buff.write(_get_struct_h().pack(_x))
        _v111 = _v108.z_coordinate
        _x = _v111.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v108.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v107.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v112 = _v107.range
        _x = _v112.value
        buff.write(_get_struct_H().pack(_x))
        _v113 = _v107.stationary_horizontal_opening_angle_start
        _x = _v113.value
        buff.write(_get_struct_H().pack(_x))
        _v114 = _v107.stationary_horizontal_opening_angle_end
        _x = _v114.value
        buff.write(_get_struct_H().pack(_x))
        _v115 = _v107.vertical_opening_angle_start
        _x = _v115.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v107.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v116 = _v107.vertical_opening_angle_end
        _x = _v116.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v107.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v117 = _v71.radial_shapes
        _v118 = _v117.ref_point_id
        _x = _v118.value
        buff.write(_get_struct_B().pack(_x))
        _v119 = _v117.x_coordinate
        _x = _v119.value
        buff.write(_get_struct_h().pack(_x))
        _v120 = _v117.y_coordinate
        _x = _v120.value
        buff.write(_get_struct_h().pack(_x))
        _v121 = _v117.z_coordinate
        _x = _v121.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v117.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v122 = _v117.radial_shapes_list
        length = len(_v122.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v122.array:
          _v123 = val5.range
          _x = _v123.value
          buff.write(_get_struct_H().pack(_x))
          _v124 = val5.horizontal_opening_angle_start
          _x = _v124.value
          buff.write(_get_struct_H().pack(_x))
          _v125 = val5.horizontal_opening_angle_end
          _x = _v125.value
          buff.write(_get_struct_H().pack(_x))
          _v126 = val5.vertical_opening_angle_start
          _x = _v126.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v127 = val5.vertical_opening_angle_end
          _x = _v127.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.shadowing_applies
        buff.write(_get_struct_B().pack(_x))
        _v128 = val1.sensor_id_list
        length = len(_v128.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v128.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v129 = val1.number_of_perceived_objects
        _x = _v129.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.number_of_perceived_objects_is_present
        buff.write(_get_struct_B().pack(_x))
        _v130 = val1.perceived_object_ids
        length = len(_v130.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v130.array:
          _x = val3.value
          buff.write(_get_struct_H().pack(_x))
        _x = val1.perceived_object_ids_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.container_data.perceived_object_container.number_of_perceived_objects.value
      buff.write(_get_struct_B().pack(_x))
      length = len(self.container_data.perceived_object_container.perceived_objects.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.perceived_object_container.perceived_objects.array:
        _v131 = val1.object_id
        _x = _v131.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.object_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v132 = val1.measurement_delta_time
        _x = _v132.value
        buff.write(_get_struct_h().pack(_x))
        _v133 = val1.position
        _v134 = _v133.x_coordinate
        _v135 = _v134.value
        _x = _v135.value
        buff.write(_get_struct_i().pack(_x))
        _v136 = _v134.confidence
        _x = _v136.value
        buff.write(_get_struct_H().pack(_x))
        _v137 = _v133.y_coordinate
        _v138 = _v137.value
        _x = _v138.value
        buff.write(_get_struct_i().pack(_x))
        _v139 = _v137.confidence
        _x = _v139.value
        buff.write(_get_struct_H().pack(_x))
        _v140 = _v133.z_coordinate
        _v141 = _v140.value
        _x = _v141.value
        buff.write(_get_struct_i().pack(_x))
        _v142 = _v140.confidence
        _x = _v142.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v133.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v143 = val1.velocity
        _x = _v143.choice
        buff.write(_get_struct_B().pack(_x))
        _v144 = _v143.polar_velocity
        _v145 = _v144.velocity_magnitude
        _v146 = _v145.speed_value
        _x = _v146.value
        buff.write(_get_struct_H().pack(_x))
        _v147 = _v145.speed_confidence
        _x = _v147.value
        buff.write(_get_struct_B().pack(_x))
        _v148 = _v144.velocity_direction
        _v149 = _v148.value
        _x = _v149.value
        buff.write(_get_struct_H().pack(_x))
        _v150 = _v148.confidence
        _x = _v150.value
        buff.write(_get_struct_B().pack(_x))
        _v151 = _v144.z_velocity
        _v152 = _v151.value
        _x = _v152.value
        buff.write(_get_struct_h().pack(_x))
        _v153 = _v151.confidence
        _x = _v153.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v144.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v154 = _v143.cartesian_velocity
        _v155 = _v154.x_velocity
        _v156 = _v155.value
        _x = _v156.value
        buff.write(_get_struct_h().pack(_x))
        _v157 = _v155.confidence
        _x = _v157.value
        buff.write(_get_struct_B().pack(_x))
        _v158 = _v154.y_velocity
        _v159 = _v158.value
        _x = _v159.value
        buff.write(_get_struct_h().pack(_x))
        _v160 = _v158.confidence
        _x = _v160.value
        buff.write(_get_struct_B().pack(_x))
        _v161 = _v154.z_velocity
        _v162 = _v161.value
        _x = _v162.value
        buff.write(_get_struct_h().pack(_x))
        _v163 = _v161.confidence
        _x = _v163.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v154.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v164 = val1.acceleration
        _x = _v164.choice
        buff.write(_get_struct_B().pack(_x))
        _v165 = _v164.polar_acceleration
        _v166 = _v165.acceleration_magnitude
        _v167 = _v166.acceleration_magnitude_value
        _x = _v167.value
        buff.write(_get_struct_B().pack(_x))
        _v168 = _v166.acceleration_confidence
        _x = _v168.value
        buff.write(_get_struct_B().pack(_x))
        _v169 = _v165.acceleration_direction
        _v170 = _v169.value
        _x = _v170.value
        buff.write(_get_struct_H().pack(_x))
        _v171 = _v169.confidence
        _x = _v171.value
        buff.write(_get_struct_B().pack(_x))
        _v172 = _v165.z_acceleration
        _v173 = _v172.value
        _x = _v173.value
        buff.write(_get_struct_h().pack(_x))
        _v174 = _v172.confidence
        _x = _v174.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v165.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v175 = _v164.cartesian_acceleration
        _v176 = _v175.x_acceleration
        _v177 = _v176.value
        _x = _v177.value
        buff.write(_get_struct_h().pack(_x))
        _v178 = _v176.confidence
        _x = _v178.value
        buff.write(_get_struct_B().pack(_x))
        _v179 = _v175.y_acceleration
        _v180 = _v179.value
        _x = _v180.value
        buff.write(_get_struct_h().pack(_x))
        _v181 = _v179.confidence
        _x = _v181.value
        buff.write(_get_struct_B().pack(_x))
        _v182 = _v175.z_acceleration
        _v183 = _v182.value
        _x = _v183.value
        buff.write(_get_struct_h().pack(_x))
        _v184 = _v182.confidence
        _x = _v184.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v175.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v185 = val1.angles
        _v186 = _v185.z_angle
        _v187 = _v186.value
        _x = _v187.value
        buff.write(_get_struct_H().pack(_x))
        _v188 = _v186.confidence
        _x = _v188.value
        buff.write(_get_struct_B().pack(_x))
        _v189 = _v185.y_angle
        _v190 = _v189.value
        _x = _v190.value
        buff.write(_get_struct_H().pack(_x))
        _v191 = _v189.confidence
        _x = _v191.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v185.y_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v192 = _v185.x_angle
        _v193 = _v192.value
        _x = _v193.value
        buff.write(_get_struct_H().pack(_x))
        _v194 = _v192.confidence
        _x = _v194.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v185.x_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.angles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v195 = val1.z_angular_velocity
        _v196 = _v195.value
        _x = _v196.value
        buff.write(_get_struct_h().pack(_x))
        _v197 = _v195.confidence
        _x = _v197.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.z_angular_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v198 = val1.lower_triangular_correlation_matrices
        length = len(_v198.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v198.array:
          _v199 = val3.components_included_inthe_matrix
          _x = _v199.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v199.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _v200 = val3.matrix
          length = len(_v200.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v200.array:
            length = len(val5.array)
            buff.write(_struct_I.pack(length))
            for val6 in val5.array:
              _x = val6.value
              buff.write(_get_struct_b().pack(_x))
        _x = val1.lower_triangular_correlation_matrices_is_present
        buff.write(_get_struct_B().pack(_x))
        _v201 = val1.object_dimension_z
        _v202 = _v201.value
        _x = _v202.value
        buff.write(_get_struct_H().pack(_x))
        _v203 = _v201.confidence
        _x = _v203.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_z_is_present
        buff.write(_get_struct_B().pack(_x))
        _v204 = val1.object_dimension_y
        _v205 = _v204.value
        _x = _v205.value
        buff.write(_get_struct_H().pack(_x))
        _v206 = _v204.confidence
        _x = _v206.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_y_is_present
        buff.write(_get_struct_B().pack(_x))
        _v207 = val1.object_dimension_x
        _v208 = _v207.value
        _x = _v208.value
        buff.write(_get_struct_H().pack(_x))
        _v209 = _v207.confidence
        _x = _v209.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_x_is_present
        buff.write(_get_struct_B().pack(_x))
        _v210 = val1.object_age
        _x = _v210.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.object_age_is_present
        buff.write(_get_struct_B().pack(_x))
        _v211 = val1.object_perception_quality
        _x = _v211.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_perception_quality_is_present
        buff.write(_get_struct_B().pack(_x))
        _v212 = val1.sensor_id_list
        length = len(_v212.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v212.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v213 = val1.classification
        length = len(_v213.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v213.array:
          _v214 = val3.object_class
          _x = _v214.choice
          buff.write(_get_struct_B().pack(_x))
          _v215 = _v214.vehicle_sub_class
          _x = _v215.value
          buff.write(_get_struct_B().pack(_x))
          _v216 = _v214.vru_sub_class
          _x = _v216.choice
          buff.write(_get_struct_B().pack(_x))
          _v217 = _v216.pedestrian
          _x = _v217.value
          buff.write(_get_struct_B().pack(_x))
          _v218 = _v216.bicyclist_and_light_vru_vehicle
          _x = _v218.value
          buff.write(_get_struct_B().pack(_x))
          _v219 = _v216.motorcyclist
          _x = _v219.value
          buff.write(_get_struct_B().pack(_x))
          _v220 = _v216.animal
          _x = _v220.value
          buff.write(_get_struct_B().pack(_x))
          _v221 = _v214.group_sub_class
          _v222 = _v221.cluster_id
          _x = _v222.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v221.cluster_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v223 = _v221.cluster_bounding_box_shape
          _x = _v223.choice
          buff.write(_get_struct_B().pack(_x))
          _v224 = _v223.rectangular
          _v225 = _v224.center_point
          _v226 = _v225.x_coordinate
          _x = _v226.value
          buff.write(_get_struct_h().pack(_x))
          _v227 = _v225.y_coordinate
          _x = _v227.value
          buff.write(_get_struct_h().pack(_x))
          _v228 = _v225.z_coordinate
          _x = _v228.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v225.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v224.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v229 = _v224.semi_length
          _x = _v229.value
          buff.write(_get_struct_H().pack(_x))
          _v230 = _v224.semi_breadth
          _x = _v230.value
          buff.write(_get_struct_H().pack(_x))
          _v231 = _v224.orientation
          _x = _v231.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v224.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v232 = _v224.height
          _x = _v232.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v224.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v233 = _v223.circular
          _v234 = _v233.shape_reference_point
          _v235 = _v234.x_coordinate
          _x = _v235.value
          buff.write(_get_struct_h().pack(_x))
          _v236 = _v234.y_coordinate
          _x = _v236.value
          buff.write(_get_struct_h().pack(_x))
          _v237 = _v234.z_coordinate
          _x = _v237.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v234.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v233.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v238 = _v233.radius
          _x = _v238.value
          buff.write(_get_struct_H().pack(_x))
          _v239 = _v233.height
          _x = _v239.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v233.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v240 = _v223.polygonal
          _v241 = _v240.shape_reference_point
          _v242 = _v241.x_coordinate
          _x = _v242.value
          buff.write(_get_struct_h().pack(_x))
          _v243 = _v241.y_coordinate
          _x = _v243.value
          buff.write(_get_struct_h().pack(_x))
          _v244 = _v241.z_coordinate
          _x = _v244.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v241.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v240.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v245 = _v240.polygon
          length = len(_v245.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v245.array:
            _v246 = val9.x_coordinate
            _x = _v246.value
            buff.write(_get_struct_h().pack(_x))
            _v247 = val9.y_coordinate
            _x = _v247.value
            buff.write(_get_struct_h().pack(_x))
            _v248 = val9.z_coordinate
            _x = _v248.value
            buff.write(_get_struct_h().pack(_x))
            _x = val9.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v249 = _v240.height
          _x = _v249.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v240.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v250 = _v223.elliptical
          _v251 = _v250.shape_reference_point
          _v252 = _v251.x_coordinate
          _x = _v252.value
          buff.write(_get_struct_h().pack(_x))
          _v253 = _v251.y_coordinate
          _x = _v253.value
          buff.write(_get_struct_h().pack(_x))
          _v254 = _v251.z_coordinate
          _x = _v254.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v251.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v250.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v255 = _v250.semi_major_axis_length
          _x = _v255.value
          buff.write(_get_struct_H().pack(_x))
          _v256 = _v250.semi_minor_axis_length
          _x = _v256.value
          buff.write(_get_struct_H().pack(_x))
          _v257 = _v250.orientation
          _x = _v257.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v250.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v258 = _v250.height
          _x = _v258.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v250.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v259 = _v223.radial
          _v260 = _v259.shape_reference_point
          _v261 = _v260.x_coordinate
          _x = _v261.value
          buff.write(_get_struct_h().pack(_x))
          _v262 = _v260.y_coordinate
          _x = _v262.value
          buff.write(_get_struct_h().pack(_x))
          _v263 = _v260.z_coordinate
          _x = _v263.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v260.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v259.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v264 = _v259.range
          _x = _v264.value
          buff.write(_get_struct_H().pack(_x))
          _v265 = _v259.stationary_horizontal_opening_angle_start
          _x = _v265.value
          buff.write(_get_struct_H().pack(_x))
          _v266 = _v259.stationary_horizontal_opening_angle_end
          _x = _v266.value
          buff.write(_get_struct_H().pack(_x))
          _v267 = _v259.vertical_opening_angle_start
          _x = _v267.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v259.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v268 = _v259.vertical_opening_angle_end
          _x = _v268.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v259.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v269 = _v223.radial_shapes
          _v270 = _v269.ref_point_id
          _x = _v270.value
          buff.write(_get_struct_B().pack(_x))
          _v271 = _v269.x_coordinate
          _x = _v271.value
          buff.write(_get_struct_h().pack(_x))
          _v272 = _v269.y_coordinate
          _x = _v272.value
          buff.write(_get_struct_h().pack(_x))
          _v273 = _v269.z_coordinate
          _x = _v273.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v269.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v274 = _v269.radial_shapes_list
          length = len(_v274.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v274.array:
            _v275 = val9.range
            _x = _v275.value
            buff.write(_get_struct_H().pack(_x))
            _v276 = val9.horizontal_opening_angle_start
            _x = _v276.value
            buff.write(_get_struct_H().pack(_x))
            _v277 = val9.horizontal_opening_angle_end
            _x = _v277.value
            buff.write(_get_struct_H().pack(_x))
            _v278 = val9.vertical_opening_angle_start
            _x = _v278.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v279 = val9.vertical_opening_angle_end
            _x = _v279.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = _v221.cluster_bounding_box_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v280 = _v221.cluster_cardinality_size
          _x = _v280.value
          buff.write(_get_struct_B().pack(_x))
          _v281 = _v221.cluster_profiles
          _x = _v281.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v281.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _x = _v221.cluster_profiles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v282 = _v214.other_sub_class
          _x = _v282.value
          buff.write(_get_struct_B().pack(_x))
          _v283 = val3.confidence
          _x = _v283.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.classification_is_present
        buff.write(_get_struct_B().pack(_x))
        _v284 = val1.map_position
        _v285 = _v284.map_reference
        _x = _v285.choice
        buff.write(_get_struct_B().pack(_x))
        _v286 = _v285.roadsegment
        _v287 = _v286.region
        _x = _v287.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v286.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v288 = _v286.id
        _x = _v288.value
        buff.write(_get_struct_H().pack(_x))
        _v289 = _v285.intersection
        _v290 = _v289.region
        _x = _v290.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v289.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v291 = _v289.id
        _x = _v291.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v284.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v292 = _v284.lane_id
        _x = _v292.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v284.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v293 = _v284.connection_id
        _x = _v293.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v284.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v294 = _v284.longitudinal_lane_position
        _v295 = _v294.longitudinal_lane_position_value
        _x = _v295.value
        buff.write(_get_struct_H().pack(_x))
        _v296 = _v294.longitudinal_lane_position_confidence
        _x = _v296.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v284.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_position_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.container_id is None:
        self.container_id = etsi_its_cpm_ts_msgs.msg.CpmContainerId()
      if self.container_data is None:
        self.container_data = etsi_its_cpm_ts_msgs.msg.CpmContainers()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.container_id.value, _x.container_data.choice.value, _x.container_data.originating_vehicle_container.orientation_angle.value.value, _x.container_data.originating_vehicle_container.orientation_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle.value.value, _x.container_data.originating_vehicle_container.pitch_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle_is_present, _x.container_data.originating_vehicle_container.roll_angle.value.value, _x.container_data.originating_vehicle_container.roll_angle.confidence.value, _x.container_data.originating_vehicle_container.roll_angle_is_present,) = _get_struct_2BHBH2BH2B().unpack(str[start:end])
      self.container_data.originating_vehicle_container.pitch_angle_is_present = bool(self.container_data.originating_vehicle_container.pitch_angle_is_present)
      self.container_data.originating_vehicle_container.roll_angle_is_present = bool(self.container_data.originating_vehicle_container.roll_angle_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.originating_vehicle_container.trailer_data_set.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.TrailerData()
        _v297 = val1.ref_point_id
        start = end
        end += 1
        (_v297.value,) = _get_struct_B().unpack(str[start:end])
        _v298 = val1.hitch_point_offset
        start = end
        end += 1
        (_v298.value,) = _get_struct_B().unpack(str[start:end])
        _v299 = val1.front_overhang
        start = end
        end += 1
        (_v299.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.front_overhang_is_present = bool(val1.front_overhang_is_present)
        _v300 = val1.rear_overhang
        start = end
        end += 1
        (_v300.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.rear_overhang_is_present = bool(val1.rear_overhang_is_present)
        _v301 = val1.trailer_width
        start = end
        end += 1
        (_v301.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trailer_width_is_present = bool(val1.trailer_width_is_present)
        _v302 = val1.hitch_angle
        _v303 = _v302.value
        start = end
        end += 2
        (_v303.value,) = _get_struct_H().unpack(str[start:end])
        _v304 = _v302.confidence
        start = end
        end += 1
        (_v304.value,) = _get_struct_B().unpack(str[start:end])
        self.container_data.originating_vehicle_container.trailer_data_set.array.append(val1)
      _x = self
      start = end
      end += 13
      (_x.container_data.originating_vehicle_container.trailer_data_set_is_present, _x.container_data.originating_rsu_container.map_reference.choice, _x.container_data.originating_rsu_container.map_reference.roadsegment.region.value, _x.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present, _x.container_data.originating_rsu_container.map_reference.roadsegment.id.value, _x.container_data.originating_rsu_container.map_reference.intersection.region.value, _x.container_data.originating_rsu_container.map_reference.intersection.region_is_present, _x.container_data.originating_rsu_container.map_reference.intersection.id.value, _x.container_data.originating_rsu_container.map_reference_is_present,) = _get_struct_2BHB2HBHB().unpack(str[start:end])
      self.container_data.originating_vehicle_container.trailer_data_set_is_present = bool(self.container_data.originating_vehicle_container.trailer_data_set_is_present)
      self.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present = bool(self.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present)
      self.container_data.originating_rsu_container.map_reference.intersection.region_is_present = bool(self.container_data.originating_rsu_container.map_reference.intersection.region_is_present)
      self.container_data.originating_rsu_container.map_reference_is_present = bool(self.container_data.originating_rsu_container.map_reference_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.sensor_information_container.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
        _v305 = val1.sensor_id
        start = end
        end += 1
        (_v305.value,) = _get_struct_B().unpack(str[start:end])
        _v306 = val1.sensor_type
        start = end
        end += 1
        (_v306.value,) = _get_struct_B().unpack(str[start:end])
        _v307 = val1.perception_region_shape
        start = end
        end += 1
        (_v307.choice,) = _get_struct_B().unpack(str[start:end])
        _v308 = _v307.rectangular
        _v309 = _v308.center_point
        _v310 = _v309.x_coordinate
        start = end
        end += 2
        (_v310.value,) = _get_struct_h().unpack(str[start:end])
        _v311 = _v309.y_coordinate
        start = end
        end += 2
        (_v311.value,) = _get_struct_h().unpack(str[start:end])
        _v312 = _v309.z_coordinate
        start = end
        end += 2
        (_v312.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v309.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v309.z_coordinate_is_present = bool(_v309.z_coordinate_is_present)
        start = end
        end += 1
        (_v308.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v308.center_point_is_present = bool(_v308.center_point_is_present)
        _v313 = _v308.semi_length
        start = end
        end += 2
        (_v313.value,) = _get_struct_H().unpack(str[start:end])
        _v314 = _v308.semi_breadth
        start = end
        end += 2
        (_v314.value,) = _get_struct_H().unpack(str[start:end])
        _v315 = _v308.orientation
        start = end
        end += 2
        (_v315.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v308.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v308.orientation_is_present = bool(_v308.orientation_is_present)
        _v316 = _v308.height
        start = end
        end += 2
        (_v316.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v308.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v308.height_is_present = bool(_v308.height_is_present)
        _v317 = _v307.circular
        _v318 = _v317.shape_reference_point
        _v319 = _v318.x_coordinate
        start = end
        end += 2
        (_v319.value,) = _get_struct_h().unpack(str[start:end])
        _v320 = _v318.y_coordinate
        start = end
        end += 2
        (_v320.value,) = _get_struct_h().unpack(str[start:end])
        _v321 = _v318.z_coordinate
        start = end
        end += 2
        (_v321.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v318.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v318.z_coordinate_is_present = bool(_v318.z_coordinate_is_present)
        start = end
        end += 1
        (_v317.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v317.shape_reference_point_is_present = bool(_v317.shape_reference_point_is_present)
        _v322 = _v317.radius
        start = end
        end += 2
        (_v322.value,) = _get_struct_H().unpack(str[start:end])
        _v323 = _v317.height
        start = end
        end += 2
        (_v323.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v317.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v317.height_is_present = bool(_v317.height_is_present)
        _v324 = _v307.polygonal
        _v325 = _v324.shape_reference_point
        _v326 = _v325.x_coordinate
        start = end
        end += 2
        (_v326.value,) = _get_struct_h().unpack(str[start:end])
        _v327 = _v325.y_coordinate
        start = end
        end += 2
        (_v327.value,) = _get_struct_h().unpack(str[start:end])
        _v328 = _v325.z_coordinate
        start = end
        end += 2
        (_v328.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v325.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v325.z_coordinate_is_present = bool(_v325.z_coordinate_is_present)
        start = end
        end += 1
        (_v324.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v324.shape_reference_point_is_present = bool(_v324.shape_reference_point_is_present)
        _v329 = _v324.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v329.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v330 = val5.x_coordinate
          start = end
          end += 2
          (_v330.value,) = _get_struct_h().unpack(str[start:end])
          _v331 = val5.y_coordinate
          start = end
          end += 2
          (_v331.value,) = _get_struct_h().unpack(str[start:end])
          _v332 = val5.z_coordinate
          start = end
          end += 2
          (_v332.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v329.array.append(val5)
        _v333 = _v324.height
        start = end
        end += 2
        (_v333.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v324.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v324.height_is_present = bool(_v324.height_is_present)
        _v334 = _v307.elliptical
        _v335 = _v334.shape_reference_point
        _v336 = _v335.x_coordinate
        start = end
        end += 2
        (_v336.value,) = _get_struct_h().unpack(str[start:end])
        _v337 = _v335.y_coordinate
        start = end
        end += 2
        (_v337.value,) = _get_struct_h().unpack(str[start:end])
        _v338 = _v335.z_coordinate
        start = end
        end += 2
        (_v338.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v335.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v335.z_coordinate_is_present = bool(_v335.z_coordinate_is_present)
        start = end
        end += 1
        (_v334.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v334.shape_reference_point_is_present = bool(_v334.shape_reference_point_is_present)
        _v339 = _v334.semi_major_axis_length
        start = end
        end += 2
        (_v339.value,) = _get_struct_H().unpack(str[start:end])
        _v340 = _v334.semi_minor_axis_length
        start = end
        end += 2
        (_v340.value,) = _get_struct_H().unpack(str[start:end])
        _v341 = _v334.orientation
        start = end
        end += 2
        (_v341.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v334.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v334.orientation_is_present = bool(_v334.orientation_is_present)
        _v342 = _v334.height
        start = end
        end += 2
        (_v342.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v334.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v334.height_is_present = bool(_v334.height_is_present)
        _v343 = _v307.radial
        _v344 = _v343.shape_reference_point
        _v345 = _v344.x_coordinate
        start = end
        end += 2
        (_v345.value,) = _get_struct_h().unpack(str[start:end])
        _v346 = _v344.y_coordinate
        start = end
        end += 2
        (_v346.value,) = _get_struct_h().unpack(str[start:end])
        _v347 = _v344.z_coordinate
        start = end
        end += 2
        (_v347.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v344.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v344.z_coordinate_is_present = bool(_v344.z_coordinate_is_present)
        start = end
        end += 1
        (_v343.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v343.shape_reference_point_is_present = bool(_v343.shape_reference_point_is_present)
        _v348 = _v343.range
        start = end
        end += 2
        (_v348.value,) = _get_struct_H().unpack(str[start:end])
        _v349 = _v343.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v349.value,) = _get_struct_H().unpack(str[start:end])
        _v350 = _v343.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v350.value,) = _get_struct_H().unpack(str[start:end])
        _v351 = _v343.vertical_opening_angle_start
        start = end
        end += 2
        (_v351.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v343.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v343.vertical_opening_angle_start_is_present = bool(_v343.vertical_opening_angle_start_is_present)
        _v352 = _v343.vertical_opening_angle_end
        start = end
        end += 2
        (_v352.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v343.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v343.vertical_opening_angle_end_is_present = bool(_v343.vertical_opening_angle_end_is_present)
        _v353 = _v307.radial_shapes
        _v354 = _v353.ref_point_id
        start = end
        end += 1
        (_v354.value,) = _get_struct_B().unpack(str[start:end])
        _v355 = _v353.x_coordinate
        start = end
        end += 2
        (_v355.value,) = _get_struct_h().unpack(str[start:end])
        _v356 = _v353.y_coordinate
        start = end
        end += 2
        (_v356.value,) = _get_struct_h().unpack(str[start:end])
        _v357 = _v353.z_coordinate
        start = end
        end += 2
        (_v357.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v353.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v353.z_coordinate_is_present = bool(_v353.z_coordinate_is_present)
        _v358 = _v353.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v358.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v359 = val5.range
          start = end
          end += 2
          (_v359.value,) = _get_struct_H().unpack(str[start:end])
          _v360 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v360.value,) = _get_struct_H().unpack(str[start:end])
          _v361 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v361.value,) = _get_struct_H().unpack(str[start:end])
          _v362 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v362.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v363 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v363.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v358.array.append(val5)
        start = end
        end += 1
        (val1.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perception_region_shape_is_present = bool(val1.perception_region_shape_is_present)
        _v364 = val1.perception_region_confidence
        start = end
        end += 1
        (_v364.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
        val1.perception_region_confidence_is_present = bool(val1.perception_region_confidence_is_present)
        val1.shadowing_applies = bool(val1.shadowing_applies)
        self.container_data.sensor_information_container.array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.perception_region_container.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
        _v365 = val1.measurement_delta_time
        start = end
        end += 2
        (_v365.value,) = _get_struct_h().unpack(str[start:end])
        _v366 = val1.perception_region_confidence
        start = end
        end += 1
        (_v366.value,) = _get_struct_B().unpack(str[start:end])
        _v367 = val1.perception_region_shape
        start = end
        end += 1
        (_v367.choice,) = _get_struct_B().unpack(str[start:end])
        _v368 = _v367.rectangular
        _v369 = _v368.center_point
        _v370 = _v369.x_coordinate
        start = end
        end += 2
        (_v370.value,) = _get_struct_h().unpack(str[start:end])
        _v371 = _v369.y_coordinate
        start = end
        end += 2
        (_v371.value,) = _get_struct_h().unpack(str[start:end])
        _v372 = _v369.z_coordinate
        start = end
        end += 2
        (_v372.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v369.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v369.z_coordinate_is_present = bool(_v369.z_coordinate_is_present)
        start = end
        end += 1
        (_v368.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v368.center_point_is_present = bool(_v368.center_point_is_present)
        _v373 = _v368.semi_length
        start = end
        end += 2
        (_v373.value,) = _get_struct_H().unpack(str[start:end])
        _v374 = _v368.semi_breadth
        start = end
        end += 2
        (_v374.value,) = _get_struct_H().unpack(str[start:end])
        _v375 = _v368.orientation
        start = end
        end += 2
        (_v375.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v368.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v368.orientation_is_present = bool(_v368.orientation_is_present)
        _v376 = _v368.height
        start = end
        end += 2
        (_v376.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v368.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v368.height_is_present = bool(_v368.height_is_present)
        _v377 = _v367.circular
        _v378 = _v377.shape_reference_point
        _v379 = _v378.x_coordinate
        start = end
        end += 2
        (_v379.value,) = _get_struct_h().unpack(str[start:end])
        _v380 = _v378.y_coordinate
        start = end
        end += 2
        (_v380.value,) = _get_struct_h().unpack(str[start:end])
        _v381 = _v378.z_coordinate
        start = end
        end += 2
        (_v381.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v378.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v378.z_coordinate_is_present = bool(_v378.z_coordinate_is_present)
        start = end
        end += 1
        (_v377.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v377.shape_reference_point_is_present = bool(_v377.shape_reference_point_is_present)
        _v382 = _v377.radius
        start = end
        end += 2
        (_v382.value,) = _get_struct_H().unpack(str[start:end])
        _v383 = _v377.height
        start = end
        end += 2
        (_v383.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v377.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v377.height_is_present = bool(_v377.height_is_present)
        _v384 = _v367.polygonal
        _v385 = _v384.shape_reference_point
        _v386 = _v385.x_coordinate
        start = end
        end += 2
        (_v386.value,) = _get_struct_h().unpack(str[start:end])
        _v387 = _v385.y_coordinate
        start = end
        end += 2
        (_v387.value,) = _get_struct_h().unpack(str[start:end])
        _v388 = _v385.z_coordinate
        start = end
        end += 2
        (_v388.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v385.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v385.z_coordinate_is_present = bool(_v385.z_coordinate_is_present)
        start = end
        end += 1
        (_v384.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v384.shape_reference_point_is_present = bool(_v384.shape_reference_point_is_present)
        _v389 = _v384.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v389.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v390 = val5.x_coordinate
          start = end
          end += 2
          (_v390.value,) = _get_struct_h().unpack(str[start:end])
          _v391 = val5.y_coordinate
          start = end
          end += 2
          (_v391.value,) = _get_struct_h().unpack(str[start:end])
          _v392 = val5.z_coordinate
          start = end
          end += 2
          (_v392.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v389.array.append(val5)
        _v393 = _v384.height
        start = end
        end += 2
        (_v393.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v384.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v384.height_is_present = bool(_v384.height_is_present)
        _v394 = _v367.elliptical
        _v395 = _v394.shape_reference_point
        _v396 = _v395.x_coordinate
        start = end
        end += 2
        (_v396.value,) = _get_struct_h().unpack(str[start:end])
        _v397 = _v395.y_coordinate
        start = end
        end += 2
        (_v397.value,) = _get_struct_h().unpack(str[start:end])
        _v398 = _v395.z_coordinate
        start = end
        end += 2
        (_v398.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v395.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v395.z_coordinate_is_present = bool(_v395.z_coordinate_is_present)
        start = end
        end += 1
        (_v394.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v394.shape_reference_point_is_present = bool(_v394.shape_reference_point_is_present)
        _v399 = _v394.semi_major_axis_length
        start = end
        end += 2
        (_v399.value,) = _get_struct_H().unpack(str[start:end])
        _v400 = _v394.semi_minor_axis_length
        start = end
        end += 2
        (_v400.value,) = _get_struct_H().unpack(str[start:end])
        _v401 = _v394.orientation
        start = end
        end += 2
        (_v401.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v394.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v394.orientation_is_present = bool(_v394.orientation_is_present)
        _v402 = _v394.height
        start = end
        end += 2
        (_v402.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v394.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v394.height_is_present = bool(_v394.height_is_present)
        _v403 = _v367.radial
        _v404 = _v403.shape_reference_point
        _v405 = _v404.x_coordinate
        start = end
        end += 2
        (_v405.value,) = _get_struct_h().unpack(str[start:end])
        _v406 = _v404.y_coordinate
        start = end
        end += 2
        (_v406.value,) = _get_struct_h().unpack(str[start:end])
        _v407 = _v404.z_coordinate
        start = end
        end += 2
        (_v407.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v404.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v404.z_coordinate_is_present = bool(_v404.z_coordinate_is_present)
        start = end
        end += 1
        (_v403.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v403.shape_reference_point_is_present = bool(_v403.shape_reference_point_is_present)
        _v408 = _v403.range
        start = end
        end += 2
        (_v408.value,) = _get_struct_H().unpack(str[start:end])
        _v409 = _v403.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v409.value,) = _get_struct_H().unpack(str[start:end])
        _v410 = _v403.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v410.value,) = _get_struct_H().unpack(str[start:end])
        _v411 = _v403.vertical_opening_angle_start
        start = end
        end += 2
        (_v411.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v403.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v403.vertical_opening_angle_start_is_present = bool(_v403.vertical_opening_angle_start_is_present)
        _v412 = _v403.vertical_opening_angle_end
        start = end
        end += 2
        (_v412.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v403.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v403.vertical_opening_angle_end_is_present = bool(_v403.vertical_opening_angle_end_is_present)
        _v413 = _v367.radial_shapes
        _v414 = _v413.ref_point_id
        start = end
        end += 1
        (_v414.value,) = _get_struct_B().unpack(str[start:end])
        _v415 = _v413.x_coordinate
        start = end
        end += 2
        (_v415.value,) = _get_struct_h().unpack(str[start:end])
        _v416 = _v413.y_coordinate
        start = end
        end += 2
        (_v416.value,) = _get_struct_h().unpack(str[start:end])
        _v417 = _v413.z_coordinate
        start = end
        end += 2
        (_v417.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v413.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v413.z_coordinate_is_present = bool(_v413.z_coordinate_is_present)
        _v418 = _v413.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v418.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v419 = val5.range
          start = end
          end += 2
          (_v419.value,) = _get_struct_H().unpack(str[start:end])
          _v420 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v420.value,) = _get_struct_H().unpack(str[start:end])
          _v421 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v421.value,) = _get_struct_H().unpack(str[start:end])
          _v422 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v422.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v423 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v423.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v418.array.append(val5)
        start = end
        end += 1
        (val1.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
        val1.shadowing_applies = bool(val1.shadowing_applies)
        _v424 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v424.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v424.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v425 = val1.number_of_perceived_objects
        start = end
        end += 1
        (_v425.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.number_of_perceived_objects_is_present = bool(val1.number_of_perceived_objects_is_present)
        _v426 = val1.perceived_object_ids
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v426.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
          start = end
          end += 2
          (val3.value,) = _get_struct_H().unpack(str[start:end])
          _v426.array.append(val3)
        start = end
        end += 1
        (val1.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perceived_object_ids_is_present = bool(val1.perceived_object_ids_is_present)
        self.container_data.perception_region_container.array.append(val1)
      start = end
      end += 1
      (self.container_data.perceived_object_container.number_of_perceived_objects.value,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.perceived_object_container.perceived_objects.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
        _v427 = val1.object_id
        start = end
        end += 2
        (_v427.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_id_is_present = bool(val1.object_id_is_present)
        _v428 = val1.measurement_delta_time
        start = end
        end += 2
        (_v428.value,) = _get_struct_h().unpack(str[start:end])
        _v429 = val1.position
        _v430 = _v429.x_coordinate
        _v431 = _v430.value
        start = end
        end += 4
        (_v431.value,) = _get_struct_i().unpack(str[start:end])
        _v432 = _v430.confidence
        start = end
        end += 2
        (_v432.value,) = _get_struct_H().unpack(str[start:end])
        _v433 = _v429.y_coordinate
        _v434 = _v433.value
        start = end
        end += 4
        (_v434.value,) = _get_struct_i().unpack(str[start:end])
        _v435 = _v433.confidence
        start = end
        end += 2
        (_v435.value,) = _get_struct_H().unpack(str[start:end])
        _v436 = _v429.z_coordinate
        _v437 = _v436.value
        start = end
        end += 4
        (_v437.value,) = _get_struct_i().unpack(str[start:end])
        _v438 = _v436.confidence
        start = end
        end += 2
        (_v438.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v429.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v429.z_coordinate_is_present = bool(_v429.z_coordinate_is_present)
        _v439 = val1.velocity
        start = end
        end += 1
        (_v439.choice,) = _get_struct_B().unpack(str[start:end])
        _v440 = _v439.polar_velocity
        _v441 = _v440.velocity_magnitude
        _v442 = _v441.speed_value
        start = end
        end += 2
        (_v442.value,) = _get_struct_H().unpack(str[start:end])
        _v443 = _v441.speed_confidence
        start = end
        end += 1
        (_v443.value,) = _get_struct_B().unpack(str[start:end])
        _v444 = _v440.velocity_direction
        _v445 = _v444.value
        start = end
        end += 2
        (_v445.value,) = _get_struct_H().unpack(str[start:end])
        _v446 = _v444.confidence
        start = end
        end += 1
        (_v446.value,) = _get_struct_B().unpack(str[start:end])
        _v447 = _v440.z_velocity
        _v448 = _v447.value
        start = end
        end += 2
        (_v448.value,) = _get_struct_h().unpack(str[start:end])
        _v449 = _v447.confidence
        start = end
        end += 1
        (_v449.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v440.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v440.z_velocity_is_present = bool(_v440.z_velocity_is_present)
        _v450 = _v439.cartesian_velocity
        _v451 = _v450.x_velocity
        _v452 = _v451.value
        start = end
        end += 2
        (_v452.value,) = _get_struct_h().unpack(str[start:end])
        _v453 = _v451.confidence
        start = end
        end += 1
        (_v453.value,) = _get_struct_B().unpack(str[start:end])
        _v454 = _v450.y_velocity
        _v455 = _v454.value
        start = end
        end += 2
        (_v455.value,) = _get_struct_h().unpack(str[start:end])
        _v456 = _v454.confidence
        start = end
        end += 1
        (_v456.value,) = _get_struct_B().unpack(str[start:end])
        _v457 = _v450.z_velocity
        _v458 = _v457.value
        start = end
        end += 2
        (_v458.value,) = _get_struct_h().unpack(str[start:end])
        _v459 = _v457.confidence
        start = end
        end += 1
        (_v459.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v450.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v450.z_velocity_is_present = bool(_v450.z_velocity_is_present)
        start = end
        end += 1
        (val1.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.velocity_is_present = bool(val1.velocity_is_present)
        _v460 = val1.acceleration
        start = end
        end += 1
        (_v460.choice,) = _get_struct_B().unpack(str[start:end])
        _v461 = _v460.polar_acceleration
        _v462 = _v461.acceleration_magnitude
        _v463 = _v462.acceleration_magnitude_value
        start = end
        end += 1
        (_v463.value,) = _get_struct_B().unpack(str[start:end])
        _v464 = _v462.acceleration_confidence
        start = end
        end += 1
        (_v464.value,) = _get_struct_B().unpack(str[start:end])
        _v465 = _v461.acceleration_direction
        _v466 = _v465.value
        start = end
        end += 2
        (_v466.value,) = _get_struct_H().unpack(str[start:end])
        _v467 = _v465.confidence
        start = end
        end += 1
        (_v467.value,) = _get_struct_B().unpack(str[start:end])
        _v468 = _v461.z_acceleration
        _v469 = _v468.value
        start = end
        end += 2
        (_v469.value,) = _get_struct_h().unpack(str[start:end])
        _v470 = _v468.confidence
        start = end
        end += 1
        (_v470.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v461.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v461.z_acceleration_is_present = bool(_v461.z_acceleration_is_present)
        _v471 = _v460.cartesian_acceleration
        _v472 = _v471.x_acceleration
        _v473 = _v472.value
        start = end
        end += 2
        (_v473.value,) = _get_struct_h().unpack(str[start:end])
        _v474 = _v472.confidence
        start = end
        end += 1
        (_v474.value,) = _get_struct_B().unpack(str[start:end])
        _v475 = _v471.y_acceleration
        _v476 = _v475.value
        start = end
        end += 2
        (_v476.value,) = _get_struct_h().unpack(str[start:end])
        _v477 = _v475.confidence
        start = end
        end += 1
        (_v477.value,) = _get_struct_B().unpack(str[start:end])
        _v478 = _v471.z_acceleration
        _v479 = _v478.value
        start = end
        end += 2
        (_v479.value,) = _get_struct_h().unpack(str[start:end])
        _v480 = _v478.confidence
        start = end
        end += 1
        (_v480.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v471.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v471.z_acceleration_is_present = bool(_v471.z_acceleration_is_present)
        start = end
        end += 1
        (val1.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.acceleration_is_present = bool(val1.acceleration_is_present)
        _v481 = val1.angles
        _v482 = _v481.z_angle
        _v483 = _v482.value
        start = end
        end += 2
        (_v483.value,) = _get_struct_H().unpack(str[start:end])
        _v484 = _v482.confidence
        start = end
        end += 1
        (_v484.value,) = _get_struct_B().unpack(str[start:end])
        _v485 = _v481.y_angle
        _v486 = _v485.value
        start = end
        end += 2
        (_v486.value,) = _get_struct_H().unpack(str[start:end])
        _v487 = _v485.confidence
        start = end
        end += 1
        (_v487.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v481.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v481.y_angle_is_present = bool(_v481.y_angle_is_present)
        _v488 = _v481.x_angle
        _v489 = _v488.value
        start = end
        end += 2
        (_v489.value,) = _get_struct_H().unpack(str[start:end])
        _v490 = _v488.confidence
        start = end
        end += 1
        (_v490.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v481.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v481.x_angle_is_present = bool(_v481.x_angle_is_present)
        start = end
        end += 1
        (val1.angles_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.angles_is_present = bool(val1.angles_is_present)
        _v491 = val1.z_angular_velocity
        _v492 = _v491.value
        start = end
        end += 2
        (_v492.value,) = _get_struct_h().unpack(str[start:end])
        _v493 = _v491.confidence
        start = end
        end += 1
        (_v493.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_angular_velocity_is_present = bool(val1.z_angular_velocity_is_present)
        _v494 = val1.lower_triangular_correlation_matrices
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v494.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
          _v495 = val3.components_included_inthe_matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v495.value = str[start:end]
          start = end
          end += 1
          (_v495.bits_unused,) = _get_struct_B().unpack(str[start:end])
          _v496 = val3.matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v496.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val5.array = []
            for i in range(0, length):
              val6 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
              start = end
              end += 1
              (val6.value,) = _get_struct_b().unpack(str[start:end])
              val5.array.append(val6)
            _v496.array.append(val5)
          _v494.array.append(val3)
        start = end
        end += 1
        (val1.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lower_triangular_correlation_matrices_is_present = bool(val1.lower_triangular_correlation_matrices_is_present)
        _v497 = val1.object_dimension_z
        _v498 = _v497.value
        start = end
        end += 2
        (_v498.value,) = _get_struct_H().unpack(str[start:end])
        _v499 = _v497.confidence
        start = end
        end += 1
        (_v499.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_z_is_present = bool(val1.object_dimension_z_is_present)
        _v500 = val1.object_dimension_y
        _v501 = _v500.value
        start = end
        end += 2
        (_v501.value,) = _get_struct_H().unpack(str[start:end])
        _v502 = _v500.confidence
        start = end
        end += 1
        (_v502.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_y_is_present = bool(val1.object_dimension_y_is_present)
        _v503 = val1.object_dimension_x
        _v504 = _v503.value
        start = end
        end += 2
        (_v504.value,) = _get_struct_H().unpack(str[start:end])
        _v505 = _v503.confidence
        start = end
        end += 1
        (_v505.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_x_is_present = bool(val1.object_dimension_x_is_present)
        _v506 = val1.object_age
        start = end
        end += 2
        (_v506.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_age_is_present = bool(val1.object_age_is_present)
        _v507 = val1.object_perception_quality
        start = end
        end += 1
        (_v507.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_perception_quality_is_present = bool(val1.object_perception_quality_is_present)
        _v508 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v508.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v508.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v509 = val1.classification
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v509.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
          _v510 = val3.object_class
          start = end
          end += 1
          (_v510.choice,) = _get_struct_B().unpack(str[start:end])
          _v511 = _v510.vehicle_sub_class
          start = end
          end += 1
          (_v511.value,) = _get_struct_B().unpack(str[start:end])
          _v512 = _v510.vru_sub_class
          start = end
          end += 1
          (_v512.choice,) = _get_struct_B().unpack(str[start:end])
          _v513 = _v512.pedestrian
          start = end
          end += 1
          (_v513.value,) = _get_struct_B().unpack(str[start:end])
          _v514 = _v512.bicyclist_and_light_vru_vehicle
          start = end
          end += 1
          (_v514.value,) = _get_struct_B().unpack(str[start:end])
          _v515 = _v512.motorcyclist
          start = end
          end += 1
          (_v515.value,) = _get_struct_B().unpack(str[start:end])
          _v516 = _v512.animal
          start = end
          end += 1
          (_v516.value,) = _get_struct_B().unpack(str[start:end])
          _v517 = _v510.group_sub_class
          _v518 = _v517.cluster_id
          start = end
          end += 1
          (_v518.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v517.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v517.cluster_id_is_present = bool(_v517.cluster_id_is_present)
          _v519 = _v517.cluster_bounding_box_shape
          start = end
          end += 1
          (_v519.choice,) = _get_struct_B().unpack(str[start:end])
          _v520 = _v519.rectangular
          _v521 = _v520.center_point
          _v522 = _v521.x_coordinate
          start = end
          end += 2
          (_v522.value,) = _get_struct_h().unpack(str[start:end])
          _v523 = _v521.y_coordinate
          start = end
          end += 2
          (_v523.value,) = _get_struct_h().unpack(str[start:end])
          _v524 = _v521.z_coordinate
          start = end
          end += 2
          (_v524.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v521.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v521.z_coordinate_is_present = bool(_v521.z_coordinate_is_present)
          start = end
          end += 1
          (_v520.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v520.center_point_is_present = bool(_v520.center_point_is_present)
          _v525 = _v520.semi_length
          start = end
          end += 2
          (_v525.value,) = _get_struct_H().unpack(str[start:end])
          _v526 = _v520.semi_breadth
          start = end
          end += 2
          (_v526.value,) = _get_struct_H().unpack(str[start:end])
          _v527 = _v520.orientation
          start = end
          end += 2
          (_v527.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v520.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v520.orientation_is_present = bool(_v520.orientation_is_present)
          _v528 = _v520.height
          start = end
          end += 2
          (_v528.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v520.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v520.height_is_present = bool(_v520.height_is_present)
          _v529 = _v519.circular
          _v530 = _v529.shape_reference_point
          _v531 = _v530.x_coordinate
          start = end
          end += 2
          (_v531.value,) = _get_struct_h().unpack(str[start:end])
          _v532 = _v530.y_coordinate
          start = end
          end += 2
          (_v532.value,) = _get_struct_h().unpack(str[start:end])
          _v533 = _v530.z_coordinate
          start = end
          end += 2
          (_v533.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v530.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v530.z_coordinate_is_present = bool(_v530.z_coordinate_is_present)
          start = end
          end += 1
          (_v529.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v529.shape_reference_point_is_present = bool(_v529.shape_reference_point_is_present)
          _v534 = _v529.radius
          start = end
          end += 2
          (_v534.value,) = _get_struct_H().unpack(str[start:end])
          _v535 = _v529.height
          start = end
          end += 2
          (_v535.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v529.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v529.height_is_present = bool(_v529.height_is_present)
          _v536 = _v519.polygonal
          _v537 = _v536.shape_reference_point
          _v538 = _v537.x_coordinate
          start = end
          end += 2
          (_v538.value,) = _get_struct_h().unpack(str[start:end])
          _v539 = _v537.y_coordinate
          start = end
          end += 2
          (_v539.value,) = _get_struct_h().unpack(str[start:end])
          _v540 = _v537.z_coordinate
          start = end
          end += 2
          (_v540.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v537.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v537.z_coordinate_is_present = bool(_v537.z_coordinate_is_present)
          start = end
          end += 1
          (_v536.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v536.shape_reference_point_is_present = bool(_v536.shape_reference_point_is_present)
          _v541 = _v536.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v541.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v542 = val9.x_coordinate
            start = end
            end += 2
            (_v542.value,) = _get_struct_h().unpack(str[start:end])
            _v543 = val9.y_coordinate
            start = end
            end += 2
            (_v543.value,) = _get_struct_h().unpack(str[start:end])
            _v544 = val9.z_coordinate
            start = end
            end += 2
            (_v544.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val9.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.z_coordinate_is_present = bool(val9.z_coordinate_is_present)
            _v541.array.append(val9)
          _v545 = _v536.height
          start = end
          end += 2
          (_v545.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v536.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v536.height_is_present = bool(_v536.height_is_present)
          _v546 = _v519.elliptical
          _v547 = _v546.shape_reference_point
          _v548 = _v547.x_coordinate
          start = end
          end += 2
          (_v548.value,) = _get_struct_h().unpack(str[start:end])
          _v549 = _v547.y_coordinate
          start = end
          end += 2
          (_v549.value,) = _get_struct_h().unpack(str[start:end])
          _v550 = _v547.z_coordinate
          start = end
          end += 2
          (_v550.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v547.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v547.z_coordinate_is_present = bool(_v547.z_coordinate_is_present)
          start = end
          end += 1
          (_v546.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v546.shape_reference_point_is_present = bool(_v546.shape_reference_point_is_present)
          _v551 = _v546.semi_major_axis_length
          start = end
          end += 2
          (_v551.value,) = _get_struct_H().unpack(str[start:end])
          _v552 = _v546.semi_minor_axis_length
          start = end
          end += 2
          (_v552.value,) = _get_struct_H().unpack(str[start:end])
          _v553 = _v546.orientation
          start = end
          end += 2
          (_v553.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v546.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v546.orientation_is_present = bool(_v546.orientation_is_present)
          _v554 = _v546.height
          start = end
          end += 2
          (_v554.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v546.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v546.height_is_present = bool(_v546.height_is_present)
          _v555 = _v519.radial
          _v556 = _v555.shape_reference_point
          _v557 = _v556.x_coordinate
          start = end
          end += 2
          (_v557.value,) = _get_struct_h().unpack(str[start:end])
          _v558 = _v556.y_coordinate
          start = end
          end += 2
          (_v558.value,) = _get_struct_h().unpack(str[start:end])
          _v559 = _v556.z_coordinate
          start = end
          end += 2
          (_v559.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v556.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v556.z_coordinate_is_present = bool(_v556.z_coordinate_is_present)
          start = end
          end += 1
          (_v555.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v555.shape_reference_point_is_present = bool(_v555.shape_reference_point_is_present)
          _v560 = _v555.range
          start = end
          end += 2
          (_v560.value,) = _get_struct_H().unpack(str[start:end])
          _v561 = _v555.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v561.value,) = _get_struct_H().unpack(str[start:end])
          _v562 = _v555.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v562.value,) = _get_struct_H().unpack(str[start:end])
          _v563 = _v555.vertical_opening_angle_start
          start = end
          end += 2
          (_v563.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v555.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v555.vertical_opening_angle_start_is_present = bool(_v555.vertical_opening_angle_start_is_present)
          _v564 = _v555.vertical_opening_angle_end
          start = end
          end += 2
          (_v564.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v555.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v555.vertical_opening_angle_end_is_present = bool(_v555.vertical_opening_angle_end_is_present)
          _v565 = _v519.radial_shapes
          _v566 = _v565.ref_point_id
          start = end
          end += 1
          (_v566.value,) = _get_struct_B().unpack(str[start:end])
          _v567 = _v565.x_coordinate
          start = end
          end += 2
          (_v567.value,) = _get_struct_h().unpack(str[start:end])
          _v568 = _v565.y_coordinate
          start = end
          end += 2
          (_v568.value,) = _get_struct_h().unpack(str[start:end])
          _v569 = _v565.z_coordinate
          start = end
          end += 2
          (_v569.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v565.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v565.z_coordinate_is_present = bool(_v565.z_coordinate_is_present)
          _v570 = _v565.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v570.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v571 = val9.range
            start = end
            end += 2
            (_v571.value,) = _get_struct_H().unpack(str[start:end])
            _v572 = val9.horizontal_opening_angle_start
            start = end
            end += 2
            (_v572.value,) = _get_struct_H().unpack(str[start:end])
            _v573 = val9.horizontal_opening_angle_end
            start = end
            end += 2
            (_v573.value,) = _get_struct_H().unpack(str[start:end])
            _v574 = val9.vertical_opening_angle_start
            start = end
            end += 2
            (_v574.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_start_is_present = bool(val9.vertical_opening_angle_start_is_present)
            _v575 = val9.vertical_opening_angle_end
            start = end
            end += 2
            (_v575.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_end_is_present = bool(val9.vertical_opening_angle_end_is_present)
            _v570.array.append(val9)
          start = end
          end += 1
          (_v517.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          _v517.cluster_bounding_box_shape_is_present = bool(_v517.cluster_bounding_box_shape_is_present)
          _v576 = _v517.cluster_cardinality_size
          start = end
          end += 1
          (_v576.value,) = _get_struct_B().unpack(str[start:end])
          _v577 = _v517.cluster_profiles
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v577.value = str[start:end]
          start = end
          end += 1
          (_v577.bits_unused,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v517.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
          _v517.cluster_profiles_is_present = bool(_v517.cluster_profiles_is_present)
          _v578 = _v510.other_sub_class
          start = end
          end += 1
          (_v578.value,) = _get_struct_B().unpack(str[start:end])
          _v579 = val3.confidence
          start = end
          end += 1
          (_v579.value,) = _get_struct_B().unpack(str[start:end])
          _v509.array.append(val3)
        start = end
        end += 1
        (val1.classification_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.classification_is_present = bool(val1.classification_is_present)
        _v580 = val1.map_position
        _v581 = _v580.map_reference
        start = end
        end += 1
        (_v581.choice,) = _get_struct_B().unpack(str[start:end])
        _v582 = _v581.roadsegment
        _v583 = _v582.region
        start = end
        end += 2
        (_v583.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v582.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v582.region_is_present = bool(_v582.region_is_present)
        _v584 = _v582.id
        start = end
        end += 2
        (_v584.value,) = _get_struct_H().unpack(str[start:end])
        _v585 = _v581.intersection
        _v586 = _v585.region
        start = end
        end += 2
        (_v586.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v585.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v585.region_is_present = bool(_v585.region_is_present)
        _v587 = _v585.id
        start = end
        end += 2
        (_v587.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v580.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v580.map_reference_is_present = bool(_v580.map_reference_is_present)
        _v588 = _v580.lane_id
        start = end
        end += 1
        (_v588.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v580.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v580.lane_id_is_present = bool(_v580.lane_id_is_present)
        _v589 = _v580.connection_id
        start = end
        end += 1
        (_v589.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v580.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v580.connection_id_is_present = bool(_v580.connection_id_is_present)
        _v590 = _v580.longitudinal_lane_position
        _v591 = _v590.longitudinal_lane_position_value
        start = end
        end += 2
        (_v591.value,) = _get_struct_H().unpack(str[start:end])
        _v592 = _v590.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v592.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v580.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v580.longitudinal_lane_position_is_present = bool(_v580.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_position_is_present = bool(val1.map_position_is_present)
        self.container_data.perceived_object_container.perceived_objects.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2BHBH2BH2B().pack(_x.container_id.value, _x.container_data.choice.value, _x.container_data.originating_vehicle_container.orientation_angle.value.value, _x.container_data.originating_vehicle_container.orientation_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle.value.value, _x.container_data.originating_vehicle_container.pitch_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle_is_present, _x.container_data.originating_vehicle_container.roll_angle.value.value, _x.container_data.originating_vehicle_container.roll_angle.confidence.value, _x.container_data.originating_vehicle_container.roll_angle_is_present))
      length = len(self.container_data.originating_vehicle_container.trailer_data_set.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.originating_vehicle_container.trailer_data_set.array:
        _v593 = val1.ref_point_id
        _x = _v593.value
        buff.write(_get_struct_B().pack(_x))
        _v594 = val1.hitch_point_offset
        _x = _v594.value
        buff.write(_get_struct_B().pack(_x))
        _v595 = val1.front_overhang
        _x = _v595.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.front_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v596 = val1.rear_overhang
        _x = _v596.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.rear_overhang_is_present
        buff.write(_get_struct_B().pack(_x))
        _v597 = val1.trailer_width
        _x = _v597.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trailer_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v598 = val1.hitch_angle
        _v599 = _v598.value
        _x = _v599.value
        buff.write(_get_struct_H().pack(_x))
        _v600 = _v598.confidence
        _x = _v600.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2BHB2HBHB().pack(_x.container_data.originating_vehicle_container.trailer_data_set_is_present, _x.container_data.originating_rsu_container.map_reference.choice, _x.container_data.originating_rsu_container.map_reference.roadsegment.region.value, _x.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present, _x.container_data.originating_rsu_container.map_reference.roadsegment.id.value, _x.container_data.originating_rsu_container.map_reference.intersection.region.value, _x.container_data.originating_rsu_container.map_reference.intersection.region_is_present, _x.container_data.originating_rsu_container.map_reference.intersection.id.value, _x.container_data.originating_rsu_container.map_reference_is_present))
      length = len(self.container_data.sensor_information_container.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.sensor_information_container.array:
        _v601 = val1.sensor_id
        _x = _v601.value
        buff.write(_get_struct_B().pack(_x))
        _v602 = val1.sensor_type
        _x = _v602.value
        buff.write(_get_struct_B().pack(_x))
        _v603 = val1.perception_region_shape
        _x = _v603.choice
        buff.write(_get_struct_B().pack(_x))
        _v604 = _v603.rectangular
        _v605 = _v604.center_point
        _v606 = _v605.x_coordinate
        _x = _v606.value
        buff.write(_get_struct_h().pack(_x))
        _v607 = _v605.y_coordinate
        _x = _v607.value
        buff.write(_get_struct_h().pack(_x))
        _v608 = _v605.z_coordinate
        _x = _v608.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v605.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v604.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v609 = _v604.semi_length
        _x = _v609.value
        buff.write(_get_struct_H().pack(_x))
        _v610 = _v604.semi_breadth
        _x = _v610.value
        buff.write(_get_struct_H().pack(_x))
        _v611 = _v604.orientation
        _x = _v611.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v604.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v612 = _v604.height
        _x = _v612.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v604.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v613 = _v603.circular
        _v614 = _v613.shape_reference_point
        _v615 = _v614.x_coordinate
        _x = _v615.value
        buff.write(_get_struct_h().pack(_x))
        _v616 = _v614.y_coordinate
        _x = _v616.value
        buff.write(_get_struct_h().pack(_x))
        _v617 = _v614.z_coordinate
        _x = _v617.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v614.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v613.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v618 = _v613.radius
        _x = _v618.value
        buff.write(_get_struct_H().pack(_x))
        _v619 = _v613.height
        _x = _v619.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v613.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v620 = _v603.polygonal
        _v621 = _v620.shape_reference_point
        _v622 = _v621.x_coordinate
        _x = _v622.value
        buff.write(_get_struct_h().pack(_x))
        _v623 = _v621.y_coordinate
        _x = _v623.value
        buff.write(_get_struct_h().pack(_x))
        _v624 = _v621.z_coordinate
        _x = _v624.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v621.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v620.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v625 = _v620.polygon
        length = len(_v625.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v625.array:
          _v626 = val5.x_coordinate
          _x = _v626.value
          buff.write(_get_struct_h().pack(_x))
          _v627 = val5.y_coordinate
          _x = _v627.value
          buff.write(_get_struct_h().pack(_x))
          _v628 = val5.z_coordinate
          _x = _v628.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v629 = _v620.height
        _x = _v629.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v620.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v630 = _v603.elliptical
        _v631 = _v630.shape_reference_point
        _v632 = _v631.x_coordinate
        _x = _v632.value
        buff.write(_get_struct_h().pack(_x))
        _v633 = _v631.y_coordinate
        _x = _v633.value
        buff.write(_get_struct_h().pack(_x))
        _v634 = _v631.z_coordinate
        _x = _v634.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v631.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v630.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v635 = _v630.semi_major_axis_length
        _x = _v635.value
        buff.write(_get_struct_H().pack(_x))
        _v636 = _v630.semi_minor_axis_length
        _x = _v636.value
        buff.write(_get_struct_H().pack(_x))
        _v637 = _v630.orientation
        _x = _v637.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v630.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v638 = _v630.height
        _x = _v638.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v630.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v639 = _v603.radial
        _v640 = _v639.shape_reference_point
        _v641 = _v640.x_coordinate
        _x = _v641.value
        buff.write(_get_struct_h().pack(_x))
        _v642 = _v640.y_coordinate
        _x = _v642.value
        buff.write(_get_struct_h().pack(_x))
        _v643 = _v640.z_coordinate
        _x = _v643.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v640.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v639.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v644 = _v639.range
        _x = _v644.value
        buff.write(_get_struct_H().pack(_x))
        _v645 = _v639.stationary_horizontal_opening_angle_start
        _x = _v645.value
        buff.write(_get_struct_H().pack(_x))
        _v646 = _v639.stationary_horizontal_opening_angle_end
        _x = _v646.value
        buff.write(_get_struct_H().pack(_x))
        _v647 = _v639.vertical_opening_angle_start
        _x = _v647.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v639.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v648 = _v639.vertical_opening_angle_end
        _x = _v648.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v639.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v649 = _v603.radial_shapes
        _v650 = _v649.ref_point_id
        _x = _v650.value
        buff.write(_get_struct_B().pack(_x))
        _v651 = _v649.x_coordinate
        _x = _v651.value
        buff.write(_get_struct_h().pack(_x))
        _v652 = _v649.y_coordinate
        _x = _v652.value
        buff.write(_get_struct_h().pack(_x))
        _v653 = _v649.z_coordinate
        _x = _v653.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v649.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v654 = _v649.radial_shapes_list
        length = len(_v654.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v654.array:
          _v655 = val5.range
          _x = _v655.value
          buff.write(_get_struct_H().pack(_x))
          _v656 = val5.horizontal_opening_angle_start
          _x = _v656.value
          buff.write(_get_struct_H().pack(_x))
          _v657 = val5.horizontal_opening_angle_end
          _x = _v657.value
          buff.write(_get_struct_H().pack(_x))
          _v658 = val5.vertical_opening_angle_start
          _x = _v658.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v659 = val5.vertical_opening_angle_end
          _x = _v659.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.perception_region_shape_is_present
        buff.write(_get_struct_B().pack(_x))
        _v660 = val1.perception_region_confidence
        _x = _v660.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
      length = len(self.container_data.perception_region_container.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.perception_region_container.array:
        _v661 = val1.measurement_delta_time
        _x = _v661.value
        buff.write(_get_struct_h().pack(_x))
        _v662 = val1.perception_region_confidence
        _x = _v662.value
        buff.write(_get_struct_B().pack(_x))
        _v663 = val1.perception_region_shape
        _x = _v663.choice
        buff.write(_get_struct_B().pack(_x))
        _v664 = _v663.rectangular
        _v665 = _v664.center_point
        _v666 = _v665.x_coordinate
        _x = _v666.value
        buff.write(_get_struct_h().pack(_x))
        _v667 = _v665.y_coordinate
        _x = _v667.value
        buff.write(_get_struct_h().pack(_x))
        _v668 = _v665.z_coordinate
        _x = _v668.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v665.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v664.center_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v669 = _v664.semi_length
        _x = _v669.value
        buff.write(_get_struct_H().pack(_x))
        _v670 = _v664.semi_breadth
        _x = _v670.value
        buff.write(_get_struct_H().pack(_x))
        _v671 = _v664.orientation
        _x = _v671.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v664.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v672 = _v664.height
        _x = _v672.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v664.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v673 = _v663.circular
        _v674 = _v673.shape_reference_point
        _v675 = _v674.x_coordinate
        _x = _v675.value
        buff.write(_get_struct_h().pack(_x))
        _v676 = _v674.y_coordinate
        _x = _v676.value
        buff.write(_get_struct_h().pack(_x))
        _v677 = _v674.z_coordinate
        _x = _v677.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v674.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v673.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v678 = _v673.radius
        _x = _v678.value
        buff.write(_get_struct_H().pack(_x))
        _v679 = _v673.height
        _x = _v679.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v673.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v680 = _v663.polygonal
        _v681 = _v680.shape_reference_point
        _v682 = _v681.x_coordinate
        _x = _v682.value
        buff.write(_get_struct_h().pack(_x))
        _v683 = _v681.y_coordinate
        _x = _v683.value
        buff.write(_get_struct_h().pack(_x))
        _v684 = _v681.z_coordinate
        _x = _v684.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v681.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v680.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v685 = _v680.polygon
        length = len(_v685.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v685.array:
          _v686 = val5.x_coordinate
          _x = _v686.value
          buff.write(_get_struct_h().pack(_x))
          _v687 = val5.y_coordinate
          _x = _v687.value
          buff.write(_get_struct_h().pack(_x))
          _v688 = val5.z_coordinate
          _x = _v688.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
        _v689 = _v680.height
        _x = _v689.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v680.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v690 = _v663.elliptical
        _v691 = _v690.shape_reference_point
        _v692 = _v691.x_coordinate
        _x = _v692.value
        buff.write(_get_struct_h().pack(_x))
        _v693 = _v691.y_coordinate
        _x = _v693.value
        buff.write(_get_struct_h().pack(_x))
        _v694 = _v691.z_coordinate
        _x = _v694.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v691.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v690.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v695 = _v690.semi_major_axis_length
        _x = _v695.value
        buff.write(_get_struct_H().pack(_x))
        _v696 = _v690.semi_minor_axis_length
        _x = _v696.value
        buff.write(_get_struct_H().pack(_x))
        _v697 = _v690.orientation
        _x = _v697.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v690.orientation_is_present
        buff.write(_get_struct_B().pack(_x))
        _v698 = _v690.height
        _x = _v698.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v690.height_is_present
        buff.write(_get_struct_B().pack(_x))
        _v699 = _v663.radial
        _v700 = _v699.shape_reference_point
        _v701 = _v700.x_coordinate
        _x = _v701.value
        buff.write(_get_struct_h().pack(_x))
        _v702 = _v700.y_coordinate
        _x = _v702.value
        buff.write(_get_struct_h().pack(_x))
        _v703 = _v700.z_coordinate
        _x = _v703.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v700.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = _v699.shape_reference_point_is_present
        buff.write(_get_struct_B().pack(_x))
        _v704 = _v699.range
        _x = _v704.value
        buff.write(_get_struct_H().pack(_x))
        _v705 = _v699.stationary_horizontal_opening_angle_start
        _x = _v705.value
        buff.write(_get_struct_H().pack(_x))
        _v706 = _v699.stationary_horizontal_opening_angle_end
        _x = _v706.value
        buff.write(_get_struct_H().pack(_x))
        _v707 = _v699.vertical_opening_angle_start
        _x = _v707.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v699.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v708 = _v699.vertical_opening_angle_end
        _x = _v708.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v699.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
        _v709 = _v663.radial_shapes
        _v710 = _v709.ref_point_id
        _x = _v710.value
        buff.write(_get_struct_B().pack(_x))
        _v711 = _v709.x_coordinate
        _x = _v711.value
        buff.write(_get_struct_h().pack(_x))
        _v712 = _v709.y_coordinate
        _x = _v712.value
        buff.write(_get_struct_h().pack(_x))
        _v713 = _v709.z_coordinate
        _x = _v713.value
        buff.write(_get_struct_h().pack(_x))
        _x = _v709.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v714 = _v709.radial_shapes_list
        length = len(_v714.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v714.array:
          _v715 = val5.range
          _x = _v715.value
          buff.write(_get_struct_H().pack(_x))
          _v716 = val5.horizontal_opening_angle_start
          _x = _v716.value
          buff.write(_get_struct_H().pack(_x))
          _v717 = val5.horizontal_opening_angle_end
          _x = _v717.value
          buff.write(_get_struct_H().pack(_x))
          _v718 = val5.vertical_opening_angle_start
          _x = _v718.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v719 = val5.vertical_opening_angle_end
          _x = _v719.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.shadowing_applies
        buff.write(_get_struct_B().pack(_x))
        _v720 = val1.sensor_id_list
        length = len(_v720.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v720.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v721 = val1.number_of_perceived_objects
        _x = _v721.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.number_of_perceived_objects_is_present
        buff.write(_get_struct_B().pack(_x))
        _v722 = val1.perceived_object_ids
        length = len(_v722.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v722.array:
          _x = val3.value
          buff.write(_get_struct_H().pack(_x))
        _x = val1.perceived_object_ids_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.container_data.perceived_object_container.number_of_perceived_objects.value
      buff.write(_get_struct_B().pack(_x))
      length = len(self.container_data.perceived_object_container.perceived_objects.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.container_data.perceived_object_container.perceived_objects.array:
        _v723 = val1.object_id
        _x = _v723.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.object_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v724 = val1.measurement_delta_time
        _x = _v724.value
        buff.write(_get_struct_h().pack(_x))
        _v725 = val1.position
        _v726 = _v725.x_coordinate
        _v727 = _v726.value
        _x = _v727.value
        buff.write(_get_struct_i().pack(_x))
        _v728 = _v726.confidence
        _x = _v728.value
        buff.write(_get_struct_H().pack(_x))
        _v729 = _v725.y_coordinate
        _v730 = _v729.value
        _x = _v730.value
        buff.write(_get_struct_i().pack(_x))
        _v731 = _v729.confidence
        _x = _v731.value
        buff.write(_get_struct_H().pack(_x))
        _v732 = _v725.z_coordinate
        _v733 = _v732.value
        _x = _v733.value
        buff.write(_get_struct_i().pack(_x))
        _v734 = _v732.confidence
        _x = _v734.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v725.z_coordinate_is_present
        buff.write(_get_struct_B().pack(_x))
        _v735 = val1.velocity
        _x = _v735.choice
        buff.write(_get_struct_B().pack(_x))
        _v736 = _v735.polar_velocity
        _v737 = _v736.velocity_magnitude
        _v738 = _v737.speed_value
        _x = _v738.value
        buff.write(_get_struct_H().pack(_x))
        _v739 = _v737.speed_confidence
        _x = _v739.value
        buff.write(_get_struct_B().pack(_x))
        _v740 = _v736.velocity_direction
        _v741 = _v740.value
        _x = _v741.value
        buff.write(_get_struct_H().pack(_x))
        _v742 = _v740.confidence
        _x = _v742.value
        buff.write(_get_struct_B().pack(_x))
        _v743 = _v736.z_velocity
        _v744 = _v743.value
        _x = _v744.value
        buff.write(_get_struct_h().pack(_x))
        _v745 = _v743.confidence
        _x = _v745.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v736.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v746 = _v735.cartesian_velocity
        _v747 = _v746.x_velocity
        _v748 = _v747.value
        _x = _v748.value
        buff.write(_get_struct_h().pack(_x))
        _v749 = _v747.confidence
        _x = _v749.value
        buff.write(_get_struct_B().pack(_x))
        _v750 = _v746.y_velocity
        _v751 = _v750.value
        _x = _v751.value
        buff.write(_get_struct_h().pack(_x))
        _v752 = _v750.confidence
        _x = _v752.value
        buff.write(_get_struct_B().pack(_x))
        _v753 = _v746.z_velocity
        _v754 = _v753.value
        _x = _v754.value
        buff.write(_get_struct_h().pack(_x))
        _v755 = _v753.confidence
        _x = _v755.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v746.z_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v756 = val1.acceleration
        _x = _v756.choice
        buff.write(_get_struct_B().pack(_x))
        _v757 = _v756.polar_acceleration
        _v758 = _v757.acceleration_magnitude
        _v759 = _v758.acceleration_magnitude_value
        _x = _v759.value
        buff.write(_get_struct_B().pack(_x))
        _v760 = _v758.acceleration_confidence
        _x = _v760.value
        buff.write(_get_struct_B().pack(_x))
        _v761 = _v757.acceleration_direction
        _v762 = _v761.value
        _x = _v762.value
        buff.write(_get_struct_H().pack(_x))
        _v763 = _v761.confidence
        _x = _v763.value
        buff.write(_get_struct_B().pack(_x))
        _v764 = _v757.z_acceleration
        _v765 = _v764.value
        _x = _v765.value
        buff.write(_get_struct_h().pack(_x))
        _v766 = _v764.confidence
        _x = _v766.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v757.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v767 = _v756.cartesian_acceleration
        _v768 = _v767.x_acceleration
        _v769 = _v768.value
        _x = _v769.value
        buff.write(_get_struct_h().pack(_x))
        _v770 = _v768.confidence
        _x = _v770.value
        buff.write(_get_struct_B().pack(_x))
        _v771 = _v767.y_acceleration
        _v772 = _v771.value
        _x = _v772.value
        buff.write(_get_struct_h().pack(_x))
        _v773 = _v771.confidence
        _x = _v773.value
        buff.write(_get_struct_B().pack(_x))
        _v774 = _v767.z_acceleration
        _v775 = _v774.value
        _x = _v775.value
        buff.write(_get_struct_h().pack(_x))
        _v776 = _v774.confidence
        _x = _v776.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v767.z_acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.acceleration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v777 = val1.angles
        _v778 = _v777.z_angle
        _v779 = _v778.value
        _x = _v779.value
        buff.write(_get_struct_H().pack(_x))
        _v780 = _v778.confidence
        _x = _v780.value
        buff.write(_get_struct_B().pack(_x))
        _v781 = _v777.y_angle
        _v782 = _v781.value
        _x = _v782.value
        buff.write(_get_struct_H().pack(_x))
        _v783 = _v781.confidence
        _x = _v783.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v777.y_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v784 = _v777.x_angle
        _v785 = _v784.value
        _x = _v785.value
        buff.write(_get_struct_H().pack(_x))
        _v786 = _v784.confidence
        _x = _v786.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v777.x_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.angles_is_present
        buff.write(_get_struct_B().pack(_x))
        _v787 = val1.z_angular_velocity
        _v788 = _v787.value
        _x = _v788.value
        buff.write(_get_struct_h().pack(_x))
        _v789 = _v787.confidence
        _x = _v789.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.z_angular_velocity_is_present
        buff.write(_get_struct_B().pack(_x))
        _v790 = val1.lower_triangular_correlation_matrices
        length = len(_v790.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v790.array:
          _v791 = val3.components_included_inthe_matrix
          _x = _v791.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v791.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _v792 = val3.matrix
          length = len(_v792.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v792.array:
            length = len(val5.array)
            buff.write(_struct_I.pack(length))
            for val6 in val5.array:
              _x = val6.value
              buff.write(_get_struct_b().pack(_x))
        _x = val1.lower_triangular_correlation_matrices_is_present
        buff.write(_get_struct_B().pack(_x))
        _v793 = val1.object_dimension_z
        _v794 = _v793.value
        _x = _v794.value
        buff.write(_get_struct_H().pack(_x))
        _v795 = _v793.confidence
        _x = _v795.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_z_is_present
        buff.write(_get_struct_B().pack(_x))
        _v796 = val1.object_dimension_y
        _v797 = _v796.value
        _x = _v797.value
        buff.write(_get_struct_H().pack(_x))
        _v798 = _v796.confidence
        _x = _v798.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_y_is_present
        buff.write(_get_struct_B().pack(_x))
        _v799 = val1.object_dimension_x
        _v800 = _v799.value
        _x = _v800.value
        buff.write(_get_struct_H().pack(_x))
        _v801 = _v799.confidence
        _x = _v801.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_dimension_x_is_present
        buff.write(_get_struct_B().pack(_x))
        _v802 = val1.object_age
        _x = _v802.value
        buff.write(_get_struct_h().pack(_x))
        _x = val1.object_age_is_present
        buff.write(_get_struct_B().pack(_x))
        _v803 = val1.object_perception_quality
        _x = _v803.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.object_perception_quality_is_present
        buff.write(_get_struct_B().pack(_x))
        _v804 = val1.sensor_id_list
        length = len(_v804.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v804.array:
          _x = val3.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.sensor_id_list_is_present
        buff.write(_get_struct_B().pack(_x))
        _v805 = val1.classification
        length = len(_v805.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v805.array:
          _v806 = val3.object_class
          _x = _v806.choice
          buff.write(_get_struct_B().pack(_x))
          _v807 = _v806.vehicle_sub_class
          _x = _v807.value
          buff.write(_get_struct_B().pack(_x))
          _v808 = _v806.vru_sub_class
          _x = _v808.choice
          buff.write(_get_struct_B().pack(_x))
          _v809 = _v808.pedestrian
          _x = _v809.value
          buff.write(_get_struct_B().pack(_x))
          _v810 = _v808.bicyclist_and_light_vru_vehicle
          _x = _v810.value
          buff.write(_get_struct_B().pack(_x))
          _v811 = _v808.motorcyclist
          _x = _v811.value
          buff.write(_get_struct_B().pack(_x))
          _v812 = _v808.animal
          _x = _v812.value
          buff.write(_get_struct_B().pack(_x))
          _v813 = _v806.group_sub_class
          _v814 = _v813.cluster_id
          _x = _v814.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v813.cluster_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v815 = _v813.cluster_bounding_box_shape
          _x = _v815.choice
          buff.write(_get_struct_B().pack(_x))
          _v816 = _v815.rectangular
          _v817 = _v816.center_point
          _v818 = _v817.x_coordinate
          _x = _v818.value
          buff.write(_get_struct_h().pack(_x))
          _v819 = _v817.y_coordinate
          _x = _v819.value
          buff.write(_get_struct_h().pack(_x))
          _v820 = _v817.z_coordinate
          _x = _v820.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v817.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v816.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v821 = _v816.semi_length
          _x = _v821.value
          buff.write(_get_struct_H().pack(_x))
          _v822 = _v816.semi_breadth
          _x = _v822.value
          buff.write(_get_struct_H().pack(_x))
          _v823 = _v816.orientation
          _x = _v823.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v816.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v824 = _v816.height
          _x = _v824.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v816.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v825 = _v815.circular
          _v826 = _v825.shape_reference_point
          _v827 = _v826.x_coordinate
          _x = _v827.value
          buff.write(_get_struct_h().pack(_x))
          _v828 = _v826.y_coordinate
          _x = _v828.value
          buff.write(_get_struct_h().pack(_x))
          _v829 = _v826.z_coordinate
          _x = _v829.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v826.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v825.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v830 = _v825.radius
          _x = _v830.value
          buff.write(_get_struct_H().pack(_x))
          _v831 = _v825.height
          _x = _v831.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v825.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v832 = _v815.polygonal
          _v833 = _v832.shape_reference_point
          _v834 = _v833.x_coordinate
          _x = _v834.value
          buff.write(_get_struct_h().pack(_x))
          _v835 = _v833.y_coordinate
          _x = _v835.value
          buff.write(_get_struct_h().pack(_x))
          _v836 = _v833.z_coordinate
          _x = _v836.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v833.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v832.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v837 = _v832.polygon
          length = len(_v837.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v837.array:
            _v838 = val9.x_coordinate
            _x = _v838.value
            buff.write(_get_struct_h().pack(_x))
            _v839 = val9.y_coordinate
            _x = _v839.value
            buff.write(_get_struct_h().pack(_x))
            _v840 = val9.z_coordinate
            _x = _v840.value
            buff.write(_get_struct_h().pack(_x))
            _x = val9.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v841 = _v832.height
          _x = _v841.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v832.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v842 = _v815.elliptical
          _v843 = _v842.shape_reference_point
          _v844 = _v843.x_coordinate
          _x = _v844.value
          buff.write(_get_struct_h().pack(_x))
          _v845 = _v843.y_coordinate
          _x = _v845.value
          buff.write(_get_struct_h().pack(_x))
          _v846 = _v843.z_coordinate
          _x = _v846.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v843.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v842.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v847 = _v842.semi_major_axis_length
          _x = _v847.value
          buff.write(_get_struct_H().pack(_x))
          _v848 = _v842.semi_minor_axis_length
          _x = _v848.value
          buff.write(_get_struct_H().pack(_x))
          _v849 = _v842.orientation
          _x = _v849.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v842.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v850 = _v842.height
          _x = _v850.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v842.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v851 = _v815.radial
          _v852 = _v851.shape_reference_point
          _v853 = _v852.x_coordinate
          _x = _v853.value
          buff.write(_get_struct_h().pack(_x))
          _v854 = _v852.y_coordinate
          _x = _v854.value
          buff.write(_get_struct_h().pack(_x))
          _v855 = _v852.z_coordinate
          _x = _v855.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v852.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v851.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v856 = _v851.range
          _x = _v856.value
          buff.write(_get_struct_H().pack(_x))
          _v857 = _v851.stationary_horizontal_opening_angle_start
          _x = _v857.value
          buff.write(_get_struct_H().pack(_x))
          _v858 = _v851.stationary_horizontal_opening_angle_end
          _x = _v858.value
          buff.write(_get_struct_H().pack(_x))
          _v859 = _v851.vertical_opening_angle_start
          _x = _v859.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v851.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v860 = _v851.vertical_opening_angle_end
          _x = _v860.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v851.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v861 = _v815.radial_shapes
          _v862 = _v861.ref_point_id
          _x = _v862.value
          buff.write(_get_struct_B().pack(_x))
          _v863 = _v861.x_coordinate
          _x = _v863.value
          buff.write(_get_struct_h().pack(_x))
          _v864 = _v861.y_coordinate
          _x = _v864.value
          buff.write(_get_struct_h().pack(_x))
          _v865 = _v861.z_coordinate
          _x = _v865.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v861.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v866 = _v861.radial_shapes_list
          length = len(_v866.array)
          buff.write(_struct_I.pack(length))
          for val9 in _v866.array:
            _v867 = val9.range
            _x = _v867.value
            buff.write(_get_struct_H().pack(_x))
            _v868 = val9.horizontal_opening_angle_start
            _x = _v868.value
            buff.write(_get_struct_H().pack(_x))
            _v869 = val9.horizontal_opening_angle_end
            _x = _v869.value
            buff.write(_get_struct_H().pack(_x))
            _v870 = val9.vertical_opening_angle_start
            _x = _v870.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v871 = val9.vertical_opening_angle_end
            _x = _v871.value
            buff.write(_get_struct_H().pack(_x))
            _x = val9.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = _v813.cluster_bounding_box_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v872 = _v813.cluster_cardinality_size
          _x = _v872.value
          buff.write(_get_struct_B().pack(_x))
          _v873 = _v813.cluster_profiles
          _x = _v873.value
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = _v873.bits_unused
          buff.write(_get_struct_B().pack(_x))
          _x = _v813.cluster_profiles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v874 = _v806.other_sub_class
          _x = _v874.value
          buff.write(_get_struct_B().pack(_x))
          _v875 = val3.confidence
          _x = _v875.value
          buff.write(_get_struct_B().pack(_x))
        _x = val1.classification_is_present
        buff.write(_get_struct_B().pack(_x))
        _v876 = val1.map_position
        _v877 = _v876.map_reference
        _x = _v877.choice
        buff.write(_get_struct_B().pack(_x))
        _v878 = _v877.roadsegment
        _v879 = _v878.region
        _x = _v879.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v878.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v880 = _v878.id
        _x = _v880.value
        buff.write(_get_struct_H().pack(_x))
        _v881 = _v877.intersection
        _v882 = _v881.region
        _x = _v882.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v881.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v883 = _v881.id
        _x = _v883.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v876.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v884 = _v876.lane_id
        _x = _v884.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v876.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v885 = _v876.connection_id
        _x = _v885.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v876.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v886 = _v876.longitudinal_lane_position
        _v887 = _v886.longitudinal_lane_position_value
        _x = _v887.value
        buff.write(_get_struct_H().pack(_x))
        _v888 = _v886.longitudinal_lane_position_confidence
        _x = _v888.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v876.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_position_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.container_id is None:
        self.container_id = etsi_its_cpm_ts_msgs.msg.CpmContainerId()
      if self.container_data is None:
        self.container_data = etsi_its_cpm_ts_msgs.msg.CpmContainers()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.container_id.value, _x.container_data.choice.value, _x.container_data.originating_vehicle_container.orientation_angle.value.value, _x.container_data.originating_vehicle_container.orientation_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle.value.value, _x.container_data.originating_vehicle_container.pitch_angle.confidence.value, _x.container_data.originating_vehicle_container.pitch_angle_is_present, _x.container_data.originating_vehicle_container.roll_angle.value.value, _x.container_data.originating_vehicle_container.roll_angle.confidence.value, _x.container_data.originating_vehicle_container.roll_angle_is_present,) = _get_struct_2BHBH2BH2B().unpack(str[start:end])
      self.container_data.originating_vehicle_container.pitch_angle_is_present = bool(self.container_data.originating_vehicle_container.pitch_angle_is_present)
      self.container_data.originating_vehicle_container.roll_angle_is_present = bool(self.container_data.originating_vehicle_container.roll_angle_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.originating_vehicle_container.trailer_data_set.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.TrailerData()
        _v889 = val1.ref_point_id
        start = end
        end += 1
        (_v889.value,) = _get_struct_B().unpack(str[start:end])
        _v890 = val1.hitch_point_offset
        start = end
        end += 1
        (_v890.value,) = _get_struct_B().unpack(str[start:end])
        _v891 = val1.front_overhang
        start = end
        end += 1
        (_v891.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.front_overhang_is_present = bool(val1.front_overhang_is_present)
        _v892 = val1.rear_overhang
        start = end
        end += 1
        (_v892.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.rear_overhang_is_present = bool(val1.rear_overhang_is_present)
        _v893 = val1.trailer_width
        start = end
        end += 1
        (_v893.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trailer_width_is_present = bool(val1.trailer_width_is_present)
        _v894 = val1.hitch_angle
        _v895 = _v894.value
        start = end
        end += 2
        (_v895.value,) = _get_struct_H().unpack(str[start:end])
        _v896 = _v894.confidence
        start = end
        end += 1
        (_v896.value,) = _get_struct_B().unpack(str[start:end])
        self.container_data.originating_vehicle_container.trailer_data_set.array.append(val1)
      _x = self
      start = end
      end += 13
      (_x.container_data.originating_vehicle_container.trailer_data_set_is_present, _x.container_data.originating_rsu_container.map_reference.choice, _x.container_data.originating_rsu_container.map_reference.roadsegment.region.value, _x.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present, _x.container_data.originating_rsu_container.map_reference.roadsegment.id.value, _x.container_data.originating_rsu_container.map_reference.intersection.region.value, _x.container_data.originating_rsu_container.map_reference.intersection.region_is_present, _x.container_data.originating_rsu_container.map_reference.intersection.id.value, _x.container_data.originating_rsu_container.map_reference_is_present,) = _get_struct_2BHB2HBHB().unpack(str[start:end])
      self.container_data.originating_vehicle_container.trailer_data_set_is_present = bool(self.container_data.originating_vehicle_container.trailer_data_set_is_present)
      self.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present = bool(self.container_data.originating_rsu_container.map_reference.roadsegment.region_is_present)
      self.container_data.originating_rsu_container.map_reference.intersection.region_is_present = bool(self.container_data.originating_rsu_container.map_reference.intersection.region_is_present)
      self.container_data.originating_rsu_container.map_reference_is_present = bool(self.container_data.originating_rsu_container.map_reference_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.sensor_information_container.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
        _v897 = val1.sensor_id
        start = end
        end += 1
        (_v897.value,) = _get_struct_B().unpack(str[start:end])
        _v898 = val1.sensor_type
        start = end
        end += 1
        (_v898.value,) = _get_struct_B().unpack(str[start:end])
        _v899 = val1.perception_region_shape
        start = end
        end += 1
        (_v899.choice,) = _get_struct_B().unpack(str[start:end])
        _v900 = _v899.rectangular
        _v901 = _v900.center_point
        _v902 = _v901.x_coordinate
        start = end
        end += 2
        (_v902.value,) = _get_struct_h().unpack(str[start:end])
        _v903 = _v901.y_coordinate
        start = end
        end += 2
        (_v903.value,) = _get_struct_h().unpack(str[start:end])
        _v904 = _v901.z_coordinate
        start = end
        end += 2
        (_v904.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v901.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v901.z_coordinate_is_present = bool(_v901.z_coordinate_is_present)
        start = end
        end += 1
        (_v900.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v900.center_point_is_present = bool(_v900.center_point_is_present)
        _v905 = _v900.semi_length
        start = end
        end += 2
        (_v905.value,) = _get_struct_H().unpack(str[start:end])
        _v906 = _v900.semi_breadth
        start = end
        end += 2
        (_v906.value,) = _get_struct_H().unpack(str[start:end])
        _v907 = _v900.orientation
        start = end
        end += 2
        (_v907.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v900.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v900.orientation_is_present = bool(_v900.orientation_is_present)
        _v908 = _v900.height
        start = end
        end += 2
        (_v908.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v900.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v900.height_is_present = bool(_v900.height_is_present)
        _v909 = _v899.circular
        _v910 = _v909.shape_reference_point
        _v911 = _v910.x_coordinate
        start = end
        end += 2
        (_v911.value,) = _get_struct_h().unpack(str[start:end])
        _v912 = _v910.y_coordinate
        start = end
        end += 2
        (_v912.value,) = _get_struct_h().unpack(str[start:end])
        _v913 = _v910.z_coordinate
        start = end
        end += 2
        (_v913.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v910.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v910.z_coordinate_is_present = bool(_v910.z_coordinate_is_present)
        start = end
        end += 1
        (_v909.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v909.shape_reference_point_is_present = bool(_v909.shape_reference_point_is_present)
        _v914 = _v909.radius
        start = end
        end += 2
        (_v914.value,) = _get_struct_H().unpack(str[start:end])
        _v915 = _v909.height
        start = end
        end += 2
        (_v915.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v909.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v909.height_is_present = bool(_v909.height_is_present)
        _v916 = _v899.polygonal
        _v917 = _v916.shape_reference_point
        _v918 = _v917.x_coordinate
        start = end
        end += 2
        (_v918.value,) = _get_struct_h().unpack(str[start:end])
        _v919 = _v917.y_coordinate
        start = end
        end += 2
        (_v919.value,) = _get_struct_h().unpack(str[start:end])
        _v920 = _v917.z_coordinate
        start = end
        end += 2
        (_v920.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v917.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v917.z_coordinate_is_present = bool(_v917.z_coordinate_is_present)
        start = end
        end += 1
        (_v916.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v916.shape_reference_point_is_present = bool(_v916.shape_reference_point_is_present)
        _v921 = _v916.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v921.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v922 = val5.x_coordinate
          start = end
          end += 2
          (_v922.value,) = _get_struct_h().unpack(str[start:end])
          _v923 = val5.y_coordinate
          start = end
          end += 2
          (_v923.value,) = _get_struct_h().unpack(str[start:end])
          _v924 = val5.z_coordinate
          start = end
          end += 2
          (_v924.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v921.array.append(val5)
        _v925 = _v916.height
        start = end
        end += 2
        (_v925.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v916.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v916.height_is_present = bool(_v916.height_is_present)
        _v926 = _v899.elliptical
        _v927 = _v926.shape_reference_point
        _v928 = _v927.x_coordinate
        start = end
        end += 2
        (_v928.value,) = _get_struct_h().unpack(str[start:end])
        _v929 = _v927.y_coordinate
        start = end
        end += 2
        (_v929.value,) = _get_struct_h().unpack(str[start:end])
        _v930 = _v927.z_coordinate
        start = end
        end += 2
        (_v930.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v927.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v927.z_coordinate_is_present = bool(_v927.z_coordinate_is_present)
        start = end
        end += 1
        (_v926.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v926.shape_reference_point_is_present = bool(_v926.shape_reference_point_is_present)
        _v931 = _v926.semi_major_axis_length
        start = end
        end += 2
        (_v931.value,) = _get_struct_H().unpack(str[start:end])
        _v932 = _v926.semi_minor_axis_length
        start = end
        end += 2
        (_v932.value,) = _get_struct_H().unpack(str[start:end])
        _v933 = _v926.orientation
        start = end
        end += 2
        (_v933.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v926.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v926.orientation_is_present = bool(_v926.orientation_is_present)
        _v934 = _v926.height
        start = end
        end += 2
        (_v934.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v926.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v926.height_is_present = bool(_v926.height_is_present)
        _v935 = _v899.radial
        _v936 = _v935.shape_reference_point
        _v937 = _v936.x_coordinate
        start = end
        end += 2
        (_v937.value,) = _get_struct_h().unpack(str[start:end])
        _v938 = _v936.y_coordinate
        start = end
        end += 2
        (_v938.value,) = _get_struct_h().unpack(str[start:end])
        _v939 = _v936.z_coordinate
        start = end
        end += 2
        (_v939.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v936.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v936.z_coordinate_is_present = bool(_v936.z_coordinate_is_present)
        start = end
        end += 1
        (_v935.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v935.shape_reference_point_is_present = bool(_v935.shape_reference_point_is_present)
        _v940 = _v935.range
        start = end
        end += 2
        (_v940.value,) = _get_struct_H().unpack(str[start:end])
        _v941 = _v935.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v941.value,) = _get_struct_H().unpack(str[start:end])
        _v942 = _v935.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v942.value,) = _get_struct_H().unpack(str[start:end])
        _v943 = _v935.vertical_opening_angle_start
        start = end
        end += 2
        (_v943.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v935.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v935.vertical_opening_angle_start_is_present = bool(_v935.vertical_opening_angle_start_is_present)
        _v944 = _v935.vertical_opening_angle_end
        start = end
        end += 2
        (_v944.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v935.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v935.vertical_opening_angle_end_is_present = bool(_v935.vertical_opening_angle_end_is_present)
        _v945 = _v899.radial_shapes
        _v946 = _v945.ref_point_id
        start = end
        end += 1
        (_v946.value,) = _get_struct_B().unpack(str[start:end])
        _v947 = _v945.x_coordinate
        start = end
        end += 2
        (_v947.value,) = _get_struct_h().unpack(str[start:end])
        _v948 = _v945.y_coordinate
        start = end
        end += 2
        (_v948.value,) = _get_struct_h().unpack(str[start:end])
        _v949 = _v945.z_coordinate
        start = end
        end += 2
        (_v949.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v945.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v945.z_coordinate_is_present = bool(_v945.z_coordinate_is_present)
        _v950 = _v945.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v950.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v951 = val5.range
          start = end
          end += 2
          (_v951.value,) = _get_struct_H().unpack(str[start:end])
          _v952 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v952.value,) = _get_struct_H().unpack(str[start:end])
          _v953 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v953.value,) = _get_struct_H().unpack(str[start:end])
          _v954 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v954.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v955 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v955.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v950.array.append(val5)
        start = end
        end += 1
        (val1.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perception_region_shape_is_present = bool(val1.perception_region_shape_is_present)
        _v956 = val1.perception_region_confidence
        start = end
        end += 1
        (_v956.value,) = _get_struct_B().unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
        val1.perception_region_confidence_is_present = bool(val1.perception_region_confidence_is_present)
        val1.shadowing_applies = bool(val1.shadowing_applies)
        self.container_data.sensor_information_container.array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.perception_region_container.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
        _v957 = val1.measurement_delta_time
        start = end
        end += 2
        (_v957.value,) = _get_struct_h().unpack(str[start:end])
        _v958 = val1.perception_region_confidence
        start = end
        end += 1
        (_v958.value,) = _get_struct_B().unpack(str[start:end])
        _v959 = val1.perception_region_shape
        start = end
        end += 1
        (_v959.choice,) = _get_struct_B().unpack(str[start:end])
        _v960 = _v959.rectangular
        _v961 = _v960.center_point
        _v962 = _v961.x_coordinate
        start = end
        end += 2
        (_v962.value,) = _get_struct_h().unpack(str[start:end])
        _v963 = _v961.y_coordinate
        start = end
        end += 2
        (_v963.value,) = _get_struct_h().unpack(str[start:end])
        _v964 = _v961.z_coordinate
        start = end
        end += 2
        (_v964.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v961.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v961.z_coordinate_is_present = bool(_v961.z_coordinate_is_present)
        start = end
        end += 1
        (_v960.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v960.center_point_is_present = bool(_v960.center_point_is_present)
        _v965 = _v960.semi_length
        start = end
        end += 2
        (_v965.value,) = _get_struct_H().unpack(str[start:end])
        _v966 = _v960.semi_breadth
        start = end
        end += 2
        (_v966.value,) = _get_struct_H().unpack(str[start:end])
        _v967 = _v960.orientation
        start = end
        end += 2
        (_v967.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v960.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v960.orientation_is_present = bool(_v960.orientation_is_present)
        _v968 = _v960.height
        start = end
        end += 2
        (_v968.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v960.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v960.height_is_present = bool(_v960.height_is_present)
        _v969 = _v959.circular
        _v970 = _v969.shape_reference_point
        _v971 = _v970.x_coordinate
        start = end
        end += 2
        (_v971.value,) = _get_struct_h().unpack(str[start:end])
        _v972 = _v970.y_coordinate
        start = end
        end += 2
        (_v972.value,) = _get_struct_h().unpack(str[start:end])
        _v973 = _v970.z_coordinate
        start = end
        end += 2
        (_v973.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v970.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v970.z_coordinate_is_present = bool(_v970.z_coordinate_is_present)
        start = end
        end += 1
        (_v969.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v969.shape_reference_point_is_present = bool(_v969.shape_reference_point_is_present)
        _v974 = _v969.radius
        start = end
        end += 2
        (_v974.value,) = _get_struct_H().unpack(str[start:end])
        _v975 = _v969.height
        start = end
        end += 2
        (_v975.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v969.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v969.height_is_present = bool(_v969.height_is_present)
        _v976 = _v959.polygonal
        _v977 = _v976.shape_reference_point
        _v978 = _v977.x_coordinate
        start = end
        end += 2
        (_v978.value,) = _get_struct_h().unpack(str[start:end])
        _v979 = _v977.y_coordinate
        start = end
        end += 2
        (_v979.value,) = _get_struct_h().unpack(str[start:end])
        _v980 = _v977.z_coordinate
        start = end
        end += 2
        (_v980.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v977.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v977.z_coordinate_is_present = bool(_v977.z_coordinate_is_present)
        start = end
        end += 1
        (_v976.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v976.shape_reference_point_is_present = bool(_v976.shape_reference_point_is_present)
        _v981 = _v976.polygon
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v981.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
          _v982 = val5.x_coordinate
          start = end
          end += 2
          (_v982.value,) = _get_struct_h().unpack(str[start:end])
          _v983 = val5.y_coordinate
          start = end
          end += 2
          (_v983.value,) = _get_struct_h().unpack(str[start:end])
          _v984 = val5.z_coordinate
          start = end
          end += 2
          (_v984.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_coordinate_is_present = bool(val5.z_coordinate_is_present)
          _v981.array.append(val5)
        _v985 = _v976.height
        start = end
        end += 2
        (_v985.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v976.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v976.height_is_present = bool(_v976.height_is_present)
        _v986 = _v959.elliptical
        _v987 = _v986.shape_reference_point
        _v988 = _v987.x_coordinate
        start = end
        end += 2
        (_v988.value,) = _get_struct_h().unpack(str[start:end])
        _v989 = _v987.y_coordinate
        start = end
        end += 2
        (_v989.value,) = _get_struct_h().unpack(str[start:end])
        _v990 = _v987.z_coordinate
        start = end
        end += 2
        (_v990.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v987.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v987.z_coordinate_is_present = bool(_v987.z_coordinate_is_present)
        start = end
        end += 1
        (_v986.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v986.shape_reference_point_is_present = bool(_v986.shape_reference_point_is_present)
        _v991 = _v986.semi_major_axis_length
        start = end
        end += 2
        (_v991.value,) = _get_struct_H().unpack(str[start:end])
        _v992 = _v986.semi_minor_axis_length
        start = end
        end += 2
        (_v992.value,) = _get_struct_H().unpack(str[start:end])
        _v993 = _v986.orientation
        start = end
        end += 2
        (_v993.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v986.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
        _v986.orientation_is_present = bool(_v986.orientation_is_present)
        _v994 = _v986.height
        start = end
        end += 2
        (_v994.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v986.height_is_present,) = _get_struct_B().unpack(str[start:end])
        _v986.height_is_present = bool(_v986.height_is_present)
        _v995 = _v959.radial
        _v996 = _v995.shape_reference_point
        _v997 = _v996.x_coordinate
        start = end
        end += 2
        (_v997.value,) = _get_struct_h().unpack(str[start:end])
        _v998 = _v996.y_coordinate
        start = end
        end += 2
        (_v998.value,) = _get_struct_h().unpack(str[start:end])
        _v999 = _v996.z_coordinate
        start = end
        end += 2
        (_v999.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v996.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v996.z_coordinate_is_present = bool(_v996.z_coordinate_is_present)
        start = end
        end += 1
        (_v995.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
        _v995.shape_reference_point_is_present = bool(_v995.shape_reference_point_is_present)
        _v1000 = _v995.range
        start = end
        end += 2
        (_v1000.value,) = _get_struct_H().unpack(str[start:end])
        _v1001 = _v995.stationary_horizontal_opening_angle_start
        start = end
        end += 2
        (_v1001.value,) = _get_struct_H().unpack(str[start:end])
        _v1002 = _v995.stationary_horizontal_opening_angle_end
        start = end
        end += 2
        (_v1002.value,) = _get_struct_H().unpack(str[start:end])
        _v1003 = _v995.vertical_opening_angle_start
        start = end
        end += 2
        (_v1003.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v995.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        _v995.vertical_opening_angle_start_is_present = bool(_v995.vertical_opening_angle_start_is_present)
        _v1004 = _v995.vertical_opening_angle_end
        start = end
        end += 2
        (_v1004.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v995.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        _v995.vertical_opening_angle_end_is_present = bool(_v995.vertical_opening_angle_end_is_present)
        _v1005 = _v959.radial_shapes
        _v1006 = _v1005.ref_point_id
        start = end
        end += 1
        (_v1006.value,) = _get_struct_B().unpack(str[start:end])
        _v1007 = _v1005.x_coordinate
        start = end
        end += 2
        (_v1007.value,) = _get_struct_h().unpack(str[start:end])
        _v1008 = _v1005.y_coordinate
        start = end
        end += 2
        (_v1008.value,) = _get_struct_h().unpack(str[start:end])
        _v1009 = _v1005.z_coordinate
        start = end
        end += 2
        (_v1009.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (_v1005.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1005.z_coordinate_is_present = bool(_v1005.z_coordinate_is_present)
        _v1010 = _v1005.radial_shapes_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1010.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
          _v1011 = val5.range
          start = end
          end += 2
          (_v1011.value,) = _get_struct_H().unpack(str[start:end])
          _v1012 = val5.horizontal_opening_angle_start
          start = end
          end += 2
          (_v1012.value,) = _get_struct_H().unpack(str[start:end])
          _v1013 = val5.horizontal_opening_angle_end
          start = end
          end += 2
          (_v1013.value,) = _get_struct_H().unpack(str[start:end])
          _v1014 = val5.vertical_opening_angle_start
          start = end
          end += 2
          (_v1014.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_start_is_present = bool(val5.vertical_opening_angle_start_is_present)
          _v1015 = val5.vertical_opening_angle_end
          start = end
          end += 2
          (_v1015.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.vertical_opening_angle_end_is_present = bool(val5.vertical_opening_angle_end_is_present)
          _v1010.array.append(val5)
        start = end
        end += 1
        (val1.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
        val1.shadowing_applies = bool(val1.shadowing_applies)
        _v1016 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1016.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v1016.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v1017 = val1.number_of_perceived_objects
        start = end
        end += 1
        (_v1017.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.number_of_perceived_objects_is_present = bool(val1.number_of_perceived_objects_is_present)
        _v1018 = val1.perceived_object_ids
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1018.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
          start = end
          end += 2
          (val3.value,) = _get_struct_H().unpack(str[start:end])
          _v1018.array.append(val3)
        start = end
        end += 1
        (val1.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.perceived_object_ids_is_present = bool(val1.perceived_object_ids_is_present)
        self.container_data.perception_region_container.array.append(val1)
      start = end
      end += 1
      (self.container_data.perceived_object_container.number_of_perceived_objects.value,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.container_data.perceived_object_container.perceived_objects.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
        _v1019 = val1.object_id
        start = end
        end += 2
        (_v1019.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_id_is_present = bool(val1.object_id_is_present)
        _v1020 = val1.measurement_delta_time
        start = end
        end += 2
        (_v1020.value,) = _get_struct_h().unpack(str[start:end])
        _v1021 = val1.position
        _v1022 = _v1021.x_coordinate
        _v1023 = _v1022.value
        start = end
        end += 4
        (_v1023.value,) = _get_struct_i().unpack(str[start:end])
        _v1024 = _v1022.confidence
        start = end
        end += 2
        (_v1024.value,) = _get_struct_H().unpack(str[start:end])
        _v1025 = _v1021.y_coordinate
        _v1026 = _v1025.value
        start = end
        end += 4
        (_v1026.value,) = _get_struct_i().unpack(str[start:end])
        _v1027 = _v1025.confidence
        start = end
        end += 2
        (_v1027.value,) = _get_struct_H().unpack(str[start:end])
        _v1028 = _v1021.z_coordinate
        _v1029 = _v1028.value
        start = end
        end += 4
        (_v1029.value,) = _get_struct_i().unpack(str[start:end])
        _v1030 = _v1028.confidence
        start = end
        end += 2
        (_v1030.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v1021.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1021.z_coordinate_is_present = bool(_v1021.z_coordinate_is_present)
        _v1031 = val1.velocity
        start = end
        end += 1
        (_v1031.choice,) = _get_struct_B().unpack(str[start:end])
        _v1032 = _v1031.polar_velocity
        _v1033 = _v1032.velocity_magnitude
        _v1034 = _v1033.speed_value
        start = end
        end += 2
        (_v1034.value,) = _get_struct_H().unpack(str[start:end])
        _v1035 = _v1033.speed_confidence
        start = end
        end += 1
        (_v1035.value,) = _get_struct_B().unpack(str[start:end])
        _v1036 = _v1032.velocity_direction
        _v1037 = _v1036.value
        start = end
        end += 2
        (_v1037.value,) = _get_struct_H().unpack(str[start:end])
        _v1038 = _v1036.confidence
        start = end
        end += 1
        (_v1038.value,) = _get_struct_B().unpack(str[start:end])
        _v1039 = _v1032.z_velocity
        _v1040 = _v1039.value
        start = end
        end += 2
        (_v1040.value,) = _get_struct_h().unpack(str[start:end])
        _v1041 = _v1039.confidence
        start = end
        end += 1
        (_v1041.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1032.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1032.z_velocity_is_present = bool(_v1032.z_velocity_is_present)
        _v1042 = _v1031.cartesian_velocity
        _v1043 = _v1042.x_velocity
        _v1044 = _v1043.value
        start = end
        end += 2
        (_v1044.value,) = _get_struct_h().unpack(str[start:end])
        _v1045 = _v1043.confidence
        start = end
        end += 1
        (_v1045.value,) = _get_struct_B().unpack(str[start:end])
        _v1046 = _v1042.y_velocity
        _v1047 = _v1046.value
        start = end
        end += 2
        (_v1047.value,) = _get_struct_h().unpack(str[start:end])
        _v1048 = _v1046.confidence
        start = end
        end += 1
        (_v1048.value,) = _get_struct_B().unpack(str[start:end])
        _v1049 = _v1042.z_velocity
        _v1050 = _v1049.value
        start = end
        end += 2
        (_v1050.value,) = _get_struct_h().unpack(str[start:end])
        _v1051 = _v1049.confidence
        start = end
        end += 1
        (_v1051.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1042.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1042.z_velocity_is_present = bool(_v1042.z_velocity_is_present)
        start = end
        end += 1
        (val1.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.velocity_is_present = bool(val1.velocity_is_present)
        _v1052 = val1.acceleration
        start = end
        end += 1
        (_v1052.choice,) = _get_struct_B().unpack(str[start:end])
        _v1053 = _v1052.polar_acceleration
        _v1054 = _v1053.acceleration_magnitude
        _v1055 = _v1054.acceleration_magnitude_value
        start = end
        end += 1
        (_v1055.value,) = _get_struct_B().unpack(str[start:end])
        _v1056 = _v1054.acceleration_confidence
        start = end
        end += 1
        (_v1056.value,) = _get_struct_B().unpack(str[start:end])
        _v1057 = _v1053.acceleration_direction
        _v1058 = _v1057.value
        start = end
        end += 2
        (_v1058.value,) = _get_struct_H().unpack(str[start:end])
        _v1059 = _v1057.confidence
        start = end
        end += 1
        (_v1059.value,) = _get_struct_B().unpack(str[start:end])
        _v1060 = _v1053.z_acceleration
        _v1061 = _v1060.value
        start = end
        end += 2
        (_v1061.value,) = _get_struct_h().unpack(str[start:end])
        _v1062 = _v1060.confidence
        start = end
        end += 1
        (_v1062.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1053.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1053.z_acceleration_is_present = bool(_v1053.z_acceleration_is_present)
        _v1063 = _v1052.cartesian_acceleration
        _v1064 = _v1063.x_acceleration
        _v1065 = _v1064.value
        start = end
        end += 2
        (_v1065.value,) = _get_struct_h().unpack(str[start:end])
        _v1066 = _v1064.confidence
        start = end
        end += 1
        (_v1066.value,) = _get_struct_B().unpack(str[start:end])
        _v1067 = _v1063.y_acceleration
        _v1068 = _v1067.value
        start = end
        end += 2
        (_v1068.value,) = _get_struct_h().unpack(str[start:end])
        _v1069 = _v1067.confidence
        start = end
        end += 1
        (_v1069.value,) = _get_struct_B().unpack(str[start:end])
        _v1070 = _v1063.z_acceleration
        _v1071 = _v1070.value
        start = end
        end += 2
        (_v1071.value,) = _get_struct_h().unpack(str[start:end])
        _v1072 = _v1070.confidence
        start = end
        end += 1
        (_v1072.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1063.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1063.z_acceleration_is_present = bool(_v1063.z_acceleration_is_present)
        start = end
        end += 1
        (val1.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.acceleration_is_present = bool(val1.acceleration_is_present)
        _v1073 = val1.angles
        _v1074 = _v1073.z_angle
        _v1075 = _v1074.value
        start = end
        end += 2
        (_v1075.value,) = _get_struct_H().unpack(str[start:end])
        _v1076 = _v1074.confidence
        start = end
        end += 1
        (_v1076.value,) = _get_struct_B().unpack(str[start:end])
        _v1077 = _v1073.y_angle
        _v1078 = _v1077.value
        start = end
        end += 2
        (_v1078.value,) = _get_struct_H().unpack(str[start:end])
        _v1079 = _v1077.confidence
        start = end
        end += 1
        (_v1079.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1073.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1073.y_angle_is_present = bool(_v1073.y_angle_is_present)
        _v1080 = _v1073.x_angle
        _v1081 = _v1080.value
        start = end
        end += 2
        (_v1081.value,) = _get_struct_H().unpack(str[start:end])
        _v1082 = _v1080.confidence
        start = end
        end += 1
        (_v1082.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1073.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1073.x_angle_is_present = bool(_v1073.x_angle_is_present)
        start = end
        end += 1
        (val1.angles_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.angles_is_present = bool(val1.angles_is_present)
        _v1083 = val1.z_angular_velocity
        _v1084 = _v1083.value
        start = end
        end += 2
        (_v1084.value,) = _get_struct_h().unpack(str[start:end])
        _v1085 = _v1083.confidence
        start = end
        end += 1
        (_v1085.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.z_angular_velocity_is_present = bool(val1.z_angular_velocity_is_present)
        _v1086 = val1.lower_triangular_correlation_matrices
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1086.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
          _v1087 = val3.components_included_inthe_matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v1087.value = str[start:end]
          start = end
          end += 1
          (_v1087.bits_unused,) = _get_struct_B().unpack(str[start:end])
          _v1088 = val3.matrix
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1088.array = []
          for i in range(0, length):
            val5 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val5.array = []
            for i in range(0, length):
              val6 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
              start = end
              end += 1
              (val6.value,) = _get_struct_b().unpack(str[start:end])
              val5.array.append(val6)
            _v1088.array.append(val5)
          _v1086.array.append(val3)
        start = end
        end += 1
        (val1.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lower_triangular_correlation_matrices_is_present = bool(val1.lower_triangular_correlation_matrices_is_present)
        _v1089 = val1.object_dimension_z
        _v1090 = _v1089.value
        start = end
        end += 2
        (_v1090.value,) = _get_struct_H().unpack(str[start:end])
        _v1091 = _v1089.confidence
        start = end
        end += 1
        (_v1091.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_z_is_present = bool(val1.object_dimension_z_is_present)
        _v1092 = val1.object_dimension_y
        _v1093 = _v1092.value
        start = end
        end += 2
        (_v1093.value,) = _get_struct_H().unpack(str[start:end])
        _v1094 = _v1092.confidence
        start = end
        end += 1
        (_v1094.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_y_is_present = bool(val1.object_dimension_y_is_present)
        _v1095 = val1.object_dimension_x
        _v1096 = _v1095.value
        start = end
        end += 2
        (_v1096.value,) = _get_struct_H().unpack(str[start:end])
        _v1097 = _v1095.confidence
        start = end
        end += 1
        (_v1097.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_dimension_x_is_present = bool(val1.object_dimension_x_is_present)
        _v1098 = val1.object_age
        start = end
        end += 2
        (_v1098.value,) = _get_struct_h().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_age_is_present = bool(val1.object_age_is_present)
        _v1099 = val1.object_perception_quality
        start = end
        end += 1
        (_v1099.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.object_perception_quality_is_present = bool(val1.object_perception_quality_is_present)
        _v1100 = val1.sensor_id_list
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1100.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
          start = end
          end += 1
          (val3.value,) = _get_struct_B().unpack(str[start:end])
          _v1100.array.append(val3)
        start = end
        end += 1
        (val1.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.sensor_id_list_is_present = bool(val1.sensor_id_list_is_present)
        _v1101 = val1.classification
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1101.array = []
        for i in range(0, length):
          val3 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
          _v1102 = val3.object_class
          start = end
          end += 1
          (_v1102.choice,) = _get_struct_B().unpack(str[start:end])
          _v1103 = _v1102.vehicle_sub_class
          start = end
          end += 1
          (_v1103.value,) = _get_struct_B().unpack(str[start:end])
          _v1104 = _v1102.vru_sub_class
          start = end
          end += 1
          (_v1104.choice,) = _get_struct_B().unpack(str[start:end])
          _v1105 = _v1104.pedestrian
          start = end
          end += 1
          (_v1105.value,) = _get_struct_B().unpack(str[start:end])
          _v1106 = _v1104.bicyclist_and_light_vru_vehicle
          start = end
          end += 1
          (_v1106.value,) = _get_struct_B().unpack(str[start:end])
          _v1107 = _v1104.motorcyclist
          start = end
          end += 1
          (_v1107.value,) = _get_struct_B().unpack(str[start:end])
          _v1108 = _v1104.animal
          start = end
          end += 1
          (_v1108.value,) = _get_struct_B().unpack(str[start:end])
          _v1109 = _v1102.group_sub_class
          _v1110 = _v1109.cluster_id
          start = end
          end += 1
          (_v1110.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1109.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1109.cluster_id_is_present = bool(_v1109.cluster_id_is_present)
          _v1111 = _v1109.cluster_bounding_box_shape
          start = end
          end += 1
          (_v1111.choice,) = _get_struct_B().unpack(str[start:end])
          _v1112 = _v1111.rectangular
          _v1113 = _v1112.center_point
          _v1114 = _v1113.x_coordinate
          start = end
          end += 2
          (_v1114.value,) = _get_struct_h().unpack(str[start:end])
          _v1115 = _v1113.y_coordinate
          start = end
          end += 2
          (_v1115.value,) = _get_struct_h().unpack(str[start:end])
          _v1116 = _v1113.z_coordinate
          start = end
          end += 2
          (_v1116.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1113.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1113.z_coordinate_is_present = bool(_v1113.z_coordinate_is_present)
          start = end
          end += 1
          (_v1112.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1112.center_point_is_present = bool(_v1112.center_point_is_present)
          _v1117 = _v1112.semi_length
          start = end
          end += 2
          (_v1117.value,) = _get_struct_H().unpack(str[start:end])
          _v1118 = _v1112.semi_breadth
          start = end
          end += 2
          (_v1118.value,) = _get_struct_H().unpack(str[start:end])
          _v1119 = _v1112.orientation
          start = end
          end += 2
          (_v1119.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1112.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1112.orientation_is_present = bool(_v1112.orientation_is_present)
          _v1120 = _v1112.height
          start = end
          end += 2
          (_v1120.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1112.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1112.height_is_present = bool(_v1112.height_is_present)
          _v1121 = _v1111.circular
          _v1122 = _v1121.shape_reference_point
          _v1123 = _v1122.x_coordinate
          start = end
          end += 2
          (_v1123.value,) = _get_struct_h().unpack(str[start:end])
          _v1124 = _v1122.y_coordinate
          start = end
          end += 2
          (_v1124.value,) = _get_struct_h().unpack(str[start:end])
          _v1125 = _v1122.z_coordinate
          start = end
          end += 2
          (_v1125.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1122.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1122.z_coordinate_is_present = bool(_v1122.z_coordinate_is_present)
          start = end
          end += 1
          (_v1121.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1121.shape_reference_point_is_present = bool(_v1121.shape_reference_point_is_present)
          _v1126 = _v1121.radius
          start = end
          end += 2
          (_v1126.value,) = _get_struct_H().unpack(str[start:end])
          _v1127 = _v1121.height
          start = end
          end += 2
          (_v1127.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1121.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1121.height_is_present = bool(_v1121.height_is_present)
          _v1128 = _v1111.polygonal
          _v1129 = _v1128.shape_reference_point
          _v1130 = _v1129.x_coordinate
          start = end
          end += 2
          (_v1130.value,) = _get_struct_h().unpack(str[start:end])
          _v1131 = _v1129.y_coordinate
          start = end
          end += 2
          (_v1131.value,) = _get_struct_h().unpack(str[start:end])
          _v1132 = _v1129.z_coordinate
          start = end
          end += 2
          (_v1132.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1129.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1129.z_coordinate_is_present = bool(_v1129.z_coordinate_is_present)
          start = end
          end += 1
          (_v1128.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1128.shape_reference_point_is_present = bool(_v1128.shape_reference_point_is_present)
          _v1133 = _v1128.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1133.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v1134 = val9.x_coordinate
            start = end
            end += 2
            (_v1134.value,) = _get_struct_h().unpack(str[start:end])
            _v1135 = val9.y_coordinate
            start = end
            end += 2
            (_v1135.value,) = _get_struct_h().unpack(str[start:end])
            _v1136 = val9.z_coordinate
            start = end
            end += 2
            (_v1136.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val9.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.z_coordinate_is_present = bool(val9.z_coordinate_is_present)
            _v1133.array.append(val9)
          _v1137 = _v1128.height
          start = end
          end += 2
          (_v1137.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1128.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1128.height_is_present = bool(_v1128.height_is_present)
          _v1138 = _v1111.elliptical
          _v1139 = _v1138.shape_reference_point
          _v1140 = _v1139.x_coordinate
          start = end
          end += 2
          (_v1140.value,) = _get_struct_h().unpack(str[start:end])
          _v1141 = _v1139.y_coordinate
          start = end
          end += 2
          (_v1141.value,) = _get_struct_h().unpack(str[start:end])
          _v1142 = _v1139.z_coordinate
          start = end
          end += 2
          (_v1142.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1139.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1139.z_coordinate_is_present = bool(_v1139.z_coordinate_is_present)
          start = end
          end += 1
          (_v1138.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1138.shape_reference_point_is_present = bool(_v1138.shape_reference_point_is_present)
          _v1143 = _v1138.semi_major_axis_length
          start = end
          end += 2
          (_v1143.value,) = _get_struct_H().unpack(str[start:end])
          _v1144 = _v1138.semi_minor_axis_length
          start = end
          end += 2
          (_v1144.value,) = _get_struct_H().unpack(str[start:end])
          _v1145 = _v1138.orientation
          start = end
          end += 2
          (_v1145.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1138.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1138.orientation_is_present = bool(_v1138.orientation_is_present)
          _v1146 = _v1138.height
          start = end
          end += 2
          (_v1146.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1138.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1138.height_is_present = bool(_v1138.height_is_present)
          _v1147 = _v1111.radial
          _v1148 = _v1147.shape_reference_point
          _v1149 = _v1148.x_coordinate
          start = end
          end += 2
          (_v1149.value,) = _get_struct_h().unpack(str[start:end])
          _v1150 = _v1148.y_coordinate
          start = end
          end += 2
          (_v1150.value,) = _get_struct_h().unpack(str[start:end])
          _v1151 = _v1148.z_coordinate
          start = end
          end += 2
          (_v1151.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1148.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1148.z_coordinate_is_present = bool(_v1148.z_coordinate_is_present)
          start = end
          end += 1
          (_v1147.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1147.shape_reference_point_is_present = bool(_v1147.shape_reference_point_is_present)
          _v1152 = _v1147.range
          start = end
          end += 2
          (_v1152.value,) = _get_struct_H().unpack(str[start:end])
          _v1153 = _v1147.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v1153.value,) = _get_struct_H().unpack(str[start:end])
          _v1154 = _v1147.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v1154.value,) = _get_struct_H().unpack(str[start:end])
          _v1155 = _v1147.vertical_opening_angle_start
          start = end
          end += 2
          (_v1155.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1147.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1147.vertical_opening_angle_start_is_present = bool(_v1147.vertical_opening_angle_start_is_present)
          _v1156 = _v1147.vertical_opening_angle_end
          start = end
          end += 2
          (_v1156.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1147.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1147.vertical_opening_angle_end_is_present = bool(_v1147.vertical_opening_angle_end_is_present)
          _v1157 = _v1111.radial_shapes
          _v1158 = _v1157.ref_point_id
          start = end
          end += 1
          (_v1158.value,) = _get_struct_B().unpack(str[start:end])
          _v1159 = _v1157.x_coordinate
          start = end
          end += 2
          (_v1159.value,) = _get_struct_h().unpack(str[start:end])
          _v1160 = _v1157.y_coordinate
          start = end
          end += 2
          (_v1160.value,) = _get_struct_h().unpack(str[start:end])
          _v1161 = _v1157.z_coordinate
          start = end
          end += 2
          (_v1161.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1157.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1157.z_coordinate_is_present = bool(_v1157.z_coordinate_is_present)
          _v1162 = _v1157.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1162.array = []
          for i in range(0, length):
            val9 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v1163 = val9.range
            start = end
            end += 2
            (_v1163.value,) = _get_struct_H().unpack(str[start:end])
            _v1164 = val9.horizontal_opening_angle_start
            start = end
            end += 2
            (_v1164.value,) = _get_struct_H().unpack(str[start:end])
            _v1165 = val9.horizontal_opening_angle_end
            start = end
            end += 2
            (_v1165.value,) = _get_struct_H().unpack(str[start:end])
            _v1166 = val9.vertical_opening_angle_start
            start = end
            end += 2
            (_v1166.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_start_is_present = bool(val9.vertical_opening_angle_start_is_present)
            _v1167 = val9.vertical_opening_angle_end
            start = end
            end += 2
            (_v1167.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val9.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val9.vertical_opening_angle_end_is_present = bool(val9.vertical_opening_angle_end_is_present)
            _v1162.array.append(val9)
          start = end
          end += 1
          (_v1109.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1109.cluster_bounding_box_shape_is_present = bool(_v1109.cluster_bounding_box_shape_is_present)
          _v1168 = _v1109.cluster_cardinality_size
          start = end
          end += 1
          (_v1168.value,) = _get_struct_B().unpack(str[start:end])
          _v1169 = _v1109.cluster_profiles
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          _v1169.value = str[start:end]
          start = end
          end += 1
          (_v1169.bits_unused,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1109.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1109.cluster_profiles_is_present = bool(_v1109.cluster_profiles_is_present)
          _v1170 = _v1102.other_sub_class
          start = end
          end += 1
          (_v1170.value,) = _get_struct_B().unpack(str[start:end])
          _v1171 = val3.confidence
          start = end
          end += 1
          (_v1171.value,) = _get_struct_B().unpack(str[start:end])
          _v1101.array.append(val3)
        start = end
        end += 1
        (val1.classification_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.classification_is_present = bool(val1.classification_is_present)
        _v1172 = val1.map_position
        _v1173 = _v1172.map_reference
        start = end
        end += 1
        (_v1173.choice,) = _get_struct_B().unpack(str[start:end])
        _v1174 = _v1173.roadsegment
        _v1175 = _v1174.region
        start = end
        end += 2
        (_v1175.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v1174.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1174.region_is_present = bool(_v1174.region_is_present)
        _v1176 = _v1174.id
        start = end
        end += 2
        (_v1176.value,) = _get_struct_H().unpack(str[start:end])
        _v1177 = _v1173.intersection
        _v1178 = _v1177.region
        start = end
        end += 2
        (_v1178.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v1177.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1177.region_is_present = bool(_v1177.region_is_present)
        _v1179 = _v1177.id
        start = end
        end += 2
        (_v1179.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v1172.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1172.map_reference_is_present = bool(_v1172.map_reference_is_present)
        _v1180 = _v1172.lane_id
        start = end
        end += 1
        (_v1180.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1172.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1172.lane_id_is_present = bool(_v1172.lane_id_is_present)
        _v1181 = _v1172.connection_id
        start = end
        end += 1
        (_v1181.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v1172.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1172.connection_id_is_present = bool(_v1172.connection_id_is_present)
        _v1182 = _v1172.longitudinal_lane_position
        _v1183 = _v1182.longitudinal_lane_position_value
        start = end
        end += 2
        (_v1183.value,) = _get_struct_H().unpack(str[start:end])
        _v1184 = _v1182.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v1184.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v1172.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v1172.longitudinal_lane_position_is_present = bool(_v1172.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_position_is_present = bool(val1.map_position_is_present)
        self.container_data.perceived_object_container.perceived_objects.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2BHB2HBHB = None
def _get_struct_2BHB2HBHB():
    global _struct_2BHB2HBHB
    if _struct_2BHB2HBHB is None:
        _struct_2BHB2HBHB = struct.Struct("<2BHB2HBHB")
    return _struct_2BHB2HBHB
_struct_2BHBH2BH2B = None
def _get_struct_2BHBH2BH2B():
    global _struct_2BHBH2BH2B
    if _struct_2BHBH2BH2B is None:
        _struct_2BHBH2BH2B = struct.Struct("<2BHBH2BH2B")
    return _struct_2BHBH2BH2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
