# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cpm_ts_msgs/WrappedCpmContainers.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cpm_ts_msgs.msg

class WrappedCpmContainers(genpy.Message):
  _md5sum = "7172310aea64488736155f5ef0dd89d8"
  _type = "etsi_its_cpm_ts_msgs/WrappedCpmContainers"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# WrappedCpmContainers::= SEQUENCE SIZE(1..8,...) OF WrappedCpmContainer 
# ------------------------------------------------------------------------------
# *
# * This DF represents a list of CPM containers, each with their type identifier. 
#

WrappedCpmContainer[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/WrappedCpmContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# WrappedCpmContainer ::= SEQUENCE {
#    containerId     CPM-CONTAINER-ID-AND-TYPE.&id( {CpmContainers} ),
# ------------------------------------------------------------------------------
# *
# * This DF represents a CPM container preceded by its type identifier and a lenght indicator.
# *
# * It shall include the following components: 
# *
# * @field containerId: the identifier of the container type.
# *
# * @field containerData: the container content consistent with the container type.
# *
#

CpmContainerId container_id

CpmContainers container_data


================================================================================
MSG: etsi_its_cpm_ts_msgs/CpmContainerId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CpmContainerId ::= INTEGER (1..16)
# ------------------------------------------------------------------------------
# *
# * This DE represents the identifier of the container type. 
# *
#

uint8 value
uint8 MIN = 1
uint8 MAX = 16
uint8 ORIGINATING_RSU_CONTAINER = 2
uint8 ORIGINATING_VEHICLE_CONTAINER = 1
uint8 PERCEIVED_OBJECT_CONTAINER = 5
uint8 PERCEPTION_REGION_CONTAINER = 4
uint8 SENSOR_INFORMATION_CONTAINER = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/CpmContainers
# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CpmContainers CPM-CONTAINER-ID-AND-TYPE ::= {
#     {OriginatingVehicleContainer IDENTIFIED BY originatingVehicleContainer} |
# ------------------------------------------------------------------------------
CpmContainerId choice
OriginatingVehicleContainer originating_vehicle_container
OriginatingRsuContainer originating_rsu_container
SensorInformationContainer sensor_information_container
PerceptionRegionContainer perception_region_container
PerceivedObjectContainer perceived_object_container

================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingVehicleContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OriginatingVehicleContainer ::= SEQUENCE {
#     orientationAngle   Wgs84Angle,
#     pitchAngle         CartesianAngle OPTIONAL,
#     rollAngle          CartesianAngle OPTIONAL,
#     trailerDataSet     TrailerDataSet OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Originating Vehicle Container
# *
# * It shall include the following components: 
# *
# * @field orientationAngle: the angle and angle accuracy of the absolute orientation of the disseminating vehicle in the WGS84 coordinate system with respect to true North.
# *
# * @field pitchAngle: the optional angle and angle accuracy between the ground plane and the current orientation of the vehicle's x-axis with respect to the ground plane about the y-axis according to the ISO 8855.
# *
# * @field rollAngle: the optional angle and angle accuracy between the ground plane and the current orientation of a vehicle's y-axis with respect to the ground plane about the x-axis according to the ISO 8855
# *
# * @field trailerData: information about the trailer dimensions and orientation in case a trailer is present.
# * 
#

Wgs84Angle orientation_angle

CartesianAngle pitch_angle
bool pitch_angle_is_present

CartesianAngle roll_angle
bool roll_angle_is_present

TrailerDataSet trailer_data_set
bool trailer_data_set_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84Angle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84Angle ::= SEQUENCE {
#     value         Wgs84AngleValue,
#     confidence    Wgs84AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an angular component along with a confidence value in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * It shall include the following components: 
# *
# * @field value: the angle value, which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the angle value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

Wgs84AngleValue value

Wgs84AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/Wgs84AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Wgs84AngleConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,
# * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the confidence value is not available.
# *
# *
# * @unit 0,1 degrees
# * @category: GeoReference Information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angle value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------
# * 
# * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
# * - `36001` if the accuracy information is not available.
# *
# * The value 3600 shall not be used. 
# * 
# * @unit 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
# * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
# * - `127` if the accuracy information is not available.
# *
# * @unit: 0,1 degrees
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerDataSet
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerDataSet::= SEQUENCE SIZE(1..8,...) OF TrailerData (WITH COMPONENTS {... ,frontOverhang ABSENT, rearOverhang ABSENT, trailerWidth ABSENT}) 
# ------------------------------------------------------------------------------
# *
# * This DF  represents a list of trailer data.
# * 
#

TrailerData[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/TrailerData
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrailerData ::= SEQUENCE { 
#     refPointId          Identifier1B,
#     hitchPointOffset    StandardLength1B, 
#     frontOverhang       StandardLength1B OPTIONAL, 
#     rearOverhang        StandardLength1B OPTIONAL, 
#     trailerWidth        VehicleWidth OPTIONAL,
#     hitchAngle          CartesianAngle,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides detailed information about an attached trailer.
# *
# * It shall include the following components: 
# *
# * @field refPointId: identifier of the reference point of the trailer.
# *
# * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
# * vehicle Reference Point.
# *
# * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
# * is not overhanging to the front with respect to the trailer reference point.
# *
# * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
# * trailer Reference Point indicated by the refPointID.
# *
# * @field trailerWidth: optional width of the trailer.
# *
# * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
# * direction of the ISO 8855 [21] coordinate system centered on the trailer) and the direction of
# * the segment having as end points the reference point of the trailer and the reference point of
# * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
# * xy, described in the local Cartesian coordinate system of the trailer. The
# * angle is measured with negative values considering the trailer orientation turning clockwise
# * starting from the segment direction. The angle value accuracy is provided with the
# * confidence level of 95 %.
# *
# * @category: Vehicle information
# * @revision: Created in V2.1.1
#

Identifier1B ref_point_id

StandardLength1B hitch_point_offset

StandardLength1B front_overhang
bool front_overhang_is_present

StandardLength1B rear_overhang
bool rear_overhang_is_present

VehicleWidth trailer_width
bool trailer_width_is_present

CartesianAngle hitch_angle


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength1B::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/VehicleWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleWidth ::= INTEGER {
#     outOfRange  (61),  
#     unavailable (62)
# } (1..62)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a vehicle, excluding side mirrors and possible similar extensions.
#
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 61`) indicates the applicable value is equal to or less than n x 0,1 metre, and greater than (n-1) x 0,1 metre,
# * - `61` indicates that the vehicle width is greater than 6,0 metres,
# * - `62` indicates that the information in unavailable.
# * 
# * @unit: 0,1 metre
# * @category: Vehicle information 
# * @revision: Description updated in V2.1.1 (the meaning of 61 has changed slightly).
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 62
uint8 OUT_OF_RANGE = 61
uint8 UNAVAILABLE = 62

================================================================================
MSG: etsi_its_cpm_ts_msgs/OriginatingRsuContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OriginatingRsuContainer ::= SEQUENCE{
#     mapReference    MapReference OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Originating RSU Container.
# *
# * It shall include the following components: 
# *
# * @field mapReference: identifies the MAPEM containing the topology information reference in the Perceived Object Container
# * 
#

MapReference map_reference
bool map_reference_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cpm_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformationContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformationContainer ::= SEQUENCE SIZE(1..128, ...) OF SensorInformation
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Sensor Information Container as a list of information objects about the sensors or data fusion systems from which the station provides information about detected objects.
#

SensorInformation[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorInformation ::= SEQUENCE {
#     sensorId          		    Identifier1B,
#     sensorType        		    SensorType,
#     perceptionRegionShape		Shape OPTIONAL,
#     perceptionRegionConfidence  ConfidenceLevel OPTIONAL,
#     shadowingApplies            BOOLEAN,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the characteristics of a single sensor or data fusion system.
# *
# * It shall include the following components: 
# *
# * @field sensorId: identifier of the sensor or data fusion system used to relate the perceived object in the Perceived Object Container to the sensor that detected it.
# * this identifier shall uniquely identify the sensor inside the CPM, but may be changed from one CPM to the next.
# *
# * @field sensorType: the type of the sensor.
# *
# * @field perceptionRegionShape: the perception region of the sensor.
# *
# * @field perceptionRegionConfidence: the homogeneous perception region confidence that can be assumed for the entire perception region shape of this sensor. 
# *
# * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
# *
#

Identifier1B sensor_id

SensorType sensor_type

Shape perception_region_shape
bool perception_region_shape_is_present

ConfidenceLevel perception_region_confidence
bool perception_region_confidence_is_present

bool shadowing_applies


================================================================================
MSG: etsi_its_cpm_ts_msgs/SensorType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorType ::= INTEGER {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (0..31)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor.
# * 
# * The value shall be set to:
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-31                  - are reserved for future usage.
# *
# * @category: Sensing Information
# * @revision: created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 UNDEFINED = 0
uint8 RADAR = 1
uint8 LIDAR = 2
uint8 MONOVIDEO = 3
uint8 STEREOVISION = 4
uint8 NIGHTVISION = 5
uint8 ULTRASONIC = 6
uint8 PMD = 7
uint8 INDUCTION_LOOP = 8
uint8 SPHERICAL_CAMERA = 9
uint8 UWB = 10
uint8 ACOUSTIC = 11
uint8 LOCAL_AGGREGATION = 12
uint8 ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/Shape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Shape::= CHOICE {
#    rectangular       RectangularShape,
#    circular          CircularShape, 
#    polygonal         PolygonalShape,
#    elliptical        EllipticalShape,
#    radial            RadialShape,
#    radialShapes      RadialShapes,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the definition of a geographical area or volume, based on different options.
# *
# * It is a choice of the following components: 
# *
# * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
# *
# * @field circular: definition of an area of circular shape or a right circular cylinder.
# *
# * @field polygonal: definition of an area of polygonal shape or a right prism.
# *
# * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
# *
# * @field radial: definition of a radial shape.
# *
# * @field radialList: definition of list of radial shapes.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 choice

RectangularShape rectangular
uint8 CHOICE_RECTANGULAR = 0

CircularShape circular
uint8 CHOICE_CIRCULAR = 1

PolygonalShape polygonal
uint8 CHOICE_POLYGONAL = 2

EllipticalShape elliptical
uint8 CHOICE_ELLIPTICAL = 3

RadialShape radial
uint8 CHOICE_RADIAL = 4

RadialShapes radial_shapes
uint8 CHOICE_RADIAL_SHAPES = 5


================================================================================
MSG: etsi_its_cpm_ts_msgs/RectangularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RectangularShape ::= SEQUENCE { 
#     centerPoint    CartesianPosition3d OPTIONAL,
#     semiLength     StandardLength12b,
#     semiBreadth    StandardLength12b,
#     orientation    Wgs84AngleValue OPTIONAL,
#     height         StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF. 
# *
# * It shall include the following components: 
# * 
# * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
# *
# * @field semiLength: represents half the length of the rectangle.
# * 
# * @field semiBreadth: represents half the breadth of the rectangle.
# *
# * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d center_point
bool center_point_is_present

StandardLength12b semi_length

StandardLength12b semi_breadth

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value.
# *
# * @field yCoordinate: the Y coordinate value.
# *
# * @field zCoordinate: the optional Z coordinate value.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
# *
# * The value shall be set to:
# * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
# * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_cpm_ts_msgs/CircularShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CircularShape ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     radius                 StandardLength12b,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field radius: the radius of the circular area.
# *
# * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
# *
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b radius

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/PolygonalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PolygonalShape ::= SEQUENCE {
#    shapeReferencePoint    CartesianPosition3d OPTIONAL,
#    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
#    height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the shape of a polygonal area or of a right prism.
# *
# * It shall include the following components: 
# *
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's reference point. 
# *
# * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
# * All nodes of the polygon shall be considered relative to the shape's reference point.
# *
# * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
# * 
# * @category GeoReference information
# * @revision: created in V2.1.1
# *
# 

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

SequenceOfCartesianPosition3d polygon
int64 POLYGON_MIN_SIZE = 3
int64 POLYGON_MAX_SIZE = 16

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfCartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of DF @ref CartesianPosition3d.
# * 
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

CartesianPosition3d[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/EllipticalShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EllipticalShape  ::= SEQUENCE {
#     shapeReferencePoint    CartesianPosition3d OPTIONAL,
#     semiMajorAxisLength    StandardLength12b,
#     semiMinorAxisLength    StandardLength12b,
#     orientation            Wgs84AngleValue OPTIONAL,
#     height                 StandardLength12b OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * 
# * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred on the shape's reference point. 
# *
# * It shall include the following components: 
# * 
# * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field semiMajorAxisLength: half length of the major axis of the ellipse.
# * 
# * @field semiMinorAxisLength: half length of the minor axis of the ellipse.
# *
# * @field orientation: the optional orientation of the major axis of the ellipse in the WGS84 coordinate system.
# * 
# * @field height: the optional height, present if the shape is a right elliptical cylinder extending in the positive z-axis.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b semi_major_axis_length

StandardLength12b semi_minor_axis_length

Wgs84AngleValue orientation
bool orientation_is_present

StandardLength12b height
bool height_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShape
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  between a horizontal start 
# * and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
# * If this component is absent, the externally specified reference position represents the shape's  reference point. 
# *
# * @field range: the radial range of the shape from the shape's reference point. 
# *
# * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction with respect to the 
# * WGS84 coordinate system.
# *
# * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
# * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
# * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category GeoReference information
# * @revision: created in V2.1.1
#

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a list of radial shapes. 
# *
# * It shall include the following components:
#
# * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
# * 
# * @field xCoordinate: the x-coordinate of the offset point.
# *
# * @field yCoordinate: the y-coordinate of the offset point.
# *
# * @field zCoordinate: the optional z-coordinate of the offset point.
# *
# * @field radialShapesList: the list of radial shape details.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
# *
# * The value shall be set to:
# * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
# * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of @ref RadialShapeDetails.
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

RadialShapeDetails[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cpm_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF describes a radial shape details. The triangular or cone-shaped volume is
# * constructed by sweeping the provided range about the reference point  or about the offset
# * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
# * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
# * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
# * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
# * above intersections).
# *
# * It shall include the following components:
# * 
# * @field range: the radial range of the sensor from the reference point or sensor point offset. 
# *
# * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
# * shape's horizontal opening angle in positive angular direction.
# *
# * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
# * opening angle in positive angular direction.
# *
# * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system.
# *
# * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
# * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
# * located in the north-east plane of the WGS84 coordinate system. 
# *
# * @category: Georeference information
# * @revision: created in V2.1.1
# 

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegionContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceptionRegionContainer ::= SEQUENCE SIZE(1..256, ...) OF PerceptionRegion
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Perception Region Container as a list of perception region information objects. 
#

PerceptionRegion[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceptionRegion
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceptionRegion ::= SEQUENCE {
#     measurementDeltaTime         DeltaTimeMilliSecondSigned,     
#     perceptionRegionConfidence   ConfidenceLevel,
#     perceptionRegionShape        Shape, 
#     shadowingApplies             BOOLEAN,
#     sensorIdList                 SequenceOfIdentifier1B OPTIONAL,
#     numberOfPerceivedObjects     CardinalNumber1B OPTIONAL,
#     perceivedObjectIds           PerceivedObjectIds OPTIONAL,
# 	...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the actual perception capabilities available to the transmitting ITS-S, offering additional (often dynamic) details to the information provided in the sensor information container.
# *
# * It shall include the following components: 
#
# * @field measurementDeltaTime: difference between the time of estimation of the perception region and the reference time. Positive values indicates that the provided information refers to a point in time after the reference time.
# *
# * @field perceptionRegionConfidence: the perception confidence.
# *
# * @field perceptionRegionShape: specification of the shape of the perception region.
# *
# * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
# *
# * @field sensorIdList: the optional list of identifiers of the sensors which are involved in perceiving the region.
# *
# * @field numberOfPerceivedObjects: the optional number of perceived objects contained in the perception region specified in the component perceptionRegionShape. 
# *
# * @field perceivedObjectIds: the optional list of identifiers of the objects specified in the Perceived Object Container that are contained in the perception region specified in the component perceptionRegionShape.
# *
#

DeltaTimeMilliSecondSigned measurement_delta_time

ConfidenceLevel perception_region_confidence

Shape perception_region_shape

bool shadowing_applies

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

CardinalNumber1B number_of_perceived_objects
bool number_of_perceived_objects_is_present

PerceivedObjectIds perceived_object_ids
bool perceived_object_ids_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/DeltaTimeMilliSecondSigned
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaTimeMilliSecondSigned ::= INTEGER (-2048..2047)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a signed difference in time with respect to a reference time.
# *
# * The value shall be set to:
# * - `-2048` for time values equal to or less than -2,048 s,
# * - `n` (`n > -2048` and `n < 2047`) to indicate a time value equal to or less than n x 0,001 s, and greater than (n-1) x 0,001 s,
# * - `2047` for time values greater than 2,046 s
# *
# * @unit: 0,001 s
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -2048
int16 MAX = 2047


================================================================================
MSG: etsi_its_cpm_ts_msgs/SequenceOfIdentifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SequenceOfIdentifier1B ::= SEQUENCE SIZE(1..128, ...) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * The DF contains a list of DE @ref Identifier1B.
# *
# * @category: Basic information
# * @revision: created in V2.1.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 128

================================================================================
MSG: etsi_its_cpm_ts_msgs/CardinalNumber1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CardinalNumber1B ::= INTEGER(0..255)
# ------------------------------------------------------------------------------
# *
# * The DE represents a cardinal number that counts the size of a set. 
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectIds
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjectIds::= SEQUENCE SIZE(0..255, ...) OF Identifier2B
# ------------------------------------------------------------------------------
# *
# * This DF  represents a list of identifiers of perceived objects. 
#

Identifier2B[] array
int64 MIN_SIZE = 0
int64 MAX_SIZE = 255

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjectContainer
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjectContainer ::= SEQUENCE {
#     numberOfPerceivedObjects    CardinalNumber1B,
#     perceivedObjects            PerceivedObjects,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF  represents the Perceived Object Container 
# *
# * It shall include the following components: 
# *
# * @field numberOfPerceivedObjects: the total number of perceived objects at the time of generating the message. 
# *
# * @field perceivedObjects: the list of perceived objects.
# *
#

CardinalNumber1B number_of_perceived_objects

PerceivedObjects perceived_objects


================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObjects
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObjects::= SEQUENCE SIZE(0..255, ...) OF PerceivedObject (WITH COMPONENTS {... ,objectId PRESENT})
# ------------------------------------------------------------------------------
# * @brief Perceived Objects
# * This DF provides a list of perceived objects represented in the coordinate system in which the y-axis corresponds to the North direction, the x-axis to the East direction, and the z- axis to the vertical direction.
#

PerceivedObject[] array
int64 MIN_SIZE = 0
int64 MAX_SIZE = 255

================================================================================
MSG: etsi_its_cpm_ts_msgs/PerceivedObject
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PerceivedObject ::= SEQUENCE {
#     objectId                                          Identifier2B OPTIONAL,
#     measurementDeltaTime                              DeltaTimeMilliSecondSigned,
#     position                                          CartesianPosition3dWithConfidence, 
#     velocity                                          Velocity3dWithConfidence OPTIONAL,
#     acceleration                                      Acceleration3dWithConfidence OPTIONAL,
#     angles                                            EulerAnglesWithConfidence OPTIONAL,
#     zAngularVelocity                                  CartesianAngularVelocityComponent OPTIONAL,
#     lowerTriangularCorrelationMatrices                LowerTriangularPositiveSemidefiniteMatrices OPTIONAL,
#     objectDimensionZ                                  ObjectDimension OPTIONAL,
#     objectDimensionY                                  ObjectDimension OPTIONAL,
#     objectDimensionX                                  ObjectDimension OPTIONAL,
#     objectAge                                         DeltaTimeMilliSecondSigned (0..2047) OPTIONAL,
#     objectPerceptionQuality                           ObjectPerceptionQuality OPTIONAL,
#     sensorIdList                                      SequenceOfIdentifier1B OPTIONAL,
#     classification                                    ObjectClassDescription OPTIONAL,
#     mapPosition                                       MapPosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF contains information about a perceived object including its kinematic state and attitude vector in a pre-defined coordinate system and with respect to a reference time.
# * 
# * It shall include the following components: 
# *
# * @field objectId: optional identifier assigned to a detected object.
# *
# * @field measurementDeltaTime: the time difference from a reference time to the time of the  measurement of the object. 
# * Negative values indicate that the provided object state refers to a point in time before the reference time.
# *
# * @field position: the position of the geometric centre of the object's bounding box within the pre-defined coordinate system.
# *
# * @field velocity: the velocity vector of the object within the pre-defined coordinate system.
# *
# * @field acceleration: the acceleration vector of the object within the pre-defined coordinate system.
# *
# * @field angles: optional Euler angles of the object bounding box at the time of measurement. 
# * 
# * @field zAngularVelocity: optional angular velocity of the object around the z-axis at the time of measurement.
# * The angular velocity is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule.
# *
# * @field lowerTriangularCorrelationMatrices: optional set of lower triangular correlation matrices for selected components of the provided kinematic state and attitude vector.
# *
# * @field objectDimensionZ: optional z-dimension of object bounding box. 
# * This dimension shall be measured along the direction of the z-axis after all the rotations have been applied. 
# *
# * @field objectDimensionY: optional y-dimension of the object bounding box. 
# * This dimension shall be measured along the direction of the y-axis after all the rotations have been applied. 
# *
# * @field objectDimensionX: optional x-dimension of object bounding box.
# * This dimension shall be measured along the direction of the x-axis after all the rotations have been applied.
# * 
# * @field objectAge: optional age of the detected and described object, i.e. the difference in time between the moment 
# * it has been first detected and the reference time of the message. Value `1500` indicates that the object has been observed for more than 1.5s.
# *
# * @field objectPerceptionQuality: optional confidence associated to the object. 
# *
# * @field sensorIdList: optional list of sensor-IDs which provided the measurement data. 
# *
# * @field classification: optional classification of the described object
# *
# * @field matchedPosition: optional map-matched position of an object.
# *
# * @category Sensing information
# * @revision: created in V2.1.1
# 

Identifier2B object_id
bool object_id_is_present

DeltaTimeMilliSecondSigned measurement_delta_time

CartesianPosition3dWithConfidence position

Velocity3dWithConfidence velocity
bool velocity_is_present

Acceleration3dWithConfidence acceleration
bool acceleration_is_present

EulerAnglesWithConfidence angles
bool angles_is_present

CartesianAngularVelocityComponent z_angular_velocity
bool z_angular_velocity_is_present

LowerTriangularPositiveSemidefiniteMatrices lower_triangular_correlation_matrices
bool lower_triangular_correlation_matrices_is_present

ObjectDimension object_dimension_z
bool object_dimension_z_is_present

ObjectDimension object_dimension_y
bool object_dimension_y_is_present

ObjectDimension object_dimension_x
bool object_dimension_x_is_present

DeltaTimeMilliSecondSigned object_age
bool object_age_is_present
uint16 OBJECT_AGE_MIN = 0
uint16 OBJECT_AGE_MAX = 2047

ObjectPerceptionQuality object_perception_quality
bool object_perception_quality_is_present

SequenceOfIdentifier1B sensor_id_list
bool sensor_id_list_is_present

ObjectClassDescription classification
bool classification_is_present

MapPosition map_position
bool map_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianPosition3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianPosition3dWithConfidence::= SEQUENCE{    
#     xCoordinate    CartesianCoordinateWithConfidence, 
#     yCoordinate    CartesianCoordinateWithConfidence, 
#     zCoordinate    CartesianCoordinateWithConfidence OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a  position in a two- or three-dimensional cartesian coordinate system with an associated confidence level for each coordinate.
# *
# * It shall include the following components: 
# *
# * @field xCoordinate: the X coordinate value with the associated confidence level.
# *
# * @field yCoordinate: the Y coordinate value with the associated confidence level.
# *
# * @field zCoordinate: the optional Z coordinate value with the associated confidence level.
# * 
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateWithConfidence x_coordinate

CartesianCoordinateWithConfidence y_coordinate

CartesianCoordinateWithConfidence z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateWithConfidence ::= SEQUENCE {
#     value         CartesianCoordinateLarge,
#     confidence    CoordinateConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a coordinate along with a confidence value in a cartesian reference system.
# *
# * It shall include the following components: 
# * 
# * @field value: the coordinate value, which can be estimated as the mean of the current distribution.
# * 
# * @field confidence: the coordinate confidence value associated to the provided value.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

CartesianCoordinateLarge value

CoordinateConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianCoordinateLarge
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianCoordinateLarge::= INTEGER{ 
#     negativeOutOfRange (-131072),
#     positiveOutOfRange (131071)
# } (-131072..131071)
# ------------------------------------------------------------------------------
# *
# * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
# *
# * The value shall be set to:
# * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
# * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
# *  
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int32 value
int32 MIN = -131072
int32 MAX = 131071
int32 NEGATIVE_OUT_OF_RANGE = -131072
int32 POSITIVE_OUT_OF_RANGE = 131071

================================================================================
MSG: etsi_its_cpm_ts_msgs/CoordinateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CoordinateConfidence ::= INTEGER {
#     outOfRange            (4095),
#     unavailable           (4096) 
# } (1..4096)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,
# * - `4095` if the confidence value is greater than 40,94 metres,
# * - `4096` if the confidence value is not available.
# *
# * @unit 0,01 m
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 1
uint16 MAX = 4096
uint16 OUT_OF_RANGE = 4095
uint16 UNAVAILABLE = 4096

================================================================================
MSG: etsi_its_cpm_ts_msgs/Velocity3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Velocity3dWithConfidence::= CHOICE{
#     polarVelocity          VelocityPolarWithZ, 
#     cartesianVelocity      VelocityCartesian
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector with associated confidence value.
# *
# * The following options are available:
# * 
# * @field polarVelocity: the representation of the velocity vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianVelocity: the representation of the velocity vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

VelocityPolarWithZ polar_velocity
uint8 CHOICE_POLAR_VELOCITY = 0

VelocityCartesian cartesian_velocity
uint8 CHOICE_CARTESIAN_VELOCITY = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityPolarWithZ::= SEQUENCE {
#     velocityMagnitude    Speed, 
#     velocityDirection    CartesianAngle,
#     zVelocity            VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a polar or cylindrical coordinate system.
# *
# * It shall include the following components: 
# * 
# * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
# * 
# * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

Speed velocity_magnitude

CartesianAngle velocity_direction

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the speed and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field speedValue: the speed value.
# * 
# * @field speedConfidence: the confidence value of the speed value.
# *
# * @category: Kinematic information
# * @revision: V1.3.1
# 

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------
# *
# * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
# *
# * The value shall be set to:
# * - `0` in a standstill situation.
# * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for speed values greater than 163,81 m/s,
# * - `16 383` if the speed accuracy information is not available.
# * 
# * @note: the definition of standstill is out of scope of the present document.
# *
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
#

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
# * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
# * - `127` if the confidence value information is not available.
# *  
# * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the speed value may be valid and used by the application.
# * 
# * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
# * and therefore cannot be trusted. Such is not useful for the application.
# *
# * @unit: 0,01 m/s
# * @category: Vehicle information
# * @revision: Description revised in V2.1.1 
# 

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponent ::= SEQUENCE {
#     value         VelocityComponentValue,
#     confidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a component of the velocity vector and the associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the value of the component.
# * 
# * @field confidence: the confidence value of the value.
# *
# * @category: Kinematic information
# * @revision: V2.1.1
# 

VelocityComponentValue value

SpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityComponentValue ::= INTEGER {
#     negativeOutOfRange (-16383),
#     positiveOutOfRange  (16382),
#     unavailable        (16383)
# } (-16383..16383)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of a velocity component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,
# * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
# * - `16 382` for velocity values equal to or greater than 163,81 m/s,
# * - `16 383` if the velocity information is not available.
# * 
# * @unit: 0,01 m/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -16383
int16 MAX = 16383
int16 NEGATIVE_OUT_OF_RANGE = -16383
int16 POSITIVE_OUT_OF_RANGE = 16382
int16 UNAVAILABLE = 16383

================================================================================
MSG: etsi_its_cpm_ts_msgs/VelocityCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VelocityCartesian::= SEQUENCE {
#     xVelocity   VelocityComponent,
#     yVelocity   VelocityComponent,
#     zVelocity   VelocityComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a velocity vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xVelocity: the x component of the velocity vector with the associated confidence value.
# * 
# * @field yVelocity: the y component of the velocity vector with the associated confidence value.
# *
# * @field zVelocity: the optional z component of the velocity vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

VelocityComponent x_velocity

VelocityComponent y_velocity

VelocityComponent z_velocity
bool z_velocity_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/Acceleration3dWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Acceleration3dWithConfidence::= CHOICE {
#     polarAcceleration                    AccelerationPolarWithZ,
#     cartesianAcceleration                AccelerationCartesian 
# }
# ------------------------------------------------------------------------------
# 
#
#
#
#
#
#
#
#
#
# Specification of CDD Data Frames:
#
#
#
#
#
#
#
#
#
#
#*
# * This DF represents an acceleration vector with associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field polarAcceleration: the representation of the acceleration vector in a polar or cylindrical coordinate system. 
# * 
# * @field cartesianAcceleration: the representation of the acceleration vector in a cartesian coordinate system.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

uint8 choice

AccelerationPolarWithZ polar_acceleration
uint8 CHOICE_POLAR_ACCELERATION = 0

AccelerationCartesian cartesian_acceleration
uint8 CHOICE_CARTESIAN_ACCELERATION = 1


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationPolarWithZ
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationPolarWithZ::= SEQUENCE{
#     accelerationMagnitude                             AccelerationMagnitude,
#     accelerationDirection                             CartesianAngle,
#     zAcceleration                                     AccelerationComponent OPTIONAL
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents an acceleration vector in a polar or cylindrical coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field accelerationMagnitude: magnitude of the acceleration vector projected onto the reference plane, with the associated confidence value.
# * 
# * @field accelerationDirection: polar angle of the acceleration vector projected onto the reference plane, with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitude acceleration_magnitude

CartesianAngle acceleration_direction

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitude::= SEQUENCE {
#     accelerationMagnitudeValue   AccelerationMagnitudeValue,
#     accelerationConfidence       AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the magnitude of the acceleration vector and associated confidence value.
# *
# * It shall include the following components: 
# * 
# * @field accelerationMagnitudeValue: the magnitude of the acceleration vector.
# * 
# * @field accelerationConfidence: the confidence value of the magnitude value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationMagnitudeValue acceleration_magnitude_value

AccelerationConfidence acceleration_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationMagnitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationMagnitudeValue ::= INTEGER {
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (0.. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the magnitude of the acceleration vector in a defined coordinate system.
# *
# * The value shall be set to:
# * - `0` to indicate no acceleration,
# * - `n` (`n > 0` and `n < 160`) to indicate acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 161
uint8 POSITIVE_OUT_OF_RANGE = 160
uint8 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------
# *
# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
# * - `102` if the confidence value is unavailable.
# *
# * The value 0 shall not be used.
# *
# * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
# * - the sensor cannot calculate the accuracy due to lack of variables, or
# * - there has been a vehicle bus (e.g. CAN bus) error.
# * In all 3 cases above, the acceleration value may be valid and used by the application.
# * 
# * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
# *
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Description revised in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationComponent ::= SEQUENCE {
#     value         AccelerationValue,
#     confidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an acceleration component along with a confidence value.
# *
# * It shall include the following components: 
# *
# * @field value: the value of the acceleration component which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the confidence value associated to the provided value.
# *
# * @category: Kinematic Information
# * @revision: Created in V2.1.1
# 

AccelerationValue value

AccelerationConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the value of an acceleration component in a defined coordinate system.
# *
# * The value shall be set to:
# * - `-160` for acceleration values equal to or less than -16 m/s^2,
# * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
# * - `160` for acceleration values greater than 15,9 m/s^2,
# * - `161` when the data is unavailable.
# *
# * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
# * @unit 0,1 m/s^2
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161

================================================================================
MSG: etsi_its_cpm_ts_msgs/AccelerationCartesian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AccelerationCartesian::= SEQUENCE{
#     xAcceleration      AccelerationComponent,
#     yAcceleration      AccelerationComponent,
#     zAcceleration      AccelerationComponent OPTIONAL
# }            
# ------------------------------------------------------------------------------
# *
# * This DF represents a acceleration vector in a cartesian coordinate system.
# 
# * It shall include the following components: 
# * 
# * @field xAcceleration: the x component of the acceleration vector with the associated confidence value.
# * 
# * @field yAcceleration: the y component of the acceleration vector with the associated confidence value.
# *
# * @field zAcceleration: the optional z component of the acceleration vector with the associated confidence value.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

AccelerationComponent x_acceleration

AccelerationComponent y_acceleration

AccelerationComponent z_acceleration
bool z_acceleration_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/EulerAnglesWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EulerAnglesWithConfidence ::= SEQUENCE {
#     zAngle CartesianAngle,
#     yAngle CartesianAngle OPTIONAL,
#     xAngle CartesianAngle OPTIONAL
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
# *
# * It shall include the following components: 
# *
# * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
# *
# * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
# *
# * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
# * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis. 
# * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

CartesianAngle z_angle

CartesianAngle y_angle
bool y_angle_is_present

CartesianAngle x_angle
bool x_angle_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponent
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponent ::= SEQUENCE {
#     value         CartesianAngularVelocityComponentValue,
#     confidence    AngularSpeedConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents an angular velocity component along with a confidence value in a cartesian coordinate system.
# *
# * It shall include the following components: 
# *
# * @field value: The angular velocity component.
# *
# * @field confidence: The confidence value associated to the provided value.
# *
# * @category: Kinematic information
# * @revision: Created in V2.1.1
# 

CartesianAngularVelocityComponentValue value

AngularSpeedConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/CartesianAngularVelocityComponentValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CartesianAngularVelocityComponentValue ::= INTEGER {
#     negativeOutofRange (-255),
#     positiveOutOfRange (255),
#     unavailable	       (256)
# } (-255..256)
# ------------------------------------------------------------------------------
# *
# * This DE represents an angular velocity component described in a local Cartesian coordinate system, per default counted positive in
# * a right-hand local coordinate system from the abscissa.
# *
# * The value shall be set to: 
# * - `-255` if the velocity is equal to or less than -255 degrees/s,
# * - `n` (`n > -255` and `n < 255`) if the velocity is equal to or less than n x 1 degree/s, and greater than (n-1) x 1 degree/s,
# * - `255` if the velocity is greater than 254 degrees/s,
# * - `256` if the information is unavailable.
# *
# * @unit: degree/s
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

int16 value
int16 MIN = -255
int16 MAX = 256
int16 NEGATIVE_OUTOF_RANGE = -255
int16 POSITIVE_OUT_OF_RANGE = 255
int16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/AngularSpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AngularSpeedConfidence ::= ENUMERATED {
#     degSec-01   (0), 
#     degSec-02   (1),  
#     degSec-05   (2), 
#     degSec-10   (3), 
#     degSec-20   (4),  
#     degSec-50   (5), 
#     outOfRange  (6),   
#     unavailable (7)   
# }
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# * For correlation computation, maximum interval levels can be assumed.
# *
# * The value shall be set to:
# * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
# * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
# * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
# * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
# * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
# * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
# * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
# * - 7 - `unavailable` - if the accuracy information is unavailable.
# * 
# * @category: Kinematic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 DEG_SEC_01 = 0
uint8 DEG_SEC_02 = 1
uint8 DEG_SEC_05 = 2
uint8 DEG_SEC_10 = 3
uint8 DEG_SEC_20 = 4
uint8 DEG_SEC_50 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrices
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrices::= SEQUENCE SIZE (1..4) OF LowerTriangularPositiveSemidefiniteMatrix
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of a lower triangular positive semi-definite matrices.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

LowerTriangularPositiveSemidefiniteMatrix[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrix
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
#     componentsIncludedIntheMatrix   MatrixIncludedComponents,
#     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a lower triangular positive semi-definite matrix. 
# *
# * It shall include the following components: 
# *
# * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix. 
# * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
# *
# * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows. 
# *
# * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
# * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
# * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

MatrixIncludedComponents components_included_inthe_matrix

LowerTriangularPositiveSemidefiniteMatrixColumns matrix


================================================================================
MSG: etsi_its_cpm_ts_msgs/MatrixIncludedComponents
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MatrixIncludedComponents::= BIT STRING{
#     xPosition                    (0),
#     yPosition                    (1),
#     zPosition                    (2),
#     xVelocityOrVelocityMagnitude (3),
#     yVelocityOrVelocityDirection (4),
#     zSpeed                       (5),
#     xAccelOrAccelMagnitude       (6),
#     yAccelOrAccelDirection       (7),
#     zAcceleration                (8),
#     zAngle                       (9),  
#     yAngle                      (10), 
#     xAngle                      (11), 
#     zAngularVelocity              (12)
# } (SIZE(13,...))
# ------------------------------------------------------------------------------
# *
# * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
# *
# * The corresponding bit shall be set to 1 if the component is included:
# * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
# * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,   
# * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included, 
# * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,   
# * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,   
# * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
# * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,  
# * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,   
# * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
# * - 9 - `zAngle`                        - when the component zAngle is included,
# * - 10 - `yAngle`                       - when the component yAngle is included,   
# * - 11 - `xAngle`                       - when the component xAngle is included,   
# * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.   
# *
# * Otherwise, it shall be set to 0.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 13
int64 MAX_SIZE_BITS = 13
uint8 BIT_INDEX_X_POSITION = 0
uint8 BIT_INDEX_Y_POSITION = 1
uint8 BIT_INDEX_Z_POSITION = 2
uint8 BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
uint8 BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
uint8 BIT_INDEX_Z_SPEED = 5
uint8 BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
uint8 BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
uint8 BIT_INDEX_Z_ACCELERATION = 8
uint8 BIT_INDEX_Z_ANGLE = 9
uint8 BIT_INDEX_Y_ANGLE = 10
uint8 BIT_INDEX_X_ANGLE = 11
uint8 BIT_INDEX_Z_ANGULAR_VELOCITY = 12

================================================================================
MSG: etsi_its_cpm_ts_msgs/LowerTriangularPositiveSemidefiniteMatrixColumns
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LowerTriangularPositiveSemidefiniteMatrixColumns ::= SEQUENCE SIZE (1..13) OF CorrelationColumn
# ------------------------------------------------------------------------------
# * 
# * This DF represents the columns of a lower triangular positive semi-definite matrix, each column not including the main diagonal cell of the matrix.
# * Given a matrix "A" of size n x n, the number of @ref CorrelationColumn to be included in the lower triangular matrix is k=n-1.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

CorrelationColumn[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationColumn
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationColumn ::= SEQUENCE SIZE (1..13,...) OF CorrelationCellValue  
# ------------------------------------------------------------------------------
# *
# * This DF represents a column of a lower triangular positive semi-definite matrix and consists of a list of correlation cell values ordered by rows.
# * Given a matrix "A" of size n x n, the number of columns to be included in the lower triangular matrix is k=n-1.
# * Each column "i" of the lower triangular matrix then contains k-(i-1) values (ordered by rows from 1 to n-1), where "i" refers to the column number count
# * starting at 1 from the left.
# *
# * @category: Sensing Information
# * @revision: Created in V2.1.1
#

CorrelationCellValue[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 13

================================================================================
MSG: etsi_its_cpm_ts_msgs/CorrelationCellValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CorrelationCellValue ::= INTEGER {
#     full-negative-correlation    (-100),     
#     no-correlation               (0),       
#     full-positive-correlation    (100),
#     unavailable (101)  
# } (-100..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
# *
# * The value shall be set to: 
# * - `-100` in case of full negative correlation,
# * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
# * - `0` in case of no correlation,
# * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
# * - `100` in case of full positive correlation,
# * - `101` in case the correlation information is unavailable. 
# *
# * @unit: the value is scaled by 100
# * @category: Basic information
# * @revision: Created in V2.1.1
#

int8 value
int8 MIN = -100
int8 MAX = 101
int8 FULL_NEGATIVE_CORRELATION = -100
int8 NO_CORRELATION = 0
int8 FULL_POSITIVE_CORRELATION = 100
int8 UNAVAILABLE = 101

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimension
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimension ::= SEQUENCE {
#     value         ObjectDimensionValue,
#     confidence    ObjectDimensionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents a dimension of an object together with a confidence value.
# *
# * It shall include the following components: 
# * 
# * @field value: the object dimension value which can be estimated as the mean of the current distribution.
# *
# * @field confidence: the associated confidence value.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectDimensionValue value

ObjectDimensionConfidence confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionValue ::= INTEGER { 
#     outOfRange              (255),
#     unavailable             (256)
# }(1..256)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single dimension of an object.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
# * - `256` if the data is unavailable.
# *
# * @unit 0,1 m
# * @category: Basic information
# * @revision: Created in V2.1.1 
#

uint16 value
uint16 MIN = 1
uint16 MAX = 256
uint16 OUT_OF_RANGE = 255
uint16 UNAVAILABLE = 256

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectDimensionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectDimensionConfidence ::= INTEGER { 
#     outOfRange              (31),
#     unavailable             (32)
# } (1..32)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
# * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
# * - `32` if the confidence value is unavailable.
# *
# * @unit 0,1 m
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 32
uint8 OUT_OF_RANGE = 31
uint8 UNAVAILABLE = 32

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectPerceptionQuality
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectPerceptionQuality ::= INTEGER {
#     noConfidence        (0), 
#     fullConfidence      (15) 
# } (0..15)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a single-value indication about the overall information quality of a perceived object.
# * 
# * The value shall be set to:  
# * - `0`                        : if there is no confidence in detected object, e.g. for "ghost"-objects or if confidence could not be computed,
# * - `n` (`n > 0` and `n < 15`) : for the applicable confidence value,
# * - `15`                       : if there is full confidence in the detected Object.
# * 
# * @unit n/a
# * @category: Sensing information
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 0
uint8 MAX = 15
uint8 NO_CONFIDENCE = 0
uint8 FULL_CONFIDENCE = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassDescription
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassDescription ::= SEQUENCE (SIZE(1..8)) OF ObjectClassWithConfidence
# ------------------------------------------------------------------------------
# * 
# * This DF shall contain a list of object classes.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClassWithConfidence[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClassWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClassWithConfidence ::= SEQUENCE {
#     objectClass    ObjectClass,
#     confidence     ConfidenceLevel
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the classification of a detected object together with a confidence level.
# *
# * It shall include the following components: 
# *
# * @field objectClass: the class of the object.
# *
# * @field Confidence: the associated confidence level.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
#

ObjectClass object_class

ConfidenceLevel confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/ObjectClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ObjectClass ::= CHOICE {
#     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
#     vruSubClass          VruProfileAndSubprofile,
#     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
# ------------------------------------------------------------------------------
# * 
# * This DF indicates both the class and associated subclass that best describes an object.
# *
# * The following options are available:
# *
# * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
# *
# * @field vruSubClass: the object is a VRU and the specific subclass is specified.
# *
# * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
# *
# * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 choice

TrafficParticipantType vehicle_sub_class
uint8 CHOICE_VEHICLE_SUB_CLASS = 0

VruProfileAndSubprofile vru_sub_class
uint8 CHOICE_VRU_SUB_CLASS = 1

VruClusterInformation group_sub_class
uint8 CHOICE_GROUP_SUB_CLASS = 2

OtherSubClass other_sub_class
uint8 CHOICE_OTHER_SUB_CLASS = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a traffic participant.
# * 
# * The value shall be set to:
# * - 0 `unknown`          - information about traffic participant is not provided,
# * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
# * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
# * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
# * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
# * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
# * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
# * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
# * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
# * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
# * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
# * - 11 `tram`            - vehicle which runs on tracks along public streets,
# * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
# * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
# * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
# * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                            on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
# * - 16-255               - are reserved for future usage.
# * 
# * @category: Communication information.
# * @revision: Created in V2.1.1 based on StationType
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15

================================================================================
MSG: etsi_its_cpm_ts_msgs/VruProfileAndSubprofile
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates the profile of a VRU including sub-profile information
# * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
# *
# * @field pedestrian: VRU Profile 1 - Pedestrian.
# *
# * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
# *
# * @field motorcyclist: VRU Profile 3  - Motorcyclist.
# *
# * @field animal: VRU Profile  4 -  Animal.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a pedestrian.
# * 
# * The value shall be set to:
# * - 0 `unavailable`             - to indicate that the information on is unavailable,
# * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
# * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
# * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
# * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
# *
# * The value shall be set to:
# * - 0 `unavailable`           - to indicate that the information  is unavailable,
# * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
# * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
# * - 3 `horse-and-rider`       - to indicate a horse and rider,
# * - 4 `rollerskater`          - to indicate a rolleskater and skater,
# * - 5 `e-scooter`             - to indicate an e-scooter and rider,
# * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
# * - 7 `pedelec`               - to indicate a pedelec and rider,
# * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
# * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of a motorcyclist and corresponding vehicle.
# * 
# * The value shall be set to:
# * - 0 `unavailable `                  - to indicate that the information  is unavailable,
# * - 1 `moped`                         - to indicate a moped and rider,
# * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
# * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
# * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
# * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the profile of an animal
# * 
# * The value shall be set to:
# * - 0 `unavailable`     - to indicate that the information  is unavailable,
# * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
# * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
# * - 3 `service-animal`  - to indicate an animal that supports a human being.
# * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterInformation ::= SEQUENCE { 
#    clusterId                  Identifier1B OPTIONAL,
#    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about a VRU cluster.
# *
# * It shall include the following components: 
# *
# * @field clusterId: optional identifier of a VRU cluster .
# *
# * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
# *
# * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
# *
# * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
# * if this component is absent it means that the information is unavailable. 
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

Identifier1B cluster_id
bool cluster_id_is_present

Shape cluster_bounding_box_shape
bool cluster_bounding_box_shape_is_present
int64 CLUSTER_BOUNDING_BOX_SHAPE_MIN = 0

CardinalNumber1B cluster_cardinality_size

VruClusterProfiles cluster_profiles
bool cluster_profiles_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/VruClusterProfiles
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VruClusterProfiles ::= BIT STRING {
#     pedestrian   (0),
#     bicyclist    (1),
#     motorcyclist (2),
#     animal       (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------
# * 
# * This DE Identifies all the VRU profile types within a cluster.
# * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
# * 
# * The corresponding bit shall be set to 1 under the following conditions:
# * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
# * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
# * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
# * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
# * 
# * Otherwise, the corresponding bit shall be set to 0.
# *
# * @category: VRU information
# * @revision: Created in V2.1.1
#

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_PEDESTRIAN = 0
uint8 BIT_INDEX_BICYCLIST = 1
uint8 BIT_INDEX_MOTORCYCLIST = 2
uint8 BIT_INDEX_ANIMAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/OtherSubClass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OtherSubClass ::= INTEGER {
#     unknown         (0),
#     singleObject    (1),
#     multipleObjects (2),
#     bulkMaterial    (3)
# } (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the subclass of a detected object for @ref ObjectClass "otherSubclass".
# *
# * The value shall be set to:
# * - `0` - unknown          - if the subclass is unknown.
# * - `1` - singleObject     - if the object is a single object.
# * - `2` - multipleObjects  - if the object is a group of multiple objects.
# * - `3` - bulkMaterial     - if the object is a bulk material.
# *
# * @category: Sensing information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 SINGLE_OBJECT = 1
uint8 MULTIPLE_OBJECTS = 2
uint8 BULK_MATERIAL = 3

================================================================================
MSG: etsi_its_cpm_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# * 
# * @field mapReference: optionally identifies the MAPEM containing the topology information.
# * It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
# *
# * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
# * conflict area of an intersection which connects e.g an ingress with an egress lane.
# *
# * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
# * 
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the estimated position along the longitudinal length of a particular lane. 
# *
# * It shall include the following components: 
# *
# * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
# *
# * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
# *
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
# * 
# * The value shall be set to:
# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
# * - `32 767` if the longitudinal offset information is not available. 
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767

================================================================================
MSG: etsi_its_cpm_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
# * - `1 023` if the confidence value is unavailable.
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cpm_ts_msgs/WrappedCpmContainer[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WrappedCpmContainers, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.container_id
        _x = _v1.value
        buff.write(_get_struct_B().pack(_x))
        _v2 = val1.container_data
        _v3 = _v2.choice
        _x = _v3.value
        buff.write(_get_struct_B().pack(_x))
        _v4 = _v2.originating_vehicle_container
        _v5 = _v4.orientation_angle
        _v6 = _v5.value
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
        _v7 = _v5.confidence
        _x = _v7.value
        buff.write(_get_struct_B().pack(_x))
        _v8 = _v4.pitch_angle
        _v9 = _v8.value
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v8.confidence
        _x = _v10.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v4.pitch_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v11 = _v4.roll_angle
        _v12 = _v11.value
        _x = _v12.value
        buff.write(_get_struct_H().pack(_x))
        _v13 = _v11.confidence
        _x = _v13.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v4.roll_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v14 = _v4.trailer_data_set
        length = len(_v14.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v14.array:
          _v15 = val5.ref_point_id
          _x = _v15.value
          buff.write(_get_struct_B().pack(_x))
          _v16 = val5.hitch_point_offset
          _x = _v16.value
          buff.write(_get_struct_B().pack(_x))
          _v17 = val5.front_overhang
          _x = _v17.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.front_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v18 = val5.rear_overhang
          _x = _v18.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.rear_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v19 = val5.trailer_width
          _x = _v19.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.trailer_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v20 = val5.hitch_angle
          _v21 = _v20.value
          _x = _v21.value
          buff.write(_get_struct_H().pack(_x))
          _v22 = _v20.confidence
          _x = _v22.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v4.trailer_data_set_is_present
        buff.write(_get_struct_B().pack(_x))
        _v23 = _v2.originating_rsu_container
        _v24 = _v23.map_reference
        _x = _v24.choice
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v24.roadsegment
        _v26 = _v25.region
        _x = _v26.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v25.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v27 = _v25.id
        _x = _v27.value
        buff.write(_get_struct_H().pack(_x))
        _v28 = _v24.intersection
        _v29 = _v28.region
        _x = _v29.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v28.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v30 = _v28.id
        _x = _v30.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v23.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v31 = _v2.sensor_information_container
        length = len(_v31.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v31.array:
          _v32 = val4.sensor_id
          _x = _v32.value
          buff.write(_get_struct_B().pack(_x))
          _v33 = val4.sensor_type
          _x = _v33.value
          buff.write(_get_struct_B().pack(_x))
          _v34 = val4.perception_region_shape
          _x = _v34.choice
          buff.write(_get_struct_B().pack(_x))
          _v35 = _v34.rectangular
          _v36 = _v35.center_point
          _v37 = _v36.x_coordinate
          _x = _v37.value
          buff.write(_get_struct_h().pack(_x))
          _v38 = _v36.y_coordinate
          _x = _v38.value
          buff.write(_get_struct_h().pack(_x))
          _v39 = _v36.z_coordinate
          _x = _v39.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v36.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v35.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v40 = _v35.semi_length
          _x = _v40.value
          buff.write(_get_struct_H().pack(_x))
          _v41 = _v35.semi_breadth
          _x = _v41.value
          buff.write(_get_struct_H().pack(_x))
          _v42 = _v35.orientation
          _x = _v42.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v35.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v43 = _v35.height
          _x = _v43.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v35.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v44 = _v34.circular
          _v45 = _v44.shape_reference_point
          _v46 = _v45.x_coordinate
          _x = _v46.value
          buff.write(_get_struct_h().pack(_x))
          _v47 = _v45.y_coordinate
          _x = _v47.value
          buff.write(_get_struct_h().pack(_x))
          _v48 = _v45.z_coordinate
          _x = _v48.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v45.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v44.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v49 = _v44.radius
          _x = _v49.value
          buff.write(_get_struct_H().pack(_x))
          _v50 = _v44.height
          _x = _v50.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v44.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v51 = _v34.polygonal
          _v52 = _v51.shape_reference_point
          _v53 = _v52.x_coordinate
          _x = _v53.value
          buff.write(_get_struct_h().pack(_x))
          _v54 = _v52.y_coordinate
          _x = _v54.value
          buff.write(_get_struct_h().pack(_x))
          _v55 = _v52.z_coordinate
          _x = _v55.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v52.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v51.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v56 = _v51.polygon
          length = len(_v56.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v56.array:
            _v57 = val8.x_coordinate
            _x = _v57.value
            buff.write(_get_struct_h().pack(_x))
            _v58 = val8.y_coordinate
            _x = _v58.value
            buff.write(_get_struct_h().pack(_x))
            _v59 = val8.z_coordinate
            _x = _v59.value
            buff.write(_get_struct_h().pack(_x))
            _x = val8.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v60 = _v51.height
          _x = _v60.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v51.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v61 = _v34.elliptical
          _v62 = _v61.shape_reference_point
          _v63 = _v62.x_coordinate
          _x = _v63.value
          buff.write(_get_struct_h().pack(_x))
          _v64 = _v62.y_coordinate
          _x = _v64.value
          buff.write(_get_struct_h().pack(_x))
          _v65 = _v62.z_coordinate
          _x = _v65.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v62.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v61.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v66 = _v61.semi_major_axis_length
          _x = _v66.value
          buff.write(_get_struct_H().pack(_x))
          _v67 = _v61.semi_minor_axis_length
          _x = _v67.value
          buff.write(_get_struct_H().pack(_x))
          _v68 = _v61.orientation
          _x = _v68.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v61.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v69 = _v61.height
          _x = _v69.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v61.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v70 = _v34.radial
          _v71 = _v70.shape_reference_point
          _v72 = _v71.x_coordinate
          _x = _v72.value
          buff.write(_get_struct_h().pack(_x))
          _v73 = _v71.y_coordinate
          _x = _v73.value
          buff.write(_get_struct_h().pack(_x))
          _v74 = _v71.z_coordinate
          _x = _v74.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v71.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v70.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v75 = _v70.range
          _x = _v75.value
          buff.write(_get_struct_H().pack(_x))
          _v76 = _v70.stationary_horizontal_opening_angle_start
          _x = _v76.value
          buff.write(_get_struct_H().pack(_x))
          _v77 = _v70.stationary_horizontal_opening_angle_end
          _x = _v77.value
          buff.write(_get_struct_H().pack(_x))
          _v78 = _v70.vertical_opening_angle_start
          _x = _v78.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v70.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v79 = _v70.vertical_opening_angle_end
          _x = _v79.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v70.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v80 = _v34.radial_shapes
          _v81 = _v80.ref_point_id
          _x = _v81.value
          buff.write(_get_struct_B().pack(_x))
          _v82 = _v80.x_coordinate
          _x = _v82.value
          buff.write(_get_struct_h().pack(_x))
          _v83 = _v80.y_coordinate
          _x = _v83.value
          buff.write(_get_struct_h().pack(_x))
          _v84 = _v80.z_coordinate
          _x = _v84.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v80.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v85 = _v80.radial_shapes_list
          length = len(_v85.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v85.array:
            _v86 = val8.range
            _x = _v86.value
            buff.write(_get_struct_H().pack(_x))
            _v87 = val8.horizontal_opening_angle_start
            _x = _v87.value
            buff.write(_get_struct_H().pack(_x))
            _v88 = val8.horizontal_opening_angle_end
            _x = _v88.value
            buff.write(_get_struct_H().pack(_x))
            _v89 = val8.vertical_opening_angle_start
            _x = _v89.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v90 = val8.vertical_opening_angle_end
            _x = _v90.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val4.perception_region_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v91 = val4.perception_region_confidence
          _x = _v91.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4
          buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
        _v92 = _v2.perception_region_container
        length = len(_v92.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v92.array:
          _v93 = val4.measurement_delta_time
          _x = _v93.value
          buff.write(_get_struct_h().pack(_x))
          _v94 = val4.perception_region_confidence
          _x = _v94.value
          buff.write(_get_struct_B().pack(_x))
          _v95 = val4.perception_region_shape
          _x = _v95.choice
          buff.write(_get_struct_B().pack(_x))
          _v96 = _v95.rectangular
          _v97 = _v96.center_point
          _v98 = _v97.x_coordinate
          _x = _v98.value
          buff.write(_get_struct_h().pack(_x))
          _v99 = _v97.y_coordinate
          _x = _v99.value
          buff.write(_get_struct_h().pack(_x))
          _v100 = _v97.z_coordinate
          _x = _v100.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v97.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v96.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v101 = _v96.semi_length
          _x = _v101.value
          buff.write(_get_struct_H().pack(_x))
          _v102 = _v96.semi_breadth
          _x = _v102.value
          buff.write(_get_struct_H().pack(_x))
          _v103 = _v96.orientation
          _x = _v103.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v96.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v104 = _v96.height
          _x = _v104.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v96.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v105 = _v95.circular
          _v106 = _v105.shape_reference_point
          _v107 = _v106.x_coordinate
          _x = _v107.value
          buff.write(_get_struct_h().pack(_x))
          _v108 = _v106.y_coordinate
          _x = _v108.value
          buff.write(_get_struct_h().pack(_x))
          _v109 = _v106.z_coordinate
          _x = _v109.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v106.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v105.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v110 = _v105.radius
          _x = _v110.value
          buff.write(_get_struct_H().pack(_x))
          _v111 = _v105.height
          _x = _v111.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v105.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v112 = _v95.polygonal
          _v113 = _v112.shape_reference_point
          _v114 = _v113.x_coordinate
          _x = _v114.value
          buff.write(_get_struct_h().pack(_x))
          _v115 = _v113.y_coordinate
          _x = _v115.value
          buff.write(_get_struct_h().pack(_x))
          _v116 = _v113.z_coordinate
          _x = _v116.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v113.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v112.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v117 = _v112.polygon
          length = len(_v117.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v117.array:
            _v118 = val8.x_coordinate
            _x = _v118.value
            buff.write(_get_struct_h().pack(_x))
            _v119 = val8.y_coordinate
            _x = _v119.value
            buff.write(_get_struct_h().pack(_x))
            _v120 = val8.z_coordinate
            _x = _v120.value
            buff.write(_get_struct_h().pack(_x))
            _x = val8.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v121 = _v112.height
          _x = _v121.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v112.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v122 = _v95.elliptical
          _v123 = _v122.shape_reference_point
          _v124 = _v123.x_coordinate
          _x = _v124.value
          buff.write(_get_struct_h().pack(_x))
          _v125 = _v123.y_coordinate
          _x = _v125.value
          buff.write(_get_struct_h().pack(_x))
          _v126 = _v123.z_coordinate
          _x = _v126.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v123.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v122.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v127 = _v122.semi_major_axis_length
          _x = _v127.value
          buff.write(_get_struct_H().pack(_x))
          _v128 = _v122.semi_minor_axis_length
          _x = _v128.value
          buff.write(_get_struct_H().pack(_x))
          _v129 = _v122.orientation
          _x = _v129.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v122.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v130 = _v122.height
          _x = _v130.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v122.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v131 = _v95.radial
          _v132 = _v131.shape_reference_point
          _v133 = _v132.x_coordinate
          _x = _v133.value
          buff.write(_get_struct_h().pack(_x))
          _v134 = _v132.y_coordinate
          _x = _v134.value
          buff.write(_get_struct_h().pack(_x))
          _v135 = _v132.z_coordinate
          _x = _v135.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v132.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v131.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v136 = _v131.range
          _x = _v136.value
          buff.write(_get_struct_H().pack(_x))
          _v137 = _v131.stationary_horizontal_opening_angle_start
          _x = _v137.value
          buff.write(_get_struct_H().pack(_x))
          _v138 = _v131.stationary_horizontal_opening_angle_end
          _x = _v138.value
          buff.write(_get_struct_H().pack(_x))
          _v139 = _v131.vertical_opening_angle_start
          _x = _v139.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v131.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v140 = _v131.vertical_opening_angle_end
          _x = _v140.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v131.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v141 = _v95.radial_shapes
          _v142 = _v141.ref_point_id
          _x = _v142.value
          buff.write(_get_struct_B().pack(_x))
          _v143 = _v141.x_coordinate
          _x = _v143.value
          buff.write(_get_struct_h().pack(_x))
          _v144 = _v141.y_coordinate
          _x = _v144.value
          buff.write(_get_struct_h().pack(_x))
          _v145 = _v141.z_coordinate
          _x = _v145.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v141.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v146 = _v141.radial_shapes_list
          length = len(_v146.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v146.array:
            _v147 = val8.range
            _x = _v147.value
            buff.write(_get_struct_H().pack(_x))
            _v148 = val8.horizontal_opening_angle_start
            _x = _v148.value
            buff.write(_get_struct_H().pack(_x))
            _v149 = val8.horizontal_opening_angle_end
            _x = _v149.value
            buff.write(_get_struct_H().pack(_x))
            _v150 = val8.vertical_opening_angle_start
            _x = _v150.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v151 = val8.vertical_opening_angle_end
            _x = _v151.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val4.shadowing_applies
          buff.write(_get_struct_B().pack(_x))
          _v152 = val4.sensor_id_list
          length = len(_v152.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v152.array:
            _x = val6.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v153 = val4.number_of_perceived_objects
          _x = _v153.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.number_of_perceived_objects_is_present
          buff.write(_get_struct_B().pack(_x))
          _v154 = val4.perceived_object_ids
          length = len(_v154.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v154.array:
            _x = val6.value
            buff.write(_get_struct_H().pack(_x))
          _x = val4.perceived_object_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _v155 = _v2.perceived_object_container
        _v156 = _v155.number_of_perceived_objects
        _x = _v156.value
        buff.write(_get_struct_B().pack(_x))
        _v157 = _v155.perceived_objects
        length = len(_v157.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v157.array:
          _v158 = val5.object_id
          _x = _v158.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.object_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v159 = val5.measurement_delta_time
          _x = _v159.value
          buff.write(_get_struct_h().pack(_x))
          _v160 = val5.position
          _v161 = _v160.x_coordinate
          _v162 = _v161.value
          _x = _v162.value
          buff.write(_get_struct_i().pack(_x))
          _v163 = _v161.confidence
          _x = _v163.value
          buff.write(_get_struct_H().pack(_x))
          _v164 = _v160.y_coordinate
          _v165 = _v164.value
          _x = _v165.value
          buff.write(_get_struct_i().pack(_x))
          _v166 = _v164.confidence
          _x = _v166.value
          buff.write(_get_struct_H().pack(_x))
          _v167 = _v160.z_coordinate
          _v168 = _v167.value
          _x = _v168.value
          buff.write(_get_struct_i().pack(_x))
          _v169 = _v167.confidence
          _x = _v169.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v160.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v170 = val5.velocity
          _x = _v170.choice
          buff.write(_get_struct_B().pack(_x))
          _v171 = _v170.polar_velocity
          _v172 = _v171.velocity_magnitude
          _v173 = _v172.speed_value
          _x = _v173.value
          buff.write(_get_struct_H().pack(_x))
          _v174 = _v172.speed_confidence
          _x = _v174.value
          buff.write(_get_struct_B().pack(_x))
          _v175 = _v171.velocity_direction
          _v176 = _v175.value
          _x = _v176.value
          buff.write(_get_struct_H().pack(_x))
          _v177 = _v175.confidence
          _x = _v177.value
          buff.write(_get_struct_B().pack(_x))
          _v178 = _v171.z_velocity
          _v179 = _v178.value
          _x = _v179.value
          buff.write(_get_struct_h().pack(_x))
          _v180 = _v178.confidence
          _x = _v180.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v171.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v181 = _v170.cartesian_velocity
          _v182 = _v181.x_velocity
          _v183 = _v182.value
          _x = _v183.value
          buff.write(_get_struct_h().pack(_x))
          _v184 = _v182.confidence
          _x = _v184.value
          buff.write(_get_struct_B().pack(_x))
          _v185 = _v181.y_velocity
          _v186 = _v185.value
          _x = _v186.value
          buff.write(_get_struct_h().pack(_x))
          _v187 = _v185.confidence
          _x = _v187.value
          buff.write(_get_struct_B().pack(_x))
          _v188 = _v181.z_velocity
          _v189 = _v188.value
          _x = _v189.value
          buff.write(_get_struct_h().pack(_x))
          _v190 = _v188.confidence
          _x = _v190.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v181.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v191 = val5.acceleration
          _x = _v191.choice
          buff.write(_get_struct_B().pack(_x))
          _v192 = _v191.polar_acceleration
          _v193 = _v192.acceleration_magnitude
          _v194 = _v193.acceleration_magnitude_value
          _x = _v194.value
          buff.write(_get_struct_B().pack(_x))
          _v195 = _v193.acceleration_confidence
          _x = _v195.value
          buff.write(_get_struct_B().pack(_x))
          _v196 = _v192.acceleration_direction
          _v197 = _v196.value
          _x = _v197.value
          buff.write(_get_struct_H().pack(_x))
          _v198 = _v196.confidence
          _x = _v198.value
          buff.write(_get_struct_B().pack(_x))
          _v199 = _v192.z_acceleration
          _v200 = _v199.value
          _x = _v200.value
          buff.write(_get_struct_h().pack(_x))
          _v201 = _v199.confidence
          _x = _v201.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v192.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v202 = _v191.cartesian_acceleration
          _v203 = _v202.x_acceleration
          _v204 = _v203.value
          _x = _v204.value
          buff.write(_get_struct_h().pack(_x))
          _v205 = _v203.confidence
          _x = _v205.value
          buff.write(_get_struct_B().pack(_x))
          _v206 = _v202.y_acceleration
          _v207 = _v206.value
          _x = _v207.value
          buff.write(_get_struct_h().pack(_x))
          _v208 = _v206.confidence
          _x = _v208.value
          buff.write(_get_struct_B().pack(_x))
          _v209 = _v202.z_acceleration
          _v210 = _v209.value
          _x = _v210.value
          buff.write(_get_struct_h().pack(_x))
          _v211 = _v209.confidence
          _x = _v211.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v202.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v212 = val5.angles
          _v213 = _v212.z_angle
          _v214 = _v213.value
          _x = _v214.value
          buff.write(_get_struct_H().pack(_x))
          _v215 = _v213.confidence
          _x = _v215.value
          buff.write(_get_struct_B().pack(_x))
          _v216 = _v212.y_angle
          _v217 = _v216.value
          _x = _v217.value
          buff.write(_get_struct_H().pack(_x))
          _v218 = _v216.confidence
          _x = _v218.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v212.y_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _v219 = _v212.x_angle
          _v220 = _v219.value
          _x = _v220.value
          buff.write(_get_struct_H().pack(_x))
          _v221 = _v219.confidence
          _x = _v221.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v212.x_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.angles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v222 = val5.z_angular_velocity
          _v223 = _v222.value
          _x = _v223.value
          buff.write(_get_struct_h().pack(_x))
          _v224 = _v222.confidence
          _x = _v224.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.z_angular_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v225 = val5.lower_triangular_correlation_matrices
          length = len(_v225.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v225.array:
            _v226 = val7.components_included_inthe_matrix
            _x = _v226.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v226.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _v227 = val7.matrix
            length = len(_v227.array)
            buff.write(_struct_I.pack(length))
            for val9 in _v227.array:
              length = len(val9.array)
              buff.write(_struct_I.pack(length))
              for val10 in val9.array:
                _x = val10.value
                buff.write(_get_struct_b().pack(_x))
          _x = val5.lower_triangular_correlation_matrices_is_present
          buff.write(_get_struct_B().pack(_x))
          _v228 = val5.object_dimension_z
          _v229 = _v228.value
          _x = _v229.value
          buff.write(_get_struct_H().pack(_x))
          _v230 = _v228.confidence
          _x = _v230.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_z_is_present
          buff.write(_get_struct_B().pack(_x))
          _v231 = val5.object_dimension_y
          _v232 = _v231.value
          _x = _v232.value
          buff.write(_get_struct_H().pack(_x))
          _v233 = _v231.confidence
          _x = _v233.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_y_is_present
          buff.write(_get_struct_B().pack(_x))
          _v234 = val5.object_dimension_x
          _v235 = _v234.value
          _x = _v235.value
          buff.write(_get_struct_H().pack(_x))
          _v236 = _v234.confidence
          _x = _v236.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_x_is_present
          buff.write(_get_struct_B().pack(_x))
          _v237 = val5.object_age
          _x = _v237.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.object_age_is_present
          buff.write(_get_struct_B().pack(_x))
          _v238 = val5.object_perception_quality
          _x = _v238.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_perception_quality_is_present
          buff.write(_get_struct_B().pack(_x))
          _v239 = val5.sensor_id_list
          length = len(_v239.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v239.array:
            _x = val7.value
            buff.write(_get_struct_B().pack(_x))
          _x = val5.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v240 = val5.classification
          length = len(_v240.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v240.array:
            _v241 = val7.object_class
            _x = _v241.choice
            buff.write(_get_struct_B().pack(_x))
            _v242 = _v241.vehicle_sub_class
            _x = _v242.value
            buff.write(_get_struct_B().pack(_x))
            _v243 = _v241.vru_sub_class
            _x = _v243.choice
            buff.write(_get_struct_B().pack(_x))
            _v244 = _v243.pedestrian
            _x = _v244.value
            buff.write(_get_struct_B().pack(_x))
            _v245 = _v243.bicyclist_and_light_vru_vehicle
            _x = _v245.value
            buff.write(_get_struct_B().pack(_x))
            _v246 = _v243.motorcyclist
            _x = _v246.value
            buff.write(_get_struct_B().pack(_x))
            _v247 = _v243.animal
            _x = _v247.value
            buff.write(_get_struct_B().pack(_x))
            _v248 = _v241.group_sub_class
            _v249 = _v248.cluster_id
            _x = _v249.value
            buff.write(_get_struct_B().pack(_x))
            _x = _v248.cluster_id_is_present
            buff.write(_get_struct_B().pack(_x))
            _v250 = _v248.cluster_bounding_box_shape
            _x = _v250.choice
            buff.write(_get_struct_B().pack(_x))
            _v251 = _v250.rectangular
            _v252 = _v251.center_point
            _v253 = _v252.x_coordinate
            _x = _v253.value
            buff.write(_get_struct_h().pack(_x))
            _v254 = _v252.y_coordinate
            _x = _v254.value
            buff.write(_get_struct_h().pack(_x))
            _v255 = _v252.z_coordinate
            _x = _v255.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v252.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v251.center_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v256 = _v251.semi_length
            _x = _v256.value
            buff.write(_get_struct_H().pack(_x))
            _v257 = _v251.semi_breadth
            _x = _v257.value
            buff.write(_get_struct_H().pack(_x))
            _v258 = _v251.orientation
            _x = _v258.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v251.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v259 = _v251.height
            _x = _v259.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v251.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v260 = _v250.circular
            _v261 = _v260.shape_reference_point
            _v262 = _v261.x_coordinate
            _x = _v262.value
            buff.write(_get_struct_h().pack(_x))
            _v263 = _v261.y_coordinate
            _x = _v263.value
            buff.write(_get_struct_h().pack(_x))
            _v264 = _v261.z_coordinate
            _x = _v264.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v261.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v260.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v265 = _v260.radius
            _x = _v265.value
            buff.write(_get_struct_H().pack(_x))
            _v266 = _v260.height
            _x = _v266.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v260.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v267 = _v250.polygonal
            _v268 = _v267.shape_reference_point
            _v269 = _v268.x_coordinate
            _x = _v269.value
            buff.write(_get_struct_h().pack(_x))
            _v270 = _v268.y_coordinate
            _x = _v270.value
            buff.write(_get_struct_h().pack(_x))
            _v271 = _v268.z_coordinate
            _x = _v271.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v268.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v267.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v272 = _v267.polygon
            length = len(_v272.array)
            buff.write(_struct_I.pack(length))
            for val13 in _v272.array:
              _v273 = val13.x_coordinate
              _x = _v273.value
              buff.write(_get_struct_h().pack(_x))
              _v274 = val13.y_coordinate
              _x = _v274.value
              buff.write(_get_struct_h().pack(_x))
              _v275 = val13.z_coordinate
              _x = _v275.value
              buff.write(_get_struct_h().pack(_x))
              _x = val13.z_coordinate_is_present
              buff.write(_get_struct_B().pack(_x))
            _v276 = _v267.height
            _x = _v276.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v267.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v277 = _v250.elliptical
            _v278 = _v277.shape_reference_point
            _v279 = _v278.x_coordinate
            _x = _v279.value
            buff.write(_get_struct_h().pack(_x))
            _v280 = _v278.y_coordinate
            _x = _v280.value
            buff.write(_get_struct_h().pack(_x))
            _v281 = _v278.z_coordinate
            _x = _v281.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v278.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v277.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v282 = _v277.semi_major_axis_length
            _x = _v282.value
            buff.write(_get_struct_H().pack(_x))
            _v283 = _v277.semi_minor_axis_length
            _x = _v283.value
            buff.write(_get_struct_H().pack(_x))
            _v284 = _v277.orientation
            _x = _v284.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v277.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v285 = _v277.height
            _x = _v285.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v277.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v286 = _v250.radial
            _v287 = _v286.shape_reference_point
            _v288 = _v287.x_coordinate
            _x = _v288.value
            buff.write(_get_struct_h().pack(_x))
            _v289 = _v287.y_coordinate
            _x = _v289.value
            buff.write(_get_struct_h().pack(_x))
            _v290 = _v287.z_coordinate
            _x = _v290.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v287.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v286.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v291 = _v286.range
            _x = _v291.value
            buff.write(_get_struct_H().pack(_x))
            _v292 = _v286.stationary_horizontal_opening_angle_start
            _x = _v292.value
            buff.write(_get_struct_H().pack(_x))
            _v293 = _v286.stationary_horizontal_opening_angle_end
            _x = _v293.value
            buff.write(_get_struct_H().pack(_x))
            _v294 = _v286.vertical_opening_angle_start
            _x = _v294.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v286.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v295 = _v286.vertical_opening_angle_end
            _x = _v295.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v286.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
            _v296 = _v250.radial_shapes
            _v297 = _v296.ref_point_id
            _x = _v297.value
            buff.write(_get_struct_B().pack(_x))
            _v298 = _v296.x_coordinate
            _x = _v298.value
            buff.write(_get_struct_h().pack(_x))
            _v299 = _v296.y_coordinate
            _x = _v299.value
            buff.write(_get_struct_h().pack(_x))
            _v300 = _v296.z_coordinate
            _x = _v300.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v296.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _v301 = _v296.radial_shapes_list
            length = len(_v301.array)
            buff.write(_struct_I.pack(length))
            for val13 in _v301.array:
              _v302 = val13.range
              _x = _v302.value
              buff.write(_get_struct_H().pack(_x))
              _v303 = val13.horizontal_opening_angle_start
              _x = _v303.value
              buff.write(_get_struct_H().pack(_x))
              _v304 = val13.horizontal_opening_angle_end
              _x = _v304.value
              buff.write(_get_struct_H().pack(_x))
              _v305 = val13.vertical_opening_angle_start
              _x = _v305.value
              buff.write(_get_struct_H().pack(_x))
              _x = val13.vertical_opening_angle_start_is_present
              buff.write(_get_struct_B().pack(_x))
              _v306 = val13.vertical_opening_angle_end
              _x = _v306.value
              buff.write(_get_struct_H().pack(_x))
              _x = val13.vertical_opening_angle_end_is_present
              buff.write(_get_struct_B().pack(_x))
            _x = _v248.cluster_bounding_box_shape_is_present
            buff.write(_get_struct_B().pack(_x))
            _v307 = _v248.cluster_cardinality_size
            _x = _v307.value
            buff.write(_get_struct_B().pack(_x))
            _v308 = _v248.cluster_profiles
            _x = _v308.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v308.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _x = _v248.cluster_profiles_is_present
            buff.write(_get_struct_B().pack(_x))
            _v309 = _v241.other_sub_class
            _x = _v309.value
            buff.write(_get_struct_B().pack(_x))
            _v310 = val7.confidence
            _x = _v310.value
            buff.write(_get_struct_B().pack(_x))
          _x = val5.classification_is_present
          buff.write(_get_struct_B().pack(_x))
          _v311 = val5.map_position
          _v312 = _v311.map_reference
          _x = _v312.choice
          buff.write(_get_struct_B().pack(_x))
          _v313 = _v312.roadsegment
          _v314 = _v313.region
          _x = _v314.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v313.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v315 = _v313.id
          _x = _v315.value
          buff.write(_get_struct_H().pack(_x))
          _v316 = _v312.intersection
          _v317 = _v316.region
          _x = _v317.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v316.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v318 = _v316.id
          _x = _v318.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v311.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v319 = _v311.lane_id
          _x = _v319.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v311.lane_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v320 = _v311.connection_id
          _x = _v320.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v311.connection_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v321 = _v311.longitudinal_lane_position
          _v322 = _v321.longitudinal_lane_position_value
          _x = _v322.value
          buff.write(_get_struct_H().pack(_x))
          _v323 = _v321.longitudinal_lane_position_confidence
          _x = _v323.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v311.longitudinal_lane_position_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.map_position_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.WrappedCpmContainer()
        _v324 = val1.container_id
        start = end
        end += 1
        (_v324.value,) = _get_struct_B().unpack(str[start:end])
        _v325 = val1.container_data
        _v326 = _v325.choice
        start = end
        end += 1
        (_v326.value,) = _get_struct_B().unpack(str[start:end])
        _v327 = _v325.originating_vehicle_container
        _v328 = _v327.orientation_angle
        _v329 = _v328.value
        start = end
        end += 2
        (_v329.value,) = _get_struct_H().unpack(str[start:end])
        _v330 = _v328.confidence
        start = end
        end += 1
        (_v330.value,) = _get_struct_B().unpack(str[start:end])
        _v331 = _v327.pitch_angle
        _v332 = _v331.value
        start = end
        end += 2
        (_v332.value,) = _get_struct_H().unpack(str[start:end])
        _v333 = _v331.confidence
        start = end
        end += 1
        (_v333.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v327.pitch_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v327.pitch_angle_is_present = bool(_v327.pitch_angle_is_present)
        _v334 = _v327.roll_angle
        _v335 = _v334.value
        start = end
        end += 2
        (_v335.value,) = _get_struct_H().unpack(str[start:end])
        _v336 = _v334.confidence
        start = end
        end += 1
        (_v336.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v327.roll_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v327.roll_angle_is_present = bool(_v327.roll_angle_is_present)
        _v337 = _v327.trailer_data_set
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v337.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.TrailerData()
          _v338 = val5.ref_point_id
          start = end
          end += 1
          (_v338.value,) = _get_struct_B().unpack(str[start:end])
          _v339 = val5.hitch_point_offset
          start = end
          end += 1
          (_v339.value,) = _get_struct_B().unpack(str[start:end])
          _v340 = val5.front_overhang
          start = end
          end += 1
          (_v340.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.front_overhang_is_present = bool(val5.front_overhang_is_present)
          _v341 = val5.rear_overhang
          start = end
          end += 1
          (_v341.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.rear_overhang_is_present = bool(val5.rear_overhang_is_present)
          _v342 = val5.trailer_width
          start = end
          end += 1
          (_v342.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.trailer_width_is_present = bool(val5.trailer_width_is_present)
          _v343 = val5.hitch_angle
          _v344 = _v343.value
          start = end
          end += 2
          (_v344.value,) = _get_struct_H().unpack(str[start:end])
          _v345 = _v343.confidence
          start = end
          end += 1
          (_v345.value,) = _get_struct_B().unpack(str[start:end])
          _v337.array.append(val5)
        start = end
        end += 1
        (_v327.trailer_data_set_is_present,) = _get_struct_B().unpack(str[start:end])
        _v327.trailer_data_set_is_present = bool(_v327.trailer_data_set_is_present)
        _v346 = _v325.originating_rsu_container
        _v347 = _v346.map_reference
        start = end
        end += 1
        (_v347.choice,) = _get_struct_B().unpack(str[start:end])
        _v348 = _v347.roadsegment
        _v349 = _v348.region
        start = end
        end += 2
        (_v349.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v348.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v348.region_is_present = bool(_v348.region_is_present)
        _v350 = _v348.id
        start = end
        end += 2
        (_v350.value,) = _get_struct_H().unpack(str[start:end])
        _v351 = _v347.intersection
        _v352 = _v351.region
        start = end
        end += 2
        (_v352.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v351.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v351.region_is_present = bool(_v351.region_is_present)
        _v353 = _v351.id
        start = end
        end += 2
        (_v353.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v346.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v346.map_reference_is_present = bool(_v346.map_reference_is_present)
        _v354 = _v325.sensor_information_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v354.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
          _v355 = val4.sensor_id
          start = end
          end += 1
          (_v355.value,) = _get_struct_B().unpack(str[start:end])
          _v356 = val4.sensor_type
          start = end
          end += 1
          (_v356.value,) = _get_struct_B().unpack(str[start:end])
          _v357 = val4.perception_region_shape
          start = end
          end += 1
          (_v357.choice,) = _get_struct_B().unpack(str[start:end])
          _v358 = _v357.rectangular
          _v359 = _v358.center_point
          _v360 = _v359.x_coordinate
          start = end
          end += 2
          (_v360.value,) = _get_struct_h().unpack(str[start:end])
          _v361 = _v359.y_coordinate
          start = end
          end += 2
          (_v361.value,) = _get_struct_h().unpack(str[start:end])
          _v362 = _v359.z_coordinate
          start = end
          end += 2
          (_v362.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v359.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v359.z_coordinate_is_present = bool(_v359.z_coordinate_is_present)
          start = end
          end += 1
          (_v358.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v358.center_point_is_present = bool(_v358.center_point_is_present)
          _v363 = _v358.semi_length
          start = end
          end += 2
          (_v363.value,) = _get_struct_H().unpack(str[start:end])
          _v364 = _v358.semi_breadth
          start = end
          end += 2
          (_v364.value,) = _get_struct_H().unpack(str[start:end])
          _v365 = _v358.orientation
          start = end
          end += 2
          (_v365.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v358.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v358.orientation_is_present = bool(_v358.orientation_is_present)
          _v366 = _v358.height
          start = end
          end += 2
          (_v366.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v358.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v358.height_is_present = bool(_v358.height_is_present)
          _v367 = _v357.circular
          _v368 = _v367.shape_reference_point
          _v369 = _v368.x_coordinate
          start = end
          end += 2
          (_v369.value,) = _get_struct_h().unpack(str[start:end])
          _v370 = _v368.y_coordinate
          start = end
          end += 2
          (_v370.value,) = _get_struct_h().unpack(str[start:end])
          _v371 = _v368.z_coordinate
          start = end
          end += 2
          (_v371.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v368.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v368.z_coordinate_is_present = bool(_v368.z_coordinate_is_present)
          start = end
          end += 1
          (_v367.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v367.shape_reference_point_is_present = bool(_v367.shape_reference_point_is_present)
          _v372 = _v367.radius
          start = end
          end += 2
          (_v372.value,) = _get_struct_H().unpack(str[start:end])
          _v373 = _v367.height
          start = end
          end += 2
          (_v373.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v367.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v367.height_is_present = bool(_v367.height_is_present)
          _v374 = _v357.polygonal
          _v375 = _v374.shape_reference_point
          _v376 = _v375.x_coordinate
          start = end
          end += 2
          (_v376.value,) = _get_struct_h().unpack(str[start:end])
          _v377 = _v375.y_coordinate
          start = end
          end += 2
          (_v377.value,) = _get_struct_h().unpack(str[start:end])
          _v378 = _v375.z_coordinate
          start = end
          end += 2
          (_v378.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v375.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v375.z_coordinate_is_present = bool(_v375.z_coordinate_is_present)
          start = end
          end += 1
          (_v374.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v374.shape_reference_point_is_present = bool(_v374.shape_reference_point_is_present)
          _v379 = _v374.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v379.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v380 = val8.x_coordinate
            start = end
            end += 2
            (_v380.value,) = _get_struct_h().unpack(str[start:end])
            _v381 = val8.y_coordinate
            start = end
            end += 2
            (_v381.value,) = _get_struct_h().unpack(str[start:end])
            _v382 = val8.z_coordinate
            start = end
            end += 2
            (_v382.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val8.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.z_coordinate_is_present = bool(val8.z_coordinate_is_present)
            _v379.array.append(val8)
          _v383 = _v374.height
          start = end
          end += 2
          (_v383.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v374.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v374.height_is_present = bool(_v374.height_is_present)
          _v384 = _v357.elliptical
          _v385 = _v384.shape_reference_point
          _v386 = _v385.x_coordinate
          start = end
          end += 2
          (_v386.value,) = _get_struct_h().unpack(str[start:end])
          _v387 = _v385.y_coordinate
          start = end
          end += 2
          (_v387.value,) = _get_struct_h().unpack(str[start:end])
          _v388 = _v385.z_coordinate
          start = end
          end += 2
          (_v388.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v385.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v385.z_coordinate_is_present = bool(_v385.z_coordinate_is_present)
          start = end
          end += 1
          (_v384.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v384.shape_reference_point_is_present = bool(_v384.shape_reference_point_is_present)
          _v389 = _v384.semi_major_axis_length
          start = end
          end += 2
          (_v389.value,) = _get_struct_H().unpack(str[start:end])
          _v390 = _v384.semi_minor_axis_length
          start = end
          end += 2
          (_v390.value,) = _get_struct_H().unpack(str[start:end])
          _v391 = _v384.orientation
          start = end
          end += 2
          (_v391.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v384.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v384.orientation_is_present = bool(_v384.orientation_is_present)
          _v392 = _v384.height
          start = end
          end += 2
          (_v392.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v384.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v384.height_is_present = bool(_v384.height_is_present)
          _v393 = _v357.radial
          _v394 = _v393.shape_reference_point
          _v395 = _v394.x_coordinate
          start = end
          end += 2
          (_v395.value,) = _get_struct_h().unpack(str[start:end])
          _v396 = _v394.y_coordinate
          start = end
          end += 2
          (_v396.value,) = _get_struct_h().unpack(str[start:end])
          _v397 = _v394.z_coordinate
          start = end
          end += 2
          (_v397.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v394.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v394.z_coordinate_is_present = bool(_v394.z_coordinate_is_present)
          start = end
          end += 1
          (_v393.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v393.shape_reference_point_is_present = bool(_v393.shape_reference_point_is_present)
          _v398 = _v393.range
          start = end
          end += 2
          (_v398.value,) = _get_struct_H().unpack(str[start:end])
          _v399 = _v393.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v399.value,) = _get_struct_H().unpack(str[start:end])
          _v400 = _v393.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v400.value,) = _get_struct_H().unpack(str[start:end])
          _v401 = _v393.vertical_opening_angle_start
          start = end
          end += 2
          (_v401.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v393.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v393.vertical_opening_angle_start_is_present = bool(_v393.vertical_opening_angle_start_is_present)
          _v402 = _v393.vertical_opening_angle_end
          start = end
          end += 2
          (_v402.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v393.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v393.vertical_opening_angle_end_is_present = bool(_v393.vertical_opening_angle_end_is_present)
          _v403 = _v357.radial_shapes
          _v404 = _v403.ref_point_id
          start = end
          end += 1
          (_v404.value,) = _get_struct_B().unpack(str[start:end])
          _v405 = _v403.x_coordinate
          start = end
          end += 2
          (_v405.value,) = _get_struct_h().unpack(str[start:end])
          _v406 = _v403.y_coordinate
          start = end
          end += 2
          (_v406.value,) = _get_struct_h().unpack(str[start:end])
          _v407 = _v403.z_coordinate
          start = end
          end += 2
          (_v407.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v403.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v403.z_coordinate_is_present = bool(_v403.z_coordinate_is_present)
          _v408 = _v403.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v408.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v409 = val8.range
            start = end
            end += 2
            (_v409.value,) = _get_struct_H().unpack(str[start:end])
            _v410 = val8.horizontal_opening_angle_start
            start = end
            end += 2
            (_v410.value,) = _get_struct_H().unpack(str[start:end])
            _v411 = val8.horizontal_opening_angle_end
            start = end
            end += 2
            (_v411.value,) = _get_struct_H().unpack(str[start:end])
            _v412 = val8.vertical_opening_angle_start
            start = end
            end += 2
            (_v412.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_start_is_present = bool(val8.vertical_opening_angle_start_is_present)
            _v413 = val8.vertical_opening_angle_end
            start = end
            end += 2
            (_v413.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_end_is_present = bool(val8.vertical_opening_angle_end_is_present)
            _v408.array.append(val8)
          start = end
          end += 1
          (val4.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.perception_region_shape_is_present = bool(val4.perception_region_shape_is_present)
          _v414 = val4.perception_region_confidence
          start = end
          end += 1
          (_v414.value,) = _get_struct_B().unpack(str[start:end])
          _x = val4
          start = end
          end += 2
          (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
          val4.perception_region_confidence_is_present = bool(val4.perception_region_confidence_is_present)
          val4.shadowing_applies = bool(val4.shadowing_applies)
          _v354.array.append(val4)
        _v415 = _v325.perception_region_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v415.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
          _v416 = val4.measurement_delta_time
          start = end
          end += 2
          (_v416.value,) = _get_struct_h().unpack(str[start:end])
          _v417 = val4.perception_region_confidence
          start = end
          end += 1
          (_v417.value,) = _get_struct_B().unpack(str[start:end])
          _v418 = val4.perception_region_shape
          start = end
          end += 1
          (_v418.choice,) = _get_struct_B().unpack(str[start:end])
          _v419 = _v418.rectangular
          _v420 = _v419.center_point
          _v421 = _v420.x_coordinate
          start = end
          end += 2
          (_v421.value,) = _get_struct_h().unpack(str[start:end])
          _v422 = _v420.y_coordinate
          start = end
          end += 2
          (_v422.value,) = _get_struct_h().unpack(str[start:end])
          _v423 = _v420.z_coordinate
          start = end
          end += 2
          (_v423.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v420.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v420.z_coordinate_is_present = bool(_v420.z_coordinate_is_present)
          start = end
          end += 1
          (_v419.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v419.center_point_is_present = bool(_v419.center_point_is_present)
          _v424 = _v419.semi_length
          start = end
          end += 2
          (_v424.value,) = _get_struct_H().unpack(str[start:end])
          _v425 = _v419.semi_breadth
          start = end
          end += 2
          (_v425.value,) = _get_struct_H().unpack(str[start:end])
          _v426 = _v419.orientation
          start = end
          end += 2
          (_v426.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v419.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v419.orientation_is_present = bool(_v419.orientation_is_present)
          _v427 = _v419.height
          start = end
          end += 2
          (_v427.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v419.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v419.height_is_present = bool(_v419.height_is_present)
          _v428 = _v418.circular
          _v429 = _v428.shape_reference_point
          _v430 = _v429.x_coordinate
          start = end
          end += 2
          (_v430.value,) = _get_struct_h().unpack(str[start:end])
          _v431 = _v429.y_coordinate
          start = end
          end += 2
          (_v431.value,) = _get_struct_h().unpack(str[start:end])
          _v432 = _v429.z_coordinate
          start = end
          end += 2
          (_v432.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v429.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v429.z_coordinate_is_present = bool(_v429.z_coordinate_is_present)
          start = end
          end += 1
          (_v428.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v428.shape_reference_point_is_present = bool(_v428.shape_reference_point_is_present)
          _v433 = _v428.radius
          start = end
          end += 2
          (_v433.value,) = _get_struct_H().unpack(str[start:end])
          _v434 = _v428.height
          start = end
          end += 2
          (_v434.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v428.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v428.height_is_present = bool(_v428.height_is_present)
          _v435 = _v418.polygonal
          _v436 = _v435.shape_reference_point
          _v437 = _v436.x_coordinate
          start = end
          end += 2
          (_v437.value,) = _get_struct_h().unpack(str[start:end])
          _v438 = _v436.y_coordinate
          start = end
          end += 2
          (_v438.value,) = _get_struct_h().unpack(str[start:end])
          _v439 = _v436.z_coordinate
          start = end
          end += 2
          (_v439.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v436.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v436.z_coordinate_is_present = bool(_v436.z_coordinate_is_present)
          start = end
          end += 1
          (_v435.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v435.shape_reference_point_is_present = bool(_v435.shape_reference_point_is_present)
          _v440 = _v435.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v440.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v441 = val8.x_coordinate
            start = end
            end += 2
            (_v441.value,) = _get_struct_h().unpack(str[start:end])
            _v442 = val8.y_coordinate
            start = end
            end += 2
            (_v442.value,) = _get_struct_h().unpack(str[start:end])
            _v443 = val8.z_coordinate
            start = end
            end += 2
            (_v443.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val8.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.z_coordinate_is_present = bool(val8.z_coordinate_is_present)
            _v440.array.append(val8)
          _v444 = _v435.height
          start = end
          end += 2
          (_v444.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v435.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v435.height_is_present = bool(_v435.height_is_present)
          _v445 = _v418.elliptical
          _v446 = _v445.shape_reference_point
          _v447 = _v446.x_coordinate
          start = end
          end += 2
          (_v447.value,) = _get_struct_h().unpack(str[start:end])
          _v448 = _v446.y_coordinate
          start = end
          end += 2
          (_v448.value,) = _get_struct_h().unpack(str[start:end])
          _v449 = _v446.z_coordinate
          start = end
          end += 2
          (_v449.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v446.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v446.z_coordinate_is_present = bool(_v446.z_coordinate_is_present)
          start = end
          end += 1
          (_v445.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v445.shape_reference_point_is_present = bool(_v445.shape_reference_point_is_present)
          _v450 = _v445.semi_major_axis_length
          start = end
          end += 2
          (_v450.value,) = _get_struct_H().unpack(str[start:end])
          _v451 = _v445.semi_minor_axis_length
          start = end
          end += 2
          (_v451.value,) = _get_struct_H().unpack(str[start:end])
          _v452 = _v445.orientation
          start = end
          end += 2
          (_v452.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v445.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v445.orientation_is_present = bool(_v445.orientation_is_present)
          _v453 = _v445.height
          start = end
          end += 2
          (_v453.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v445.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v445.height_is_present = bool(_v445.height_is_present)
          _v454 = _v418.radial
          _v455 = _v454.shape_reference_point
          _v456 = _v455.x_coordinate
          start = end
          end += 2
          (_v456.value,) = _get_struct_h().unpack(str[start:end])
          _v457 = _v455.y_coordinate
          start = end
          end += 2
          (_v457.value,) = _get_struct_h().unpack(str[start:end])
          _v458 = _v455.z_coordinate
          start = end
          end += 2
          (_v458.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v455.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v455.z_coordinate_is_present = bool(_v455.z_coordinate_is_present)
          start = end
          end += 1
          (_v454.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v454.shape_reference_point_is_present = bool(_v454.shape_reference_point_is_present)
          _v459 = _v454.range
          start = end
          end += 2
          (_v459.value,) = _get_struct_H().unpack(str[start:end])
          _v460 = _v454.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v460.value,) = _get_struct_H().unpack(str[start:end])
          _v461 = _v454.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v461.value,) = _get_struct_H().unpack(str[start:end])
          _v462 = _v454.vertical_opening_angle_start
          start = end
          end += 2
          (_v462.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v454.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v454.vertical_opening_angle_start_is_present = bool(_v454.vertical_opening_angle_start_is_present)
          _v463 = _v454.vertical_opening_angle_end
          start = end
          end += 2
          (_v463.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v454.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v454.vertical_opening_angle_end_is_present = bool(_v454.vertical_opening_angle_end_is_present)
          _v464 = _v418.radial_shapes
          _v465 = _v464.ref_point_id
          start = end
          end += 1
          (_v465.value,) = _get_struct_B().unpack(str[start:end])
          _v466 = _v464.x_coordinate
          start = end
          end += 2
          (_v466.value,) = _get_struct_h().unpack(str[start:end])
          _v467 = _v464.y_coordinate
          start = end
          end += 2
          (_v467.value,) = _get_struct_h().unpack(str[start:end])
          _v468 = _v464.z_coordinate
          start = end
          end += 2
          (_v468.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v464.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v464.z_coordinate_is_present = bool(_v464.z_coordinate_is_present)
          _v469 = _v464.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v469.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v470 = val8.range
            start = end
            end += 2
            (_v470.value,) = _get_struct_H().unpack(str[start:end])
            _v471 = val8.horizontal_opening_angle_start
            start = end
            end += 2
            (_v471.value,) = _get_struct_H().unpack(str[start:end])
            _v472 = val8.horizontal_opening_angle_end
            start = end
            end += 2
            (_v472.value,) = _get_struct_H().unpack(str[start:end])
            _v473 = val8.vertical_opening_angle_start
            start = end
            end += 2
            (_v473.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_start_is_present = bool(val8.vertical_opening_angle_start_is_present)
            _v474 = val8.vertical_opening_angle_end
            start = end
            end += 2
            (_v474.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_end_is_present = bool(val8.vertical_opening_angle_end_is_present)
            _v469.array.append(val8)
          start = end
          end += 1
          (val4.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
          val4.shadowing_applies = bool(val4.shadowing_applies)
          _v475 = val4.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v475.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val6.value,) = _get_struct_B().unpack(str[start:end])
            _v475.array.append(val6)
          start = end
          end += 1
          (val4.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.sensor_id_list_is_present = bool(val4.sensor_id_list_is_present)
          _v476 = val4.number_of_perceived_objects
          start = end
          end += 1
          (_v476.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.number_of_perceived_objects_is_present = bool(val4.number_of_perceived_objects_is_present)
          _v477 = val4.perceived_object_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v477.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
            start = end
            end += 2
            (val6.value,) = _get_struct_H().unpack(str[start:end])
            _v477.array.append(val6)
          start = end
          end += 1
          (val4.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.perceived_object_ids_is_present = bool(val4.perceived_object_ids_is_present)
          _v415.array.append(val4)
        _v478 = _v325.perceived_object_container
        _v479 = _v478.number_of_perceived_objects
        start = end
        end += 1
        (_v479.value,) = _get_struct_B().unpack(str[start:end])
        _v480 = _v478.perceived_objects
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v480.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
          _v481 = val5.object_id
          start = end
          end += 2
          (_v481.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_id_is_present = bool(val5.object_id_is_present)
          _v482 = val5.measurement_delta_time
          start = end
          end += 2
          (_v482.value,) = _get_struct_h().unpack(str[start:end])
          _v483 = val5.position
          _v484 = _v483.x_coordinate
          _v485 = _v484.value
          start = end
          end += 4
          (_v485.value,) = _get_struct_i().unpack(str[start:end])
          _v486 = _v484.confidence
          start = end
          end += 2
          (_v486.value,) = _get_struct_H().unpack(str[start:end])
          _v487 = _v483.y_coordinate
          _v488 = _v487.value
          start = end
          end += 4
          (_v488.value,) = _get_struct_i().unpack(str[start:end])
          _v489 = _v487.confidence
          start = end
          end += 2
          (_v489.value,) = _get_struct_H().unpack(str[start:end])
          _v490 = _v483.z_coordinate
          _v491 = _v490.value
          start = end
          end += 4
          (_v491.value,) = _get_struct_i().unpack(str[start:end])
          _v492 = _v490.confidence
          start = end
          end += 2
          (_v492.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v483.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v483.z_coordinate_is_present = bool(_v483.z_coordinate_is_present)
          _v493 = val5.velocity
          start = end
          end += 1
          (_v493.choice,) = _get_struct_B().unpack(str[start:end])
          _v494 = _v493.polar_velocity
          _v495 = _v494.velocity_magnitude
          _v496 = _v495.speed_value
          start = end
          end += 2
          (_v496.value,) = _get_struct_H().unpack(str[start:end])
          _v497 = _v495.speed_confidence
          start = end
          end += 1
          (_v497.value,) = _get_struct_B().unpack(str[start:end])
          _v498 = _v494.velocity_direction
          _v499 = _v498.value
          start = end
          end += 2
          (_v499.value,) = _get_struct_H().unpack(str[start:end])
          _v500 = _v498.confidence
          start = end
          end += 1
          (_v500.value,) = _get_struct_B().unpack(str[start:end])
          _v501 = _v494.z_velocity
          _v502 = _v501.value
          start = end
          end += 2
          (_v502.value,) = _get_struct_h().unpack(str[start:end])
          _v503 = _v501.confidence
          start = end
          end += 1
          (_v503.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v494.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v494.z_velocity_is_present = bool(_v494.z_velocity_is_present)
          _v504 = _v493.cartesian_velocity
          _v505 = _v504.x_velocity
          _v506 = _v505.value
          start = end
          end += 2
          (_v506.value,) = _get_struct_h().unpack(str[start:end])
          _v507 = _v505.confidence
          start = end
          end += 1
          (_v507.value,) = _get_struct_B().unpack(str[start:end])
          _v508 = _v504.y_velocity
          _v509 = _v508.value
          start = end
          end += 2
          (_v509.value,) = _get_struct_h().unpack(str[start:end])
          _v510 = _v508.confidence
          start = end
          end += 1
          (_v510.value,) = _get_struct_B().unpack(str[start:end])
          _v511 = _v504.z_velocity
          _v512 = _v511.value
          start = end
          end += 2
          (_v512.value,) = _get_struct_h().unpack(str[start:end])
          _v513 = _v511.confidence
          start = end
          end += 1
          (_v513.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v504.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v504.z_velocity_is_present = bool(_v504.z_velocity_is_present)
          start = end
          end += 1
          (val5.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.velocity_is_present = bool(val5.velocity_is_present)
          _v514 = val5.acceleration
          start = end
          end += 1
          (_v514.choice,) = _get_struct_B().unpack(str[start:end])
          _v515 = _v514.polar_acceleration
          _v516 = _v515.acceleration_magnitude
          _v517 = _v516.acceleration_magnitude_value
          start = end
          end += 1
          (_v517.value,) = _get_struct_B().unpack(str[start:end])
          _v518 = _v516.acceleration_confidence
          start = end
          end += 1
          (_v518.value,) = _get_struct_B().unpack(str[start:end])
          _v519 = _v515.acceleration_direction
          _v520 = _v519.value
          start = end
          end += 2
          (_v520.value,) = _get_struct_H().unpack(str[start:end])
          _v521 = _v519.confidence
          start = end
          end += 1
          (_v521.value,) = _get_struct_B().unpack(str[start:end])
          _v522 = _v515.z_acceleration
          _v523 = _v522.value
          start = end
          end += 2
          (_v523.value,) = _get_struct_h().unpack(str[start:end])
          _v524 = _v522.confidence
          start = end
          end += 1
          (_v524.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v515.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v515.z_acceleration_is_present = bool(_v515.z_acceleration_is_present)
          _v525 = _v514.cartesian_acceleration
          _v526 = _v525.x_acceleration
          _v527 = _v526.value
          start = end
          end += 2
          (_v527.value,) = _get_struct_h().unpack(str[start:end])
          _v528 = _v526.confidence
          start = end
          end += 1
          (_v528.value,) = _get_struct_B().unpack(str[start:end])
          _v529 = _v525.y_acceleration
          _v530 = _v529.value
          start = end
          end += 2
          (_v530.value,) = _get_struct_h().unpack(str[start:end])
          _v531 = _v529.confidence
          start = end
          end += 1
          (_v531.value,) = _get_struct_B().unpack(str[start:end])
          _v532 = _v525.z_acceleration
          _v533 = _v532.value
          start = end
          end += 2
          (_v533.value,) = _get_struct_h().unpack(str[start:end])
          _v534 = _v532.confidence
          start = end
          end += 1
          (_v534.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v525.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v525.z_acceleration_is_present = bool(_v525.z_acceleration_is_present)
          start = end
          end += 1
          (val5.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.acceleration_is_present = bool(val5.acceleration_is_present)
          _v535 = val5.angles
          _v536 = _v535.z_angle
          _v537 = _v536.value
          start = end
          end += 2
          (_v537.value,) = _get_struct_H().unpack(str[start:end])
          _v538 = _v536.confidence
          start = end
          end += 1
          (_v538.value,) = _get_struct_B().unpack(str[start:end])
          _v539 = _v535.y_angle
          _v540 = _v539.value
          start = end
          end += 2
          (_v540.value,) = _get_struct_H().unpack(str[start:end])
          _v541 = _v539.confidence
          start = end
          end += 1
          (_v541.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v535.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v535.y_angle_is_present = bool(_v535.y_angle_is_present)
          _v542 = _v535.x_angle
          _v543 = _v542.value
          start = end
          end += 2
          (_v543.value,) = _get_struct_H().unpack(str[start:end])
          _v544 = _v542.confidence
          start = end
          end += 1
          (_v544.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v535.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v535.x_angle_is_present = bool(_v535.x_angle_is_present)
          start = end
          end += 1
          (val5.angles_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.angles_is_present = bool(val5.angles_is_present)
          _v545 = val5.z_angular_velocity
          _v546 = _v545.value
          start = end
          end += 2
          (_v546.value,) = _get_struct_h().unpack(str[start:end])
          _v547 = _v545.confidence
          start = end
          end += 1
          (_v547.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_angular_velocity_is_present = bool(val5.z_angular_velocity_is_present)
          _v548 = val5.lower_triangular_correlation_matrices
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v548.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
            _v549 = val7.components_included_inthe_matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v549.value = str[start:end]
            start = end
            end += 1
            (_v549.bits_unused,) = _get_struct_B().unpack(str[start:end])
            _v550 = val7.matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v550.array = []
            for i in range(0, length):
              val9 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              val9.array = []
              for i in range(0, length):
                val10 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
                start = end
                end += 1
                (val10.value,) = _get_struct_b().unpack(str[start:end])
                val9.array.append(val10)
              _v550.array.append(val9)
            _v548.array.append(val7)
          start = end
          end += 1
          (val5.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.lower_triangular_correlation_matrices_is_present = bool(val5.lower_triangular_correlation_matrices_is_present)
          _v551 = val5.object_dimension_z
          _v552 = _v551.value
          start = end
          end += 2
          (_v552.value,) = _get_struct_H().unpack(str[start:end])
          _v553 = _v551.confidence
          start = end
          end += 1
          (_v553.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_z_is_present = bool(val5.object_dimension_z_is_present)
          _v554 = val5.object_dimension_y
          _v555 = _v554.value
          start = end
          end += 2
          (_v555.value,) = _get_struct_H().unpack(str[start:end])
          _v556 = _v554.confidence
          start = end
          end += 1
          (_v556.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_y_is_present = bool(val5.object_dimension_y_is_present)
          _v557 = val5.object_dimension_x
          _v558 = _v557.value
          start = end
          end += 2
          (_v558.value,) = _get_struct_H().unpack(str[start:end])
          _v559 = _v557.confidence
          start = end
          end += 1
          (_v559.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_x_is_present = bool(val5.object_dimension_x_is_present)
          _v560 = val5.object_age
          start = end
          end += 2
          (_v560.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_age_is_present = bool(val5.object_age_is_present)
          _v561 = val5.object_perception_quality
          start = end
          end += 1
          (_v561.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_perception_quality_is_present = bool(val5.object_perception_quality_is_present)
          _v562 = val5.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v562.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val7.value,) = _get_struct_B().unpack(str[start:end])
            _v562.array.append(val7)
          start = end
          end += 1
          (val5.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.sensor_id_list_is_present = bool(val5.sensor_id_list_is_present)
          _v563 = val5.classification
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v563.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
            _v564 = val7.object_class
            start = end
            end += 1
            (_v564.choice,) = _get_struct_B().unpack(str[start:end])
            _v565 = _v564.vehicle_sub_class
            start = end
            end += 1
            (_v565.value,) = _get_struct_B().unpack(str[start:end])
            _v566 = _v564.vru_sub_class
            start = end
            end += 1
            (_v566.choice,) = _get_struct_B().unpack(str[start:end])
            _v567 = _v566.pedestrian
            start = end
            end += 1
            (_v567.value,) = _get_struct_B().unpack(str[start:end])
            _v568 = _v566.bicyclist_and_light_vru_vehicle
            start = end
            end += 1
            (_v568.value,) = _get_struct_B().unpack(str[start:end])
            _v569 = _v566.motorcyclist
            start = end
            end += 1
            (_v569.value,) = _get_struct_B().unpack(str[start:end])
            _v570 = _v566.animal
            start = end
            end += 1
            (_v570.value,) = _get_struct_B().unpack(str[start:end])
            _v571 = _v564.group_sub_class
            _v572 = _v571.cluster_id
            start = end
            end += 1
            (_v572.value,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v571.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
            _v571.cluster_id_is_present = bool(_v571.cluster_id_is_present)
            _v573 = _v571.cluster_bounding_box_shape
            start = end
            end += 1
            (_v573.choice,) = _get_struct_B().unpack(str[start:end])
            _v574 = _v573.rectangular
            _v575 = _v574.center_point
            _v576 = _v575.x_coordinate
            start = end
            end += 2
            (_v576.value,) = _get_struct_h().unpack(str[start:end])
            _v577 = _v575.y_coordinate
            start = end
            end += 2
            (_v577.value,) = _get_struct_h().unpack(str[start:end])
            _v578 = _v575.z_coordinate
            start = end
            end += 2
            (_v578.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v575.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v575.z_coordinate_is_present = bool(_v575.z_coordinate_is_present)
            start = end
            end += 1
            (_v574.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v574.center_point_is_present = bool(_v574.center_point_is_present)
            _v579 = _v574.semi_length
            start = end
            end += 2
            (_v579.value,) = _get_struct_H().unpack(str[start:end])
            _v580 = _v574.semi_breadth
            start = end
            end += 2
            (_v580.value,) = _get_struct_H().unpack(str[start:end])
            _v581 = _v574.orientation
            start = end
            end += 2
            (_v581.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v574.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v574.orientation_is_present = bool(_v574.orientation_is_present)
            _v582 = _v574.height
            start = end
            end += 2
            (_v582.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v574.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v574.height_is_present = bool(_v574.height_is_present)
            _v583 = _v573.circular
            _v584 = _v583.shape_reference_point
            _v585 = _v584.x_coordinate
            start = end
            end += 2
            (_v585.value,) = _get_struct_h().unpack(str[start:end])
            _v586 = _v584.y_coordinate
            start = end
            end += 2
            (_v586.value,) = _get_struct_h().unpack(str[start:end])
            _v587 = _v584.z_coordinate
            start = end
            end += 2
            (_v587.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v584.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v584.z_coordinate_is_present = bool(_v584.z_coordinate_is_present)
            start = end
            end += 1
            (_v583.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v583.shape_reference_point_is_present = bool(_v583.shape_reference_point_is_present)
            _v588 = _v583.radius
            start = end
            end += 2
            (_v588.value,) = _get_struct_H().unpack(str[start:end])
            _v589 = _v583.height
            start = end
            end += 2
            (_v589.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v583.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v583.height_is_present = bool(_v583.height_is_present)
            _v590 = _v573.polygonal
            _v591 = _v590.shape_reference_point
            _v592 = _v591.x_coordinate
            start = end
            end += 2
            (_v592.value,) = _get_struct_h().unpack(str[start:end])
            _v593 = _v591.y_coordinate
            start = end
            end += 2
            (_v593.value,) = _get_struct_h().unpack(str[start:end])
            _v594 = _v591.z_coordinate
            start = end
            end += 2
            (_v594.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v591.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v591.z_coordinate_is_present = bool(_v591.z_coordinate_is_present)
            start = end
            end += 1
            (_v590.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v590.shape_reference_point_is_present = bool(_v590.shape_reference_point_is_present)
            _v595 = _v590.polygon
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v595.array = []
            for i in range(0, length):
              val13 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
              _v596 = val13.x_coordinate
              start = end
              end += 2
              (_v596.value,) = _get_struct_h().unpack(str[start:end])
              _v597 = val13.y_coordinate
              start = end
              end += 2
              (_v597.value,) = _get_struct_h().unpack(str[start:end])
              _v598 = val13.z_coordinate
              start = end
              end += 2
              (_v598.value,) = _get_struct_h().unpack(str[start:end])
              start = end
              end += 1
              (val13.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.z_coordinate_is_present = bool(val13.z_coordinate_is_present)
              _v595.array.append(val13)
            _v599 = _v590.height
            start = end
            end += 2
            (_v599.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v590.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v590.height_is_present = bool(_v590.height_is_present)
            _v600 = _v573.elliptical
            _v601 = _v600.shape_reference_point
            _v602 = _v601.x_coordinate
            start = end
            end += 2
            (_v602.value,) = _get_struct_h().unpack(str[start:end])
            _v603 = _v601.y_coordinate
            start = end
            end += 2
            (_v603.value,) = _get_struct_h().unpack(str[start:end])
            _v604 = _v601.z_coordinate
            start = end
            end += 2
            (_v604.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v601.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v601.z_coordinate_is_present = bool(_v601.z_coordinate_is_present)
            start = end
            end += 1
            (_v600.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v600.shape_reference_point_is_present = bool(_v600.shape_reference_point_is_present)
            _v605 = _v600.semi_major_axis_length
            start = end
            end += 2
            (_v605.value,) = _get_struct_H().unpack(str[start:end])
            _v606 = _v600.semi_minor_axis_length
            start = end
            end += 2
            (_v606.value,) = _get_struct_H().unpack(str[start:end])
            _v607 = _v600.orientation
            start = end
            end += 2
            (_v607.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v600.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v600.orientation_is_present = bool(_v600.orientation_is_present)
            _v608 = _v600.height
            start = end
            end += 2
            (_v608.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v600.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v600.height_is_present = bool(_v600.height_is_present)
            _v609 = _v573.radial
            _v610 = _v609.shape_reference_point
            _v611 = _v610.x_coordinate
            start = end
            end += 2
            (_v611.value,) = _get_struct_h().unpack(str[start:end])
            _v612 = _v610.y_coordinate
            start = end
            end += 2
            (_v612.value,) = _get_struct_h().unpack(str[start:end])
            _v613 = _v610.z_coordinate
            start = end
            end += 2
            (_v613.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v610.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v610.z_coordinate_is_present = bool(_v610.z_coordinate_is_present)
            start = end
            end += 1
            (_v609.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v609.shape_reference_point_is_present = bool(_v609.shape_reference_point_is_present)
            _v614 = _v609.range
            start = end
            end += 2
            (_v614.value,) = _get_struct_H().unpack(str[start:end])
            _v615 = _v609.stationary_horizontal_opening_angle_start
            start = end
            end += 2
            (_v615.value,) = _get_struct_H().unpack(str[start:end])
            _v616 = _v609.stationary_horizontal_opening_angle_end
            start = end
            end += 2
            (_v616.value,) = _get_struct_H().unpack(str[start:end])
            _v617 = _v609.vertical_opening_angle_start
            start = end
            end += 2
            (_v617.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v609.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            _v609.vertical_opening_angle_start_is_present = bool(_v609.vertical_opening_angle_start_is_present)
            _v618 = _v609.vertical_opening_angle_end
            start = end
            end += 2
            (_v618.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v609.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            _v609.vertical_opening_angle_end_is_present = bool(_v609.vertical_opening_angle_end_is_present)
            _v619 = _v573.radial_shapes
            _v620 = _v619.ref_point_id
            start = end
            end += 1
            (_v620.value,) = _get_struct_B().unpack(str[start:end])
            _v621 = _v619.x_coordinate
            start = end
            end += 2
            (_v621.value,) = _get_struct_h().unpack(str[start:end])
            _v622 = _v619.y_coordinate
            start = end
            end += 2
            (_v622.value,) = _get_struct_h().unpack(str[start:end])
            _v623 = _v619.z_coordinate
            start = end
            end += 2
            (_v623.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v619.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v619.z_coordinate_is_present = bool(_v619.z_coordinate_is_present)
            _v624 = _v619.radial_shapes_list
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v624.array = []
            for i in range(0, length):
              val13 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
              _v625 = val13.range
              start = end
              end += 2
              (_v625.value,) = _get_struct_H().unpack(str[start:end])
              _v626 = val13.horizontal_opening_angle_start
              start = end
              end += 2
              (_v626.value,) = _get_struct_H().unpack(str[start:end])
              _v627 = val13.horizontal_opening_angle_end
              start = end
              end += 2
              (_v627.value,) = _get_struct_H().unpack(str[start:end])
              _v628 = val13.vertical_opening_angle_start
              start = end
              end += 2
              (_v628.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val13.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.vertical_opening_angle_start_is_present = bool(val13.vertical_opening_angle_start_is_present)
              _v629 = val13.vertical_opening_angle_end
              start = end
              end += 2
              (_v629.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val13.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.vertical_opening_angle_end_is_present = bool(val13.vertical_opening_angle_end_is_present)
              _v624.array.append(val13)
            start = end
            end += 1
            (_v571.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
            _v571.cluster_bounding_box_shape_is_present = bool(_v571.cluster_bounding_box_shape_is_present)
            _v630 = _v571.cluster_cardinality_size
            start = end
            end += 1
            (_v630.value,) = _get_struct_B().unpack(str[start:end])
            _v631 = _v571.cluster_profiles
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v631.value = str[start:end]
            start = end
            end += 1
            (_v631.bits_unused,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v571.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
            _v571.cluster_profiles_is_present = bool(_v571.cluster_profiles_is_present)
            _v632 = _v564.other_sub_class
            start = end
            end += 1
            (_v632.value,) = _get_struct_B().unpack(str[start:end])
            _v633 = val7.confidence
            start = end
            end += 1
            (_v633.value,) = _get_struct_B().unpack(str[start:end])
            _v563.array.append(val7)
          start = end
          end += 1
          (val5.classification_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.classification_is_present = bool(val5.classification_is_present)
          _v634 = val5.map_position
          _v635 = _v634.map_reference
          start = end
          end += 1
          (_v635.choice,) = _get_struct_B().unpack(str[start:end])
          _v636 = _v635.roadsegment
          _v637 = _v636.region
          start = end
          end += 2
          (_v637.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v636.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v636.region_is_present = bool(_v636.region_is_present)
          _v638 = _v636.id
          start = end
          end += 2
          (_v638.value,) = _get_struct_H().unpack(str[start:end])
          _v639 = _v635.intersection
          _v640 = _v639.region
          start = end
          end += 2
          (_v640.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v639.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v639.region_is_present = bool(_v639.region_is_present)
          _v641 = _v639.id
          start = end
          end += 2
          (_v641.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v634.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          _v634.map_reference_is_present = bool(_v634.map_reference_is_present)
          _v642 = _v634.lane_id
          start = end
          end += 1
          (_v642.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v634.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v634.lane_id_is_present = bool(_v634.lane_id_is_present)
          _v643 = _v634.connection_id
          start = end
          end += 1
          (_v643.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v634.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v634.connection_id_is_present = bool(_v634.connection_id_is_present)
          _v644 = _v634.longitudinal_lane_position
          _v645 = _v644.longitudinal_lane_position_value
          start = end
          end += 2
          (_v645.value,) = _get_struct_H().unpack(str[start:end])
          _v646 = _v644.longitudinal_lane_position_confidence
          start = end
          end += 2
          (_v646.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v634.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
          _v634.longitudinal_lane_position_is_present = bool(_v634.longitudinal_lane_position_is_present)
          start = end
          end += 1
          (val5.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.map_position_is_present = bool(val5.map_position_is_present)
          _v480.array.append(val5)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v647 = val1.container_id
        _x = _v647.value
        buff.write(_get_struct_B().pack(_x))
        _v648 = val1.container_data
        _v649 = _v648.choice
        _x = _v649.value
        buff.write(_get_struct_B().pack(_x))
        _v650 = _v648.originating_vehicle_container
        _v651 = _v650.orientation_angle
        _v652 = _v651.value
        _x = _v652.value
        buff.write(_get_struct_H().pack(_x))
        _v653 = _v651.confidence
        _x = _v653.value
        buff.write(_get_struct_B().pack(_x))
        _v654 = _v650.pitch_angle
        _v655 = _v654.value
        _x = _v655.value
        buff.write(_get_struct_H().pack(_x))
        _v656 = _v654.confidence
        _x = _v656.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v650.pitch_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v657 = _v650.roll_angle
        _v658 = _v657.value
        _x = _v658.value
        buff.write(_get_struct_H().pack(_x))
        _v659 = _v657.confidence
        _x = _v659.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v650.roll_angle_is_present
        buff.write(_get_struct_B().pack(_x))
        _v660 = _v650.trailer_data_set
        length = len(_v660.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v660.array:
          _v661 = val5.ref_point_id
          _x = _v661.value
          buff.write(_get_struct_B().pack(_x))
          _v662 = val5.hitch_point_offset
          _x = _v662.value
          buff.write(_get_struct_B().pack(_x))
          _v663 = val5.front_overhang
          _x = _v663.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.front_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v664 = val5.rear_overhang
          _x = _v664.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.rear_overhang_is_present
          buff.write(_get_struct_B().pack(_x))
          _v665 = val5.trailer_width
          _x = _v665.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.trailer_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v666 = val5.hitch_angle
          _v667 = _v666.value
          _x = _v667.value
          buff.write(_get_struct_H().pack(_x))
          _v668 = _v666.confidence
          _x = _v668.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v650.trailer_data_set_is_present
        buff.write(_get_struct_B().pack(_x))
        _v669 = _v648.originating_rsu_container
        _v670 = _v669.map_reference
        _x = _v670.choice
        buff.write(_get_struct_B().pack(_x))
        _v671 = _v670.roadsegment
        _v672 = _v671.region
        _x = _v672.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v671.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v673 = _v671.id
        _x = _v673.value
        buff.write(_get_struct_H().pack(_x))
        _v674 = _v670.intersection
        _v675 = _v674.region
        _x = _v675.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v674.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v676 = _v674.id
        _x = _v676.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v669.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v677 = _v648.sensor_information_container
        length = len(_v677.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v677.array:
          _v678 = val4.sensor_id
          _x = _v678.value
          buff.write(_get_struct_B().pack(_x))
          _v679 = val4.sensor_type
          _x = _v679.value
          buff.write(_get_struct_B().pack(_x))
          _v680 = val4.perception_region_shape
          _x = _v680.choice
          buff.write(_get_struct_B().pack(_x))
          _v681 = _v680.rectangular
          _v682 = _v681.center_point
          _v683 = _v682.x_coordinate
          _x = _v683.value
          buff.write(_get_struct_h().pack(_x))
          _v684 = _v682.y_coordinate
          _x = _v684.value
          buff.write(_get_struct_h().pack(_x))
          _v685 = _v682.z_coordinate
          _x = _v685.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v682.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v681.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v686 = _v681.semi_length
          _x = _v686.value
          buff.write(_get_struct_H().pack(_x))
          _v687 = _v681.semi_breadth
          _x = _v687.value
          buff.write(_get_struct_H().pack(_x))
          _v688 = _v681.orientation
          _x = _v688.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v681.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v689 = _v681.height
          _x = _v689.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v681.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v690 = _v680.circular
          _v691 = _v690.shape_reference_point
          _v692 = _v691.x_coordinate
          _x = _v692.value
          buff.write(_get_struct_h().pack(_x))
          _v693 = _v691.y_coordinate
          _x = _v693.value
          buff.write(_get_struct_h().pack(_x))
          _v694 = _v691.z_coordinate
          _x = _v694.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v691.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v690.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v695 = _v690.radius
          _x = _v695.value
          buff.write(_get_struct_H().pack(_x))
          _v696 = _v690.height
          _x = _v696.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v690.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v697 = _v680.polygonal
          _v698 = _v697.shape_reference_point
          _v699 = _v698.x_coordinate
          _x = _v699.value
          buff.write(_get_struct_h().pack(_x))
          _v700 = _v698.y_coordinate
          _x = _v700.value
          buff.write(_get_struct_h().pack(_x))
          _v701 = _v698.z_coordinate
          _x = _v701.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v698.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v697.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v702 = _v697.polygon
          length = len(_v702.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v702.array:
            _v703 = val8.x_coordinate
            _x = _v703.value
            buff.write(_get_struct_h().pack(_x))
            _v704 = val8.y_coordinate
            _x = _v704.value
            buff.write(_get_struct_h().pack(_x))
            _v705 = val8.z_coordinate
            _x = _v705.value
            buff.write(_get_struct_h().pack(_x))
            _x = val8.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v706 = _v697.height
          _x = _v706.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v697.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v707 = _v680.elliptical
          _v708 = _v707.shape_reference_point
          _v709 = _v708.x_coordinate
          _x = _v709.value
          buff.write(_get_struct_h().pack(_x))
          _v710 = _v708.y_coordinate
          _x = _v710.value
          buff.write(_get_struct_h().pack(_x))
          _v711 = _v708.z_coordinate
          _x = _v711.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v708.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v707.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v712 = _v707.semi_major_axis_length
          _x = _v712.value
          buff.write(_get_struct_H().pack(_x))
          _v713 = _v707.semi_minor_axis_length
          _x = _v713.value
          buff.write(_get_struct_H().pack(_x))
          _v714 = _v707.orientation
          _x = _v714.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v707.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v715 = _v707.height
          _x = _v715.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v707.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v716 = _v680.radial
          _v717 = _v716.shape_reference_point
          _v718 = _v717.x_coordinate
          _x = _v718.value
          buff.write(_get_struct_h().pack(_x))
          _v719 = _v717.y_coordinate
          _x = _v719.value
          buff.write(_get_struct_h().pack(_x))
          _v720 = _v717.z_coordinate
          _x = _v720.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v717.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v716.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v721 = _v716.range
          _x = _v721.value
          buff.write(_get_struct_H().pack(_x))
          _v722 = _v716.stationary_horizontal_opening_angle_start
          _x = _v722.value
          buff.write(_get_struct_H().pack(_x))
          _v723 = _v716.stationary_horizontal_opening_angle_end
          _x = _v723.value
          buff.write(_get_struct_H().pack(_x))
          _v724 = _v716.vertical_opening_angle_start
          _x = _v724.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v716.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v725 = _v716.vertical_opening_angle_end
          _x = _v725.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v716.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v726 = _v680.radial_shapes
          _v727 = _v726.ref_point_id
          _x = _v727.value
          buff.write(_get_struct_B().pack(_x))
          _v728 = _v726.x_coordinate
          _x = _v728.value
          buff.write(_get_struct_h().pack(_x))
          _v729 = _v726.y_coordinate
          _x = _v729.value
          buff.write(_get_struct_h().pack(_x))
          _v730 = _v726.z_coordinate
          _x = _v730.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v726.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v731 = _v726.radial_shapes_list
          length = len(_v731.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v731.array:
            _v732 = val8.range
            _x = _v732.value
            buff.write(_get_struct_H().pack(_x))
            _v733 = val8.horizontal_opening_angle_start
            _x = _v733.value
            buff.write(_get_struct_H().pack(_x))
            _v734 = val8.horizontal_opening_angle_end
            _x = _v734.value
            buff.write(_get_struct_H().pack(_x))
            _v735 = val8.vertical_opening_angle_start
            _x = _v735.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v736 = val8.vertical_opening_angle_end
            _x = _v736.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val4.perception_region_shape_is_present
          buff.write(_get_struct_B().pack(_x))
          _v737 = val4.perception_region_confidence
          _x = _v737.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4
          buff.write(_get_struct_2B().pack(_x.perception_region_confidence_is_present, _x.shadowing_applies))
        _v738 = _v648.perception_region_container
        length = len(_v738.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v738.array:
          _v739 = val4.measurement_delta_time
          _x = _v739.value
          buff.write(_get_struct_h().pack(_x))
          _v740 = val4.perception_region_confidence
          _x = _v740.value
          buff.write(_get_struct_B().pack(_x))
          _v741 = val4.perception_region_shape
          _x = _v741.choice
          buff.write(_get_struct_B().pack(_x))
          _v742 = _v741.rectangular
          _v743 = _v742.center_point
          _v744 = _v743.x_coordinate
          _x = _v744.value
          buff.write(_get_struct_h().pack(_x))
          _v745 = _v743.y_coordinate
          _x = _v745.value
          buff.write(_get_struct_h().pack(_x))
          _v746 = _v743.z_coordinate
          _x = _v746.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v743.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v742.center_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v747 = _v742.semi_length
          _x = _v747.value
          buff.write(_get_struct_H().pack(_x))
          _v748 = _v742.semi_breadth
          _x = _v748.value
          buff.write(_get_struct_H().pack(_x))
          _v749 = _v742.orientation
          _x = _v749.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v742.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v750 = _v742.height
          _x = _v750.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v742.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v751 = _v741.circular
          _v752 = _v751.shape_reference_point
          _v753 = _v752.x_coordinate
          _x = _v753.value
          buff.write(_get_struct_h().pack(_x))
          _v754 = _v752.y_coordinate
          _x = _v754.value
          buff.write(_get_struct_h().pack(_x))
          _v755 = _v752.z_coordinate
          _x = _v755.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v752.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v751.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v756 = _v751.radius
          _x = _v756.value
          buff.write(_get_struct_H().pack(_x))
          _v757 = _v751.height
          _x = _v757.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v751.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v758 = _v741.polygonal
          _v759 = _v758.shape_reference_point
          _v760 = _v759.x_coordinate
          _x = _v760.value
          buff.write(_get_struct_h().pack(_x))
          _v761 = _v759.y_coordinate
          _x = _v761.value
          buff.write(_get_struct_h().pack(_x))
          _v762 = _v759.z_coordinate
          _x = _v762.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v759.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v758.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v763 = _v758.polygon
          length = len(_v763.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v763.array:
            _v764 = val8.x_coordinate
            _x = _v764.value
            buff.write(_get_struct_h().pack(_x))
            _v765 = val8.y_coordinate
            _x = _v765.value
            buff.write(_get_struct_h().pack(_x))
            _v766 = val8.z_coordinate
            _x = _v766.value
            buff.write(_get_struct_h().pack(_x))
            _x = val8.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
          _v767 = _v758.height
          _x = _v767.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v758.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v768 = _v741.elliptical
          _v769 = _v768.shape_reference_point
          _v770 = _v769.x_coordinate
          _x = _v770.value
          buff.write(_get_struct_h().pack(_x))
          _v771 = _v769.y_coordinate
          _x = _v771.value
          buff.write(_get_struct_h().pack(_x))
          _v772 = _v769.z_coordinate
          _x = _v772.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v769.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v768.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v773 = _v768.semi_major_axis_length
          _x = _v773.value
          buff.write(_get_struct_H().pack(_x))
          _v774 = _v768.semi_minor_axis_length
          _x = _v774.value
          buff.write(_get_struct_H().pack(_x))
          _v775 = _v768.orientation
          _x = _v775.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v768.orientation_is_present
          buff.write(_get_struct_B().pack(_x))
          _v776 = _v768.height
          _x = _v776.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v768.height_is_present
          buff.write(_get_struct_B().pack(_x))
          _v777 = _v741.radial
          _v778 = _v777.shape_reference_point
          _v779 = _v778.x_coordinate
          _x = _v779.value
          buff.write(_get_struct_h().pack(_x))
          _v780 = _v778.y_coordinate
          _x = _v780.value
          buff.write(_get_struct_h().pack(_x))
          _v781 = _v778.z_coordinate
          _x = _v781.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v778.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = _v777.shape_reference_point_is_present
          buff.write(_get_struct_B().pack(_x))
          _v782 = _v777.range
          _x = _v782.value
          buff.write(_get_struct_H().pack(_x))
          _v783 = _v777.stationary_horizontal_opening_angle_start
          _x = _v783.value
          buff.write(_get_struct_H().pack(_x))
          _v784 = _v777.stationary_horizontal_opening_angle_end
          _x = _v784.value
          buff.write(_get_struct_H().pack(_x))
          _v785 = _v777.vertical_opening_angle_start
          _x = _v785.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v777.vertical_opening_angle_start_is_present
          buff.write(_get_struct_B().pack(_x))
          _v786 = _v777.vertical_opening_angle_end
          _x = _v786.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v777.vertical_opening_angle_end_is_present
          buff.write(_get_struct_B().pack(_x))
          _v787 = _v741.radial_shapes
          _v788 = _v787.ref_point_id
          _x = _v788.value
          buff.write(_get_struct_B().pack(_x))
          _v789 = _v787.x_coordinate
          _x = _v789.value
          buff.write(_get_struct_h().pack(_x))
          _v790 = _v787.y_coordinate
          _x = _v790.value
          buff.write(_get_struct_h().pack(_x))
          _v791 = _v787.z_coordinate
          _x = _v791.value
          buff.write(_get_struct_h().pack(_x))
          _x = _v787.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v792 = _v787.radial_shapes_list
          length = len(_v792.array)
          buff.write(_struct_I.pack(length))
          for val8 in _v792.array:
            _v793 = val8.range
            _x = _v793.value
            buff.write(_get_struct_H().pack(_x))
            _v794 = val8.horizontal_opening_angle_start
            _x = _v794.value
            buff.write(_get_struct_H().pack(_x))
            _v795 = val8.horizontal_opening_angle_end
            _x = _v795.value
            buff.write(_get_struct_H().pack(_x))
            _v796 = val8.vertical_opening_angle_start
            _x = _v796.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v797 = val8.vertical_opening_angle_end
            _x = _v797.value
            buff.write(_get_struct_H().pack(_x))
            _x = val8.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
          _x = val4.shadowing_applies
          buff.write(_get_struct_B().pack(_x))
          _v798 = val4.sensor_id_list
          length = len(_v798.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v798.array:
            _x = val6.value
            buff.write(_get_struct_B().pack(_x))
          _x = val4.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v799 = val4.number_of_perceived_objects
          _x = _v799.value
          buff.write(_get_struct_B().pack(_x))
          _x = val4.number_of_perceived_objects_is_present
          buff.write(_get_struct_B().pack(_x))
          _v800 = val4.perceived_object_ids
          length = len(_v800.array)
          buff.write(_struct_I.pack(length))
          for val6 in _v800.array:
            _x = val6.value
            buff.write(_get_struct_H().pack(_x))
          _x = val4.perceived_object_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _v801 = _v648.perceived_object_container
        _v802 = _v801.number_of_perceived_objects
        _x = _v802.value
        buff.write(_get_struct_B().pack(_x))
        _v803 = _v801.perceived_objects
        length = len(_v803.array)
        buff.write(_struct_I.pack(length))
        for val5 in _v803.array:
          _v804 = val5.object_id
          _x = _v804.value
          buff.write(_get_struct_H().pack(_x))
          _x = val5.object_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v805 = val5.measurement_delta_time
          _x = _v805.value
          buff.write(_get_struct_h().pack(_x))
          _v806 = val5.position
          _v807 = _v806.x_coordinate
          _v808 = _v807.value
          _x = _v808.value
          buff.write(_get_struct_i().pack(_x))
          _v809 = _v807.confidence
          _x = _v809.value
          buff.write(_get_struct_H().pack(_x))
          _v810 = _v806.y_coordinate
          _v811 = _v810.value
          _x = _v811.value
          buff.write(_get_struct_i().pack(_x))
          _v812 = _v810.confidence
          _x = _v812.value
          buff.write(_get_struct_H().pack(_x))
          _v813 = _v806.z_coordinate
          _v814 = _v813.value
          _x = _v814.value
          buff.write(_get_struct_i().pack(_x))
          _v815 = _v813.confidence
          _x = _v815.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v806.z_coordinate_is_present
          buff.write(_get_struct_B().pack(_x))
          _v816 = val5.velocity
          _x = _v816.choice
          buff.write(_get_struct_B().pack(_x))
          _v817 = _v816.polar_velocity
          _v818 = _v817.velocity_magnitude
          _v819 = _v818.speed_value
          _x = _v819.value
          buff.write(_get_struct_H().pack(_x))
          _v820 = _v818.speed_confidence
          _x = _v820.value
          buff.write(_get_struct_B().pack(_x))
          _v821 = _v817.velocity_direction
          _v822 = _v821.value
          _x = _v822.value
          buff.write(_get_struct_H().pack(_x))
          _v823 = _v821.confidence
          _x = _v823.value
          buff.write(_get_struct_B().pack(_x))
          _v824 = _v817.z_velocity
          _v825 = _v824.value
          _x = _v825.value
          buff.write(_get_struct_h().pack(_x))
          _v826 = _v824.confidence
          _x = _v826.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v817.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v827 = _v816.cartesian_velocity
          _v828 = _v827.x_velocity
          _v829 = _v828.value
          _x = _v829.value
          buff.write(_get_struct_h().pack(_x))
          _v830 = _v828.confidence
          _x = _v830.value
          buff.write(_get_struct_B().pack(_x))
          _v831 = _v827.y_velocity
          _v832 = _v831.value
          _x = _v832.value
          buff.write(_get_struct_h().pack(_x))
          _v833 = _v831.confidence
          _x = _v833.value
          buff.write(_get_struct_B().pack(_x))
          _v834 = _v827.z_velocity
          _v835 = _v834.value
          _x = _v835.value
          buff.write(_get_struct_h().pack(_x))
          _v836 = _v834.confidence
          _x = _v836.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v827.z_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v837 = val5.acceleration
          _x = _v837.choice
          buff.write(_get_struct_B().pack(_x))
          _v838 = _v837.polar_acceleration
          _v839 = _v838.acceleration_magnitude
          _v840 = _v839.acceleration_magnitude_value
          _x = _v840.value
          buff.write(_get_struct_B().pack(_x))
          _v841 = _v839.acceleration_confidence
          _x = _v841.value
          buff.write(_get_struct_B().pack(_x))
          _v842 = _v838.acceleration_direction
          _v843 = _v842.value
          _x = _v843.value
          buff.write(_get_struct_H().pack(_x))
          _v844 = _v842.confidence
          _x = _v844.value
          buff.write(_get_struct_B().pack(_x))
          _v845 = _v838.z_acceleration
          _v846 = _v845.value
          _x = _v846.value
          buff.write(_get_struct_h().pack(_x))
          _v847 = _v845.confidence
          _x = _v847.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v838.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v848 = _v837.cartesian_acceleration
          _v849 = _v848.x_acceleration
          _v850 = _v849.value
          _x = _v850.value
          buff.write(_get_struct_h().pack(_x))
          _v851 = _v849.confidence
          _x = _v851.value
          buff.write(_get_struct_B().pack(_x))
          _v852 = _v848.y_acceleration
          _v853 = _v852.value
          _x = _v853.value
          buff.write(_get_struct_h().pack(_x))
          _v854 = _v852.confidence
          _x = _v854.value
          buff.write(_get_struct_B().pack(_x))
          _v855 = _v848.z_acceleration
          _v856 = _v855.value
          _x = _v856.value
          buff.write(_get_struct_h().pack(_x))
          _v857 = _v855.confidence
          _x = _v857.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v848.z_acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.acceleration_is_present
          buff.write(_get_struct_B().pack(_x))
          _v858 = val5.angles
          _v859 = _v858.z_angle
          _v860 = _v859.value
          _x = _v860.value
          buff.write(_get_struct_H().pack(_x))
          _v861 = _v859.confidence
          _x = _v861.value
          buff.write(_get_struct_B().pack(_x))
          _v862 = _v858.y_angle
          _v863 = _v862.value
          _x = _v863.value
          buff.write(_get_struct_H().pack(_x))
          _v864 = _v862.confidence
          _x = _v864.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v858.y_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _v865 = _v858.x_angle
          _v866 = _v865.value
          _x = _v866.value
          buff.write(_get_struct_H().pack(_x))
          _v867 = _v865.confidence
          _x = _v867.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v858.x_angle_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.angles_is_present
          buff.write(_get_struct_B().pack(_x))
          _v868 = val5.z_angular_velocity
          _v869 = _v868.value
          _x = _v869.value
          buff.write(_get_struct_h().pack(_x))
          _v870 = _v868.confidence
          _x = _v870.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.z_angular_velocity_is_present
          buff.write(_get_struct_B().pack(_x))
          _v871 = val5.lower_triangular_correlation_matrices
          length = len(_v871.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v871.array:
            _v872 = val7.components_included_inthe_matrix
            _x = _v872.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v872.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _v873 = val7.matrix
            length = len(_v873.array)
            buff.write(_struct_I.pack(length))
            for val9 in _v873.array:
              length = len(val9.array)
              buff.write(_struct_I.pack(length))
              for val10 in val9.array:
                _x = val10.value
                buff.write(_get_struct_b().pack(_x))
          _x = val5.lower_triangular_correlation_matrices_is_present
          buff.write(_get_struct_B().pack(_x))
          _v874 = val5.object_dimension_z
          _v875 = _v874.value
          _x = _v875.value
          buff.write(_get_struct_H().pack(_x))
          _v876 = _v874.confidence
          _x = _v876.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_z_is_present
          buff.write(_get_struct_B().pack(_x))
          _v877 = val5.object_dimension_y
          _v878 = _v877.value
          _x = _v878.value
          buff.write(_get_struct_H().pack(_x))
          _v879 = _v877.confidence
          _x = _v879.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_y_is_present
          buff.write(_get_struct_B().pack(_x))
          _v880 = val5.object_dimension_x
          _v881 = _v880.value
          _x = _v881.value
          buff.write(_get_struct_H().pack(_x))
          _v882 = _v880.confidence
          _x = _v882.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_dimension_x_is_present
          buff.write(_get_struct_B().pack(_x))
          _v883 = val5.object_age
          _x = _v883.value
          buff.write(_get_struct_h().pack(_x))
          _x = val5.object_age_is_present
          buff.write(_get_struct_B().pack(_x))
          _v884 = val5.object_perception_quality
          _x = _v884.value
          buff.write(_get_struct_B().pack(_x))
          _x = val5.object_perception_quality_is_present
          buff.write(_get_struct_B().pack(_x))
          _v885 = val5.sensor_id_list
          length = len(_v885.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v885.array:
            _x = val7.value
            buff.write(_get_struct_B().pack(_x))
          _x = val5.sensor_id_list_is_present
          buff.write(_get_struct_B().pack(_x))
          _v886 = val5.classification
          length = len(_v886.array)
          buff.write(_struct_I.pack(length))
          for val7 in _v886.array:
            _v887 = val7.object_class
            _x = _v887.choice
            buff.write(_get_struct_B().pack(_x))
            _v888 = _v887.vehicle_sub_class
            _x = _v888.value
            buff.write(_get_struct_B().pack(_x))
            _v889 = _v887.vru_sub_class
            _x = _v889.choice
            buff.write(_get_struct_B().pack(_x))
            _v890 = _v889.pedestrian
            _x = _v890.value
            buff.write(_get_struct_B().pack(_x))
            _v891 = _v889.bicyclist_and_light_vru_vehicle
            _x = _v891.value
            buff.write(_get_struct_B().pack(_x))
            _v892 = _v889.motorcyclist
            _x = _v892.value
            buff.write(_get_struct_B().pack(_x))
            _v893 = _v889.animal
            _x = _v893.value
            buff.write(_get_struct_B().pack(_x))
            _v894 = _v887.group_sub_class
            _v895 = _v894.cluster_id
            _x = _v895.value
            buff.write(_get_struct_B().pack(_x))
            _x = _v894.cluster_id_is_present
            buff.write(_get_struct_B().pack(_x))
            _v896 = _v894.cluster_bounding_box_shape
            _x = _v896.choice
            buff.write(_get_struct_B().pack(_x))
            _v897 = _v896.rectangular
            _v898 = _v897.center_point
            _v899 = _v898.x_coordinate
            _x = _v899.value
            buff.write(_get_struct_h().pack(_x))
            _v900 = _v898.y_coordinate
            _x = _v900.value
            buff.write(_get_struct_h().pack(_x))
            _v901 = _v898.z_coordinate
            _x = _v901.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v898.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v897.center_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v902 = _v897.semi_length
            _x = _v902.value
            buff.write(_get_struct_H().pack(_x))
            _v903 = _v897.semi_breadth
            _x = _v903.value
            buff.write(_get_struct_H().pack(_x))
            _v904 = _v897.orientation
            _x = _v904.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v897.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v905 = _v897.height
            _x = _v905.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v897.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v906 = _v896.circular
            _v907 = _v906.shape_reference_point
            _v908 = _v907.x_coordinate
            _x = _v908.value
            buff.write(_get_struct_h().pack(_x))
            _v909 = _v907.y_coordinate
            _x = _v909.value
            buff.write(_get_struct_h().pack(_x))
            _v910 = _v907.z_coordinate
            _x = _v910.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v907.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v906.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v911 = _v906.radius
            _x = _v911.value
            buff.write(_get_struct_H().pack(_x))
            _v912 = _v906.height
            _x = _v912.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v906.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v913 = _v896.polygonal
            _v914 = _v913.shape_reference_point
            _v915 = _v914.x_coordinate
            _x = _v915.value
            buff.write(_get_struct_h().pack(_x))
            _v916 = _v914.y_coordinate
            _x = _v916.value
            buff.write(_get_struct_h().pack(_x))
            _v917 = _v914.z_coordinate
            _x = _v917.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v914.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v913.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v918 = _v913.polygon
            length = len(_v918.array)
            buff.write(_struct_I.pack(length))
            for val13 in _v918.array:
              _v919 = val13.x_coordinate
              _x = _v919.value
              buff.write(_get_struct_h().pack(_x))
              _v920 = val13.y_coordinate
              _x = _v920.value
              buff.write(_get_struct_h().pack(_x))
              _v921 = val13.z_coordinate
              _x = _v921.value
              buff.write(_get_struct_h().pack(_x))
              _x = val13.z_coordinate_is_present
              buff.write(_get_struct_B().pack(_x))
            _v922 = _v913.height
            _x = _v922.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v913.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v923 = _v896.elliptical
            _v924 = _v923.shape_reference_point
            _v925 = _v924.x_coordinate
            _x = _v925.value
            buff.write(_get_struct_h().pack(_x))
            _v926 = _v924.y_coordinate
            _x = _v926.value
            buff.write(_get_struct_h().pack(_x))
            _v927 = _v924.z_coordinate
            _x = _v927.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v924.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v923.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v928 = _v923.semi_major_axis_length
            _x = _v928.value
            buff.write(_get_struct_H().pack(_x))
            _v929 = _v923.semi_minor_axis_length
            _x = _v929.value
            buff.write(_get_struct_H().pack(_x))
            _v930 = _v923.orientation
            _x = _v930.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v923.orientation_is_present
            buff.write(_get_struct_B().pack(_x))
            _v931 = _v923.height
            _x = _v931.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v923.height_is_present
            buff.write(_get_struct_B().pack(_x))
            _v932 = _v896.radial
            _v933 = _v932.shape_reference_point
            _v934 = _v933.x_coordinate
            _x = _v934.value
            buff.write(_get_struct_h().pack(_x))
            _v935 = _v933.y_coordinate
            _x = _v935.value
            buff.write(_get_struct_h().pack(_x))
            _v936 = _v933.z_coordinate
            _x = _v936.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v933.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _x = _v932.shape_reference_point_is_present
            buff.write(_get_struct_B().pack(_x))
            _v937 = _v932.range
            _x = _v937.value
            buff.write(_get_struct_H().pack(_x))
            _v938 = _v932.stationary_horizontal_opening_angle_start
            _x = _v938.value
            buff.write(_get_struct_H().pack(_x))
            _v939 = _v932.stationary_horizontal_opening_angle_end
            _x = _v939.value
            buff.write(_get_struct_H().pack(_x))
            _v940 = _v932.vertical_opening_angle_start
            _x = _v940.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v932.vertical_opening_angle_start_is_present
            buff.write(_get_struct_B().pack(_x))
            _v941 = _v932.vertical_opening_angle_end
            _x = _v941.value
            buff.write(_get_struct_H().pack(_x))
            _x = _v932.vertical_opening_angle_end_is_present
            buff.write(_get_struct_B().pack(_x))
            _v942 = _v896.radial_shapes
            _v943 = _v942.ref_point_id
            _x = _v943.value
            buff.write(_get_struct_B().pack(_x))
            _v944 = _v942.x_coordinate
            _x = _v944.value
            buff.write(_get_struct_h().pack(_x))
            _v945 = _v942.y_coordinate
            _x = _v945.value
            buff.write(_get_struct_h().pack(_x))
            _v946 = _v942.z_coordinate
            _x = _v946.value
            buff.write(_get_struct_h().pack(_x))
            _x = _v942.z_coordinate_is_present
            buff.write(_get_struct_B().pack(_x))
            _v947 = _v942.radial_shapes_list
            length = len(_v947.array)
            buff.write(_struct_I.pack(length))
            for val13 in _v947.array:
              _v948 = val13.range
              _x = _v948.value
              buff.write(_get_struct_H().pack(_x))
              _v949 = val13.horizontal_opening_angle_start
              _x = _v949.value
              buff.write(_get_struct_H().pack(_x))
              _v950 = val13.horizontal_opening_angle_end
              _x = _v950.value
              buff.write(_get_struct_H().pack(_x))
              _v951 = val13.vertical_opening_angle_start
              _x = _v951.value
              buff.write(_get_struct_H().pack(_x))
              _x = val13.vertical_opening_angle_start_is_present
              buff.write(_get_struct_B().pack(_x))
              _v952 = val13.vertical_opening_angle_end
              _x = _v952.value
              buff.write(_get_struct_H().pack(_x))
              _x = val13.vertical_opening_angle_end_is_present
              buff.write(_get_struct_B().pack(_x))
            _x = _v894.cluster_bounding_box_shape_is_present
            buff.write(_get_struct_B().pack(_x))
            _v953 = _v894.cluster_cardinality_size
            _x = _v953.value
            buff.write(_get_struct_B().pack(_x))
            _v954 = _v894.cluster_profiles
            _x = _v954.value
            length = len(_x)
            # - if encoded as a list instead, serialize as bytes instead of string
            if type(_x) in [list, tuple]:
              buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
            else:
              buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
            _x = _v954.bits_unused
            buff.write(_get_struct_B().pack(_x))
            _x = _v894.cluster_profiles_is_present
            buff.write(_get_struct_B().pack(_x))
            _v955 = _v887.other_sub_class
            _x = _v955.value
            buff.write(_get_struct_B().pack(_x))
            _v956 = val7.confidence
            _x = _v956.value
            buff.write(_get_struct_B().pack(_x))
          _x = val5.classification_is_present
          buff.write(_get_struct_B().pack(_x))
          _v957 = val5.map_position
          _v958 = _v957.map_reference
          _x = _v958.choice
          buff.write(_get_struct_B().pack(_x))
          _v959 = _v958.roadsegment
          _v960 = _v959.region
          _x = _v960.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v959.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v961 = _v959.id
          _x = _v961.value
          buff.write(_get_struct_H().pack(_x))
          _v962 = _v958.intersection
          _v963 = _v962.region
          _x = _v963.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v962.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v964 = _v962.id
          _x = _v964.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v957.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v965 = _v957.lane_id
          _x = _v965.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v957.lane_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v966 = _v957.connection_id
          _x = _v966.value
          buff.write(_get_struct_B().pack(_x))
          _x = _v957.connection_id_is_present
          buff.write(_get_struct_B().pack(_x))
          _v967 = _v957.longitudinal_lane_position
          _v968 = _v967.longitudinal_lane_position_value
          _x = _v968.value
          buff.write(_get_struct_H().pack(_x))
          _v969 = _v967.longitudinal_lane_position_confidence
          _x = _v969.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v957.longitudinal_lane_position_is_present
          buff.write(_get_struct_B().pack(_x))
          _x = val5.map_position_is_present
          buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cpm_ts_msgs.msg.WrappedCpmContainer()
        _v970 = val1.container_id
        start = end
        end += 1
        (_v970.value,) = _get_struct_B().unpack(str[start:end])
        _v971 = val1.container_data
        _v972 = _v971.choice
        start = end
        end += 1
        (_v972.value,) = _get_struct_B().unpack(str[start:end])
        _v973 = _v971.originating_vehicle_container
        _v974 = _v973.orientation_angle
        _v975 = _v974.value
        start = end
        end += 2
        (_v975.value,) = _get_struct_H().unpack(str[start:end])
        _v976 = _v974.confidence
        start = end
        end += 1
        (_v976.value,) = _get_struct_B().unpack(str[start:end])
        _v977 = _v973.pitch_angle
        _v978 = _v977.value
        start = end
        end += 2
        (_v978.value,) = _get_struct_H().unpack(str[start:end])
        _v979 = _v977.confidence
        start = end
        end += 1
        (_v979.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v973.pitch_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v973.pitch_angle_is_present = bool(_v973.pitch_angle_is_present)
        _v980 = _v973.roll_angle
        _v981 = _v980.value
        start = end
        end += 2
        (_v981.value,) = _get_struct_H().unpack(str[start:end])
        _v982 = _v980.confidence
        start = end
        end += 1
        (_v982.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v973.roll_angle_is_present,) = _get_struct_B().unpack(str[start:end])
        _v973.roll_angle_is_present = bool(_v973.roll_angle_is_present)
        _v983 = _v973.trailer_data_set
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v983.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.TrailerData()
          _v984 = val5.ref_point_id
          start = end
          end += 1
          (_v984.value,) = _get_struct_B().unpack(str[start:end])
          _v985 = val5.hitch_point_offset
          start = end
          end += 1
          (_v985.value,) = _get_struct_B().unpack(str[start:end])
          _v986 = val5.front_overhang
          start = end
          end += 1
          (_v986.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.front_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.front_overhang_is_present = bool(val5.front_overhang_is_present)
          _v987 = val5.rear_overhang
          start = end
          end += 1
          (_v987.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.rear_overhang_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.rear_overhang_is_present = bool(val5.rear_overhang_is_present)
          _v988 = val5.trailer_width
          start = end
          end += 1
          (_v988.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.trailer_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.trailer_width_is_present = bool(val5.trailer_width_is_present)
          _v989 = val5.hitch_angle
          _v990 = _v989.value
          start = end
          end += 2
          (_v990.value,) = _get_struct_H().unpack(str[start:end])
          _v991 = _v989.confidence
          start = end
          end += 1
          (_v991.value,) = _get_struct_B().unpack(str[start:end])
          _v983.array.append(val5)
        start = end
        end += 1
        (_v973.trailer_data_set_is_present,) = _get_struct_B().unpack(str[start:end])
        _v973.trailer_data_set_is_present = bool(_v973.trailer_data_set_is_present)
        _v992 = _v971.originating_rsu_container
        _v993 = _v992.map_reference
        start = end
        end += 1
        (_v993.choice,) = _get_struct_B().unpack(str[start:end])
        _v994 = _v993.roadsegment
        _v995 = _v994.region
        start = end
        end += 2
        (_v995.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v994.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v994.region_is_present = bool(_v994.region_is_present)
        _v996 = _v994.id
        start = end
        end += 2
        (_v996.value,) = _get_struct_H().unpack(str[start:end])
        _v997 = _v993.intersection
        _v998 = _v997.region
        start = end
        end += 2
        (_v998.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v997.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v997.region_is_present = bool(_v997.region_is_present)
        _v999 = _v997.id
        start = end
        end += 2
        (_v999.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v992.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v992.map_reference_is_present = bool(_v992.map_reference_is_present)
        _v1000 = _v971.sensor_information_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1000.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.SensorInformation()
          _v1001 = val4.sensor_id
          start = end
          end += 1
          (_v1001.value,) = _get_struct_B().unpack(str[start:end])
          _v1002 = val4.sensor_type
          start = end
          end += 1
          (_v1002.value,) = _get_struct_B().unpack(str[start:end])
          _v1003 = val4.perception_region_shape
          start = end
          end += 1
          (_v1003.choice,) = _get_struct_B().unpack(str[start:end])
          _v1004 = _v1003.rectangular
          _v1005 = _v1004.center_point
          _v1006 = _v1005.x_coordinate
          start = end
          end += 2
          (_v1006.value,) = _get_struct_h().unpack(str[start:end])
          _v1007 = _v1005.y_coordinate
          start = end
          end += 2
          (_v1007.value,) = _get_struct_h().unpack(str[start:end])
          _v1008 = _v1005.z_coordinate
          start = end
          end += 2
          (_v1008.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1005.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1005.z_coordinate_is_present = bool(_v1005.z_coordinate_is_present)
          start = end
          end += 1
          (_v1004.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1004.center_point_is_present = bool(_v1004.center_point_is_present)
          _v1009 = _v1004.semi_length
          start = end
          end += 2
          (_v1009.value,) = _get_struct_H().unpack(str[start:end])
          _v1010 = _v1004.semi_breadth
          start = end
          end += 2
          (_v1010.value,) = _get_struct_H().unpack(str[start:end])
          _v1011 = _v1004.orientation
          start = end
          end += 2
          (_v1011.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1004.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1004.orientation_is_present = bool(_v1004.orientation_is_present)
          _v1012 = _v1004.height
          start = end
          end += 2
          (_v1012.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1004.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1004.height_is_present = bool(_v1004.height_is_present)
          _v1013 = _v1003.circular
          _v1014 = _v1013.shape_reference_point
          _v1015 = _v1014.x_coordinate
          start = end
          end += 2
          (_v1015.value,) = _get_struct_h().unpack(str[start:end])
          _v1016 = _v1014.y_coordinate
          start = end
          end += 2
          (_v1016.value,) = _get_struct_h().unpack(str[start:end])
          _v1017 = _v1014.z_coordinate
          start = end
          end += 2
          (_v1017.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1014.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1014.z_coordinate_is_present = bool(_v1014.z_coordinate_is_present)
          start = end
          end += 1
          (_v1013.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1013.shape_reference_point_is_present = bool(_v1013.shape_reference_point_is_present)
          _v1018 = _v1013.radius
          start = end
          end += 2
          (_v1018.value,) = _get_struct_H().unpack(str[start:end])
          _v1019 = _v1013.height
          start = end
          end += 2
          (_v1019.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1013.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1013.height_is_present = bool(_v1013.height_is_present)
          _v1020 = _v1003.polygonal
          _v1021 = _v1020.shape_reference_point
          _v1022 = _v1021.x_coordinate
          start = end
          end += 2
          (_v1022.value,) = _get_struct_h().unpack(str[start:end])
          _v1023 = _v1021.y_coordinate
          start = end
          end += 2
          (_v1023.value,) = _get_struct_h().unpack(str[start:end])
          _v1024 = _v1021.z_coordinate
          start = end
          end += 2
          (_v1024.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1021.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1021.z_coordinate_is_present = bool(_v1021.z_coordinate_is_present)
          start = end
          end += 1
          (_v1020.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1020.shape_reference_point_is_present = bool(_v1020.shape_reference_point_is_present)
          _v1025 = _v1020.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1025.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v1026 = val8.x_coordinate
            start = end
            end += 2
            (_v1026.value,) = _get_struct_h().unpack(str[start:end])
            _v1027 = val8.y_coordinate
            start = end
            end += 2
            (_v1027.value,) = _get_struct_h().unpack(str[start:end])
            _v1028 = val8.z_coordinate
            start = end
            end += 2
            (_v1028.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val8.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.z_coordinate_is_present = bool(val8.z_coordinate_is_present)
            _v1025.array.append(val8)
          _v1029 = _v1020.height
          start = end
          end += 2
          (_v1029.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1020.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1020.height_is_present = bool(_v1020.height_is_present)
          _v1030 = _v1003.elliptical
          _v1031 = _v1030.shape_reference_point
          _v1032 = _v1031.x_coordinate
          start = end
          end += 2
          (_v1032.value,) = _get_struct_h().unpack(str[start:end])
          _v1033 = _v1031.y_coordinate
          start = end
          end += 2
          (_v1033.value,) = _get_struct_h().unpack(str[start:end])
          _v1034 = _v1031.z_coordinate
          start = end
          end += 2
          (_v1034.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1031.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1031.z_coordinate_is_present = bool(_v1031.z_coordinate_is_present)
          start = end
          end += 1
          (_v1030.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1030.shape_reference_point_is_present = bool(_v1030.shape_reference_point_is_present)
          _v1035 = _v1030.semi_major_axis_length
          start = end
          end += 2
          (_v1035.value,) = _get_struct_H().unpack(str[start:end])
          _v1036 = _v1030.semi_minor_axis_length
          start = end
          end += 2
          (_v1036.value,) = _get_struct_H().unpack(str[start:end])
          _v1037 = _v1030.orientation
          start = end
          end += 2
          (_v1037.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1030.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1030.orientation_is_present = bool(_v1030.orientation_is_present)
          _v1038 = _v1030.height
          start = end
          end += 2
          (_v1038.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1030.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1030.height_is_present = bool(_v1030.height_is_present)
          _v1039 = _v1003.radial
          _v1040 = _v1039.shape_reference_point
          _v1041 = _v1040.x_coordinate
          start = end
          end += 2
          (_v1041.value,) = _get_struct_h().unpack(str[start:end])
          _v1042 = _v1040.y_coordinate
          start = end
          end += 2
          (_v1042.value,) = _get_struct_h().unpack(str[start:end])
          _v1043 = _v1040.z_coordinate
          start = end
          end += 2
          (_v1043.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1040.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1040.z_coordinate_is_present = bool(_v1040.z_coordinate_is_present)
          start = end
          end += 1
          (_v1039.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1039.shape_reference_point_is_present = bool(_v1039.shape_reference_point_is_present)
          _v1044 = _v1039.range
          start = end
          end += 2
          (_v1044.value,) = _get_struct_H().unpack(str[start:end])
          _v1045 = _v1039.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v1045.value,) = _get_struct_H().unpack(str[start:end])
          _v1046 = _v1039.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v1046.value,) = _get_struct_H().unpack(str[start:end])
          _v1047 = _v1039.vertical_opening_angle_start
          start = end
          end += 2
          (_v1047.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1039.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1039.vertical_opening_angle_start_is_present = bool(_v1039.vertical_opening_angle_start_is_present)
          _v1048 = _v1039.vertical_opening_angle_end
          start = end
          end += 2
          (_v1048.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1039.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1039.vertical_opening_angle_end_is_present = bool(_v1039.vertical_opening_angle_end_is_present)
          _v1049 = _v1003.radial_shapes
          _v1050 = _v1049.ref_point_id
          start = end
          end += 1
          (_v1050.value,) = _get_struct_B().unpack(str[start:end])
          _v1051 = _v1049.x_coordinate
          start = end
          end += 2
          (_v1051.value,) = _get_struct_h().unpack(str[start:end])
          _v1052 = _v1049.y_coordinate
          start = end
          end += 2
          (_v1052.value,) = _get_struct_h().unpack(str[start:end])
          _v1053 = _v1049.z_coordinate
          start = end
          end += 2
          (_v1053.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1049.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1049.z_coordinate_is_present = bool(_v1049.z_coordinate_is_present)
          _v1054 = _v1049.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1054.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v1055 = val8.range
            start = end
            end += 2
            (_v1055.value,) = _get_struct_H().unpack(str[start:end])
            _v1056 = val8.horizontal_opening_angle_start
            start = end
            end += 2
            (_v1056.value,) = _get_struct_H().unpack(str[start:end])
            _v1057 = val8.horizontal_opening_angle_end
            start = end
            end += 2
            (_v1057.value,) = _get_struct_H().unpack(str[start:end])
            _v1058 = val8.vertical_opening_angle_start
            start = end
            end += 2
            (_v1058.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_start_is_present = bool(val8.vertical_opening_angle_start_is_present)
            _v1059 = val8.vertical_opening_angle_end
            start = end
            end += 2
            (_v1059.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_end_is_present = bool(val8.vertical_opening_angle_end_is_present)
            _v1054.array.append(val8)
          start = end
          end += 1
          (val4.perception_region_shape_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.perception_region_shape_is_present = bool(val4.perception_region_shape_is_present)
          _v1060 = val4.perception_region_confidence
          start = end
          end += 1
          (_v1060.value,) = _get_struct_B().unpack(str[start:end])
          _x = val4
          start = end
          end += 2
          (_x.perception_region_confidence_is_present, _x.shadowing_applies,) = _get_struct_2B().unpack(str[start:end])
          val4.perception_region_confidence_is_present = bool(val4.perception_region_confidence_is_present)
          val4.shadowing_applies = bool(val4.shadowing_applies)
          _v1000.array.append(val4)
        _v1061 = _v971.perception_region_container
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1061.array = []
        for i in range(0, length):
          val4 = etsi_its_cpm_ts_msgs.msg.PerceptionRegion()
          _v1062 = val4.measurement_delta_time
          start = end
          end += 2
          (_v1062.value,) = _get_struct_h().unpack(str[start:end])
          _v1063 = val4.perception_region_confidence
          start = end
          end += 1
          (_v1063.value,) = _get_struct_B().unpack(str[start:end])
          _v1064 = val4.perception_region_shape
          start = end
          end += 1
          (_v1064.choice,) = _get_struct_B().unpack(str[start:end])
          _v1065 = _v1064.rectangular
          _v1066 = _v1065.center_point
          _v1067 = _v1066.x_coordinate
          start = end
          end += 2
          (_v1067.value,) = _get_struct_h().unpack(str[start:end])
          _v1068 = _v1066.y_coordinate
          start = end
          end += 2
          (_v1068.value,) = _get_struct_h().unpack(str[start:end])
          _v1069 = _v1066.z_coordinate
          start = end
          end += 2
          (_v1069.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1066.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1066.z_coordinate_is_present = bool(_v1066.z_coordinate_is_present)
          start = end
          end += 1
          (_v1065.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1065.center_point_is_present = bool(_v1065.center_point_is_present)
          _v1070 = _v1065.semi_length
          start = end
          end += 2
          (_v1070.value,) = _get_struct_H().unpack(str[start:end])
          _v1071 = _v1065.semi_breadth
          start = end
          end += 2
          (_v1071.value,) = _get_struct_H().unpack(str[start:end])
          _v1072 = _v1065.orientation
          start = end
          end += 2
          (_v1072.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1065.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1065.orientation_is_present = bool(_v1065.orientation_is_present)
          _v1073 = _v1065.height
          start = end
          end += 2
          (_v1073.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1065.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1065.height_is_present = bool(_v1065.height_is_present)
          _v1074 = _v1064.circular
          _v1075 = _v1074.shape_reference_point
          _v1076 = _v1075.x_coordinate
          start = end
          end += 2
          (_v1076.value,) = _get_struct_h().unpack(str[start:end])
          _v1077 = _v1075.y_coordinate
          start = end
          end += 2
          (_v1077.value,) = _get_struct_h().unpack(str[start:end])
          _v1078 = _v1075.z_coordinate
          start = end
          end += 2
          (_v1078.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1075.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1075.z_coordinate_is_present = bool(_v1075.z_coordinate_is_present)
          start = end
          end += 1
          (_v1074.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1074.shape_reference_point_is_present = bool(_v1074.shape_reference_point_is_present)
          _v1079 = _v1074.radius
          start = end
          end += 2
          (_v1079.value,) = _get_struct_H().unpack(str[start:end])
          _v1080 = _v1074.height
          start = end
          end += 2
          (_v1080.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1074.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1074.height_is_present = bool(_v1074.height_is_present)
          _v1081 = _v1064.polygonal
          _v1082 = _v1081.shape_reference_point
          _v1083 = _v1082.x_coordinate
          start = end
          end += 2
          (_v1083.value,) = _get_struct_h().unpack(str[start:end])
          _v1084 = _v1082.y_coordinate
          start = end
          end += 2
          (_v1084.value,) = _get_struct_h().unpack(str[start:end])
          _v1085 = _v1082.z_coordinate
          start = end
          end += 2
          (_v1085.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1082.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1082.z_coordinate_is_present = bool(_v1082.z_coordinate_is_present)
          start = end
          end += 1
          (_v1081.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1081.shape_reference_point_is_present = bool(_v1081.shape_reference_point_is_present)
          _v1086 = _v1081.polygon
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1086.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
            _v1087 = val8.x_coordinate
            start = end
            end += 2
            (_v1087.value,) = _get_struct_h().unpack(str[start:end])
            _v1088 = val8.y_coordinate
            start = end
            end += 2
            (_v1088.value,) = _get_struct_h().unpack(str[start:end])
            _v1089 = val8.z_coordinate
            start = end
            end += 2
            (_v1089.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (val8.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.z_coordinate_is_present = bool(val8.z_coordinate_is_present)
            _v1086.array.append(val8)
          _v1090 = _v1081.height
          start = end
          end += 2
          (_v1090.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1081.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1081.height_is_present = bool(_v1081.height_is_present)
          _v1091 = _v1064.elliptical
          _v1092 = _v1091.shape_reference_point
          _v1093 = _v1092.x_coordinate
          start = end
          end += 2
          (_v1093.value,) = _get_struct_h().unpack(str[start:end])
          _v1094 = _v1092.y_coordinate
          start = end
          end += 2
          (_v1094.value,) = _get_struct_h().unpack(str[start:end])
          _v1095 = _v1092.z_coordinate
          start = end
          end += 2
          (_v1095.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1092.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1092.z_coordinate_is_present = bool(_v1092.z_coordinate_is_present)
          start = end
          end += 1
          (_v1091.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1091.shape_reference_point_is_present = bool(_v1091.shape_reference_point_is_present)
          _v1096 = _v1091.semi_major_axis_length
          start = end
          end += 2
          (_v1096.value,) = _get_struct_H().unpack(str[start:end])
          _v1097 = _v1091.semi_minor_axis_length
          start = end
          end += 2
          (_v1097.value,) = _get_struct_H().unpack(str[start:end])
          _v1098 = _v1091.orientation
          start = end
          end += 2
          (_v1098.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1091.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1091.orientation_is_present = bool(_v1091.orientation_is_present)
          _v1099 = _v1091.height
          start = end
          end += 2
          (_v1099.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1091.height_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1091.height_is_present = bool(_v1091.height_is_present)
          _v1100 = _v1064.radial
          _v1101 = _v1100.shape_reference_point
          _v1102 = _v1101.x_coordinate
          start = end
          end += 2
          (_v1102.value,) = _get_struct_h().unpack(str[start:end])
          _v1103 = _v1101.y_coordinate
          start = end
          end += 2
          (_v1103.value,) = _get_struct_h().unpack(str[start:end])
          _v1104 = _v1101.z_coordinate
          start = end
          end += 2
          (_v1104.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1101.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1101.z_coordinate_is_present = bool(_v1101.z_coordinate_is_present)
          start = end
          end += 1
          (_v1100.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1100.shape_reference_point_is_present = bool(_v1100.shape_reference_point_is_present)
          _v1105 = _v1100.range
          start = end
          end += 2
          (_v1105.value,) = _get_struct_H().unpack(str[start:end])
          _v1106 = _v1100.stationary_horizontal_opening_angle_start
          start = end
          end += 2
          (_v1106.value,) = _get_struct_H().unpack(str[start:end])
          _v1107 = _v1100.stationary_horizontal_opening_angle_end
          start = end
          end += 2
          (_v1107.value,) = _get_struct_H().unpack(str[start:end])
          _v1108 = _v1100.vertical_opening_angle_start
          start = end
          end += 2
          (_v1108.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1100.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1100.vertical_opening_angle_start_is_present = bool(_v1100.vertical_opening_angle_start_is_present)
          _v1109 = _v1100.vertical_opening_angle_end
          start = end
          end += 2
          (_v1109.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1100.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1100.vertical_opening_angle_end_is_present = bool(_v1100.vertical_opening_angle_end_is_present)
          _v1110 = _v1064.radial_shapes
          _v1111 = _v1110.ref_point_id
          start = end
          end += 1
          (_v1111.value,) = _get_struct_B().unpack(str[start:end])
          _v1112 = _v1110.x_coordinate
          start = end
          end += 2
          (_v1112.value,) = _get_struct_h().unpack(str[start:end])
          _v1113 = _v1110.y_coordinate
          start = end
          end += 2
          (_v1113.value,) = _get_struct_h().unpack(str[start:end])
          _v1114 = _v1110.z_coordinate
          start = end
          end += 2
          (_v1114.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (_v1110.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1110.z_coordinate_is_present = bool(_v1110.z_coordinate_is_present)
          _v1115 = _v1110.radial_shapes_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1115.array = []
          for i in range(0, length):
            val8 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
            _v1116 = val8.range
            start = end
            end += 2
            (_v1116.value,) = _get_struct_H().unpack(str[start:end])
            _v1117 = val8.horizontal_opening_angle_start
            start = end
            end += 2
            (_v1117.value,) = _get_struct_H().unpack(str[start:end])
            _v1118 = val8.horizontal_opening_angle_end
            start = end
            end += 2
            (_v1118.value,) = _get_struct_H().unpack(str[start:end])
            _v1119 = val8.vertical_opening_angle_start
            start = end
            end += 2
            (_v1119.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_start_is_present = bool(val8.vertical_opening_angle_start_is_present)
            _v1120 = val8.vertical_opening_angle_end
            start = end
            end += 2
            (_v1120.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (val8.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            val8.vertical_opening_angle_end_is_present = bool(val8.vertical_opening_angle_end_is_present)
            _v1115.array.append(val8)
          start = end
          end += 1
          (val4.shadowing_applies,) = _get_struct_B().unpack(str[start:end])
          val4.shadowing_applies = bool(val4.shadowing_applies)
          _v1121 = val4.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1121.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val6.value,) = _get_struct_B().unpack(str[start:end])
            _v1121.array.append(val6)
          start = end
          end += 1
          (val4.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.sensor_id_list_is_present = bool(val4.sensor_id_list_is_present)
          _v1122 = val4.number_of_perceived_objects
          start = end
          end += 1
          (_v1122.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val4.number_of_perceived_objects_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.number_of_perceived_objects_is_present = bool(val4.number_of_perceived_objects_is_present)
          _v1123 = val4.perceived_object_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1123.array = []
          for i in range(0, length):
            val6 = etsi_its_cpm_ts_msgs.msg.Identifier2B()
            start = end
            end += 2
            (val6.value,) = _get_struct_H().unpack(str[start:end])
            _v1123.array.append(val6)
          start = end
          end += 1
          (val4.perceived_object_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val4.perceived_object_ids_is_present = bool(val4.perceived_object_ids_is_present)
          _v1061.array.append(val4)
        _v1124 = _v971.perceived_object_container
        _v1125 = _v1124.number_of_perceived_objects
        start = end
        end += 1
        (_v1125.value,) = _get_struct_B().unpack(str[start:end])
        _v1126 = _v1124.perceived_objects
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v1126.array = []
        for i in range(0, length):
          val5 = etsi_its_cpm_ts_msgs.msg.PerceivedObject()
          _v1127 = val5.object_id
          start = end
          end += 2
          (_v1127.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_id_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_id_is_present = bool(val5.object_id_is_present)
          _v1128 = val5.measurement_delta_time
          start = end
          end += 2
          (_v1128.value,) = _get_struct_h().unpack(str[start:end])
          _v1129 = val5.position
          _v1130 = _v1129.x_coordinate
          _v1131 = _v1130.value
          start = end
          end += 4
          (_v1131.value,) = _get_struct_i().unpack(str[start:end])
          _v1132 = _v1130.confidence
          start = end
          end += 2
          (_v1132.value,) = _get_struct_H().unpack(str[start:end])
          _v1133 = _v1129.y_coordinate
          _v1134 = _v1133.value
          start = end
          end += 4
          (_v1134.value,) = _get_struct_i().unpack(str[start:end])
          _v1135 = _v1133.confidence
          start = end
          end += 2
          (_v1135.value,) = _get_struct_H().unpack(str[start:end])
          _v1136 = _v1129.z_coordinate
          _v1137 = _v1136.value
          start = end
          end += 4
          (_v1137.value,) = _get_struct_i().unpack(str[start:end])
          _v1138 = _v1136.confidence
          start = end
          end += 2
          (_v1138.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1129.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1129.z_coordinate_is_present = bool(_v1129.z_coordinate_is_present)
          _v1139 = val5.velocity
          start = end
          end += 1
          (_v1139.choice,) = _get_struct_B().unpack(str[start:end])
          _v1140 = _v1139.polar_velocity
          _v1141 = _v1140.velocity_magnitude
          _v1142 = _v1141.speed_value
          start = end
          end += 2
          (_v1142.value,) = _get_struct_H().unpack(str[start:end])
          _v1143 = _v1141.speed_confidence
          start = end
          end += 1
          (_v1143.value,) = _get_struct_B().unpack(str[start:end])
          _v1144 = _v1140.velocity_direction
          _v1145 = _v1144.value
          start = end
          end += 2
          (_v1145.value,) = _get_struct_H().unpack(str[start:end])
          _v1146 = _v1144.confidence
          start = end
          end += 1
          (_v1146.value,) = _get_struct_B().unpack(str[start:end])
          _v1147 = _v1140.z_velocity
          _v1148 = _v1147.value
          start = end
          end += 2
          (_v1148.value,) = _get_struct_h().unpack(str[start:end])
          _v1149 = _v1147.confidence
          start = end
          end += 1
          (_v1149.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1140.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1140.z_velocity_is_present = bool(_v1140.z_velocity_is_present)
          _v1150 = _v1139.cartesian_velocity
          _v1151 = _v1150.x_velocity
          _v1152 = _v1151.value
          start = end
          end += 2
          (_v1152.value,) = _get_struct_h().unpack(str[start:end])
          _v1153 = _v1151.confidence
          start = end
          end += 1
          (_v1153.value,) = _get_struct_B().unpack(str[start:end])
          _v1154 = _v1150.y_velocity
          _v1155 = _v1154.value
          start = end
          end += 2
          (_v1155.value,) = _get_struct_h().unpack(str[start:end])
          _v1156 = _v1154.confidence
          start = end
          end += 1
          (_v1156.value,) = _get_struct_B().unpack(str[start:end])
          _v1157 = _v1150.z_velocity
          _v1158 = _v1157.value
          start = end
          end += 2
          (_v1158.value,) = _get_struct_h().unpack(str[start:end])
          _v1159 = _v1157.confidence
          start = end
          end += 1
          (_v1159.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1150.z_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1150.z_velocity_is_present = bool(_v1150.z_velocity_is_present)
          start = end
          end += 1
          (val5.velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.velocity_is_present = bool(val5.velocity_is_present)
          _v1160 = val5.acceleration
          start = end
          end += 1
          (_v1160.choice,) = _get_struct_B().unpack(str[start:end])
          _v1161 = _v1160.polar_acceleration
          _v1162 = _v1161.acceleration_magnitude
          _v1163 = _v1162.acceleration_magnitude_value
          start = end
          end += 1
          (_v1163.value,) = _get_struct_B().unpack(str[start:end])
          _v1164 = _v1162.acceleration_confidence
          start = end
          end += 1
          (_v1164.value,) = _get_struct_B().unpack(str[start:end])
          _v1165 = _v1161.acceleration_direction
          _v1166 = _v1165.value
          start = end
          end += 2
          (_v1166.value,) = _get_struct_H().unpack(str[start:end])
          _v1167 = _v1165.confidence
          start = end
          end += 1
          (_v1167.value,) = _get_struct_B().unpack(str[start:end])
          _v1168 = _v1161.z_acceleration
          _v1169 = _v1168.value
          start = end
          end += 2
          (_v1169.value,) = _get_struct_h().unpack(str[start:end])
          _v1170 = _v1168.confidence
          start = end
          end += 1
          (_v1170.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1161.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1161.z_acceleration_is_present = bool(_v1161.z_acceleration_is_present)
          _v1171 = _v1160.cartesian_acceleration
          _v1172 = _v1171.x_acceleration
          _v1173 = _v1172.value
          start = end
          end += 2
          (_v1173.value,) = _get_struct_h().unpack(str[start:end])
          _v1174 = _v1172.confidence
          start = end
          end += 1
          (_v1174.value,) = _get_struct_B().unpack(str[start:end])
          _v1175 = _v1171.y_acceleration
          _v1176 = _v1175.value
          start = end
          end += 2
          (_v1176.value,) = _get_struct_h().unpack(str[start:end])
          _v1177 = _v1175.confidence
          start = end
          end += 1
          (_v1177.value,) = _get_struct_B().unpack(str[start:end])
          _v1178 = _v1171.z_acceleration
          _v1179 = _v1178.value
          start = end
          end += 2
          (_v1179.value,) = _get_struct_h().unpack(str[start:end])
          _v1180 = _v1178.confidence
          start = end
          end += 1
          (_v1180.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1171.z_acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1171.z_acceleration_is_present = bool(_v1171.z_acceleration_is_present)
          start = end
          end += 1
          (val5.acceleration_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.acceleration_is_present = bool(val5.acceleration_is_present)
          _v1181 = val5.angles
          _v1182 = _v1181.z_angle
          _v1183 = _v1182.value
          start = end
          end += 2
          (_v1183.value,) = _get_struct_H().unpack(str[start:end])
          _v1184 = _v1182.confidence
          start = end
          end += 1
          (_v1184.value,) = _get_struct_B().unpack(str[start:end])
          _v1185 = _v1181.y_angle
          _v1186 = _v1185.value
          start = end
          end += 2
          (_v1186.value,) = _get_struct_H().unpack(str[start:end])
          _v1187 = _v1185.confidence
          start = end
          end += 1
          (_v1187.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1181.y_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1181.y_angle_is_present = bool(_v1181.y_angle_is_present)
          _v1188 = _v1181.x_angle
          _v1189 = _v1188.value
          start = end
          end += 2
          (_v1189.value,) = _get_struct_H().unpack(str[start:end])
          _v1190 = _v1188.confidence
          start = end
          end += 1
          (_v1190.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1181.x_angle_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1181.x_angle_is_present = bool(_v1181.x_angle_is_present)
          start = end
          end += 1
          (val5.angles_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.angles_is_present = bool(val5.angles_is_present)
          _v1191 = val5.z_angular_velocity
          _v1192 = _v1191.value
          start = end
          end += 2
          (_v1192.value,) = _get_struct_h().unpack(str[start:end])
          _v1193 = _v1191.confidence
          start = end
          end += 1
          (_v1193.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.z_angular_velocity_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.z_angular_velocity_is_present = bool(val5.z_angular_velocity_is_present)
          _v1194 = val5.lower_triangular_correlation_matrices
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1194.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.LowerTriangularPositiveSemidefiniteMatrix()
            _v1195 = val7.components_included_inthe_matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v1195.value = str[start:end]
            start = end
            end += 1
            (_v1195.bits_unused,) = _get_struct_B().unpack(str[start:end])
            _v1196 = val7.matrix
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1196.array = []
            for i in range(0, length):
              val9 = etsi_its_cpm_ts_msgs.msg.CorrelationColumn()
              start = end
              end += 4
              (length,) = _struct_I.unpack(str[start:end])
              val9.array = []
              for i in range(0, length):
                val10 = etsi_its_cpm_ts_msgs.msg.CorrelationCellValue()
                start = end
                end += 1
                (val10.value,) = _get_struct_b().unpack(str[start:end])
                val9.array.append(val10)
              _v1196.array.append(val9)
            _v1194.array.append(val7)
          start = end
          end += 1
          (val5.lower_triangular_correlation_matrices_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.lower_triangular_correlation_matrices_is_present = bool(val5.lower_triangular_correlation_matrices_is_present)
          _v1197 = val5.object_dimension_z
          _v1198 = _v1197.value
          start = end
          end += 2
          (_v1198.value,) = _get_struct_H().unpack(str[start:end])
          _v1199 = _v1197.confidence
          start = end
          end += 1
          (_v1199.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_z_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_z_is_present = bool(val5.object_dimension_z_is_present)
          _v1200 = val5.object_dimension_y
          _v1201 = _v1200.value
          start = end
          end += 2
          (_v1201.value,) = _get_struct_H().unpack(str[start:end])
          _v1202 = _v1200.confidence
          start = end
          end += 1
          (_v1202.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_y_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_y_is_present = bool(val5.object_dimension_y_is_present)
          _v1203 = val5.object_dimension_x
          _v1204 = _v1203.value
          start = end
          end += 2
          (_v1204.value,) = _get_struct_H().unpack(str[start:end])
          _v1205 = _v1203.confidence
          start = end
          end += 1
          (_v1205.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_dimension_x_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_dimension_x_is_present = bool(val5.object_dimension_x_is_present)
          _v1206 = val5.object_age
          start = end
          end += 2
          (_v1206.value,) = _get_struct_h().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_age_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_age_is_present = bool(val5.object_age_is_present)
          _v1207 = val5.object_perception_quality
          start = end
          end += 1
          (_v1207.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val5.object_perception_quality_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.object_perception_quality_is_present = bool(val5.object_perception_quality_is_present)
          _v1208 = val5.sensor_id_list
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1208.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val7.value,) = _get_struct_B().unpack(str[start:end])
            _v1208.array.append(val7)
          start = end
          end += 1
          (val5.sensor_id_list_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.sensor_id_list_is_present = bool(val5.sensor_id_list_is_present)
          _v1209 = val5.classification
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v1209.array = []
          for i in range(0, length):
            val7 = etsi_its_cpm_ts_msgs.msg.ObjectClassWithConfidence()
            _v1210 = val7.object_class
            start = end
            end += 1
            (_v1210.choice,) = _get_struct_B().unpack(str[start:end])
            _v1211 = _v1210.vehicle_sub_class
            start = end
            end += 1
            (_v1211.value,) = _get_struct_B().unpack(str[start:end])
            _v1212 = _v1210.vru_sub_class
            start = end
            end += 1
            (_v1212.choice,) = _get_struct_B().unpack(str[start:end])
            _v1213 = _v1212.pedestrian
            start = end
            end += 1
            (_v1213.value,) = _get_struct_B().unpack(str[start:end])
            _v1214 = _v1212.bicyclist_and_light_vru_vehicle
            start = end
            end += 1
            (_v1214.value,) = _get_struct_B().unpack(str[start:end])
            _v1215 = _v1212.motorcyclist
            start = end
            end += 1
            (_v1215.value,) = _get_struct_B().unpack(str[start:end])
            _v1216 = _v1212.animal
            start = end
            end += 1
            (_v1216.value,) = _get_struct_B().unpack(str[start:end])
            _v1217 = _v1210.group_sub_class
            _v1218 = _v1217.cluster_id
            start = end
            end += 1
            (_v1218.value,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v1217.cluster_id_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1217.cluster_id_is_present = bool(_v1217.cluster_id_is_present)
            _v1219 = _v1217.cluster_bounding_box_shape
            start = end
            end += 1
            (_v1219.choice,) = _get_struct_B().unpack(str[start:end])
            _v1220 = _v1219.rectangular
            _v1221 = _v1220.center_point
            _v1222 = _v1221.x_coordinate
            start = end
            end += 2
            (_v1222.value,) = _get_struct_h().unpack(str[start:end])
            _v1223 = _v1221.y_coordinate
            start = end
            end += 2
            (_v1223.value,) = _get_struct_h().unpack(str[start:end])
            _v1224 = _v1221.z_coordinate
            start = end
            end += 2
            (_v1224.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1221.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1221.z_coordinate_is_present = bool(_v1221.z_coordinate_is_present)
            start = end
            end += 1
            (_v1220.center_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1220.center_point_is_present = bool(_v1220.center_point_is_present)
            _v1225 = _v1220.semi_length
            start = end
            end += 2
            (_v1225.value,) = _get_struct_H().unpack(str[start:end])
            _v1226 = _v1220.semi_breadth
            start = end
            end += 2
            (_v1226.value,) = _get_struct_H().unpack(str[start:end])
            _v1227 = _v1220.orientation
            start = end
            end += 2
            (_v1227.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1220.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1220.orientation_is_present = bool(_v1220.orientation_is_present)
            _v1228 = _v1220.height
            start = end
            end += 2
            (_v1228.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1220.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1220.height_is_present = bool(_v1220.height_is_present)
            _v1229 = _v1219.circular
            _v1230 = _v1229.shape_reference_point
            _v1231 = _v1230.x_coordinate
            start = end
            end += 2
            (_v1231.value,) = _get_struct_h().unpack(str[start:end])
            _v1232 = _v1230.y_coordinate
            start = end
            end += 2
            (_v1232.value,) = _get_struct_h().unpack(str[start:end])
            _v1233 = _v1230.z_coordinate
            start = end
            end += 2
            (_v1233.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1230.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1230.z_coordinate_is_present = bool(_v1230.z_coordinate_is_present)
            start = end
            end += 1
            (_v1229.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1229.shape_reference_point_is_present = bool(_v1229.shape_reference_point_is_present)
            _v1234 = _v1229.radius
            start = end
            end += 2
            (_v1234.value,) = _get_struct_H().unpack(str[start:end])
            _v1235 = _v1229.height
            start = end
            end += 2
            (_v1235.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1229.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1229.height_is_present = bool(_v1229.height_is_present)
            _v1236 = _v1219.polygonal
            _v1237 = _v1236.shape_reference_point
            _v1238 = _v1237.x_coordinate
            start = end
            end += 2
            (_v1238.value,) = _get_struct_h().unpack(str[start:end])
            _v1239 = _v1237.y_coordinate
            start = end
            end += 2
            (_v1239.value,) = _get_struct_h().unpack(str[start:end])
            _v1240 = _v1237.z_coordinate
            start = end
            end += 2
            (_v1240.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1237.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1237.z_coordinate_is_present = bool(_v1237.z_coordinate_is_present)
            start = end
            end += 1
            (_v1236.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1236.shape_reference_point_is_present = bool(_v1236.shape_reference_point_is_present)
            _v1241 = _v1236.polygon
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1241.array = []
            for i in range(0, length):
              val13 = etsi_its_cpm_ts_msgs.msg.CartesianPosition3d()
              _v1242 = val13.x_coordinate
              start = end
              end += 2
              (_v1242.value,) = _get_struct_h().unpack(str[start:end])
              _v1243 = val13.y_coordinate
              start = end
              end += 2
              (_v1243.value,) = _get_struct_h().unpack(str[start:end])
              _v1244 = val13.z_coordinate
              start = end
              end += 2
              (_v1244.value,) = _get_struct_h().unpack(str[start:end])
              start = end
              end += 1
              (val13.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.z_coordinate_is_present = bool(val13.z_coordinate_is_present)
              _v1241.array.append(val13)
            _v1245 = _v1236.height
            start = end
            end += 2
            (_v1245.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1236.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1236.height_is_present = bool(_v1236.height_is_present)
            _v1246 = _v1219.elliptical
            _v1247 = _v1246.shape_reference_point
            _v1248 = _v1247.x_coordinate
            start = end
            end += 2
            (_v1248.value,) = _get_struct_h().unpack(str[start:end])
            _v1249 = _v1247.y_coordinate
            start = end
            end += 2
            (_v1249.value,) = _get_struct_h().unpack(str[start:end])
            _v1250 = _v1247.z_coordinate
            start = end
            end += 2
            (_v1250.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1247.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1247.z_coordinate_is_present = bool(_v1247.z_coordinate_is_present)
            start = end
            end += 1
            (_v1246.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1246.shape_reference_point_is_present = bool(_v1246.shape_reference_point_is_present)
            _v1251 = _v1246.semi_major_axis_length
            start = end
            end += 2
            (_v1251.value,) = _get_struct_H().unpack(str[start:end])
            _v1252 = _v1246.semi_minor_axis_length
            start = end
            end += 2
            (_v1252.value,) = _get_struct_H().unpack(str[start:end])
            _v1253 = _v1246.orientation
            start = end
            end += 2
            (_v1253.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1246.orientation_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1246.orientation_is_present = bool(_v1246.orientation_is_present)
            _v1254 = _v1246.height
            start = end
            end += 2
            (_v1254.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1246.height_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1246.height_is_present = bool(_v1246.height_is_present)
            _v1255 = _v1219.radial
            _v1256 = _v1255.shape_reference_point
            _v1257 = _v1256.x_coordinate
            start = end
            end += 2
            (_v1257.value,) = _get_struct_h().unpack(str[start:end])
            _v1258 = _v1256.y_coordinate
            start = end
            end += 2
            (_v1258.value,) = _get_struct_h().unpack(str[start:end])
            _v1259 = _v1256.z_coordinate
            start = end
            end += 2
            (_v1259.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1256.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1256.z_coordinate_is_present = bool(_v1256.z_coordinate_is_present)
            start = end
            end += 1
            (_v1255.shape_reference_point_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1255.shape_reference_point_is_present = bool(_v1255.shape_reference_point_is_present)
            _v1260 = _v1255.range
            start = end
            end += 2
            (_v1260.value,) = _get_struct_H().unpack(str[start:end])
            _v1261 = _v1255.stationary_horizontal_opening_angle_start
            start = end
            end += 2
            (_v1261.value,) = _get_struct_H().unpack(str[start:end])
            _v1262 = _v1255.stationary_horizontal_opening_angle_end
            start = end
            end += 2
            (_v1262.value,) = _get_struct_H().unpack(str[start:end])
            _v1263 = _v1255.vertical_opening_angle_start
            start = end
            end += 2
            (_v1263.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1255.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1255.vertical_opening_angle_start_is_present = bool(_v1255.vertical_opening_angle_start_is_present)
            _v1264 = _v1255.vertical_opening_angle_end
            start = end
            end += 2
            (_v1264.value,) = _get_struct_H().unpack(str[start:end])
            start = end
            end += 1
            (_v1255.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1255.vertical_opening_angle_end_is_present = bool(_v1255.vertical_opening_angle_end_is_present)
            _v1265 = _v1219.radial_shapes
            _v1266 = _v1265.ref_point_id
            start = end
            end += 1
            (_v1266.value,) = _get_struct_B().unpack(str[start:end])
            _v1267 = _v1265.x_coordinate
            start = end
            end += 2
            (_v1267.value,) = _get_struct_h().unpack(str[start:end])
            _v1268 = _v1265.y_coordinate
            start = end
            end += 2
            (_v1268.value,) = _get_struct_h().unpack(str[start:end])
            _v1269 = _v1265.z_coordinate
            start = end
            end += 2
            (_v1269.value,) = _get_struct_h().unpack(str[start:end])
            start = end
            end += 1
            (_v1265.z_coordinate_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1265.z_coordinate_is_present = bool(_v1265.z_coordinate_is_present)
            _v1270 = _v1265.radial_shapes_list
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            _v1270.array = []
            for i in range(0, length):
              val13 = etsi_its_cpm_ts_msgs.msg.RadialShapeDetails()
              _v1271 = val13.range
              start = end
              end += 2
              (_v1271.value,) = _get_struct_H().unpack(str[start:end])
              _v1272 = val13.horizontal_opening_angle_start
              start = end
              end += 2
              (_v1272.value,) = _get_struct_H().unpack(str[start:end])
              _v1273 = val13.horizontal_opening_angle_end
              start = end
              end += 2
              (_v1273.value,) = _get_struct_H().unpack(str[start:end])
              _v1274 = val13.vertical_opening_angle_start
              start = end
              end += 2
              (_v1274.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val13.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.vertical_opening_angle_start_is_present = bool(val13.vertical_opening_angle_start_is_present)
              _v1275 = val13.vertical_opening_angle_end
              start = end
              end += 2
              (_v1275.value,) = _get_struct_H().unpack(str[start:end])
              start = end
              end += 1
              (val13.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
              val13.vertical_opening_angle_end_is_present = bool(val13.vertical_opening_angle_end_is_present)
              _v1270.array.append(val13)
            start = end
            end += 1
            (_v1217.cluster_bounding_box_shape_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1217.cluster_bounding_box_shape_is_present = bool(_v1217.cluster_bounding_box_shape_is_present)
            _v1276 = _v1217.cluster_cardinality_size
            start = end
            end += 1
            (_v1276.value,) = _get_struct_B().unpack(str[start:end])
            _v1277 = _v1217.cluster_profiles
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            _v1277.value = str[start:end]
            start = end
            end += 1
            (_v1277.bits_unused,) = _get_struct_B().unpack(str[start:end])
            start = end
            end += 1
            (_v1217.cluster_profiles_is_present,) = _get_struct_B().unpack(str[start:end])
            _v1217.cluster_profiles_is_present = bool(_v1217.cluster_profiles_is_present)
            _v1278 = _v1210.other_sub_class
            start = end
            end += 1
            (_v1278.value,) = _get_struct_B().unpack(str[start:end])
            _v1279 = val7.confidence
            start = end
            end += 1
            (_v1279.value,) = _get_struct_B().unpack(str[start:end])
            _v1209.array.append(val7)
          start = end
          end += 1
          (val5.classification_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.classification_is_present = bool(val5.classification_is_present)
          _v1280 = val5.map_position
          _v1281 = _v1280.map_reference
          start = end
          end += 1
          (_v1281.choice,) = _get_struct_B().unpack(str[start:end])
          _v1282 = _v1281.roadsegment
          _v1283 = _v1282.region
          start = end
          end += 2
          (_v1283.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1282.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1282.region_is_present = bool(_v1282.region_is_present)
          _v1284 = _v1282.id
          start = end
          end += 2
          (_v1284.value,) = _get_struct_H().unpack(str[start:end])
          _v1285 = _v1281.intersection
          _v1286 = _v1285.region
          start = end
          end += 2
          (_v1286.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1285.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1285.region_is_present = bool(_v1285.region_is_present)
          _v1287 = _v1285.id
          start = end
          end += 2
          (_v1287.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1280.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1280.map_reference_is_present = bool(_v1280.map_reference_is_present)
          _v1288 = _v1280.lane_id
          start = end
          end += 1
          (_v1288.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1280.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1280.lane_id_is_present = bool(_v1280.lane_id_is_present)
          _v1289 = _v1280.connection_id
          start = end
          end += 1
          (_v1289.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (_v1280.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1280.connection_id_is_present = bool(_v1280.connection_id_is_present)
          _v1290 = _v1280.longitudinal_lane_position
          _v1291 = _v1290.longitudinal_lane_position_value
          start = end
          end += 2
          (_v1291.value,) = _get_struct_H().unpack(str[start:end])
          _v1292 = _v1290.longitudinal_lane_position_confidence
          start = end
          end += 2
          (_v1292.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v1280.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
          _v1280.longitudinal_lane_position_is_present = bool(_v1280.longitudinal_lane_position_is_present)
          start = end
          end += 1
          (val5.map_position_is_present,) = _get_struct_B().unpack(str[start:end])
          val5.map_position_is_present = bool(val5.map_position_is_present)
          _v1126.array.append(val5)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
